Package: quickr
Title: Compiler for R
Version: 0.3.0
Authors@R: c(
    person("Tomasz", "Kalinowski", , "tomasz@posit.co", role = c("aut", "cre")),
    person("Posit Software, PBC", role = c("cph", "fnd"),
           comment = c(ROR = "03wc8by49"))
  )
Description: Compile R functions annotated with type and shape
    declarations for extremely fast performance and robust runtime
    type checking. Supports both just-in-time (JIT) and ahead-of-time
    (AOT) compilation. Compilation is performed by lowering R code to
    Fortran.
License: MIT + file LICENSE
URL: https://github.com/t-kalinowski/quickr
BugReports: https://github.com/t-kalinowski/quickr/issues
Depends: R (>= 4.3.0)
Imports: dotty, glue, S7
Suggests: bench, cli, pkgload (>= 1.4.0), rlang, testthat (>= 3.0.0),
        withr
Config/testthat/edition: 3
Config/testthat/parallel: true
Config/testthat/start-first: unary-intrinsics, loops
Encoding: UTF-8
RoxygenNote: 7.3.3
NeedsCompilation: no
Packaged: 2026-04-18 01:33:02 UTC; tomasz
Author: Tomasz Kalinowski [aut, cre],
  Posit Software, PBC [cph, fnd] (ROR: <https://ror.org/03wc8by49>)
Maintainer: Tomasz Kalinowski <tomasz@posit.co>
Repository: CRAN
Date/Publication: 2026-04-18 02:20:02 UTC

Package: quickr
Title: Compiler for R
Version: 0.3.0
Authors@R: c(
    person("Tomasz", "Kalinowski", , "tomasz@posit.co", role = c("aut", "cre")),
    person("Posit Software, PBC", role = c("cph", "fnd"),
           comment = c(ROR = "03wc8by49"))
  )
Description: Compile R functions annotated with type and shape
    declarations for extremely fast performance and robust runtime
    type checking. Supports both just-in-time (JIT) and ahead-of-time
    (AOT) compilation. Compilation is performed by lowering R code to
    Fortran.
License: MIT + file LICENSE
URL: https://github.com/t-kalinowski/quickr
BugReports: https://github.com/t-kalinowski/quickr/issues
Depends: R (>= 4.3.0)
Imports: dotty, glue, S7
Suggests: bench, cli, pkgload (>= 1.4.0), rlang, testthat (>= 3.0.0),
        withr
Config/testthat/edition: 3
Config/testthat/parallel: true
Config/testthat/start-first: unary-intrinsics, loops
Encoding: UTF-8
RoxygenNote: 7.3.3
NeedsCompilation: no
Packaged: 2026-04-18 01:33:02 UTC; tomasz
Author: Tomasz Kalinowski [aut, cre],
  Posit Software, PBC [cph, fnd] (ROR: <https://ror.org/03wc8by49>)
Maintainer: Tomasz Kalinowski <tomasz@posit.co>
Repository: CRAN
Date/Publication: 2026-04-18 02:20:02 UTC
Built: R 4.6.0; ; 2026-04-27 00:58:05 UTC; unix

<!-- README.md is generated from README.Rmd. Please edit that file -->

# quickr <img src="man/figures/logo.png" align="right" height="138"/>

<!-- ![](https://i.giphy.com/media/v1.Y2lkPTc5MGI3NjExMjBhNWt1Z3Q4ZW56cG00c2hncmtwbGJycm53M3JxYWdscjRkaDJobCZlcD12MV9pbnRlcm5hbF9naWZfYnlfaWQmY3Q9Zw/12haGO61oFZ28w/giphy.gif){alt="An animated GIF showing two characters in a spaceship cockpit rapidly accelerating into hyperspace, with stars stretching into bright streaks, creating a sensation of rapid acceleration and motion."} -->
<!-- badges: start -->

[![R-CMD-check](https://github.com/t-kalinowski/quickr/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/t-kalinowski/quickr/actions/workflows/R-CMD-check.yaml)
[![Codecov test
coverage](https://codecov.io/gh/t-kalinowski/quickr/graph/badge.svg)](https://app.codecov.io/gh/t-kalinowski/quickr)

<!-- badges: end -->

The goal of quickr is to make your R code run quicker.

## Overview

R is an extremely flexible and dynamic language, but that flexibility
and dynamicism can come at the expense of speed. This package lets you
trade back some of that flexibility for some speed, for the context of a
single function.

<!-- Programming language design requires some hard decisions and trade-ofs. -->
<!-- When you want to have it all, you typically end up have two (or more!) languages. -->
<!-- An interpreted, dynamic language full of conveniences, and a staticly-typed, explicit, high-performance language. -->
<!-- This is sometimes called the "Two Language Problem". -->
<!-- Like [Numba](https://numba.pydata.org) in Python, or the [Julia](https://julialang.org) language, quickr is a solution to the [two-language problem](https://juliadatascience.io/julia_accomplish). -->
<!-- Unlike those tools however, quickr does not bundle most of LLVM, keeping dependencies lightweight. -->
<!-- Quickr works by translating the R code to Fortran. -->
<!-- Fortran might seem like a surprising choice, but it has many compelling properties: -->
<!-- -   Superb performance. -->
<!--     As a stalwart of the numerical computing community, Fortran has accrued the benefit of countless person-hours from top-tier computer scientists and compiler engineers. -->
<!--     There is a reason that over 20% of R itself, (and numpy, and ...) are still in Fortran, and it's not merely because of legacy. -->
<!--     And this trend of compiler engineers focusing on Fortran is not stopping. -->
<!-- -   Large overlap with R semantics and syntax for numerical computing. -->
<!--     Fortran and R have very similar syntax for operating on arrays. -->
<!--     Like R, Fortran has builtin-in support for nd-arrays, provides vectorized operators on arrays, convenient array slicing semantics that match many capabilities of R's `[` , 1-based indexing, and a well-populated collection of operators for working on those arrays like `min`, `max`, `any` `all`, etc. -->
<!--     This means that it's relatively straightforward to translate R to Fortran, often just a 1:1 mapping of semantics, with some changes to syntax. -->
<!--     This is also why Fortran has such superb performance, and why it attracts compiler engineers to work on it. -->
<!--     Because the language spec guarantees things like, static shapes for nd-arrays, views of those arrays, etc, it provides many opportunities for compiler engineers to do things like generate SIMD instructions, or automatically parallelize code. -->
<!-- -   Excellent support in R. -->
<!--     One of the original motivations for R was to serve as a front-end for Fortran. -->
<!--     Since its inception, R has supported Fortran extensions, and supported them well. -->
<!--     It also means that any computing environment where R build tools are available, Fortran is supported. -->
<!--     The barrier to entry and thorny questions, that, for example, using Rust in CRAN might raise, is non-existent for Fortran. -->

The main exported function is `quick()`. Here is how you use it:

``` r
library(quickr)

convolve <- quick(function(a, b) {
  declare(type(a = double(NA)),
          type(b = double(NA)))
  ab <- double(length(a) + length(b) - 1)
  for (i in seq_along(a)) {
    for (j in seq_along(b)) {
      ab[i+j-1] <- ab[i+j-1] + a[i] * b[j]
    }
  }
  ab
})
```

`quick()` returns a quicker R function. How much quicker? Let’s
benchmark it! For reference, we’ll also compare it to a
[pure-C](https://cran.r-project.org/doc/FAQ/R-exts.html#Calling-_002eCall-1)
implementation.

``` r
slow_convolve <- function(a, b) {
  declare(type(a = double(NA)),
          type(b = double(NA)))
  ab <- double(length(a) + length(b) - 1)
  for (i in seq_along(a)) {
    for (j in seq_along(b)) {
      ab[i+j-1] <- ab[i+j-1] + a[i] * b[j]
    }
  }
  ab
}

library(quickr)
quick_convolve <- quick(slow_convolve)

convolve_c <- inline::cfunction(
  sig = c(a = "SEXP", b = "SEXP"), body = r"({
    int na, nb, nab;
    double *xa, *xb, *xab;
    SEXP ab;

    a = PROTECT(Rf_coerceVector(a, REALSXP));
    b = PROTECT(Rf_coerceVector(b, REALSXP));
    na = Rf_length(a); nb = Rf_length(b); nab = na + nb - 1;
    ab = PROTECT(Rf_allocVector(REALSXP, nab));
    xa = REAL(a); xb = REAL(b); xab = REAL(ab);
    for(int i = 0; i < nab; i++) xab[i] = 0.0;
    for(int i = 0; i < na; i++)
        for(int j = 0; j < nb; j++)
            xab[i + j] += xa[i] * xb[j];
    UNPROTECT(3);
    return ab;
})")



a <- runif(100000); b <- runif(100)

timings <- bench::mark(
  r = slow_convolve(a, b),
  quickr = quick_convolve(a, b),
  c = convolve_c(a, b),
  min_time = 2
)
timings
#> # A tibble: 3 × 6
#>   expression      min   median `itr/sec` mem_alloc `gc/sec`
#>   <bch:expr> <bch:tm> <bch:tm>     <dbl> <bch:byt>    <dbl>
#> 1 r             1.43s    1.43s     0.702     782KB    0.702
#> 2 quickr       2.63ms    2.7ms   355.        782KB    6.77 
#> 3 c            4.92ms   5.22ms   189.        782KB    3.61
plot(timings) + bench::scale_x_bench_time(base = NULL)
```

<img src="man/figures/README-unnamed-chunk-3-1.png" alt="" width="100%" />

In the case of `convolve()`, `quick()` returns a function approximately
*200* times quicker, with performance similar to the C function.

`quick()` can accelerate any R function, with some restrictions:

- Function arguments must have their types and shapes declared using
  `declare()`.
- Only atomic vectors, matrices, and array are currently supported:
  `integer`, `double`, `logical`, and `complex`.
- The return value must be an atomic array (e.g., not a list)
- Named variables must have consistent shapes throughout their
  lifetimes.
- `NA` values are not supported.
- Only a subset of R’s vocabulary is currently supported.

<!-- -->

    #>   [1] -            :            !            !=           (           
    #>   [6] [            [<-          [<<-         {            *           
    #>  [11] /            &            &&           %*%          %/%         
    #>  [16] %%           %o%          ^            +            <           
    #>  [21] <-           <<-          <=           =            ==          
    #>  [26] >            >=           |            ||           $           
    #>  [31] Arg          Conj         Fortran      Im           Mod         
    #>  [36] Re           abs          acos         all          any         
    #>  [41] array        as.double    as.integer   asin         atan        
    #>  [46] backsolve    break        c            cat          cbind       
    #>  [51] ceiling      character    chol         chol2inv     cos         
    #>  [56] crossprod    declare      diag         dim          double      
    #>  [61] drop         exp          floor        for          forwardsolve
    #>  [66] if           ifelse       integer      is.null      length      
    #>  [71] log          log10        logical      matrix       max         
    #>  [76] min          ncol         next         nrow         numeric     
    #>  [81] outer        print        prod         qr.solve     raw         
    #>  [86] rbind        rep.int      repeat       rev          runif       
    #>  [91] seq          seq_along    seq_len      sin          solve       
    #>  [96] sqrt         stop         sum          svd          t           
    #> [101] tan          tanh         tcrossprod   trunc        which.max   
    #> [106] which.min    while

Many of these restrictions are expected to be relaxed as the project
matures. However, quickr is intended primarily for high-performance
numerical computing, so features like polymorphic dispatch or support
for complex or dynamic types are out of scope.

## `declare(type())` syntax:

The shape and mode of all function arguments must be declared. Local and
return variables may optionally also be declared.

`declare(type())` also has support for declaring size constraints, or
size relationships between variables. Here are some examples of declare
calls:

``` r
declare(type(x = double(NA))) # x is a 1-d double vector of any length
declare(type(x = double(10))) # x is a 1-d double vector of length 10
declare(type(x = double(1)))  # x is a scalar double

declare(type(x = integer(2, 3)))  # x is a 2-d integer matrix with dim (2, 3)
declare(type(x = integer(NA, 3))) # x is a 2-d integer matrix with dim (<any>, 3)

# x is a 4-d logical matrix with dim (<any>, 24, 24, 3)
declare(type(x = logical(NA, 24, 24, 3)))

# x and y are 1-d double vectors of any length
declare(type(x = double(NA)),
        type(y = double(NA)))

# x and y are 1-d double vectors of the same length
declare(
  type(x = double(n)),
  type(y = double(n)),
)

# x and y are 1-d double vectors, where length(y) == length(x) + 2
declare(type(x = double(n)),
        type(y = double(n+2)))
```

Tip: declare shapes as specifically as you can. quickr uses these size
constraints both for compile-time checking and for choosing more
efficient implementations. For example, if you know a matrix is square,
declare it as `type(A = double(n, n))` (not `double(n, k)`). That can
allow quickr to use a faster code path for operations like
`solve(A, b)`. If the compiler can’t prove a matrix is square, it may
need to fall back to a more general rectangular solver.

## More examples:

### `viterbi`

The Viterbi algorithm is an example of a dynamic programming algorithm
within the family of Hidden Markov Models
(<https://en.wikipedia.org/wiki/Viterbi_algorithm>). Here, `quick()`
makes `viterbi()` approximately 50 times faster.

``` r
slow_viterbi <- function(observations, states, initial_probs, transition_probs, emission_probs) {
    declare(
      type(observations = integer(num_steps)),
      type(states = integer(num_states)),
      type(initial_probs = double(num_states)),
      type(transition_probs = double(num_states, num_states)),
      type(emission_probs = double(num_states, num_obs)),
    )

    trellis <- matrix(0, nrow = length(states), ncol = length(observations))
    backpointer <- matrix(0L, nrow = length(states), ncol = length(observations))
    trellis[, 1] <- initial_probs * emission_probs[, observations[1]]

    for (step in 2:length(observations)) {
      for (current_state in 1:length(states)) {
        probabilities <- trellis[, step - 1] * transition_probs[, current_state]
        trellis[current_state, step] <- max(probabilities) * emission_probs[current_state, observations[step]]
        backpointer[current_state, step] <- which.max(probabilities)
      }
    }

    path <- integer(length(observations))
    path[length(observations)] <- which.max(trellis[, length(observations)])
    for (step in seq(length(observations) - 1, 1)) {
      path[step] <- backpointer[path[step + 1], step + 1]
    }

    out <- states[path]
    out
}

quick_viterbi <- quick(slow_viterbi)

set.seed(1234)
num_steps <- 16
num_states <- 8
num_obs <- 16

observations <- sample(1:num_obs, num_steps, replace = TRUE)
states <- 1:num_states
initial_probs <- runif (num_states)
initial_probs <- initial_probs / sum(initial_probs)  # normalize to sum to 1
transition_probs <- matrix(runif (num_states * num_states), nrow = num_states)
transition_probs <- transition_probs / rowSums(transition_probs)  # normalize rows
emission_probs <- matrix(runif (num_states * num_obs), nrow = num_states)
emission_probs <- emission_probs / rowSums(emission_probs)  # normalize rows

timings <- bench::mark(
  slow_viterbi = slow_viterbi(observations, states, initial_probs,
                              transition_probs, emission_probs),
  quick_viterbi = quick_viterbi(observations, states, initial_probs,
                                transition_probs, emission_probs)
)
timings
#> # A tibble: 2 × 6
#>   expression         min   median `itr/sec` mem_alloc `gc/sec`
#>   <bch:expr>    <bch:tm> <bch:tm>     <dbl> <bch:byt>    <dbl>
#> 1 slow_viterbi  170.18µs 186.23µs     5011.    1.59KB     12.4
#> 2 quick_viterbi   2.44µs   2.72µs   349107.        0B      0
plot(timings)
```

<img src="man/figures/README-unnamed-chunk-6-1.png" alt="" width="100%" />

### Diffusion simulation

Simulate how heat spreads over time across a 2D grid, using the [finite
difference method](https://en.wikipedia.org/wiki/Finite_difference)
applied to the [Heat
Equation](https://en.wikipedia.org/wiki/Heat_equation).

Note the use of local closures within the quick function. Here,
`quick()` returns a function approximately 20 times faster. The speedup
is relatively modest because the core operation of computing the
laplacian is already expressed as a vectorized operation. If we were
instead comparing against `for` loops that operate on individual array
elements, the speedup would be much more substantial. In general,
idiomatic vectorized R code is quite fast already!

``` r
diffuse_heat <- function(nx, ny, dx, dy, dt, k, steps) {
  declare(
    type(nx = integer(1)),
    type(ny = integer(1)),
    type(dx = integer(1)),
    type(dy = integer(1)),
    type(dt = double(1)),
    type(k = double(1)),
    type(steps = integer(1))
  )

  temp <- matrix(0, nx, ny)
  temp[nx %/% 2L, ny %/% 2L] <- 100

  apply_boundary_conditions <- function(temp) {
    temp[1, ] <- 0
    temp[nx, ] <- 0
    temp[, 1] <- 0
    temp[, ny] <- 0
    temp
  }

  update_temperature <- function(temp) {
    temp_new <- temp

    i <- 2:(nx - 1)
    j <- 2:(ny - 1)

    laplacian <-
      (temp[i + 1, j] - 2 * temp[i, j] + temp[i - 1, j]) / dx ^ 2 +
      (temp[i, j + 1] - 2 * temp[i, j] + temp[i, j - 1]) / dy ^ 2

    temp_new[i, j] <- temp[i, j] + k * dt * laplacian
    temp_new
  }

  for (step in seq_len(steps)) {
    temp <- temp |>
      apply_boundary_conditions() |>
      update_temperature()
  }

  temp
}


quick_diffuse_heat <- quick(diffuse_heat)

# Parameters
nx <- 100L      # Grid size in x
ny <- 100L      # Grid size in y
dx <- 1L        # Grid spacing
dy <- 1L        # Grid spacing
dt <- 0.01      # Time step
k <- 0.1        # Thermal diffusivity
steps <- 500L   # Number of time steps

timings <- bench::mark(
  diffuse_heat = diffuse_heat(nx, ny, dx, dy, dt, k, steps),
  quick_diffuse_heat = quick_diffuse_heat(nx, ny, dx, dy, dt, k, steps)
)
#> Warning: Some expressions had a GC in every iteration; so filtering is
#> disabled.
summary(timings, relative = TRUE)
#> Warning: Some expressions had a GC in every iteration; so filtering is
#> disabled.
#> # A tibble: 2 × 6
#>   expression           min median `itr/sec` mem_alloc `gc/sec`
#>   <bch:expr>         <dbl>  <dbl>     <dbl>     <dbl>    <dbl>
#> 1 diffuse_heat        13.6   16.8       1       4893.      Inf
#> 2 quick_diffuse_heat   1      1        16.7        1       NaN
plot(timings)
```

<img src="man/figures/README-unnamed-chunk-7-1.png" alt="" width="100%" />

### Rolling Mean

Here is *quickr* used to calculate a rolling mean. The CRAN package
*RcppRoll* already provides a highly optimized rolling mean, which we
include in the benchmarks for comparison.

``` r
slow_roll_mean <- function(x, weights, normalize = TRUE) {
  declare(
    type(x = double(NA)),
    type(weights = double(NA)),
    type(normalize = logical(1))
  )
  out <- double(length(x) - length(weights) + 1)
  n <- length(weights)
  if (normalize)
    weights <- weights/sum(weights)*length(weights)

  for(i in seq_along(out)) {
    out[i] <- sum(x[i:(i+n-1)] * weights) / length(weights)
  }
  out
}

quick_roll_mean <- quick(slow_roll_mean)

x <- dnorm(seq(-3, 3, len = 100000))
weights <- dnorm(seq(-1, 1, len = 100))

timings <- bench::mark(
  r = slow_roll_mean(x, weights),
  rcpp = RcppRoll::roll_mean(x, weights = weights),
  quickr = quick_roll_mean(x, weights = weights)
)
#> Warning: Some expressions had a GC in every iteration; so filtering is
#> disabled.
timings
#> # A tibble: 3 × 6
#>   expression      min   median `itr/sec` mem_alloc `gc/sec`
#>   <bch:expr> <bch:tm> <bch:tm>     <dbl> <bch:byt>    <dbl>
#> 1 r           187.9ms  292.3ms      3.42  124.24MB    10.3 
#> 2 rcpp        20.12ms   20.4ms     48.9     4.46MB     0   
#> 3 quickr       6.82ms    7.2ms    133.    781.35KB     1.99

timings$expression <- factor(names(timings$expression), rev(names(timings$expression)))
plot(timings) + bench::scale_x_bench_time(base = NULL)
```

<img src="man/figures/README-unnamed-chunk-8-1.png" alt="" width="100%" />

## Linear regression benchmark (`fastLm`)

quickr supports a variety of matrix operations from base R, including
most of the common linear algebra functions like `%*%`, `crossprod()`,
`tcrossprod()`, `solve()`, and `chol()`. Performance is generally
similar to running the same code in R itself, but as you start to chain
multiple operations in a function, you may see speed-ups due to reduced
interpreter overhead. Actual performance depends on the BLAS/LAPACK
libraries linked to your R build (e.g. OpenBLAS, MKL, Accelerate).

To illustrate, here is a benchmark showing a `fastLm`-style
implementation comparing base R, quickr, and (for reference) a compiled
RcppArmadillo implementation. The `fastLm` function is adapted from the
README of the RcppArmadillo project.

``` r
# reference implementation
fast_lm_ref <- function(X, y) {
  fit <- lm(y ~ X - 1)
  s <- summary(fit)

  list(
    coefficients = unname(coef(fit)),
    stderr = unname(s$coefficients[, "Std. Error"]),
    df.residual = fit$df.residual
  )
}

# RcppArmadillo implementation
Rcpp::sourceCpp(
code = '
#include <RcppArmadillo/Lighter>
// [[Rcpp::depends(RcppArmadillo)]]

// [[Rcpp::export]]
Rcpp::List fast_lm_rcpp_armadillo(const arma::mat& X, const arma::colvec& y) {
    int n = X.n_rows, k = X.n_cols;

    arma::colvec coef = arma::solve(X, y);     // fit model y ~ X
    arma::colvec res  = y - X*coef;            // residuals
    double s2 = arma::dot(res, res) / (n - k); // std.errors of coefficients
    arma::colvec std_err = arma::sqrt(s2 * arma::diagvec(arma::pinv(arma::trans(X)*X)));

    return Rcpp::List::create(Rcpp::Named("coefficients") = coef,
                              Rcpp::Named("stderr")       = std_err,
                              Rcpp::Named("df.residual")  = n - k);
}')

# Plain R fast-path
fast_lm_r <- function(X, y) {
  declare(
    type(X = double(n, k)),
    type(y = double(n))
  )

  # analogous to arma::pinv()
  pinv_svd <- function(A, tol = NULL) {
    s <- svd(A)
    if (is.null(tol)) {
      tol <- max(dim(A)) * max(s$d) * .Machine$double.eps
    }
    d_inv <- ifelse(s$d > tol, 1 / s$d, 0)
    s$v %*% (d_inv * t(s$u))
  }

  df_residual <- nrow(X) - ncol(X)

  coef <- qr.solve(X, y) # analogous to arma::solve(X, y)
  res <- y - X %*% coef
  s2 <- drop(crossprod(res)) / df_residual

  XtX <- crossprod(X)
  XtX_pinv <- pinv_svd(XtX) # analogous to arma::pinv()
  std_err <- sqrt(s2 * diag(XtX_pinv))

  list(
    coefficients = coef, 
    stderr = std_err,
    df.residual = df_residual
  )
}

# quickr func
quick_fast_lm <- quick(fast_lm_r)
```

### Benchmark

``` r
set.seed(1)

beta <- c(0.5, 1.0, -2.0, 10, 5)
X <- cbind(1, matrix(rnorm(3 * 10^5), ncol = 4))
y <- as.vector(X %*% beta + rnorm(nrow(X), sd = 2))

timings <- bench::mark(
  `reference`     = fast_lm_ref(X, y),
  `RcppArmadillo` = fast_lm_rcpp_armadillo(X, y),
  `plain R`       = fast_lm_r(X, y),
  `quickr`        = quick_fast_lm(X, y)
)

timings
#> # A tibble: 4 × 6
#>   expression         min   median `itr/sec` mem_alloc `gc/sec`
#>   <bch:expr>    <bch:tm> <bch:tm>     <dbl> <bch:byt>    <dbl>
#> 1 reference      65.18ms  65.41ms      13.9    29.6MB     13.9
#> 2 RcppArmadillo   5.56ms   7.86ms     110.         0B      0  
#> 3 plain R          5.1ms   8.82ms      66.7    13.2MB     16.0
#> 4 quickr          2.22ms   2.66ms     256.         0B      0
plot(timings) + ggplot2::scale_y_discrete(limits = rev(c( 
  "reference", "RcppArmadillo", "plain R", "quickr"
)))
```

<img src="man/figures/README-unnamed-chunk-10-1.png" alt="" width="100%" />

------------------------------------------------------------------------

## Parallelize loops with OpenMP

Use `declare(parallel())` to annotate the next `for` loop or `sapply()`
call for OpenMP parallelization. Parallel loops must be
order-independent: avoid shared-state updates or inter-iteration
dependencies. OpenMP adds overhead, so it can be slower for small
workloads, but substantially faster for larger ones.

Here is a concrete example using `colSums()`. At smaller sizes, the
quickr serial version is fastest (even faster than base `colSums()`). As
sizes grow, the two serial versions converge, and the parallel version
pulls ahead. However, the speedup is not linear with core count (e.g.,
with 12 cores, the speedup is closer to ~6x).

``` r
colSums_quick_parallel <- quick(function(x) {
  declare(type(x = double(NA, NA)))
  declare(parallel())
  sapply(seq_len(nrow(x)), \(r) sum(x[, r]))
})

colSums_quick <- quick(function(x) {
  declare(type(x = double(NA, NA)))
  sapply(seq_len(nrow(x)), \(r) sum(x[, r]))
})

r <- bench::press(
  n = 2^(4:14),
  {
    m <- array(runif(n * n), c(n, n))
    bench::mark(
      parallel = colSums_quick_parallel(m),
      quick = colSums_quick(m),
      base = colSums(m),
    )
  },
  .quiet = TRUE
)

library(ggplot2)
library(dplyr, warn.conflicts = FALSE)

r |>
  mutate(.before = 1,
         desc = attr(expression, "description")) |>
  select(desc, n, median) |>
  ggplot(aes(x = n, y = median, color = desc)) +
  geom_point() + geom_line() +
  scale_x_log10() + bench::scale_y_bench_time()
```

<img src="man/figures/README-unnamed-chunk-11-1.png" alt="" width="100%" />

quickr does not set OpenMP thread counts. To control threads, set
`OMP_NUM_THREADS` (and optionally `OMP_THREAD_LIMIT` or `OMP_DYNAMIC`)
before calling a compiled function, e.g.
`Sys.setenv(OMP_NUM_THREADS = "4")`.

## Using `quickr` in an R package

When called in a package, `quick()` will pre-compile the quick functions
and place them in the `./src` directory. Run `devtools::load_all()` or
`quickr::compile_package()` to ensure that the generated files in
`./src` and `./R` are in sync with each other.

In a package, you must provide a function name to `quick()`. For
example:

``` r
my_fun <- quick(name = "my_fun", function(x) ....)
```

## Installation

You can install quickr from CRAN with:

``` r
install.packages("quickr")
```

You can install the development version of quickr from
[GitHub](https://github.com/) with:

``` r
# install.packages("pak")
pak::pak("t-kalinowski/quickr")
```

You will also need a C and Fortran compiler, preferably the same ones
used to build R itself.

On macOS:

- Make sure xcode tools and gfortran are installed, as described in
  <https://mac.r-project.org/tools/>. In Terminal, run:

  ``` zsh
  sudo xcode-select --install
  # curl -LO https://mac.r-project.org/tools/gfortran-12.2-universal.pkg # R 4.4
  # sudo installer -pkg gfortran-12.2-universal.pkg -target /
  curl -LO https://mac.r-project.org/tools/gfortran-14.2-universal.pkg   # R 4.5
  sudo installer -pkg gfortran-14.2-universal.pkg -target /
  ```

- Optional: install `flang-new` via Homebrew (used by quickr on macOS
  when available):

  ``` zsh
  brew install flang
  ```

On Windows:

- Install the latest version of
  [Rtools](https://cran.r-project.org/bin/windows/Rtools/)

On Linux:

- The “Install Required Dependencies” section
  [here](https://docs.posit.co/resources/install-r-source.html#install-required-dependencies)
  provides detailed instructions for installing R build tools on various
  Linux flavors.

make_c_bridge <- function(
  fsub,
  strict = TRUE,
  headers = TRUE,
  force_rmath_header = FALSE,
  force_rng_header = FALSE
) {
  stopifnot(inherits(fsub, FortranSubroutine))

  closure <- fsub@closure
  scope <- fsub@scope
  uses_rng <- scope_uses_rng(scope)
  uses_errors <- scope_uses_errors_flag(scope)

  fsub_arg_names <- fsub@signature # arg names
  closure_arg_names <- names(formals(closure)) %||% character()

  c_body <- character()
  c_hoist <- c_bridge_hoist()

  closure_arg_vars <- mget(closure_arg_names, scope)
  closure_arg_fortran_names <- map_chr(closure_arg_vars, \(var) var@name)
  if (!all(closure_arg_fortran_names %in% fsub_arg_names)) {
    missing_idx <- which(!closure_arg_fortran_names %in% fsub_arg_names)
    stop(
      "Undeclared arguments: ",
      str_flatten_commas(closure_arg_names[missing_idx])
    )
  }

  # first unpack all the input vars into named C variables (including sizes and pointer)
  arg_defs <- lapply(
    closure_arg_vars,
    closure_arg_c_defs,
    strict = strict
  ) |>
    rbind("")

  ## TODO, might still need to define a length size for vars where rank>1, if in checks.

  # now do all size checks.
  size_checks <- unlist(
    lapply(
      closure_arg_vars,
      closure_arg_size_checks,
      scope = scope,
      c_hoist = c_hoist
    ),
    use.names = FALSE
  )

  # maybe define and allocate the output var(s)
  n_protected <- 0L
  return_var_names <- scope_return_var_names(scope)
  return_defs <- character()
  # Deduplicate by the underlying variable name to avoid duplicate C defs
  for (return_var in mget(unique(unname(return_var_names)), scope)) {
    return_var_r_name <- return_var@r_name %||% return_var@name
    if (!return_var_r_name %in% closure_arg_names) {
      return_var@modified <- TRUE
      assign(return_var_r_name, return_var, scope)
      append(return_defs) <- return_var_c_defs(
        return_var,
        fsub@scope,
        c_hoist = c_hoist
      )
      add(n_protected) <- 1L # allocated return var
      if (return_var@rank > 1) {
        add(n_protected) <- 1L # allocated _dim_sexp
      }
    }
  }

  c_body <- c(arg_defs)
  append(c_body) <- size_checks
  append(c_body) <- return_defs

  if (uses_errors) {
    append(c_body) <- c(
      "",
      glue("char {quickr_error_msg_name()}[{quickr_error_msg_len()}];"),
      glue("{quickr_error_msg_name()}[0] = '\\0';"),
      ""
    )
  }

  fsub_call_args <- fsub_arg_names |>
    lapply(\(nm) {
      if (is_quickr_error_msg(nm)) {
        return(nm)
      }
      paste0(nm, if (!is_size_name(nm)) "__")
    }) |>
    unlist()

  if (length(fsub_call_args) > 3) {
    fsub_call_args <- paste0("\n  ", fsub_call_args)
  }

  append(c_body) <- c(
    "",
    if (uses_rng) "GetRNGstate();",
    glue("{fsub@name}({str_flatten_commas(fsub_call_args)});"),
    if (uses_rng) "PutRNGstate();",
    if (uses_errors) glue("if ({quickr_error_msg_name()}[0] != '\\0') {{"),
    if (uses_errors) {
      indent(glue(
        "Rf_error(\"%s\", {quickr_error_msg_name()});"
      ))
    },
    if (uses_errors) "}",
    ""
  )
  # Determine if the closure returns a list call or a single symbol
  is_list_return <- is_call(last(body(closure)), quote(list))

  if (length(return_var_names) == 1L && !is_list_return) {
    return_var_r_name <- unname(return_var_names)[[1L]]
    return_var_c_name <- scope[[return_var_r_name]]@name
    if (n_protected > 0) {
      append(c_body) <- glue("UNPROTECT({n_protected});")
    }
    append(c_body) <- glue("return {return_var_c_name};")
  } else {
    return_var_values <- unname(return_var_names)
    return_var_c_names <- unname(map_chr(
      mget(return_var_values, scope),
      \(var) var@name
    ))
    provided_names <- names(return_var_names)
    if (is.null(provided_names)) {
      provided_names <- rep("", length(return_var_values))
    }
    has_any_names <- any(nzchar(provided_names))

    append(c_body) <- c(
      glue(
        "SEXP _ans = PROTECT(Rf_allocVector(VECSXP, {length(return_var_values)}));"
      ),
      imap(return_var_c_names, function(nm, i) {
        glue("SET_VECTOR_ELT(_ans, {i-1}, {nm});")
      })
    )

    if (has_any_names) {
      names_to_use <- provided_names
      append(c_body) <- c(
        glue(
          "SEXP _names = PROTECT(Rf_allocVector(STRSXP, {length(return_var_values)}));"
        ),
        imap(names_to_use, function(nm, i) {
          glue('SET_STRING_ELT(_names, {i-1}, Rf_mkChar("{nm}"));')
        }),
        "Rf_setAttrib(_ans, R_NamesSymbol, _names);"
      )
      append(c_body) <- glue("UNPROTECT({n_protected + 2});")
    } else {
      append(c_body) <- glue("UNPROTECT({n_protected + 1});")
    }

    append(c_body) <- "return _ans;"
  }

  c_args <- paste("SEXP", names(formals(closure)), collapse = ", ")
  needs_rmath <- any(grepl("R_pow(", c_body, fixed = TRUE))
  c_body <- as_glue(str_flatten_lines(c_body))

  c_func_def <- glue("SEXP {fsub@name}_(SEXP _args) {c_block(c_body)}")

  fsub_extern_decl <- fsub_extern_decl(fsub)

  c_headers <- str_flatten_lines(
    "#define R_NO_REMAP",
    "#include <R.h>",
    "#include <Rinternals.h>",
    if (needs_rmath || isTRUE(force_rmath_header)) "#include <Rmath.h>",
    if (uses_rng || isTRUE(force_rng_header)) "#include <R_ext/Random.h>",
    "",
    ""
  )

  as_glue(str_flatten_lines(c(
    if (headers) c_headers,
    fsub_extern_decl,
    "",
    c_func_def
  )))
}


closure_arg_c_defs <- function(var, strict = TRUE) {
  name <- var@name
  mode <- var@mode

  c_code <- character()

  name <- var@name
  SEXPTYPE <- sexptype(var@mode)
  protect <- glue("SETCAR(_args, {var@name});")

  append(c_code) <- glue(
    "// {name}
    _args = CDR(_args);
    SEXP {var@name} = CAR(_args);"
  )

  # first maybe duplicate or coerce the SEXP if needed.
  append(c_code) <- glue("if (TYPEOF({name}) != {SEXPTYPE}) {{")
  append(c_code) <- indent(
    if (strict) {
      glue(
        r"(
      Rf_error("typeof({name}) must be '{mode}', not '%s'", Rf_type2char(TYPEOF({name})));
      )"
      )
    } else {
      glue(
        "{name} = Rf_coerceVector({name}, {SEXPTYPE});
         {protect}"
      )
    }
  )

  if (var@modified) {
    dup <- glue(
      '
      {name} = Rf_duplicate({name});
      {protect}
      '
    )

    if (strict) {
      append(c_code) <- c("}", dup)
    } else {
      append(c_code) <- sprintf("} else %s", dup)
    }
  } else {
    append(c_code) <- "}"
  }

  # define the variable that will be passed to the fsub
  append(c_code) <- glue(
    "{fsub_arg_var_c_type(var)} {name}__ = {sexpdata(var@mode)}({name});"
  )

  if (var@rank == 1) {
    size_name <- get_size_name(var)
    append(c_code) <- glue(
      "const R_xlen_t {size_name} = Rf_xlength({var@name});"
    )
  } else if (var@rank > 1) {
    append(c_code) <- glue(
      'const int* const {var@name}__dim_ = ({{
         SEXP dim_ = Rf_getAttrib({var@name}, R_DimSymbol);
         if (Rf_length(dim_) != {var@rank}) Rf_error(
           "{var@name} must be a {var@rank}D-array, but length(dim({var@name})) is %i",
           (int) Rf_length(dim_));
         INTEGER(dim_);}});'
    )
    append(c_code) <- map_chr(seq_len(var@rank), \(axis) {
      size_name <- get_size_name(var, axis)
      glue("const int {size_name} = {var@name}__dim_[{axis-1}];")
    })
  } else {
    stop(
      "bad rank for argument `",
      var@r_name %||% var@name,
      "`: quickr does not support rank-0 arguments. ",
      "Declare scalars with an explicit length, e.g. `integer(1)` or `double(1)`."
    )
  }

  as_glue(str_flatten_lines(c_code))
}


closure_arg_size_checks <- function(var, scope, c_hoist = NULL) {
  imap(var@dims, function(d, axis) {
    # axis is either:
    #  - an integer
    #  - a symbol of a size_name
    #  - a call, consisting of only size_name symbols and basic arithmetic ops.
    size_name <- get_size_name(var, axis)

    if (is_scalar_integer(d)) {
      return(glue(
        '
          if ({size_name} != {d})
            Rf_error("{friendly_size(var, axis)} must be {d}, not %0.f",
                      (double){size_name});'
      ))
    }

    if (is.symbol(d)) {
      if (as.character(d) == size_name) {
        # self-named size_name is expected to be passed along to subroutine
        return()
      }

      d_name <- as.character(d)
      d_var <- get0(d_name, scope)
      if (inherits(d_var, Variable)) {
        d_expr <- as_c_name(d_var, c_hoist = c_hoist)
        d_label <- d_name
      } else if (is_size_name(d_name)) {
        d_expr <- d_name
        d_label <- as_friendly_size_name(d_name)
      } else {
        d_expr <- d_name
        d_label <- d_name
      }

      decls <- if (!is.null(c_hoist)) {
        c_bridge_hoist_take_pending(c_hoist)
      } else {
        character()
      }
      c_lines <- c(
        decls,
        glue(
          '
            if ({d_expr} != {size_name})
              Rf_error("{as_friendly_size_name(size_name)} must equal {d_label},"
                       " but are %0.f and %0.f",
                        (double){size_name}, (double){d_expr});'
        )
      )
      return(as_glue(str_flatten_lines(c_lines)))
    }

    if (is.call(d)) {
      size.c <- dims2c(list(d), scope, c_hoist = c_hoist)[[1L]]
      decls <- if (!is.null(c_hoist)) {
        c_bridge_hoist_take_pending(c_hoist)
      } else {
        character()
      }
      c_lines <- c(
        decls,
        glue(
          '{{
            const R_xlen_t expected = {size.c};
            if ({size_name} != expected)
              Rf_error("{as_friendly_size_name(size_name)} must equal {as_friendly_size_expression(d)},"
                       " but are %0.f and %0.f",
                        (double){size_name}, (double)expected);
          }}'
        )
      )
      return(as_glue(str_flatten_lines(c_lines)))
    }

    stop("bad dim")
  })
}


return_var_c_defs <- function(var, scope, c_hoist = NULL) {
  # allocate the return var.
  name <- var@name
  len_name <- get_size_name(var)
  c_dims <- dims2c(var@dims, scope, c_hoist = c_hoist)
  names(c_dims) <- NULL
  c_len <- c_dims2c_len(c_dims)
  decls <- if (!is.null(c_hoist)) {
    c_bridge_hoist_take_pending(c_hoist)
  } else {
    character()
  }

  c_code <- c(
    decls,
    glue("const R_xlen_t {len_name} = {c_len};"),
    glue(switch(
      var@mode,
      double = "
        SEXP {name} = PROTECT(Rf_allocVector(REALSXP, {len_name}));
        double* {name}__ = REAL({name});",
      integer = "
        SEXP {name} = PROTECT(Rf_allocVector(INTSXP, {len_name}));
        int* {name}__ = INTEGER({name});",
      complex = "
        SEXP {name} = PROTECT(Rf_allocVector(CPLXSXP, {len_name}));
        Rcomplex* {name}__ = COMPLEX({name});",
      logical = "
        SEXP {name} = PROTECT(Rf_allocVector(LGLSXP, {len_name}));
        int* {name}__ = LOGICAL({name});"
    ))
  )

  if (var@rank > 1) {
    append(c_code) <- c_block(
      glue(
        "
        const SEXP _dim_sexp = PROTECT(Rf_allocVector(INTSXP, {var@rank}));
        int* const _dim = INTEGER(_dim_sexp);"
      ),
      imap(c_dims, function(d, i) {
        glue("_dim[{i-1}] = {d};")
      }),
      glue("Rf_dimgets({var@name}, _dim_sexp);")
    )
  }

  str_flatten_lines(c_code)
}


c_bridge_hoist <- function() {
  hoist <- new.env(parent = emptyenv())
  hoist$as_int <- new.env(parent = emptyenv())
  hoist$as_int_tmp <- new.env(parent = emptyenv())
  hoist$used_tmp <- new.env(parent = emptyenv())
  hoist$pending <- character()
  hoist
}

c_bridge_hoist_as_int <- function(hoist, sexp_name, expr) {
  stopifnot(is.environment(hoist), is_string(sexp_name), is_string(expr))

  existing <- get0(sexp_name, envir = hoist$as_int, inherits = FALSE)
  if (is_string(existing)) {
    return(existing)
  }

  tmp <- c_bridge_hoist_tmp_name(hoist, sexp_name)
  assign(sexp_name, tmp, envir = hoist$as_int)
  hoist$pending <- c(hoist$pending, glue("const int {tmp} = {expr};"))
  tmp
}

c_bridge_hoist_tmp_name <- function(hoist, sexp_name) {
  existing <- get0(sexp_name, envir = hoist$as_int_tmp, inherits = FALSE)
  if (is_string(existing)) {
    return(existing)
  }

  safe <- gsub("[^A-Za-z0-9_]", "_", sexp_name)
  if (!nzchar(safe) || !grepl("^[A-Za-z_]", safe)) {
    safe <- paste0("x_", safe)
  }

  tmp_base <- paste0("_as_int_", safe)
  tmp <- tmp_base
  i <- 1L
  while (isTRUE(get0(tmp, envir = hoist$used_tmp, inherits = FALSE))) {
    i <- i + 1L
    tmp <- paste0(tmp_base, "_", i)
  }
  assign(tmp, TRUE, envir = hoist$used_tmp)
  assign(sexp_name, tmp, envir = hoist$as_int_tmp)
  tmp
}

c_bridge_hoist_take_pending <- function(hoist) {
  stopifnot(is.environment(hoist))
  pending <- hoist$pending %||% character()
  hoist$pending <- character()
  pending
}


as_c_name <- function(var, c_hoist = NULL) {
  stopifnot(inherits(var, Variable))
  expr <- glue("Rf_asInteger({var@name})")
  if (is.null(c_hoist)) {
    return(expr)
  }
  c_bridge_hoist_as_int(c_hoist, var@name, expr)
}

dims2c_length_expr <- function(arg, scope) {
  if (!is.symbol(arg)) {
    stop("length() size expressions must refer to a symbol")
  }
  nm <- as.character(arg)
  var <- get0(nm, scope)
  if (!inherits(var, Variable)) {
    stop("could not resolve size: ", nm)
  }
  if (var@rank <= 0L) {
    return("1")
  }
  if (var@rank == 1L) {
    return(get_size_name(var))
  }
  dims <- map_chr(seq_len(var@rank), \(axis) get_size_name(var, axis))
  paste0("(", paste0(dims, collapse = " * "), ")")
}

dims2c_dim_index_expr <- function(cl, scope) {
  stopifnot(is.call(cl), identical(as.character(cl[[1L]]), "["))
  if (length(cl) != 3L || !is_call(cl[[2L]], quote(dim))) {
    stop("unsupported size expression: ", deparse1(cl))
  }
  dim_arg <- cl[[2L]][[2L]]
  if (!is.symbol(dim_arg)) {
    stop("dim() size expressions must refer to a symbol")
  }
  axis <- cl[[3L]]
  if (!is_wholenumber(axis)) {
    stop("dim(x)[axis] requires integer axis")
  }
  var <- get0(as.character(dim_arg), scope)
  if (!inherits(var, Variable)) {
    stop("could not resolve size: ", deparse1(cl))
  }
  if (axis > var@rank) {
    stop("insufficient rank of variable in ", deparse1(cl))
  }
  get_size_name(var, axis)
}

dims2c_expr <- function(e, scope, c_hoist = NULL) {
  if (is.null(e)) {
    return(NULL)
  }

  if (inherits(e, Variable)) {
    return(as_c_name(e, c_hoist = c_hoist))
  }

  if (is_scalar_integer(e)) {
    return(as.character(e))
  }

  if (is_wholenumber(e)) {
    return(as.character(as.integer(e)))
  }

  if (is.symbol(e)) {
    nm <- as.character(e)
    if (is_size_name(nm)) {
      return(nm)
    }
    var <- get0(nm, scope)
    if (!inherits(var, Variable) && inherits(scope, "quickr_scope")) {
      var <- scope_var_by_fortran_name(scope, nm)
    }
    if (!inherits(var, Variable)) {
      stop("could not resolve size: ", nm)
    }
    return(as_c_name(var, c_hoist = c_hoist))
  }

  if (!is.call(e)) {
    stop("unsupported size expression: ", deparse1(e))
  }

  op <- as.character(e[[1L]])
  args <- as.list(e)[-1L]

  if (identical(op, "(")) {
    if (length(args) != 1L) {
      stop("unsupported size expression: ", deparse1(e))
    }
    return(dims2c_expr(args[[1L]], scope, c_hoist = c_hoist))
  }

  if (identical(op, "length")) {
    if (length(args) != 1L) {
      stop("length() expects one argument")
    }
    return(dims2c_length_expr(args[[1L]], scope))
  }

  if (identical(op, "[")) {
    return(dims2c_dim_index_expr(e, scope))
  }

  if (identical(op, "nrow")) {
    if (length(args) != 1L) {
      stop("nrow() expects one argument")
    }
    return(dims2c_dim_index_expr(call("[", call("dim", args[[1L]]), 1L), scope))
  }

  if (identical(op, "ncol")) {
    if (length(args) != 1L) {
      stop("ncol() expects one argument")
    }
    return(dims2c_dim_index_expr(call("[", call("dim", args[[1L]]), 2L), scope))
  }

  if (identical(op, "abs")) {
    if (length(args) != 1L) {
      stop("abs() expects one argument")
    }
    e1 <- dims2c_expr(args[[1L]], scope, c_hoist = c_hoist)
    return(glue("(({e1}) < 0 ? -({e1}) : ({e1}))"))
  }

  if (op %in% c("+", "-", "*", "/", "%/%", "%%", "^")) {
    if (length(args) == 1L && op %in% c("+", "-")) {
      e1 <- dims2c_expr(args[[1L]], scope, c_hoist = c_hoist)
      return(glue("({op}({e1}))"))
    }
    if (length(args) != 2L) {
      stop("unsupported size expression: ", deparse1(e))
    }
    e1 <- dims2c_expr(args[[1L]], scope, c_hoist = c_hoist)
    e2 <- dims2c_expr(args[[2L]], scope, c_hoist = c_hoist)
    return(switch(
      op,
      `+` = glue("({e1} + {e2})"),
      `-` = glue("({e1} - {e2})"),
      `*` = glue("({e1} * {e2})"),
      `/` = glue("((double)({e1}) / (double)({e2}))"),
      `%/%` = glue("((R_xlen_t){e1} / (R_xlen_t){e2})"),
      `%%` = glue("((R_xlen_t){e1} % (R_xlen_t){e2})"),
      `^` = glue("R_pow((double)({e1}), (double)({e2}))")
    ))
  }

  if (op %in% c("min", "max")) {
    if (!length(args)) {
      return("0")
    }
    rendered <- lapply(args, dims2c_expr, scope = scope, c_hoist = c_hoist)
    cmp <- if (identical(op, "min")) "<" else ">"
    reduce(rendered, \(a, b) glue("(({a}) {cmp} ({b}) ? ({a}) : ({b}))"))
  } else {
    stop("unsupported size expression: ", deparse1(e))
  }
}

dims2c <- function(dims, scope, c_hoist = NULL) {
  if (!length(dims) || identical(dims, list(1L))) {
    return(list(NULL, "1"))
  }
  lapply(dims, dims2c_expr, scope = scope, c_hoist = c_hoist)
}

c_dims2c_len <- function(c_dims) {
  if (length(c_dims) == 1) {
    c_dims[[1L]]
  } else {
    paste0("(", unlist(c_dims), ")", collapse = " * ")
  }
  # eval(Reduce(\(a, b) { call("*", as.symbol(a@name), as.symbol(b@name)) }, dims),
  #      eval_env)
}


# --- utils ----

c_block <- function(...) {
  as_glue(paste0(c("{", indent(c(...)), "}"), collapse = "\n"))
}

# is_var_size <- function(x) inherits(x, VariableSize)

passes_as_scalar <- function(var) {
  var@rank == 0 || var@rank == 1 && identical(var@dims, list(1L))
}

passes_as_value <- function(var) {
  passes_as_scalar(var) && isFALSE(var@modified)
}

sexptype <- function(mode) {
  switch(
    mode,
    integer = "INTSXP",
    double = "REALSXP",
    complex = "CPLXSXP",
    logical = "LGLSXP",
    stop("Unrecognized mode: ", mode)
  )
}

sexpdata <- function(mode) {
  switch(
    mode,
    integer = "INTEGER",
    double = "REAL",
    complex = "COMPLEX",
    logical = "LOGICAL",
    stop("Unrecognized mode: ", mode)
  )
}

is_size_name <- function(name) {
  if (is.symbol(name)) {
    name <- as.character(name)
  } else if (!is_string(name)) {
    return(FALSE)
  }

  grepl("(_len_|_dim_[0-9]+_)$", name)
}

friendly_size <- function(var, axis = NULL) {
  if (is.null(axis) || var@rank == 1 && axis == 1) {
    glue("length({var@name})")
  } else {
    glue("dim({var@name})[{axis}]")
  }
}

as_friendly_size_name <- function(size_name) {
  size_name <- as.character(size_name)
  if (endsWith(size_name, "__len_")) {
    sprintf("length(%s)", sub("__len_$", "", size_name))
  } else {
    sub("^(.*)__dim_([0-9]+)_$", "dim(\\1)[\\2]", size_name)
  }
}

as_friendly_size_expression <- function(d) {
  stopifnot(is.call(d))
  nms <- all.names(d, functions = FALSE, unique = TRUE)
  friendly_substitutions <- new.env(parent = emptyenv())
  for (name in nms) {
    if (is_size_name(name)) {
      assign(
        name,
        str2lang(as_friendly_size_name(name)),
        friendly_substitutions
      )
    }
  }
  d <- substitute_(d, friendly_substitutions)
  d <- call("(", d)
  deparse1(d)
}

closure_return_var_names <- function(closure) {
  return_var_expr <- last(body(closure))
  if (is.symbol(return_var_expr)) {
    val <- as.character(return_var_expr)
    # Return named to keep interface consistent
    return(setNames(val, val))
  }
  if (is_call(return_var_expr, quote(list))) {
    args <- as.list(return_var_expr)[-1L]
    if (length(args) == 0L) {
      stop("return list must contain at least one element")
    }
    vals <- map_chr(args, as.character)
    nms <- names(args)
    if (is.null(nms)) {
      nms <- rep("", length(vals))
    }
    # validate names are syntactic when provided
    if (any(nzchar(nms))) {
      bad <- nzchar(nms) & make.names(nms) != nms
      if (any(bad)) {
        stop(
          "only syntactic names are valid, encountered: ",
          paste0(nms[bad], sep = ", ")
        )
      }
    }
    # Use provided names when present; fallback to symbol names
    # nms <- ifelse(nzchar(nms), nms, vals)
    return(setNames(vals, nms))
  }
  ## is it redundent ? new_fortran_subroutine also errors ?
  stop("return value must be a symbol or list of symbols")
}


fsub_arg_var_c_type <- function(var) {
  type <- switch(
    var@mode,
    double = "double*",
    integer = "int*",
    complex = "Rcomplex*",
    logical = "int*",
  )

  # the first const declares that the pointed to values can't be modified
  #   (the array values are read only)
  # the second const declares that the pointer itself can't be modified
  #   (the fsub can never move/reallocate the array, so this const is always present)
  paste0(c(if (!var@modified) "const", type, "const"), collapse = " ")
}

fsub_extern_decl <- function(fsub) {
  fsub_arg_names <- fsub@signature # arg names
  scope <- fsub@scope

  fsub_c_sig <- map_chr(fsub_arg_names, function(name) {
    if (is_quickr_error_msg(name)) {
      return(glue("char* {name}"))
    }
    if (is_size_name(name)) {
      type <- if (name |> endsWith("__len_")) {
        "R_xlen_t"
      } else {
        "R_len_t"
      }
      glue("const {type} {name}")
    } else {
      var <- scope_var_by_fortran_name(scope, name)
      if (!inherits(var, Variable)) {
        stop("internal error: could not resolve variable: ", name)
      }
      glue("{fsub_arg_var_c_type(var)} {var@name}__")
    }
  })
  if (length(fsub_c_sig) >= 3L) {
    fsub_c_sig <- paste0("\n  ", fsub_c_sig)
  }

  glue("extern void {fsub@name}({str_flatten_commas(fsub_c_sig)});")
}

# Example: convolution

skip_on_cran()

test_that("convolve", {
  # options("quickr.r2f.debug" = TRUE)
  slow_convolve <- function(a, b) {
    declare(type(a = double(NA)))
    declare(type(b = double(NA)))

    ab <- double(length(a) + length(b) - 1)
    for (i in seq_along(a)) {
      for (j in seq_along(b)) {
        ab[i + j - 1] = ab[i + j - 1] + a[i] * b[j]
      }
    }
    ab
  }

  fsub <- new_fortran_subroutine("slow_convolve", slow_convolve)
  cwrapper <- make_c_bridge(fsub)

  expect_snapshot(
    {
      slow_convolve
      cat(fsub)
      cat(cwrapper)
    },
    transform = scrub_environment
  )

  quick_convolve <- quick(name = "quick_convolve", slow_convolve)
  a <- 1:3
  b <- 10:15
  expect_error(
    quick_convolve(a, b),
    "must be 'double', not 'integer'",
    fixed = TRUE
  )
  a <- as.double(1:3)
  b <- as.double(10:15)
  expect_equal(quick_convolve(a, b), slow_convolve(a, b))
  a <- as.double(0:3)
  b <- 1
  expect_equal(quick_convolve(a, b), slow_convolve(a, b))
})

# Unit tests for matrix creation and implicit size reuse

skip_on_cran()

test_that("matrix", {
  fn <- function(a, b) {
    declare(type(a = integer(1)))
    declare(type(b = integer(1)))

    out <- matrix(0, a, b)
    out
  }

  fsub <- r2f(fn)
  make_c_bridge(fsub)

  (r2f(fn))
  expect_snapshot(r2f(fn))

  qfn <- quick(fn)

  # expect_identical(qfn(3, 4), fn(3, 4))  ## strict = TRUE by default
  # expect_identical(qfn(3L, 4), fn(3L, 4))
  expect_identical(qfn(3L, 4L), fn(3L, 4L))

  fn <- function(val, nc, nr) {
    # declare({
    #   type(val = double(1))
    #   type(a = integer(1))
    #   type(b = integer(1))
    # })
    declare(
      type(val = double(1)),
      type(nc = integer(1)),
      type(nr = integer(1))
    )

    out <- matrix(val, nc, nr)
    out
  }
  qfn <- quick(fn)

  qfn(1.1, 3L, 3L)

  expect_identical(qfn(2.3, 3L, 4L), fn(2.3, 3L, 4L))
  expect_identical(qfn(2.3, 3L, 4L), matrix(2.3, 3L, 4L))
  # bench::mark(fn(2.3, 3, 4), matrix(2.3, 3, 4), qfn(2.3, 3, 4)) -> r; print(r); plot(r)
})

test_that("matrix() reshapes non-scalar data expressions", {
  fn <- function(x) {
    declare(type(x = double(2L, 3L)))
    matrix(as.integer(x), nrow = 2L, ncol = 3L)
  }

  x <- matrix(as.double(1:6), nrow = 2L, ncol = 3L)
  expect_quick_identical(fn, list(x))
})

test_that("matrix() does not evaluate data expressions twice", {
  fn <- function() {
    matrix(runif(4L), nrow = 2L, ncol = 2L)
  }
  qfn <- quick(fn)

  set.seed(1234)
  qfn()
  q_next <- runif(1L)

  set.seed(1234)
  fn()
  r_next <- runif(1L)

  expect_equal(q_next, r_next)
})

test_that("reuse implicit size", {
  fn <- function(a1, a2) {
    declare(type(a1 = double(n)))
    declare(type(a2 = double(n, n)))
    out <- a1 + a2[1, ]
    out
  }

  fsub <- r2f(fn)
  c_wrapper <- make_c_bridge(fsub)
  qfn <- quick(fn)

  expect_snapshot({
    print(fsub)
    cat(c_wrapper)
  })

  n <- 400
  a1 <- as.double(1:n)
  a2 <- matrix(runif(n), n, n)

  expect_identical(fn(a1, a2), qfn(a1, a2))

  # bench::mark(fn(a1, a2), qfn(a1, a2)) |> print() |> plot()
})

test_that("vector-matrix ops only recycle along the first dimension", {
  fn <- function(vec, mat) {
    declare(
      type(vec = double(3)),
      type(mat = double(1L, 3))
    )
    left_side_vec <- vec + mat
    right_side_vec <- mat + vec
    out <- left_side_vec + right_side_vec
    out
  }

  expect_error(
    quick(fn),
    "elementwise vector-matrix operations require a scalar or a vector length equal to the matrix first dimension (nrow)",
    fixed = TRUE
  )
})

test_that("elementwise vector and singleton column matrix keep matrix shape", {
  fn <- function(vec, mat) {
    declare(
      type(vec = double(n)),
      type(mat = double(n, 1L))
    )
    left_side_vec <- vec + mat
    right_side_vec <- mat + vec
    out <- left_side_vec + right_side_vec
    out
  }

  expect_quick_identical(
    fn,
    list(runif(4), matrix(runif(4), ncol = 1L))
  )
})

test_that("elementwise vector-matrix reuse works across columns", {
  fn <- function(vec, mat) {
    declare(
      type(vec = double(3)),
      type(mat = double(3, 2))
    )
    left <- vec * mat
    right <- mat * vec
    left + right
  }

  vec <- as.double(1:3)
  mat <- matrix(as.double(1:6), nrow = 3)

  expect_quick_identical(fn, list(vec, mat))
})

test_that("elementwise vector-matrix ops allow scalar vectors", {
  fn <- function(vec, mat) {
    declare(
      type(vec = double(1)),
      type(mat = double(3, 2))
    )
    vec + mat
  }

  vec <- 2.5
  mat <- matrix(as.double(1:6), nrow = 3)

  expect_quick_identical(fn, list(vec, mat))
})

test_that("elementwise vector-matrix ops reject longer vectors", {
  fn <- function(vec, mat) {
    declare(
      type(vec = double(2)),
      type(mat = double(3, 2))
    )
    vec + mat
  }

  expect_error(
    quick(fn),
    "elementwise vector-matrix operations require a scalar or a vector length equal to the matrix first dimension (nrow)",
    fixed = TRUE
  )
})

test_that("elementwise matrix operations require matching dimensions", {
  fn <- function(a, b) {
    declare(
      type(a = double(2, 3)),
      type(b = double(2, 2))
    )
    a + b
  }

  expect_error(
    quick(fn),
    "elementwise matrix operations require matching dimensions",
    fixed = TRUE
  )
})

test_that("elementwise vector operations require matching lengths", {
  fn <- function(a, b) {
    declare(
      type(a = double(2)),
      type(b = double(3))
    )
    a + b
  }

  expect_error(
    quick(fn),
    "elementwise vector operations require lengths that recycle cleanly unless one operand is scalar",
    fixed = TRUE
  )
})

test_that("elementwise vector ops allow scalar vectors", {
  fn <- function(a, b) {
    declare(
      type(a = double(1)),
      type(b = double(3))
    )
    a + b
  }

  expect_quick_identical(fn, list(2.5, as.double(1:3)))
})

test_that("elementwise ops reshape vectors for singleton matrices", {
  fn <- function(vec, mat) {
    declare(
      type(vec = double(n)),
      type(mat = double(n, 1L))
    )
    a <- vec - mat
    b <- mat * vec
    c <- vec / mat
    a + b + c
  }

  expect_quick_identical(
    fn,
    list(runif(3) + 1, matrix(runif(3) + 1, ncol = 1L))
  )
})

test_that("1x1 matrix preserves matrix result with length-1 vector", {
  fn <- function(vec, mat) {
    declare(
      type(vec = double(1L)),
      type(mat = double(1L, 1L))
    )
    vec + mat
  }

  expect_quick_identical(
    fn,
    list(runif(1), matrix(runif(1), nrow = 1L))
  )
})

test_that("1x1 matrix with length-3 vector yields a vector", {
  fn <- function(vec, mat_1_1) {
    declare(
      type(vec = double(3)),
      type(mat_1_1 = double(1, 1))
    )
    a <- vec + mat_1_1
    b <- mat_1_1 + vec
    out <- list(a = a, b = b)
    out
  }

  suppressWarnings(expect_quick_identical(
    fn,
    list(c(1, 2, 3), matrix(1, nrow = 1L, ncol = 1L))
  ))
})

test_that("indexing function like transposed expressions hoists temporaries that can be accessed", {
  fn <- function(x) {
    declare(type(x = double(5, 5)))
    first_element <- t(x)[1]
    second_row <- t(x)[2, ]
    third_col <- t(x)[, 3]
    sub_matrix <- t(x)[c(1, 2), c(3, 4)]
    list(
      first_element = first_element,
      second_row = second_row,
      third_col = third_col,
      sub_matrix = sub_matrix
    )
  }

  x <- matrix(runif(25), 5, 5)
  expect_quick_identical(fn, list(x = x))
})

# Example: Heat diffusion simulation

skip_on_cran()

test_that("heat diffusion", {
  # Heat Diffusion Simulation in R
  # 2D grid, explicit time-stepping, fixed boundaries

  # Parameters
  nx <- 60L # Grid size in x
  ny <- 60L # Grid size in y
  dx <- 1L # Grid spacing
  dy <- 1L
  dt <- 0.01 # Time step
  k <- 0.1 # Thermal diffusivity
  steps <- 25L # Number of time steps

  diffuse_heat <- function(nx, ny, dx, dy, dt, k, steps) {
    declare(
      type(nx = integer(1)),
      type(ny = integer(1)),
      type(dx = integer(1)),
      type(dy = integer(1)),
      type(dt = double(1)),
      type(k = double(1)),
      type(steps = integer(1))
    )

    # Initialize temperature grid
    temp <- matrix(0, nx, ny)
    temp[nx / 2, ny / 2] <- 100 # Initial heat source in the center

    apply_boundary_conditions <- function(temp) {
      temp[1, ] <- 0
      temp[nx, ] <- 0
      temp[, 1] <- 0
      temp[, ny] <- 0
      temp
    }

    update_temperature <- function(temp, k, dx, dy, dt) {
      temp_new <- temp
      for (i in 2:(nx - 1)) {
        for (j in 2:(ny - 1)) {
          temp_new[i, j] <- temp[i, j] +
            k *
              dt *
              ((temp[i + 1, j] - 2 * temp[i, j] + temp[i - 1, j]) /
                dx^2 +
                (temp[i, j + 1] - 2 * temp[i, j] + temp[i, j - 1]) / dy^2)
        }
      }
      temp_new
    }

    # Time stepping
    for (step in seq_len(steps)) {
      temp <- apply_boundary_conditions(temp)
      temp <- update_temperature(temp, k, dx, dy, dt)
    }

    temp

    # Plot the final temperature distribution
    # image(temp, col = heat.colors(100), main = "Heat Diffusion")
  }

  fsub <- r2f(diffuse_heat)
  expect_snapshot(
    {
      diffuse_heat
      cat(fsub)
      cat(make_c_bridge(fsub))
    },
    transform = scrub_environment
  )

  qdiffuse_heat <- quick(diffuse_heat)

  expect_equal(
    qdiffuse_heat(nx, ny, dx, dy, dt, k, steps),
    diffuse_heat(nx, ny, dx, dy, dt, k, steps)
  )

  if (FALSE) {
    bench::mark(
      qdiffuse_heat(nx, ny, dx, dy, dt, k, steps),
      diffuse_heat(nx, ny, dx, dy, dt, k, steps)
    ) -> res
    res |> print() |> plot()
    summary(res, relative = TRUE) |> print()
  }
})

test_that("heat diffusion with statement boundary closure + <<-", {
  # Smaller runtime parameters; snapshot is compile-time only.
  nx <- 20L
  ny <- 20L
  dx <- 1L
  dy <- 1L
  dt <- 0.01
  k <- 0.1
  steps <- 5L

  diffuse_heat <- function(nx, ny, dx, dy, dt, k, steps) {
    declare(
      type(nx = integer(1)),
      type(ny = integer(1)),
      type(dx = integer(1)),
      type(dy = integer(1)),
      type(dt = double(1)),
      type(k = double(1)),
      type(steps = integer(1))
    )

    temp <- matrix(0, nx, ny)
    temp[nx / 2, ny / 2] <- 100

    apply_boundary_conditions <- function() {
      temp[1, ] <<- 0
      temp[nx, ] <<- 0
      temp[, 1] <<- 0
      temp[, ny] <<- 0
    }

    update_temperature <- function(temp, k, dx, dy, dt) {
      temp_new <- temp
      for (i in 2:(nx - 1)) {
        for (j in 2:(ny - 1)) {
          temp_new[i, j] <- temp[i, j] +
            k *
              dt *
              ((temp[i + 1, j] - 2 * temp[i, j] + temp[i - 1, j]) /
                dx^2 +
                (temp[i, j + 1] - 2 * temp[i, j] + temp[i, j - 1]) / dy^2)
        }
      }
      temp_new
    }

    for (step in seq_len(steps)) {
      apply_boundary_conditions()
      temp <- update_temperature(temp, k, dx, dy, dt)
    }

    temp
  }

  fsub <- r2f(diffuse_heat)
  expect_snapshot(
    {
      diffuse_heat
      cat(fsub)
      cat(make_c_bridge(fsub))
    },
    transform = scrub_environment
  )

  qdiffuse_heat <- quick(diffuse_heat)

  expect_equal(
    qdiffuse_heat(nx, ny, dx, dy, dt, k, steps),
    diffuse_heat(nx, ny, dx, dy, dt, k, steps)
  )
})

# Unit test for mask hoisting

skip_on_cran()

test_that("hoist mask", {
  # no mask to hoist
  fn <- function(x) {
    declare(type(x = double(NA)))
    out <- max(x)
    out
  }

  fsub <- r2f(fn)
  cwrapper <- make_c_bridge(fsub)

  expect_snapshot(
    {
      fn
      cat(fsub)
      cat(cwrapper)
    },
    transform = scrub_environment
  )

  x <- runif(100, -10, 10)
  qfn := quick(fn)
  expect_equal(qfn(x), fn(x))

  # mask hoists
  fn <- function(x) {
    declare(type(x = double(NA)))
    out <- max(x[x >= 0])
    out
  }

  fsub <- r2f(fn)
  cwrapper <- make_c_bridge(fsub)

  expect_snapshot(
    {
      fn
      cat(fsub)
      cat(cwrapper)
    },
    transform = scrub_environment
  )

  x <- runif(100, -10, 10)
  qfn := quick(fn)
  expect_equal(qfn(x), fn(x))
  # bench::mark(qfn(x), fn(x), relative = T)
})

skip_on_cran()

test_that("[ handles scalar, missing, and logical subscripts", {
  m <- matrix(1:6, nrow = 2L, ncol = 3L, byrow = TRUE)

  scalar_drop <- function(m) {
    declare(type(m = integer(NA, NA)))
    m[1L, 1L]
  }
  expect_quick_identical(scalar_drop, list(m))

  scalar_keep <- function(m) {
    declare(type(m = integer(NA, NA)))
    m[1L, 1L, drop = FALSE]
  }
  expect_quick_identical(scalar_keep, list(m))

  whole_col_missing <- function(m) {
    declare(type(m = integer(NA, NA)))
    m[, 2L]
  }
  expect_quick_identical(whole_col_missing, list(m))

  whole_col_logical0 <- function(m) {
    declare(type(m = integer(NA, NA)))
    m[TRUE, 2L]
  }
  expect_quick_identical(whole_col_logical0, list(m))

  logical_rows_sum <- function(m) {
    declare(type(m = integer(NA, NA)))
    sum(m[c(TRUE, FALSE), ])
  }
  expect_quick_identical(logical_rows_sum, list(m))

  pack_filter_sum <- function(m) {
    declare(type(m = integer(NA, NA)))
    sum(m[m > 3L])
  }
  expect_quick_identical(pack_filter_sum, list(m))
})


test_that("reduction intrinsics cover scalar, multi-arg, and mask cases", {
  min_two <- function(x, y) {
    declare(type(x = integer(NA)), type(y = integer(NA)))
    min(x, y)
  }
  fsub <- r2f(min_two)
  expect_match(as.character(fsub), "minval\\(")
  expect_quick_identical(min_two, list(1:4, 2:5))

  min_mix_scalar <- function(x) {
    declare(type(x = integer(NA)))
    min(x, 0L)
  }
  fsub <- r2f(min_mix_scalar)
  expect_match(as.character(fsub), "minval\\(")
  expect_quick_identical(min_mix_scalar, list(c(3L, -1L, 2L)))

  sum_masked <- function(x) {
    declare(type(x = double(NA)))
    sum(x[x > 0])
  }
  fsub <- r2f(sum_masked)
  expect_match(as.character(fsub), "sum\\(x, mask =")
  expect_quick_equal(sum_masked, list(c(-2, 1, 3, -4, 5)))

  prod_two <- function(x, y) {
    declare(type(x = double(NA)), type(y = double(NA)))
    prod(x, y)
  }
  fsub <- r2f(prod_two)
  expect_match(as.character(fsub), "product\\(")
  expect_quick_equal(prod_two, list(c(1, 2, 3), c(4, 5, 6)))
})

test_that("any/all reduction intrinsics cover scalar, multi-arg, and mask cases", {
  any_basic <- function(x) {
    declare(type(x = logical(NA)))
    any(x)
  }
  fsub <- r2f(any_basic)
  expect_match(as.character(fsub), "any\\(")
  expect_quick_identical(any_basic, list(c(FALSE, FALSE)), list(c(FALSE, TRUE)))

  all_basic <- function(x) {
    declare(type(x = logical(NA)))
    all(x)
  }
  fsub <- r2f(all_basic)
  expect_match(as.character(fsub), "all\\(")
  expect_quick_identical(all_basic, list(c(TRUE, TRUE)), list(c(TRUE, FALSE)))

  any_two <- function(a, b) {
    declare(type(a = logical(NA)), type(b = logical(NA)))
    any(a, b)
  }
  fsub <- r2f(any_two)
  expect_match(as.character(fsub), "\\.or\\.")
  expect_quick_identical(
    any_two,
    list(a = c(FALSE, FALSE), b = c(FALSE, FALSE)),
    list(a = c(FALSE, FALSE), b = c(TRUE, FALSE))
  )

  all_two <- function(a, b) {
    declare(type(a = logical(NA)), type(b = logical(NA)))
    all(a, b)
  }
  fsub <- r2f(all_two)
  expect_match(as.character(fsub), "\\.and\\.")
  expect_quick_identical(
    all_two,
    list(a = c(TRUE, TRUE), b = c(TRUE, TRUE)),
    list(a = c(TRUE, TRUE), b = c(FALSE, TRUE))
  )

  # Scalar masked subset: preserve empty-selection semantics.
  any_scalar_masked_empty <- function(x) {
    declare(type(x = logical(1)))
    any(x[c(FALSE)])
  }
  expect_quick_identical(any_scalar_masked_empty, list(TRUE), list(FALSE))

  all_scalar_masked_empty <- function(x) {
    declare(type(x = logical(1)))
    all(x[c(FALSE)])
  }
  expect_quick_identical(all_scalar_masked_empty, list(TRUE), list(FALSE))

  # Scalar masked subset with a scalar mask variable: should compile and
  # preserve empty-selection semantics.
  any_scalar_masked_var <- function(x, m) {
    declare(type(x = logical(1)), type(m = logical(1)))
    any(x[m])
  }
  expect_quick_identical(
    any_scalar_masked_var,
    list(x = TRUE, m = FALSE),
    list(x = FALSE, m = TRUE)
  )

  all_scalar_masked_var <- function(x, m) {
    declare(type(x = logical(1)), type(m = logical(1)))
    all(x[m])
  }
  expect_quick_identical(
    all_scalar_masked_var,
    list(x = FALSE, m = FALSE),
    list(x = FALSE, m = TRUE)
  )

  # Scalar `x` with a longer logical mask diverges from simple empty/non-empty
  # semantics in R because selecting out-of-range positions yields NAs. We don't
  # implement that behavior here, so fail fast instead of silently emitting
  # wrong code.
  any_scalar_masked_long_mask <- function(x) {
    declare(type(x = logical(1)))
    any(x[c(FALSE, TRUE)])
  }
  expect_error(r2f(any_scalar_masked_long_mask), "scalar masked subsets")

  all_scalar_masked_long_mask <- function(x) {
    declare(type(x = logical(1)))
    all(x[c(FALSE, TRUE)])
  }
  expect_error(r2f(all_scalar_masked_long_mask), "scalar masked subsets")

  # 1-element vector expressions like c(FALSE) compile to Fortran array
  # constructors (`[.false.]`) but any()/all() must still return scalars.
  any_array_ctor_len1 <- function() {
    any(c(FALSE))
  }
  expect_quick_identical(any_array_ctor_len1, list())

  all_array_ctor_len1 <- function() {
    all(c(TRUE))
  }
  expect_quick_identical(all_array_ctor_len1, list())

  # Masked reduction over a 1-element array constructor: `[` can hoist the mask
  # while leaving `x` as a rank-1 array constructor (`[.true.]`), but the
  # reduction result must still be scalar.
  any_array_ctor_len1_masked <- function() {
    any(c(TRUE)[c(TRUE)])
  }
  expect_quick_identical(any_array_ctor_len1_masked, list())

  all_array_ctor_len1_masked_empty <- function() {
    all(c(TRUE)[c(FALSE)])
  }
  expect_quick_identical(all_array_ctor_len1_masked_empty, list())

  # Length-1 mask constructors (c(TRUE)/c(FALSE)) are hoisted as rank-1 array
  # constructors but should behave like scalars via recycling in R. The lowering
  # must scalarize them so elementwise `.and.`/`.or.` remain conformable.
  any_mask_ctor_len1 <- function(x) {
    declare(type(x = double(NA)))
    pred <- x > 1
    any(pred[c(TRUE)])
  }
  fsub <- r2f(any_mask_ctor_len1)
  expect_false(grepl("\\.and\\. \\(\\[", as.character(fsub)))
  expect_quick_identical(
    any_mask_ctor_len1,
    list(c(-2, -1)),
    list(c(0.2, 2))
  )

  all_mask_ctor_len1_empty <- function(x) {
    declare(type(x = double(NA)))
    pred <- x > 1
    all(pred[c(FALSE)])
  }
  fsub <- r2f(all_mask_ctor_len1_empty)
  expect_false(grepl("\\.not\\. \\(\\[", as.character(fsub)))
  expect_false(grepl("\\.or\\. \\(\\[", as.character(fsub)))
  expect_quick_identical(
    all_mask_ctor_len1_empty,
    list(c(-2, -1)),
    list(c(0.2, 2))
  )

  # Masked subset: preserve empty-selection semantics without pack() temporaries.
  any_masked <- function(x) {
    declare(type(x = double(NA)))
    pred <- x > 1
    any(pred[x > 0])
  }
  fsub <- r2f(any_masked)
  expect_false(grepl("pack\\(", as.character(fsub)))
  expect_match(as.character(fsub), "\\.and\\.")
  expect_match(as.character(fsub), "any\\(")
  expect_quick_identical(
    any_masked,
    list(c(-2, -1)), # empty selection -> any(logical(0)) == FALSE
    list(c(0.2, 0.3)), # selection all FALSE
    list(c(0.5, 2)) # selection contains TRUE
  )

  all_masked <- function(x) {
    declare(type(x = double(NA)))
    pred <- x > 1
    all(pred[x > 0])
  }
  fsub <- r2f(all_masked)
  expect_false(grepl("pack\\(", as.character(fsub)))
  expect_match(as.character(fsub), "\\.not\\.")
  expect_match(as.character(fsub), "\\.or\\.")
  expect_match(as.character(fsub), "all\\(")
  expect_quick_identical(
    all_masked,
    list(c(-2, -1)), # empty selection -> all(logical(0)) == TRUE
    list(c(0.2, 0.3)), # selection all FALSE -> FALSE
    list(c(0.5, 2)) # selection has a FALSE -> FALSE
  )
})


test_that("1x1 subsetting keeps dims and C bridge builds", {
  fn <- function(m) {
    declare(type(m = integer(NA, NA)))
    m[1L, 1L, drop = FALSE]
  }

  fsub <- r2f(fn)
  expect_no_error(make_c_bridge(fsub))
})

# Unit tests for size constraints

skip_on_cran()

test_that("size constraint", {
  fn <- function(a, b) {
    declare(type(a = double(n)), type(b = double(n + 1)))
    a = sum(b)
    a
  }

  fsub <- new_fortran_subroutine("fn", fn)
  cbridge <- make_c_bridge(fsub, strict = TRUE)

  qfn := quick(fn)

  expect_error(
    qfn(1, 2),
    regexp = "length(b) must equal (length(a) + 1), but are 1 and 2",
    fixed = TRUE
  )
  expect_translation_snapshots(fn, "call_size_constraint")
  expect_equal(qfn(1, c(2, 3)), 5)
})

test_that("size constraint", {
  fn <- function(x) {
    declare(type(x = double(1)))
    x <- -0.1 + x
    x
  }

  qfn := quick(fn)

  expect_error(
    qfn(c(1, 2)),
    regexp = "length(x) must be 1, not 2",
    fixed = TRUE
  )

  expect_identical(qfn(3), fn(3))
  expect_identical(qfn(-3), fn(-3))
  expect_identical(qfn(0), fn(0))
  expect_identical(qfn(-0), fn(-0))
})

test_that("size symbols honor declared argument sizes", {
  fn <- function(n) {
    declare(
      type(n = integer(1)),
      type(out = double(n))
    )
    out <- double(n)
    out
  }

  expect_quick_identical(fn, list(5L), list(10L))
})

# Example: Viterbi algorithm

skip_on_cran()

test_that("viterbi", {
  viterbi <- function(
    observations,
    states,
    initial_probs,
    transition_probs,
    emission_probs
  ) {
    declare({
      type(observations = integer(num_steps))
      type(states = integer(num_states))
      type(initial_probs = double(num_states))
      type(transition_probs = double(num_states, num_states))
      type(emission_probs = double(num_states, num_obs))
    })

    num_states <- length(states)
    num_steps <- length(observations)

    # Trellis matrices for probabilities and backtracking
    trellis <- matrix(0, nrow = length(states), ncol = length(observations))
    backpointer <- matrix(
      0L,
      nrow = length(states),
      ncol = length(observations)
    )

    # print(backpointer)
    # print(trellis)
    # Fortran("write (*,*) backpointer")

    # Initialization step
    trellis[, 1] <- initial_probs * emission_probs[, observations[1]]

    # print(backpointer)
    # print(trellis)

    # Recursion step
    for (step in 2:num_steps) {
      for (current_state in 1:num_states) {
        probabilities <- trellis[, step - 1] * transition_probs[, current_state]
        trellis[current_state, step] <- max(probabilities) *
          emission_probs[current_state, observations[step]]
        backpointer[current_state, step] <- which.max(probabilities)
      }
    }

    # print(backpointer)
    # print(trellis)

    # Backtracking to find the most likely path
    path <- integer(length(observations))
    # print(path)
    path[num_steps] <- which.max(trellis[, num_steps])
    # print(path)
    for (step in seq((num_steps - 1), 1)) {
      # print(backpointer[path[step + 1], step + 1])
      path[step] <- backpointer[path[step + 1], step + 1]
      # print(step)
    }

    # print(path)

    # print(states)
    # Return the most likely path
    out <- states[path]
    out
  }

  fsub <- r2f(viterbi)
  cwrapper <- make_c_bridge(fsub)
  expect_snapshot(
    {
      viterbi
      cat(fsub)
      cat(cwrapper)
    },
    transform = scrub_environment
  )

  set.seed(42)

  # Parameters
  num_steps <- 15L
  num_states <- 4L
  num_obs <- 15L

  observations <- sample(1:num_obs, num_steps, replace = TRUE)
  states <- 1:num_states
  initial_probs <- runif(num_states)
  initial_probs <- initial_probs / sum(initial_probs) # Normalize to sum to 1
  transition_probs <- matrix(runif(num_states * num_states), nrow = num_states)
  transition_probs <- transition_probs / rowSums(transition_probs) # Row-normalize
  emission_probs <- matrix(runif(num_states * num_obs), nrow = num_states)
  emission_probs <- emission_probs / rowSums(emission_probs) # Row-normalize

  qviterbi <- quick(viterbi)
  expect_equal(
    viterbi(
      observations,
      states,
      initial_probs,
      transition_probs,
      emission_probs
    ),
    qviterbi(
      observations,
      states,
      initial_probs,
      transition_probs,
      emission_probs
    )
  )
})


#

test_that("viterbi2", {
  viterbi <- function(
    observations,
    states,
    initial_probs,
    transition_probs,
    emission_probs
  ) {
    declare(
      type(observations = integer(num_steps)),
      type(states = integer(num_states)),
      type(initial_probs = double(num_states)),
      type(transition_probs = double(num_states, num_states)),
      type(emission_probs = double(num_states, num_obs)),
    )

    trellis <- matrix(0, nrow = length(states), ncol = length(observations))
    backpointer <- matrix(
      0L,
      nrow = length(states),
      ncol = length(observations)
    )
    trellis[, 1] <- initial_probs * emission_probs[, observations[1]]

    for (step in 2:length(observations)) {
      for (current_state in 1:length(states)) {
        probabilities <- trellis[, step - 1] * transition_probs[, current_state]
        trellis[current_state, step] <- max(probabilities) *
          emission_probs[current_state, observations[step]]
        backpointer[current_state, step] <- which.max(probabilities)
      }
    }

    path <- integer(length(observations))
    path[length(observations)] <- which.max(trellis[, length(observations)])
    for (step in seq(length(observations) - 1, 1)) {
      path[step] <- backpointer[path[step + 1], step + 1]
    }

    out <- states[path]
    out
  }

  expect_snapshot(
    {
      viterbi
      cat(fsub <- r2f(viterbi))
      cat(make_c_bridge(fsub))
    },
    transform = scrub_environment
  )

  set.seed(1234)

  n <- 2L
  # Parameters
  num_steps <- 16
  num_states <- 8
  num_obs <- 16

  observations <- sample(1:num_obs, num_steps, replace = TRUE)
  states <- 1:num_states
  initial_probs <- runif(num_states)
  initial_probs <- initial_probs / sum(initial_probs) # Normalize to sum to 1
  transition_probs <- matrix(runif(num_states * num_states), nrow = num_states)
  transition_probs <- transition_probs / rowSums(transition_probs) # Row-normalize
  emission_probs <- matrix(runif(num_states * num_obs), nrow = num_states)
  emission_probs <- emission_probs / rowSums(emission_probs) # Row-normalize

  qviterbi <- quick(viterbi)
  expect_equal(
    viterbi(
      observations,
      states,
      initial_probs,
      transition_probs,
      emission_probs
    ),
    qviterbi(
      observations,
      states,
      initial_probs,
      transition_probs,
      emission_probs
    )
  )
  if (FALSE) {
    bench::mark(
      viterbi(
        observations,
        states,
        initial_probs,
        transition_probs,
        emission_probs
      ),
      qviterbi(
        observations,
        states,
        initial_probs,
        transition_probs,
        emission_probs
      )
    ) -> res
    res |> print() |> plot()
    summary(res, relative = TRUE) |> print()
    # viterbi(observations, states, initial_probs, transition_probs, emission_probs)
    # qviterbi(observations, states, initial_probs, transition_probs, emission_probs)
  }
})

scrub_environment <- function(x) {
  gsub("environment: 0x[0-9a-f]+", "environment: 0x0", x)
}

expect_translation_snapshots <- function(
  fn,
  name = deparse(substitute(fn)),
  note = NULL
) {
  fn
  fsub <- r2f(fn)
  cwrapper <- make_c_bridge(fsub)

  if (is.null(note)) {
    expect_snapshot(
      {
        fn
        cat(fsub)
        cat(cwrapper)
      },
      transform = scrub_environment
    )
  } else {
    expect_snapshot(
      {
        cat("# Snapshot note: ", note, "\n", sep = "")
        fn
        cat(fsub)
        cat(cwrapper)
      },
      transform = scrub_environment
    )
  }
}

expect_quick_identical <- function(fn, ...) {
  dll_paths_before <- loaded_dll_paths()
  on.exit(
    cleanup_new_quick_dlls(dll_paths_before),
    add = TRUE
  )
  qfn := quick(fn)
  args_list <- rlang::list2(...)
  args_list <- lapply(args_list, function(x) if (!is.list(x)) list(x) else x)

  for (args in args_list) {
    fn_res <- do.call(fn, args)
    qfn_res <- do.call(qfn, args)
    expect_identical(fn_res, qfn_res)
  }
}


expect_quick_equal <- function(fn, ...) {
  dll_paths_before <- loaded_dll_paths()
  on.exit(
    cleanup_new_quick_dlls(dll_paths_before),
    add = TRUE
  )
  qfn := quick(fn)
  args_list <- rlang::list2(...)
  args_list <- lapply(args_list, function(x) if (!is.list(x)) list(x) else x)

  for (args in args_list) {
    fn_res <- do.call(fn, args)
    qfn_res <- do.call(qfn, args)
    expect_equal(fn_res, qfn_res)
    expect_identical(typeof(fn_res), typeof(qfn_res))
  }
}

assign_in_global <- function(...) {
  x <- rlang::dots_list(..., .named = TRUE)
  list2env(x, envir = globalenv())
}

set_seed_and_call <- function(fun, ...) {
  set.seed(1234)
  fun(...)
}

loaded_dll_paths <- function() {
  unname(vapply(getLoadedDLLs(), function(dll) dll[["path"]], character(1)))
}

cleanup_new_quick_dlls <- function(before) {
  temp_root <- normalizePath(tempdir(), winslash = "/", mustWork = TRUE)
  after <- loaded_dll_paths()
  new_paths <- setdiff(after, before)
  new_paths <- new_paths[
    nzchar(new_paths) &
      startsWith(new_paths, temp_root) &
      grepl("-build-", new_paths, fixed = TRUE)
  ]

  for (path in rev(new_paths)) {
    tryCatch(dyn.unload(path), error = function(...) NULL)
    tryCatch(
      unlink(dirname(path), recursive = TRUE, force = TRUE),
      error = function(...) NULL
    )
  }

  invisible(NULL)
}

skip_if_no_openmp <- local({
  supported <- NULL
  function() {
    skip_on_cran()
    skip_if_not_installed("pkgload")
    if (is.null(supported)) {
      supported <<- tryCatch(
        {
          quick(function(x) {
            declare(type(x = double(1)))
            declare(parallel())
            for (i in seq_len(1L)) {
              x[i] <- x[i] + 1
            }
            x
          })
          TRUE
        },
        quickr_openmp_unavailable = function(e) FALSE,
        quickr_openmp_ignored = function(e) FALSE,
        quickr_openmp_load_failed = function(e) FALSE
      )
    }
    if (!isTRUE(supported)) {
      skip("OpenMP toolchain not available")
    }
  }
})

# r2f-io.R
# Handlers for I/O operations: cat, print

# --- Handlers ---

r2f_handlers[["cat"]] <- function(args, scope, ...) {
  args <- lapply(args, r2f, scope, ...)
  # can do a lot more here still, just a POC for now
  stopifnot(length(args) == 1, typeof(args[[1]]) == "character")
  label <- args[[1]]
  if (!endsWith(label, "\n")) {
    stop("cat(<strings>) must end with '\n'")
  }
  label <- substring(label, 1, nchar(label) - 1)

  Fortran(glue('call labelpr("{label}", {nchar(label)})'))
}

r2f_handlers[["print"]] <- function(args, scope = NULL, ...) {
  # args <- lapply(as.list(e)[-1], r2f, scope)
  # args <- as.list(e)[-1]
  # can do alot more here still, just a POC for now
  stopifnot(length(args) == 1, typeof(args[[1]]) == "symbol")
  name <- args[[1]]
  var <- get0(as.character(name), scope)
  if (!inherits(var, Variable)) {
    stop("could not resolve symbol: ", as.character(name))
  }
  name <- as.character(name)
  if (var@mode == "logical") {
    name <- sprintf("(%s/=0)", name)
  }
  label <- ""
  # browser()
  if (passes_as_scalar(var)) {
    # } "scalar"
    # paste0(c(var@mode, scalar) collapse = "_"),
    printer <- switch(
      var@mode,
      logical = ,
      integer = "intpr1",
      double = "dblepr1",
      {
        print(var)
        stop("Unsupported type in print()")
      }
    )

    Fortran(glue('call {printer}("{label}", {nchar(label)}, {name})'))
  } else {
    printer <- switch(
      var@mode,
      logical = ,
      integer = "intpr",
      double = "dblepr",
      {
        print(var)
        stop("Unsupported type in print()")
      }
    )

    Fortran(glue(
      'call {printer}("{label}", {nchar(label)}, {name}, size({name}))'
    ))
  }
}

# r2f-core-handlers.R
# Handlers for core language constructs: declare, Fortran, (, {

# --- Handlers ---

r2f_handlers[["declare"]] <- function(args, scope, ...) {
  for (a in args) {
    if (is_missing(a)) {
      next
    }
    if (is_parallel_decl_call(a)) {
      if (has_pending_parallel(scope)) {
        stop("parallel()/omp() declaration already pending.", call. = FALSE)
      }
      set_pending_parallel(scope, parse_parallel_decl(a))
    } else if (is_type_call(a)) {
      var <- type_call_to_var(a)
      r_name <- var@r_name %||% var@name
      var@is_arg <- r_name %in% names(formals(scope_closure(scope)))
      if (identical(var@mode, "logical") && isTRUE(var@is_arg)) {
        var@logical_as_int <- TRUE
      }
      scope[[r_name]] <- var
    } else if (is_call(a, quote(`{`))) {
      Recall(as.list(a)[-1], scope)
    }
  }

  Fortran("")
}


r2f_handlers[["Fortran"]] <- function(args, scope = NULL, ...) {
  if (!is_string(args[[1]])) {
    stop("Fortran() must be called with a string")
  }
  Fortran(args[[1]])
  # enable passing through literal fortran code
  # used like:
  #   Fortran("nearest(x, 1)", double(length(x)))
  #   Fortran("nearest(x, 1)", x)
  #   Fortran("x = nearest(x, 1)")
}

r2f_handlers[["stop"]] <- function(args, scope = NULL, ...) {
  if (!length(args)) {
    msg <- "Execution halted"
  } else {
    if (
      length(args) != 1L ||
        !is.character(args[[1L]]) ||
        length(args[[1L]]) != 1L
    ) {
      stop(
        "stop() only supports a single string literal message",
        call. = FALSE
      )
    }
    msg <- args[[1L]]
  }

  mark_scope_uses_errors(scope)
  Fortran(str_flatten_lines(quickr_error_fortran_lines(msg, scope = scope)))
}

r2f_handlers[["("]] <- function(args, scope, ...) {
  x <- r2f(args[[1L]], scope, ...)
  Fortran(glue("({x})"), x@value)
}

r2f_handlers[["$"]] <- function(args, scope, ..., hoist = NULL) {
  stopifnot(length(args) == 2L)
  base <- args[[1L]]
  field <- args[[2L]]
  field_name <- if (is.symbol(field)) {
    as.character(field)
  } else if (is_string(field)) {
    field
  } else {
    stop("`$` expects a symbol or string field name", call. = FALSE)
  }

  if (is.symbol(base) && identical(as.character(base), ".Machine")) {
    if (identical(field_name, "double.eps")) {
      return(Fortran("epsilon(1.0_c_double)", Variable("double")))
    }
    stop("`.Machine$", field_name, "` is not supported", call. = FALSE)
  }

  if (field_name %in% c("d", "u", "v")) {
    if (is.symbol(base)) {
      base_name <- as.character(base)
      base_val <- if (is.null(scope)) NULL else get0(base_name, scope)
      if (inherits(base_val, SvdResult)) {
        out_var <- switch(
          field_name,
          d = base_val@d,
          u = base_val@u,
          v = base_val@v
        )
        if (is.null(out_var)) {
          stop(
            "svd() result does not include `$",
            field_name,
            "`",
            call. = FALSE
          )
        }
        return(Fortran(out_var@name, out_var))
      }
    }
    if (is_call(base, "svd")) {
      return(svd_component_from_call(
        base,
        field_name,
        scope,
        ...,
        hoist = hoist
      ))
    }
  }

  stop(
    "`$` only supports `.Machine$double.eps` and `svd()` results ($d, $u, $v)",
    call. = FALSE
  )
}

r2f_handlers[["{"]] <- function(args, scope, ..., hoist = NULL) {
  # every top level R-expr / fortran statement gets its own hoist target.
  x <- vector("list", length(args))
  for (i in seq_along(args)) {
    stmt <- args[[i]]
    check_pending_parallel_target(stmt, scope)
    x[[i]] <- r2f(stmt, scope, ...)
  }
  check_pending_parallel_consumed(scope)
  code <- str_flatten_lines(x)

  # browser()
  value <- (if (length(args)) last(x)@value) %||% Variable()
  Fortran(code, value)
}

# r2f-control-flow.R
# Handlers for control flow: if, while, repeat, break, next, for

# --- Handlers ---

r2f_handlers[["if"]] <- function(args, scope, ..., hoist = NULL) {
  # cond uses the current hoist context.
  cond <- r2f(args[[1]], scope, ..., hoist = hoist)

  # true and false branchs gets their own hoist target.
  true <- r2f(args[[2]], scope, ..., hoist = NULL)
  check_pending_parallel_consumed(scope)

  if (length(args) == 2) {
    Fortran(glue(
      "
      if ({cond}) then
      {indent(true)}
      end if
      "
    ))
  } else {
    false <- r2f(args[[3]], scope, ..., hoist = NULL)
    check_pending_parallel_consumed(scope)
    Fortran(glue(
      "
      if ({cond}) then
      {indent(true)}
      else
      {indent(false)}
      end if
      "
    ))
  }
}


# TODO: return

# ---- repeat ----
r2f_handlers[["repeat"]] <- function(args, scope, ...) {
  stopifnot(length(args) == 1L)
  body <- r2f(args[[1]], scope, ...)
  check_pending_parallel_consumed(scope)
  Fortran(glue(
    "do
    {indent(body)}
    end do
    "
  ))
}

# ---- break ----
r2f_handlers[["break"]] <- function(args, scope, ...) {
  stopifnot(length(args) == 0L)
  Fortran("exit")
}

# ---- next ----
r2f_handlers[["next"]] <- function(args, scope, ...) {
  stopifnot(length(args) == 0L)
  Fortran("cycle")
}

# ---- while ----
r2f_handlers[["while"]] <- function(args, scope, ...) {
  stopifnot(length(args) == 2L)
  cond <- r2f(args[[1]], scope, ...)
  body <- r2f(args[[2]], scope, ...) ## should we set a new hoist target here?
  check_pending_parallel_consumed(scope)
  Fortran(glue(
    "do while ({cond})
    {indent(body)}
    end do
    "
  ))
}

# ---- for ----
r2f_handlers[["for"]] <- function(args, scope, ...) {
  .[var, iterable, body] <- args
  stopifnot(is.symbol(var))
  var <- as.character(var)
  existing <- get0(var, scope, inherits = FALSE)
  base_fortran <- fortranize_name(var)
  var_name <- if (inherits(existing, Variable) && !is.null(existing@name)) {
    existing@name
  } else if (scope_is_closure(scope) && inherits(get0(var, scope), Variable)) {
    make_shadow_fortran_name(scope, base_fortran)
  } else {
    base_fortran
  }

  iterable_info <- r2f_unwrap_for_iterable(iterable)
  iterable_unwrapped <- iterable_info$iterable
  iterable_reversed <- isTRUE(iterable_info$reversed)
  parallel <- take_pending_parallel(scope)

  # Value iteration: `for (x in foo) { ... }`
  if (is.symbol(iterable_unwrapped)) {
    iterable_name <- as.character(iterable_unwrapped)
    iterable_var <- get0(iterable_name, scope)
    if (!inherits(iterable_var, Variable)) {
      stop(
        "could not resolve iterable in for(): ",
        iterable_name,
        call. = FALSE
      )
    }
    if (is.null(iterable_var@mode)) {
      stop(
        "could not infer iterable type in for(): ",
        iterable_name,
        call. = FALSE
      )
    }

    if (inherits(existing, Variable) && !passes_as_scalar(existing)) {
      stop(
        "for-loop variable must be scalar when iterating values: ",
        var,
        call. = FALSE
      )
    }

    loop_var <- existing %||% Variable(mode = iterable_var@mode)
    loop_var@name <- var_name
    if (identical(loop_var@mode, "logical") && !inherits(existing, Variable)) {
      loop_var@logical_as_int <- logical_as_int(iterable_var)
    }
    loop_var@modified <- TRUE
    scope[[var]] <- loop_var

    iterable_tmp <- scope_unique_var(
      scope,
      mode = iterable_var@mode,
      dims = iterable_var@dims,
      logical_as_int = logical_as_int(iterable_var)
    )
    iterable_tmp_assign <- glue("{iterable_tmp@name} = {iterable_var@name}")

    idx <- scope_unique_var(scope, "integer")
    end <- if (passes_as_scalar(iterable_var)) {
      "1_c_int"
    } else {
      glue("size({iterable_tmp@name})")
    }

    element_designator <- if (passes_as_scalar(iterable_var)) {
      iterable_tmp@name
    } else if (iterable_var@rank == 1L) {
      glue("{iterable_tmp@name}({idx@name})")
    } else {
      subs <- linear_subscripts_from_1d(
        iterable_tmp@name,
        iterable_var@rank,
        Fortran(idx@name, idx)
      )
      glue("{iterable_tmp@name}({str_flatten_commas(subs)})")
    }

    element_expr <- element_designator
    if (identical(loop_var@mode, "logical")) {
      element_is_int <- logical_as_int(iterable_tmp)
      target_is_int <- logical_as_int(loop_var)
      if (target_is_int && !element_is_int) {
        element_expr <- glue("merge(1_c_int, 0_c_int, {element_expr})")
      } else if (!target_is_int && element_is_int) {
        element_expr <- glue("({element_expr} /= 0)")
      }
    }

    if (!is.null(parallel)) {
      previous_openmp <- enter_openmp_scope(scope)
      on.exit(exit_openmp_scope(scope, previous_openmp), add = TRUE)
    }
    body <- r2f(body, scope, ...)
    check_pending_parallel_consumed(scope)
    loop_stmts <- str_flatten_lines(glue("{var_name} = {element_expr}"), body)

    loop_header <- if (iterable_reversed) {
      glue("do {idx@name} = {end}, 1_c_int, -1_c_int")
    } else {
      glue("do {idx@name} = 1_c_int, {end}")
    }

    directives <- openmp_directives(parallel, private = var_name)
    if (!is.null(parallel)) {
      mark_openmp_used(scope)
    }
    error_check_after <- if (!is.null(parallel)) {
      quickr_error_return_if_set(
        scope,
        openmp_depth = scope_openmp_depth(scope) - 1L
      )
    } else {
      ""
    }
    return(Fortran(glue(
      "
      {iterable_tmp_assign}
      {str_flatten_lines(directives$prefix, loop_header)}
      {indent(loop_stmts)}
      end do
      {str_flatten_lines(directives$suffix, error_check_after)}
      "
    )))
  }

  # Index iteration: `for (i in 1:n) { ... }`
  loop_var <- Variable(mode = "integer", name = var_name)
  if (iterable_is_singleton_one(iterable_unwrapped, scope)) {
    loop_var@loop_is_singleton <- TRUE
  }
  scope[[var]] <- loop_var

  iterable <- r2f_for_iterable(iterable, scope, ...)
  if (!is.null(parallel)) {
    previous_openmp <- enter_openmp_scope(scope)
    on.exit(exit_openmp_scope(scope, previous_openmp), add = TRUE)
  }
  body <- r2f(body, scope, ...)
  check_pending_parallel_consumed(scope)

  directives <- openmp_directives(parallel)
  if (!is.null(parallel)) {
    mark_openmp_used(scope)
  }
  error_check_after <- if (!is.null(parallel)) {
    quickr_error_return_if_set(
      scope,
      openmp_depth = scope_openmp_depth(scope) - 1L
    )
  } else {
    ""
  }
  loop_header <- glue("do {var_name} = {iterable}")
  Fortran(glue(
    "{str_flatten_lines(directives$prefix, loop_header)}
    {indent(body)}
    end do
    {str_flatten_lines(directives$suffix, error_check_after)}
    "
  ))
}

#' Compile a Quick Function
#'
#' Compile an R function.
#'
#' @param fun An R function
#' @param name String, name to use for the function. This is optional in
#'   regular usage but required in an R package. As a convenience, arguments
#'   `fun` and `name` can also be supplied as positional arguments to `quick` with
#'   `name` in the first position.
#'
#' @details
#'
#' ## `declare(type())` syntax:
#'
#' The shape and mode of all function arguments must be declared. Local and
#' return variables may optionally also be declared.
#'
#' `declare(type())` also has support for declaring size constraints, or
#' size relationships between variables. Here are some examples of declare
#' calls:
#'
#' ```r
#' declare(type(x = double(NA))) # x is a 1-d double vector of any length
#' declare(type(x = double(10))) # x is a 1-d double vector of length 10
#' declare(type(x = double(1)))  # x is a scalar double
#'
#' declare(type(x = integer(2, 3)))  # x is a 2-d integer matrix with dim (2, 3)
#' declare(type(x = integer(NA, 3))) # x is a 2-d integer matrix with dim (<any>, 3)
#'
#' # x is a 4-d logical matrix with dim (<any>, 24, 24, 3)
#' declare(type(x = logical(NA, 24, 24, 3)))
#'
#' # x and y are 1-d double vectors of any length
#' declare(type(x = double(NA)),
#'         type(y = double(NA)))
#'
#' # x and y are 1-d double vectors of the same length
#' declare(
#'   type(x = double(n)),
#'   type(y = double(n)),
#' )
#'
#' # x and y are 1-d double vectors, where length(y) == length(x) + 2
#' declare(type(x = double(n)),
#'         type(y = double(n+2)))
#' ```
#'
#' You can provide declarations to `declare()` as:
#'
#' - Multiple arguments to a single `declare()` call
#' - Separate `declare()` calls
#' - Multiple arguments within a code block (`{}`) inside `declare()`
#'
#' ```r
#' declare(
#'   type(x = double(n)),
#'   type(y = double(n)),
#' )
#'
#' declare(type(x = double(n)))
#' declare(type(y = double(n)))
#'
#' declare({
#'   type(x = double(n))
#'   type(y = double(n))
#' })
#' ```
#'
#' ## Return values
#'
#' The shape and type of a function return value must be known at compile
#' time. In most situations, this will be automatically inferred by
#' `quick()`. However, if the output is dynamic, then you may need to
#' provide a hint. For example, returning the result of `seq()` will fail
#' because the output shape cannot be inferred.
#'
#' ```r
#' # Will fail to compile:
#' quick_seq <- quick(function(start, end) {
#'   declare({
#'     type(start = integer(1))
#'     type(end = integer(1))
#'   })
#'   out <- seq(start, end)
#'   out
#' })
#' ```
#'
#' However, if the output size can be declared as a dynamic expression using
#' other values known at runtime, compilation will succeed:
#'
#' ```r
#' # Succeeds:
#' quick_seq <- quick(function(start, end) {
#'   declare({
#'     type(start = integer(1))
#'     type(end = integer(1))
#'     type(out = integer(end - start + 1))
#'   })
#'   out <- seq(start, end)
#'   out
#' })
#' quick_seq(1L, 5L)
#' ```
#'
#' ## Fortran compiler
#'
#' quickr compiles via `R CMD SHLIB` and will normally use the same toolchain
#' that R was built/configured with.
#'
#' quickr only uses LLVM flang when it is explicitly requested or, on macOS,
#' when flang is available on `PATH` (and `flang --version` succeeds). If flang
#' is requested but unavailable, compilation errors. If flang compilation
#' fails, quickr retries with the default toolchain; on success it emits a
#' one-time warning and disables automatic flang preference for the rest of the
#' session.
#'
#' In interactive use, you can explicitly control this with:
#'
#' ```r
#' options(quickr.fortran_compiler = "flang")
#' ```
#'
#' To disable the macOS auto-preference, set
#' `options(quickr.fortran_compiler = "gfortran")`.
#'
#' @returns A quicker R function.
#' @export
#' @examples
#' \donttest{
#' add_ab <- quick(function(a, b) {
#'   declare(type(a = double(n)),
#'           type(b = double(n)))
#'   a + b
#' })
#' add_ab(1, 2)
#' add_ab(c(1, 2, 3), c(4, 5, 6))
#' }
quick <- function(fun, name = NULL) {
  if (is.null(name)) {
    name <- if (is.symbol(substitute(fun))) {
      deparse(substitute(fun))
    } else {
      make_unique_name(prefix = "anonymous_quick_function_")
    }
  } else if (is.function(name) && is_string(fun)) {
    .[name, fun] <- list(fun, name)
  }

  if (nzchar(pkgname <- Sys.getenv("DEVTOOLS_LOAD"))) {
    if (!collector$is_active()) {
      if (!requireNamespace("pkgload", quietly = TRUE)) {
        stop("Please install 'pkgload'")
      }
      for (i in seq_along(sys.calls())) {
        if (identical(sys.function(i), pkgload::load_code)) {
          collector$activate(paste0(pkgname, ":quick_funcs"))
          defer(dump_collected(), sys.frame(i), after = TRUE)
          break
        }
      }
    }
  }

  if (collector$is_active()) {
    # we are in a quickr::compile_package() or a devtools::load_all() call,
    # merely collecting functions at this point.
    quick_closure <- create_quick_closure(name, fun)
    collector$add(name = name, closure = fun, quick_closure = quick_closure)
    return(quick_closure)
  }

  pkgname <- parent.pkg()
  if (!is.null(pkgname) && pkgname != "quickr") {
    if (startsWith(name, 'anonymous_quick_function_')) {
      stop(
        'When used in an R package, you must provide a unique `name` to every `quick()` call.\n',
        'For example: `my_fun <- quick("my_fun", function(x) ....)'
      )
    }
    # we are in a package - but outside a quickr::compile_package() call.
    return(create_quick_closure(name, fun))
  }

  # not in a package. Compile and load eagerly.
  attr(fun, "name") <- name
  fun <- compile(r2f(fun))
  attr(fun, "name") <- NULL

  fun
}

compile <- function(fsub, build_dir = tempfile(paste0(fsub@name, "-build-"))) {
  stopifnot(inherits(fsub, FortranSubroutine))

  name <- fsub@name
  c_wrapper <- make_c_bridge(fsub)

  if (dir.exists(build_dir)) {
    unlink(build_dir, recursive = T)
  }
  if (!dir.exists(build_dir)) {
    dir.create(build_dir)
  }
  owd <- setwd(build_dir)
  on.exit(setwd(owd))

  fsub_path <- paste0(name, "_fsub.f90")
  c_wrapper_path <- paste0(name, "_c_wrapper.c")
  dll_path <- paste0(name, .Platform$dynlib.ext)
  writeLines(fsub, fsub_path)
  writeLines(c_wrapper, c_wrapper_path)

  # Link against the same BLAS/LAPACK/Fortran libs as the running R
  # to support generated calls to vendor BLAS (e.g., dgemm, dgesv).
  cfg <- quickr_r_cmd_config_value
  BLAS_LIBS <- strsplit(cfg("BLAS_LIBS"), "[[:space:]]+")[[1]]
  LAPACK_LIBS <- strsplit(cfg("LAPACK_LIBS"), "[[:space:]]+")[[1]]
  FLIBS <- strsplit(cfg("FLIBS"), "[[:space:]]+")[[1]]
  BLAS_LIBS <- BLAS_LIBS[nzchar(BLAS_LIBS)]
  LAPACK_LIBS <- LAPACK_LIBS[nzchar(LAPACK_LIBS)]
  FLIBS <- FLIBS[nzchar(FLIBS)]
  link_flags <- c(LAPACK_LIBS, BLAS_LIBS, FLIBS)

  use_openmp <- scope_uses_openmp_flag(fsub@scope)
  suppressWarnings({
    env <- quickr_fcompiler_env(
      build_dir = build_dir,
      use_openmp = use_openmp,
      link_flags = link_flags
    )
    r_args_base <- c(
      "CMD SHLIB --use-LTO",
      "-o",
      dll_path,
      fsub_path,
      c_wrapper_path
    )
    r_args_libs <- c(r_args_base, link_flags)
    is_windows <- identical(.Platform$OS.type, "windows")
    r_args <- if (length(env) && !is_windows) r_args_base else r_args_libs
    result <- system2(
      R.home("bin/R"),
      r_args,
      stdout = TRUE,
      stderr = TRUE,
      env = env
    )
    if (!is.null(attr(result, "status")) && length(env) && !use_openmp) {
      result2 <- system2(
        R.home("bin/R"),
        r_args_libs,
        stdout = TRUE,
        stderr = TRUE
      )
      if (is.null(attr(result2, "status"))) {
        result <- result2
        quickr_disable_flang_auto()
        quickr_warn_flang_fallback_once()
      } else {
        # Prefer to show the flang attempt first, then the fallback attempt.
        result <- c(
          "--- flang attempt ---",
          result,
          "",
          "--- fallback attempt ---",
          result2
        )
        attr(result, "status") <- attr(result2, "status")
      }
    }
  })

  status <- attr(result, "status")
  if (!is.null(status)) {
    # Adjust the compiler error so RStudio console formatter doesn't mangle
    # the actual error message https://github.com/rstudio/rstudio/issues/16365
    result <- gsub("Error: ", "Compiler Error: ", result, fixed = TRUE)
    quickr_warn_compiler_failure_once(
      paste(
        c(result, "---", sprintf("Compiler exit status: %s", status)),
        collapse = "\n"
      )
    )
    if (use_openmp) {
      openmp_abort(
        paste(
          "OpenMP was requested but compilation with OpenMP flags failed.",
          "quickr will not fall back to a non-OpenMP build.",
          "Resolve the OpenMP toolchain or remove the parallel declarations.",
          sep = "\n"
        ),
        class = "quickr_openmp_ignored"
      )
    }
    stop("Compilation Error", call. = FALSE)
  }

  quickr_windows_add_dll_paths(link_flags)

  # tryCatch(dyn.unload(dll_path), error = identity)
  dll <- tryCatch(
    dyn.load(dll_path),
    error = function(e) {
      if (use_openmp) {
        openmp_abort(
          paste(
            "OpenMP was requested but the compiled shared library failed to load.",
            "This usually means the OpenMP runtime (libgomp/libomp) was not found.",
            "Original error:",
            conditionMessage(e),
            sep = "\n"
          ),
          class = "quickr_openmp_load_failed"
        )
      }
      stop(e)
    }
  )
  c_wrapper_name <- paste0(fsub@name, "_")
  ptr <- getNativeSymbolInfo(c_wrapper_name, dll)$address

  create_quick_closure(fsub@name, fsub@closure, native_symbol = ptr)
}

quickr_windows_add_dll_paths <- function(
  flags,
  os_type = .Platform$OS.type,
  config_value = quickr_r_cmd_config_value,
  which = Sys.which
) {
  if (!identical(os_type, "windows")) {
    return(invisible(FALSE))
  }
  dirs <- flags[grepl("^-L", flags)]
  dirs <- sub("^-L", "", dirs)
  dirs <- dirs[nzchar(dirs)]

  bin_siblings <- file.path(dirs, "..", "bin")

  config_values <- c(
    config_value("BINPREF"),
    config_value("FC"),
    config_value("F77"),
    config_value("CC"),
    config_value("CXX")
  )
  config_paths <- vapply(
    config_values,
    function(value) {
      value <- trimws(value)
      if (!nzchar(value)) {
        return("")
      }
      value <- sub("^\"([^\"]+)\".*", "\\1", value)
      value <- sub("^'([^']+)'.*", "\\1", value)
      strsplit(value, "\\s+")[[1L]][[1L]]
    },
    character(1)
  )
  config_bins <- unique(dirname(config_paths[nzchar(config_paths)]))

  r_bin <- R.home("bin")
  r_bin_x64 <- file.path(r_bin, "x64")
  r_bin_i386 <- file.path(r_bin, "i386")

  rtools_roots <- Sys.getenv(c(
    "RTOOLS45_HOME",
    "RTOOLS44_HOME",
    "RTOOLS43_HOME",
    "RTOOLS42_HOME",
    "RTOOLS40_HOME",
    "RTOOLS_HOME"
  ))
  rtools_roots <- rtools_roots[nzchar(rtools_roots)]
  rtools_bins <- unique(c(
    file.path(rtools_roots, "usr", "bin"),
    file.path(rtools_roots, "mingw64", "bin"),
    file.path(rtools_roots, "ucrt64", "bin"),
    file.path(rtools_roots, "x86_64-w64-mingw32.static.posix", "bin"),
    file.path(rtools_roots, "x86_64-w64-mingw32.static", "bin"),
    file.path(rtools_roots, "x86_64-w64-mingw32", "bin")
  ))

  compilers <- which(c("gfortran", "gcc", "clang", "flang"))
  compilers <- compilers[nzchar(compilers)]
  compiler_bins <- unique(dirname(compilers))

  dirs <- unique(c(
    dirs,
    bin_siblings,
    config_bins,
    r_bin,
    r_bin_x64,
    r_bin_i386,
    rtools_bins,
    compiler_bins
  ))
  dirs <- dirs[nzchar(dirs)]
  dirs <- dirs[dir.exists(dirs)]
  if (!length(dirs)) {
    return(invisible(FALSE))
  }

  path <- Sys.getenv("PATH", unset = "")
  existing <- strsplit(path, ";", fixed = TRUE)[[1]]
  existing <- existing[nzchar(existing)]
  existing_norm <- tolower(normalizePath(
    existing,
    winslash = "\\",
    mustWork = FALSE
  ))
  dirs_norm <- tolower(normalizePath(dirs, winslash = "\\", mustWork = FALSE))
  to_add <- dirs[!dirs_norm %in% existing_norm]
  if (length(to_add)) {
    Sys.setenv(PATH = paste(c(to_add, existing), collapse = ";"))
    return(invisible(TRUE))
  }

  invisible(FALSE)
}


create_quick_closure <- function(
  name,
  closure,
  native_symbol = as.name(paste0(name, "_"))
) {
  body(closure) <- as.call(c(
    quote(.External),
    native_symbol,
    lapply(names(formals(closure)), as.name)
  ))
  closure
}


check_all_var_names_valid <- function(fun) {
  nms <- unique(c(names(formals(fun)), all.vars(body(fun), functions = FALSE)))
  invalid <- endsWith(nms, "_") | startsWith(nms, "_")
  if (any(invalid)) {
    stop(
      "symbols cannot start or end with '_', but found: ",
      glue_collapse(nms[invalid], ", ", last = ", and ")
    )
  }

  fortran_nms <- map_chr(nms, fortranize_name)
  reserved <- fortran_nms %in%
    c(
      # clashes with Fortran subroutine symbols
      "c_int",
      "c_double",
      "c_ptrdiff_t",

      # clashes with C bridge symbols
      "int",
      quickr_error_msg_name(),
      quickr_error_setter_name()

      # ??? (clashes with R symbols?)
      # "double", "integer"
    )
  if (any(reserved)) {
    stop(
      "symbols map to reserved Fortran names: ",
      glue_collapse(
        paste0(nms[reserved], " -> ", fortran_nms[reserved]),
        ", ",
        last = ", and "
      )
    )
  }

  case_clashes <- nms[is_duplicate(tolower(fortran_nms))]
  if (length(case_clashes)) {
    clash_map <- paste0(
      case_clashes,
      " -> ",
      fortran_nms[match(case_clashes, nms)]
    )
    stop(
      "Fortran is case-insensitive; these names conflict when mapped: ",
      glue_collapse(glue::backtick(clash_map), ", ", last = " and ")
    )
  }
}


# ---- utils ----

make_unique_name <- local({
  i <- 0L
  function(prefix = "tmp") {
    paste0(prefix, i <<- i + 1L)
  }
})

is_duplicate <- function(x) {
  out <- duplicated(x) | duplicated(x, fromLast = TRUE)
  names(out) <- names(x)
  out
}

skip_on_cran()

test_that("quick() supports svd(x)$d", {
  fn <- function(x) {
    declare(type(x = double(3, 2)))
    svd(x)$d
  }

  expect_translation_snapshots(fn)

  x <- matrix(c(3, 0, 0, 0, 2, 0), nrow = 3)
  qfn <- quick(fn)
  expect_equal(qfn(x), svd(x)$d, tolerance = 1e-12)
})

test_that("quick() supports assignment of svd() results", {
  fn <- function(x) {
    declare(type(x = double(3, 2)))
    s <- svd(x)
    s$d
  }

  x <- matrix(c(3, 0, 0, 0, 2, 0), nrow = 3)
  qfn <- quick(fn)
  expect_equal(qfn(x), svd(x)$d, tolerance = 1e-12)
})

test_that("quick() errors when svd() is used without $d/$u/$v", {
  expect_error(
    quick(function(x) {
      declare(type(x = double(3, 2)))
      svd(x)
      sum(x)
    }),
    "svd\\(\\) must be assigned to a symbol or accessed via \\$d, \\$u, \\$v",
    fixed = FALSE
  )
})

test_that("quick() returns svd() results as a named list", {
  fn <- function(x) {
    declare(type(x = double(3, 2)))
    s <- svd(x)
    s
  }

  x <- matrix(c(3, 0, 0, 0, 2, 0), nrow = 3)
  out <- quick(fn)(x)
  expect_named(out, c("d", "u", "v"))
  expect_equal(out$d, svd(x)$d)
  recon <- out$u %*% diag(out$d, nrow = length(out$d)) %*% t(out$v)
  expect_equal(recon, x, tolerance = 1e-8)
})

# Unit tests for which.max and related functions

skip_on_cran()

test_that("which.max", {
  fn <- function(a) {
    declare(type(a = double(NA)))

    out <- which.max(a)
    out
  }

  expect_snapshot(r2f(fn))

  a1 <- c(1.0, 3.0, 2.0)
  a2 <- c(-1.0, -2.0, -0.5)
  a3 <- c(1.0, 3.0, 3.0)

  expect_identical(fn(a1), 2L)
  expect_identical(fn(a2), 3L)
  expect_identical(fn(a3), 2L)
  expect_quick_identical(fn, a1, a2, a3)

  # bench::mark(fn(x), {anyNA(x); qfn(x)}) -> r; print(r); plot(r);

  # qfn(-c(1, 2, 3, 2, 1))
  # fn(-c(1, 2, 3, 2, 1))

  # ---------------------

  # now with logical
  fn <- function(a) {
    declare(type(a = logical(NA)))

    out <- which.max(a)
    out
  }

  expect_snapshot(r2f(fn))

  lgl1 <- c(FALSE, TRUE, FALSE)
  lgl2 <- c(FALSE, FALSE, TRUE)
  lgl3 <- c(FALSE, FALSE, FALSE)

  expect_identical(fn(lgl1), 2L)
  expect_identical(fn(lgl2), 3L)
  expect_identical(fn(lgl3), 1L)
  expect_quick_identical(fn, lgl1, lgl2, lgl3)
})

test_that("which.max/which.min on local logical arrays", {
  fn_max <- function(x) {
    declare(type(x = double(NA)))

    lgl <- x > 0
    out <- which.max(lgl)
    out
  }

  x1 <- c(-1, -2, -3)
  x2 <- c(-1, 2, 3)
  x3 <- c(-1, 0, 2)

  expect_identical(fn_max(x1), 1L)
  expect_identical(fn_max(x2), 2L)
  expect_identical(fn_max(x3), 3L)
  expect_quick_identical(fn_max, x1, x2, x3)

  fn_min <- function(x) {
    declare(type(x = double(NA)))

    lgl <- x > 0
    out <- which.min(lgl)
    out
  }

  y1 <- c(1, 2, 3) # all TRUE -> 1 (R semantics)
  y2 <- c(1, -1, 2)
  y3 <- c(1, 2, -1)

  expect_identical(fn_min(y1), 1L)
  expect_identical(fn_min(y2), 2L)
  expect_identical(fn_min(y3), 3L)
  expect_quick_identical(fn_min, y1, y2, y3)
})

#   qfn_find_loc_int <- quick("fn", fn)
#   qfn_find_loc_lgl <- quick("fn", fn)
#
#
#   bench::mark(fn(x), {anyNA(x); qfn(x)}) -> r; print(r); plot(r);
#   bench::mark(fn(x), qfn(x)) -> r; print(r); plot(r);
#   bench::mark(qfn_find_loc_int(x), qfn_find_loc_lgl(x)) -> r; print(r); plot(r);

# })

test_that("which.max/which.min", {
  fn <- function(lgl1, int1, dbl1) {
    declare(type(lgl1 = logical(NA)))
    declare(type(int1 = integer(NA)))
    declare(type(dbl1 = double(NA)))
    out <- c(
      which.min(lgl1),
      which.min(int1),
      which.min(dbl1),
      which.max(lgl1),
      which.max(int1),
      which.max(dbl1),
      which.max(dbl1[dbl1 < 0])
    )
    out
  }

  r2f(fn)
  # qfn := quick(fn)
  #
  # lgl1 = sample(c(TRUE, FALSE), 111, TRUE)
  # int1 = sample.int(222)
  # dbl1 = runif (333, -1, 1)
  #
  # # expect_equal(
  # bench::mark(relative=T,
  #   qfn(lgl1, int1, dbl1),
  #   fn(lgl1, int1, dbl1)
  # )

  expect_translation_snapshots(fn)
  expect_quick_identical(
    fn,
    list(
      lgl1 = sample(c(TRUE, FALSE), 10, TRUE),
      int1 = sample.int(100),
      dbl1 = runif(100, -1, 1)
    )
  )
})

# Unit test for seq translation

skip_on_cran()

test_that("seq", {
  fn <- function(a, b) {
    declare(
      type(a = integer(1)),
      type(b = integer(1))
    )

    out <- sum(seq(a, b))
    out
  }

  expect_quick_identical(fn, list(-1L, 10L), list(10L, -5L))
})

test_that("seq supports literal bounds and steps", {
  seq_range <- function() {
    out <- seq(2L, 5L)
    out
  }

  seq_step <- function() {
    out <- seq(1L, 5L, by = 2L)
    out
  }

  expect_quick_identical(seq_range, list())
  expect_quick_identical(seq_step, list())
})

test_that("seq_along returns linear indices for arrays", {
  seq_along_matrix <- function(x) {
    declare(type(x = double(m, n)))
    out <- seq_along(x)
    out
  }

  expect_quick_identical(
    seq_along_matrix,
    list(matrix(as.double(1:6), nrow = 2))
  )
})

test_that("seq_along requires a value", {
  bad_seq_along <- function() {
    out <- seq_along(NULL)
    out
  }

  expect_error(
    quick(bad_seq_along),
    regexp = "seq_along\\(\\) argument must have a value"
  )
})

test_that("seq rejects length.out and along.with", {
  bad_length_out <- function() {
    out <- seq(1L, 5L, length.out = 3L)
    out
  }

  bad_along_with <- function(x) {
    declare(type(x = double(NA)))
    out <- seq(along.with = x)
    out
  }

  expect_error(
    quick(bad_length_out),
    regexp = "seq\\(length.out=, along.with=\\) not implemented yet"
  )
  expect_error(
    quick(bad_along_with),
    regexp = "seq\\(length.out=, along.with=\\) not implemented yet"
  )
})

test_that("seq() requires explicit from/to (no 1-arg seq semantics)", {
  expect_error(
    quick(function() {
      seq(5L)
    }),
    regexp = "seq\\(\\) requires both `from` and `to`"
  )
})

test_that("seq-like iterables work in subset indexing", {
  seq_index <- function(x, start, end) {
    declare(
      type(x = double(5)),
      type(start = integer(1)),
      type(end = integer(1))
    )
    out <- x[seq(start, end)]
    out
  }

  seq_len_index <- function(x) {
    declare(type(x = double(5)))
    out <- x[seq_len(length(x))]
    out
  }

  seq_along_index <- function(x) {
    declare(type(x = double(3)))
    out <- x[seq_along(x)]
    out
  }

  expect_quick_identical(
    seq_index,
    list(c(1, 2, 3, 4, 5), 2L, 4L),
    list(c(5, 4, 3, 2, 1), 1L, 3L)
  )
  expect_quick_identical(seq_len_index, list(c(1, 2, 3, 4, 5)))
  expect_quick_identical(seq_along_index, list(c(2, 4, 6)))
})

skip_on_cran()

test_that("subscript drop=TRUE drops length-1 ranges like 1:1", {
  fn <- function(x) {
    declare(type(x = double(1, 1, 2, 3, 4)))
    x[1:1, 1:1, 1:2, 1:3, 1:4]
  }

  x <- array(as.double(1:24), dim = c(1, 1, 2, 3, 4))
  expect_quick_identical(fn, list(x))
})

test_that("subset assignment preserves length-1 range rank on the LHS", {
  fn <- function() {
    declare({
      type(out = double(2L, 4L, 3L))
      type(tmp = double(1L, 4L, 3L))
    })

    out <- array(0.0, dim = c(2L, 4L, 3L))
    tmp <- array(1.0, dim = c(1L, 4L, 3L))

    for (i in seq_len(2L)) {
      out[i:i, , ] <- tmp
    }

    out
  }

  fq <- quick(fn)
  expect_identical(fn(), fq())
})

skip_on_cran()

test_that("quick() supports mixed-case compiled names", {
  qSim <- quick(
    name = "qSim",
    function(x) {
      declare(type(x = double(n)))
      x + 1
    }
  )

  expect_identical(qSim(c(1, 2, 3)), c(2, 3, 4))
})

test_that("quick() errors early for invalid compiled names", {
  expect_error(
    quick(
      name = "foo.bar",
      function(x) {
        declare(type(x = double(n)))
        x
      }
    ),
    "Invalid `quick\\(\\)` name",
    fixed = FALSE
  )

  expect_error(
    quick(
      name = "1foo",
      function(x) {
        declare(type(x = double(n)))
        x
      }
    ),
    "Suggested name: 'quick_1foo'",
    fixed = TRUE
  )
})

skip_on_cran()

test_that("sapply lowers scalar-return closures (named + inline)", {
  fn_named <- function(x) {
    declare(type(x = double(NA)))
    out <- double(length(x))
    f <- function(i) x[i] * 2
    out <- sapply(seq_along(out), f)
    out
  }

  fn_inline <- function(x, thresh) {
    declare(type(x = double(NA)), type(thresh = double(1)))
    out <- logical(length(x))
    out <- sapply(seq_along(out), function(i) x[i] > thresh)
    out
  }

  expect_translation_snapshots(
    fn_named,
    note = "Named local closure lowered to an internal subroutine using host association for captures (no capture arguments)."
  )
  expect_translation_snapshots(
    fn_inline,
    note = "Inline closure lowered to an internal subroutine using host association for captures (no capture arguments)."
  )

  set.seed(1)
  x <- runif(25)
  expect_quick_identical(fn_named, list(x))
  expect_quick_identical(fn_inline, list(x, 0.5))
})

test_that("sapply supports integer scalar return", {
  fn <- function(x) {
    declare(type(x = double(NA)))
    out <- integer(length(x))
    out <- sapply(seq_along(out), function(i) i * 2L)
    out
  }

  expect_translation_snapshots(
    fn,
    note = "Integer scalar return produces an integer vector."
  )

  set.seed(1)
  x <- runif(10)
  expect_quick_identical(fn, list(x))
})

test_that("sapply iterates over vector values", {
  fn <- function(x) {
    declare(type(x = double(NA)))
    out <- sapply(x, function(v) v * 2)
    out
  }

  set.seed(1)
  x <- runif(8)
  expect_quick_identical(fn, list(x))
})

test_that("sapply supports simple sequence inputs", {
  fn <- function(n) {
    declare(type(n = integer(1)))
    out <- sapply(1:n, function(v) as.double(v) + 0.5)
    out
  }

  expect_quick_identical(fn, list(5L))
})

test_that("sapply supports singleton range sizes", {
  fn <- function(n) {
    declare(type(n = integer(1)))
    out <- sapply(1:n, function(v) v + 1L)
    out
  }

  expect_quick_identical(fn, list(1L), list(4L))
})

test_that("sapply seq() validates by sign and zero step", {
  bad_sign <- function() {
    out <- sapply(seq(1L, 5L, by = -1L), function(v) v)
    out
  }

  bad_zero <- function() {
    out <- sapply(seq(1L, 2L, by = 0L), function(v) v)
    out
  }

  ok_zero <- function() {
    out <- sapply(seq(2L, 2L, by = 0L), function(v) v + 1L)
    out
  }

  expect_error(quick(bad_sign), regexp = "wrong sign in 'by' argument")
  expect_error(quick(bad_zero), regexp = "invalid '\\(to - from\\)/by'")
  expect_quick_identical(ok_zero, list())
})

test_that("sapply seq_len() validates integer scalar", {
  bad_seq_len <- function() {
    out <- sapply(seq_len(2.5), function(v) v)
    out
  }

  expect_error(
    quick(bad_seq_len),
    regexp = "seq_len\\(\\) expects an integer scalar"
  )
})

test_that("sapply supports vector return -> matrix output", {
  fn <- function(x) {
    declare(type(x = double(m, n)))
    out <- matrix(0, nrow(x), ncol(x))
    out <- sapply(seq_len(ncol(x)), function(j) x[, j] * 2.0)
    out
  }

  expect_translation_snapshots(
    fn,
    note = "Vector return from a closure simplifies to a rank-2 output."
  )

  set.seed(1)
  x <- matrix(runif(12), 3, 4)
  expect_quick_identical(fn, list(x))
})

test_that("sapply supports logical vector return -> logical matrix output", {
  fn <- function(x, thresh) {
    declare(type(x = double(m, n)), type(thresh = double(1)))
    out <- matrix(FALSE, nrow(x), ncol(x))
    out <- sapply(seq_len(ncol(x)), function(j) x[, j] > thresh)
    out
  }

  expect_translation_snapshots(
    fn,
    note = "Logical vector return simplifies to a logical matrix output."
  )

  set.seed(1)
  x <- matrix(runif(12), 3, 4)
  expect_quick_identical(fn, list(x, 0.5))
})

test_that("sapply supports matrix return -> rank-3 output", {
  fn <- function(x, k) {
    declare(type(x = double(m, n)), type(k = integer(1)))
    out <- array(0, dim = c(nrow(x), ncol(x), k))
    out <- sapply(seq_len(k), function(t) x + as.double(t), simplify = "array")
    out
  }

  expect_translation_snapshots(
    fn,
    note = "Matrix return from a closure simplifies to a rank-3 output."
  )

  set.seed(1)
  x <- matrix(runif(12), 3, 4)
  expect_quick_identical(fn, list(x, 3L))
})

test_that("sapply supports slice returns for higher-rank captures", {
  fn_rank3 <- function(x) {
    declare(type(x = double(a, b, k)))
    out <- array(0, dim = dim(x))
    out <- sapply(
      seq_len(dim(x)[3]),
      function(t) x[,, t] + 1.0,
      simplify = "array"
    )
    out
  }

  fn_rank4 <- function(x) {
    declare(type(x = double(a, b, c, k)))
    out <- array(0, dim = dim(x))
    out <- sapply(
      seq_len(dim(x)[4]),
      function(t) x[,,, t] * 2.0,
      simplify = "array"
    )
    out
  }

  expect_translation_snapshots(
    fn_rank3,
    note = "Matrix slice x[,,t] returned into a rank-3 result."
  )
  expect_translation_snapshots(
    fn_rank4,
    note = "Rank-3 slice x[,,,t] returned into a rank-4 result."
  )

  set.seed(1)
  x3 <- array(runif(24), dim = c(2, 3, 4))
  x4 <- array(runif(48), dim = c(2, 3, 2, 4))
  expect_quick_identical(fn_rank3, list(x3))
  expect_quick_identical(fn_rank4, list(x4))
})

test_that("sapply supports rank-3 return -> rank-4 output", {
  fn <- function(x, k) {
    declare(type(x = double(a, b, c)), type(k = integer(1)))
    out <- array(0, dim = c(dim(x), k))
    out <- sapply(seq_len(k), function(t) x + as.double(t), simplify = "array")
    out
  }

  expect_translation_snapshots(
    fn,
    note = "Rank-3 return from a closure simplifies to a rank-4 output."
  )

  set.seed(1)
  x <- array(runif(24), dim = c(2, 3, 4))
  expect_quick_identical(fn, list(x, 2L))
})

test_that("closures can capture and index rank>1 arrays with x[i] linear indexing", {
  fn <- function(x) {
    declare(type(x = double(3, 4)))
    out <- double(length(x))
    out <- sapply(seq_along(out), function(i) x[i] + 1.0)
    out
  }

  expect_translation_snapshots(
    fn,
    note = "Linear indexing x[i] on a rank-2 capture uses computed subscripts."
  )

  set.seed(1)
  x <- matrix(runif(12), 3, 4)
  expect_quick_identical(fn, list(x))
})

test_that("sapply can write into an existing argument variable", {
  fn <- function(out, x) {
    declare(type(out = double(n)), type(x = double(n)))
    out <- sapply(seq_along(out), function(i) x[i] + 1.0)
    out
  }

  set.seed(1)
  x <- runif(10)
  out <- rep(0, length(x))
  expect_quick_identical(fn, list(out, x))
})

test_that("sapply preserves R semantics when output is also captured", {
  fn <- function(x) {
    declare(type(x = double(m, n)))
    out <- matrix(0, nrow(x), ncol(x))
    out <- x
    out <- sapply(seq_len(ncol(out)), function(j) out[, j] + 1.0)
    out
  }

  expect_translation_snapshots(
    fn,
    note = "When the output is captured by the closure, quickr uses a hidden temp to avoid in-place updates during the loop."
  )

  set.seed(1)
  x <- matrix(runif(12), 3, 4)
  expect_quick_identical(fn, list(x))
})

test_that("closures may assign to captured variables (shadowing the host)", {
  fn <- function(x) {
    declare(type(x = double(NA)))
    out <- double(length(x))
    f <- function(i) {
      x[i] <- x[i] + 1.0
      x[i]
    }
    out <- sapply(seq_along(out), f)
    out
  }

  x1 <- c(1, 2, 3)
  x2 <- c(-1.5, 0.25, 2.0)

  expect_identical(fn(x1), x1 + 1.0)
  expect_identical(fn(x2), x2 + 1.0)
  expect_quick_identical(fn, x1, x2, as.double(seq(-10, 10)))

  qfn <- quick(fn)
  for (x0 in list(x1, x2)) {
    x <- x0
    out <- qfn(x)
    expect_identical(out, x0 + 1.0)
    expect_identical(out, fn(x0))
    expect_identical(x, x0)
  }
})

test_that("shadowed captures are reinitialized for each sapply() iteration", {
  fn <- function(x) {
    declare(type(x = double(NA)))
    out <- double(length(x))
    out <- sapply(seq_along(out), function(i) {
      x <- x + as.double(i)
      sum(x)
    })
    out
  }

  set.seed(1)
  x <- runif(6)
  expect_quick_identical(fn, list(x))
})

test_that("local closures can be called directly with multiple arguments", {
  fn <- function(nx, ny, k, dt, steps) {
    declare(
      type(nx = integer(1)),
      type(ny = integer(1)),
      type(k = double(1)),
      type(dt = double(1)),
      type(steps = integer(1))
    )

    temp <- matrix(0, nx, ny)
    temp[nx / 2, ny / 2] <- 100

    apply_boundary_conditions <- function(temp) {
      temp[1, ] <- 0
      temp[nx, ] <- 0
      temp[, 1] <- 0
      temp[, ny] <- 0
      temp
    }

    update_temperature <- function(temp, k, dt) {
      temp_new <- temp
      for (i in 2:(nx - 1)) {
        for (j in 2:(ny - 1)) {
          temp_new[i, j] <- temp[i, j] + k * dt
        }
      }
      temp_new
    }

    for (step in seq_len(steps)) {
      temp <- apply_boundary_conditions(temp)
      temp <- update_temperature(temp, k, dt)
    }

    temp
  }

  set.seed(1)
  expect_quick_identical(fn, list(10L, 8L, 0.1, 0.01, 3L))
})

test_that("sapply errors for insufficient arguments", {
  expect_error(
    quick(function(x) {
      declare(type(x = double(NA)))
      out <- sapply(seq_along(x))
      out
    }),
    "sapply\\(\\) requires at least 2 arguments"
  )
})

test_that("sapply errors for unsupported simplify value", {
  expect_error(
    quick(function(x) {
      declare(type(x = double(NA)))
      out <- sapply(seq_along(x), function(i) x[i], simplify = FALSE)
      out
    }),
    'Only `sapply.*simplify = "array".*is supported'
  )
})

test_that("sapply errors for unsupported FUN", {
  expect_error(
    quick(function(x) {
      declare(type(x = double(NA)))
      out <- sapply(seq_along(x), "mean")
      out
    }),
    "unsupported FUN in sapply"
  )
})

test_that("sapply errors when FUN has wrong number of arguments", {
  expect_error(
    quick(function(x) {
      declare(type(x = double(NA)))
      f <- function(i, j) x[i] + x[j]
      out <- sapply(seq_along(x), f)
      out
    }),
    "sapply\\(\\) FUN must have exactly one named argument"
  )
})

test_that("sapply errors when output is scalar", {
  expect_error(
    quick(function(x) {
      declare(type(x = double(NA)))
      out <- 0
      out <- sapply(seq_along(x), function(i) x[i])
      out
    }),
    "sapply\\(\\) output must be an array"
  )
})

test_that("sapply errors for rank>2 output without simplify='array'", {
  expect_error(
    quick(function(x) {
      declare(type(x = double(a, b, c)))
      out <- array(0, dim = c(dim(x), 2L))
      out <- sapply(1:2, function(t) x)
      out
    }),
    'sapply\\(\\) that returns arrays requires.*simplify = "array"'
  )
})

test_that("sapply errors when named FUN is not a local closure", {
  expect_error(
    quick(function(x) {
      declare(type(x = double(NA)))
      out <- sapply(seq_along(x), sum)
      out
    }),
    "unsupported FUN in sapply\\(\\)"
  )
})

# Public API tests for drop()

skip_on_cran()

test_that("drop() translation snapshots", {
  drop_row <- function(A) {
    declare(type(A = double(1L, 3L)))
    drop(A)
  }
  drop_col <- function(A) {
    declare(type(A = double(3L, 1L)))
    drop(A)
  }
  drop_row_unknown <- function(A) {
    declare(type(A = double(1L, NA)))
    drop(A)
  }
  drop_col_unknown <- function(A) {
    declare(type(A = double(NA, 1L)))
    drop(A)
  }
  drop_row_n <- function(A, n) {
    declare(type(n = integer(1)))
    declare(type(A = double(1L, n)))
    drop(A)
  }
  drop_col_n <- function(A, n) {
    declare(type(n = integer(1)))
    declare(type(A = double(n, 1L)))
    drop(A)
  }

  expect_translation_snapshots(drop_row)
  expect_translation_snapshots(drop_col)
  expect_translation_snapshots(drop_row_unknown)
  expect_translation_snapshots(drop_col_unknown)
  expect_translation_snapshots(drop_row_n)
  expect_translation_snapshots(drop_col_n)
})

test_that("drop() matches base R for singleton matrices", {
  drop_row <- function(A) {
    declare(type(A = double(1L, 3L)))
    drop(A)
  }
  drop_col <- function(A) {
    declare(type(A = double(3L, 1L)))
    drop(A)
  }
  drop_row_unknown <- function(A) {
    declare(type(A = double(1L, NA)))
    drop(A)
  }
  drop_col_unknown <- function(A) {
    declare(type(A = double(NA, 1L)))
    drop(A)
  }
  drop_row_n <- function(A, n) {
    declare(type(n = integer(1)))
    declare(type(A = double(1L, n)))
    drop(A)
  }
  drop_col_n <- function(A, n) {
    declare(type(n = integer(1)))
    declare(type(A = double(n, 1L)))
    drop(A)
  }
  drop_none <- function(A) {
    declare(type(A = double(3L, 2L)))
    drop(A)
  }

  expect_quick_identical(drop_row, list(matrix(runif(3), nrow = 1L)))
  expect_quick_identical(drop_col, list(matrix(runif(3), ncol = 1L)))
  expect_quick_identical(drop_row_unknown, list(matrix(runif(5), nrow = 1L)))
  expect_quick_identical(drop_col_unknown, list(matrix(runif(7), ncol = 1L)))
  expect_quick_identical(drop_row_n, list(matrix(runif(4), nrow = 1L), 4L))
  expect_quick_identical(drop_col_n, list(matrix(runif(6), ncol = 1L), 6L))
  expect_quick_identical(drop_none, list(matrix(runif(6), nrow = 3L)))
})

test_that("drop() errors for rank > 2 inputs", {
  fn <- function(A) {
    declare(type(A = double(2, 2, 2)))
    drop(A)
  }

  expect_error(
    quick(fn),
    "drop() only supports rank 0-2 inputs",
    fixed = TRUE
  )
})

# Unit tests for cbind() and rbind()

skip_on_cran()

expect_bind_equal <- function(fn, ...) {
  qfn := quick(fn)
  args_list <- rlang::list2(...)
  args_list <- lapply(args_list, function(x) if (!is.list(x)) list(x) else x)

  for (args in args_list) {
    fn_res <- do.call(fn, args)
    qfn_res <- do.call(qfn, args)
    expect_identical(dim(fn_res), dim(qfn_res))
    expect_equal(unname(fn_res), unname(qfn_res))
    expect_identical(typeof(fn_res), typeof(qfn_res))
  }
}

test_that("cbind binds vectors and matrices with scalar recycling", {
  cbind_vec <- function(x, y, s) {
    declare(type(x = double(n)), type(y = double(n)), type(s = double(1)))
    cbind(x, y, s)
  }

  set.seed(1)
  x <- runif(4)
  y <- runif(4)
  s <- 2.5
  expect_bind_equal(cbind_vec, list(x, y, s))

  cbind_mat <- function(A, v) {
    declare(type(A = double(n, m)), type(v = double(n)))
    cbind(A, v)
  }

  A <- matrix(runif(6), nrow = 3)
  v <- runif(3)
  expect_bind_equal(cbind_mat, list(A, v))

  cbind_int <- function(x, y) {
    declare(type(x = integer(n)), type(y = integer(n)))
    cbind(x, y)
  }

  x_int <- 1:3
  y_int <- 4:6
  expect_bind_equal(cbind_int, list(x_int, y_int))
})

test_that("rbind binds vectors and matrices with scalar recycling", {
  rbind_vec <- function(x, y, s) {
    declare(type(x = double(n)), type(y = double(n)), type(s = double(1)))
    rbind(x, y, s)
  }

  set.seed(2)
  x <- runif(5)
  y <- runif(5)
  s <- -1.25
  expect_bind_equal(rbind_vec, list(x, y, s))

  rbind_mat <- function(A, v) {
    declare(type(A = double(n, m)), type(v = double(m)))
    rbind(A, v)
  }

  A <- matrix(runif(6), nrow = 2)
  v <- runif(3)
  expect_bind_equal(rbind_mat, list(A, v))

  rbind_int <- function(x, y) {
    declare(type(x = integer(n)), type(y = integer(n)))
    rbind(x, y)
  }

  x_int <- 1:4
  y_int <- 5:8
  expect_bind_equal(rbind_int, list(x_int, y_int))
})

test_that("cbind/rbind enforce common lengths", {
  bad_cbind <- function(x, y) {
    declare(type(x = double(2)), type(y = double(3)))
    cbind(x, y)
  }

  expect_error(
    quick(bad_cbind),
    "common row count",
    fixed = TRUE
  )

  bad_rbind <- function(A, B) {
    declare(type(A = double(2, 3)), type(B = double(2, 4)))
    rbind(A, B)
  }

  expect_error(
    quick(bad_rbind),
    "common column count",
    fixed = TRUE
  )
})

test_that("cbind/rbind reject rank > 2 inputs with clear errors", {
  capture_bind_error <- function(expr) {
    tryCatch(expr, error = function(e) cat(conditionMessage(e), "\n"))
  }

  bad_cbind <- function(x) {
    declare(type(x = double(2, 2, 2)))
    cbind(x)
  }

  bad_rbind <- function(x) {
    declare(type(x = double(2, 2, 2)))
    rbind(x)
  }

  expect_snapshot({
    capture_bind_error(r2f(bad_cbind))
    capture_bind_error(r2f(bad_rbind))
  })
})

test_that("cbind/rbind handle mixed rank-2, rank-1, and rank-0 inputs", {
  cbind_mixed <- function(A, v1, s1, B, s2, v2, C, v3, s3) {
    declare(
      type(A = double(n, 2)),
      type(B = double(n, 1)),
      type(C = double(n, 3)),
      type(v1 = double(n)),
      type(v2 = double(n)),
      type(v3 = double(n)),
      type(s1 = double(1)),
      type(s2 = double(1)),
      type(s3 = double(1))
    )
    cbind(A, v1, s1, B, s2, v2, C, v3, s3)
  }

  rbind_mixed <- function(A, v1, s1, B, s2, v2, C, v3, s3) {
    declare(
      type(A = double(2, m)),
      type(B = double(1, m)),
      type(C = double(3, m)),
      type(v1 = double(m)),
      type(v2 = double(m)),
      type(v3 = double(m)),
      type(s1 = double(1)),
      type(s2 = double(1)),
      type(s3 = double(1))
    )
    rbind(A, v1, s1, B, s2, v2, C, v3, s3)
  }

  set.seed(42)
  n <- 2L
  A <- matrix(runif(n * 2L), nrow = n)
  B <- matrix(runif(n * 1L), nrow = n)
  C <- matrix(runif(n * 3L), nrow = n)
  v1 <- runif(n)
  v2 <- runif(n)
  v3 <- runif(n)
  s1 <- -0.5
  s2 <- 1.25
  s3 <- 0.0

  expect_bind_equal(
    cbind_mixed,
    list(A, v1, s1, B, s2, v2, C, v3, s3)
  )

  m <- 3L
  A2 <- matrix(runif(2L * m), nrow = 2L)
  B2 <- matrix(runif(1L * m), nrow = 1L)
  C2 <- matrix(runif(3L * m), nrow = 3L)
  w1 <- runif(m)
  w2 <- runif(m)
  w3 <- runif(m)
  t1 <- 2.0
  t2 <- -1.0
  t3 <- 0.5

  expect_bind_equal(
    rbind_mixed,
    list(A2, w1, t1, B2, t2, w2, C2, w3, t3)
  )
})

test_that("cbind/rbind coerce logical inputs when mixed with integer", {
  cbind_int_lgl <- function(i, l) {
    declare(type(i = integer(n)), type(l = logical(n)))
    cbind(i, l)
  }

  rbind_int_lgl <- function(i, l) {
    declare(type(i = integer(n)), type(l = logical(n)))
    rbind(i, l)
  }

  i <- 1:4
  l <- c(TRUE, FALSE, TRUE, FALSE)

  expect_bind_equal(cbind_int_lgl, list(i, l))
  expect_bind_equal(rbind_int_lgl, list(i, l))
})

test_that("cbind/rbind coerce integers to double when mixed", {
  cbind_dbl_int <- function(d, i) {
    declare(type(d = double(n)), type(i = integer(n)))
    cbind(d, i)
  }

  rbind_dbl_int <- function(d, i) {
    declare(type(d = double(n)), type(i = integer(n)))
    rbind(d, i)
  }

  d <- c(1.25, -0.5, 3.0)
  i <- c(1L, 2L, 3L)

  expect_bind_equal(cbind_dbl_int, list(d, i))
  expect_bind_equal(rbind_dbl_int, list(d, i))
})

test_that("cbind supports complex inputs", {
  cbind_complex <- function(z1, z2) {
    declare(type(z1 = complex(n)), type(z2 = complex(n)))
    cbind(z1, z2)
  }

  set.seed(10)
  x <- runif(4)
  y <- runif(4)
  z1 <- complex(real = x, imaginary = y)
  z2 <- complex(real = y, imaginary = x)

  expect_bind_equal(cbind_complex, list(z1, z2))
})

test_that("cbind rejects mixing complex with non-complex", {
  bad <- function(z, x) {
    declare(type(z = complex(n)), type(x = double(n)))
    cbind(z, x)
  }

  expect_error(quick(bad), "mixing complex", fixed = TRUE)
})

test_that("cbind requires dimensions to be equal at compile time", {
  fn <- function(x, y, n, m) {
    declare(
      type(n = integer(1)),
      type(m = integer(1)),
      type(x = double(n)),
      type(y = double(m))
    )
    cbind(x, y)
  }

  expect_error(
    quick(fn),
    "common row count",
    fixed = TRUE
  )
})

test_that("cbind supports symbolic dimension expressions in output shape", {
  fn <- function(x, A, n, m) {
    declare(
      type(n = integer(1)),
      type(m = integer(1)),
      type(x = double(n)),
      type(A = double(n, m))
    )
    cbind(x, A)
  }

  set.seed(99)
  n <- 3L
  m <- 2L
  x <- runif(n)
  A <- matrix(runif(n * m), nrow = n)
  expect_bind_equal(fn, list(x, A, n, m))
})

test_that("cbind requires inferred dimensions to match", {
  unknown_rows <- function(A, B) {
    declare(type(A = double(NA, 2)), type(B = double(NA, 1)))
    cbind(A, B)
  }

  q_unknown_rows <- NULL
  expect_error(
    q_unknown_rows <- quick(unknown_rows),
    "common row count",
    fixed = TRUE
  )

  expect_null(q_unknown_rows)
})

skip_on_cran()

test_that("solve matches R for vector, matrix, and inverse", {
  solve_vec <- function(A, b) {
    declare(
      type(A = double(n, n)),
      type(b = double(n))
    )
    solve(A, b)
  }

  solve_mat <- function(A, B) {
    declare(
      type(A = double(n, n)),
      type(B = double(n, k))
    )
    solve(A, B)
  }

  solve_inv <- function(A) {
    declare(type(A = double(n, n)))
    solve(A)
  }

  set.seed(1)
  n <- 5
  k <- 3
  base <- matrix(rnorm(n * n), n, n)
  A <- crossprod(base) + diag(n)
  b <- rnorm(n)
  B <- matrix(rnorm(n * k), n, k)

  expect_quick_equal(solve_vec, list(A = A, b = b))
  expect_quick_equal(solve_mat, list(A = A, B = B))
  expect_quick_equal(solve_inv, list(A = A))
})

test_that("solve handles column RHS matrices and 1x1 systems", {
  solve_col <- function(A, B) {
    declare(
      type(A = double(n, n)),
      type(B = double(n, 1L))
    )
    solve(A, B)
  }

  solve_scalar <- function(A, b) {
    declare(
      type(A = double(1L, 1L)),
      type(b = double(1L))
    )
    solve(A, b)
  }

  set.seed(10)
  n <- 4
  base <- matrix(rnorm(n * n), n, n)
  A <- crossprod(base) + diag(n)
  B <- matrix(rnorm(n), n, 1L)

  expect_quick_equal(solve_col, list(A = A, B = B))
  expect_quick_equal(solve_scalar, list(A = matrix(2.5, 1L, 1L), b = 1.25))
})

test_that("solve supports least-squares for rectangular systems", {
  solve_ls_vec <- function(X, y) {
    declare(
      type(X = double(n, k)),
      type(y = double(n))
    )
    solve(X, y)
  }

  solve_ls_mat <- function(X, Y) {
    declare(
      type(X = double(n, k)),
      type(Y = double(n, p))
    )
    solve(X, Y)
  }

  set.seed(123)
  n <- 20
  k <- 5
  p <- 3
  X <- matrix(rnorm(n * k), n, k)
  y <- rnorm(n)
  Y <- matrix(rnorm(n * p), n, p)

  q_solve_ls_vec <- expect_warning(quick(solve_ls_vec), NA)
  q_solve_ls_mat <- expect_warning(quick(solve_ls_mat), NA)

  expect_equal(q_solve_ls_vec(X, y), qr.solve(X, y))
  expect_equal(q_solve_ls_mat(X, Y), qr.solve(X, Y))
})

test_that("solve supports least-squares for single-column systems", {
  solve_ls_col <- function(X, y) {
    declare(
      type(X = double(n, 1L)),
      type(y = double(n))
    )
    solve(X, y)
  }

  set.seed(125)
  n <- 20
  X <- matrix(rnorm(n), n, 1L)
  y <- rnorm(n)

  q_solve_ls_col <- expect_warning(quick(solve_ls_col), NA)
  expect_equal(q_solve_ls_col(X, y), qr.solve(X, y))
})

test_that("solve compiles 1-row least-squares systems", {
  solve_one_row <- function(X, y) {
    declare(
      type(X = double(1L, 2L)),
      type(y = double(1L))
    )
    solve(X, y)
  }

  expect_no_error(r2f(solve_one_row))
})

test_that("qr.solve matches R for vectors and matrices", {
  qr_solve_ls_vec <- function(X, y) {
    declare(
      type(X = double(n, k)),
      type(y = double(n))
    )
    qr.solve(X, y)
  }

  qr_solve_ls_mat <- function(X, Y) {
    declare(
      type(X = double(n, k)),
      type(Y = double(n, p))
    )
    qr.solve(X, Y)
  }

  qr_solve_square <- function(A, B) {
    declare(
      type(A = double(n, n)),
      type(B = double(n, k))
    )
    qr.solve(A, B)
  }

  set.seed(124)
  n <- 20
  k <- 5
  p <- 3
  X <- matrix(rnorm(n * k), n, k)
  y <- rnorm(n)
  Y <- matrix(rnorm(n * p), n, p)

  base <- matrix(rnorm(n * n), n, n)
  A <- crossprod(base) + diag(n)
  B <- matrix(rnorm(n * k), n, k)

  q_qr_solve_ls_vec <- expect_warning(quick(qr_solve_ls_vec), NA)
  q_qr_solve_ls_mat <- expect_warning(quick(qr_solve_ls_mat), NA)
  q_qr_solve_square <- expect_warning(quick(qr_solve_square), NA)

  expect_equal(q_qr_solve_ls_vec(X, y), qr.solve(X, y))
  expect_equal(q_qr_solve_ls_mat(X, Y), qr.solve(X, Y))
  expect_equal(q_qr_solve_square(A, B), qr.solve(A, B))
})

test_that("qr.solve uses QR with pivoting for known square systems", {
  qr_solve_square <- function(A, b) {
    declare(
      type(A = double(n, n)),
      type(b = double(n))
    )
    qr.solve(A, b)
  }

  square_fortran <- paste(
    capture.output(cat(r2f(qr_solve_square))),
    collapse = "\n"
  )
  has_call <- function(code, routine) {
    any(grepl(paste0("call ", routine, "("), tolower(code), fixed = TRUE))
  }

  # Search emitted Fortran to ensure qr.solve uses QR w/ pivoting, not LU
  # (dgesv), so rank-deficient square systems can be handled consistently.
  expect_true(
    has_call(square_fortran, "dqrdc2") || has_call(square_fortran, "dgelsy")
  )
  expect_false(has_call(square_fortran, "dgesv"))
})

test_that("solve uses dgesv for known square and dgels for rectangular systems", {
  solve_square <- function(A, b) {
    declare(
      type(A = double(n, n)),
      type(b = double(n))
    )
    solve(A, b)
  }

  solve_square_fixed <- function(A, b) {
    declare(
      type(A = double(3, 3)),
      type(b = double(3))
    )
    solve(A, b)
  }

  solve_rect <- function(A, b) {
    declare(type(A = double(3, 2)), type(b = double(3)))
    solve(A, b)
  }

  solve_rect_named <- function(A, b) {
    declare(
      type(A = double(n, k)),
      type(b = double(n))
    )
    solve(A, b)
  }

  square_named_fortran <- paste(
    capture.output(cat(r2f(solve_square))),
    collapse = "\n"
  )
  square_fixed_fortran <- paste(
    capture.output(cat(r2f(solve_square_fixed))),
    collapse = "\n"
  )
  rect_fixed_fortran <- paste(
    capture.output(cat(r2f(solve_rect))),
    collapse = "\n"
  )
  rect_named_fortran <- paste(
    capture.output(cat(r2f(solve_rect_named))),
    collapse = "\n"
  )

  has_call <- function(code, routine) {
    any(grepl(paste0("call ", routine, "("), tolower(code), fixed = TRUE))
  }

  # Search emitted Fortran to ensure solve() chooses LU (dgesv) for proven-square
  # systems and least-squares (dgels) for rectangular systems.
  expect_true(has_call(square_named_fortran, "dgesv"))
  expect_false(has_call(square_named_fortran, "dgels"))

  expect_true(has_call(square_fixed_fortran, "dgesv"))
  expect_false(has_call(square_fixed_fortran, "dgels"))

  expect_true(has_call(rect_fixed_fortran, "dgels"))
  expect_false(has_call(rect_fixed_fortran, "dgesv"))

  expect_true(has_call(rect_named_fortran, "dgels"))
  expect_false(has_call(rect_named_fortran, "dgesv"))
})

test_that("chol and chol2inv match R", {
  chol_fn <- function(A) {
    declare(type(A = double(n, n)))
    chol(A)
  }

  chol2inv_fn <- function(A) {
    declare(type(A = double(n, n)))
    U <- chol(A)
    chol2inv(U)
  }

  set.seed(2)
  n <- 4
  base <- matrix(rnorm(n * n), n, n)
  A <- crossprod(base) + diag(n)

  expect_quick_equal(chol_fn, list(A = A))
  expect_quick_equal(chol2inv_fn, list(A = A))
})

test_that("chol and chol2inv handle 1x1 matrices", {
  chol_scalar <- function(A) {
    declare(type(A = double(1L, 1L)))
    chol(A)
  }

  chol2inv_scalar <- function(A) {
    declare(type(A = double(1L, 1L)))
    U <- chol(A)
    chol2inv(U)
  }

  expect_quick_equal(chol_scalar, list(A = matrix(3.2, 1L, 1L)))
  expect_quick_equal(chol2inv_scalar, list(A = matrix(3.2, 1L, 1L)))
})

test_that("diag matches R for vectors, matrices, and sizes", {
  diag_vec <- function(x) {
    declare(type(x = double(n)))
    diag(x)
  }

  diag_mat <- function(A) {
    declare(type(A = double(m, n)))
    diag(A)
  }

  diag_size <- function() {
    diag(3L)
  }

  diag_value <- function(x) {
    declare(type(x = double(1)))
    diag(x, nrow = 2, ncol = 3)
  }

  diag_named_order <- function(x) {
    declare(type(x = double(n)))
    diag(nrow = 3L, x = x)
  }

  set.seed(3)
  x <- rnorm(4)
  A <- matrix(rnorm(2 * 3), nrow = 2)

  expect_quick_equal(diag_vec, list(x = x))
  expect_quick_equal(diag_mat, list(A = A))
  expect_quick_equal(diag_size, list())
  expect_quick_equal(diag_value, list(x = 2.5))
  expect_quick_equal(diag_named_order, list(x = c(1, 2)))
})

test_that("diag handles missing x with nrow/ncol and 1x1 matrices", {
  diag_nrow <- function(n) {
    declare(type(n = integer(1)))
    diag(nrow = n)
  }

  diag_ncol <- function(n) {
    declare(type(n = integer(1)))
    diag(ncol = n)
  }

  diag_rowvec <- function(A) {
    declare(type(A = double(1L, n)))
    diag(A)
  }

  expect_quick_equal(diag_nrow, list(n = 3L))
  expect_error(diag_ncol(2L), "nrow")
  expect_error(quick(diag_ncol)(2L), "nrow")
  expect_quick_equal(
    diag_rowvec,
    list(A = matrix(runif(3), nrow = 1L))
  )
})

test_that("Test bad path in lapack functions", {
  solve_bad_rank <- function(a, b) {
    declare(type(a = double(n)), type(b = double(n)))
    solve(a, b)
  }

  solve_non_square <- function(a, b) {
    declare(type(a = double(2, 3)), type(b = double(2)))
    solve(a, b)
  }

  solve_bad_rhs <- function(a, b) {
    declare(type(a = double(2, 2)), type(b = double(2, 2, 2)))
    solve(a, b)
  }

  chol_bad_rank <- function(a) {
    declare(type(a = double(2, 2, 2)))
    chol(a)
  }

  chol_pivot <- function(a) {
    declare(type(a = double(2, 2)))
    chol(a, pivot = TRUE)
  }

  chol_linpack <- function(a) {
    declare(type(a = double(2, 2)))
    chol(a, LINPACK = TRUE)
  }

  chol2inv_size <- function(a) {
    declare(type(a = double(2, 2)))
    chol2inv(a, size = 1L)
  }

  chol2inv_bad_rank <- function(a) {
    declare(type(a = double(2)))
    chol2inv(a)
  }

  diag_bad_rank <- function(a) {
    declare(type(a = double(2, 2, 2)))
    diag(a)
  }

  diag_matrix_nrow <- function(a) {
    declare(type(a = double(2, 2)))
    diag(a, nrow = 2L)
  }

  diag_missing <- function() {
    diag()
  }

  expect_error(quick(solve_bad_rank), "expects a matrix")
  expect_warning(quick(solve_non_square), NA)
  expect_error(quick(solve_bad_rhs), "only supports vector or matrix")
  expect_error(quick(chol_bad_rank), "expects a matrix")
  expect_error(quick(chol_pivot), "pivot = TRUE")
  expect_error(quick(chol_linpack), "LINPACK")
  expect_error(quick(chol2inv_size), "does not support size")
  expect_error(quick(chol2inv_bad_rank), "expects a matrix")
  expect_error(
    quick(diag_bad_rank),
    "only supports scalar, vector, or matrix"
  )
  expect_error(quick(diag_matrix_nrow), "cannot be specified")
  expect_error(quick(diag_missing), "argument \"nrow\" is missing")
})

test_that("lapack functions test non-square matrix errors", {
  solve_rect <- function(A, b) {
    declare(type(A = double(3, 2)), type(b = double(3)))
    solve(A, b)
  }

  chol_rect <- function(A) {
    declare(type(A = double(3, 2)))
    chol(A)
  }

  chol2inv_rect <- function(R) {
    declare(type(R = double(3, 2)))
    chol2inv(R)
  }

  expect_warning(quick(solve_rect), NA)
  expect_error(quick(chol_rect), "requires a square matrix")
  expect_error(quick(chol2inv_rect), "requires a square matrix")
})

test_that("solve with scalar RHS is rejected", {
  solve_scalar_rhs <- function(A, b) {
    declare(type(A = double(2, 2)), type(b = double(1)))
    solve(A, b[1])
  }

  expect_error(
    quick(solve_scalar_rhs),
    "non-conformable arguments|expects a vector or matrix"
  )
})

test_that("diag with various nrow/ncol combinations", {
  diag_with_nrow <- function(n) {
    declare(type(n = integer(1)))
    diag(nrow = n)
  }

  diag_with_ncol <- function(n, m) {
    declare(type(n = integer(1)), type(m = integer(1)))
    diag(nrow = n, ncol = m)
  }

  diag_vec_nrow_ncol <- function(x, n, m) {
    declare(
      type(x = double(3)),
      type(n = integer(1)),
      type(m = integer(1))
    )
    diag(x, nrow = n, ncol = m)
  }

  expect_quick_equal(diag_with_nrow, list(n = 3L))
  expect_quick_equal(diag_with_ncol, list(n = 2L, m = 3L))
  expect_quick_equal(diag_vec_nrow_ncol, list(x = c(1, 2, 3), n = 4L, m = 4L))
})

test_that("linear model example matches R", {
  my_lm <- function(X, y) {
    declare(type(X = double(n, k)), type(y = double(n)))
    n <- nrow(X)
    k <- ncol(X)

    XtX <- crossprod(X)
    Xty <- crossprod(X, y)
    coef <- solve(XtX, Xty)

    res <- y - X %*% coef
    ## crossprod(res)[1] was added by codex to silence 1x1 warnings in R
    ##
    s2 <- crossprod(res)[1] / (n - k)

    U <- chol(XtX)
    XtX_inv <- chol2inv(U)

    std_err <- sqrt(diag(XtX_inv) * s2)
    df <- n - k

    list(
      coefficients = coef,
      stderr = std_err,
      df.residual = df
    )
  }

  set.seed(4)
  n <- 30
  k <- 4
  X <- matrix(rnorm(n * k), n, k)
  y <- rnorm(n)

  expect_quick_equal(my_lm, list(X = X, y = y))
})

test_that("crossprod temp can be indexed directly", {
  fn <- function(x) {
    declare(type(x = double(n, k)))
    crossprod(x)[1]
  }

  set.seed(11)
  x <- matrix(rnorm(6), 3, 2)
  expect_quick_equal(fn, list(x = x))
})

skip_on_cran()

test_that("direct-call statement closure can host-mutate with x <<- expr", {
  fn <- function(x) {
    declare(type(x = double(NA)))
    f <- function() {
      x <<- x + 1
      NULL
    }
    f()
    x
  }

  x1 <- c(1, 2, 3)
  x2 <- c(-1, 0, 4, 5)

  expect_identical(fn(x1), x1 + 1)
  expect_identical(fn(x2), x2 + 1)
  expect_quick_identical(fn, x1, x2)

  qfn <- quick(fn)
  for (x0 in list(x1, x2)) {
    x <- x0
    out <- qfn(x)
    expect_identical(out, fn(x0))
    expect_identical(x, x0)
  }
})

test_that("direct-call statement closure supports rank>1 linear x[i] <<- ...", {
  fn <- function(x, k) {
    declare(type(x = double(a, b)), type(k = integer(1)))
    f <- function() {
      x[k] <<- x[k] + 1
      NULL
    }
    f()
    x
  }

  set.seed(1)
  x <- matrix(runif(12), 3, 4)
  expect_quick_identical(fn, list(x, 1L), list(x, 5L), list(x, 12L))
})

test_that("direct-call statement closure supports missing indices in x[ , ] <<- ...", {
  fn <- function(nx, ny) {
    declare(type(nx = integer(1)), type(ny = integer(1)))
    temp <- matrix(0, nx, ny)
    j <- 2L

    f <- function() {
      temp[, 1] <<- 1
      temp[1, ] <<- 2
      temp[, j] <<- 3
      temp[nx, ] <<- 4
      NULL
    }

    f()
    temp
  }

  expect_quick_identical(fn, list(3L, 4L), list(2L, 3L))
})

test_that("direct-call statement closure can use hoist+block inside contains", {
  fn <- function(nx, ny) {
    declare(type(nx = integer(1)), type(ny = integer(1)))
    temp <- matrix(0, nx, ny)

    bc <- function() {
      temp[1, 1] <<- (temp + 1.0)[1, 1]
      temp[nx, ny] <<- (temp + 2.0)[nx, ny]
      NULL
    }

    bc()
    temp
  }

  expect_quick_identical(fn, list(3L, 4L), list(2L, 2L))
})

test_that("sapply closures can use hoist paths inside contains", {
  fn <- function(x) {
    declare(type(x = double(NA)))
    out <- double(length(x))
    out <- sapply(seq_along(out), function(i) (x + 1.0)[i])
    out
  }

  set.seed(1)
  x <- runif(10)
  expect_quick_identical(fn, list(x))
})

test_that("sapply closures can use reduction mask-hoist paths inside contains", {
  fn <- function(x) {
    declare(type(x = double(NA)))
    out <- double(length(x))
    out <- sapply(seq_along(out), function(i) sum(x[x > 0.0]))
    out
  }

  set.seed(1)
  x <- runif(20) - 0.5
  expect_quick_identical(fn, list(x))
})

test_that("<<- is rejected outside local closures", {
  fn <- function(x) {
    declare(type(x = double(NA)))
    x <<- x + 1
    x
  }

  expect_error(
    r2f(fn),
    "<<- is only supported inside local closures",
    fixed = TRUE
  )
})

test_that("<<- errors when target does not exist in the host scope", {
  fn <- function(x) {
    declare(type(x = double(NA)))
    f <- function() {
      y <<- 1
      NULL
    }
    f()
    x
  }

  expect_error(r2f(fn), "existing variable", fixed = TRUE)
})

test_that("<<- errors when targeting a closure formal", {
  fn <- function(x) {
    declare(type(x = double(NA)))
    f <- function(x) {
      x <<- x + 1
      NULL
    }
    f(1.0)
    x
  }

  expect_error(r2f(fn), "must not shadow closure formals", fixed = TRUE)
})

test_that("statement local closure calls may ignore return values", {
  fn <- function(x) {
    declare(type(x = double(NA)))
    f <- function() 1
    f()
    x
  }

  set.seed(1)
  x <- runif(10)
  expect_quick_identical(fn, list(x))
})

test_that("statement local closure calls support chaining void closures", {
  fn <- function(x) {
    declare(type(x = double(NA)))
    g <- function(i) {
      x[i] <- x[i] + 1.0
    }
    f <- function(i) {
      g(i)
    }
    f(1L)
    x
  }

  set.seed(1)
  x <- runif(10)
  expect_quick_identical(fn, list(x))
})

test_that("local closure calls can be used in expression position", {
  fn <- function(x) {
    declare(type(x = double(NA)))
    f <- function(i) x[i]
    out <- double(1)
    out <- 1.0 + f(1L)
    out
  }

  set.seed(1)
  x <- runif(10)
  expect_quick_identical(fn, list(x))
})

test_that("local closure assignments shadow captured variables", {
  fn <- function(x) {
    declare(type(x = double(NA)))
    f <- function() {
      x <- x + 1.0
      sum(x * x)
    }
    a <- f()
    b <- sum(x * x)
    diff <- a - b
    list(diff = diff, host_x = x)
  }

  x1 <- c(0, 0, 0)
  x2 <- c(1, 2, 3)

  expect_identical(fn(x1)$diff, 3)
  expect_identical(fn(x2)$diff, 15)

  expect_identical(fn(x1)$host_x, x1)
  expect_identical(fn(x2)$host_x, x2)

  expect_quick_identical(fn, x1, x2, as.double(seq(-10, 10)))
})

test_that("<<- targets the host even when the name is shadowed locally", {
  fn <- function(x) {
    declare(type(x = double(NA)))
    f <- function() {
      x <- x + 1.0
      x <<- x + 1.0
      sum(x)
    }
    local_sum <- f()
    host_sum <- sum(x)
    diff <- host_sum - local_sum
    list(
      diff = diff,
      local_sum = local_sum,
      host_sum = host_sum,
      host_x = x
    )
  }

  x1 <- c(0)
  x2 <- c(1, 2, 3)

  res1 <- fn(x1)
  res2 <- fn(x2)

  expect_identical(res1$diff, 1)
  expect_identical(res2$diff, 3)

  expect_identical(res1$local_sum, 1)
  expect_identical(res2$local_sum, 9)

  expect_identical(res1$host_sum, 2)
  expect_identical(res2$host_sum, 12)

  expect_identical(res1$host_x, x1 + 2.0)
  expect_identical(res2$host_x, x2 + 2.0)

  expect_quick_identical(fn, x1, x2, as.double(seq(-10, 10)))
})

test_that("captured subset assignments shadow the host", {
  fn <- function(x) {
    declare(type(x = double(NA)))
    f <- function(i) {
      x[i] <- x[i] + 1.0
      x[i]
    }
    out <- double(1)
    out <- f(1L)
    list(out = out, x = x)
  }

  x1 <- as.double(1:5)
  x2 <- c(-3.0, 0.0, 4.0)

  expect_identical(fn(x1), list(out = 2.0, x = x1))
  expect_identical(fn(x2), list(out = -2.0, x = x2))

  expect_quick_identical(fn, x1, x2, as.double(seq(-10, 10)))

  qfn <- quick(fn)
  for (x0 in list(x1, x2)) {
    x <- x0
    res <- qfn(x)

    expect_identical(res, fn(x0))
    expect_identical(x, x0)
  }
})

test_that("shadowed logical captures do not mutate the host", {
  fn <- function(lgl) {
    declare(type(lgl = logical(NA)))
    f <- function() {
      lgl <- !lgl
      lgl
    }
    out <- logical(length(lgl))
    out <- f()
    list(out = out, lgl = lgl)
  }

  lgl1 <- c(TRUE, FALSE, TRUE)
  lgl2 <- c(FALSE, FALSE, TRUE)

  expect_identical(fn(lgl1), list(out = c(FALSE, TRUE, FALSE), lgl = lgl1))
  expect_identical(fn(lgl2), list(out = c(TRUE, TRUE, FALSE), lgl = lgl2))

  expect_quick_identical(fn, lgl1, lgl2, rep(FALSE, 5))

  qfn <- quick(fn)
  for (lgl0 in list(lgl1, lgl2)) {
    lgl <- lgl0
    res <- qfn(lgl)
    expect_identical(res, fn(lgl0))
    expect_identical(lgl, lgl0)
  }
})

test_that("sapply() errors if the closure superassigns to the output variable", {
  fn <- function(x) {
    declare(type(x = double(NA)))
    out <- double(length(x))
    f <- function(i) {
      out[i] <<- x[i] + 1.0
      out[i]
    }
    out <- sapply(seq_along(out), f)
    out
  }

  expect_error(
    r2f(fn),
    "closure must not superassign to its output variable",
    fixed = TRUE
  )
})

test_that("<<- supports the same subset targets as [<- (e.g. x[1:2] <<- ...)", {
  fn <- function(x) {
    declare(type(x = double(NA)))
    f <- function() {
      x[1:2] <<- 0
      NULL
    }
    f()
    x
  }

  expect_quick_identical(fn, list(as.double(1:5)))
})

test_that("<<- errors on drop = FALSE", {
  fn <- function(x) {
    declare(type(x = double(m, n)))
    f <- function() {
      x[1, 1, drop = FALSE] <<- 0
      NULL
    }
    f()
    x
  }

  expect_error(
    r2f(fn),
    "drop = FALSE not supported for superassignment",
    fixed = TRUE
  )
})

skip_on_cran()

test_that("rep.int works in subset indexing", {
  f <- function(x) {
    declare(type(x = double(10)))
    x[rep.int(1L, 5L)]
  }

  expect_quick_identical(f, list(as.double(1:10)))
})

test_that("rep.int is not silently supported outside subset indexing", {
  # Regression: a rep.int() handler intended for subscripts must not change
  # program semantics when called as a general value constructor.
  f <- function(n) {
    declare(type(n = integer(1)))
    rep.int(1.5, n)
  }

  expect_error(quick(f), "rep.int", fixed = TRUE)
})

test_that("rep.int fails cleanly (no internal slot errors) for NULL args in indexing", {
  bad_x <- function(x) {
    declare(type(x = double(10)))
    x[rep.int(NULL, 2L)]
  }
  bad_times <- function(x) {
    declare(type(x = double(10)))
    x[rep.int(1L, NULL)]
  }

  # Prior bug: would error with "no applicable method for '@' applied to an
  # object of class \"NULL\"" rather than a controlled message.
  expect_error(quick(bad_x), "rep.int\\(\\)", fixed = FALSE)
  expect_error(quick(bad_times), "rep.int\\(\\)", fixed = FALSE)
})

test_that("rep.int supports named times= in subset indexing", {
  f <- function(x) {
    declare(type(x = double(10)))
    x[rep.int(3L, times = 2L)]
  }

  expect_quick_identical(f, list(as.double(1:10)))
})

test_that("rep.int supports non-literal times in subset indexing", {
  f <- function(x, n) {
    declare(type(x = double(10)))
    declare(type(n = integer(1)))
    x[rep.int(2L, n)]
  }

  expect_quick_identical(f, list(as.double(1:10), 4L))
})

# Public API regression tests for dotted argument names in size expressions

skip_on_cran()

test_that("dotted argument names work in size expressions", {
  fn <- function(foo.bar) {
    declare(type(foo.bar = integer(1)))

    out <- double(foo.bar)
    for (i in seq_len(foo.bar)) {
      out[i] <- as.double(i)
    }
    out
  }

  qfn <- quick(fn)
  expect_identical(qfn(1L), 1.0)
  expect_identical(qfn(5L), as.double(1:5))
})

skip_on_cran()

test_that("<<- supports whole-vector superassignment via x[] across lengths", {
  fn <- function(x) {
    declare(type(x = double(NA)))
    f <- function() {
      x[] <<- x + 1.0
      NULL
    }
    f()
    x
  }

  expect_quick_identical(fn, list(1), list(c(1, 2)), list(c(1, 2, 3, 4, 5)))
})

test_that("<<- supports vector indexing with double scalar indices (casts to int)", {
  fn <- function(x, idx) {
    declare(type(x = double(NA)), type(idx = double(1)))
    f <- function() {
      x[idx] <<- x[idx] + 1.0
      NULL
    }
    f()
    x
  }

  x <- c(1, 2, 3, 4)
  expect_quick_identical(fn, list(x, 1), list(x, 2), list(x, 4))
})

test_that("<<- supports matrix element and section targets together", {
  fn <- function(x) {
    declare(type(x = double(NA, NA)))
    j <- 2L
    f <- function() {
      x[1, ] <<- 1.0
      x[, j] <<- x[, j] + 2.0
      x[2, 2] <<- x[2, 2] + 3.0
      NULL
    }
    f()
    x
  }

  set.seed(1)
  expect_quick_identical(
    fn,
    list(matrix(runif(6), 2, 3)),
    list(matrix(runif(12), 3, 4))
  )
})

test_that("<<- mutating a matrix argument preserves caller copy-on-modify semantics", {
  fn <- function(x) {
    declare(type(x = double(NA, NA)))
    f <- function() {
      x[1, ] <<- 0.0
      x[, 1] <<- x[, 1] + 1.0
      NULL
    }
    f()
    x
  }

  x1 <- matrix(as.double(1:12), 3, 4)
  x2 <- matrix(as.double(1:6), 2, 3)

  expected1 <- x1
  expected1[1, ] <- 0.0
  expected1[, 1] <- expected1[, 1] + 1.0

  expected2 <- x2
  expected2[1, ] <- 0.0
  expected2[, 1] <- expected2[, 1] + 1.0

  expect_identical(fn(x1), expected1)
  expect_identical(fn(x2), expected2)
  expect_quick_identical(fn, x1, x2)

  qfn <- quick(fn)
  for (x0 in list(x1, x2)) {
    x <- x0
    out <- qfn(x)

    expect_identical(out, fn(x0))
    expect_identical(x, x0)
  }
})

test_that("<<- supports 3D slice superassignment with missing indices", {
  fn <- function(nx, ny, nz) {
    declare(type(nx = integer(1)), type(ny = integer(1)), type(nz = integer(1)))
    a <- array(0.0, c(nx, ny, nz))

    f <- function(k) {
      a[,, k] <<- as.double(k)
      a[1, 1, k] <<- a[1, 1, k] + 0.5
      NULL
    }

    f(1L)
    f(nz)
    a
  }

  expect_quick_identical(fn, list(2L, 3L, 2L), list(3L, 2L, 3L))
})

test_that("sapply + <<- can mutate a matrix host argument and return a matrix", {
  fn <- function(x) {
    declare(type(x = double(NA, NA)))
    out <- x
    f <- function(j) {
      x[, j] <<- x[, j] * 2.0
      x[, j]
    }
    out <- sapply(seq_len(ncol(x)), f, simplify = "array")
    list(x = x, out = out)
  }

  x1 <- matrix(as.double(1:12), 3, 4)
  x2 <- matrix(as.double(1:6), 2, 3)

  expect_identical(fn(x1), list(x = x1 * 2.0, out = x1 * 2.0))
  expect_identical(fn(x2), list(x = x2 * 2.0, out = x2 * 2.0))
  expect_quick_identical(fn, x1, x2)

  qfn <- quick(fn)
  for (x0 in list(x1, x2)) {
    x <- x0
    out <- qfn(x)

    expect_identical(out, fn(x0))
    expect_identical(x, x0)
  }
})

test_that("sapply + <<- supports host scalar accumulation", {
  fn <- function(x) {
    declare(type(x = double(NA)))
    out <- double(length(x))
    acc <- 0.0
    f <- function(i) {
      acc <<- acc + x[i]
      acc
    }
    out <- sapply(seq_along(x), f)
    list(acc = acc, out = out)
  }

  set.seed(1)
  x <- runif(10)
  expect_quick_identical(fn, list(x))
})

test_that("statement closures can be called in loops while mutating host arrays", {
  fn <- function(n) {
    declare(type(n = integer(1)))
    x <- integer(n)
    f <- function(i) {
      x[i] <<- i
      NULL
    }
    for (i in seq_len(n)) {
      f(i)
    }
    x
  }

  expect_quick_identical(fn, list(1L), list(2L), list(7L))
})

test_that("<<- supports rank>1 linear indexing with computed scalar indices", {
  fn <- function(x) {
    declare(type(x = double(NA, NA)))
    k <- nrow(x) * ncol(x)
    kk <- as.double(k)
    f <- function() {
      x[k] <<- x[k] + 1.0
      x[kk] <<- x[kk] + 2.0
      NULL
    }
    f()
    x
  }

  set.seed(1)
  expect_quick_identical(
    fn,
    list(matrix(runif(6), 2, 3)),
    list(matrix(runif(12), 3, 4))
  )
})

test_that("<<- supports 3D element superassignment via a[i, j, k]", {
  fn <- function(nx, ny, nz) {
    declare(type(nx = integer(1)), type(ny = integer(1)), type(nz = integer(1)))
    a <- array(0.0, c(nx, ny, nz))

    bump <- function(i, j, k) {
      a[i, j, k] <<- as.double(i + j + k)
      NULL
    }

    bump(1L, 1L, 1L)
    bump(nx, ny, nz)
    a
  }

  expect_quick_identical(fn, list(2L, 3L, 2L), list(3L, 2L, 3L))
})

# Public API tests for optional NULL defaults in local closures

skip_on_cran()

test_that("optional NULL default treats explicit NULL as missing", {
  fn <- function(x) {
    declare(type(x = double(1)))
    f <- function(a = NULL) {
      if (is.null(a)) {
        a <- x + 1
      }
      a * 2
    }
    f(NULL)
  }

  expect_quick_identical(fn, list(2), list(5))
})

test_that("optional NULL defaults work with multiple optional arguments", {
  fn <- function(x) {
    declare(type(x = double(1)))

    f <- function(a = NULL, b = NULL) {
      if (is.null(a)) {
        a <- x + 1
      }
      if (is.null(b)) {
        b <- 2
      }
      a + b
    }

    c(
      f(),
      f(b = 5),
      f(a = 10),
      f(a = 10, b = 5)
    )
  }

  qfn <- quick(fn)
  expect_identical(qfn(2), c(5, 8, 12, 15))
  expect_identical(qfn(5), c(8, 11, 12, 15))
})

test_that("local closure calls error for unknown or missing arguments", {
  unknown_arg <- function(x) {
    declare(type(x = double(1)))
    f <- function(a = NULL, ...) a
    f(b = x)
  }
  expect_error(
    quick(unknown_arg),
    "call has unknown argument\\(s\\): b",
    fixed = FALSE
  )

  missing_required <- function(x) {
    declare(type(x = double(1)))
    f <- function(a) a + x
    f()
  }
  expect_error(
    quick(missing_required),
    "call is missing required argument\\(s\\): a",
    fixed = FALSE
  )
})

test_that("local closure calls error when required arguments have no inferred type", {
  bad <- function(x) {
    declare(type(x = double(1)))
    f <- function(a) a + x
    f(NULL)
  }

  expect_error(
    quick(bad),
    "call has argument\\(s\\) without inferred types",
    fixed = FALSE
  )
})

test_that("optional NULL defaults must be initialized before use", {
  bad <- function(x) {
    declare(type(x = double(n)))

    f <- function(i, shift = NULL) {
      x[i] + shift
    }

    f(1L)
  }

  expect_error(
    quick(bad),
    "optional argument\\(s\\) used without initializing when NULL: shift",
    fixed = FALSE
  )
})

test_that("optional NULL defaults can be assigned before use", {
  fn <- function(x) {
    declare(type(x = double(1)))

    f <- function(shift = NULL) {
      shift <- 2
      x + shift
    }

    f()
  }

  expect_quick_identical(fn, list(3))
})

test_that("optional arg shadow names avoid existing fortran names", {
  fn <- function(x) {
    declare(type(x = double(1)))
    declare(type(`x..local.` = double(1)))
    `x..local.` <- x + 1

    f <- function(x = NULL) {
      if (is.null(x)) {
        x <- 2
      }
      x + `x..local.`
    }

    f()
  }

  expect_quick_identical(fn, list(1))
})

test_that("local closure calls returning NULL cannot be used as values", {
  bad <- function(x) {
    declare(type(x = double(1)))
    f <- function() NULL
    1 + f()
  }

  expect_error(
    quick(bad),
    "local closure calls that return `NULL` cannot be used as values",
    fixed = TRUE
  )
})

skip_on_cran()

test_that("arg-not-declared error is stable under parent-env name collisions", {
  local({
    # A same-named object exists in the function's enclosure.
    x <- 10:13

    f <- function(x) {
      y <- x[2:1]
      y
    }

    expect_error(quick(f), "arg not declared: x", fixed = TRUE)
  })
})

skip_on_cran()

test_that("operator normalization handles symbol-free calls (public API)", {
  fn <- function(x) {
    declare(type(x = integer(1)))
    abs(-1L) + x
  }
  expect_quick_identical(fn, 1L, 10L)
})

test_that("C bridge hoisting can be disabled (public API)", {
  old <- options(quickr.c_bridge.hoist = FALSE)
  on.exit(options(old), add = TRUE)

  fn <- function(x, y, n) {
    declare({
      type(n = integer(1))
      type(x = double(n))
      type(y = double(n + 1))
      type(out = double(n))
    })
    out <- x + 1
    out
  }

  qfn <- quick(fn)
  expect_identical(qfn(c(1, 2), c(10, 11, 12), 2L), c(2, 3))
})

test_that("C-bridge size-expression errors are surfaced through quick()", {
  mk <- function(dim_expr, include_n = TRUE) {
    if (isTRUE(include_n)) {
      eval(bquote(function(n, x) {
        declare(type(n = integer(1)), type(x = double(.(dim_expr))))
        x
      }))
    } else {
      eval(bquote(function(x) {
        declare(type(x = double(.(dim_expr))))
        x
      }))
    }
  }

  expect_error(
    quick(mk(quote(x[1]), include_n = FALSE)),
    "unsupported size expression"
  )
  expect_error(
    quick(mk(as.call(list(as.name("("), quote(unknown))))),
    "could not resolve size"
  )
  expect_error(quick(mk(quote(dim(unknown)[1]))), "could not resolve size")
  expect_error(quick(mk(quote(unknown + 1))), "could not resolve size")
})

test_that("rank-0 arguments are rejected by the C bridge (public API)", {
  fn <- function(n) {
    declare(type(n = integer()))
    n
  }
  expect_error(quick(fn), "bad rank")
  expect_error(quick(fn), "rank-0")
  expect_error(quick(fn), "integer\\(1\\)")
})

# Compact end-to-end coverage kept on CRAN.

test_that("CRAN smoke: core language and matrix paths compile and run", {
  fn <- function(
    vals,
    mask_mat,
    lhs,
    rhs_mat,
    chol_mat,
    solve_rhs,
    design,
    response
  ) {
    declare(
      type(vals = double(NA)),
      type(mask_mat = double(NA, NA)),
      type(lhs = double(2, 3)),
      type(rhs_mat = double(3, 2)),
      type(chol_mat = double(n, n)),
      type(solve_rhs = double(n)),
      type(design = double(p, k)),
      type(response = double(p))
    )

    bump <- function() {
      vals <<- vals + 1.0
      NULL
    }
    bump()

    shifted <- sapply(seq_along(vals), function(i) sin(vals[i]))
    reversed <- rev(shifted)
    filtered <- reversed[reversed > 0]

    lang_total <- 0.0
    for (elt in filtered) {
      lang_total <- lang_total + elt
    }

    matrix_total <- sum(mask_mat[mask_mat > 3.0])
    matrix_total <- matrix_total + sum(lhs %*% rhs_mat)
    matrix_total <- matrix_total + sum(solve(chol_mat, solve_rhs))
    matrix_total <- matrix_total + sum(qr.solve(design, response))
    matrix_total <- matrix_total + sum(chol(chol_mat))

    lang_total + matrix_total
  }

  vals <- c(-2, -1, 0, 1, 2, 3)
  mask_mat <- matrix(as.double(1:6), nrow = 2L, ncol = 3L, byrow = TRUE)

  set.seed(2)
  lhs <- matrix(rnorm(6), nrow = 2L)
  rhs_mat <- matrix(rnorm(6), nrow = 3L)
  n <- 4L
  k <- 2L
  base <- matrix(rnorm(n * n), nrow = n)
  chol_mat <- crossprod(base) + diag(n)
  solve_rhs <- rnorm(n)
  design <- matrix(rnorm(6 * k), nrow = 6L)
  response <- rnorm(6)

  q_fn <- expect_no_warning(quick(fn))
  expected <- fn(
    vals,
    mask_mat,
    lhs,
    rhs_mat,
    chol_mat,
    solve_rhs,
    design,
    response
  )
  actual <- q_fn(
    vals,
    mask_mat,
    lhs,
    rhs_mat,
    chol_mat,
    solve_rhs,
    design,
    response
  )

  expect_equal(actual, expected)
  expect_identical(typeof(actual), typeof(expected))
})

skip_on_cran()

test_that("local closures support if/else control flow in sapply()", {
  fn <- function(x, thresh) {
    declare(type(x = double(NA)), type(thresh = double(1)))
    out <- double(length(x))
    f <- function(i) {
      val <- 0.0
      if (x[i] > thresh) {
        val <- x[i] * 2.0
      } else {
        val <- x[i] + 1.0
      }
      val
    }
    out <- sapply(seq_along(out), f)
    out
  }

  x0 <- c(0.2, 0.4)
  expect_identical(fn(x0, 0.3), c(1.2, 0.8))
  expect_identical(fn(x0, 0.5), c(1.2, 1.4))

  set.seed(1)
  x <- runif(20)
  expect_quick_identical(
    fn,
    list(x0, 0.3),
    list(x0, 0.5),
    list(x, 0.5)
  )
})

test_that("local closures support repeat/break/next control flow in sapply()", {
  fn <- function(x, thresh, limit) {
    declare(
      type(x = double(NA)),
      type(thresh = double(1)),
      type(limit = double(1))
    )
    out <- double(length(x))
    f <- function(i) {
      acc <- 0.0
      j <- 0L
      repeat {
        j <- j + 1L
        if (j > i) {
          break
        }
        if (x[j] < thresh) {
          next
        }
        acc <- acc + x[j]
        if (acc > limit) break
      }
      acc
    }
    out <- sapply(seq_along(out), f)
    out
  }

  x0 <- c(0.1, 0.5, 0.6)
  expect_identical(fn(x0, 0.2, 0.8), c(0.0, 0.5, 1.1))
  expect_identical(fn(x0, 0.2, 0.4), c(0.0, 0.5, 0.5))

  set.seed(1)
  x <- runif(15)
  expect_quick_identical(
    fn,
    list(x0, 0.2, 0.8),
    list(x0, 0.2, 0.4),
    list(x, 0.2, 1.0)
  )
})

test_that("statement local closures support while loops + <<- host mutation", {
  fn <- function(n) {
    declare(type(n = integer(1)))
    x <- double(n)
    fill <- function() {
      i <- 1L
      while (i <= n) {
        x[i] <<- as.double(i)
        i <- i + 1L
      }
      NULL
    }
    fill()
    x
  }

  expect_identical(fn(1L), 1.0)
  expect_identical(fn(3L), c(1.0, 2.0, 3.0))
  expect_quick_identical(fn, list(1L), list(2L), list(3L), list(7L))
})

test_that("loop variables in local closures shadow host variables", {
  fn <- function(x) {
    declare(type(x = double(NA)))
    j <- 999L
    out <- double(length(x))
    f <- function(i) {
      acc <- 0.0
      for (j in seq_len(i)) {
        acc <- acc + x[j]
      }
      acc
    }
    out <- sapply(seq_along(out), f)
    list(j = j, out = out)
  }

  x1 <- c(1, 2, 3)
  x2 <- c(0, 0, 0)
  expect_identical(fn(x1), list(j = 999L, out = c(1, 3, 6)))
  expect_identical(fn(x2), list(j = 999L, out = c(0, 0, 0)))

  set.seed(1)
  x <- runif(10)
  expect_quick_identical(fn, list(x1), list(x2), list(x))
})

test_that("inline function calls are lowered correctly", {
  fn <- function(x) {
    declare(type(x = double(1)))
    y <- (function(a) a + 1)(x)
    y
  }

  expect_identical(fn(1), 2)
  expect_quick_identical(fn, list(1), list(5))
})

test_that("parenthesized closure calls work", {
  fn <- function(x) {
    declare(type(x = double(1)))
    f <- function(a) a * 2
    y <- ((f))(x)
    y
  }

  expect_identical(fn(3), 6)
  expect_quick_identical(fn, list(3), list(7))
})

test_that("local closures support NULL defaults via optional args", {
  fn <- function(x) {
    declare(type(x = double(1)))
    f <- function(a = NULL) {
      if (is.null(a)) {
        a <- x + 1
      }
      a * 2
    }
    f()
  }

  expect_translation_snapshots(fn)
  expect_identical(fn(2), 6)
  expect_quick_identical(fn, list(2), list(5))

  fn <- function(x) {
    declare(type(x = double(1)))
    f <- function(a = NULL) {
      if (is.null(a)) {
        a <- x + 1
      }
      a * 2
    }
    f(4)
  }

  expect_identical(fn(2), 8)
  expect_quick_identical(fn, list(2), list(5))
})

test_that("optional NULL defaults require a presence guard", {
  fn <- function(x) {
    declare(type(x = double(1)))
    f <- function(a = NULL) {
      if (!is.null(a)) {
        a <- x
      }
      a + x
    }
    f()
  }

  expect_identical(fn(2), numeric())
  expect_error(
    quick(fn),
    "optional argument\\(s\\) used without initializing when NULL: a"
  )
})

test_that("optional NULL defaults allow unconditional assignment", {
  fn <- function(x) {
    declare(type(x = double(1)))
    f <- function(a = NULL) {
      a <- x + 1
      a * 2
    }
    f()
  }

  expect_identical(fn(2), 6)
  expect_quick_identical(fn, list(2), list(5))
})

test_that("closure returning logical assigned to return variable", {
  fn <- function(x) {
    declare(type(x = double(NA)))
    check <- function(i) x[i] > 0.5
    out <- sapply(seq_along(x), check)
    out
  }

  x <- c(0.1, 0.6, 0.3, 0.9)
  expect_identical(fn(x), c(FALSE, TRUE, FALSE, TRUE))
  expect_quick_identical(fn, list(x))
})

test_that("sapply over scalar iterable works", {
  fn <- function(x) {
    declare(type(x = double(1)))
    out <- sapply(x, function(v) v * 2)
    out
  }

  expect_identical(fn(3), 6)
  expect_quick_identical(fn, list(3), list(5))
})

test_that("closure captures and shadows host variable on subscript assign", {
  fn <- function(x) {
    declare(type(x = double(NA)))
    modify <- function(i) {
      x[i] <- x[i] + 1
      x[i]
    }
    out <- sapply(seq_along(x), modify)
    out
  }

  x <- c(1, 2, 3)
  expect_identical(fn(x), c(2, 3, 4))
  expect_quick_identical(fn, list(x))
})

test_that("superassignment to non-existent variable errors", {
  expect_error(
    quick(function(x) {
      declare(type(x = double(NA)))
      modify <- function(i) {
        nonexistent[i] <<- 1
      }
      modify(1L)
      x
    }),
    "must resolve to an existing variable"
  )
})

test_that("closure with scalar indexing on scalar value via superassign", {
  fn <- function(x) {
    declare(type(x = double(1)))
    modify <- function() {
      x[1] <<- x[1] + 1
      NULL
    }
    modify()
    x
  }

  expect_identical(fn(5), 6)
  expect_quick_identical(fn, list(5), list(10))
})

skip_on_cran()

test_that("case-sensitive variable name clashes", {
  expect_snapshot(
    quick(function(j) {
      declare(type(j = integer(1)))
      J <- double(length = j)
      J
    }),
    error = TRUE
  )
})

test_that("non-final expressions must be assigned", {
  expect_error(regexp = "all expressions except the final return", {
    quick(function(x) {
      declare(type(x = double(1)))
      x + 1
      x
    })
  })

  expect_error(regexp = "all expressions except the final return", {
    quick(function(x) {
      declare(type(x = double(1)))
      x
      x
    })
  })

  expect_error(regexp = "all expressions except the final return", {
    quick(function(x) {
      declare(type(x = double(1)))
      x <- x + 1
      x + 1
      x
    })
  })
})

test_that("value-returning local closures can be called as statements", {
  fn <- function(x) {
    declare(type(x = double(1)))

    apply_boundary_conditions <- function() {
      x <<- x + 1
    }

    apply_boundary_conditions()
    x
  }

  # r2f(fn)

  expect_quick_identical(fn, list(1))

  fn <- function(x) {
    declare(type(x = double(1)))

    apply_boundary_conditions <- function() {
      x <<- x + 1
      x
    }

    apply_boundary_conditions()
    x
  }

  # r2f(fn)

  expect_quick_identical(fn, list(1))
})

test_that("reserved or underscored names are rejected", {
  expect_snapshot(
    quick(function(x) {
      `_bad` <- x + 1L
      `_bad`
    }),
    error = TRUE
  )

  expect_snapshot(
    quick(function(x) {
      `bad_` <- x + 1L
      `bad_`
    }),
    error = TRUE
  )

  expect_snapshot(
    quick(function(int) {
      int
    }),
    error = TRUE
  )

  expect_snapshot(
    quick(function(`foo.bar`, foo_bar) {
      1
    }),
    error = TRUE
  )
})

test_that("closure return mode must match output mode", {
  expect_error(
    quick(function(x) {
      declare(type(x = double(1)))
      out <- integer(1)
      compute <- function() x + 1
      out <- compute()
      out
    }),
    "closure result mode.*does not match output mode"
  )
})

test_that("closure must return scalar for scalar outputs", {
  expect_error(
    quick(function(x) {
      declare(type(x = double(3)))
      s <- 0
      compute <- function() x
      s <- compute()
      s
    }),
    "closure must return a scalar"
  )
})

test_that("missing argument declarations get a clear error", {
  expect_error(
    quick(function(x) {
      x + 1
    }),
    "arg not declared: x"
  )
})

test_that("declare() type() calls validate syntax", {
  too_many <- function(x, y) {
    declare(type(x = double(1), y = double(1)))
    x + y
  }
  expect_error(
    quick(too_many),
    "only one variable can be declared per type\\(\\) call",
    fixed = FALSE
  )

  missing_name <- function(x) {
    declare(type(double(1)))
    x
  }
  expect_error(
    quick(missing_name),
    "name must be provided as:",
    fixed = TRUE
  )

  bad_mode <- function(x) {
    declare(type(x = double))
    x
  }
  expect_error(
    quick(bad_mode),
    "only atomic modes are supported",
    fixed = TRUE
  )
})

skip_on_cran()

test_that("quickr_windows_add_dll_paths is a no-op off Windows", {
  withr::local_envvar(PATH = "path-entry")

  expect_false(
    isTRUE(quickr:::quickr_windows_add_dll_paths(
      flags = character(),
      os_type = "unix"
    ))
  )
  expect_identical(Sys.getenv("PATH"), "path-entry")
})

test_that("quickr_windows_add_dll_paths adds missing directories on Windows", {
  temp <- withr::local_tempdir()
  lib_dir <- file.path(temp, "lib")
  bin_dir <- file.path(temp, "bin")
  compiler_dir <- file.path(temp, "compiler")
  dir.create(lib_dir)
  dir.create(bin_dir)
  dir.create(compiler_dir)

  withr::local_envvar(c(
    PATH = temp,
    RTOOLS45_HOME = "",
    RTOOLS44_HOME = "",
    RTOOLS43_HOME = "",
    RTOOLS42_HOME = "",
    RTOOLS40_HOME = "",
    RTOOLS_HOME = ""
  ))

  res <- quickr:::quickr_windows_add_dll_paths(
    flags = c(paste0("-L", lib_dir)),
    os_type = "windows",
    config_value = function(...) "",
    which = function(cmds) setNames(file.path(compiler_dir, cmds), cmds)
  )

  expect_true(isTRUE(res))
  path <- Sys.getenv("PATH")
  path_entries <- strsplit(path, ";", fixed = TRUE)[[1L]]
  path_entries <- path_entries[nzchar(path_entries)]
  path_norm <- tolower(normalizePath(
    path_entries,
    winslash = "\\",
    mustWork = FALSE
  ))
  bin_sibling <- file.path(lib_dir, "..", "bin")
  lib_dir_norm <- tolower(normalizePath(
    lib_dir,
    winslash = "\\",
    mustWork = FALSE
  ))
  bin_sibling_norm <- tolower(normalizePath(
    bin_sibling,
    winslash = "\\",
    mustWork = FALSE
  ))
  bin_dir_norm <- tolower(normalizePath(
    bin_dir,
    winslash = "\\",
    mustWork = FALSE
  ))

  expect_true(lib_dir_norm %in% path_norm)
  expect_true(
    bin_sibling_norm %in% path_norm || bin_dir_norm %in% path_norm
  )
  compiler_dir_norm <- tolower(normalizePath(
    compiler_dir,
    winslash = "\\",
    mustWork = FALSE
  ))
  expect_true(compiler_dir_norm %in% path_norm)
})

test_that("quickr_windows_add_dll_paths leaves PATH unchanged when complete", {
  temp <- withr::local_tempdir()
  lib_dir <- file.path(temp, "lib")
  bin_dir <- file.path(temp, "bin")
  compiler_dir <- file.path(temp, "compiler")
  dir.create(lib_dir)
  dir.create(bin_dir)
  dir.create(compiler_dir)

  base_path <- paste(
    c(lib_dir, bin_dir, R.home("bin"), compiler_dir),
    collapse = ";"
  )
  withr::local_envvar(c(
    PATH = base_path,
    RTOOLS45_HOME = "",
    RTOOLS44_HOME = "",
    RTOOLS43_HOME = "",
    RTOOLS42_HOME = "",
    RTOOLS40_HOME = "",
    RTOOLS_HOME = ""
  ))

  res <- quickr:::quickr_windows_add_dll_paths(
    flags = c(paste0("-L", lib_dir)),
    os_type = "windows",
    config_value = function(...) "",
    which = function(cmds) setNames(file.path(compiler_dir, cmds), cmds)
  )

  expect_false(isTRUE(res))
  expect_identical(Sys.getenv("PATH"), base_path)
})

skip_on_cran()

test_that("runif generates random numbers", {
  ## test simple runif
  fn <- function(n) {
    declare(type(n = integer(1)))
    runif(n)
  }

  expect_translation_snapshots(fn)
  qrunif <- quick(fn)

  expect_identical(
    set_seed_and_call(runif, 5L),
    set_seed_and_call(qrunif, 5L)
  )

  expect_identical(
    set_seed_and_call(runif, 1L),
    set_seed_and_call(qrunif, 1L)
  )

  # scalar runif in fortran local
  fn <- function(x) {
    declare(type(x = double(NA)))
    x * runif(1)
  }
  expect_translation_snapshots(fn)
  qfn <- quick(fn)

  x <- runif(5)
  expect_identical(
    set_seed_and_call(fn, x),
    set_seed_and_call(qfn, x)
  )

  # 1d runif array in fortran local
  fn <- function(x) {
    declare(type(x = double(NA)))
    x * runif(length(x))
  }
  expect_translation_snapshots(fn)
  qfn <- quick(fn)

  expect_identical(
    set_seed_and_call(fn, x),
    set_seed_and_call(qfn, x)
  )
})

test_that("runif with min/max", {
  fn <- function(n, a, b) {
    declare(
      type(n = integer(1)),
      type(a = double(1)),
      type(b = double(1))
    )
    runif(n, a, b)
  }

  expect_translation_snapshots(fn)
  qfn <- quick(fn)

  expect_identical(
    set_seed_and_call(fn, 10L, 3, 11),
    set_seed_and_call(qfn, 10L, 3, 11)
  )

  expect_identical(
    set_seed_and_call(fn, 1L, 3, 11),
    set_seed_and_call(qfn, 1L, 3, 11)
  )

  fn <- function(n, b) {
    declare(
      type(n = integer(1)),
      type(b = double(1))
    )
    runif(n, max = b)
  }

  expect_translation_snapshots(fn)
  qfn <- quick(fn)

  expect_identical(
    set_seed_and_call(fn, 10L, 20),
    set_seed_and_call(qfn, 10L, 20)
  )

  fn <- function(b) {
    declare(
      type(b = double(1))
    )
    runif(1, max = b)
  }

  expect_translation_snapshots(fn)
  qfn <- quick(fn)

  expect_identical(
    set_seed_and_call(fn, 20),
    set_seed_and_call(qfn, 20)
  )

  fn <- function(b) {
    declare(
      type(b = double(1))
    )
    runif(10, max = b)
  }

  expect_translation_snapshots(fn)
  qfn <- quick(fn)

  expect_identical(
    set_seed_and_call(fn, 20),
    set_seed_and_call(qfn, 20)
  )
})

skip_on_cran()

test_that("stop propagates errors from quickr functions", {
  stop_fn <- function(x) {
    declare(type(x = double(1)))
    if (x < 0) {
      stop("x must be nonnegative")
    }
    x + 1
  }

  q_stop <- quick(stop_fn)
  expect_error(q_stop(-1), "x must be nonnegative", fixed = TRUE)
  expect_equal(q_stop(1), 2)
})

test_that("stop with empty message still signals an error", {
  stop_empty <- function(x) {
    declare(type(x = double(1)))
    if (x < 0) {
      stop("")
    }
    x + 1
  }

  expect_error(quick(stop_empty)(-1), "quickr error", fixed = TRUE)
})

test_that("stop with one-character message propagates", {
  stop_one <- function(x) {
    declare(type(x = double(1)))
    if (x < 0) {
      stop("x")
    }
    x + 1
  }

  expect_error(quick(stop_one)(-1), "x", fixed = TRUE)
})

test_that("stop with newline escapes in error message", {
  stop_newline <- function(x) {
    declare(type(x = double(1)))
    if (x < 0) {
      stop("a\nb")
    }
    x + 1
  }

  err <- tryCatch(quick(stop_newline)(-1), error = identity)
  expect_true(inherits(err, "error"))
  expect_equal(conditionMessage(err), "a\\nb")
})

test_that("long stop messages are truncated", {
  # Include spaces so Fortran line continuations can split the literal.
  long_msg <- paste(rep("abcdefghij", 30), collapse = " ")
  stop_long <- eval(bquote(function(x) {
    declare(type(x = double(1)))
    if (x < 0) {
      stop(.(long_msg))
    }
    x + 1
  }))

  err <- tryCatch(quick(stop_long)(-1), error = identity)
  expect_true(inherits(err, "error"))
  msg <- conditionMessage(err)
  expect_equal(nchar(msg), 255L)
  expect_equal(msg, substr(long_msg, 1, 255L))
})

test_that("long stop messages without spaces are rejected", {
  long_msg <- paste(rep("abcdefghij", 30), collapse = "")
  stop_long <- eval(bquote(function(x) {
    declare(type(x = double(1)))
    if (x < 0) {
      stop(.(long_msg))
    }
    x + 1
  }))

  expect_error(
    quick(stop_long),
    "Error message is too long to fit in a single Fortran line without spaces.",
    fixed = TRUE
  )
})

test_that("lapack rank deficiency errors surface in quickr", {
  solve_singular <- function(A, b) {
    declare(type(A = double(2, 2)), type(b = double(2)))
    solve(A, b)
  }

  qr_singular <- function(A, b) {
    declare(type(A = double(2, 2)), type(b = double(2)))
    qr.solve(A, b)
  }

  A <- matrix(c(1, 2, 2, 4), nrow = 2)
  b <- c(1, 2)

  expect_error(quick(solve_singular)(A, b), "dgesv", fixed = TRUE)
  expect_error(quick(qr_singular)(A, b), "rank deficient", fixed = TRUE)
})

test_that("stop() translation includes error plumbing", {
  stop_fn <- function(x) {
    declare(type(x = double(1)))
    if (x < 0) {
      stop("x must be nonnegative")
    }
    x + 1
  }

  expect_translation_snapshots(
    stop_fn,
    note = "stop() should emit error message and C bridge checks"
  )
})

test_that("stop() translation wraps long error messages", {
  long_msg <- paste(rep("abcdefghij", 15), collapse = " ")
  stop_fn <- eval(bquote(function(x) {
    declare(type(x = double(1)))
    if (x < 0) {
      stop(.(long_msg))
    }
    x + 1
  }))

  expect_translation_snapshots(stop_fn)
})

skip_on_cran()

test_that("assignment is not skipped when RHS does not write to dest", {
  fn <- function(x) {
    declare(type(x = double(1)))
    x <- 1
    x
  }
  qfn <- quick(fn)

  args <- list(x = 2)
  expect_equal(do.call(fn, args), do.call(qfn, args))
})

skip_on_cran()

test_that("dimension mismatch errors show axis", {
  fn <- function(x) {
    declare(type(x = double(2, 3)))
    sum(x)
  }
  qfn <- quick(fn)

  expect_error(
    qfn(matrix(as.double(1:6), nrow = 3, ncol = 2)),
    "dim(x)[1] must be 2, not 3",
    fixed = TRUE
  )

  expect_error(
    qfn(matrix(as.double(1:4), nrow = 2, ncol = 2)),
    "dim(x)[2] must be 3, not 2",
    fixed = TRUE
  )
})

# Public API tests for nrow()/ncol()/dim() size expression lowering in the C bridge

skip_on_cran()

test_that("declare() size expressions support nrow() and ncol()", {
  fn <- function(x) {
    declare(
      type(x = double(NA, NA)),
      type(out = double(nrow(x) + ncol(x)))
    )
    out <- double(nrow(x) + ncol(x))
    out[1] <- 1
    out
  }

  set.seed(1)
  x <- matrix(runif(6), nrow = 2, ncol = 3)
  qfn <- quick(fn)
  out <- qfn(x)
  expect_identical(length(out), nrow(x) + ncol(x))
  expect_identical(out[[1L]], 1.0)
})

test_that("declare() size expressions support dim(x)[axis] indices", {
  fn <- function(x) {
    declare(
      type(x = double(NA, NA)),
      type(out = double(dim(x)[1L] + dim(x)[2L]))
    )
    out <- double(dim(x)[1L] + dim(x)[2L])
    for (i in seq_len(length(out))) {
      out[i] <- as.double(i)
    }
    out
  }

  set.seed(2)
  x <- matrix(runif(12), nrow = 3, ncol = 4)
  expect_quick_identical(fn, list(x))
})

test_that("declare() size expressions validate nrow()/ncol() arity", {
  bad_nrow <- function(x) {
    declare(type(x = double(NA, NA)), type(out = double(nrow(x, 1L))))
    out <- double(1L)
    out
  }
  bad_ncol <- function(x) {
    declare(type(x = double(NA, NA)), type(out = double(ncol(x, 1L))))
    out <- double(1L)
    out
  }

  expect_error(quick(bad_nrow), "unused argument", fixed = TRUE)
  expect_error(quick(bad_ncol), "unused argument", fixed = TRUE)
})

test_that("declare() size expressions reject ncol() beyond variable rank", {
  bad <- function(x) {
    declare(type(x = double(NA)))
    out <- double(ncol(x))
    out
  }

  expect_error(quick(bad), "insufficient rank", fixed = TRUE)
})

test_that("declare() size expressions reject unsupported calls", {
  bad <- function(n) {
    declare(type(n = integer(1)), type(out = double(sum(n))))
    out <- double(1L)
    out
  }

  expect_error(quick(bad), "could not find function \"sum\"", fixed = TRUE)
})

test_that("declare() size expressions require dim() to reference a symbol", {
  bad <- function(x) {
    declare(type(x = double(dim(1)[1L])))
    sum(x)
  }

  expect_error(
    quick(bad),
    "dim\\(\\) size expressions must refer to a symbol",
    fixed = FALSE
  )
})

# Coverage-oriented public API tests (exercise compiled calls via quick()).

skip_on_cran()

test_that("C bridge size checks handle scalar size args (including dotted args)", {
  fn <- function(n, x) {
    declare(type(n = integer(1)), type(x = double(n)))
    sum(x)
  }
  qfn <- quick(fn)

  expect_identical(qfn(3L, as.double(1:3)), 6.0)
  expect_error(
    qfn(4L, as.double(1:3)),
    "length\\(x\\) must equal n, but are 3 and 4",
    fixed = FALSE
  )

  dotted <- function(foo.bar, x) {
    declare(type(foo.bar = integer(1)), type(x = double(foo.bar)))
    sum(x)
  }
  qdotted <- quick(dotted)

  expect_identical(qdotted(2L, c(0.25, 0.75)), 1.0)
  expect_error(
    qdotted(3L, c(0.25, 0.75)),
    "length\\(x\\) must equal foo\\.bar, but are 2 and 3",
    fixed = FALSE
  )
})

test_that("qr.solve supports explicit tol and errors on rank-deficient matrices", {
  fn_tol <- function(a, b) {
    declare(type(a = double(n, k)), type(b = double(n)))
    qr.solve(a, b, tol = 1e-7)
  }

  set.seed(1)
  a <- matrix(rnorm(50), nrow = 10)
  b <- rnorm(10)
  qtol <- quick(fn_tol)
  expect_equal(qtol(a, b), qr.solve(a, b, tol = 1e-7))

  fn_rd <- function(a, b) {
    declare(type(a = double(n, k)), type(b = double(n)))
    qr.solve(a, b)
  }
  qrd <- quick(fn_rd)

  a_rd <- cbind(1, 1, rnorm(10))
  b_rd <- rnorm(10)
  expect_error(
    qrd(a_rd, b_rd),
    "rank deficient matrix in qr.solve",
    fixed = TRUE
  )
})

test_that("svd() $u/$d/$v can be used to reconstruct a matrix", {
  fn <- function(x) {
    declare(type(x = double(m, n)))
    s <- svd(x)
    s$u %*% diag(s$d) %*% t(s$v)
  }

  set.seed(2)
  x <- matrix(rnorm(12), nrow = 4, ncol = 3)
  qfn <- quick(fn)
  expect_equal(qfn(x), x, tolerance = 1e-10)
})

test_that("local closure calls use keyword arguments when optional args are missing", {
  fn <- function(x) {
    declare(type(x = double(n)))

    f <- function(i, shift = NULL, scale = NULL) {
      if (is.null(shift)) {
        shift <- 1
      }
      if (is.null(scale)) {
        scale <- 2
      }
      (x[i] + shift) * scale
    }

    g <- function(i) f(i, scale = 3)
    sapply(seq_along(x), g)
  }

  set.seed(3)
  x <- runif(20)
  expect_quick_equal(fn, list(x))
})

test_that("subset designators support drop = FALSE for scalar indices", {
  fn <- function(A) {
    declare(type(A = double(m, n)))
    A[1, 2, drop = FALSE]
  }

  set.seed(4)
  A <- matrix(runif(20), nrow = 5)
  expect_quick_identical(fn, list(A))
})

test_that("indexing a length-1 vector with [1] is a no-op", {
  fn <- function(x) {
    declare(type(x = double(1L)))
    x[1] + 1
  }
  qfn <- quick(fn)
  expect_identical(qfn(2.5), 3.5)
})

test_that("subset superassignment works and rejects unsupported forms", {
  ok <- function(A) {
    declare(type(A = double(m, n)))

    f <- function() {
      A[1, 1] <<- 0
      NULL
    }

    f()
    A
  }

  set.seed(5)
  A <- matrix(runif(12), nrow = 4)
  qok <- quick(ok)
  out <- qok(A)
  expect_identical(out[1, 1], 0.0)

  bad_drop <- function(A) {
    declare(type(A = double(m, n)))
    f <- function() {
      A[1, 1, drop = FALSE] <<- A[1, 1, drop = FALSE]
    }
    f()
    A
  }
  expect_error(
    quick(bad_drop),
    "drop = FALSE not supported for superassignment",
    fixed = TRUE
  )

  bad_base <- function(A) {
    declare(type(A = double(m, n)))
    f <- function() {
      (A)[1, 1] <<- 0
    }
    f()
    A
  }
  expect_error(
    quick(bad_base),
    "only superassignment to x[...] is supported",
    fixed = TRUE
  )

  missing_target <- function(A) {
    declare(type(A = double(m, n)))
    f <- function() {
      B[1, 1] <<- 0
    }
    f()
    A
  }
  expect_error(
    quick(missing_target),
    "<<- targets must resolve to an existing variable",
    fixed = TRUE
  )
})

test_that("subset translation errors are user-facing", {
  rank_mismatch <- function(A) {
    declare(type(A = double(m, n)))
    A[1, 2, 3]
  }
  expect_error(
    quick(rank_mismatch),
    "number of args to x[...] must match the rank of x",
    fixed = TRUE
  )

  bad_index_rank <- function(x, idx) {
    declare(type(x = double(n)), type(idx = integer(2L, 2L)))
    x[idx]
  }
  expect_error(
    quick(bad_index_rank),
    "all args to x[...] must be logical or integer of rank 0 or 1",
    fixed = TRUE
  )
})

test_that("svd() rejects unsupported arguments and access patterns", {
  missing_x <- function() {
    svd(NULL)$d
  }
  expect_error(
    quick(missing_x),
    "svd\\(\\) expects `x`",
    fixed = FALSE
  )

  bad_nu <- function(x) {
    declare(type(x = double(m, n)))
    svd(x, nu = 0)$d
  }
  expect_error(quick(bad_nu), "svd() does not support `nu` yet", fixed = TRUE)

  bad_nv <- function(x) {
    declare(type(x = double(m, n)))
    svd(x, nv = 0)$d
  }
  expect_error(quick(bad_nv), "svd() does not support `nv` yet", fixed = TRUE)

  bad_linpack <- function(x) {
    declare(type(x = double(m, n)))
    svd(x, LINPACK = TRUE)$d
  }
  expect_error(
    quick(bad_linpack),
    "svd() does not support LINPACK",
    fixed = TRUE
  )

  bad_field <- function(x) {
    declare(type(x = double(m, n)))
    svd(x)$foo
  }
  expect_error(
    quick(bad_field),
    "`$` only supports `.Machine$double.eps` and `svd()` results ($d, $u, $v)",
    fixed = TRUE
  )

  bare_call <- function(x) {
    declare(type(x = double(m, n)))
    svd(x)
    1
  }
  expect_error(
    quick(bare_call),
    "svd() must be assigned to a symbol or accessed via $d, $u, $v",
    fixed = TRUE
  )
})

test_that("svd() assignment cannot overwrite declared variables", {
  fn <- function(x) {
    declare(type(x = double(m, n)))
    declare(type(s = double(1L)))
    s <- svd(x)
    1
  }

  expect_error(
    quick(fn),
    "svd() result cannot overwrite declared variable: s",
    fixed = TRUE
  )
})

test_that("invalid size expressions produce helpful errors", {
  bad_length_literal <- function(x) {
    declare(type(x = double(length(1 + 2))))
    sum(x)
  }
  expect_error(
    quick(bad_length_literal),
    "length() size expressions must refer to a symbol",
    fixed = TRUE
  )

  bad_length_unknown <- function(x) {
    declare(type(x = double(length(y))))
    sum(x)
  }
  expect_error(
    quick(bad_length_unknown),
    "could not resolve size: y",
    fixed = TRUE
  )

  bad_dim_axis <- function(y, x) {
    declare(type(y = double(n)), type(x = double(dim(y)[1.5])))
    sum(x)
  }
  expect_error(
    quick(bad_dim_axis),
    "dim(x)[axis] requires integer axis",
    fixed = TRUE
  )

  bad_dim_rank <- function(y, x) {
    declare(type(y = double(n)), type(x = double(dim(y)[2])))
    sum(x)
  }
  expect_error(
    quick(bad_dim_rank),
    "insufficient rank of variable",
    fixed = TRUE
  )
})

test_that("size expressions support max() and integer division", {
  fn <- function(n, x) {
    declare(
      type(n = integer(1)),
      type(x = double(max(n %/% 2L, 2L, 3L)))
    )
    sum(x)
  }
  qfn <- quick(fn)

  expect_identical(qfn(8L, rep(1, 4)), 4.0)
  expect_error(qfn(8L, rep(1, 3)))
})

test_that("C bridge size expressions support min()", {
  fn <- function(n, x) {
    declare(
      type(n = integer(1)),
      type(x = double(min(n, 5L)))
    )
    sum(x)
  }

  qfn <- quick(fn)
  expect_identical(qfn(3L, as.double(1:3)), 6.0)
  expect_identical(qfn(10L, as.double(1:5)), 15.0)
})

test_that("vector ops accept mixed constant/symbol sizes", {
  fn <- function(n, x, y) {
    declare(
      type(n = integer(1)),
      type(x = double(3L)),
      type(y = double(n))
    )
    x + y
  }

  qfn <- quick(fn)
  expect_identical(
    qfn(3L, as.double(1:3), as.double(4:6)),
    as.double(c(5, 7, 9))
  )
})

test_that("size expressions support length() and modulo", {
  fn <- function(x) {
    declare(
      type(x = double(n)),
      type(out = double(length(x) %% 3L + 1L))
    )
    out <- double(length(x) %% 3L + 1L)
    for (i in seq_len(length(out))) {
      out[i] <- as.double(i)
    }
    out
  }

  x <- runif(5)
  expect_quick_identical(fn, list(x))
})

test_that("symbolic size names reuse fortranized symbols", {
  fn <- function(foo.bar, x, y) {
    declare(
      type(foo.bar = integer(1)),
      type(x = double(foo.bar)),
      type(y = double(foo.bar))
    )
    x + y
  }

  qfn <- quick(fn)
  expect_identical(
    qfn(3L, as.double(1:3), as.double(4:6)),
    as.double(c(5, 7, 9))
  )
})

test_that("quick() returns named lists from compiled functions", {
  fn <- function(a, b) {
    declare(type(a = double(1)), type(b = double(1)))
    sum <- a + b
    diff <- a - b
    list(sum = sum, diff = diff)
  }

  qfn <- quick(fn)
  expect_identical(qfn(2, 1), fn(2, 1))
})

test_that("triangular solve handles matrix right-hand sides", {
  fn <- function(U, B) {
    declare(type(U = double(n, n)), type(B = double(n, k)))
    backsolve(U, B)
  }

  set.seed(6)
  n <- 3
  k <- 2
  U <- matrix(rnorm(n * n), nrow = n)
  U[lower.tri(U)] <- 0
  B <- matrix(rnorm(n * k), nrow = n)

  qfn <- quick(fn)
  expect_equal(qfn(U, B), backsolve(U, B), tolerance = 1e-10)
})

test_that("inline local closure calls compile", {
  fn <- function(x) {
    declare(type(x = double(1)))
    (function(y) y + 1)(x)
  }

  expect_quick_identical(fn, list(2))
})

test_that("math intrinsics handle doubles with log10", {
  fn <- function(x) {
    declare(type(x = double(n)))
    out <- sin(x) + cos(x)
    out <- out + sqrt(x) + log(x) + exp(x)
    out <- out + floor(x) + ceiling(x)
    out <- out + log10(x)
    out
  }

  x <- seq(0.1, 2, length.out = 6)
  expect_quick_equal(fn, list(x))
})

test_that("math intrinsics handle complex log10 and components", {
  fn <- function(z) {
    declare(type(z = complex(n)))
    out <- Re(z) + Im(z) + Mod(z) + Arg(z) + abs(z)
    out <- out + Re(log10(z)) + Im(log10(z))
    out <- out + Re(Conj(z))
    out
  }

  z <- complex(
    real = seq(1, 6, length.out = 6),
    imaginary = seq(2, 7, length.out = 6)
  )
  qfn <- quick(fn)
  expect_equal(qfn(z), fn(z), tolerance = 1e-12)
})

test_that("reductions hoist logical masks and linear indexing works", {
  fn_mask <- function(x) {
    declare(type(x = double(n)))
    sum(x[x > 0])
  }
  x <- c(-1, 2, -3, 4)
  expect_quick_equal(fn_mask, list(x))

  fn_linear <- function(A) {
    declare(type(A = double(m, n)))
    A[3]
  }
  A <- matrix(as.double(1:6), nrow = 2)
  expect_quick_identical(fn_linear, list(A))
})

test_that("reductions reject distinct masks within one expression", {
  fn <- function(x, a, b) {
    declare(
      type(x = double(n)),
      type(a = logical(n)),
      type(b = logical(n))
    )
    sum(x[a] + x[b])
  }
  expect_error(
    quick(fn),
    "reduction expressions only support a single logical mask",
    fixed = TRUE
  )
})

test_that("cbind handles matrix, vector, and scalar inputs with symbolic sizes", {
  fn <- function(A, v, s) {
    declare(type(A = double(n, k)), type(v = double(n)), type(s = double(1)))
    cbind(A, v, s)
  }

  set.seed(7)
  A <- matrix(rnorm(6), nrow = 2)
  v <- rnorm(2)
  s <- 1.25
  qfn <- quick(fn)
  expect_equal(unname(qfn(A, v, s)), unname(cbind(A, v, s)))
})

test_that("cbind preserves logical inputs", {
  fn <- function(a, b) {
    declare(type(a = logical(n)), type(b = logical(n)))
    cbind(a, b)
  }

  a <- c(TRUE, FALSE, TRUE)
  b <- c(FALSE, TRUE, FALSE)
  qfn <- quick(fn)
  expect_identical(unname(qfn(a, b)), unname(cbind(a, b)))
})

test_that("rbind coerces logical inputs to integer mode", {
  fn <- function(x, lgl, s) {
    declare(type(x = integer(n)), type(lgl = logical(n)), type(s = integer(1)))
    rbind(x, lgl, s)
  }

  x <- as.integer(1:3)
  lgl <- c(TRUE, FALSE, TRUE)
  s <- 2L
  qfn <- quick(fn)
  expect_identical(unname(qfn(x, lgl, s)), unname(rbind(x, lgl, s)))
})

test_that("cbind supports dynamic column sizes with common row counts", {
  bad_cols <- function(x, y) {
    declare(type(x = double(n, NA)), type(y = double(n, NA)))
    cbind(x, y)
  }
  x <- matrix(as.double(1:6), nrow = 2)
  y <- matrix(as.double(7:12), nrow = 2)
  qcols <- quick(bad_cols)
  expect_identical(unname(qcols(x, y)), unname(cbind(x, y)))

  bad_rows <- function(x, y) {
    declare(type(x = double(NA, n)), type(y = double(NA, n)))
    cbind(x, y)
  }
  expect_error(
    quick(bad_rows),
    "cbind() requires inputs with a common row count",
    fixed = TRUE
  )
})

test_that("crossprod supports two-argument form", {
  fn <- function(x, y) {
    declare(type(x = double(n, k)), type(y = double(n, m)))
    crossprod(x, y)
  }

  set.seed(8)
  x <- matrix(rnorm(6), nrow = 3)
  y <- matrix(rnorm(9), nrow = 3)
  qfn <- quick(fn)
  expect_equal(qfn(x, y), crossprod(x, y), tolerance = 1e-12)
})

test_that("crossprod errors on non-conformable arguments", {
  fn <- function(x, y) {
    declare(type(x = double(2L, 3L)), type(y = double(4L, 5L)))
    crossprod(x, y)
  }

  expect_error(
    quick(fn),
    "non-conformable arguments in crossprod",
    fixed = TRUE
  )
})

test_that("matmul assignment infers destination shape", {
  fn <- function(A, B) {
    declare(type(A = double(n, k)), type(B = double(k, m)))
    out <- (A %*% B)
    out
  }

  set.seed(9)
  A <- matrix(rnorm(6), nrow = 2)
  B <- matrix(rnorm(6), nrow = 3)
  qfn <- quick(fn)
  expect_equal(qfn(A, B), A %*% B, tolerance = 1e-12)
})

test_that("double literals preserve precision in compiled code", {
  fn <- function(x) {
    declare(type(x = double(1)))
    x + 1.23456789
  }

  qfn <- quick(fn)
  expect_equal(qfn(0), 1.23456789, tolerance = 1e-12)
})

test_that("character constructor is not implemented", {
  fn <- function() {
    character(1)
  }

  expect_error(quick(fn), "not implemented yet", fixed = TRUE)
})

test_that("raw constructor is not implemented", {
  fn <- function() {
    raw(1)
  }

  expect_error(quick(fn), "not implemented yet", fixed = TRUE)
})

test_that("cbind errors for complex mixed with non-complex", {
  fn <- function(x, y) {
    declare(type(x = complex(n)), type(y = double(n)))
    cbind(x, y)
  }

  expect_error(
    quick(fn),
    "cbind() does not support mixing complex with other types",
    fixed = TRUE
  )
})

test_that("cbind requires known and common row sizes", {
  mismatched_rows <- function(x, y) {
    declare(type(x = double(n)), type(y = double(m)))
    cbind(x, y)
  }
  expect_error(
    quick(mismatched_rows),
    "cbind() requires inputs with a common row count",
    fixed = TRUE
  )
})

test_that("rbind requires common column sizes", {
  mismatched_cols <- function(x, y) {
    declare(type(x = double(n)), type(y = double(m)))
    rbind(x, y)
  }
  expect_error(
    quick(mismatched_cols),
    "rbind() requires inputs with a common column count",
    fixed = TRUE
  )
})

test_that("cbind supports symbolic size expressions", {
  fn <- function(n, x, y) {
    declare(
      type(n = integer(1)),
      type(x = double(n + 1L)),
      type(y = double(n + 1L))
    )
    cbind(x, y)
  }

  qfn <- quick(fn)
  x <- as.double(1:4)
  y <- as.double(5:8)
  expect_equal(unname(qfn(3L, x, y)), unname(cbind(x, y)))
})

test_that("tcrossprod supports single-argument form", {
  fn <- function(x) {
    declare(type(x = double(n, k)))
    tcrossprod(x)
  }

  set.seed(10)
  x <- matrix(rnorm(12), nrow = 3)
  qfn <- quick(fn)
  expect_equal(qfn(x), tcrossprod(x), tolerance = 1e-12)
})

test_that("svd() $u and $v can be accessed inline", {
  fn <- function(x) {
    declare(type(x = double(m, n)))
    sum(svd(x)$u) + sum(svd(x)$v)
  }

  set.seed(11)
  x <- matrix(rnorm(12), nrow = 4)
  qfn <- quick(fn)
  expect_equal(qfn(x), fn(x), tolerance = 1e-10)
})

test_that("crossprod assignment infers destination shape", {
  fn <- function(x) {
    declare(type(x = double(n, k)))
    out <- crossprod(x)
    out
  }

  set.seed(12)
  x <- matrix(rnorm(12), nrow = 3)
  qfn <- quick(fn)
  expect_equal(qfn(x), crossprod(x), tolerance = 1e-12)
})

test_that("local closure calls can be assigned", {
  fn <- function(x) {
    declare(type(x = double(n)))
    f <- function(i) x[i] + 1
    y <- f(2L)
    y
  }

  x <- as.double(1:5)
  expect_quick_equal(fn, list(x))
})

test_that("local closure calls returning NULL cannot be assigned", {
  fn <- function(x) {
    declare(type(x = double(n)))
    f <- function(i) {
      x[i] <- x[i] + 1
      NULL
    }
    y <- f(1L)
    y
  }

  expect_error(
    quick(fn),
    "local closure calls that return `NULL` cannot be assigned",
    fixed = TRUE
  )
})

test_that("optional args must be initialized before use", {
  fn <- function(x) {
    declare(type(x = double(n)))
    f <- function(i, shift = NULL) x[i] + shift
    f(1L)
  }

  expect_error(
    quick(fn),
    "optional argument\\(s\\) used without initializing",
    fixed = FALSE
  )
})

test_that("optional args can be initialized via is.null branches", {
  fn <- function(x) {
    declare(type(x = double(n)))
    f <- function(i, shift = NULL) {
      if (is.null(shift)) {
        shift <- 2
      }
      x[i] + shift
    }
    f(1L)
  }

  x <- as.double(1:3)
  expect_quick_equal(fn, list(x))
})

test_that("optional args can be assigned before use", {
  fn <- function(x) {
    declare(type(x = double(n)))
    f <- function(i, shift = NULL) {
      shift <- 3
      x[i] + shift
    }
    f(1L)
  }

  x <- as.double(1:3)
  expect_quick_equal(fn, list(x))
})

test_that("optional args can be initialized in else branches", {
  fn <- function(x) {
    declare(type(x = double(n)))
    f <- function(i, shift = NULL) {
      if (!is.null(shift)) {
        shift <- shift + 1
      } else {
        shift <- 1
      }
      x[i] + shift
    }
    f(1L)
  }

  x <- as.double(1:3)
  expect_quick_equal(fn, list(x))
})

test_that("local subset assignment shadows host variables", {
  fn <- function(x) {
    declare(type(x = double(n)))
    f <- function() {
      x[1] <- x[1] + 1
      NULL
    }
    f()
    x
  }

  x <- as.double(1:3)
  expect_quick_identical(fn, list(x))
})

test_that("subset superassignment with linear indexing updates host", {
  fn <- function(A) {
    declare(type(A = double(m, n)))
    f <- function() {
      A[3] <<- 0
      NULL
    }
    f()
    A
  }

  A <- matrix(as.double(1:6), nrow = 2)
  qfn <- quick(fn)
  out <- qfn(A)
  expect_identical(out[3], 0.0)
})

test_that("subset superassignment supports scalar indices", {
  fn <- function(s) {
    declare(type(s = double(1L)))
    f <- function() {
      s[1] <<- s[1] + 1
      NULL
    }
    f()
    s
  }

  qfn <- quick(fn)
  expect_identical(qfn(2), 3.0)
})

test_that("subset superassignment errors outside local closures", {
  fn <- function(x) {
    declare(type(x = double(n)))
    x[1] <<- 0
    x
  }
  expect_error(
    quick(fn),
    "<<- is only supported inside local closures",
    fixed = TRUE
  )
})

test_that("elementwise vector-matrix ops reshape vectors", {
  fn_left <- function(x, A) {
    declare(type(x = double(n)), type(A = double(n, k)))
    x + A
  }
  fn_right <- function(A, x) {
    declare(type(A = double(n, k)), type(x = double(n)))
    A + x
  }

  set.seed(13)
  A <- matrix(rnorm(6), nrow = 2)
  x <- rnorm(2)
  ql <- quick(fn_left)
  qr <- quick(fn_right)
  expect_equal(ql(x, A), x + A)
  expect_equal(qr(A, x), A + x)
})

test_that("elementwise vector lengths must recycle cleanly", {
  fn <- function(x, y) {
    declare(type(x = double(3L)), type(y = double(2L)))
    x + y
  }

  expect_error(
    quick(fn),
    "elementwise vector operations require lengths that recycle cleanly",
    fixed = TRUE
  )
})

test_that("recycling uses fortranized size expressions", {
  fn <- function(foo.bar, x, y) {
    declare(
      type(foo.bar = integer(1)),
      type(x = double(foo.bar + 1L)),
      type(y = double(foo.bar + 1L))
    )
    x + y
  }

  qfn <- quick(fn)
  x <- as.double(1:4)
  y <- as.double(5:8)
  expect_equal(qfn(3L, x, y), x + y)
})

test_that("mask hoisting accepts repeated masks", {
  same_mask <- function(x) {
    declare(type(x = double(n)))
    sum(x[x > 0] + x[x > 0])
  }

  x <- c(-1, 2, -3, 4)
  expect_quick_equal(same_mask, list(x))
})

test_that("local closures enforce unique fortranized argument names", {
  fn <- function(x) {
    declare(type(x = double(1)))
    f <- function(foo.bar, foo_bar) foo.bar + foo_bar
    f(foo.bar = x, foo_bar = x)
  }
  expect_error(
    quick(fn),
    "Fortran is case-insensitive; these names conflict when mapped",
    fixed = TRUE
  )
})

test_that("local closure calls error on missing required arguments", {
  fn <- function(x) {
    declare(type(x = double(n)))
    f <- function(i, j) x[i] + j
    f(i = 1L)
  }
  expect_error(
    quick(fn),
    "call is missing required argument",
    fixed = TRUE
  )
})

test_that("local subset assignment errors on unknown symbols", {
  fn <- function(x) {
    declare(type(x = double(n)))
    f <- function() {
      y[1] <- 1
      NULL
    }
    f()
    x
  }
  expect_error(
    quick(fn),
    "could not resolve symbol: y",
    fixed = TRUE
  )
})

test_that("superassignment errors on rank mismatches", {
  fn <- function(A) {
    declare(type(A = double(m, n)))
    f <- function() {
      A[1, 2, 3] <<- 0
      NULL
    }
    f()
    A
  }
  expect_error(
    quick(fn),
    "number of args to x\\[\\.\\.\\.\\] must match the rank of x",
    fixed = FALSE
  )
})

test_that("local closure calls can be used for side effects", {
  fn <- function(x) {
    declare(type(x = double(n)))
    f <- function(i) {
      x[i] <- x[i] + 1
      NULL
    }
    f(1L)
    x
  }

  x <- as.double(1:3)
  qfn <- quick(fn)
  expect_identical(qfn(x), x)
})

test_that("local subset assignment supports logical subscripts", {
  fn <- function(A) {
    declare(type(A = double(m, n)))
    A[c(TRUE, FALSE), ] <- A[c(TRUE, FALSE), ]
    A
  }

  A <- matrix(as.double(1:6), nrow = 2)
  expect_quick_identical(fn, list(A))
})

test_that("r2f debug mode compiles successfully", {
  fn <- function(x) {
    declare(type(x = double(n)))
    x + 1
  }
  withr::local_options(list(quickr.r2f.debug = TRUE))
  qfn <- quick(fn)
  expect_equal(qfn(as.double(1:3)), as.double(2:4))
})

test_that("referencing undeclared arguments errors with helpful message", {
  fn <- function(x) {
    y <- x + 1
    y
  }

  expect_error(
    quick(fn),
    "arg not declared",
    fixed = TRUE
  )
})

test_that("quick() runs when DEVTOOLS_LOAD is set and pkgload is available", {
  fn <- function(x) {
    declare(type(x = double(1)))
    x + 1
  }

  withr::local_envvar(c(DEVTOOLS_LOAD = "quickr"))
  qfn <- quick(fn)
  expect_identical(qfn(1), 2.0)
})

test_that("unary intrinsic handlers run for complex inputs", {
  fn <- function(z) {
    declare(type(z = complex(n)))
    Arg(Conj(z)) + Mod(z)
  }

  z <- complex(real = c(1, -2, 0.5), imaginary = c(0.5, -1, 2))
  qfn <- quick(fn)
  expect_equal(qfn(z), Arg(Conj(z)) + Mod(z))
})

test_that("cbind casts logical to integer when integer inputs are present", {
  fn <- function(x, y) {
    declare(type(x = integer(n)), type(y = logical(n)))
    cbind(x, y)
  }

  x <- 1:3
  y <- c(TRUE, FALSE, TRUE)
  qfn <- quick(fn)
  actual <- qfn(x, y)
  expected <- cbind(x, y)
  dimnames(actual) <- NULL
  dimnames(expected) <- NULL
  expect_identical(actual, expected)
})

test_that("local closure optional args initialize before use", {
  fn <- function(x) {
    declare(type(x = double(n)))
    f <- function(i, shift = NULL) {
      if (is.null(shift)) {
        shift <- 1.5
      }
      x[i] + shift
    }
    f(1L)
  }

  set.seed(10)
  x <- runif(6)
  expect_quick_equal(fn, list(x))
})

test_that("local closure optional args error when used without init", {
  bad <- function(x) {
    declare(type(x = double(n)))
    f <- function(i, shift = NULL) {
      if (!is.null(shift)) {
        shift <- shift + 1
      }
      x[i] + shift
    }
    f(1L)
  }

  expect_error(
    quick(bad),
    "optional argument\\(s\\) used without initializing",
    fixed = FALSE
  )
})

test_that("local closure call assignment handles target reads", {
  fn <- function(x) {
    declare(type(x = double(n)), type(out = double(1)))
    f <- function(i, add = NULL) {
      if (is.null(add)) {
        add <- 0
      }
      x[i] + add
    }
    out <- 0
    out <- f(1L, out)
    out
  }

  set.seed(11)
  x <- runif(4)
  qfn <- quick(fn)
  expect_equal(qfn(x), fn(x))
})

test_that("sapply assignment supports simplify = TRUE and output reuse", {
  fn <- function(x) {
    declare(type(x = double(n)), type(out = double(n)))
    out <- x
    out <- sapply(((seq_along(x))), function(i) out[i] + x[i], simplify = TRUE)
    out
  }

  set.seed(12)
  x <- runif(5)
  expect_quick_equal(fn, list(x))
})

test_that("sapply over matrix values uses linear indexing", {
  fn <- function(A) {
    declare(type(A = double(m, n)))
    out <- sapply(A, function(v) v * 2)
    out
  }

  set.seed(13)
  A <- matrix(runif(6), nrow = 2)
  expect_quick_equal(fn, list(A))
})

test_that("svd supports $u and $v directly", {
  fn_u <- function(x) {
    declare(type(x = double(3, 2)))
    svd(x)$u
  }
  fn_v <- function(x) {
    declare(type(x = double(3, 2)))
    svd(x)$v
  }

  x <- matrix(c(3, 0, 0, 0, 2, 0), nrow = 3)
  qfn_u <- quick(fn_u)
  qfn_v <- quick(fn_v)
  expect_equal(qfn_u(x), svd(x)$u, tolerance = 1e-12)
  expect_equal(qfn_v(x), svd(x)$v, tolerance = 1e-12)
})

test_that("quick errors when DEVTOOLS_LOAD is set without pkgload", {
  fn <- function(x) {
    declare(type(x = double(1)))
    x + 1
  }

  withr::local_envvar(DEVTOOLS_LOAD = "quickr")
  expect_error(
    testthat::with_mocked_bindings(
      quick(fn),
      requireNamespace = function(...) FALSE,
      .package = "base"
    ),
    "Please install 'pkgload'",
    fixed = TRUE
  )
})

test_that("unary intrinsics exercise handler registration paths", {
  fn <- function(x) {
    declare(type(x = double(n)))
    sin(x) + cos(x)
  }

  x <- c(0, 0.5, 1)
  expect_quick_equal(fn, list(x))
})

test_that("cbind rejects complex mixed with real", {
  fn <- function(x, y) {
    declare(type(x = complex(n)), type(y = double(n)))
    cbind(x, y)
  }

  expect_error(
    quick(fn),
    "mixing complex with other types",
    fixed = TRUE
  )
})

test_that("cbind errors on unsupported coercion to logical", {
  fn <- function(x, y) {
    declare(type(x = raw(n)), type(y = logical(n)))
    cbind(x, y)
  }

  expect_error(
    quick(fn),
    "does not support coercion",
    fixed = TRUE
  )
})

test_that("cbind combines symbolic column sizes", {
  fn <- function(x, y, n, m) {
    declare(
      type(n = integer(1)),
      type(m = integer(1)),
      type(x = double(n, 2L)),
      type(y = double(n, m))
    )
    cbind(x, y)
  }

  x <- matrix(1, nrow = 3, ncol = 2)
  y <- matrix(2, nrow = 3, ncol = 4)
  out <- quick(fn)(x, y, 3L, 4L)
  expect_identical(dim(out), c(3L, 6L))
})

test_that("cbind requires common row counts", {
  fn <- function(x, y) {
    declare(type(x = double(2L, 2L)), type(y = double(3L, 1L)))
    cbind(x, y)
  }

  expect_error(
    quick(fn),
    "requires inputs with a common row count",
    fixed = TRUE
  )
})

test_that("svd rejects unsupported field access", {
  fn <- function(x) {
    declare(type(x = double(3L, 2L)))
    svd(x)$foo
  }

  x <- matrix(c(3, 0, 0, 0, 2, 0), nrow = 3)
  expect_error(
    quick(fn)(x),
    "`$` only supports `.Machine$double.eps` and `svd()` results ($d, $u, $v)",
    fixed = TRUE
  )
})

test_that("svd returns a named list", {
  fn <- function(x) {
    declare(type(x = double(3L, 2L)))
    s <- svd(x)
    s
  }

  x <- matrix(c(3, 0, 0, 0, 2, 0), nrow = 3)
  out <- quick(fn)(x)
  expect_named(out, c("d", "u", "v"))
  expect_equal(out$d, svd(x)$d)
  recon <- out$u %*% diag(out$d, nrow = length(out$d)) %*% t(out$v)
  expect_equal(recon, x, tolerance = 1e-8)
})

skip_on_cran()

test_that("matrix multiplication matches R for common shapes", {
  mat_mat <- function(mat_A, mat_B) {
    declare(
      type(mat_A = double(4, 3)),
      type(mat_B = double(3, 5))
    )
    mat_A %*% mat_B
  }

  mat_mat_square <- function(mat_A, mat_B) {
    declare(
      type(mat_A = double(3, 3)),
      type(mat_B = double(3, 3))
    )
    mat_A %*% mat_B
  }

  vec_mat <- function(vec, mat_A) {
    declare(
      type(vec = double(3)),
      type(mat_A = double(3, 4))
    )
    vec %*% mat_A
  }

  mat_vec <- function(mat_A, vec) {
    declare(
      type(mat_A = double(3, 4)),
      type(vec = double(4))
    )
    mat_A %*% vec
  }

  vec_vec <- function(vec_A, vec_B) {
    declare(
      type(vec_A = double(3)),
      type(vec_B = double(3))
    )
    vec_A %*% vec_B
  }

  set.seed(1)
  mat_A <- matrix(rnorm(4 * 3), nrow = 4)
  mat_B <- matrix(rnorm(3 * 5), nrow = 3)
  mat_sq_A <- matrix(rnorm(3 * 3), nrow = 3)
  mat_sq_B <- matrix(rnorm(3 * 3), nrow = 3)
  vec_3 <- rnorm(3)
  mat_3x4 <- matrix(rnorm(3 * 4), nrow = 3)
  vec_4 <- rnorm(4)

  expect_quick_equal(mat_mat, list(mat_A = mat_A, mat_B = mat_B))
  expect_quick_equal(
    mat_mat_square,
    list(mat_A = mat_sq_A, mat_B = mat_sq_B)
  )
  expect_quick_equal(vec_mat, list(vec = vec_3, mat_A = mat_3x4))
  expect_quick_equal(mat_vec, list(mat_A = mat_3x4, vec = vec_4))
  expect_quick_equal(vec_vec, list(vec_A = vec_3, vec_B = vec_3))
})

test_that("matrix multiplication handles transposed operands", {
  matmul_t_left <- function(x, y) {
    declare(
      type(x = double(4, 3)),
      type(y = double(4, 5))
    )
    t(x) %*% y
  }

  matmul_t_right <- function(x, y) {
    declare(
      type(x = double(4, 3)),
      type(y = double(5, 3))
    )
    x %*% t(y)
  }

  matmul_t_both <- function(x, y) {
    declare(
      type(x = double(4, 3)),
      type(y = double(5, 4))
    )
    t(x) %*% t(y)
  }

  set.seed(4)
  x <- matrix(rnorm(4 * 3), nrow = 4)
  y_left <- matrix(rnorm(4 * 5), nrow = 4)
  y_right <- matrix(rnorm(5 * 3), nrow = 5)
  y_both <- matrix(rnorm(5 * 4), nrow = 5)

  expect_quick_equal(matmul_t_left, list(x = x, y = y_left))
  expect_quick_equal(matmul_t_right, list(x = x, y = y_right))
  expect_quick_equal(matmul_t_both, list(x = x, y = y_both))
})

test_that("matrix multiplication handles chained mixes", {
  chain_mix <- function(a, b, c) {
    declare(
      type(a = double(4, 3)),
      type(b = double(5, 3)),
      type(c = double(5, 5))
    )
    (a %*% t(b)) %*% c + 0.25 * (a %*% t(b))
  }

  set.seed(7)
  a <- matrix(rnorm(4 * 3), nrow = 4)
  b <- matrix(rnorm(5 * 3), nrow = 5)
  c <- matrix(rnorm(5 * 5), nrow = 5)

  expect_quick_equal(chain_mix, list(a = a, b = b, c = c))
})

test_that("matrix multiplication handles 1x1 and 1xN/Nx1 shapes", {
  mat_mat_1x1 <- function(a, b) {
    declare(
      type(a = double(1, 1)),
      type(b = double(1, 1))
    )
    a %*% b
  }

  mat_row_col <- function(row, col) {
    declare(
      type(row = double(1, 4)),
      type(col = double(4, 1))
    )
    row %*% col
  }

  mat_col_row <- function(col, row) {
    declare(
      type(col = double(4, 1)),
      type(row = double(1, 4))
    )
    col %*% row
  }

  set.seed(5)
  a <- matrix(rnorm(1), nrow = 1)
  b <- matrix(rnorm(1), nrow = 1)
  row <- matrix(rnorm(4), nrow = 1)
  col <- matrix(rnorm(4), nrow = 4)

  expect_quick_equal(mat_mat_1x1, list(a = a, b = b))
  expect_quick_equal(mat_row_col, list(row = row, col = col))
  expect_quick_equal(mat_col_row, list(col = col, row = row))
})

test_that("matrix multiplication handles t(vec) orientation", {
  tvec_mat <- function(vec, mat_A) {
    declare(
      type(vec = double(3)),
      type(mat_A = double(3, 4))
    )
    t(vec) %*% mat_A
  }

  mat_tvec <- function(mat_A, vec) {
    declare(
      type(mat_A = double(4, 1)),
      type(vec = double(4))
    )
    mat_A %*% t(vec)
  }

  set.seed(6)
  vec <- rnorm(3)
  mat_A <- matrix(rnorm(3 * 4), nrow = 3)
  vec_long <- rnorm(4)
  mat_B <- matrix(rnorm(4), nrow = 4)

  expect_quick_equal(tvec_mat, list(vec = vec, mat_A = mat_A))
  expect_quick_equal(mat_tvec, list(mat_A = mat_B, vec = vec_long))
})

test_that("matrix multiplication handles transposed matrix in vector cases", {
  vec_tmat <- function(vec, mat_A) {
    declare(
      type(vec = double(3)),
      type(mat_A = double(4, 3))
    )
    vec %*% t(mat_A)
  }

  tmat_vec <- function(mat_A, vec) {
    declare(
      type(mat_A = double(4, 3)),
      type(vec = double(4))
    )
    t(mat_A) %*% vec
  }

  set.seed(15)
  vec_3 <- rnorm(3)
  mat_4x3 <- matrix(rnorm(12), nrow = 4)
  vec_4 <- rnorm(4)

  expect_quick_equal(vec_tmat, list(vec = vec_3, mat_A = mat_4x3))
  expect_quick_equal(tmat_vec, list(mat_A = mat_4x3, vec = vec_4))
})

test_that("matrix multiplication errors on non-conformable arguments", {
  matmul_bad <- function(x, y) {
    declare(
      type(x = double(2, 3)),
      type(y = double(2, 4))
    )
    x %*% y
  }

  x <- matrix(rnorm(2 * 3), nrow = 2)
  y <- matrix(rnorm(2 * 4), nrow = 2)

  expect_error(matmul_bad(x, y), "non-conformable")
  expect_error(quick(matmul_bad), "non-conformable arguments in %*%")
})

test_that("matrix multiplication rejects incompatible destinations", {
  dest_mismatch <- function() {
    declare(type(x = double(2)))
    a <- matrix(1.5, 2L, 2L)
    x <- a %*% a
    x
  }

  expect_error(quick(dest_mismatch), "incompatible rank for %\\*%")
})

test_that("BLAS matrix ops coerce integer and logical inputs to double", {
  matmul_int <- function(A, B) {
    declare(type(A = integer(2, 2)), type(B = integer(2, 2)))
    A %*% B
  }

  crossprod_int <- function(x) {
    declare(type(x = integer(3, 2)))
    crossprod(x)
  }

  outer_int <- function(x, y) {
    declare(type(x = integer(2)), type(y = integer(3)))
    outer(x, y)
  }

  matmul_lgl <- function(A, B) {
    declare(type(A = logical(2, 2)), type(B = logical(2, 2)))
    A %*% B
  }

  A <- matrix(as.integer(c(1, 2, 3, 4)), nrow = 2)
  B <- matrix(as.integer(c(2, 0, 1, -1)), nrow = 2)
  x <- matrix(as.integer(1:6), nrow = 3)
  v2 <- as.integer(c(1, -2))
  v3 <- as.integer(c(3, 0, 4))

  set.seed(123)
  A_lgl <- matrix(sample(c(TRUE, FALSE), 4, TRUE), nrow = 2)
  B_lgl <- matrix(sample(c(TRUE, FALSE), 4, TRUE), nrow = 2)

  expect_quick_equal(matmul_int, list(A = A, B = B))
  expect_quick_equal(crossprod_int, list(x = x))
  expect_quick_equal(outer_int, list(x = v2, y = v3))
  expect_quick_equal(matmul_lgl, list(A = A_lgl, B = B_lgl))
})

test_that("matrix multiplication avoids unsafe in-place aliasing", {
  fn <- function(A, B) {
    declare(type(A = double(2, 2)), type(B = double(2, 2)))
    A <- (A) %*% B
    A
  }

  set.seed(42)
  A0 <- matrix(rnorm(4), nrow = 2)
  B <- matrix(rnorm(4), nrow = 2)

  qfn <- quick(fn)
  A_orig <- A0 + 0
  out <- qfn(A0, B)

  expect_identical(A0, A_orig)
  expect_equal(out, fn(A_orig, B))
})

test_that("matrix multiplication handles expression inputs without mutating sources", {
  fn <- function(A, B) {
    declare(type(A = double(2, 2)), type(B = double(2, 2)))
    A <- (A + 1) %*% B
    A
  }

  set.seed(101)
  A0 <- matrix(rnorm(4), nrow = 2)
  B <- matrix(rnorm(4), nrow = 2)

  qfn <- quick(fn)
  A_orig <- A0 + 0
  out <- qfn(A0, B)

  expect_identical(A0, A_orig)
  expect_equal(out, fn(A_orig, B))
})

test_that("crossprod handles parenthesized inputs without aliasing", {
  fn <- function(A) {
    declare(type(A = double(2, 2)))
    A <- crossprod(((A)))
    A
  }

  set.seed(202)
  A0 <- matrix(rnorm(4), nrow = 2)

  qfn <- quick(fn)
  A_orig <- A0 + 0
  out <- qfn(A0)

  expect_identical(A0, A_orig)
  expect_equal(out, fn(A_orig))
})

test_that("triangular solves can write into the RHS variable safely", {
  fn <- function(U, b) {
    declare(type(U = double(2, 2)), type(b = double(2)))
    b <- backsolve(U, b)
    b
  }

  U <- matrix(c(2, 1, 0, 3), nrow = 2, byrow = TRUE)
  b0 <- c(1.25, -0.5)

  qfn <- quick(fn)
  b_orig <- b0 + 0
  out <- qfn(U, b0)

  expect_identical(b0, b_orig)
  expect_equal(out, fn(U, b_orig))
})

test_that("triangular solves accept parenthesized RHS safely", {
  fn <- function(U, b) {
    declare(type(U = double(2, 2)), type(b = double(2)))
    b <- backsolve(U, (b))
    b
  }

  U <- matrix(c(2, 1, 0, 3), nrow = 2, byrow = TRUE)
  b0 <- c(1.25, -0.5)

  qfn <- quick(fn)
  b_orig <- b0 + 0
  out <- qfn(U, b0)

  expect_identical(b0, b_orig)
  expect_equal(out, fn(U, b_orig))
})

test_that("crossprod and tcrossprod match R", {
  cross_fun <- function(x, y) {
    declare(
      type(x = double(6, 4)),
      type(y = double(6, 4))
    )
    crossprod(x, y)
  }

  tcross_fun <- function(x, y) {
    declare(
      type(x = double(6, 4)),
      type(y = double(6, 4))
    )
    tcrossprod(x, y)
  }

  set.seed(2)
  x <- matrix(rnorm(6 * 4), nrow = 6)
  y <- matrix(rnorm(6 * 4), nrow = 6)

  expect_quick_equal(cross_fun, list(x = x, y = y))
  expect_quick_equal(tcross_fun, list(x = x, y = y))
})

test_that("single-argument crossprod/tcrossprod match R", {
  cross_single <- function(x) {
    declare(type(x = double(5, 4)))
    crossprod(x)
  }

  tcross_single <- function(x) {
    declare(type(x = double(5, 4)))
    tcrossprod(x)
  }

  cross_vec <- function(x) {
    declare(type(x = double(5)))
    crossprod(x)
  }

  tcross_vec <- function(x) {
    declare(type(x = double(5)))
    tcrossprod(x)
  }

  set.seed(3)
  x <- matrix(rnorm(5 * 4), nrow = 5)
  v <- rnorm(5)

  expect_quick_equal(cross_single, list(x = x))
  expect_quick_equal(tcross_single, list(x = x))
  expect_quick_equal(cross_vec, list(x = v))
  expect_quick_equal(tcross_vec, list(x = v))
})

test_that("crossprod and tcrossprod handle vector inputs", {
  cross_vec_mat <- function(x, y) {
    declare(
      type(x = double(4)),
      type(y = double(4, 3))
    )
    crossprod(x, y)
  }

  cross_vec_vec <- function(x, y) {
    declare(
      type(x = double(4)),
      type(y = double(4))
    )
    crossprod(x, y)
  }

  tcross_vec_vec <- function(x, y) {
    declare(
      type(x = double(4)),
      type(y = double(5))
    )
    tcrossprod(x, y)
  }

  set.seed(13)
  x <- rnorm(4)
  y_cross <- matrix(rnorm(12), nrow = 4)
  y_vec <- rnorm(4)
  y_vec_long <- rnorm(5)

  expect_quick_equal(cross_vec_mat, list(x = x, y = y_cross))
  expect_quick_equal(cross_vec_vec, list(x = x, y = y_vec))
  expect_quick_equal(tcross_vec_vec, list(x = x, y = y_vec_long))
})

test_that("crossprod rejects incompatible destination dimensions", {
  crossprod_bad_dest <- function(x) {
    declare(type(x = double(4, 3)), type(out = double(2, 2)))
    out <- crossprod(x)
    out
  }

  expect_error(
    quick(crossprod_bad_dest),
    "assignment target has incompatible dimensions"
  )
})

test_that("outer supports multiplication and %o%", {
  outer_default <- function(x, y) {
    declare(
      type(x = double(3)),
      type(y = double(4))
    )
    outer(x, y)
  }

  outer_mul <- function(x, y) {
    declare(
      type(x = double(3)),
      type(y = double(4))
    )
    outer(x, y, "*")
  }

  outer_op <- function(x, y) {
    declare(
      type(x = double(3)),
      type(y = double(4))
    )
    x %o% y
  }

  set.seed(10)
  x <- rnorm(3)
  y <- rnorm(4)

  expect_quick_equal(outer_default, list(x = x, y = y))
  expect_quick_equal(outer_mul, list(x = x, y = y))
  expect_quick_equal(outer_op, list(x = x, y = y))
})

test_that("outer supports scalar inputs", {
  outer_scalar <- function(x, y) {
    declare(
      type(x = double(NA)),
      type(y = double(3))
    )
    out <- outer(x, y)
    out
  }

  outer_scalar_op <- function(x, y) {
    declare(
      type(x = double(3)),
      type(y = double(NA))
    )
    out <- x %o% y
    out
  }

  set.seed(16)
  x <- 1.25
  y <- rnorm(3)
  x_vec <- rnorm(3)
  y_scalar <- -0.5

  expect_quick_equal(outer_scalar, list(x = x, y = y))
  expect_quick_equal(outer_scalar_op, list(x = x_vec, y = y_scalar))
})

test_that("blas operations support preallocated outputs", {
  matmul_out <- function(A, B) {
    declare(
      type(A = double(2, 3)),
      type(B = double(3, 2)),
      type(out = double(2, 2))
    )
    out <- A %*% B
    out
  }

  crossprod_out <- function(x) {
    declare(
      type(x = double(4, 3)),
      type(out = double(3, 3))
    )
    out <- crossprod(x)
    out
  }

  outer_out <- function(x, y) {
    declare(
      type(x = double(2)),
      type(y = double(3)),
      type(out = double(2, 3))
    )
    out <- outer(x, y)
    out
  }

  set.seed(12)
  A <- matrix(rnorm(2 * 3), nrow = 2)
  B <- matrix(rnorm(3 * 2), nrow = 3)
  X <- matrix(rnorm(4 * 3), nrow = 4)
  x <- rnorm(2)
  y <- rnorm(3)

  expect_quick_equal(matmul_out, list(A = A, B = B))
  expect_quick_equal(crossprod_out, list(x = X))
  expect_quick_equal(outer_out, list(x = x, y = y))
})

test_that("matrix multiplication temporaries can be indexed directly", {
  fn <- function(A, x) {
    declare(
      type(A = double(n, k)),
      type(x = double(k))
    )
    (A %*% x)[, 1]
  }

  set.seed(42)
  A <- matrix(rnorm(12), nrow = 3)
  x <- rnorm(ncol(A))
  expect_quick_equal(fn, list(A = A, x = x))
})

test_that("outer errors on unsupported FUN", {
  outer_add <- function(x, y) {
    declare(
      type(x = double(3)),
      type(y = double(4))
    )
    outer(x, y, "+")
  }

  set.seed(1)
  x <- rnorm(3)
  y <- rnorm(4)

  expect_error(quick(outer_add), "outer\\(\\) only supports FUN = \"\\*\"")
})

test_that("forwardsolve and backsolve match R", {
  forward_vec <- function(L, b) {
    declare(
      type(L = double(4, 4)),
      type(b = double(4))
    )
    forwardsolve(L, b)
  }

  forward_mat <- function(L, b) {
    declare(
      type(L = double(4, 4)),
      type(b = double(4, 2))
    )
    forwardsolve(L, b)
  }

  back_vec <- function(U, b) {
    declare(
      type(U = double(4, 4)),
      type(b = double(4))
    )
    backsolve(U, b)
  }

  back_mat <- function(U, b) {
    declare(
      type(U = double(4, 4)),
      type(b = double(4, 2))
    )
    backsolve(U, b)
  }

  back_transpose <- function(U, b) {
    declare(
      type(U = double(4, 4)),
      type(b = double(4))
    )
    backsolve(U, b, transpose = TRUE)
  }

  forward_upper <- function(U, b) {
    declare(
      type(U = double(4, 4)),
      type(b = double(4))
    )
    forwardsolve(U, b, upper.tri = TRUE)
  }

  forward_transpose <- function(L, b) {
    declare(
      type(L = double(4, 4)),
      type(b = double(4))
    )
    forwardsolve(L, b, transpose = TRUE)
  }

  back_lower <- function(L, b) {
    declare(
      type(L = double(4, 4)),
      type(b = double(4))
    )
    backsolve(L, b, upper.tri = FALSE)
  }

  set.seed(11)
  base <- matrix(rnorm(16), nrow = 4)
  L <- base
  L[upper.tri(L)] <- 0
  diag(L) <- diag(L) + 5
  U <- base
  U[lower.tri(U)] <- 0
  diag(U) <- diag(U) + 5
  b_vec <- rnorm(4)
  b_mat <- matrix(rnorm(8), nrow = 4)

  expect_quick_equal(forward_vec, list(L = L, b = b_vec))
  expect_quick_equal(forward_mat, list(L = L, b = b_mat))
  expect_quick_equal(back_vec, list(U = U, b = b_vec))
  expect_quick_equal(back_mat, list(U = U, b = b_mat))
  expect_quick_equal(back_transpose, list(U = U, b = b_vec))
  expect_quick_equal(forward_upper, list(U = U, b = b_vec))
  expect_quick_equal(forward_transpose, list(L = L, b = b_vec))
  expect_quick_equal(back_lower, list(L = L, b = b_vec))
})

# Unit tests for `for (... in <iterable>)` lowering

skip_on_cran()

test_that("for() supports parenthesized iterables", {
  sum_i <- function(n) {
    declare(type(n = integer(1)))
    s <- 0L
    for (i in (1:n)) {
      s <- s + i
    }
    s
  }

  sum_seq_len <- function(n) {
    declare(type(n = integer(1)))
    s <- 0L
    for (i in (seq_len(n))) {
      s <- s + i
    }
    s
  }

  sum_seq_along <- function(x) {
    declare(type(x = double(NA)))
    s <- 0L
    for (i in (seq_along(x))) {
      s <- s + i
    }
    s
  }

  expect_quick_identical(sum_i, -1L, 0L, 1L, 5L)
  expect_quick_identical(sum_seq_len, 0L, 1L, 5L)
  expect_quick_identical(sum_seq_along, numeric(), c(1, 2, 3))
})

test_that("seq_along() works for scalars", {
  fn <- function(x) {
    declare(type(x = double(1)))
    s <- 0L
    for (i in seq_along(x)) {
      s <- s + i
    }
    s
  }

  expect_quick_identical(fn, 0, 1, -3)
})

test_that("for() supports scalar indexing in singleton iterables", {
  seq_len_scalar <- function(x) {
    declare(type(x = double(1)))
    for (i in seq_len(1L)) {
      x[i] <- x[i] + 1.5
    }
    x
  }

  colon_scalar <- function(x) {
    declare(type(x = double(1)))
    for (i in 1:1) {
      x[i] <- x[i] + 2.0
    }
    x
  }

  expect_quick_identical(seq_len_scalar, 0, 1, -2.5)
  expect_quick_identical(colon_scalar, 0, 1, -2.5)
})

test_that("for() supports seq() direction and step", {
  digits_from_seq <- function(a, b) {
    declare(type(a = integer(1)), type(b = integer(1)))
    out <- 0L
    for (i in seq(a, b)) {
      out <- out * 10L + i
    }
    out
  }

  sum_by_2 <- function(n) {
    declare(type(n = integer(1)))
    s <- 0L
    for (i in seq(1L, n, by = 2L)) {
      s <- s + i
    }
    s
  }

  expect_quick_identical(digits_from_seq, list(3L, 1L), list(1L, 3L))
  expect_quick_identical(sum_by_2, 1L, 5L, 6L)
})

test_that("for() iterable errors are clear", {
  unsupported_iterable <- function() {
    s <- 0L
    for (i in rev(list(1L, 2L))) {
      s <- s + i
    }
    s
  }

  non_integer_seq <- function() {
    s <- 0L
    for (i in seq(1, 2, by = 0.5)) {
      s <- s + i
    }
    s
  }

  non_integer_seq_len <- function() {
    s <- 0L
    for (i in seq_len(2.5)) {
      s <- s + i
    }
    s
  }

  literal_iterable <- function() {
    s <- 0L
    for (i in 1L) {
      s <- s + i
    }
    s
  }

  expect_error(
    quick(unsupported_iterable),
    regexp = "unsupported iterable in for\\(\\): rev\\(list\\("
  )
  expect_error(
    quick(non_integer_seq),
    regexp = "non-integer seq\\(\\)'s not implemented yet"
  )
  expect_error(
    quick(non_integer_seq_len),
    regexp = "seq_len\\(\\) expects an integer scalar"
  )
  expect_error(
    quick(literal_iterable),
    regexp = "unsupported iterable in for\\(\\): 1"
  )
})

test_that("for() supports rev() on index iterables", {
  rev_colon <- function(n) {
    declare(type(n = integer(1)))
    out <- 0L
    for (i in rev(1:n)) {
      out <- out * 10L + i
    }
    out
  }

  rev_seq <- function() {
    out <- 0L
    for (i in rev(seq(1L, 6L, by = 2L))) {
      out <- out * 10L + i
    }
    out
  }

  rev_seq_len <- function(n) {
    declare(type(n = integer(1)))
    out <- 0L
    for (i in rev(seq_len(n))) {
      out <- out * 10L + i
    }
    out
  }

  rev_seq_along <- function(x) {
    declare(type(x = double(NA)))
    out <- 0L
    for (i in rev(seq_along(x))) {
      out <- out * 10L + i
    }
    out
  }

  expect_quick_identical(rev_colon, 0L, 1L, 3L, 5L)
  expect_quick_identical(rev_seq, list())
  expect_quick_identical(rev_seq_len, 0L, 1L, 5L)
  expect_quick_identical(rev_seq_along, numeric(), c(1, 2, 3))
})

test_that("for() rev(seq()) validates scalar bounds and step", {
  non_scalar_bounds <- function(x) {
    declare(type(x = integer(NA)))
    s <- 0L
    for (i in rev(seq(1L, x))) {
      s <- s + i
    }
    s
  }

  non_scalar_step <- function(x) {
    declare(type(x = integer(NA)))
    s <- 0L
    for (i in rev(seq(1L, 5L, by = x))) {
      s <- s + i
    }
    s
  }

  expect_error(
    quick(non_scalar_bounds),
    regexp = "seq\\(\\) iterable bounds must be scalars"
  )
  expect_error(
    quick(non_scalar_step),
    regexp = "seq\\(\\) iterable step must be a scalar"
  )
})

test_that("for() supports iterating over a symbol (value iteration)", {
  sum_values <- function(x) {
    declare(type(x = double(NA)))
    s <- 0
    for (v in x) {
      s <- s + v
    }
    s
  }

  count_true <- function(x) {
    declare(type(x = logical(NA)))
    n <- 0L
    for (v in x) {
      if (v) n <- n + 1L
    }
    n
  }

  linearize_matrix <- function(m) {
    declare(type(m = integer(NA, NA)))
    out <- integer(length(m))
    j <- 1L
    for (v in m) {
      out[j] <- v
      j <- j + 1L
    }
    out
  }

  iterable_hoisted <- function(x) {
    declare(type(x = integer(NA)))
    y <- x
    out <- 0L
    for (v in y) {
      out <- out * 10L + v
      y[length(y)] <- 9L
    }
    out
  }

  expect_quick_identical(sum_values, numeric(), c(1, 2, 3))
  expect_quick_identical(
    count_true,
    logical(),
    c(TRUE, FALSE, TRUE),
    c(FALSE, FALSE)
  )
  expect_quick_identical(linearize_matrix, matrix(1:6, nrow = 2))
  expect_quick_identical(iterable_hoisted, 1:3, c(1L, 2L, 3L, 4L))
})

test_that("for() supports rev() for value iteration", {
  rev_values <- function(x) {
    declare(type(x = integer(NA)))
    out <- 0L
    for (v in rev(x)) {
      out <- out * 10L + v
    }
    out
  }

  rev_matrix_values <- function(m) {
    declare(type(m = integer(NA, NA)))
    out <- 0L
    for (v in rev(m)) {
      out <- out * 10L + v
    }
    out
  }

  expect_quick_identical(rev_values, 1:3, c(1L, 2L, 3L, 4L))
  expect_quick_identical(rev_matrix_values, matrix(1:6, nrow = 2))
})

# Public API tests for abs() support in declared size expressions

skip_on_cran()

test_that("declare() size expressions support abs()", {
  fn <- function(start, end) {
    declare(
      type(start = integer(1)),
      type(end = integer(1)),
      type(out = double(abs(end - start) + 1L))
    )
    out <- double(abs(end - start) + 1L)
    for (i in seq_len(length(out))) {
      out[i] <- as.double(i)
    }
    out
  }

  qfn <- quick(fn)
  expect_identical(qfn(1L, 1L), 1.0)
  expect_identical(qfn(2L, 5L), as.double(1:4))
  expect_identical(qfn(5L, 2L), as.double(1:4))
})

test_that("declare() size expressions validate abs() arity", {
  bad <- function(n, m) {
    declare(
      type(n = integer(1)),
      type(m = integer(1)),
      type(out = double(abs(n, m)))
    )
    out <- double(1L)
    out
  }

  expect_error(quick(bad), "unused argument", fixed = TRUE)
})

# Unit tests for indexing external logical arrays (passed from R as logical,
# represented as 0/1 integer storage inside the generated Fortran interface).

skip_on_cran()

test_that("scalar logical indexing works in ifelse()", {
  fn <- function(pred) {
    declare(type(pred = logical(3, 4)))
    out <- double(1)
    out[1] <- ifelse(pred[2, 3], 1.0, 0.0)
    out
  }

  expect_translation_snapshots(
    fn,
    note = "Regression: indexing external logical arrays must compile (no invalid subscripting of booleanized expressions)."
  )

  set.seed(1)
  pred <- matrix(sample(c(TRUE, FALSE), 12, TRUE), 3, 4)
  expect_quick_identical(fn, list(pred))
})

test_that("indexing a logical expression works (comparison)", {
  fn <- function(x) {
    declare(type(x = double(3, 4)))
    out <- double(1)
    out[1] <- ifelse(((((x > 0.0))))[2, 3], 1.0, 0.0)
    out
  }

  expect_translation_snapshots(
    fn,
    note = "Ensures indexing a logical expression compiles by hoisting the array expression to a temporary before subscripting (no invalid (expr)(i,j))."
  )

  set.seed(1)
  x <- matrix(runif(12, -1, 1), 3, 4)
  expect_quick_identical(fn, list(x))
})

test_that("indexing a logical expression works (boolean ops)", {
  fn <- function(x) {
    declare(type(x = double(3, 4)))
    out <- double(1)
    out[1] <- ifelse(((((x > 0.0) & (x < 0.5))))[2, 3], 1.0, 0.0)
    out
  }

  expect_translation_snapshots(
    fn,
    note = "Ensures indexing a boolean expression compiles by hoisting to a temporary before subscripting (no invalid (expr)(i,j))."
  )

  set.seed(1)
  x <- matrix(runif(12, -1, 1), 3, 4)
  expect_quick_identical(fn, list(x))
})

test_that("scalar logical indexing works in if() with nested boolean logic", {
  fn <- function(x, pred) {
    declare(type(x = double(3, 4)), type(pred = logical(3, 4)))
    out <- double(1)
    out[1] <- 0.0

    # exercise multiple reads of pred[i, j] inside a larger condition
    if ((pred[2, 3] && (x[2, 3] > 0.0)) || (!pred[2, 3] && (x[2, 3] < 0.0))) {
      out[1] <- x[2, 3] + 1.0
    } else {
      out[1] <- x[2, 3] - 1.0
    }

    out
  }

  set.seed(1)
  x <- matrix(runif(12, -1, 1), 3, 4)
  pred <- matrix(sample(c(TRUE, FALSE), 12, TRUE), 3, 4)
  expect_quick_identical(fn, list(x, pred))
})

test_that("slice logical indexing works in nested ifelse() expressions", {
  fn <- function(x, pred) {
    declare(type(x = double(3, 4)), type(pred = logical(3, 4)))
    out <- double(4)

    # vector mask + nested ifelse -> merge(merge(...), merge(...), mask)
    out <- ifelse(
      pred[2, ],
      ifelse(x[2, ] > 0.0, x[2, ] + 1.0, x[2, ] + 2.0),
      ifelse(x[2, ] < 0.0, x[2, ] - 1.0, x[2, ] - 2.0)
    )

    out
  }

  set.seed(1)
  x <- matrix(runif(12, -1, 1), 3, 4)
  pred <- matrix(sample(c(TRUE, FALSE), 12, TRUE), 3, 4)
  expect_quick_identical(fn, list(x, pred))
})

test_that("logical slice indexing works for pred[, j] and pred[i, ]", {
  fn <- function(pred) {
    declare(type(pred = logical(3, 4)))
    out <- double(2)
    out[1] <- sum(ifelse(pred[, 2], 1.0, 0.0))
    out[2] <- sum(ifelse(pred[3, ], 1.0, 0.0))
    out
  }

  set.seed(1)
  pred <- matrix(sample(c(TRUE, FALSE), 12, TRUE), 3, 4)
  expect_quick_identical(fn, list(pred))
})

test_that("drop = FALSE logical indexing works and compiles in larger expressions", {
  fn <- function(x, pred) {
    declare(type(x = double(3, 4)), type(pred = logical(3, 4)))
    out <- double(1)

    # keep dims (1x1), then use it in a larger scalar expression
    out[1] <- sum(ifelse(pred[2, 3, drop = FALSE], x[2, 3, drop = FALSE], 0.0))
    out[1] <- out[1] + sum(ifelse(!pred[2, 3, drop = FALSE], 1.0, 0.0))

    out
  }

  set.seed(1)
  x <- matrix(runif(12, -1, 1), 3, 4)
  pred <- matrix(sample(c(TRUE, FALSE), 12, TRUE), 3, 4)
  expect_quick_identical(fn, list(x, pred))
})

test_that("logical indexing inside nested loops drives elementwise updates", {
  fn <- function(x, pred) {
    declare(type(x = double(3, 4)), type(pred = logical(3, 4)))
    out <- matrix(0.0, 3, 4)

    for (i in 1:3) {
      for (j in 1:4) {
        if (pred[i, j]) {
          if (x[i, j] > 0.0) {
            out[i, j] <- x[i, j] * 2.0
          } else {
            out[i, j] <- (-x[i, j]) * 3.0
          }
        } else {
          # mix in scalar logical-as-double conversion to exercise both paths
          out[i, j] <- x[i, j] + as.double(pred[i, j])
        }
      }
    }

    out
  }

  set.seed(1)
  x <- matrix(runif(12, -1, 1), 3, 4)
  pred <- matrix(sample(c(TRUE, FALSE), 12, TRUE), 3, 4)
  expect_quick_identical(fn, list(x, pred))
})

test_that("rank-3 external logical indexing works in complex reductions", {
  fn <- function(x, pred) {
    declare(type(x = double(2, 3, 4)), type(pred = logical(2, 3, 4)))
    out <- double(1)
    out[1] <- 0.0

    for (i in 1:2) {
      for (j in 1:3) {
        for (k in 1:4) {
          # more complex expression mixing arithmetic and boolean logic
          if (pred[i, j, k] && (x[i, j, k] > 0.25)) {
            out[1] <- out[1] + x[i, j, k] * 2.0
          } else if ((!pred[i, j, k]) && (x[i, j, k] < -0.25)) {
            out[1] <- out[1] - x[i, j, k] * 3.0
          } else {
            out[1] <- out[1] + (x[i, j, k] + as.double(pred[i, j, k]))
          }
        }
      }
    }

    out
  }

  set.seed(1)
  x <- array(runif(24, -1, 1), dim = c(2, 3, 4))
  pred <- array(sample(c(TRUE, FALSE), 24, TRUE), dim = c(2, 3, 4))
  expect_quick_identical(fn, list(x, pred))
})

test_that("logical indexing can be combined with other vector masks and reductions", {
  fn <- function(x, pred) {
    declare(type(x = double(3, 4)), type(pred = logical(3, 4)))
    out <- double(1)

    # build a numeric row, then reduce it; mask combines pred row with x-based mask
    out[1] <- sum(ifelse(
      pred[2, ] & (x[2, ] > 0.0),
      x[2, ] * 2.0,
      x[2, ] / 2.0
    ))
    out
  }

  set.seed(1)
  x <- matrix(runif(12, -1, 1), 3, 4)
  pred <- matrix(sample(c(TRUE, FALSE), 12, TRUE), 3, 4)
  expect_quick_identical(fn, list(x, pred))
})

test_that("external logical masks work in x[pred] (pack / masked reduction)", {
  fn <- function(x, pred) {
    declare(type(x = double(3, 4)), type(pred = logical(3, 4)))
    out <- double(1)
    out[1] <- sum(x[pred])
    out
  }

  set.seed(1)
  x <- matrix(runif(12), 3, 4)
  pred <- matrix(sample(c(TRUE, FALSE), 12, TRUE), 3, 4)
  expect_quick_identical(fn, list(x, pred))
})

test_that("logical declared inputs reject integer 0/1 arrays (strict typing)", {
  fn <- function(pred) {
    declare(type(pred = logical(3, 4)))
    out <- double(1)
    out[1] <- ifelse(pred[2, 3], 1.0, 0.0)
    out
  }

  qfn <- quick(fn)
  set.seed(1)
  pred <- matrix(sample(0:1, 12, TRUE), 3, 4)
  expect_error(qfn(pred), "typeof\\(pred\\) must be 'logical'")
})

test_that("expression indexing with logical mask avoids extra materialization", {
  fn <- function(x, y, z, a) {
    declare(
      type(x = double(3, 4)),
      type(y = double(3, 4)),
      type(z = double(3, 4)),
      type(a = double(1))
    )
    out <- double(1)
    out[1] <- sum((x + y)[z > a])
    out
  }

  expect_translation_snapshots(
    fn,
    note = "Mask subsetting should stay as a single pack-like operation (avoid pushing mask into operands and duplicating mask evaluation)."
  )

  set.seed(1)
  x <- matrix(runif(12), 3, 4)
  y <- matrix(runif(12), 3, 4)
  z <- matrix(runif(12), 3, 4)
  a <- 0.5
  expect_quick_identical(fn, list(x, y, z, a))
})

skip_on_cran()

test_that("array() supports reshaping non-scalar data", {
  fn <- function(x) {
    declare(type(x = integer(2L, 3L, 4L)))
    array(as.double(x), dim = c(2L, 3L, 4L))
  }

  set.seed(1)
  x <- array(sample(1:10, 24, replace = TRUE), dim = c(2L, 3L, 4L))
  expect_quick_identical(fn, list(x))
})

test_that("array() reshape accepts numeric dim vectors", {
  fn <- function(x) {
    declare(type(x = integer(2L, 3L, 4L)))
    array(as.double(x), dim = c(2, 3, 4))
  }

  set.seed(1)
  x <- array(sample(1:10, 24, replace = TRUE), dim = c(2L, 3L, 4L))
  expect_quick_identical(fn, list(x))
})

test_that("array() reshape accepts scalar dims", {
  fn <- function(x) {
    declare(type(x = integer(24L)))
    # Rank-1 arrays carry a `dim` attribute in base R, but quickr treats them as
    # plain vectors; wrap in `c()` so both sides compare identically while still
    # exercising the `array(dim=scalar)` lowering.
    c(array(as.double(x), dim = 24))
  }

  set.seed(1)
  x <- sample(1:10, 24, replace = TRUE)
  expect_quick_identical(fn, list(x))
})

test_that("array() reshape works when data is scalar-emitted (e.g. integer(n))", {
  fn <- function() {
    # `integer(3)` currently lowers to scalar `0` with a non-scalar value shape.
    # The array() reshape path must produce valid Fortran anyway.
    array(integer(3L), dim = c(1L, 3L))
  }

  expect_quick_identical(fn, list())
})

test_that("array() reshape accepts literal dim vectors in the AST", {
  dim_const <- c(2L, 3L, 4L)
  fn <- eval(bquote(function(x) {
    declare(type(x = integer(2L, 3L, 4L)))
    array(as.double(x), dim = .(dim_const))
  }))

  set.seed(1)
  x <- array(sample(1:10, 24, replace = TRUE), dim = c(2L, 3L, 4L))
  expect_quick_identical(fn, list(x))
})

test_that("array() reshape accepts dim as a literal sequence (2:4)", {
  fn <- function(x) {
    declare(type(x = integer(2L, 3L, 4L)))
    array(as.double(x), dim = 2:4)
  }

  set.seed(1)
  x <- array(sample(1:10, 24, replace = TRUE), dim = c(2L, 3L, 4L))
  expect_quick_identical(fn, list(x))
})

test_that("array() reshape accepts dim passed as a variable bound to a literal sequence", {
  fn <- function(x) {
    declare(type(x = integer(2L, 3L, 4L)))
    d <- 2:4
    array(as.double(x), dim = d)
  }

  set.seed(1)
  x <- array(sample(1:10, 24, replace = TRUE), dim = c(2L, 3L, 4L))
  expect_quick_identical(fn, list(x))
})

test_that("array() reshape fails early when recycling would be required", {
  fn <- function() {
    array(c(1L, 2L, 3L), dim = c(2L, 2L))
  }

  # Fortran `reshape()` errors when the source is too short; quickr should stop
  # before generating uncompilable code.
  expect_error(quick(fn), "does not support recycling")
})

test_that("array() fill reshape handles dim expressions that lower to comma-containing Fortran", {
  fn <- function(y, x) {
    declare(type(y = double(NA, NA)), type(x = double(nrow(y), ncol(y))))

    # `dim(x)` uses the dims declared above, which dims2f() lowers to
    # `size(y, 1), size(y, 2)` (commas inside expressions). Codegen must not
    # split on commas in Fortran output.
    array(integer(nrow(y) * ncol(y)), dim = dim(x))
  }

  set.seed(1)
  y <- matrix(runif(6), 2, 3)
  x <- y
  expect_quick_identical(fn, list(y, x))
})

test_that("array() reshape supports dim = 1 for non-scalar data", {
  fn <- function(x) {
    declare(type(x = integer(2L, 3L, 4L)))
    # Rank-1 length-1 arrays are scalar-like in quickr; index the first element
    # to compare against base R without relying on `dim` attributes.
    array(as.double(x), dim = 1L)[1]
  }

  set.seed(1)
  x <- array(sample(1:10, 24, replace = TRUE), dim = c(2L, 3L, 4L))
  expect_quick_identical(fn, list(x))
})

test_that("array() forwards hoist when data needs hoisted temporaries", {
  fn <- function(x, y) {
    declare(type(x = double(2L, 2L)), type(y = double(2L, 2L)))
    array((x + y)[, 1], dim = c(2L, 1L))
  }

  set.seed(1)
  x <- matrix(runif(4), 2, 2)
  y <- matrix(runif(4), 2, 2)
  expect_quick_identical(fn, list(x, y))
})

test_that("array() rejects empty dim vectors (dim=c())", {
  fn <- function(x) {
    declare(type(x = double(2L, 2L)))
    array(as.double(x), dim = c())
  }

  # Base R errors here ("'dims' cannot be of length 0"); quickr should fail
  # early too, rather than emitting rank-mismatched Fortran.
  expect_error(quick(fn), "dim")
})

# Integration tests for compile_package() and the pkgload::load_all() hook

skip_on_cran()

create_test_package <- function(
  .local_envir = parent.frame(),
  use_dynlib = TRUE,
  named_quick = TRUE
) {
  pkgname <- "quickr.test.pkg"
  pkgdir <- withr::local_tempdir(
    pattern = "quickr-test-pkg-",
    .local_envir = .local_envir
  )
  pkgpath <- file.path(pkgdir, pkgname)
  dir.create(pkgpath)
  dir.create(file.path(pkgpath, "R"))

  writeLines(
    c(
      paste0("Package: ", pkgname),
      "Title: quickr integration test package",
      "Version: 0.0.0.9000",
      "Description: Temporary package for quickr integration tests.",
      "License: MIT",
      "Encoding: UTF-8",
      "Imports: quickr"
    ),
    file.path(pkgpath, "DESCRIPTION")
  )

  namespace_lines <- c(
    "export(add_ab)",
    "importFrom(quickr,quick)"
  )
  if (isTRUE(use_dynlib)) {
    namespace_lines <- c(
      namespace_lines,
      sprintf("useDynLib(%s, .registration = TRUE)", pkgname)
    )
  }
  writeLines(namespace_lines, file.path(pkgpath, "NAMESPACE"))

  quick_call <- if (isTRUE(named_quick)) {
    "add_ab <- quickr::quick(\"add_ab\", function(a, b) {"
  } else {
    "add_ab <- quickr::quick(function(a, b) {"
  }

  writeLines(
    c(
      "declare <- function(...) invisible()",
      "",
      quick_call,
      "  declare({",
      "    type(a = double(n))",
      "    type(b = double(n))",
      "  })",
      "  out <- a + b",
      "  out",
      "})"
    ),
    file.path(pkgpath, "R", "package.R")
  )

  pkgpath
}

run_r <- function(code) {
  out <- suppressWarnings(system2(
    R.home("bin/R"),
    c("--vanilla", "--slave", "-e", shQuote(code)),
    stdout = TRUE,
    stderr = TRUE
  ))
  if (!is.null(status <- attr(out, "status"))) {
    writeLines(out)
    stop("R subprocess failed with status: ", status)
  }
  out
}

test_that("compile_package errors when path is not an R package", {
  temp <- withr::local_tempdir()
  expect_error(
    quickr::compile_package(temp),
    "does not appear to be an R package"
  )
})

test_that("compile_package errors when DESCRIPTION is empty", {
  temp <- withr::local_tempdir()
  withr::local_dir(temp)
  dir.create("R")
  writeLines("", "DESCRIPTION")

  expect_error(
    quickr::compile_package("."),
    "does not point to an R package"
  )
})

test_that("compile_package runs pkgload::load_all and writes src outputs", {
  skip_on_cran()
  skip_if_not_installed("pkgload")

  pkgpath <- create_test_package(named_quick = TRUE, use_dynlib = TRUE)
  entrypoints <- file.path(pkgpath, "src", "quickr_entrypoints.c")
  fsubs <- file.path(pkgpath, "src", "quickr_sub_routines.f90")

  expect_false(file.exists(entrypoints))
  expect_false(file.exists(fsubs))

  expect_silent(quickr::compile_package(pkgpath))

  expect_true(file.exists(entrypoints))
  expect_true(file.exists(fsubs))
  expect_true(file.info(entrypoints)$size > 0)
  expect_true(file.info(fsubs)$size > 0)
  expect_true(any(grepl("add_ab_", readLines(entrypoints), fixed = TRUE)))
})

test_that("pkgload::load_all includes package-level headers needed by later entrypoints", {
  skip_on_cran()
  skip_if_not_installed("pkgload")

  pkgpath <- create_test_package(named_quick = TRUE, use_dynlib = TRUE)
  entrypoints <- file.path(pkgpath, "src", "quickr_entrypoints.c")

  writeLines(
    c(
      "",
      "pow_len <- quickr::quick(\"pow_len\", function(n) {",
      "  declare(type(n = integer(1)))",
      "  out <- double(n^2L)",
      "  out",
      "})"
    ),
    file.path(pkgpath, "R", "power.R")
  )

  expect_no_error(withr::with_dir(pkgpath, {
    pkgload::load_all(".", quiet = TRUE)
  }))

  entrypoint_lines <- readLines(entrypoints)
  expect_true(any(grepl("#include <Rmath.h>", entrypoint_lines, fixed = TRUE)))
  expect_true(any(grepl("pow_len_", entrypoint_lines, fixed = TRUE)))
  expect_true(any(grepl("R_pow(", entrypoint_lines, fixed = TRUE)))
})

test_that("compile_package reports pkgload::load_all failures", {
  skip_on_cran()
  skip_if_not_installed("pkgload")

  pkgpath <- create_test_package(named_quick = TRUE, use_dynlib = TRUE)
  writeLines(
    c("this is not valid R code", "1 +"),
    file.path(pkgpath, "R", "broken.R")
  )

  expect_error(
    quickr::compile_package(pkgpath),
    "pkgload::load_all\\(\\) failed with status"
  )
})

test_that("pkgload::load_all writes outputs and resolves anonymous quick() names", {
  skip_on_cran()
  skip_if_not_installed("pkgload")

  pkgpath <- create_test_package(named_quick = FALSE, use_dynlib = TRUE)
  pkgpath <- normalizePath(pkgpath, winslash = "/", mustWork = TRUE)
  entrypoints <- file.path(pkgpath, "src", "quickr_entrypoints.c")
  fsubs <- file.path(pkgpath, "src", "quickr_sub_routines.f90")

  expect_false(file.exists(entrypoints))
  expect_false(file.exists(fsubs))

  code <- paste(
    sprintf("setwd(%s)", shQuote(pkgpath)),
    "suppressPackageStartupMessages(library(pkgload))",
    "pkgload::load_all('.', quiet = TRUE)",
    sep = "; "
  )
  run_r(code)

  expect_true(file.exists(entrypoints))
  expect_true(file.exists(fsubs))
  expect_true(any(grepl("add_ab_", readLines(entrypoints), fixed = TRUE)))
})

test_that("pkgload::load_all messages when NAMESPACE lacks useDynLib", {
  skip_on_cran()
  skip_if_not_installed("pkgload")

  pkgpath <- create_test_package(named_quick = TRUE, use_dynlib = FALSE)
  pkgpath <- normalizePath(pkgpath, winslash = "/", mustWork = TRUE)
  entrypoints <- file.path(pkgpath, "src", "quickr_entrypoints.c")

  code <- paste(
    sprintf("setwd(%s)", shQuote(pkgpath)),
    "suppressPackageStartupMessages(library(pkgload))",
    "pkgload::load_all('.', quiet = TRUE)",
    sep = "; "
  )
  out <- run_r(code)

  expect_true(file.exists(entrypoints))
  expect_true(any(grepl("@useDynLib", out)))
})

skip_on_cran()

test_that("multiple return values", {
  fn <- function(x) {
    declare(type(x = integer(n)))
    y <- x + 1
    z <- x + 2
    list(y = y, z = z)
  }
  qfn <- quick(fn)
  x <- 1:3
  expect_equal(qfn(x), fn(x))
})

test_that("multiple return values via assignment", {
  fn <- function(x) {
    declare(type(x = integer(n)))
    y <- x + 1
    z <- x + 2
    out <- list(y = y, z = z)
    out
  }
  qfn <- quick(fn)
  x <- 1:3
  expect_equal(qfn(x), fn(x))
})

test_that("single return variable still works", {
  fn <- function(x) {
    declare(type(x = integer(n)))
    y <- x + 1
    y
  }
  qfn <- quick(fn)
  x <- 1:3
  expect_equal(qfn(x), fn(x))
})

test_that("custom names for multiple return values are preserved", {
  fn <- function(x) {
    declare(type(x = integer(n)))
    y <- x + 1L
    z <- x + 2L
    list(abc = y, def = z)
  }
  qfn <- quick(fn)
  x <- 1:3
  expect_equal(qfn(x), fn(x))
})

test_that("no names add to unnamed elements", {
  fn <- function(x) {
    declare(type(x = integer(n)))
    y <- x + 1L
    z <- x + 2L
    list(y, z)
  }
  qfn <- quick(fn)
  x <- 1:3
  expect_equal(qfn(x), fn(x))
})


test_that("single-element unnamed list returns a list", {
  fn <- function(x) {
    declare(type(x = integer(n)))
    y <- x + 1L
    list(y)
  }
  qfn <- quick(fn)
  x <- 1:3
  expect_equal(qfn(x), fn(x))
})


test_that("single-element named list preserves name", {
  fn <- function(x) {
    declare(type(x = integer(n)))
    y <- x + 1L
    list(abc = y)
  }
  qfn <- quick(fn)
  x <- 1:3
  expect_equal(qfn(x), fn(x))
})

test_that("single-element list via assignment returns a list (VECSXP)", {
  fn <- function(x) {
    declare(type(x = integer(n)))
    y <- x + 1L
    out <- list(y)
    out
  }
  qfn <- quick(fn)
  x <- 1:3
  expect_equal(qfn(x), fn(x))
})

test_that("assignment form with non-syntactic name errors", {
  fn <- function(x) {
    declare(type(x = integer(n)))
    y <- x + 1L
    out <- list(`a b` = y)
    out
  }
  expect_error(quick(fn), "only syntactic names are valid")
})

test_that("empty return list errors", {
  fn <- function(x) {
    declare(type(x = integer(n)))
    list()
  }
  expect_error(quick(fn), "must contain at least one element")
})


test_that("mixed named and unnamed list work", {
  fn <- function(x) {
    declare(type(x = integer(n)))
    y <- x + 1L
    z <- x + 2L
    list(y, abc = z, x)
  }
  qfn <- quick(fn)
  x <- 1:3
  expect_equal(qfn(x), fn(x))
})

test_that("duplicate return variables compile once and work", {
  fn <- function(x) {
    declare(type(x = integer(n)))
    y <- x + 1L
    list(y, y)
  }
  qfn <- quick(fn)
  x <- 1:3
  expect_equal(qfn(x), fn(x))
})

test_that("duplicate return variables with names work", {
  fn <- function(x) {
    declare(type(x = integer(n)))
    y <- x + 1L
    list(a = y, b = y)
  }
  qfn <- quick(fn)
  x <- 1:3
  expect_equal(qfn(x), fn(x))
})


test_that("errors if list is used outside return pattern [r2f error]", {
  ## list not last or second to last
  fn <- function(x) {
    declare(type(x = integer(n)))
    y <- x + 1
    z <- x + 2
    out <- list(y = y, z = z)
    gg <- 1 + 1
    out
  }
  expect_error(quick(fn), "Unsupported function: list")
  ## List is being accessed
  fn <- function(x) {
    declare(type(x = integer(n)))
    y <- x + 1
    z <- x + 2
    out <- list(y = y, z = z)
    out$y
  }
  expect_error(quick(fn), "Unsupported function: list")
})


test_that("errors om nested list and non-symbols [validate_list_symbols]", {
  ## Nested lists
  fn <- function(x) {
    declare(type(x = integer(n)))
    y <- x + 1
    z <- x + 2
    out <- list(y = y, z = z, list(x = x))
    out
  }
  x <- 1:3
  expect_error(quick(fn), "all elements of the list must be symbols")

  ## non-symbols in list
  fn <- function(x) {
    declare(type(x = integer(n)))
    y <- x + 1
    z <- x + 2
    list(a = 1L, b = 2L)
  }
  x <- 1:3
  expect_error(quick(fn), "all elements of the list must be symbols")

  fn <- function(x) {
    declare(type(x = integer(n)))
    y <- x + 1
    z <- x + 2
    list(1L)
  }
  x <- 1:3
  expect_error(quick(fn), "all elements of the list must be symbols")
})


test_that("errors on non-syntactic names in return list", {
  fn <- function(x) {
    declare(type(x = integer(n)))
    y <- x + 1L
    list(`a b` = y)
  }
  expect_error(quick(fn), "only syntactic names are valid")
})

skip_on_cran()

benchmark_timings <- function(serial_fn, parallel_fn, args, reps = 5L) {
  reps <- as.integer(reps)
  if (reps < 1L) {
    stop("reps must be >= 1")
  }

  record_one <- function(fn, variant, rep, order) {
    timing <- system.time(do.call(fn, args))
    elapsed <- timing["elapsed"]
    cpu <- sum(timing[c("user.self", "sys.self")])
    data.frame(
      variant = variant,
      rep = rep,
      order = order,
      elapsed = elapsed,
      cpu = cpu,
      multiple_cores_used = (cpu * 1.5) > elapsed,
      cpu_over_elapsed = if (elapsed > 0) {
        cpu / elapsed
      } else {
        NA_real_
      },
      stringsAsFactors = FALSE
    )
  }

  out <- vector("list", reps * 2L)
  pos <- 0L
  for (rep in seq_len(reps)) {
    variants <- if (rep %% 2L == 1L) {
      c("serial", "parallel")
    } else {
      c("parallel", "serial")
    }

    for (order in 1:2) {
      variant <- variants[[order]]
      fn <- if (identical(variant, "serial")) serial_fn else parallel_fn
      pos <- pos + 1L
      out[[pos]] <- record_one(fn, variant = variant, rep = rep, order = order)
    }
  }

  do.call(rbind, out)
}

test_that("parallel loop uses multiple threads", {
  skip_if_no_openmp()

  serial <- function(x, n, iters, out) {
    declare(
      type(x = double(n)),
      type(n = integer(1)),
      type(iters = integer(1)),
      type(out = double(n))
    )
    for (i in seq_len(n)) {
      v <- x[i]
      for (k in seq_len(iters)) {
        v <- sin(v) + cos(v)
        v <- sqrt(v + 1)
      }
      out[i] <- v
    }
    out
  }

  parallel <- function(x, n, iters, out) {
    declare(
      type(x = double(n)),
      type(n = integer(1)),
      type(iters = integer(1)),
      type(out = double(n))
    )
    declare(parallel())
    for (i in seq_len(n)) {
      v <- x[i]
      for (k in seq_len(iters)) {
        v <- sin(v) + cos(v)
        v <- sqrt(v + 1)
      }
      out[i] <- v
    }
    out
  }

  threads <- 2L
  withr::local_envvar(c(
    OMP_NUM_THREADS = as.character(threads),
    OMP_THREAD_LIMIT = as.character(threads),
    OMP_DYNAMIC = "false"
  ))

  n <- 500000L
  set.seed(1)
  x <- runif(n)
  out <- double(n)
  serial_q <- quick(serial)
  parallel_q <- quick(parallel)

  iters <- 12L

  expect_equal(
    parallel_q(x, n, iters, double(n)),
    serial_q(x, n, iters, double(n))
  )

  serial_q(x, n, iters, out)
  parallel_q(x, n, iters, out)

  for (attempt in seq_len(6L)) {
    calibration <- benchmark_timings(
      serial_q,
      parallel_q,
      args = list(x = x, n = n, iters = iters, out = out),
      reps = 1L
    )
    serial_elapsed <- calibration$elapsed[calibration$variant == "serial"][1L]
    if (serial_elapsed >= 0.2) {
      break
    }
    iters <- as.integer(iters * 2L)
  }

  timings <- benchmark_timings(
    serial_q,
    parallel_q,
    args = list(x = x, n = n, iters = iters, out = out),
    reps = 5L
  )

  # We intentionally avoid a strict "parallel must be faster" assertion here,
  # because elapsed time is highly sensitive to external contention (other test
  # processes, CI load, thermal throttling). Instead, the unit test focuses on:
  # - evidence that multiple threads actually did work (cpu/elapsed > 1), and
  # - the parallel path not being catastrophically slower than the serial path.
  serial_ratio <- median(timings$cpu_over_elapsed[timings$variant == "serial"])
  parallel_ratio <- median(
    timings$cpu_over_elapsed[timings$variant == "parallel"]
  )

  if (!any(timings$multiple_cores_used[timings$variant == "parallel"])) {
    skip(paste0(
      "OpenMP threads not observed running concurrently (serial cpu/elapsed=",
      signif(serial_ratio, 3),
      ", parallel cpu/elapsed=",
      signif(parallel_ratio, 3),
      ")"
    ))
  }

  serial_median <- median(timings$elapsed[timings$variant == "serial"])
  parallel_median <- median(timings$elapsed[timings$variant == "parallel"])

  info <- paste0(
    "threads=",
    threads,
    "; iters=",
    iters,
    "; serial=",
    signif(serial_median, 3),
    "s; parallel=",
    signif(parallel_median, 3),
    "s; serial cpu/elapsed=",
    signif(serial_ratio, 3),
    "; parallel cpu/elapsed=",
    signif(parallel_ratio, 3)
  )

  # This bound is intentionally generous to avoid test flakiness under load.
  # A strict speedup assertion belongs in a dedicated perf check (see
  # scripts/perf-openmp-speedup.R), while the unit test's job is to confirm that
  # OpenMP parallelism is engaged and doesn't catastrophically regress.
  slowdown_factor <- if (identical(Sys.info()[["sysname"]], "Darwin")) 3 else 2
  expect_lt(parallel_median, serial_median * slowdown_factor, label = info)
})

test_that("stop inside parallel loop propagates errors", {
  skip_if_no_openmp()

  stop_in_parallel <- function(x) {
    declare(type(x = double(1)))
    declare(parallel())
    for (i in seq_len(1L)) {
      if (x < 0) {
        stop("x must be nonnegative")
      }
    }
    x + 1
  }

  q_stop <- quick(stop_in_parallel)
  expect_error(q_stop(-1), "x must be nonnegative", fixed = TRUE)
  expect_equal(q_stop(1), 2)
})

test_that("stop inside nested parallel loop propagates errors", {
  skip_if_no_openmp()

  stop_in_nested_parallel <- function(x) {
    declare(type(x = double(1)))
    declare(parallel())
    for (i in seq_len(1L)) {
      declare(parallel())
      for (j in seq_len(1L)) {
        if (x < 0) {
          stop("x must be nonnegative")
        }
      }
    }
    x + 1
  }

  q_stop <- quick(stop_in_nested_parallel)
  expect_error(q_stop(-1), "x must be nonnegative", fixed = TRUE)
  expect_equal(q_stop(1), 2)
})

test_that("stop inside parallel sapply propagates errors", {
  skip_if_no_openmp()

  stop_in_parallel_sapply <- function(x) {
    declare(type(x = double(1)))
    declare(parallel())
    out <- sapply(seq_len(1L), function(i) {
      if (x < 0) {
        stop("x must be nonnegative")
      }
      x + 1.0
    })
    out
  }

  q_stop <- quick(stop_in_parallel_sapply)
  expect_error(q_stop(-1), "x must be nonnegative", fixed = TRUE)
  expect_equal(q_stop(1), 2)
})

skip_on_cran()

test_that("<<- mutates host locals in statement local closures", {
  fn <- function(nx, ny) {
    declare(
      type(nx = integer(1)),
      type(ny = integer(1))
    )
    temp <- matrix(0, nx, ny)

    bc <- function() {
      temp[1, ] <<- 1
      temp[nx, ] <<- 2
      temp[, 1] <<- 3
      temp[, ny] <<- 4
      NULL
    }

    bc()
    temp
  }

  expect_quick_identical(fn, list(4L, 5L), list(2L, 3L))
})

test_that("<<- mutating a host argument preserves caller copy-on-modify semantics", {
  fn <- function(x) {
    declare(type(x = double(NA)))
    f <- function(i) {
      x[i] <<- x[i] + 1
      NULL
    }
    f(1L)
    x
  }

  x1 <- c(1, 2, 3)
  x2 <- c(-1, 0, 4)

  expect_identical(fn(x1), c(2, 2, 3))
  expect_identical(fn(x2), c(0, 0, 4))
  expect_quick_identical(fn, x1, x2, as.double(seq(-10, 10)))

  qfn <- quick(fn)
  for (x0 in list(x1, x2)) {
    x <- x0
    out <- qfn(x)
    expect_identical(out, fn(x0))
    expect_identical(x, x0)
  }
})

test_that("sapply + <<- can mutate host and return values", {
  fn <- function(x) {
    declare(type(x = double(NA)), type(out = double(length(x))))
    f <- function(i) {
      x[i] <<- x[i] * 2
      x[i]
    }
    out <- sapply(seq_along(x), f)
    list(x = x, out = out)
  }

  set.seed(1)
  x <- runif(10)
  expect_quick_identical(fn, list(x))
})

test_that("<- shadows captured variables (use <<- to mutate the host)", {
  fn <- function(x) {
    declare(type(x = double(NA)))
    out <- double(length(x))
    f <- function(i) {
      x <- x * 2
      x[i]
    }
    out <- sapply(seq_along(out), f)
    out
  }

  x1 <- c(1, 2, 3)
  x2 <- c(-1.5, 0.25, 2.0)

  expect_identical(fn(x1), x1 * 2)
  expect_identical(fn(x2), x2 * 2)
  expect_quick_identical(fn, x1, x2, as.double(seq(-10, 10)))

  qfn <- quick(fn)
  for (x0 in list(x1, x2)) {
    x <- x0
    out <- qfn(x)

    expect_identical(out, x0 * 2)
    expect_identical(out, fn(x0))
    expect_identical(x, x0)
  }
})

test_that("<<- targets the host when the name is shadowed by <- (vector)", {
  fn <- function(x) {
    declare(type(x = double(NA)))
    f <- function(i) {
      x <- x + 1.0
      x[i] <<- x[i] + 1.0
      NULL
    }
    f(1L)
    x
  }

  x1 <- as.double(1:5)
  x2 <- c(-1.5, 0.25, 2.0)

  expected1 <- x1
  expected1[[1L]] <- x1[[1L]] + 2.0
  expected2 <- x2
  expected2[[1L]] <- x2[[1L]] + 2.0

  expect_identical(fn(x1), expected1)
  expect_identical(fn(x2), expected2)
  expect_quick_identical(fn, x1, x2, as.double(seq(-10, 10)))

  qfn <- quick(fn)
  for (x0 in list(x1, x2)) {
    x <- x0
    out <- qfn(x)

    expected <- x0
    expected[[1L]] <- x0[[1L]] + 2.0
    expect_identical(out, expected)
    expect_identical(out, fn(x0))
    expect_identical(x, x0)
  }
})

test_that("<<- targets the host when the name is shadowed by <- (matrix subset)", {
  fn <- function(x) {
    declare(type(x = double(3, 4)))
    i <- 2L
    j <- 3L

    f <- function() {
      x <- x + 1.0
      x[i, j] <<- x[i, j] + 1.0
      NULL
    }
    f()
    x
  }

  x1 <- matrix(as.double(1:12), 3, 4)
  x2 <- matrix(as.double(-11:0), 3, 4)

  expected1 <- x1
  expected1[2, 3] <- x1[2, 3] + 2.0
  expected2 <- x2
  expected2[2, 3] <- x2[2, 3] + 2.0

  expect_identical(fn(x1), expected1)
  expect_identical(fn(x2), expected2)
  expect_quick_identical(fn, x1, x2)

  qfn <- quick(fn)
  for (x0 in list(x1, x2)) {
    x <- x0
    out <- qfn(x)

    expected <- x0
    expected[2, 3] <- x0[2, 3] + 2.0
    expect_identical(out, expected)
    expect_identical(out, fn(x0))
    expect_identical(x, x0)
  }
})

test_that("<<- supports 2D subset targets", {
  fn <- function(nx, ny, dt) {
    declare(
      type(nx = integer(1)),
      type(ny = integer(1)),
      type(dt = double(1))
    )
    temp <- matrix(0, nx, ny)

    bump <- function(i, j) {
      temp[i, j] <<- temp[i, j] + dt
      NULL
    }

    bump(2L, 3L)
    bump(nx, ny)
    temp
  }

  expect_quick_identical(fn, list(4L, 5L, 0.25), list(2L, 3L, 1.0))
})

skip_on_cran()

test_that("quick() supports dotted argument names", {
  expect_quick_identical(
    function(foo.bar) {
      declare(type(foo.bar = double(3)))
      foo.bar + 1
    },
    foo.bar = c(1, 2, 3)
  )
})

test_that("quick() supports dotted local variable names", {
  expect_quick_identical(
    function(x) {
      declare(type(x = double(3)))
      out.var <- x + 1
      out.var
    },
    x = c(1, 2, 3)
  )
})

test_that("quick() supports dotted for-loop variables", {
  expect_quick_identical(
    function(x) {
      declare(type(x = double(3)))
      for (i.j in seq_along(x)) {
        x[i.j] <- x[i.j] + 1
      }
      x
    },
    x = c(1, 2, 3)
  )
})

# Unit tests for size expression lowering/evaluation

skip_on_cran()

test_that("constant arithmetic in declared dims is evaluated", {
  fn <- function(x) {
    declare(type(x = double(2L + 3L)))
    sum(x)
  }
  qfn <- quick(fn)

  expect_error(
    qfn(as.double(1:4)),
    "length(x) must be 5, not 4",
    fixed = TRUE
  )
  expect_identical(qfn(as.double(1:5)), 15)

  fn_pow <- function(x) {
    declare(type(x = double(2L^3L)))
    sum(x)
  }
  qfn_pow <- quick(fn_pow)

  expect_error(
    qfn_pow(as.double(1:7)),
    "length(x) must be 8, not 7",
    fixed = TRUE
  )
  expect_identical(qfn_pow(as.double(1:8)), 36)
})

test_that("dynamic exponentiation works in declared dims", {
  fn <- function(n) {
    declare(type(n = integer(1)))
    out <- double(n^2L)
    for (i in seq_len(length(out))) {
      out[i] <- as.double(i)
    }
    out
  }

  expect_quick_identical(fn, list(3L), list(4L))
})

test_that("dim/length/nrow/ncol are supported in allocation sizes", {
  vec <- function(x) {
    declare(type(x = double(NA)))
    out <- double(length(x) + 1L)
    length(out)
  }
  expect_quick_identical(vec, list(as.double(1:3)), list(as.double(1)))

  mat <- function(x) {
    declare(type(x = double(NA, NA)))
    out <- double(length(x) + 1L)
    length(out)
  }
  expect_quick_identical(mat, list(matrix(as.double(1:12), nrow = 3, ncol = 4)))

  mat_dims <- function(x) {
    declare(type(x = double(NA, NA)))
    out1 <- double(dim(x)[2L] + 1L)
    out2 <- double(nrow(x) + ncol(x))
    c(length(out1), length(out2))
  }
  expect_quick_identical(
    mat_dims,
    list(matrix(as.double(1:12), nrow = 3, ncol = 4)),
    list(matrix(as.double(1:6), nrow = 2, ncol = 3))
  )
})

test_that("dim(x)[axis] errors when axis exceeds rank", {
  bad <- function(x) {
    declare(type(x = double(NA, NA)))
    double(dim(x)[3L])
  }

  expect_error(quick(bad), "insufficient rank", fixed = TRUE)
})

skip_on_cran()

test_that("declare dims support nested length() (vector)", {
  fn <- function(x) {
    declare(type(x = double(NA)), type(out = double(length(x) + 1)))
    out[1] <- 0
    out
  }

  expect_translation_snapshots(
    fn,
    note = "dims2c must translate length(x) inside arithmetic, not evaluate base::length() on the C expression string."
  )
})

test_that("declare dims support nested length() (rank>1)", {
  fn <- function(x) {
    declare(type(x = double(NA, NA)), type(out = double(length(x) + 1)))
    out[1] <- 0
    out
  }

  expect_translation_snapshots(
    fn,
    note = "dims2c must translate length(x) for rank>1 arrays (length == prod(dim))."
  )
})

test_that("declare dims support min() in size expressions", {
  fn <- function(n, m) {
    declare(
      type(n = integer(1)),
      type(m = integer(1)),
      type(out = double(min(n, m)))
    )
    for (i in seq_len(length(out))) {
      out[i] <- as.double(i)
    }
    out
  }

  expect_translation_snapshots(fn)
  qfn <- quick(fn)
  expect_identical(qfn(2L, 5L), as.double(1:2))
  expect_identical(qfn(4L, 3L), as.double(1:3))
})

test_that("declare dims support max() in size expressions", {
  fn <- function(n, m) {
    declare(
      type(n = integer(1)),
      type(m = integer(1)),
      type(out = double(max(n, m)))
    )
    for (i in seq_len(length(out))) {
      out[i] <- as.double(i)
    }
    out
  }

  expect_translation_snapshots(fn)
  qfn <- quick(fn)
  expect_identical(qfn(2L, 5L), as.double(1:5))
  expect_identical(qfn(4L, 3L), as.double(1:4))
})

# Public API tests for vector/matrix elementwise recycling rules

skip_on_cran()

test_that("vector-matrix elementwise ops only recycle by nrow", {
  ok <- function(mat, vec) {
    declare(type(mat = double(2, 3)), type(vec = double(2)))
    mat + vec
  }

  set.seed(1)
  mat <- matrix(runif(6), nrow = 2, ncol = 3)
  vec <- runif(2)
  expect_quick_identical(ok, list(mat, vec))

  bad <- function(mat, vec) {
    declare(type(mat = double(2, 3)), type(vec = double(3)))
    mat + vec
  }

  expect_error(
    quick(bad),
    "vector length equal to the matrix first dimension \\(nrow\\)",
    fixed = FALSE
  )
})

skip_on_cran()

test_that("matrix ops infer destination sizes for assignments", {
  matmul_infer <- function(A, B) {
    declare(type(A = double(2, 3)), type(B = double(3, 2)))
    out <- A %*% B
    out
  }

  matvec_infer <- function(A, x) {
    declare(type(A = double(2, 3)), type(x = double(3)))
    out <- A %*% x
    out
  }

  vecmat_infer <- function(x, A) {
    declare(type(x = double(2)), type(A = double(2, 3)))
    out <- x %*% A
    out
  }

  cross_infer <- function(x) {
    declare(type(x = double(4, 3)))
    out <- crossprod(x)
    out
  }

  cross_infer2 <- function(x, y) {
    declare(type(x = double(4, 3)), type(y = double(4, 2)))
    out <- crossprod(x, y)
    out
  }

  tcross_infer <- function(x) {
    declare(type(x = double(4, 3)))
    out <- tcrossprod(x)
    out
  }

  tcross_infer2 <- function(x, y) {
    declare(type(x = double(4, 3)), type(y = double(2, 3)))
    out <- tcrossprod(x, y)
    out
  }

  outer_infer <- function(x, y) {
    declare(type(x = double(2)), type(y = double(3)))
    out <- outer(x, y)
    out
  }

  outer_op_infer <- function(x, y) {
    declare(type(x = double(2)), type(y = double(3)))
    out <- x %o% y
    out
  }

  forward_infer <- function(L, b) {
    declare(type(L = double(2, 2)), type(b = double(2, 2)))
    out <- forwardsolve(L, b)
    out
  }

  back_infer <- function(U, b) {
    declare(type(U = double(2, 2)), type(b = double(2)))
    out <- backsolve(U, b)
    out
  }

  solve_vec_infer <- function(A, b) {
    declare(type(A = double(n, n)), type(b = double(n)))
    out <- solve(A, b)
    out
  }

  solve_mat_infer <- function(A, B) {
    declare(type(A = double(n, n)), type(B = double(n, k)))
    out <- solve(A, B)
    out
  }

  solve_inv_infer <- function(A) {
    declare(type(A = double(n, n)))
    out <- solve(A)
    out
  }

  chol_infer <- function(A) {
    declare(type(A = double(n, n)))
    out <- chol(A)
    out
  }

  chol2inv_infer <- function(A) {
    declare(type(A = double(n, n)))
    out <- chol2inv(chol(A))
    out
  }

  set.seed(99)
  n <- 4
  k <- 2
  A <- matrix(rnorm(6), nrow = 2)
  B <- matrix(rnorm(6), nrow = 3)
  x2 <- rnorm(2)
  x3 <- rnorm(3)
  X <- matrix(rnorm(12), nrow = 4)
  Yc <- matrix(rnorm(8), nrow = 4)
  Yt <- matrix(rnorm(6), nrow = 2)
  v2 <- rnorm(2)
  v3 <- rnorm(3)

  L <- matrix(c(2, 0, 1, 3), nrow = 2, byrow = TRUE)
  U <- matrix(c(2, 1, 0, 3), nrow = 2, byrow = TRUE)
  b_mat <- matrix(rnorm(4), nrow = 2)
  b_vec <- rnorm(2)
  base <- matrix(rnorm(n * n), n, n)
  A_pd <- crossprod(base) + diag(n)
  b_solve <- rnorm(n)
  B_solve <- matrix(rnorm(n * k), n, k)

  expect_quick_equal(matmul_infer, list(A = A, B = B))
  expect_quick_equal(matvec_infer, list(A = A, x = x3))
  expect_quick_equal(vecmat_infer, list(x = x2, A = A))
  expect_quick_equal(cross_infer, list(x = X))
  expect_quick_equal(cross_infer2, list(x = X, y = Yc))
  expect_quick_equal(tcross_infer, list(x = X))
  expect_quick_equal(tcross_infer2, list(x = X, y = Yt))
  expect_quick_equal(outer_infer, list(x = v2, y = v3))
  expect_quick_equal(outer_op_infer, list(x = v2, y = v3))
  expect_quick_equal(forward_infer, list(L = L, b = b_mat))
  expect_quick_equal(back_infer, list(U = U, b = b_vec))
  expect_quick_equal(solve_vec_infer, list(A = A_pd, b = b_solve))
  expect_quick_equal(solve_mat_infer, list(A = A_pd, B = B_solve))
  expect_quick_equal(solve_inv_infer, list(A = A_pd))
  expect_quick_equal(chol_infer, list(A = A_pd))
  expect_quick_equal(chol2inv_infer, list(A = A_pd))
})

test_that("crossprod requires conformability at compile time", {
  fn <- function(x, y, n, p, m, k) {
    declare(
      type(n = integer(1)),
      type(p = integer(1)),
      type(m = integer(1)),
      type(k = integer(1)),
      type(x = double(n, m)),
      type(y = double(p, k))
    )
    crossprod(x, y)
  }

  expect_error(
    quick(fn),
    "cannot verify conformability in crossprod",
    fixed = TRUE
  )
})

test_that("matrix helpers report unsupported inputs", {
  matmul_bad_rank <- function(a, b) {
    declare(type(a = double(2, 2, 2)), type(b = double(2, 2)))
    a %*% b
  }

  transpose_bad_rank <- function(x) {
    declare(type(x = double(2, 2, 2)))
    t(x)
  }

  outer_bad_rank <- function(x, y) {
    declare(type(x = double(2, 2)), type(y = double(2)))
    outer(x, y)
  }

  outer_missing <- function(x) {
    declare(type(x = double(2)))
    outer(x)
  }

  forward_k <- function(L, b) {
    declare(type(L = double(2, 2)), type(b = double(2)))
    forwardsolve(L, b, k = 1)
  }

  back_bad_upper <- function(U, b, flag) {
    declare(
      type(U = double(2, 2)),
      type(b = double(2)),
      type(flag = logical(1))
    )
    backsolve(U, b, upper.tri = flag)
  }

  back_bad_A <- function(A, b) {
    declare(type(A = double(2)), type(b = double(2)))
    backsolve(A, b)
  }

  back_bad_B <- function(U, b) {
    declare(type(U = double(2, 2)), type(b = double(2, 2, 2)))
    backsolve(U, b)
  }

  expect_error(quick(matmul_bad_rank), "%\\*% only supports vectors/matrices")
  expect_error(quick(transpose_bad_rank), "t\\(\\) only supports rank 0-2")
  expect_error(quick(outer_bad_rank), "outer\\(\\) only supports vectors")
  expect_error(quick(outer_missing), "outer\\(\\) expects X and Y")
  expect_error(quick(forward_k), "forwardsolve\\(\\) does not support k")
  expect_error(quick(back_bad_upper), "only supports literal upper\\.tri")
  expect_error(quick(back_bad_A), "triangular solve expects a matrix")
  expect_error(quick(back_bad_B), "triangular solve only supports vector")
})

test_that("matrix conformability warnings are surfaced", {
  matmul_warn <- function(A, B, n, m, k) {
    declare(
      type(n = integer(1)),
      type(m = integer(1)),
      type(k = integer(1)),
      type(A = double(n, m)),
      type(B = double(k, n))
    )
    A %*% B
  }

  expect_warning(
    quick(matmul_warn),
    "cannot verify conformability in %\\*%"
  )
})

skip_on_cran()

test_that("declare(parallel()) and declare(omp()) parallelize loops", {
  skip_if_no_openmp()

  parallel_for <- function(x, n) {
    declare(type(x = double(n)), type(n = integer(1)), type(out = double(n)))
    out <- double(n)
    declare(parallel())
    for (i in seq_len(n)) {
      out[i] <- x[i] + 1
    }
    out
  }

  parallel_sapply <- function(x) {
    declare(type(x = double(NA)))
    out <- double(length(x))
    declare(omp())
    out <- sapply(seq_along(out), function(i) x[i] * 2)
    out
  }

  set.seed(1)
  x <- runif(5)
  expect_quick_identical(parallel_for, list(x, 5L))
  expect_quick_identical(parallel_sapply, list(x))
})

test_that("parallel sapply supports axpy patterns", {
  skip_if_no_openmp()

  axpy <- function(x, y, a) {
    declare(
      type(x = double(n)),
      type(y = double(n)),
      type(a = double(1)),
      type(out = double(n))
    )
    n <- length(x)
    out <- double(n)
    declare(parallel())
    out <- sapply(seq_along(out), function(i) a * x[i] + y[i])
    out
  }

  axpy_no_out <- function(x, y, a) {
    declare({
      type(x = double(n))
      type(y = double(n))
      type(a = double(1))
      type(out = double(n))
    })
    declare(parallel())
    sapply(seq_along(out), function(i) a * x[i] + y[i])
  }

  set.seed(123)
  x <- runif(8)
  y <- runif(8)
  a <- 0.25

  expect_quick_identical(axpy, list(x, y, a))

  qaxpy_no_out := quick(axpy_no_out)
  expect_identical(qaxpy_no_out(x, y, a), a * x + y)
})

test_that("parallel sapply supports seq_len(nrow(x))", {
  skip_if_no_openmp()

  row_sums <- function(x) {
    declare(type(x = double(NA, NA)))
    declare(parallel())
    sapply(seq_len(nrow(x)), function(r) sum(x[r, ]))
  }

  set.seed(42)
  x <- matrix(runif(12), nrow = 3)
  expect_quick_identical(row_sums, list(x))
})

test_that("parallel for-loops support value iteration", {
  skip_if_no_openmp()

  value_iter <- function(x) {
    declare(
      type(x = double(NA)),
      type(idx = integer(length(x))),
      type(out = double(length(x)))
    )
    idx <- seq_along(x)
    out <- double(length(x))
    declare(parallel())
    for (i in idx) {
      out[i] <- x[i] * 2
    }
    out
  }

  set.seed(11)
  x <- runif(6)
  expect_quick_identical(value_iter, list(x))
})

test_that("parallel declarations require supported targets", {
  skip_if_no_openmp()

  wrong_target <- function(x) {
    declare(type(x = double(1)))
    declare(parallel())
    x <- x + 1
    x
  }

  dangling_parallel <- function(x) {
    declare(type(x = double(1)))
    declare(parallel())
    x
  }

  expect_error(
    quick(wrong_target),
    regexp = "parallel\\(\\)/omp\\(\\) must be followed by a for-loop or sapply\\(\\)"
  )
  expect_error(
    quick(dangling_parallel),
    regexp = "parallel\\(\\)/omp\\(\\) must be followed by a for-loop or sapply\\(\\)"
  )
})

test_that("parallel declarations do not cross control flow boundaries", {
  skip_if_no_openmp()

  if_decl <- function(x) {
    declare(type(x = double(1)))
    if (x > 0) {
      declare(parallel())
    }
    for (i in seq_len(1L)) {
      x <- x + i
    }
    x
  }

  for_body_decl <- function(x) {
    declare(type(x = double(1)))
    for (i in seq_len(1L)) {
      declare(parallel())
    }
    for (j in seq_len(1L)) {
      x <- x + j
    }
    x
  }

  expect_error(
    quick(if_decl),
    regexp = "parallel\\(\\)/omp\\(\\) must be followed by a for-loop or sapply\\(\\)"
  )
  expect_error(
    quick(for_body_decl),
    regexp = "parallel\\(\\)/omp\\(\\) must be followed by a for-loop or sapply\\(\\)"
  )
})

test_that("openmp functions that use BLAS load and run", {
  skip_if_no_openmp()

  blas_parallel <- function(x, n) {
    declare(
      type(x = double(n, n)),
      type(n = integer(1)),
      type(out = double(n, n))
    )
    declare(parallel())
    for (i in seq_len(1L)) {
      out <- x %*% x
    }
    out
  }

  set.seed(123)
  x <- matrix(runif(16), nrow = 4)
  expect_quick_equal(blas_parallel, list(x, 4L))
})

skip_on_cran()

test_that("quick() supports .Machine$double.eps", {
  fn <- function(x) {
    declare(type(x = double(1)))
    x + .Machine$double.eps
  }

  expect_translation_snapshots(fn)
  expect_quick_equal(fn, x = 1)
})

test_that("quick() errors for unsupported .Machine$ fields", {
  expect_error(
    quick(function(x) {
      declare(type(x = double(1)))
      x + .Machine$integer.max
    }),
    "`.Machine$integer.max` is not supported",
    fixed = TRUE
  )
})

# Public-API tests that exercise internal inference/hoisting code paths.
# These replace several direct `quickr:::` unit tests while keeping coverage.

skip_on_cran()

test_that("matrix destination inference gracefully declines non-symbol inputs", {
  matmul_expr_arg <- function(A, B) {
    declare(type(A = double(2, 3)), type(B = double(3, 2)))
    out <- (A + 0.0) %*% B
    out
  }

  crossprod_expr_arg <- function(x) {
    declare(type(x = double(4, 3)))
    out <- crossprod((x + 0.0))
    out
  }

  tcrossprod_expr_arg <- function(x) {
    declare(type(x = double(4, 3)))
    out <- tcrossprod((x + 0.0))
    out
  }

  outer_expr_arg <- function(x, y) {
    declare(type(x = double(2)), type(y = double(3)))
    out <- outer((x + 0.0), y)
    out
  }

  backsolve_expr_arg <- function(U, b) {
    declare(type(U = double(2, 2)), type(b = double(2)))
    out <- backsolve((U + 0.0), b)
    out
  }

  solve_expr_arg <- function(A, b) {
    declare(type(A = double(3, 3)), type(b = double(3)))
    out <- solve((A + 0.0), b)
    out
  }

  diag_expr_arg <- function(x) {
    declare(type(x = double(3)))
    out <- diag((x + 0.0))
    out
  }

  set.seed(1)

  A <- matrix(rnorm(6), nrow = 2)
  B <- matrix(rnorm(6), nrow = 3)
  expect_quick_equal(matmul_expr_arg, list(A = A, B = B))

  x <- matrix(rnorm(12), nrow = 4)
  expect_quick_equal(crossprod_expr_arg, list(x = x))
  expect_quick_equal(tcrossprod_expr_arg, list(x = x))

  v2 <- rnorm(2)
  v3 <- rnorm(3)
  expect_quick_equal(outer_expr_arg, list(x = v2, y = v3))

  U <- matrix(c(2, 1, 0, 3), nrow = 2, byrow = TRUE)
  b2 <- c(1.25, -0.5)
  expect_quick_equal(backsolve_expr_arg, list(U = U, b = b2))

  base <- matrix(rnorm(9), 3, 3)
  A_pd <- crossprod(base) + diag(3)
  b3 <- rnorm(3)
  expect_quick_equal(solve_expr_arg, list(A = A_pd, b = b3))

  x3 <- rnorm(3)
  expect_quick_equal(diag_expr_arg, list(x = x3))
})

test_that("matrix destination inference works for common symbol-based shapes", {
  # These cases exercise the `dest_infer` helpers without reaching for any
  # `quickr:::` internals. The key property is that `out` is NOT declared, so
  # `quickr` must infer its shape from the symbol-based operands.

  matmul_mm <- function(A, B) {
    declare(type(A = double(2, 3)), type(B = double(3, 4)))
    out <- A %*% B
    out
  }

  matmul_mv <- function(A, x) {
    declare(type(A = double(2, 3)), type(x = double(3)))
    out <- A %*% x
    out
  }

  matmul_vm <- function(x, A) {
    declare(type(x = double(3)), type(A = double(3, 4)))
    out <- x %*% A
    out
  }

  matmul_t_left <- function(A, B) {
    declare(type(A = double(4, 3)), type(B = double(4, 2)))
    out <- t(A) %*% B
    out
  }

  matmul_t_right <- function(A, B) {
    declare(type(A = double(4, 3)), type(B = double(2, 3)))
    out <- A %*% t(B)
    out
  }

  matmul_t_vector <- function(v, B) {
    declare(type(v = double(3)), type(B = double(3, 4)))
    out <- t(v) %*% B
    out
  }

  crossprod_1 <- function(x) {
    declare(type(x = double(5, 3)))
    out <- crossprod(x)
    out
  }

  crossprod_2 <- function(x, y) {
    declare(type(x = double(5, 3)), type(y = double(5, 2)))
    out <- crossprod(x, y)
    out
  }

  tcrossprod_1 <- function(x) {
    declare(type(x = double(5, 3)))
    out <- tcrossprod(x)
    out
  }

  tcrossprod_2 <- function(x, y) {
    declare(type(x = double(5, 3)), type(y = double(2, 3)))
    out <- tcrossprod(x, y)
    out
  }

  outer_vv <- function(x, y) {
    declare(type(x = double(2)), type(y = double(3)))
    out <- outer(x, y)
    out
  }

  outer_sv <- function(x, y) {
    declare(type(x = double(1)), type(y = double(3)))
    out <- outer(x, y)
    out
  }

  triangular_vec <- function(U, b) {
    declare(type(U = double(2, 2)), type(b = double(2)))
    out <- backsolve(U, b)
    out
  }

  triangular_mat <- function(U, B) {
    declare(type(U = double(2, 2)), type(B = double(2, 3)))
    out <- backsolve(U, B)
    out
  }

  solve_inv <- function(A) {
    declare(type(A = double(3, 3)))
    out <- solve(A)
    out
  }

  solve_vec <- function(A, b) {
    declare(type(A = double(3, 3)), type(b = double(3)))
    out <- solve(A, b)
    out
  }

  solve_mat <- function(A, B) {
    declare(type(A = double(3, 3)), type(B = double(3, 2)))
    out <- solve(A, B)
    out
  }

  chol_out <- function(A) {
    declare(type(A = double(3, 3)))
    out <- chol(A)
    out
  }

  chol2inv_out <- function(A) {
    declare(type(A = double(3, 3)))
    out <- chol2inv(chol(A))
    out
  }

  diag_vec <- function(x) {
    declare(type(x = double(3)))
    out <- diag(x)
    out
  }

  diag_mat <- function(A) {
    declare(type(A = double(2, 3)))
    out <- diag(A)
    out
  }

  diag_missing_x <- function(n) {
    declare(type(n = integer(1)))
    out <- diag(nrow = n)
    out
  }

  diag_scalar_symbol_no_nrow <- function() {
    # Cover the scalar-symbol branch in `infer_dest_diag()` (no nrow/ncol).
    n <- 3L
    out <- diag(n)
    out
  }

  diag_vec_with_nrow_ncol <- function(x, n, m) {
    declare(type(x = double(3)), type(n = integer(1)), type(m = integer(1)))
    out <- diag(x, nrow = n, ncol = m)
    out
  }

  set.seed(123)

  A <- matrix(rnorm(2 * 3), nrow = 2)
  B <- matrix(rnorm(3 * 4), nrow = 3)
  expect_quick_equal(matmul_mm, list(A = A, B = B))

  x3 <- rnorm(3)
  expect_quick_equal(matmul_mv, list(A = A, x = x3))
  expect_quick_equal(matmul_vm, list(x = x3, A = matrix(rnorm(3 * 4), 3, 4)))

  A43 <- matrix(rnorm(4 * 3), nrow = 4)
  B42 <- matrix(rnorm(4 * 2), nrow = 4)
  expect_quick_equal(matmul_t_left, list(A = A43, B = B42))

  B23 <- matrix(rnorm(2 * 3), nrow = 2)
  expect_quick_equal(matmul_t_right, list(A = A43, B = B23))

  expect_quick_equal(
    matmul_t_vector,
    list(v = x3, B = matrix(rnorm(3 * 4), 3, 4))
  )

  X <- matrix(rnorm(5 * 3), nrow = 5)
  Yc <- matrix(rnorm(5 * 2), nrow = 5)
  Yt <- matrix(rnorm(2 * 3), nrow = 2)
  expect_quick_equal(crossprod_1, list(x = X))
  expect_quick_equal(crossprod_2, list(x = X, y = Yc))
  expect_quick_equal(tcrossprod_1, list(x = X))
  expect_quick_equal(tcrossprod_2, list(x = X, y = Yt))

  v2 <- rnorm(2)
  v3 <- rnorm(3)
  expect_quick_equal(outer_vv, list(x = v2, y = v3))
  expect_quick_equal(outer_sv, list(x = 1.25, y = v3))

  U <- matrix(c(2, 1, 0, 3), nrow = 2, byrow = TRUE)
  b <- rnorm(2)
  B_rhs <- matrix(rnorm(2 * 3), nrow = 2)
  expect_quick_equal(triangular_vec, list(U = U, b = b))
  expect_quick_equal(triangular_mat, list(U = U, B = B_rhs))

  base <- matrix(rnorm(9), 3, 3)
  A_pd <- crossprod(base) + diag(3)
  b3 <- rnorm(3)
  B32 <- matrix(rnorm(3 * 2), nrow = 3)
  expect_quick_equal(solve_inv, list(A = A_pd))
  expect_quick_equal(solve_vec, list(A = A_pd, b = b3))
  expect_quick_equal(solve_mat, list(A = A_pd, B = B32))
  expect_quick_equal(chol_out, list(A = A_pd))
  expect_quick_equal(chol2inv_out, list(A = A_pd))

  expect_quick_equal(diag_vec, list(x = rnorm(3)))
  expect_quick_equal(diag_mat, list(A = matrix(rnorm(6), nrow = 2)))
  expect_quick_equal(diag_missing_x, list(n = 3L))
  expect_quick_equal(diag_scalar_symbol_no_nrow, list())
  expect_quick_equal(
    diag_vec_with_nrow_ncol,
    list(x = rnorm(3), n = 4L, m = 2L)
  )
})

test_that("destination inference declines unsupported triangular/solve forms", {
  # These are public-facing errors, but they also exercise inference decline
  # paths (e.g., scalar RHS) without directly calling internal helpers.

  backsolve_scalar_rhs <- function(U, b) {
    declare(type(U = double(2, 2)), type(b = double(1)))
    out <- backsolve(U, b)
    out
  }

  solve_scalar_rhs <- function(A, b) {
    declare(type(A = double(2, 2)), type(b = double(1)))
    out <- solve(A, b)
    out
  }

  expect_error(
    quick(backsolve_scalar_rhs),
    regexp = "non-conformable arguments in triangular solve|expects a vector or matrix"
  )
  expect_error(
    quick(solve_scalar_rhs),
    regexp = "non-conformable arguments in solve|expects a vector or matrix"
  )
})

# Coverage-focused tests for matrix parsing helpers.

skip_on_cran()

test_that("transpose parsing handles scalars and rejects rank > 2", {
  scalar_left <- function(B) {
    declare(type(B = double(2, 2)))
    t(1.25) %*% B
  }

  expect_error(
    quick(scalar_left),
    "non-conformable arguments in %*%",
    fixed = TRUE
  )

  rank3_left <- function(x, B) {
    declare(type(x = double(2, 2, 2)), type(B = double(2, 2)))
    t(x) %*% B
  }

  expect_error(
    quick(rank3_left),
    "t() only supports rank 0-2 inputs",
    fixed = TRUE
  )
})

test_that("matrix helpers validate logical args", {
  bad_chol <- function(A) {
    declare(type(A = double(2, 2)))
    chol(A, pivot = 1)
  }

  expect_error(
    quick(bad_chol),
    "chol\\(\\) only supports literal pivot = TRUE/FALSE"
  )

  bad_diag <- function(x) {
    declare(type(x = double(3)))
    diag(x, names = 1)
  }

  expect_error(
    quick(bad_diag),
    "diag\\(\\) only supports literal names = TRUE/FALSE"
  )
})

# r2f-random.R
# Handlers for random number generation: runif

# --- Handlers ---

r2f_handlers[["runif"]] <- function(args, scope, ..., hoist = NULL) {
  scope_mark_uses_rng(scope)

  dims <- r2dims(args$n, scope)
  var <- Variable("double", dims)

  min <- args$min %||% 0
  max <- args$max %||% 1
  default_min <- identical(min, 0) || identical(min, 0L)
  default_max <- identical(max, 1) || identical(max, 1L)

  if (default_min && default_max) {
    get1rand <- "unif_rand()"
  } else if (default_min) {
    max <- r2f(max, scope, ..., hoist = hoist)
    get1rand <- glue("unif_rand() * {max}")
  } else {
    max <- r2f(max, scope, ..., hoist = hoist)
    min <- r2f(min, scope, ..., hoist = hoist)
    get1rand <- glue("({min} + (unif_rand() * ({max} - {min})))")
  }

  if (passes_as_scalar(var)) {
    fortran <- get1rand
  } else {
    tmp_i <- scope_unique_var(scope, "integer") ## would be better as uint64...
    fortran <- glue("[({get1rand}, {tmp_i}=1, {dims[[1L]]})]")
  }

  Fortran(fortran, var)
}

# Matrix BLAS/LAPACK emission helpers

# ---- shared matrix helpers (loaded early for implicit collation) ----

# Assert hoist is a valid environment for BLAS/LAPACK helpers.
assert_hoist_env <- function(hoist) {
  if (!inherits(hoist, "environment")) {
    stop("internal: hoist must be a hoist environment")
  }
  invisible(TRUE)
}

# Assert a Fortran value is a rank-2 matrix.
assert_rank2_matrix <- function(x, message) {
  stopifnot(inherits(x, Fortran), is_string(message))
  if (x@value@rank != 2L) {
    stop(message, call. = FALSE)
  }
  invisible(TRUE)
}

# Assert a Fortran value is a scalar or vector.
assert_rank_leq1 <- function(x, message) {
  stopifnot(inherits(x, Fortran), is_string(message))
  if (x@value@rank > 1L) {
    stop(message, call. = FALSE)
  }
  invisible(TRUE)
}

# Assert a Fortran value is rank 0-2.
assert_rank_leq2 <- function(x, message) {
  stopifnot(inherits(x, Fortran), is_string(message))
  if (x@value@rank > 2L) {
    stop(message, call. = FALSE)
  }
  invisible(TRUE)
}

# Assert right-hand side rank is vector or matrix.
assert_rhs_rank <- function(
  rank,
  err_scalar,
  err_high,
  call_scalar = FALSE,
  call_high = FALSE
) {
  stopifnot(
    is_wholenumber(rank),
    is_string(err_scalar),
    is_string(err_high),
    is_bool(call_scalar),
    is_bool(call_high)
  )
  if (rank > 2L) {
    stop(err_high, call. = call_high)
  }
  if (rank == 0L) {
    stop(err_scalar, call. = call_scalar)
  }
  invisible(TRUE)
}

# Assert conformability and warn on unknown.
assert_conformable_dims <- function(left, right, context, err_msg) {
  stopifnot(is_string(context), is_string(err_msg))
  conform <- check_conformable(left, right)
  if (!conform$ok) {
    stop(err_msg, call. = FALSE)
  }
  if (conform$unknown) {
    warn_conformability_unknown(left, right, context)
  }
  invisible(TRUE)
}

emit_quickr_error_if <- function(
  condition,
  message,
  hoist,
  scope
) {
  stopifnot(
    is_string(condition),
    is_string(message),
    inherits(hoist, "environment"),
    inherits(scope, "quickr_scope")
  )
  mark_scope_uses_errors(scope)
  err_lines <- quickr_error_fortran_lines(message, scope = scope)
  hoist$emit(glue(
    "
    if ({condition}) then
    {indent(str_flatten_lines(err_lines))}
    end if
    "
  ))
}

# Return the R symbol name if operand is a bare symbol; otherwise NULL.
symbol_name_or_null <- function(x) {
  stopifnot(inherits(x, Fortran))
  r_expr <- unwrap_parens(x@r)
  if (is.symbol(r_expr)) {
    return(as.character(r_expr))
  }
  if (length(x) == 1L && grepl("^[A-Za-z][A-Za-z0-9_]*$", x)) {
    return(as.character(x))
  }
  NULL
}

# Return a dimension value for an axis, defaulting missing dims to 1L.
dim_or_one_from <- function(dims, axis) {
  stopifnot(is.numeric(axis), axis >= 1)
  axis <- as.integer(axis)
  if (is.null(dims)) {
    return(1L)
  }
  if (axis <= length(dims) && !is.null(dims[[axis]])) {
    dims[[axis]]
  } else {
    1L
  }
}

# Return the requested axis length, defaulting scalars (or missing axes) to 1L.
dim_or_one <- function(x, axis) {
  stopifnot(inherits(x, Fortran))
  dim_or_one_from(x@value@dims, axis)
}

# Return the requested axis length for a Variable, defaulting to 1L.
var_dim_or_one <- function(var, axis) {
  stopifnot(inherits(var, Variable))
  dim_or_one_from(var@dims, axis)
}

# Compute matrix-style row/column dimensions from rank, dims, and orientation.
matrix_dims_from <- function(
  rank,
  dims,
  orientation = c("matrix", "rowvec", "colvec")
) {
  orientation <- match.arg(orientation)
  rows <- dim_or_one_from(dims, 1L)
  cols <- dim_or_one_from(dims, 2L)

  if (rank == 0L) {
    rows <- 1L
    cols <- 1L
  } else if (rank == 1L) {
    if (orientation == "rowvec") {
      rows <- 1L
      cols <- dim_or_one_from(dims, 1L)
    } else {
      rows <- dim_or_one_from(dims, 1L)
      cols <- 1L
    }
  }

  list(rows = rows, cols = cols)
}

# Interpret a Fortran value as a matrix for BLAS calls. Scalars become 1x1
# matrices, and vectors can be viewed as either row or column vectors.
matrix_dims <- function(x, orientation = c("matrix", "rowvec", "colvec")) {
  stopifnot(inherits(x, Fortran))
  matrix_dims_from(x@value@rank, x@value@dims, orientation = orientation)
}

# Interpret a Variable value as a matrix for BLAS calls.
matrix_dims_var <- function(
  var,
  orientation = c("matrix", "rowvec", "colvec")
) {
  stopifnot(inherits(var, Variable))
  matrix_dims_from(var@rank, var@dims, orientation = orientation)
}

# Compute effective dimensions based on transpose flags.
effective_dims <- function(dims, trans) {
  if (identical(trans, "T")) {
    list(rows = dims$cols, cols = dims$rows)
  } else {
    dims
  }
}

# Return conformability status (ok/unknown) without side-effects.
check_conformable <- function(left, right) {
  if (is_wholenumber(left) && is_wholenumber(right)) {
    ok <- identical(as.integer(left), as.integer(right))
    return(list(ok = ok, unknown = FALSE))
  }
  if (identical(left, right)) {
    return(list(ok = TRUE, unknown = FALSE))
  }
  list(ok = TRUE, unknown = TRUE)
}

warn_conformability_unknown <- function(left, right, context) {
  left_txt <- if (is.null(left)) "NULL" else deparse(left)
  right_txt <- if (is.null(right)) "NULL" else deparse(right)
  warning(
    "cannot verify conformability in ",
    context,
    " at compile time: ",
    left_txt,
    " vs ",
    right_txt,
    call. = FALSE
  )
  invisible(FALSE)
}

# Assert that dimensions represent a square matrix (rows == cols).
# Throws an error if dimensions are known to be non-conformable,
# and warns if conformability cannot be verified at compile time.
assert_square_matrix <- function(rows, cols, context) {
  conform <- check_conformable(rows, cols)
  if (!conform$ok) {
    stop(context, " requires a square matrix", call. = FALSE)
  }
  if (conform$unknown) {
    warn_conformability_unknown(rows, cols, context)
  }
  invisible(TRUE)
}

# ---- BLAS emitters ----

# Check that destination dimensions match expected output dimensions.
assert_dest_dims_compatible <- function(dest, expected_dims, context) {
  if (is.null(dest) || is.null(expected_dims)) {
    return(invisible(TRUE))
  }
  expected_rank <- length(expected_dims)
  if (dest@rank != expected_rank) {
    stop("assignment target has incompatible rank for ", context, call. = FALSE)
  }
  for (i in seq_len(expected_rank)) {
    dest_dim <- dest@dims[[i]]
    expected_dim <- expected_dims[[i]]
    if (is_wholenumber(dest_dim) && is_wholenumber(expected_dim)) {
      if (!identical(as.integer(dest_dim), as.integer(expected_dim))) {
        stop(
          "assignment target has incompatible dimensions for ",
          context,
          call. = FALSE
        )
      }
    }
  }
  invisible(TRUE)
}

# Determine if output can safely write into dest without aliasing.
can_use_output <- function(
  dest,
  input_names = character(),
  expected_dims = NULL,
  context,
  allow_alias = character()
) {
  if (is.null(dest)) {
    return(FALSE)
  }
  if (!identical(dest@mode, "double")) {
    return(FALSE)
  }
  assert_dest_dims_compatible(dest, expected_dims, context)
  output_name <- dest@name
  if (is.null(output_name) || !nzchar(output_name)) {
    return(FALSE)
  }

  input_names <- unique(as.character(input_names))
  input_names <- input_names[nzchar(input_names)]
  allow_alias <- unique(as.character(allow_alias))
  allow_alias <- allow_alias[nzchar(allow_alias)]
  disallowed <- setdiff(input_names, allow_alias)

  !output_name %in% disallowed
}

# Ensure a BLAS operand is named, hoisting into a temp if needed.
ensure_blas_operand_name <- function(x, hoist) {
  name <- symbol_name_or_null(x)
  if (!is.null(name)) {
    return(name)
  }
  tmp <- hoist$declare_tmp(
    mode = x@value@mode %||% "double",
    dims = x@value@dims
  )
  hoist$emit(glue("{tmp@name} = {x}"))
  tmp@name
}

# Wrap an expression as a BLAS int literal.
blas_int <- function(x) {
  x_str <- if (is.language(x)) {
    gsub("([0-9]+)L\\b", "\\1", deparse1(x))
  } else if (is_wholenumber(x)) {
    as.character(as.integer(x))
  } else {
    as.character(x)
  }
  glue("int({x_str}, kind=c_int)")
}

# Centralized GEMM emission with optional destination
# gemm: centralized BLAS GEMM emission.
# - 'hoist' is required and provided by r2f(); handlers thread it through so
#   helpers can pre-emit temporary assignments and BLAS calls.
gemm <- function(
  opA,
  opB,
  left,
  right,
  m,
  n,
  k,
  lda,
  ldb,
  ldc_expr,
  scope,
  hoist,
  dest = NULL,
  context = "gemm"
) {
  assert_hoist_env(hoist)
  A_name <- ensure_blas_operand_name(left, hoist)
  B_name <- ensure_blas_operand_name(right, hoist)

  if (
    can_use_output(
      dest,
      input_names = c(A_name, B_name),
      expected_dims = list(m, n),
      context = context
    )
  ) {
    hoist$emit(glue(
      "call dgemm('{opA}','{opB}', {blas_int(m)}, {blas_int(n)}, {blas_int(k)}, 1.0_c_double, {A_name}, {blas_int(lda)}, {B_name}, {blas_int(ldb)}, 0.0_c_double, {dest@name}, {blas_int(ldc_expr)})"
    ))
    out <- Fortran(dest@name, dest)
    out@writes_to_dest <- TRUE
    return(out)
  }

  output_var <- hoist$declare_tmp(mode = "double", dims = list(m, n))
  hoist$emit(glue(
    "call dgemm('{opA}','{opB}', {blas_int(m)}, {blas_int(n)}, {blas_int(k)}, 1.0_c_double, {A_name}, {blas_int(lda)}, {B_name}, {blas_int(ldb)}, 0.0_c_double, {output_var@name}, {blas_int(ldc_expr)})"
  ))
  Fortran(output_var@name, output_var)
}

# Centralized GEMV emission with optional destination
# gemv: centralized BLAS GEMV emission.
# - 'hoist' is required and provided by r2f(); handlers thread it through so
#   helpers can pre-emit temporary assignments and BLAS calls.
gemv <- function(
  transA,
  A,
  x,
  m,
  n,
  lda,
  out_dims,
  scope,
  hoist,
  dest = NULL,
  context = "gemv"
) {
  assert_hoist_env(hoist)
  A_name <- ensure_blas_operand_name(A, hoist)
  x_name <- ensure_blas_operand_name(x, hoist)

  if (
    can_use_output(
      dest,
      input_names = c(A_name, x_name),
      expected_dims = out_dims,
      context = context
    )
  ) {
    # Assign output to output destination
    hoist$emit(glue(
      "call dgemv('{transA}', {blas_int(m)}, {blas_int(n)}, 1.0_c_double, {A_name}, {blas_int(lda)}, {x_name}, 1_c_int, 0.0_c_double, {dest@name}, 1_c_int)"
    ))
    out <- Fortran(dest@name, dest)
    out@writes_to_dest <- TRUE
    return(out)
  }
  # Else assign to a temporary variable
  output_var <- hoist$declare_tmp(mode = "double", dims = out_dims)
  hoist$emit(glue(
    "call dgemv('{transA}', {blas_int(m)}, {blas_int(n)}, 1.0_c_double, {A_name}, {blas_int(lda)}, {x_name}, 1_c_int, 0.0_c_double, {output_var@name}, 1_c_int)"
  ))
  Fortran(output_var@name, output_var)
}

symmetrize_upper_to_lower <- function(target, n, hoist) {
  stopifnot(is_string(target))
  assert_hoist_env(hoist)

  idx_i <- hoist$declare_tmp(mode = "integer", dims = list(1L))
  idx_j <- hoist$declare_tmp(mode = "integer", dims = list(1L))
  n_int <- blas_int(n)
  hoist$emit(glue(
    "
do {idx_j@name} = 1_c_int, {n_int} - 1_c_int
  do {idx_i@name} = {idx_j@name} + 1_c_int, {n_int}
    {target}({idx_i@name}, {idx_j@name}) = {target}({idx_j@name}, {idx_i@name})
  end do
end do"
  ))
}

diag_length_expr <- function(nrow, ncol, context) {
  if (is_scalar_na(nrow) || is_scalar_na(ncol)) {
    stop(context, " requires known dimensions", call. = FALSE)
  }
  if (is_wholenumber(nrow) && is_wholenumber(ncol)) {
    return(as.integer(min(nrow, ncol)))
  }
  if (identical(nrow, ncol)) {
    return(nrow)
  }
  call("min", nrow, ncol)
}

zero_lower_triangle <- function(target, n, hoist) {
  stopifnot(is_string(target))
  assert_hoist_env(hoist)

  idx_i <- hoist$declare_tmp(mode = "integer", dims = NULL)
  idx_j <- hoist$declare_tmp(mode = "integer", dims = NULL)
  n_int <- blas_int(n)
  hoist$emit(glue(
    "
do {idx_i@name} = 2_c_int, {n_int}
  do {idx_j@name} = 1_c_int, {idx_i@name} - 1_c_int
    {target}({idx_i@name}, {idx_j@name}) = 0.0_c_double
  end do
end do"
  ))
}

# Centralized SYRK emission for symmetric rank-k update
# Computes: C := alpha * op(A) * op(A)^T + beta * C
# For crossprod(X):  C = t(X) %*% X  → trans = "T"
# For tcrossprod(X): C = X %*% t(X)  → trans = "N"
syrk <- function(
  trans,
  X,
  scope,
  hoist,
  dest = NULL,
  context = "syrk"
) {
  assert_hoist_env(hoist)
  X_name <- ensure_blas_operand_name(X, hoist)

  x_dims <- matrix_dims(X)

  # For trans = "T": C = t(X) %*% X, so C is k x k where k = ncol(X)
  # For trans = "N": C = X %*% t(X), so C is n x n where n = nrow(X)
  if (trans == "T") {
    n <- x_dims$cols
    k <- x_dims$rows
  } else {
    n <- x_dims$rows
    k <- x_dims$cols
  }
  lda <- x_dims$rows

  # Output is symmetric n x n matrix
  writes_to_dest <- FALSE
  out_var <- NULL
  out_name <- NULL

  if (
    can_use_output(
      dest,
      input_names = X_name,
      expected_dims = list(n, n),
      context = context
    )
  ) {
    writes_to_dest <- TRUE
    out_var <- dest
    out_name <- dest@name
  } else {
    out_var <- hoist$declare_tmp(mode = "double", dims = list(n, n))
    out_name <- out_var@name
  }

  hoist$emit(glue(
    "call dsyrk('U', '{trans}', {blas_int(n)}, {blas_int(k)}, 1.0_c_double, {X_name}, {blas_int(lda)}, 0.0_c_double, {out_name}, {blas_int(n)})"
  ))
  symmetrize_upper_to_lower(out_name, n, hoist = hoist)

  out <- Fortran(out_name, out_var)
  if (writes_to_dest) {
    out@writes_to_dest <- TRUE
  }
  out
}

# Emit BLAS outer product for vectors or scalars with optional destination.
outer_mul <- function(
  x,
  y,
  scope,
  hoist,
  dest = NULL,
  context = "outer"
) {
  assert_hoist_env(hoist)

  x <- maybe_cast_double(x)
  y <- maybe_cast_double(y)

  if (x@value@rank > 1L || y@value@rank > 1L) {
    stop("outer() only supports vectors or scalars")
  }

  m <- dim_or_one(x, 1L)
  n <- dim_or_one(y, 1L)

  x_name <- ensure_blas_operand_name(x, hoist)
  y_name <- ensure_blas_operand_name(y, hoist)

  if (
    can_use_output(
      dest,
      input_names = c(x_name, y_name),
      expected_dims = list(m, n),
      context = context
    )
  ) {
    hoist$emit(glue("{dest@name} = 0.0_c_double"))
    hoist$emit(glue(
      "call dger({blas_int(m)}, {blas_int(n)}, 1.0_c_double, {x_name}, 1_c_int, {y_name}, 1_c_int, {dest@name}, {blas_int(m)})"
    ))
    out <- Fortran(dest@name, dest)
    out@writes_to_dest <- TRUE
    return(out)
  }

  output_var <- hoist$declare_tmp(mode = "double", dims = list(m, n))
  hoist$emit(glue("{output_var@name} = 0.0_c_double"))
  hoist$emit(glue(
    "call dger({blas_int(m)}, {blas_int(n)}, 1.0_c_double, {x_name}, 1_c_int, {y_name}, 1_c_int, {output_var@name}, {blas_int(m)})"
  ))
  Fortran(output_var@name, output_var)
}

# Emit triangular solve (vector or matrix RHS) with optional destination.
triangular_solve <- function(
  A,
  B,
  uplo,
  trans,
  diag,
  scope,
  hoist,
  dest = NULL,
  context = "triangular solve"
) {
  assert_hoist_env(hoist)

  A <- maybe_cast_double(A)
  B <- maybe_cast_double(B)

  assert_rank2_matrix(A, "triangular solve expects a matrix")

  a_dims <- matrix_dims(A)
  conform <- check_conformable(a_dims$rows, a_dims$cols)
  if (!conform$ok) {
    stop("non-conformable arguments in triangular solve", call. = FALSE)
  }
  if (conform$unknown) {
    warn_conformability_unknown(a_dims$rows, a_dims$cols, "triangular solve")
  }
  n <- a_dims$rows

  b_rank <- B@value@rank
  assert_rhs_rank(
    b_rank,
    err_scalar = "triangular solve expects a vector or matrix right-hand side",
    err_high = "triangular solve only supports vector or matrix right-hand sides"
  )
  if (b_rank == 1L) {
    b_len <- dim_or_one(B, 1L)
    assert_conformable_dims(
      n,
      b_len,
      context = "triangular solve",
      err_msg = "non-conformable arguments in triangular solve"
    )
  } else {
    b_rows <- dim_or_one(B, 1L)
    assert_conformable_dims(
      n,
      b_rows,
      context = "triangular solve",
      err_msg = "non-conformable arguments in triangular solve"
    )
  }

  A_name <- ensure_blas_operand_name(A, hoist)
  B_input_name <- symbol_name_or_null(B)

  if (
    can_use_output(
      dest,
      input_names = c(A_name, B_input_name),
      expected_dims = B@value@dims,
      context = context,
      allow_alias = B_input_name
    )
  ) {
    hoist$emit(glue("{dest@name} = {B}"))
    B_name <- dest@name
    out_var <- dest
    writes_to_dest <- TRUE
  } else {
    out_var <- hoist$declare_tmp(
      mode = B@value@mode %||% "double",
      dims = B@value@dims
    )
    hoist$emit(glue("{out_var@name} = {B}"))
    B_name <- out_var@name
    writes_to_dest <- FALSE
  }

  if (b_rank <= 1L) {
    hoist$emit(glue(
      "call dtrsv('{uplo}', '{trans}', '{diag}', {blas_int(n)}, {A_name}, {blas_int(n)}, {B_name}, 1_c_int)"
    ))
  } else {
    nrhs <- dim_or_one(B, 2L)
    hoist$emit(glue(
      "call dtrsm('L', '{uplo}', '{trans}', '{diag}', {blas_int(n)}, {blas_int(nrhs)}, 1.0_c_double, {A_name}, {blas_int(n)}, {B_name}, {blas_int(n)})"
    ))
  }

  out <- Fortran(B_name, out_var)
  if (writes_to_dest) {
    out@writes_to_dest <- TRUE
  }
  out
}

lapack_solve <- function(
  A,
  B,
  scope,
  hoist,
  dest = NULL,
  context = "solve",
  tol = NULL
) {
  assert_hoist_env(hoist)

  A <- maybe_cast_double(A)
  B <- maybe_cast_double(B)

  assert_rank2_matrix(A, paste0(context, " expects a matrix for `a`"))

  a_dims <- matrix_dims(A)
  m <- a_dims$rows
  n <- a_dims$cols

  b_rank <- B@value@rank
  assert_rhs_rank(
    b_rank,
    err_scalar = paste0(context, " expects a vector or matrix right-hand side"),
    err_high = paste0(
      context,
      " only supports vector or matrix right-hand sides"
    ),
    call_scalar = FALSE,
    call_high = FALSE
  )

  if (b_rank == 1L) {
    b_len <- dim_or_one(B, 1L)
    assert_conformable_dims(
      m,
      b_len,
      context = context,
      err_msg = paste0("non-conformable arguments in ", context)
    )
  } else {
    b_rows <- dim_or_one(B, 1L)
    assert_conformable_dims(
      m,
      b_rows,
      context = context,
      err_msg = paste0("non-conformable arguments in ", context)
    )
  }

  A_name <- ensure_blas_operand_name(A, hoist)
  B_input_name <- ensure_blas_operand_name(B, hoist)

  nrhs <- if (b_rank == 1L) 1L else dim_or_one(B, 2L)

  square <- check_conformable(m, n)
  if (square$ok && !square$unknown && !identical(context, "qr.solve")) {
    A_work <- hoist$declare_tmp(mode = "double", dims = list(m, m))
    hoist$emit(glue("{A_work@name} = {A_name}"))

    expected_dims <- if (b_rank == 1L) list(n) else list(n, nrhs)
    writes_to_dest <- FALSE
    if (
      can_use_output(
        dest,
        input_names = c(A_name, B_input_name),
        expected_dims = expected_dims,
        context = context,
        allow_alias = B_input_name
      )
    ) {
      out_var <- dest
      out_name <- dest@name
      writes_to_dest <- TRUE
    } else {
      out_var <- hoist$declare_tmp(mode = "double", dims = expected_dims)
      out_name <- out_var@name
    }
    hoist$emit(glue("{out_name} = {B_input_name}"))

    ipiv <- hoist$declare_tmp(mode = "integer", dims = list(m))
    info <- hoist$declare_tmp(mode = "integer", dims = NULL)

    hoist$emit(glue(
      "call dgesv({blas_int(m)}, {blas_int(nrhs)}, {A_work@name}, {blas_int(m)}, {ipiv@name}, {out_name}, {blas_int(m)}, {info@name})"
    ))
    emit_quickr_error_if(
      condition = glue("{info@name} > 0_c_int"),
      message = "Lapack routine dgesv: system is exactly singular",
      hoist = hoist,
      scope = scope
    )
    emit_quickr_error_if(
      condition = glue("{info@name} < 0_c_int"),
      message = "Lapack routine dgesv: illegal argument",
      hoist = hoist,
      scope = scope
    )

    out <- Fortran(out_name, out_var)
    if (writes_to_dest) {
      out@writes_to_dest <- TRUE
    }
    return(out)
  }

  if (identical(context, "qr.solve")) {
    A_work <- hoist$declare_tmp(mode = "double", dims = list(m, n))
    hoist$emit(glue("{A_work@name} = {A_name}"))

    B_work <- hoist$declare_tmp(mode = "double", dims = list(m, nrhs))
    m_f <- dims2f(list(m), scope)
    if (!nzchar(m_f)) {
      m_f <- "1"
    }
    nrhs_f <- dims2f(list(nrhs), scope)
    if (!nzchar(nrhs_f)) {
      nrhs_f <- "1"
    }
    hoist$emit(glue("{B_work@name} = 0.0_c_double"))
    if (b_rank == 1L) {
      hoist$emit(glue("{B_work@name}(1:{m_f}, 1) = {B_input_name}"))
    } else {
      hoist$emit(glue("{B_work@name}(1:{m_f}, 1:{nrhs_f}) = {B_input_name}"))
    }

    qraux <- hoist$declare_tmp(mode = "double", dims = list(n))
    jpvt <- hoist$declare_tmp(mode = "integer", dims = list(n))
    work <- hoist$declare_tmp(mode = "double", dims = list(n, 2L))
    rank <- hoist$declare_tmp(mode = "integer", dims = NULL)
    idx <- hoist$declare_tmp(mode = "integer", dims = NULL)

    hoist$emit(glue(
      "
do {idx@name} = 1_c_int, {blas_int(n)}
  {jpvt@name}({idx@name}) = {idx@name}
end do"
    ))

    tol_value <- if (is.null(tol)) "1e-7_c_double" else as.character(tol)
    mn <- call("min", m, n)
    hoist$emit(glue(
      "call dqrdc2({A_work@name}, {blas_int(m)}, {blas_int(m)}, {blas_int(n)}, {tol_value}, {rank@name}, {qraux@name}, {jpvt@name}, {work@name})"
    ))

    emit_quickr_error_if(
      condition = glue("{rank@name} < {blas_int(mn)}"),
      message = "rank deficient matrix in qr.solve",
      hoist = hoist,
      scope = scope
    )

    coef_work <- hoist$declare_tmp(
      mode = "double",
      dims = list(mn, nrhs)
    )
    hoist$emit(glue("{coef_work@name} = 0.0_c_double"))
    info <- hoist$declare_tmp(mode = "integer", dims = NULL)

    hoist$emit(glue(
      "call dqrcf({A_work@name}, {blas_int(m)}, {rank@name}, {qraux@name}, {B_work@name}, {blas_int(nrhs)}, {coef_work@name}, {info@name})"
    ))
    emit_quickr_error_if(
      condition = glue("{info@name} /= 0_c_int"),
      message = "exact singularity in 'qr.coef'",
      hoist = hoist,
      scope = scope
    )

    expected_dims <- if (b_rank == 1L) list(n) else list(n, nrhs)
    writes_to_dest <- FALSE
    if (
      can_use_output(
        dest,
        input_names = c(A_name, B_input_name),
        expected_dims = expected_dims,
        context = context,
        allow_alias = B_input_name
      )
    ) {
      out_var <- dest
      out_name <- dest@name
      writes_to_dest <- TRUE
    } else {
      out_var <- hoist$declare_tmp(mode = "double", dims = expected_dims)
      out_name <- out_var@name
    }

    if (passes_as_scalar(out_var)) {
      hoist$emit(glue("{out_name} = {coef_work@name}(1, 1)"))
    } else {
      hoist$emit(glue("{out_name} = 0.0_c_double"))
      if (b_rank == 1L) {
        idx <- hoist$declare_tmp(mode = "integer", dims = NULL)
        hoist$emit(glue(
          "
do {idx@name} = 1_c_int, {rank@name}
  {out_name}({jpvt@name}({idx@name})) = {coef_work@name}({idx@name}, 1)
end do"
        ))
      } else {
        idx_i <- hoist$declare_tmp(mode = "integer", dims = NULL)
        idx_j <- hoist$declare_tmp(mode = "integer", dims = NULL)
        hoist$emit(glue(
          "
do {idx_j@name} = 1_c_int, {blas_int(nrhs)}
  do {idx_i@name} = 1_c_int, {rank@name}
    {out_name}({jpvt@name}({idx_i@name}), {idx_j@name}) = {coef_work@name}({idx_i@name}, {idx_j@name})
  end do
end do"
        ))
      }
    }

    out <- Fortran(out_name, out_var)
    if (writes_to_dest) {
      out@writes_to_dest <- TRUE
    }
    return(out)
  }

  A_work <- hoist$declare_tmp(mode = "double", dims = list(m, n))
  hoist$emit(glue("{A_work@name} = {A_name}"))

  max_mn <- call("max", m, n)

  B_work <- hoist$declare_tmp(mode = "double", dims = list(max_mn, nrhs))
  m_f <- dims2f(list(m), scope)
  if (!nzchar(m_f)) {
    m_f <- "1"
  }
  n_f <- dims2f(list(n), scope)
  if (!nzchar(n_f)) {
    n_f <- "1"
  }
  nrhs_f <- dims2f(list(nrhs), scope)
  if (!nzchar(nrhs_f)) {
    nrhs_f <- "1"
  }
  hoist$emit(glue("{B_work@name} = 0.0_c_double"))
  if (b_rank == 1L) {
    hoist$emit(glue("{B_work@name}(1:{m_f}, 1) = {B_input_name}"))
  } else {
    hoist$emit(glue("{B_work@name}(1:{m_f}, 1:{nrhs_f}) = {B_input_name}"))
  }

  info <- hoist$declare_tmp(mode = "integer", dims = NULL)

  mn <- call("min", m, n)
  if (identical(context, "qr.solve")) {
    jpvt <- hoist$declare_tmp(mode = "integer", dims = list(n))
    hoist$emit(glue("{jpvt@name} = 0_c_int"))

    rcond <- if (is.null(tol)) "1e-7_c_double" else as.character(tol)
    rank <- hoist$declare_tmp(mode = "integer", dims = NULL)

    lwork <- call(
      "max",
      1L,
      call("+", mn, call("max", mn, nrhs)),
      call("+", call("*", 2L, mn), call("*", 64L, call("+", n, 1L))),
      call("+", mn, call("*", 2L, n))
    )
    work <- hoist$declare_tmp(mode = "double", dims = list(lwork))

    hoist$emit(glue(
      "call dgelsy({blas_int(m)}, {blas_int(n)}, {blas_int(nrhs)}, {A_work@name}, {blas_int(m)}, {B_work@name}, {blas_int(max_mn)}, {jpvt@name}, {rcond}, {rank@name}, {work@name}, {blas_int(lwork)}, {info@name})"
    ))
    emit_quickr_error_if(
      condition = glue("{info@name} < 0_c_int"),
      message = "Lapack routine dgelsy: illegal argument",
      hoist = hoist,
      scope = scope
    )
    emit_quickr_error_if(
      condition = glue("{info@name} > 0_c_int"),
      message = "Lapack routine dgelsy failed to converge",
      hoist = hoist,
      scope = scope
    )
    emit_quickr_error_if(
      condition = glue("{rank@name} < {blas_int(n)}"),
      message = "rank deficient matrix in qr.solve",
      hoist = hoist,
      scope = scope
    )
  } else {
    lwork <- call("max", 1L, call("+", mn, call("max", mn, nrhs)))
    work <- hoist$declare_tmp(mode = "double", dims = list(lwork))

    hoist$emit(glue(
      "call dgels('N', {blas_int(m)}, {blas_int(n)}, {blas_int(nrhs)}, {A_work@name}, {blas_int(m)}, {B_work@name}, {blas_int(max_mn)}, {work@name}, {blas_int(lwork)}, {info@name})"
    ))
    emit_quickr_error_if(
      condition = glue("{info@name} < 0_c_int"),
      message = "Lapack routine dgels: illegal argument",
      hoist = hoist,
      scope = scope
    )
  }

  expected_dims <- if (b_rank == 1L) list(n) else list(n, nrhs)
  writes_to_dest <- FALSE
  if (
    can_use_output(
      dest,
      input_names = c(A_name, B_input_name),
      expected_dims = expected_dims,
      context = context,
      allow_alias = B_input_name
    )
  ) {
    out_var <- dest
    out_name <- dest@name
    writes_to_dest <- TRUE
  } else {
    out_var <- hoist$declare_tmp(mode = "double", dims = expected_dims)
    out_name <- out_var@name
  }

  if (b_rank == 1L) {
    if (passes_as_scalar(out_var)) {
      hoist$emit(glue("{out_name} = {B_work@name}(1, 1)"))
    } else {
      hoist$emit(glue("{out_name} = {B_work@name}(1:{n_f}, 1)"))
    }
  } else {
    hoist$emit(glue("{out_name} = {B_work@name}(1:{n_f}, 1:{nrhs_f})"))
  }

  out <- Fortran(out_name, out_var)
  if (writes_to_dest) {
    out@writes_to_dest <- TRUE
  }
  out
}

lapack_inverse <- function(A, scope, hoist, dest = NULL, context = "solve") {
  assert_hoist_env(hoist)

  A <- maybe_cast_double(A)
  assert_rank2_matrix(A, paste0(context, " expects a matrix for `a`"))

  a_dims <- matrix_dims(A)
  assert_square_matrix(a_dims$rows, a_dims$cols, context)
  n <- a_dims$rows

  A_name <- ensure_blas_operand_name(A, hoist)

  writes_to_dest <- FALSE
  if (
    can_use_output(
      dest,
      input_names = A_name,
      expected_dims = list(n, n),
      context = context,
      allow_alias = A_name
    )
  ) {
    out_var <- dest
    out_name <- dest@name
    writes_to_dest <- TRUE
  } else {
    out_var <- hoist$declare_tmp(mode = "double", dims = list(n, n))
    out_name <- out_var@name
  }

  hoist$emit(glue("{out_name} = {A_name}"))

  ipiv <- hoist$declare_tmp(mode = "integer", dims = list(n))
  info <- hoist$declare_tmp(mode = "integer", dims = NULL)
  work <- hoist$declare_tmp(mode = "double", dims = list(n))

  hoist$emit(glue(
    "call dgetrf({blas_int(n)}, {blas_int(n)}, {out_name}, {blas_int(n)}, {ipiv@name}, {info@name})"
  ))
  emit_quickr_error_if(
    condition = glue("{info@name} > 0_c_int"),
    message = "Lapack routine dgetrf: system is exactly singular",
    hoist = hoist,
    scope = scope
  )
  emit_quickr_error_if(
    condition = glue("{info@name} < 0_c_int"),
    message = "Lapack routine dgetrf: illegal argument",
    hoist = hoist,
    scope = scope
  )
  hoist$emit(glue(
    "call dgetri({blas_int(n)}, {out_name}, {blas_int(n)}, {ipiv@name}, {work@name}, {blas_int(n)}, {info@name})"
  ))
  emit_quickr_error_if(
    condition = glue("{info@name} > 0_c_int"),
    message = "Lapack routine dgetri: system is exactly singular",
    hoist = hoist,
    scope = scope
  )
  emit_quickr_error_if(
    condition = glue("{info@name} < 0_c_int"),
    message = "Lapack routine dgetri: illegal argument",
    hoist = hoist,
    scope = scope
  )

  out <- Fortran(out_name, out_var)
  if (writes_to_dest) {
    out@writes_to_dest <- TRUE
  }
  out
}

lapack_chol <- function(A, scope, hoist, dest = NULL, context = "chol") {
  assert_hoist_env(hoist)

  A <- maybe_cast_double(A)
  assert_rank2_matrix(A, paste0(context, " expects a matrix"))

  a_dims <- matrix_dims(A)
  assert_square_matrix(a_dims$rows, a_dims$cols, context)
  n <- a_dims$rows

  A_name <- ensure_blas_operand_name(A, hoist)

  writes_to_dest <- FALSE
  if (
    can_use_output(
      dest,
      input_names = A_name,
      expected_dims = list(n, n),
      context = context,
      allow_alias = A_name
    )
  ) {
    out_var <- dest
    out_name <- dest@name
    writes_to_dest <- TRUE
  } else {
    out_var <- hoist$declare_tmp(mode = "double", dims = list(n, n))
    out_name <- out_var@name
  }

  hoist$emit(glue("{out_name} = {A_name}"))

  info <- hoist$declare_tmp(mode = "integer", dims = NULL)
  hoist$emit(glue(
    "call dpotrf('U', {blas_int(n)}, {out_name}, {blas_int(n)}, {info@name})"
  ))
  emit_quickr_error_if(
    condition = glue("{info@name} > 0_c_int"),
    message = "Lapack routine dpotrf: leading minor is not positive definite",
    hoist = hoist,
    scope = scope
  )
  emit_quickr_error_if(
    condition = glue("{info@name} < 0_c_int"),
    message = "Lapack routine dpotrf: illegal argument",
    hoist = hoist,
    scope = scope
  )
  zero_lower_triangle(out_name, n, hoist = hoist)

  out <- Fortran(out_name, out_var)
  if (writes_to_dest) {
    out@writes_to_dest <- TRUE
  }
  out
}

lapack_chol2inv <- function(
  R,
  scope,
  hoist,
  dest = NULL,
  context = "chol2inv"
) {
  assert_hoist_env(hoist)

  R <- maybe_cast_double(R)
  assert_rank2_matrix(R, paste0(context, " expects a matrix"))

  r_dims <- matrix_dims(R)
  assert_square_matrix(r_dims$rows, r_dims$cols, context)
  n <- r_dims$rows

  R_name <- ensure_blas_operand_name(R, hoist)

  writes_to_dest <- FALSE
  if (
    can_use_output(
      dest,
      input_names = R_name,
      expected_dims = list(n, n),
      context = context,
      allow_alias = R_name
    )
  ) {
    out_var <- dest
    out_name <- dest@name
    writes_to_dest <- TRUE
  } else {
    out_var <- hoist$declare_tmp(mode = "double", dims = list(n, n))
    out_name <- out_var@name
  }

  hoist$emit(glue("{out_name} = {R_name}"))

  info <- hoist$declare_tmp(mode = "integer", dims = NULL)
  hoist$emit(glue(
    "call dpotri('U', {blas_int(n)}, {out_name}, {blas_int(n)}, {info@name})"
  ))
  emit_quickr_error_if(
    condition = glue("{info@name} > 0_c_int"),
    message = "Lapack routine dpotri: matrix is not positive definite",
    hoist = hoist,
    scope = scope
  )
  emit_quickr_error_if(
    condition = glue("{info@name} < 0_c_int"),
    message = "Lapack routine dpotri: illegal argument",
    hoist = hoist,
    scope = scope
  )
  symmetrize_upper_to_lower(out_name, n, hoist = hoist)

  out <- Fortran(out_name, out_var)
  if (writes_to_dest) {
    out@writes_to_dest <- TRUE
  }
  out
}

diag_extract <- function(x, scope, hoist, dest = NULL, context = "diag") {
  assert_hoist_env(hoist)

  x <- maybe_cast_double(x)
  assert_rank2_matrix(x, paste0(context, " expects a matrix input"))

  x_dims <- matrix_dims(x)
  diag_len <- diag_length_expr(x_dims$rows, x_dims$cols, context)

  x_name <- ensure_blas_operand_name(x, hoist)

  writes_to_dest <- FALSE
  if (
    can_use_output(
      dest,
      input_names = x_name,
      expected_dims = list(diag_len),
      context = context
    )
  ) {
    out_var <- dest
    out_name <- dest@name
    writes_to_dest <- TRUE
  } else {
    out_var <- hoist$declare_tmp(mode = "double", dims = list(diag_len))
    out_name <- out_var@name
  }

  idx_i <- hoist$declare_tmp(mode = "integer", dims = NULL)
  hoist$emit(glue(
    "
do {idx_i@name} = 1_c_int, {blas_int(diag_len)}
  {out_name}({idx_i@name}) = {x_name}({idx_i@name}, {idx_i@name})
end do"
  ))

  out <- Fortran(out_name, out_var)
  if (writes_to_dest) {
    out@writes_to_dest <- TRUE
  }
  out
}

diag_matrix <- function(
  x,
  nrow,
  ncol,
  scope,
  hoist,
  dest = NULL,
  context = "diag"
) {
  assert_hoist_env(hoist)

  x <- maybe_cast_double(x)
  assert_rank_leq1(x, paste0(context, " expects a vector or scalar input"))

  diag_len <- diag_length_expr(nrow, ncol, context)
  x_scalar <- passes_as_scalar(x@value)
  x_len <- if (x_scalar) 1L else dim_or_one(x, 1L)

  x_name <- ensure_blas_operand_name(x, hoist)

  writes_to_dest <- FALSE
  if (
    can_use_output(
      dest,
      input_names = x_name,
      expected_dims = list(nrow, ncol),
      context = context
    )
  ) {
    out_var <- dest
    out_name <- dest@name
    writes_to_dest <- TRUE
  } else {
    out_var <- hoist$declare_tmp(mode = "double", dims = list(nrow, ncol))
    out_name <- out_var@name
  }

  hoist$emit(glue("{out_name} = 0.0_c_double"))

  idx_i <- hoist$declare_tmp(mode = "integer", dims = NULL)
  value_expr <- if (x_scalar) {
    x_name
  } else {
    idx_expr <- glue(
      "1_c_int + mod({idx_i@name} - 1_c_int, {blas_int(x_len)})"
    )
    glue("{x_name}({idx_expr})")
  }

  hoist$emit(glue(
    "
do {idx_i@name} = 1_c_int, {blas_int(diag_len)}
  {out_name}({idx_i@name}, {idx_i@name}) = {value_expr}
end do"
  ))

  out <- Fortran(out_name, out_var)
  if (writes_to_dest) {
    out@writes_to_dest <- TRUE
  }
  out
}

svd_dims <- function(A, context = "svd") {
  stopifnot(inherits(A, Fortran))
  assert_rank2_matrix(A, paste0(context, " expects a matrix"))
  a_dims <- matrix_dims(A)
  m <- a_dims$rows
  n <- a_dims$cols
  mn <- if (is_wholenumber(m) && is_wholenumber(n)) {
    as.integer(min(m, n))
  } else {
    call("min", m, n)
  }
  list(m = m, n = n, mn = mn)
}

lapack_svd <- function(
  A,
  d,
  u,
  v,
  scope,
  hoist,
  context = "svd"
) {
  assert_hoist_env(hoist)
  stopifnot(inherits(d, Variable), inherits(u, Variable), inherits(v, Variable))

  A <- maybe_cast_double(A)
  dims <- svd_dims(A, context = context)
  m <- dims$m
  n <- dims$n
  mn <- dims$mn

  A_name <- ensure_blas_operand_name(A, hoist)
  A_work <- hoist$declare_tmp(mode = "double", dims = list(m, n))
  hoist$emit(glue("{A_work@name} = {A_name}"))

  vt <- hoist$declare_tmp(mode = "double", dims = list(mn, n))

  info <- hoist$declare_tmp(mode = "integer", dims = NULL)
  lwork <- hoist$declare_tmp(mode = "integer", dims = NULL)
  work_query <- hoist$declare_tmp(
    mode = "double",
    dims = list(call("+", 1L, 0L))
  )
  iwork <- hoist$declare_tmp(
    mode = "integer",
    dims = list(call("*", 8L, mn))
  )

  hoist$emit(glue("{lwork@name} = -1_c_int"))
  hoist$emit(glue(
    "call dgesdd('S', {blas_int(m)}, {blas_int(n)}, {A_work@name}, {blas_int(m)}, {d@name}, {u@name}, {blas_int(m)}, {vt@name}, {blas_int(mn)}, {work_query@name}, {lwork@name}, {iwork@name}, {info@name})"
  ))
  hoist$emit(glue(
    "{lwork@name} = int({work_query@name}(1), kind=c_int)"
  ))
  work <- hoist$declare_tmp(mode = "double", dims = list(NA))
  hoist$emit(glue("allocate({work@name}({lwork@name}))"))

  hoist$emit(glue(
    "call dgesdd('S', {blas_int(m)}, {blas_int(n)}, {A_work@name}, {blas_int(m)}, {d@name}, {u@name}, {blas_int(m)}, {vt@name}, {blas_int(mn)}, {work@name}, {lwork@name}, {iwork@name}, {info@name})"
  ))
  emit_quickr_error_if(
    glue("{info@name} < 0_c_int"),
    "Lapack routine dgesdd: illegal argument",
    hoist,
    scope
  )
  emit_quickr_error_if(
    glue("{info@name} > 0_c_int"),
    "Lapack routine dgesdd failed to converge",
    hoist,
    scope
  )
  hoist$emit(glue("{v@name} = transpose({vt@name})"))

  invisible(list(d = d, u = u, v = v))
}

#' Compile all `quick()` functions in a package.
#'
#' This will compile all `quick()` functions in an R package, and
#' generate source files in the `src/` directory.
#'
#' Note, this function is automatically invoked during a `pkgload::load_all()` call.
#'
#' @param path Path to an R package
#'
#' @returns Called for its side effect.
#' @export
compile_package <- function(path = ".") {
  if (path != ".") {
    owd <- setwd(path)
    on.exit(setwd(owd), add = TRUE)
  }

  if (!dir.exists("R") || !file.exists("DESCRIPTION")) {
    stop(path, " does not appear to be an R package.")
  }

  pkgname <- read.dcf("DESCRIPTION", "Package")
  if (length(pkgname) != 1) {
    stop(sprintf("path '%s' does not point to an R package", path))
  }
  pkgname <- as.character(pkgname)

  # TODO: need to unset various R_* env vars, or just
  # take a dep on callr
  # TODO: prompt to install pkgload if not available?
  out <- suppressWarnings(system2(
    file.path(R.home("bin"), "R"),
    c("-q", "-e", shQuote("pkgload::load_all(quiet = TRUE)")),
    stdout = TRUE,
    stderr = TRUE
  ))
  if (!is.null(status <- attr(out, "status"))) {
    stop(
      "pkgload::load_all() failed with status ",
      status,
      ":\n",
      paste(out, collapse = "\n"),
      call. = FALSE
    )
  }
  invisible(out)
}


dump_collected <- function() {
  collected <- collector$get_collected()

  # try to resolve closure names for anonymous functions
  pkg_ns <- topenv(environment(collected[[1L]]$closure))
  pkg_funcs <- as.list.environment(pkg_ns, all.names = TRUE)
  tab <- hashtab("address", length(collected))
  for (i in seq_along(pkg_funcs)) {
    if (typeof(fn <- pkg_funcs[[i]]) == "closure") {
      # if is quick closure ...
      sethash(tab, pkg_funcs[[i]], names(pkg_funcs)[i])
    }
  }

  quick_funcs <- unlist(
    recursive = FALSE,
    lapply(collected, function(x) {
      if (!startsWith(x$name, "anonymous_quick_function_")) {
        return(setNames(list(x$closure), x$name))
      }
      true_name <- gethash(tab, x$quick_closure)
      if (is.null(true_name)) {
        return(setNames(list(x$closure), x$name))
      }
      # update pkg_ns with true name
      quick_closure <- create_quick_closure(true_name, x$closure)
      pkg_ns[[true_name]] <- quick_closure
      remhash(tab, x$quick_closure)
      setNames(list(x$closure), true_name)
    })
  )

  pkgname <- basename(normalizePath("."))

  # check if we have a useDynLib line in NAMESPACE.
  if (
    !any(sapply(parse(file = "NAMESPACE"), function(e) {
      identical(e[[1]], quote(useDynLib)) && isTRUE(e$.registration)
    }))
  ) {
    message(
      "- Please add this roxygen directive somewhere in the Package R sources:\n  ",
      glue("#' @useDynLib {pkgname}, .registration = TRUE"),
      "\n",
      "- Then run `devtools::document()`\n"
    )
  }

  compiled_quick_funcs <- imap(quick_funcs, function(func, name) {
    fsub <- new_fortran_subroutine(name, func)
    cbridge <- make_c_bridge(fsub, headers = FALSE)
    list(
      name = name,
      f90 = fsub,
      c = cbridge
    )
  })

  if (length(compiled_quick_funcs)) {
    compiled_quick_funcs[[1L]]$c <- make_c_bridge(
      compiled_quick_funcs[[1L]]$f90,
      headers = TRUE,
      force_rng_header = TRUE,
      force_rmath_header = TRUE
    )
  }

  sources <- zip_lists(lapply(compiled_quick_funcs, function(x) {
    list(f90 = x$f90, c = x$c)
  })) |>
    lapply(\(x) x |> unlist() |> interleave("\n"))

  entry_lines <- c(
    sprintf('  {"%1$s", (DL_FUNC) &%1$s, -1}', paste0(names(quick_funcs), "_")),
    "  {NULL, NULL, 0}"
  )
  entries <- paste(entry_lines, collapse = ",\n")
  entries <- sprintf(
    "static const R_ExternalMethodDef QuickrEntries[] = {\n%s\n};",
    entries
  )

  append(sources$c) <- c("", entries, "")

  R_init_pkg <- paste0("R_init_", pkgname, "(")
  has_pkg_init_fn <- list.files(
    "src",
    pattern = "\\.(c|cpp|h|hpp|c\\+\\+)$",
    recursive = TRUE,
    all.files = TRUE,
    full.names = TRUE
  ) |>
    setdiff("src/quickr_entrypoints.c") |>
    lapply(function(f) {
      any(grepl(R_init_pkg, readLines(f, warn = FALSE), fixed = TRUE))
    }) |>
    unlist() |>
    any()

  append(sources$c) <- c("#include <R_ext/Rdynload.h>", "")

  init_fn <- if (has_pkg_init_fn) {
    glue(
      "
      void R_init_{pkgname}_quick_functions(DllInfo *dll) {{
        R_registerRoutines(dll, NULL, NULL, NULL, QuickrEntries);
      }}"
    )
  } else {
    init_pkgname <- gsub(".", "_", pkgname, fixed = TRUE)
    glue(
      "
      void R_init_{init_pkgname}(DllInfo *dll) {{
        R_registerRoutines(dll, NULL, NULL, NULL, QuickrEntries);
        R_useDynamicSymbols(dll, FALSE);
      }}"
    )
  }

  append(sources$c) <- init_fn

  sources <- lapply(sources, str_split_lines)

  src_files_written <- FALSE
  if (!file.exists("src")) {
    dir.create("src")
  }
  cbridges_filepath <- "src/quickr_entrypoints.c"
  if (
    !file.exists(cbridges_filepath) ||
      !identical(sources$c, readLines(cbridges_filepath))
  ) {
    unlink(sprintf("%s.o", tools::file_path_sans_ext(cbridges_filepath)))
    unlink(pkg_dll_path(pkgname)) # TODO: this might fail on windows - need a fallback.
    writeLines(sources$c, cbridges_filepath)
    cli::cli_inform(c(i = "Updated {.file {cbridges_filepath}}"))
    src_files_written <- TRUE
  }

  fsubs_filepath <- "src/quickr_sub_routines.f90"
  if (
    !file.exists(fsubs_filepath) ||
      !identical(sources$f90, readLines(fsubs_filepath))
  ) {
    unlink(sprintf("%s.o", tools::file_path_sans_ext(fsubs_filepath)))
    unlink(pkg_dll_path(pkgname)) # TODO: this might fail on windows - need a fallback.
    writeLines(sources$f90, fsubs_filepath)
    cli::cli_inform(c(i = "Updated {.file {fsubs_filepath}}"))
    src_files_written <- TRUE
  }

  if (src_files_written) {
    for (i in seq_along(sys.calls())) {
      if (identical(sys.function(i), pkgload::load_all)) {
        defer(pkgload::load_all(), sys.frame(i), after = TRUE)
        rlang::return_from(sys.frame(i), value = invisible())
        break
      }
    }
  }
  invisible()
}

pkg_dll_path <- function(pkgname) {
  file.path("src", paste0(pkgname, .Platform$dynlib.ext))
}


collector <- local({
  .collected <- NULL

  activate <- function(name = NULL) {
    .collected <<- list()
    attr(.collected, "name") <<- name
  }

  is_active <- function() {
    is.list(.collected)
  }

  add <- function(...) {
    .collected[[length(.collected) + 1L]] <<- list(...)
  }

  get_collected <- function(clear = TRUE) {
    if (clear) {
      on.exit(.collected <<- NULL)
    }
    .collected
  }

  environment()
})

skip_on_cran()

test_that("quick requires explicit names inside packages", {
  pkg_call <- function() {
    quick(function(x) {
      declare(type(x = double(1)))
      x + 1
    })
  }
  environment(pkg_call) <- asNamespace("stats")

  expect_error(pkg_call(), "must provide a unique `name`", fixed = TRUE)
})

test_that("quick returns a closure in package context when named", {
  pkg_call <- function() {
    quick("pkg_fun", function(x) {
      declare(type(x = double(1)))
      x + 1
    })
  }
  environment(pkg_call) <- asNamespace("stats")

  qfn <- pkg_call()
  expect_true(is.function(qfn))
})

test_that("quick activates the collector during pkgload load_code", {
  skip_if_not_installed("pkgload")

  withr::local_envvar(DEVTOOLS_LOAD = "quickr-test")
  quickr:::collector$get_collected()
  withr::defer(quickr:::collector$get_collected())

  local_mocked_bindings(
    dump_collected = function() invisible(NULL),
    .package = "quickr"
  )
  local_mocked_bindings(
    load_code = function(code) code(),
    .package = "pkgload"
  )

  qfn <- pkgload::load_code(function() {
    quick(function(x) {
      declare(type(x = double(1)))
      x + 1
    })
  })

  expect_true(is.function(qfn))
  expect_true(quickr:::collector$is_active())
})

skip_on_cran()

test_that("package compilation: local closures don't collide across quick functions", {
  pkgdir <- withr::local_tempdir(pattern = "quickr-contains-pkg-")
  pkgpath <- file.path(pkgdir, "quickr.contains.pkg")
  dir.create(pkgpath)
  dir.create(file.path(pkgpath, "R"))
  dir.create(file.path(pkgpath, "src"))

  writeLines(
    c(
      "Package: quickr.contains.pkg",
      "Title: quickr internal-proc test package",
      "Version: 0.0.0.9000",
      "Description: Internal tests for quickr package compilation.",
      "License: MIT",
      "Encoding: UTF-8",
      "RoxygenNote: 7.3.2",
      "Imports: quickr"
    ),
    file.path(pkgpath, "DESCRIPTION")
  )

  writeLines(
    c(
      "useDynLib(quickr.contains.pkg, .registration = TRUE)",
      "export(fn1)",
      "export(fn2)"
    ),
    file.path(pkgpath, "NAMESPACE")
  )

  writeLines(
    c(
      "declare <- function(...) invisible()",
      "",
      "# Two different quick functions defining the same local closure name `f`.",
      "# If local closures were emitted as global procedures, this would fail to",
      "# compile due to duplicate symbol definitions in a single compilation unit.",
      "",
      "fn1 <- quickr::quick(\"fn1\", function(x) {",
      "  declare(type(x = double(NA)))",
      "  f <- function(i) x[i] + 1.0",
      "  out <- double(length(x))",
      "  out <- sapply(seq_along(out), f)",
      "  out",
      "})",
      "",
      "fn2 <- quickr::quick(\"fn2\", function(x) {",
      "  declare(type(x = double(NA)))",
      "  f <- function(i) x[i] * 2.0",
      "  out <- double(length(x))",
      "  out <- sapply(seq_along(out), f)",
      "  out",
      "})"
    ),
    file.path(pkgpath, "R", "pkg.R")
  )

  # Compile the package using the *development* quickr currently under test,
  # without relying on pkgload/pkgbuild (which may not have build tools in test
  # environments).
  pkg_env <- new.env(parent = baseenv())
  quickr:::collector$activate("quickr.contains.pkg:quick_funcs")
  sys.source(file.path(pkgpath, "R", "pkg.R"), envir = pkg_env)
  withr::with_dir(pkgpath, suppressMessages(quickr:::dump_collected()))

  build_dir <- withr::local_tempdir(pattern = "quickr-contains-build-")
  file.copy(
    file.path(pkgpath, "src", "quickr_sub_routines.f90"),
    file.path(build_dir, "quickr_sub_routines.f90"),
    overwrite = TRUE
  )
  file.copy(
    file.path(pkgpath, "src", "quickr_entrypoints.c"),
    file.path(build_dir, "quickr_entrypoints.c"),
    overwrite = TRUE
  )

  owd <- setwd(build_dir)
  on.exit(setwd(owd), add = TRUE)

  res <- suppressWarnings(system2(
    R.home("bin/R"),
    c(
      "CMD",
      "SHLIB",
      "-o",
      paste0("quickr.contains.pkg", .Platform$dynlib.ext),
      "quickr_sub_routines.f90",
      "quickr_entrypoints.c"
    ),
    stdout = TRUE,
    stderr = TRUE
  ))
  if (!is.null(status <- attr(res, "status"))) {
    writeLines(res)
    stop("Compilation failed with status: ", status)
  }

  expect_true(file.exists(paste0("quickr.contains.pkg", .Platform$dynlib.ext)))
})

# # ' @export
# `@.default` <- function(x, name) {
#   if (isS4(x))
#     methods::slot(x, name)
#   else
#     attr(x, name, TRUE)
# }
#
# # ' @export
# `@<-.default` <- function(x, name, value) {
#   if (isS4(x))
#     methods::`slot<-`(x, name, value = value)
#   else
#     `attr<-`(x, name, value)
# }
#
# # ' @importFrom utils .AtNames findMatches
# .AtNames.default <- function(x, pattern = "") {
#   if (isS4(x))
#     findMatches(pattern, methods::slotNames(x))
#   else
#     findMatches(pattern, names(attributes(x)))
# }
#
# on_load_register_.AtNames.default <- function() {
#   # if we register via NAMESPACE, we get warning
#   # about overwriting utils:::.AtNmaes.default
#   registerS3method(".AtNames", "default", .AtNames.default)
# }

.onLoad <- function(...) {
  suppressWarnings({
    S7::methods_register()
    asNamespace("dotty")$dotify()
  })
  # on_load_register_.AtNames.default()
}

new_ordered_env <- function(parent = emptyenv()) {
  env <- new.env(parent = parent)
  class(env) <- "quickr_ordered_env"
  env
}

#' @export
`[[<-.quickr_ordered_env` <- function(x, name, value) {
  attr(x, "ordered_names") <- unique(c(attr(x, "ordered_names", TRUE), name))
  # Allow scopes to pre-declare which symbols are "return" variables (external
  # outputs). When logical, quickr represents these using integer storage.
  if (inherits(value, Variable)) {
    return_names <- if (inherits(x, "quickr_scope")) {
      scope_get(x, "return_names")
    } else {
      attr(x, "return_names", exact = TRUE)
    }
    if (!is.null(return_names) && as.character(name) %in% return_names) {
      value@is_return <- TRUE
      if (identical(value@mode, "logical")) {
        value@logical_as_int <- TRUE
      }
    }
  }
  assign(name, value, envir = x)
  x
  # NextMethod()
}

#' @export
`[[.quickr_ordered_env` <- function(x, name) {
  get0(name, x) # name can be a symbols too
}

#' @export
names.quickr_ordered_env <- function(x) {
  all_names <- ls(envir = x, sorted = FALSE)
  ordered_names <- attr(x, "ordered_names", TRUE)
  if (!setequal(all_names, ordered_names)) {
    warning("untracked name")
    stop("untracked name")
  }
  ordered_names
}

#' @export
as.list.quickr_ordered_env <- function(x, ...) {
  out <- as.list.environment(x, all.names = TRUE, ...)
  out[names.quickr_ordered_env(x)]
}

#' @export
print.quickr_ordered_env <- function(x, ...) {
  emit("env (class: ", str_flatten_commas(class(x)), ") with bindings:")
  str(as.list.quickr_ordered_env(x), no.list = TRUE)
}


check_assignment_compatible <- function(target, value) {
  if (is.null(value)) {
    return()
  }
  stopifnot(exprs = {
    inherits(target, Variable)
    inherits(value, Variable)
    passes_as_scalar(target) ||
      passes_as_scalar(value) ||
      target@rank == value@rank
  })
}

new_scope <- function(closure, parent = emptyenv()) {
  scope <- new_ordered_env(parent = parent)
  class(scope) <- unique(c("quickr_scope", class(scope)))
  state <- new.env(parent = emptyenv())
  attr(scope, "state") <- state

  state$closure <- closure
  state$kind <- if (is.null(closure)) "block" else "subroutine"
  state$return_names <- character()
  state$internal_procs <- list()

  state$get_unique_var <- local({
    i <- 0L
    function(...) {
      prefix <- switch(
        state$kind %||% "subroutine",
        block = "btmp",
        closure = "ctmp",
        subroutine = "tmp",
        "tmp"
      )
      name <- paste0(prefix, i <<- i + 1L, "_")
      (scope[[name]] <- Variable(..., name = name))
    }
  })

  state$get_unique_proc <- local({
    i <- 0L
    function(prefix = "closure") {
      stopifnot(is_string(prefix))
      paste0(prefix, i <<- i + 1L, "_")
    }
  })

  state$new_child <- function(kind = c("block", "closure")) {
    kind <- match.arg(kind)
    child <- new_scope(closure = NULL, parent = scope)
    scope_set(child, "kind", kind)
    child
  }

  state$assign <- function(name, value) {
    stopifnot(inherits(value, Variable), is.symbol(name) || is_string(name))
    name <- as.character(name)
    existing <- get0(name, scope)
    if (inherits(existing, Variable)) {
      check_assignment_compatible(existing, value)
    }
    value@name <- name
    assign(name, value, scope)
  }

  state$add_internal_proc <- function(proc) {
    stopifnot(is.list(proc), is_string(proc$name), is_string(proc$code))
    procs <- state$internal_procs %||% list()
    procs[[proc$name]] <- proc
    state$internal_procs <- procs
    invisible(proc)
  }

  scope
}

scope_return_var_names <- function(scope) {
  stopifnot(inherits(scope, "quickr_scope"))
  return_var_names <- closure_return_var_names(scope_closure(scope))
  if (!length(return_var_names)) {
    return(return_var_names)
  }

  is_list_return <- is_call(last(body(scope_closure(scope))), quote(list))
  values <- unname(return_var_names)
  names_in <- names(return_var_names)
  if (is.null(names_in)) {
    names_in <- rep("", length(values))
  }

  expanded_values <- character()
  expanded_names <- character()

  for (i in seq_along(values)) {
    value <- values[[i]]
    name <- names_in[[i]]
    obj <- get0(value, scope, inherits = FALSE)
    if (inherits(obj, SvdResult)) {
      comps <- list(d = obj@d, u = obj@u, v = obj@v)
      comps <- drop_nulls(comps)
      comp_names <- names(comps)
      name_prefix <- if (!is_list_return && identical(name, value)) "" else name
      if (nzchar(name_prefix)) {
        comp_names <- paste0(name_prefix, ".", comp_names)
      }
      expanded_values <- c(
        expanded_values,
        map_chr(comps, \(var) var@name)
      )
      expanded_names <- c(expanded_names, comp_names)
      next
    }

    expanded_values <- c(expanded_values, value)
    expanded_names <- c(expanded_names, name)
  }

  names(expanded_values) <- expanded_names
  expanded_values
}


#' @export
`@.quickr_scope` <- function(x, name) {
  name <- as.character(name)
  scope_get(x, name)
}

#' @export
`@<-.quickr_scope` <- function(x, name, value) {
  name <- as.character(name)
  scope_set(x, name, value)
  x
}

#' @importFrom utils .AtNames findMatches
#' @export
.AtNames.quickr_scope <- function(x, pattern = "") {
  nms <- names(attributes(x)) %||% character()
  st <- attr(x, "state", exact = TRUE)
  if (is.environment(st)) {
    nms <- unique(c(nms, ls(envir = st, all.names = TRUE)))
  }
  findMatches(pattern, nms)
}

# Exercise quickr_scope state accessors to keep refactors covered by covr.

skip_on_cran()

test_that("quickr_scope @ access reads and writes state", {
  scope <- quickr:::new_scope(function(x) x, parent = emptyenv())

  expect_identical(scope@kind, "subroutine")
  expect_true(is.function(scope@closure))

  expect_false(quickr:::scope_uses_rng(scope))
  scope@uses_rng <- TRUE
  expect_true(quickr:::scope_uses_rng(scope))
})

test_that(".AtNames.quickr_scope includes state fields", {
  scope <- quickr:::new_scope(NULL, parent = emptyenv())
  nms <- quickr:::.AtNames.quickr_scope(scope)
  expect_true("kind" %in% nms)
  expect_true("get_unique_var" %in% nms)
})

# Parallel/OpenMP helpers for quickr declarations and codegen.

get_pending_parallel <- function(scope) {
  if (is.null(scope) || !inherits(scope, "quickr_scope")) {
    return(NULL)
  }
  scope_get(scope, "pending_parallel")
}

has_pending_parallel <- function(scope) !is.null(get_pending_parallel(scope))

set_pending_parallel <- function(scope, decl) {
  stopifnot(inherits(scope, "quickr_scope"), is.list(decl))
  scope_set(scope, "pending_parallel", decl)
  invisible(scope)
}

take_pending_parallel <- function(scope) {
  if (is.null(scope) || !inherits(scope, "quickr_scope")) {
    return(NULL)
  }
  decl <- scope_get(scope, "pending_parallel")
  scope_set(scope, "pending_parallel", NULL)
  decl
}

mark_openmp_used <- function(scope) {
  stopifnot(inherits(scope, "quickr_scope"))
  root <- scope_root(scope)
  scope_mark_uses_openmp_flag(root)
  invisible(root)
}

scope_openmp_depth <- function(scope) {
  if (!inherits(scope, "quickr_scope")) {
    return(0L)
  }
  depth <- scope_get(scope, "openmp_depth")
  if (is.null(depth)) {
    0L
  } else {
    as.integer(depth)
  }
}

scope_in_openmp <- function(scope) {
  scope_openmp_depth(scope) > 0L
}

enter_openmp_scope <- function(scope) {
  if (!inherits(scope, "quickr_scope")) {
    return(NULL)
  }
  previous_depth <- scope_get(scope, "openmp_depth")
  depth <- scope_openmp_depth(scope)
  scope_set(scope, "openmp_depth", depth + 1L)
  previous_depth
}

exit_openmp_scope <- function(scope, previous_depth) {
  if (!inherits(scope, "quickr_scope")) {
    return(invisible(NULL))
  }
  if (is.null(previous_depth)) {
    scope_set(scope, "openmp_depth", NULL)
  } else {
    scope_set(scope, "openmp_depth", as.integer(previous_depth))
  }
  invisible(TRUE)
}

openmp_abort <- function(message, class = "quickr_openmp_error") {
  stop(
    structure(
      list(message = message, call = sys.call(-1)),
      class = c(class, "error", "condition")
    )
  )
}

is_parallel_decl_call <- function(e) {
  is.call(e) &&
    is.symbol(e[[1L]]) &&
    as.character(e[[1L]]) %in% c("parallel", "omp")
}

parse_parallel_decl <- function(e) {
  stopifnot(is_parallel_decl_call(e))
  args <- as.list(e)[-1L]
  if (length(args)) {
    stop(
      as.character(e[[1L]]),
      "() does not accept arguments yet.",
      call. = FALSE
    )
  }
  list(backend = "omp", source = as.character(e[[1L]]))
}

unwrap_parens <- function(x) {
  while (is_call(x, quote(`(`)) && length(x) == 2L) {
    x <- x[[2L]]
  }
  x
}

is_parallel_target_stmt <- function(stmt) {
  if (!is.call(stmt)) {
    return(FALSE)
  }
  if (identical(stmt[[1L]], quote(`for`))) {
    return(TRUE)
  }
  if (
    identical(stmt[[1L]], quote(`<-`)) ||
      identical(stmt[[1L]], quote(`=`))
  ) {
    if (length(stmt) < 3L) {
      return(FALSE)
    }
    rhs <- unwrap_parens(stmt[[3L]])
    return(is_sapply_call(rhs))
  }
  FALSE
}

check_pending_parallel_target <- function(stmt, scope) {
  if (!has_pending_parallel(scope)) {
    return()
  }
  if (is_call(stmt, quote(declare))) {
    return()
  }
  if (is_parallel_target_stmt(stmt)) {
    return()
  }
  stop(
    "parallel()/omp() must be followed by a for-loop or sapply() assignment.",
    call. = FALSE
  )
}

check_pending_parallel_consumed <- function(scope) {
  if (!has_pending_parallel(scope)) {
    return()
  }
  stop(
    "parallel()/omp() must be followed by a for-loop or sapply() assignment.",
    call. = FALSE
  )
}

openmp_parallel_do <- function(private = NULL) {
  if (is.null(private) || !length(private)) {
    return("!$omp parallel do")
  }
  private <- unique(as.character(private))
  glue("!$omp parallel do private({str_flatten_commas(private)})")
}

openmp_parallel_end <- function() "!$omp end parallel do"

openmp_directives <- function(parallel, private = NULL) {
  if (is.null(parallel)) {
    return(list(prefix = NULL, suffix = NULL))
  }
  if (!identical(parallel$backend, "omp")) {
    stop("unsupported parallel backend: ", parallel$backend, call. = FALSE)
  }
  list(
    prefix = openmp_parallel_do(private = private),
    suffix = openmp_parallel_end()
  )
}

openmp_config_value <- local({
  cached <- NULL

  function(name, config_value = quickr_r_cmd_config_value) {
    if (is.null(cached)) {
      cached <<- list()
    }
    cached_value <- cached[[name]]
    if (!is.null(cached_value)) {
      return(cached_value)
    }
    value <- config_value(name)
    if (!nzchar(value)) {
      value <- ""
    }
    cached[[name]] <<- value
    value
  }
})

openmp_fflags <- function() {
  env_flags <- trimws(Sys.getenv("QUICKR_OPENMP_FFLAGS", ""))
  if (nzchar(env_flags)) {
    return(env_flags)
  }

  config_flags <- openmp_config_value("SHLIB_OPENMP_FFLAGS")
  if (nzchar(config_flags)) {
    return(config_flags)
  }

  fc <- openmp_config_value("FC")
  if (grepl("(gfortran|flang)", fc, ignore.case = TRUE)) {
    return("-fopenmp")
  }

  ""
}

openmp_link_flags <- function(fflags = openmp_fflags()) {
  env_flags <- trimws(Sys.getenv("QUICKR_OPENMP_LIBS", ""))
  if (nzchar(env_flags)) {
    return(env_flags)
  }

  config_flags <- openmp_config_value("SHLIB_OPENMP_CFLAGS")
  if (nzchar(config_flags)) {
    return(config_flags)
  }

  cc <- openmp_config_value("CC")
  if (nzchar(fflags) && !grepl("clang", cc, ignore.case = TRUE)) {
    return(fflags)
  }

  fc <- openmp_config_value("FC")
  if (grepl("gfortran", fc, ignore.case = TRUE)) {
    compiler <- strsplit(fc, "\\s+")[[1L]][[1L]]
    libname <- if (identical(Sys.info()[["sysname"]], "Darwin")) {
      "libgomp.dylib"
    } else {
      paste0("libgomp", .Platform$dynlib.ext)
    }
    path <- tryCatch(
      suppressWarnings(system2(
        compiler,
        paste0("-print-file-name=", libname),
        stdout = TRUE,
        stderr = TRUE
      )),
      error = function(e) character()
    )
    status <- attr(path, "status")
    if (!is.null(status)) {
      return("")
    }
    path <- trimws(paste(path, collapse = " "))
    if (!nzchar(path) || identical(path, libname)) {
      return("")
    }
    return(paste0("-L", dirname(path), " -lgomp"))
  }

  ""
}

openmp_makevars_lines <- function() {
  fflags <- openmp_fflags()
  if (!nzchar(fflags)) {
    openmp_abort(
      paste(
        "OpenMP was requested but no OpenMP flags were found for this toolchain.",
        "Set QUICKR_OPENMP_FFLAGS to your compiler's OpenMP flags.",
        sep = "\n"
      ),
      class = "quickr_openmp_unavailable"
    )
  }
  libs <- openmp_link_flags(fflags = fflags)
  if (!nzchar(libs)) {
    openmp_abort(
      paste(
        "OpenMP was requested but no OpenMP linker flags were found.",
        "Set QUICKR_OPENMP_LIBS to your linker OpenMP flags.",
        sep = "\n"
      ),
      class = "quickr_openmp_unavailable"
    )
  }
  c(
    paste("PKG_FFLAGS +=", fflags),
    paste("PKG_LIBS +=", libs)
  )
}

skip_on_cran()

test_that("openmp_makevars_lines uses explicit env flags", {
  withr::local_envvar(c(
    QUICKR_OPENMP_FFLAGS = "-fopenmp",
    QUICKR_OPENMP_LIBS = "-fopenmp"
  ))

  expect_equal(
    quickr:::openmp_makevars_lines(),
    c("PKG_FFLAGS += -fopenmp", "PKG_LIBS += -fopenmp")
  )
})

test_that("openmp_makevars_lines errors when flags are missing", {
  local_mocked_bindings(
    openmp_fflags = function() "",
    .package = "quickr"
  )

  expect_error(
    quickr:::openmp_makevars_lines(),
    "OpenMP was requested but no OpenMP flags",
    class = "quickr_openmp_unavailable"
  )
})

test_that("openmp_makevars_lines errors when linker flags are missing", {
  local_mocked_bindings(
    openmp_fflags = function() "-fopenmp",
    openmp_link_flags = function(...) "",
    .package = "quickr"
  )

  expect_error(
    quickr:::openmp_makevars_lines(),
    "OpenMP was requested but no OpenMP linker flags",
    class = "quickr_openmp_unavailable"
  )
})

test_that("openmp_config_value caches toolchain lookups", {
  cache_env <- environment(quickr:::openmp_config_value)
  old_cache <- cache_env$cached
  old_config <- cache_env$quickr_r_cmd_config_value
  withr::defer(cache_env$cached <- old_cache)
  withr::defer({
    if (is.null(old_config)) {
      rm(quickr_r_cmd_config_value, envir = cache_env)
    } else {
      cache_env$quickr_r_cmd_config_value <- old_config
    }
  })
  cache_env$cached <- NULL

  calls <- 0
  cache_env$quickr_r_cmd_config_value <- function(...) {
    calls <<- calls + 1
    "value"
  }

  expect_equal(quickr:::openmp_config_value("QUICKR_TEST_CACHE"), "value")
  expect_equal(quickr:::openmp_config_value("QUICKR_TEST_CACHE"), "value")
  expect_equal(calls, 1)
})

test_that("get_pending_parallel returns NULL for NULL or non-scope", {
  expect_null(quickr:::get_pending_parallel(NULL))
  expect_null(quickr:::get_pending_parallel(list()))
})

test_that("take_pending_parallel returns NULL for NULL or non-scope", {
  expect_null(quickr:::take_pending_parallel(NULL))
  expect_null(quickr:::take_pending_parallel(list()))
})

test_that("parse_parallel_decl errors when arguments provided", {
  e <- quote(parallel(foo))
  expect_error(
    quickr:::parse_parallel_decl(e),
    "does not accept arguments"
  )
})

test_that("is_parallel_target_stmt handles edge cases", {
  # non-call

  expect_false(quickr:::is_parallel_target_stmt(1L))

  # assignment with less than 3 elements
  bad_assign <- quote(`<-`(x))
  expect_false(quickr:::is_parallel_target_stmt(bad_assign))

  # other call types
  expect_false(quickr:::is_parallel_target_stmt(quote(foo(x))))
})

test_that("openmp_directives errors for unsupported backend", {
  parallel <- list(backend = "cuda")
  expect_error(
    quickr:::openmp_directives(parallel),
    "unsupported parallel backend"
  )
})

test_that("openmp_fflags uses env variable first", {
  withr::local_envvar(QUICKR_OPENMP_FFLAGS = "-custom-flags")
  result <- quickr:::openmp_fflags()
  expect_equal(result, "-custom-flags")
})

test_that("openmp_link_flags uses env variable first", {
  withr::local_envvar(QUICKR_OPENMP_LIBS = "-lcustom")
  result <- quickr:::openmp_link_flags()
  expect_equal(result, "-lcustom")
})

test_that("openmp_fflags returns empty when no config found", {
  local_mocked_bindings(
    openmp_config_value = function(...) "",
    .package = "quickr"
  )
  withr::local_envvar(QUICKR_OPENMP_FFLAGS = "")

  result <- quickr:::openmp_fflags()
  expect_equal(result, "")
})

test_that("openmp_link_flags returns fflags for non-clang CC", {
  local_mocked_bindings(
    openmp_config_value = function(name, ...) {
      switch(name, SHLIB_OPENMP_CFLAGS = "", CC = "gcc", "")
    },
    .package = "quickr"
  )
  withr::local_envvar(QUICKR_OPENMP_LIBS = "")

  result <- quickr:::openmp_link_flags(fflags = "-fopenmp")
  expect_equal(result, "-fopenmp")
})

test_that("openmp_link_flags returns empty for clang CC", {
  local_mocked_bindings(
    openmp_config_value = function(name, ...) {
      switch(name, SHLIB_OPENMP_CFLAGS = "", CC = "clang", FC = "flang", "")
    },
    .package = "quickr"
  )
  withr::local_envvar(QUICKR_OPENMP_LIBS = "")

  result <- quickr:::openmp_link_flags(fflags = "-fopenmp")
  expect_equal(result, "")
})

# r2f-math.R
# Handlers for math intrinsics: sin, cos, tan, asin, acos, atan, sqrt, exp,
# log, tanh, floor, ceiling, trunc, log10, abs, Re, Im, Mod, Arg, Conj

# --- Local Helpers ---

# Register a unary intrinsic handler for one or more function names.
# Used by: math intrinsic registrations in this file
register_unary_intrinsic <- function(
  name,
  mode_fun,
  expr_fun
) {
  handler <- function(args, scope, ...) {
    stopifnot(length(args) == 1L)
    arg <- r2f(args[[1L]], scope, ...)
    val <- Variable(mode = mode_fun(arg), dims = arg@value@dims)
    Fortran(expr_fun(arg, last(list(...)$calls)), val)
  }
  register_r2f_handler(name, handler)
  invisible(handler)
}


# --- Handlers ---

## real and complex intrinsics
register_unary_intrinsic(
  c(
    "sin",
    "cos",
    "tan",
    "tanh",
    "asin",
    "acos",
    "atan",
    "sqrt",
    "exp",
    "log"
  ),
  mode_fun = function(arg) arg@value@mode,
  expr_fun = function(arg, intrinsic) glue("{intrinsic}({arg})")
)

r2f_handlers[["floor"]] <- function(args, scope, ...) {
  stopifnot(length(args) == 1L)
  arg <- r2f(args[[1L]], scope, ...)

  arg <- maybe_cast_double(arg)
  if (!identical(arg@value@mode, "double")) {
    stop("floor() only implemented for logical, integer, and double")
  }
  out_val <- Variable("double", arg@value@dims)

  # Avoid Fortran FLOOR() overflow (it returns an integer) by staying in the
  # real domain:
  # - aint(x) truncates toward 0 (real result)
  # - adjust by -1 where trunc differs from floor (negative non-integers)
  aint <- glue("aint({arg})")
  Fortran(
    glue("({aint} - merge(1.0_c_double, 0.0_c_double, ({arg} < {aint})))"),
    out_val
  )
}

r2f_handlers[["ceiling"]] <- function(args, scope, ...) {
  stopifnot(length(args) == 1L)
  arg <- r2f(args[[1L]], scope, ...)

  arg <- maybe_cast_double(arg)
  if (!identical(arg@value@mode, "double")) {
    stop("ceiling() only implemented for logical, integer, and double")
  }
  out_val <- Variable("double", arg@value@dims)

  # As with floor(): avoid integer overflow by implementing in real arithmetic.
  aint <- glue("aint({arg})")
  Fortran(
    glue("({aint} + merge(1.0_c_double, 0.0_c_double, ({arg} > {aint})))"),
    out_val
  )
}

r2f_handlers[["trunc"]] <- function(args, scope, ...) {
  stopifnot(length(args) == 1L)
  arg <- r2f(args[[1L]], scope, ...)

  # R's trunc() always returns a double and truncates toward 0.
  # - For double input we can use Fortran AINT(), which returns a real.
  # - For integer/logical inputs, a cast-to-double is sufficient.
  if (arg@value@mode == "double") {
    return(Fortran(glue("aint({arg})"), Variable("double", arg@value@dims)))
  }
  if (arg@value@mode %in% c("integer", "logical")) {
    return(maybe_cast_double(arg))
  }
  stop("trunc() only implemented for logical, integer, and double")
}

r2f_handlers[["log10"]] <- function(args, scope, ...) {
  stopifnot(length(args) == 1L)
  arg <- r2f(args[[1]], scope, ...)
  f <- if (arg@value@mode == "complex") {
    glue("(log({arg}) / log(10.0_c_double))")
  } else {
    glue("log10({arg})")
  }
  Fortran(
    f,
    Variable(mode = arg@value@mode, dims = arg@value@dims)
  )
}

## accepts real, integer, or complex
r2f_handlers[["abs"]] <- function(args, scope, ...) {
  stopifnot(length(args) == 1L)
  arg <- r2f(args[[1]], scope, ...)
  out_mode <- if (arg@value@mode == "complex") "double" else arg@value@mode
  Fortran(glue("abs({arg})"), Variable(mode = out_mode, dims = arg@value@dims))
}


# ---- complex elemental unary intrinsics ----

register_unary_intrinsic(
  "Re",
  mode_fun = function(arg) "double",
  expr_fun = function(arg, intrinsic) glue("real({arg})")
)

register_unary_intrinsic(
  "Im",
  mode_fun = function(arg) "double",
  expr_fun = function(arg, intrinsic) glue("aimag({arg})")
)

register_unary_intrinsic(
  "Mod",
  mode_fun = function(arg) "double",
  expr_fun = function(arg, intrinsic) glue("abs({arg})")
)

register_unary_intrinsic(
  "Arg",
  mode_fun = function(arg) "double",
  expr_fun = function(arg, intrinsic) glue("atan2(aimag({arg}), real({arg}))")
)

register_unary_intrinsic(
  "Conj",
  mode_fun = function(arg) "complex",
  expr_fun = function(arg, intrinsic) glue("conjg({arg})")
)

new_fortran_subroutine <- function(
  name,
  closure,
  parent = environment(closure)
) {
  check_fortran_subroutine_name_valid(name)
  check_all_var_names_valid(closure)

  # translate body, and populate scope with variables
  body <- body(closure)

  # defuse calls like `-1` and `1+1i`. Not really necessary, but simplifies downstream a little.
  body <- defuse_numeric_literals(body)

  # TODO: try harder here to use one of the input vars as the output var
  body <- ensure_last_expr_sym(body)

  # update closure with sym return value
  base::body(closure) <- body
  # body <- rlang::zap_srcref(body)

  scope <- new_scope(closure, parent)
  scope_set(
    scope,
    "return_names",
    unique(unname(closure_return_var_names(closure)))
  )

  # inject symbols for var sizes in declare calls, so like:
  #   declare(type(foo = integer(nr, NA)),
  #           type(bar = integer(nr, 3)))
  # become:
  #   declare(type(foo = integer(foo_dim_1_, foo_dim_2_)),
  #           type(bar = integer(foo_dim_1_, 3L)))
  body <- substitute_declared_sizes(body)
  stmts <- as.list(body)[-1L]
  body <- compile_nonreturn_statements(drop_last(stmts), scope)

  # check all input vars were declared
  # TODO: this check might be too late, because r2f() might throw cryptic errors
  # when handling undeclared variables. Either throw better errors from r2f(), or
  # handle all declares first
  for (arg_name in names(formals(closure))) {
    var <- get0(arg_name, scope)
    if (is.null(var) || !inherits(var, Variable)) {
      stop("arg not declared: ", arg_name)
    }
  }

  # Ensure return vars are marked (primarily to mark logical outputs as integer
  # storage for bind(c) and to support early "external-ness" checks).
  for (return_name in unique(unname(scope_return_var_names(scope)))) {
    if (!is.null(var <- get0(return_name, scope))) {
      stopifnot(inherits(var, Variable))
      var@is_return <- TRUE
      if (identical(var@mode, "logical")) {
        var@logical_as_int <- TRUE
      }
      scope[[return_name]] <- var
    }
  }

  uses_errors <- scope_uses_errors_flag(scope)
  uses_openmp <- scope_uses_openmp_flag(scope)
  manifest <- r2f.scope(scope, include_errors = uses_errors)
  local_allocs <- attr(manifest, "local_allocations", exact = TRUE) %||%
    character()
  fsub_arg_names <- attr(manifest, "signature", TRUE)

  internal_procs <- scope_get(scope, "internal_procs", default = list()) %||%
    list()
  contains_entries <- c(
    lapply(internal_procs, `[[`, "code") |>
      unlist(use.names = FALSE),
    if (uses_errors) quickr_error_helper_fortran(openmp = uses_openmp)
  )
  contains_block <- if (length(contains_entries)) {
    procs_code <- str_flatten_lines(contains_entries)
    str_flatten_lines("contains", indent(procs_code))
  } else {
    NULL
  }
  contains_block_indented <- if (is.null(contains_block)) {
    NULL
  } else {
    indent(contains_block)
  }
  body_code <- if (length(local_allocs)) {
    str_flatten_lines(local_allocs, "", body)
  } else {
    body
  }
  body_section <- indent(body_code)
  if (!is.null(contains_block_indented)) {
    body_section <- str_flatten_lines(body_section, "", contains_block_indented)
  }

  uses_rng <- scope_uses_rng(scope)
  used_iso_bindings <- iso_c_binding_symbols(
    vars = scope_vars(scope),
    body_code = body,
    logical_is_c_int = function(var) var@name %in% fsub_arg_names,
    uses_rng = uses_rng,
    include_errors = uses_errors
  )
  if (uses_rng) {
    rng_interface <- glue::trim(
      '
      interface
        function unif_rand() bind(c, name = "unif_rand") result(u)
          use iso_c_binding, only: c_double
          real(c_double) :: u
        end function unif_rand
      end interface
      '
    )

    manifest <- str_flatten_lines(manifest, "", rng_interface)
  }
  subroutine <- glue(
    "
subroutine {name}({str_flatten_commas(fsub_arg_names)}) {fortran_bind_clause(name)}
  use iso_c_binding, only: {str_flatten_commas(used_iso_bindings)}
  implicit none

{indent(manifest)}

{body_section}
end subroutine
    "
  )
  subroutine <- glue::trim(subroutine)

  subroutine <- insert_fortran_line_continuations(subroutine)

  FortranSubroutine(
    subroutine,
    name = name,
    signature = fsub_arg_names,
    scope = scope,
    closure = closure
  )
}

check_fortran_subroutine_name_valid <- function(name) {
  if (!is_string(name) || !nzchar(name)) {
    stop("`name` must be a non-empty string.", call. = FALSE)
  }
  # Must be valid in:
  # - Fortran: used as the procedure name.
  # - C: used as the binding label and referenced from the C bridge.
  if (!grepl("^[A-Za-z][A-Za-z0-9_]*$", name)) {
    suggestion <- gsub("[^A-Za-z0-9_]", "_", name)
    if (!grepl("^[A-Za-z]", suggestion)) {
      suggestion <- paste0("quick_", suggestion)
    }
    stop(
      "Invalid `quick()` name: '",
      name,
      "'. The name must match the pattern '^[A-Za-z][A-Za-z0-9_]*$' ",
      "(letters, digits, underscore; starting with a letter). ",
      "Suggested name: '",
      suggestion,
      "'.",
      call. = FALSE
    )
  }
  invisible(TRUE)
}

fortran_bind_clause <- function(name) {
  # Fortran is case-insensitive, but C symbol names are case-sensitive.
  # When `bind(c)` is used without an explicit `name=`, some toolchains
  # canonicalize the external symbol name (e.g., lowercase), which can cause
  # the C bridge to look up the wrong symbol for mixed-case procedure names.
  if (identical(name, tolower(name))) {
    return("bind(c)")
  }
  glue('bind(c, name = "{name}")')
}

insert_fortran_line_continuations <- function(
  code,
  preserve_attributes = TRUE
) {
  attrs_in <- attributes(code)

  code <- as.character(code)
  lines <- str_split_lines(code)
  lines <- trimws(lines, "right")

  if (any(too_long <- nchar(lines) > 132)) {
    split_long_fortran_line <- function(line, max_len = 132L) {
      if (nchar(line) <= max_len) {
        return(line)
      }
      too_long <- paste(
        "Too long line encountered.",
        "Please split long expressions into a sequence of smaller expressions."
      )
      wrapped <- strwrap(
        line,
        width = max_len - 1L,
        prefix = "& ",
        initial = ""
      )
      if (length(wrapped) > 256L || any(nchar(wrapped) > max_len - 1L)) {
        stop(too_long)
      }
      paste0(wrapped, c(rep("&", length(wrapped) - 1L), ""))
    }

    # remove leading indentation
    lines[too_long] <- trimws(lines[too_long], "left")

    # move trailing comment at the end
    lines[too_long] <- sub("^(.*)!(.*)$", "!\\2\n\\1", lines[too_long])
    lines <- str_split_lines(lines)

    lines <- unlist(lapply(lines, split_long_fortran_line), use.names = FALSE)
  }

  code <- str_flatten_lines(lines)
  if (preserve_attributes) {
    attributes(code) <- attrs_in
  }
  code
}

# This file is part of the standard setup for testthat.
# It is recommended that you do not modify it.
#
# Where should you do additional test configuration?
# Learn more about the roles of various files in:
# * https://r-pkgs.org/testing-design.html#sec-tests-files-overview
# * https://testthat.r-lib.org/articles/special-files.html

# covr doesn't merge coverage across testthat worker processes, so parallel test
# execution can undercount coverage substantially.
if (identical(Sys.getenv("R_COVR"), "true")) {
  Sys.setenv(TESTTHAT_PARALLEL = "false")
}

library(testthat)
if (identical(Sys.getenv("R_COVR"), "true")) {
  # covr can emit harmless warnings while instrumenting quickr's namespace; keep
  # coverage runs clean.
  suppressWarnings(library(quickr))
} else {
  library(quickr)
}

test_check("quickr")

#' Declare quickr annotations
#'
#' `declare()` marks declarations (e.g., `type(x = double(n))`) for use by
#' `quickr`'s compiler. It is a runtime no-op and does not evaluate its
#' arguments.
#'
#' `declare()` is provided by the base package starting in R 4.4.0; for older
#' versions of R, quickr exports a compatible backport.
#'
#' `declare(parallel())` or `declare(omp())` applies an OpenMP `parallel do`
#' directive to the next `for` loop or `sapply()` assignment. `for` loops can
#' iterate values over symbols or index iterables (`1:n`, `seq_len()`,
#' `seq_along()`, `seq()`), and `sapply()` iterates over vector inputs with a
#' known length.
#'
#' Control the number of OpenMP threads using environment variables such as
#' `OMP_NUM_THREADS` (threads per region), `OMP_THREAD_LIMIT` (global cap),
#' and `OMP_DYNAMIC` (disable/enable runtime adjustment). Set them before
#' calling a compiled function, e.g. `Sys.setenv(OMP_NUM_THREADS = "4")`.
#'
#' @param ... Declarations, typically calls like `type(x = double(n))`.
#' @returns `NULL`, invisibly.
#' @rawNamespace if (getRversion() < "4.4.0") export(declare)
#' @keywords internal
declare <- function(...) invisible()

# Unit tests for declare(type()) variants

skip_on_cran()

test_that("declare(type()) variants", {
  # exprs in {
  quick_seq <- (function(start, end) {
    declare({
      type(start = integer(1))
      type(end = integer(1))
      type(out = integer(end - start + 1))
    })
    out <- seq(start, end)
    out
  })
  expect_quick_identical(quick_seq, list(1L, 5L))

  # args, with missing trailing arg
  quick_seq <- (function(start, end) {
    declare(
      type(start = integer(1)),
      type(end = integer(1)),
      type(out = integer(end - start + 1)),
    )
    out <- seq(start, end)
    out
  })
  expect_quick_identical(quick_seq, list(1L, 5L))

  # args, without missing trailing arg
  quick_seq <- (function(start, end) {
    declare(
      type(start = integer(1)),
      type(end = integer(1)),
      type(out = integer(end - start + 1))
    )
    out <- seq(start, end)
    out
  })
  expect_quick_identical(quick_seq, list(1L, 5L))

  # seperate declare() calls
  quick_seq <- (function(start, end) {
    declare(type(start = integer(1)))
    declare(type(end = integer(1)))
    declare(type(out = integer(end - start + 1)))
    out <- seq(start, end)
    out
  })
  expect_quick_identical(quick_seq, list(1L, 5L))
})

# Unit tests for logical operations

skip_on_cran()

test_that("between", {
  between <- function(x, left, right) {
    declare({
      type(x = double(n))
      type(left = double(1))
      type(right = double(1))
    })
    out <- x >= left & x <= right
    out
  }

  expect_translation_snapshots(between)
  expect_quick_identical(between, list(x = runif(100), left = .4, right = .6))
})

test_that("logical ops", {
  test_args <- list(
    list(1, 2),
    list(2, 1),
    list(-2, 2),
    list(-2, -2),
    list(3, 3),
    list(4, 1),
    list(1, 4)
  )

  fn <- function(a, b) {
    declare(
      type(a = double(1)),
      type(b = double(1))
    )

    delta <- a - b
    if (delta < 0) {
      delta <- (-1) * delta
    }

    a_gt_b <- a > b
    b_gt_a <- b > a
    delta_lt_3 <- delta <= 3

    out <- (a_gt_b || b_gt_a) && delta_lt_3
    out
  }
  expect_translation_snapshots(fn)
  expect_quick_identical(fn, !!!test_args)

  # simpler version of above
  fn <- function(a, b) {
    declare({
      type(a = double(1))
      type(b = double(1))
    })

    delta <- abs(a - b)
    out <- (a != b) & (delta <= 3)
    out
  }
  expect_translation_snapshots(fn)
  expect_quick_identical(fn, !!!test_args)

  # even simpler version
  fn <- function(a, b) {
    declare(type(a = double(1)), type(b = double(1)))
    out <- (a != b) && abs(a - b) <= 3
    out
  }
  expect_translation_snapshots(fn)
  expect_quick_identical(fn, !!!test_args)

  # vectorized version
  fn <- function(a, b) {
    declare(type(a = double(n)), type(b = double(n)))
    out <- (a != b) & abs(a - b) <= 3
    out
  }
  expect_translation_snapshots(fn)
  .[a, b] <- .mapply(c, test_args, NULL)
  expect_quick_identical(fn, list(a, b))
})

test_that("parentheses preserve logical precedence", {
  fn_a <- function(x, y) {
    declare(type(x = integer(1)), type(y = integer(1)))
    cond <- (x > 8L || x <= 0L) && (y > 8L || y <= 0L)
    cond
  }

  fn_b <- function(x, y) {
    declare(type(x = integer(1)), type(y = integer(1)))
    cond_x <- x > 8L || x <= 0L
    cond_y <- y > 8L || y <= 0L
    cond_x && cond_y
  }

  cases <- list(
    list(9L, 1L),
    list(9L, 9L),
    list(0L, 9L),
    list(1L, 0L),
    list(5L, 5L)
  )

  expect_translation_snapshots(fn_a)
  expect_translation_snapshots(fn_b)
  expect_quick_identical(fn_a, !!!cases)
  expect_quick_identical(fn_b, !!!cases)
})

# Tests for dynamic dimension expressions evaluated in Fortran environment

skip_on_cran()

test_that("arithmetic expressions in dimensions compile", {
  fn <- function(n) {
    declare(type(n = integer(1)))
    x <- double(n * 2L)
    y <- double(n - 1L)
    length(x) + length(y)
  }
  expect_translation_snapshots(fn)

  expect_identical(fn(4L), 11L)
  expect_identical(fn(7L), 20L)
  expect_quick_identical(fn, 4L, 7L)
})


test_that("integer division and modulus in dimensions compile", {
  fn <- function(n) {
    declare(type(n = integer(1)))
    out <- double(n %/% 2L + n %% 2L)
    length(out)
  }
  expect_translation_snapshots(fn)

  expect_identical(fn(5L), 3L)
  expect_identical(fn(8L), 4L)
  expect_quick_identical(fn, 5L, 8L)
})


test_that("matrix dimension expressions compile", {
  fn <- function(n) {
    declare(type(n = integer(1)))
    out <- matrix(1, n + 1L, n %/% 2L + 1L)
    dim(out)
  }
  expect_translation_snapshots(fn)

  expect_identical(fn(3L), c(4L, 2L))
  expect_identical(fn(6L), c(7L, 4L))
  expect_quick_identical(fn, 3L, 6L)
})

skip_on_cran()

test_that("translation snapshots: statement closure with host-associated <<-", {
  fn <- function(nx, ny) {
    declare(type(nx = integer(1)), type(ny = integer(1)))
    temp <- matrix(0, nx, ny)

    bc <- function() {
      temp[1, ] <<- 1
      temp[nx, ] <<- 2
      temp[, 1] <<- 3
      temp[, ny] <<- 4
      NULL
    }

    bc()
    temp
  }

  expect_translation_snapshots(
    fn,
    note = "Statement local closure lowered as internal subroutine; <<- subset targets are host-associated (no capture arg/decl in the closure)."
  )
})

test_that("translation snapshots: sapply + <<- mutates host + returns value", {
  fn <- function(x) {
    declare(type(x = double(NA)), type(out = double(length(x))))
    f <- function(i) {
      x[i] <<- x[i] * 2
      x[i]
    }
    out <- sapply(seq_along(x), f)
    list(x = x, out = out)
  }

  expect_translation_snapshots(
    fn,
    note = "Local closure lowered under contains; x is host-associated (no capture arg), marked modified so the C bridge duplicates x to preserve R semantics."
  )
})

test_that("translation snapshots: 3D slice superassignment with missing indices", {
  fn <- function(nx, ny, nz) {
    declare(type(nx = integer(1)), type(ny = integer(1)), type(nz = integer(1)))
    a <- array(0.0, c(nx, ny, nz))

    f <- function(k) {
      a[,, k] <<- as.double(k)
      a[1, 1, k] <<- a[1, 1, k] + 0.5
      NULL
    }

    f(1L)
    f(nz)
    a
  }

  expect_translation_snapshots(
    fn,
    note = "3D array section designators compile to host-associated Fortran slices (a(:, :, k))."
  )
})

test_that("translation snapshots: sapply simplify='array' + <<- mutates host matrix argument", {
  fn <- function(x) {
    declare(type(x = double(NA, NA)))
    out <- x
    f <- function(j) {
      x[, j] <<- x[, j] * 2.0
      x[, j]
    }
    out <- sapply(seq_len(ncol(x)), f, simplify = "array")
    list(x = x, out = out)
  }

  expect_translation_snapshots(
    fn,
    note = "sapply() lowering with higher-rank output and host mutation; x is duplicated by the C bridge due to modification tracking."
  )
})

# Unit tests for parentheses preservation

skip_on_cran()

test_that("parentheses preserve arithmetic precedence for scalars", {
  fn <- function(a, b, c, d) {
    declare(
      type(a = double(1)),
      type(b = double(1)),
      type(c = double(1)),
      type(d = double(1))
    )

    (a + b) / (c + d)
  }

  cases <- list(
    list(1, 2, 3, 4),
    list(5.5, -3, 2, 1),
    list(-10, 4, 7, 5)
  )

  expect_translation_snapshots(fn)
  expect_quick_identical(fn, !!!cases)
})

test_that("parentheses preserve precedence in vectorized expressions", {
  fn <- function(x, y) {
    declare(type(x = double(n)), type(y = double(n)))
    (x + 1) * (y - 1)
  }

  cases <- list(
    list(c(1, 2, 3), c(3, 2, 1)),
    list(c(-1, 0, 1), c(1, 1, 1))
  )

  expect_translation_snapshots(fn)
  expect_quick_identical(fn, !!!cases)
})

# Example: rolling mean computation

skip_on_cran()

test_that("roll_mean", {
  slow_roll_mean <- function(x, weights, normalize = TRUE) {
    declare(
      type(x = double(NA)),
      type(weights = double(NA)),
      type(normalize = logical(1))
    )
    out <- double(length(x) - length(weights) + 1)
    n <- length(weights)
    if (normalize) {
      weights <- weights / sum(weights) * length(weights)
    }

    for (i in seq_along(out)) {
      out[i] <- sum(x[i:(i + n - 1)] * weights) / length(weights)
    }
    out
  }

  x <- dnorm(seq(-3, 3, len = 2000))
  weights <- runif(30)

  expect_translation_snapshots(slow_roll_mean)
  expect_quick_equal(slow_roll_mean, list(x, weights))
})

skip_on_cran()

test_that("fall-through assignment is supported", {
  expect_quick_identical(
    function(x) {
      declare(type(x = double(1)))
      a <- b <- 1
      x + a + b
    },
    8
  )

  expect_quick_identical(
    function(x) {
      declare(type(x = double(1)))
      a <- (b <- 1)
      x + a + b
    },
    8
  )

  expect_quick_identical(
    function(x) {
      declare(type(x = double(1)))
      a <- b <- c <- x + 1
      a + b + c
    },
    8
  )
})

# Unit tests for simple addition

skip_on_cran()

test_that("add1", {
  slow_add1 <- function(x) {
    declare(type(x = double(NA)))
    x <- x + 1
    x
  }

  expect_quick_equal(slow_add1, as.double(1:3), c(1, 2, 3), 1)
})

test_that("add2", {
  slow_add2 <- function(x, y) {
    declare(type(x = integer(n)), type(y = integer(n)))
    out <- x + y
    out
  }

  x <- 1:3
  y <- 4:6
  expect_quick_identical(slow_add2, list(x, y))
})

skip_on_cran()

test_that("openmp error handling snapshots include cancellation", {
  single_parallel <- function(x) {
    declare(type(x = double(1)))
    declare(parallel())
    for (i in seq_len(1L)) {
      if (x < 0) {
        stop("x must be nonnegative")
      }
    }
    x + 1
  }

  nested_parallel <- function(x) {
    declare(type(x = double(1)))
    declare(parallel())
    for (i in seq_len(1L)) {
      declare(parallel())
      for (j in seq_len(1L)) {
        if (x < 0) {
          stop("x must be nonnegative")
        }
      }
    }
    x + 1
  }

  expect_translation_snapshots(
    single_parallel,
    note = "Single OpenMP parallel loop with stop()"
  )
  expect_translation_snapshots(
    nested_parallel,
    note = "Nested OpenMP parallel loops with stop()"
  )
})

skip_on_cran()

test_that("r2f() attaches `r` metadata for bind(c) logical symbols", {
  # Regression test: r2f() must attach attr(,"r") even for the symbol-lowering
  # path used by bind(c) logical arguments. Missing `r` can break downstream
  # compilation logic that relies on var@r (e.g. size inference).
  fn <- function(m) {
    declare(type(m = logical(NA)))
    a <- m
    a
  }

  fsub <- quickr:::r2f(fn)
  a_var <- get0("a", fsub@scope)
  expect_true(inherits(a_var, Variable))
  expect_identical(a_var@r, quote(m))
})

skip_on_cran()

test_that("subscripts can use rev(seq_len()) on multi-d arrays", {
  fn <- function(x1) {
    declare(type(x1 = integer(2L, 3L)))
    x1[seq_len(2L), rev(seq_len(3L)), drop = FALSE]
  }

  x1 <- matrix(1:6, nrow = 2, ncol = 3)
  expect_quick_identical(fn, x1)
})

test_that("slice assignment supports vector subscripts", {
  fn <- function(out, block) {
    declare(type(out = integer(2L, 3L)))
    declare(type(block = integer(2L, 3L)))
    out[seq_len(2L), rev(seq_len(3L))] <- block
    out
  }

  out <- matrix(0L, nrow = 2, ncol = 3)
  block <- matrix(1:6, nrow = 2, ncol = 3)
  expect_quick_identical(fn, list(out, block))
})

skip_on_cran()

test_that("logical-vector subscripts work for [<<- LHS", {
  logical_superassign <- function(x) {
    declare(type(x = double(n)))
    f <- function() {
      x[x > 0] <<- 0
      NULL
    }
    f()
    x
  }

  x <- c(-1, 2, -3, 4)
  expect_quick_identical(logical_superassign, x)
})

# Unit test for ifelse translation

skip_on_cran()

test_that("ifelse", {
  fn <- function(a, b) {
    declare(
      type(a = integer(n)),
      type(b = integer(n))
    )

    out <- ifelse(a < b, 1, -1)
    out
  }
  expect_quick_identical(fn, list(-10:10, integer(21)))

  # double version of above
  fn <- function(a, b) {
    declare(
      type(a = double(n)),
      type(b = double(n))
    )

    out <- ifelse(a < b, 1, -1)
    out
  }
  expect_quick_equal(fn, list(seq(-5, 5, length.out = 20), double(20)))
})

skip_on_cran()

test_that("translation snapshots: hoist+block inside contains (sapply closure)", {
  fn <- function(x) {
    declare(type(x = double(NA)))
    out <- double(length(x))
    out <- sapply(seq_along(out), function(i) (x + 1.0)[i])
    out
  }

  expect_translation_snapshots(
    fn,
    note = "The closure body indexes an array expression, which forces a hoisted temporary and a Fortran block inside the internal procedure."
  )
})

test_that("translation snapshots: hoist+block inside contains (statement closure + <<-)", {
  fn <- function(nx, ny) {
    declare(type(nx = integer(1)), type(ny = integer(1)))
    temp <- matrix(0, nx, ny)

    bc <- function() {
      temp[1, 1] <<- (temp + 1.0)[1, 1]
      temp[nx, ny] <<- (temp + 2.0)[nx, ny]
      NULL
    }

    bc()
    temp
  }

  expect_translation_snapshots(
    fn,
    note = "Statement local closure lowered under contains; RHS indexing forces hoisting + a block inside the internal procedure; LHS uses [<<- to mutate the host variable."
  )
})

# Unit tests for loop constructs

skip_on_cran()

test_that("repeat/break", {
  inc_to_5 <- function(x) {
    declare(type(x = integer(1)))
    repeat {
      if (x >= 5L) {
        break
      }
      x <- x + 1L
    }
    x
  }

  expect_translation_snapshots(inc_to_5)
  expect_quick_identical(inc_to_5, -1L, 0L, 4L, 5L)
})

test_that("repeat + next", {
  inc_to_5_skip_neg <- function(x) {
    declare(type(x = integer(1)))
    repeat {
      x <- x + 1L
      if (x < 0L) {
        next
      }
      if (x >= 5L) break
    }
    x
  }

  expect_translation_snapshots(inc_to_5_skip_neg)
  expect_quick_identical(inc_to_5_skip_neg, -3L, -1L, 0L, 4L, 5L)
})

test_that("break/for", {
  fn <- function(x) {
    declare(type(x = integer(1)))
    for (i in 1:10) {
      x = x + 1L
      if (x >= 5L) {
        break
      }
    }
    x
  }

  expect_translation_snapshots(fn)
  expect_quick_identical(fn, -1L, 0L, 4L, 5L)
})

test_that("while", {
  fn <- function(x) {
    declare(type(x = integer(1)))
    while (x < 5L) {
      x = x + 1L
    }
    x
  }

  expect_translation_snapshots(fn)
  expect_quick_identical(fn, -1L, 0L, 4L, 5L)
})

test_that("while + next", {
  inc_to_5_skip_neg_while <- function(x) {
    declare(type(x = integer(1)))
    while (x < 5L) {
      x <- x + 1L
      if (x < 0L) next
    }
    x
  }

  expect_translation_snapshots(inc_to_5_skip_neg_while)
  expect_quick_identical(inc_to_5_skip_neg_while, -3L, -1L, 0L, 4L, 5L)
})

test_that("while + break", {
  inc_to_5_break_while <- function(x) {
    declare(type(x = integer(1)))
    while (TRUE) {
      if (x >= 5L) {
        break
      }
      x <- x + 1L
    }
    x
  }

  expect_translation_snapshots(inc_to_5_break_while)
  expect_quick_identical(inc_to_5_break_while, -1L, 0L, 4L, 5L)
})

test_that("expr return value", {
  fn <- function(x) {
    declare(type(x = integer(NA)))
    x + 1L
  }

  expect_translation_snapshots(fn)
  expect_quick_identical(fn, 1:10)
})

skip_on_cran()

test_that("min handles scalar arguments without reduction", {
  fn <- function(a, b, m) {
    declare(
      type(a = integer(1)),
      type(b = integer(1)),
      type(m = integer(NA, 2))
    )

    c(min(m[a, 1], m[b, 1]), min(m[a, 2], m[b, 2]))
  }

  # fsub <- r2f(fn)
  # expect_no_match(as.character(fsub), "minval\\(")

  m <- matrix(c(5L, 1L, 3L, 9L), ncol = 2, byrow = TRUE)
  expect_identical(fn(1L, 1L, m), c(5L, 1L))
  expect_identical(fn(1L, 2L, m), c(3L, 1L))
  expect_quick_identical(fn, list(1L, 1L, m), list(1L, 2L, m))
})


test_that("drop = FALSE preserves dims and uses reductions", {
  fn <- function(a, m) {
    declare(
      type(a = integer(1)),
      type(m = integer(NA, 2))
    )

    min(m[a, 1L, drop = FALSE])
  }

  # fsub <- r2f(fn)
  # expect_match(as.character(fsub), "minval\\(")

  m <- matrix(c(2L, 4L, 1L, 3L), nrow = 2L, byrow = TRUE)
  expect_identical(fn(1L, m), 2L)
  expect_identical(fn(2L, m), 1L)
  expect_quick_identical(fn, list(1L, m), list(2L, m))
})


test_that("reductions over vectors still use intrinsics", {
  fn <- function(x) {
    declare(type(x = integer(n)))
    min(x)
  }

  # fsub <- r2f(fn)
  # expect_match(as.character(fsub), "minval\\(")

  x1 <- c(10L, -2L, 5L, 3L)
  x2 <- c(1L, 2L, 3L)

  expect_identical(fn(x1), -2L)
  expect_identical(fn(x2), 1L)
  expect_quick_identical(fn, x1, x2)
})


test_that("nested scalar min/max compiles and runs", {
  fn <- function(m) {
    declare(type(m = integer(2, 2)))
    lo <- 1L
    hi <- 2L
    min(max(m[1, 1], lo), hi)
  }

  m1 <- matrix(c(0L, 3L, 1L, 2L), nrow = 2L, byrow = TRUE)
  m2 <- matrix(c(10L, 3L, 1L, 2L), nrow = 2L, byrow = TRUE)
  expect_identical(fn(m1), 1L)
  expect_identical(fn(m2), 2L)
  expect_quick_identical(fn, m1, m2)
})


test_that("clamp on a 1d array works with nested scalar min/max", {
  clamp <- function(x, lo, hi) {
    declare(type(x = double(n)), type(lo = double(1)), type(hi = double(1)))
    out <- double(length(x))
    for (i in seq_along(x)) {
      out[i] <- min(max(x[i], lo), hi)
    }
    out
  }

  x <- c(-2.0, -0.5, 0.25, 1.25, 10.0)
  lo <- -0.25
  hi <- 1.0

  expect_identical(clamp(x, lo, hi), pmin(pmax(x, lo), hi))
  expect_quick_identical(clamp, list(x, lo, hi))
})

# Float-to-int conversion semantics (truncation vs floor/ceiling).

skip_on_cran()

test_that("as.integer(double) truncates toward zero", {
  fn <- function(x) {
    declare(type(x = double(NA)))
    out <- as.integer(x)
    out
  }

  expect_translation_snapshots(fn)

  x <- c(-2.9, -2.1, -1.9, -1.1, -0.9, -0.1, 0, 0.1, 0.9, 1.1, 1.9, 2.1)
  expect_quick_identical(fn, x)
})

test_that("trunc() returns double and truncates toward zero", {
  fn_d <- function(x) {
    declare(type(x = double(NA)))
    out <- trunc(x)
    out
  }

  expect_translation_snapshots(fn_d)

  x <- c(-2.9, -2.1, -1.9, -1.1, -0.9, -0.1, 0, 0.1, 0.9, 1.1, 1.9, 2.1)
  expect_quick_equal(fn_d, x)

  fn_i <- function(x) {
    declare(type(x = integer(NA)))
    out <- trunc(x)
    out
  }

  expect_translation_snapshots(fn_i)

  xi <- as.integer(c(-3, -1, 0, 2, 5))
  expect_quick_equal(fn_i, xi)
  expect_identical(typeof(fn_i(xi)), "double")
})

test_that("as.integer(integer division) truncates toward zero", {
  fn <- function(a, b) {
    declare(type(a = integer(n)), type(b = integer(n)))
    out <- as.integer(a / b)
    out
  }

  expect_translation_snapshots(fn)

  a <- as.integer(c(7, -7, 7, -7, 3, -3))
  b <- as.integer(c(2, 2, -2, -2, 2, 2))
  expect_quick_identical(fn, list(a, b))
})

skip_on_cran()

test_that("qr.solve translation uses linpack path", {
  qr_solve_vec <- function(a, b) {
    declare(
      type(a = double(n, k)),
      type(b = double(n))
    )
    qr.solve(a, b)
  }

  qr_solve_mat <- function(a, b) {
    declare(
      type(a = double(n, k)),
      type(b = double(n, m))
    )
    qr.solve(a, b)
  }

  expect_translation_snapshots(
    qr_solve_vec,
    note = "qr.solve uses dqrdc2/dqrcf (vector rhs)"
  )
  expect_translation_snapshots(
    qr_solve_mat,
    note = "qr.solve uses dqrdc2/dqrcf (matrix rhs)"
  )
})

test_that("qr.solve quick matches base R", {
  qr_solve_vec <- function(a, b) {
    declare(
      type(a = double(n, k)),
      type(b = double(n))
    )
    qr.solve(a, b)
  }

  qr_solve_mat <- function(a, b) {
    declare(
      type(a = double(n, k)),
      type(b = double(n, m))
    )
    qr.solve(a, b)
  }

  set.seed(123)
  a <- matrix(rnorm(40), nrow = 10)
  b <- rnorm(10)
  expect_quick_equal(qr_solve_vec, list(a, b))

  b_mat <- matrix(rnorm(20), nrow = 10)
  expect_quick_equal(qr_solve_mat, list(a, b_mat))

  a_wide <- matrix(rnorm(30), nrow = 5)
  b_wide <- rnorm(5)
  expect_quick_equal(qr_solve_vec, list(a_wide, b_wide))
})

skip_on_cran()

test_that("array-expression subscripting hoists into a block-scoped temp", {
  fn <- function(x) {
    declare(type(x = double(3, 4)))
    out <- ifelse((x > 0.0)[2, 3], 1.0, 0.0)
    out
  }

  expect_translation_snapshots(
    fn,
    note = "Fortran disallows (expr)(i,j); quickr uses a block-local temp array."
  )

  set.seed(1)
  x <- matrix(runif(12) - 0.5, 3, 4)
  expect_quick_identical(fn, list(x))
})

test_that("block-scoped temps work for rank-3 array expression subscripting", {
  fn <- function(x) {
    declare(type(x = double(2, 3, 4)))
    out <- ifelse((x > 0.0)[2, 3, 4], 1.0, 0.0)
    out
  }

  set.seed(1)
  x <- array(runif(24) - 0.5, dim = c(2, 3, 4))
  expect_quick_identical(fn, list(x))
})

test_that("block-scoped temps allocate on the heap for runtime shapes", {
  fn <- function(x) {
    declare(type(x = double(n, m)))
    out <- ifelse((x > 0.0)[1, 1], 1.0, 0.0)
    out
  }

  expect_translation_snapshots(
    fn,
    note = paste(
      "Block temps with runtime sizes are allocatable so flang doesn't",
      "stack-allocate large work arrays."
    )
  )

  set.seed(1)
  x <- matrix(runif(64) - 0.5, 8, 8)
  expect_quick_identical(fn, list(x))
})

test_that("block-scoped temps work for deferred-shape intermediates", {
  fn <- function(x) {
    declare(type(x = double(NA)))
    out <- (x[x > 0.0])[1]
    out
  }

  x <- c(-1.0, 2.0, -3.0)
  expect_quick_identical(fn, list(x))
})

# Large-magnitude floor()/ceiling() behavior.
#
# R's floor()/ceiling() return doubles. Our Fortran lowering should match R,
# including for values that exceed the range of Fortran default integers on some
# compilers (a potential overflow hazard if we lower via FLOOR()/CEILING()).

skip_on_cran()

test_that("floor() and ceiling() match R for large magnitude doubles", {
  fn_floor <- function(x) {
    declare(type(x = double(NA)))
    out <- floor(x)
    out
  }

  fn_ceiling <- function(x) {
    declare(type(x = double(NA)))
    out <- ceiling(x)
    out
  }

  imax <- as.double(.Machine$integer.max)
  x <- c(
    -2.9,
    -1.1,
    -0.1,
    0,
    0.1,
    1.1,
    2.9,
    imax - 0.2,
    -(imax - 0.2),
    (imax + 1000) + 0.2,
    -((imax + 1000) + 0.2),
    1e12 + 0.2,
    -(1e12 + 0.2)
  )

  expect_quick_equal(fn_floor, x)
  expect_quick_equal(fn_ceiling, x)
})

skip_on_cran()

test_that("rev() reverses vectors", {
  fn_dbl <- function(x) {
    declare(type(x = double(NA)))
    rev(x)
  }
  expect_quick_identical(
    fn_dbl,
    list(as.double(1:5)),
    list(as.double(c(2, -1, 3, 0)))
  )

  fn_int <- function(x) {
    declare(type(x = integer(NA)))
    rev(x)
  }
  expect_quick_identical(fn_int, list(as.integer(c(1, 0, -3, 2))))

  # Logical arguments are passed via the bind(c) interface as integer storage.
  fn_lgl <- function(x) {
    declare(type(x = logical(NA)))
    rev(x)
  }
  expect_quick_identical(fn_lgl, list(c(TRUE, FALSE, TRUE, FALSE)))
  expect_quick_identical(fn_lgl, list(c(TRUE, NA, FALSE, TRUE)))
})

test_that("rev() preserves bind(c) logical scalar storage (incl. NA)", {
  fn <- function(m) {
    declare(type(m = logical(1)))
    rev(m)
  }

  expect_quick_identical(fn, list(TRUE))
  expect_quick_identical(fn, list(FALSE))
  expect_quick_identical(fn, list(NA))
})

test_that("rev(rev()) preserves bind(c) logical storage (incl. NA)", {
  fn <- function(m) {
    declare(type(m = logical(NA)))
    rev(rev(m))
  }

  m <- c(TRUE, FALSE, NA, TRUE, FALSE)
  expect_quick_identical(fn, list(m))
})

test_that("rev() result can flow into logical coercions and reductions", {
  fn_as_integer <- function(m) {
    declare(type(m = logical(NA)))
    as.integer(rev(m))
  }
  fn_which_max <- function(m) {
    declare(type(m = logical(NA)))
    which.max(rev(m))
  }
  fn_which_min <- function(m) {
    declare(type(m = logical(NA)))
    which.min(rev(m))
  }

  m <- c(TRUE, FALSE, TRUE, FALSE, TRUE, TRUE)
  expect_quick_identical(fn_as_integer, list(m))
  expect_quick_identical(fn_which_max, list(m))
  expect_quick_identical(fn_which_min, list(m))
})

test_that("rev() works inside compound logical expressions", {
  fn <- function(x) {
    declare(type(x = logical(NA)))
    out <- ifelse(rev(x) & x, 1L, 0L)
    out
  }

  x <- c(TRUE, FALSE, TRUE, TRUE, FALSE, TRUE)
  expect_quick_identical(fn, list(x))
})

test_that("rev() works as an external logical mask in x[mask]", {
  fn <- function(x, m) {
    declare({
      type(x = double(NA))
      type(m = logical(NA))
    })
    sum(x[rev(m)])
  }

  x <- as.double(seq_len(10))
  m <- c(TRUE, FALSE, TRUE, TRUE, FALSE, TRUE, FALSE, FALSE, TRUE, FALSE)
  expect_quick_equal(fn, list(x, m))
})

test_that("rev() mask assignment preserves bind(c) storage through local symbols", {
  fn <- function(x, m) {
    declare({
      type(x = double(NA))
      type(m = logical(NA))
    })
    r <- rev(m)
    sum(x[r])
  }

  x <- as.double(seq_len(12))
  m <- c(
    TRUE,
    FALSE,
    TRUE,
    TRUE,
    FALSE,
    TRUE,
    FALSE,
    TRUE,
    FALSE,
    FALSE,
    TRUE,
    TRUE
  )
  expect_quick_equal(fn, list(x, m))
})

test_that("rev() works on local Fortran logical vectors and masks", {
  fn <- function(x) {
    declare(type(x = double(NA)))
    m <- x > 0
    sum(x[rev(m)])
  }

  x <- as.double(c(-2, -1, 0, 1, 2, 3, -4, 5))
  expect_quick_equal(fn, list(x))
})

test_that("rev() can be used as a reduction mask (sum(x[mask]))", {
  fn <- function(x, m) {
    declare({
      type(x = double(NA))
      type(m = logical(NA))
    })
    sum(x[rev(m)])
  }

  x <- as.double(seq_len(20))
  m <- rep(c(TRUE, FALSE, TRUE, TRUE), length.out = length(x))
  expect_quick_equal(fn, list(x, m))
})

test_that("rev() hoists array expressions", {
  fn <- function(x) {
    declare(type(x = double(NA)))
    rev(x + 1)
  }
  expect_quick_identical(fn, list(as.double(1:6)))
})

test_that("rev() is a no-op for scalars", {
  fn <- function(x) {
    declare(type(x = double(1)))
    rev(x)
  }
  expect_quick_identical(fn, list(as.double(3)))
})

skip_on_cran()

test_that("as.double casts integer and logical values", {
  fn_int <- function(x) {
    declare(type(x = integer(n)))
    as.double(x)
  }
  expect_quick_identical(fn_int, list(1:3))

  fn_lgl <- function(x) {
    declare(type(x = logical(n)))
    as.double(x)
  }
  expect_quick_identical(fn_lgl, list(c(TRUE, FALSE, TRUE)))
})

test_that("as.double drops dimensions for matrices and allows slice assignment", {
  as_vec <- function(a) {
    declare(type(a = integer(2L, 3L)))
    as.double(a)
  }
  expect_quick_identical(as_vec, list(matrix(1:6, 2, 3)))

  assign_slice <- function(a) {
    declare(type(a = integer(2L, 3L)))
    out <- double(6L)
    out[1:6] <- as.double(a)
    out
  }
  expect_quick_identical(assign_slice, list(matrix(1:6, 2, 3)))
})

test_that("/ performs real division for integer and logical inputs", {
  div_int <- function(a, b) {
    declare(type(a = integer(n)), type(b = integer(n)))
    a / b
  }
  expect_quick_equal(div_int, list(1:3, c(2L, 2L, 2L)))

  div_lgl <- function(a, b) {
    declare(type(a = logical(n)), type(b = logical(n)))
    a / b
  }
  expect_quick_equal(div_lgl, list(c(TRUE, FALSE, TRUE), c(TRUE, TRUE, TRUE)))
})

skip_on_cran()

test_that("division casts integers", {
  div_int <- function(a, b) {
    declare(type(a = integer(n)), type(b = integer(n)))
    a / b
  }

  expect_translation_snapshots(div_int)

  a <- as.integer(-5:5)
  b <- as.integer(sample(a))
  expect_quick_equal(div_int, list(a, b))
})


test_that("division casts double and integer", {
  div_dbl_int <- function(a, b) {
    declare(type(a = double(n)), type(b = integer(n)))
    a / b
  }

  expect_translation_snapshots(div_dbl_int)

  a <- as.double(-5:5)
  b <- as.integer(sample(-5:5))
  expect_quick_equal(div_dbl_int, list(a, b))
})


test_that("division casts logical", {
  div_dbl_lgl <- function(a, b) {
    declare(type(a = double(n)), type(b = logical(n)))
    a / b
  }

  expect_translation_snapshots(div_dbl_lgl)

  a <- c(-3, 0, 3)
  b <- c(TRUE, FALSE, TRUE)
  expect_quick_equal(div_dbl_lgl, list(a, b))
})


test_that("division casts complex", {
  div_cplx <- function(a, b) {
    declare(type(a = complex(n)), type(b = complex(n)))
    a / b
  }

  expect_translation_snapshots(div_cplx)

  real <- -2:2
  imag <- rev(real)
  a <- complex(real = real, imaginary = imag)
  b <- sample(a[a != 0 + 0i], length(a), replace = TRUE)
  expect_quick_equal(div_cplx, list(a, b))
})


test_that("division example in #33", {
  my_mean <- function(x) {
    declare(type(x = double(NA)))
    mu <- sum(x) / length(x)
    mu
  }

  expect_translation_snapshots(my_mean)

  x <- c(3, 5, 7, 8)
  expect_quick_equal(my_mean, list(x))
})

# Unit tests for unary intrinsic functions

skip_on_cran()

test_that("double unary intrinsics", {
  double_intrinsics <- c(
    "sin",
    "cos",
    "tan",
    "tanh",
    "asin",
    "acos",
    "atan",
    "sqrt",
    "exp",
    "log",
    "log10",
    "floor",
    "ceiling",
    "abs"
  )

  for (intr in double_intrinsics) {
    fn <- eval(str2lang(sprintf(
      "function(x) {
         declare(type(x = double(NA)))
         out <- %s(x)
         out
       }",
      intr
    )))

    expect_translation_snapshots(fn)

    x <- switch(
      intr,
      asin = seq(-1, 1, length.out = 20),
      acos = seq(-1, 1, length.out = 20),
      sqrt = seq(0, 10, length.out = 20),
      log = seq(.1, 10, length.out = 20),
      log10 = seq(.1, 10, length.out = 20),
      exp = seq(-2, 2, length.out = 20),
      seq(-5, 5, length.out = 20)
    )
    expect_quick_equal(fn, x)
  }
})

test_that("integer unary intrinsics", {
  integer_intrinsics <- c("abs")

  for (intr in integer_intrinsics) {
    fn <- eval(str2lang(sprintf(
      "function(x) {
         declare(type(x = integer(NA)))
         out <- %s(x)
         out
       }",
      intr
    )))

    expect_translation_snapshots(fn)

    x <- as.integer(seq(-5, 5, length.out = 20))
    expect_quick_identical(fn, x)
  }
})

test_that("complex unary intrinsics", {
  set.seed(123)
  x <- seq(-5, 5, length.out = 30)
  z <- complex(real = x, imaginary = sample(x))

  complex_intrinsics <- c(
    "sin",
    "cos",
    "tan",
    "tanh",
    "asin",
    "acos",
    "atan",
    "sqrt",
    "exp",
    "log",
    "log10",
    "Re",
    "Im",
    "Mod",
    "Arg",
    "Conj"
  )

  for (intr in complex_intrinsics) {
    fn <- eval(str2lang(sprintf(
      "function(z) {
         declare(type(z = complex(NA)))
         out <- %s(z)
         out
       }",
      intr
    )))

    expect_translation_snapshots(fn)
    expect_quick_equal(fn, z)
  }
})


test_that("unary logical 'not'-operator on vector", {
  fn <- function(x) {
    declare(type(x = integer(n)))
    lgl <- x > 1L
    not_lgl <- !lgl
    not_lgl
  }

  x1 <- -3:3
  x2 <- 0:5
  expect_quick_identical(fn, list(x1), list(x2))
})

test_that("unary minus and plus for integer and double", {
  fn_neg_i <- function(x) {
    declare(type(x = integer(n)))
    y <- -x
    y
  }
  fn_pos_i <- function(x) {
    declare(type(x = integer(n)))
    y <- +x
    y
  }
  xi <- -5:5
  expect_quick_identical(fn_neg_i, list(xi))
  expect_quick_identical(fn_pos_i, list(xi))

  fn_neg_d <- function(x) {
    declare(type(x = double(n)))
    y <- -x
    y
  }
  fn_pos_d <- function(x) {
    declare(type(x = double(n)))
    y <- +x
    y
  }
  xd <- -5:5 + 0.5
  expect_quick_equal(fn_neg_d, list(xd))
  expect_quick_equal(fn_pos_d, list(xd))
})

test_that("logical not local used as ifelse mask compiles and runs", {
  fn <- function(x) {
    declare(type(x = logical(NA)))
    y <- !x
    out <- ifelse(y, 1L, 0L)
    out
  }

  # Ensure translation and execution are correct
  expect_translation_snapshots(fn)
  expect_quick_identical(fn, list(c(TRUE, FALSE, TRUE)))
})

# Unit tests for C bridge hoisting of size expressions

skip_on_cran()

test_that("size check blocks redeclare hoisted size temps", {
  fn <- function(n, m, a, b) {
    declare(
      type(n = integer(1)),
      type(m = integer(1)),
      type(a = double(min(n, m))),
      type(b = double(min(n, m))),
      type(out = double(min(n, m)))
    )
    out <- double(min(n, m))
    for (i in seq_len(length(out))) {
      out[i] <- a[i] + b[i]
    }
    out
  }

  expect_translation_snapshots(fn)
  expect_quick_identical(
    fn,
    list(3L, 5L, c(1, 2, 3), c(10, 20, 30)),
    list(5L, 3L, c(1, 2, 3), c(4, 5, 6))
  )
})

# Unit tests for modulus and integer division

skip_on_cran()

test_that("%% and %/%", {
  x <- -7:7
  x <- expand.grid(a = x, b = x)
  x <- x[x$b != 0, ] # avoid divisor == 0
  x <- as.list(x)

  rem_double <- function(a, b) {
    declare(type(a = double(n)), type(b = double(n)))
    a %% b
  }

  expect_translation_snapshots(rem_double)
  expect_quick_equal(rem_double, lapply(x, function(v) v + 0.2))

  rem_int <- function(a, b) {
    declare(type(a = integer(n)), type(b = integer(n)))
    a %% b
  }
  expect_quick_identical(rem_int, x)

  div_double <- function(a, b) {
    declare(type(a = double(n)), type(b = double(n)))
    a %/% b
  }

  expect_translation_snapshots(div_double)
  expect_quick_equal(div_double, lapply(x, function(v) v + 0.2))

  div_int <- function(a, b) {
    declare(type(a = integer(n)), type(b = integer(n)))
    a %/% b
  }
  expect_quick_identical(div_int, x)
})

# r2f-conditionals.R
# Handlers for vectorized conditionals: ifelse

# --- Handlers ---

r2f_handlers[["ifelse"]] <- function(args, scope, ...) {
  .[mask, tsource, fsource] <- lapply(args, r2f, scope, ...)
  mask <- booleanize_logical_as_int(mask)
  # (tsource, fsource, mask)
  mode <- tsource@value@mode
  dims <- conform(mask@value, tsource@value, fsource@value)@dims
  Fortran(glue("merge({tsource}, {fsource}, {mask})"), Variable(mode, dims))
}

# r2f-coercions.R
# Handlers for type coercions: as.double, as.integer

# --- Handlers ---

r2f_handlers[["as.double"]] <- function(args, scope = NULL, ...) {
  stopifnot(length(args) == 1L)
  x <- r2f(args[[1L]], scope, ...)
  x <- maybe_cast_double(x)

  # R drops dimensions for as.double(<array>): the result is a vector.
  if (!passes_as_scalar(x@value) && x@value@rank > 1L) {
    len_expr <- value_length_expr(x@value)
    len_str <- if (is_scalar_na(len_expr)) {
      glue("size({x})")
    } else {
      # dims2f() returns "" for a scalar "1", but we need a literal length.
      out <- dims2f(list(len_expr), scope)
      if (!nzchar(out)) "1" else out
    }

    out_val <- Variable(
      "double",
      list(if (is_scalar_na(len_expr)) NA else len_expr)
    )
    return(Fortran(glue("reshape({x}, [{len_str}])"), out_val))
  }

  x
}

r2f_handlers[["as.integer"]] <- function(args, scope = NULL, ...) {
  stopifnot(length(args) == 1L)
  arg <- r2f(args[[1L]], scope, ...)

  # R semantics:
  # - numeric -> integer truncates toward 0
  # - logical -> integer is 0/1
  # - result is an integer vector
  out_val <- Variable("integer", arg@value@dims)

  out <- switch(
    arg@value@mode,
    integer = arg,
    double = Fortran(glue("int({arg}, kind=c_int)"), out_val),
    logical = {
      # External logicals are integer-backed (0/1/NA) under bind(c); if the
      # expression preserves that storage (e.g. rev(m)), return it directly.
      if (logical_as_int(arg@value)) {
        src <- arg@value@name %||% as.character(arg)
        return(Fortran(src, out_val))
      }
      arg <- booleanize_logical_as_int(arg)
      Fortran(glue("merge(1_c_int, 0_c_int, {arg})"), out_val)
    },
    stop("as.integer() only implemented for logical, integer, and double")
  )

  # R drops dimensions for as.integer(<array>): the result is a vector.
  if (!passes_as_scalar(out@value) && out@value@rank > 1L) {
    len_expr <- value_length_expr(out@value)
    len_str <- if (is_scalar_na(len_expr)) {
      glue("size({out})")
    } else {
      out_len <- dims2f(list(len_expr), scope)
      if (!nzchar(out_len)) "1" else out_len
    }
    out_val <- Variable(
      "integer",
      list(if (is_scalar_na(len_expr)) NA else len_expr)
    )
    return(Fortran(glue("reshape({out}, [{len_str}])"), out_val))
  }

  out
}

# Matrix-specific r2f handlers and wiring

# %*% handler with optional destination hint
register_r2f_handler(
  "%*%",
  function(args, scope, ..., hoist = NULL, dest = NULL) {
    stopifnot(length(args) == 2L)
    left_info <- unwrap_transpose_arg(args[[1L]], scope, ..., hoist = hoist)
    right_info <- unwrap_transpose_arg(args[[2L]], scope, ..., hoist = hoist)
    left <- left_info$value
    right <- right_info$value
    left_trans <- left_info$trans
    right_trans <- right_info$trans

    left_rank <- left@value@rank
    right_rank <- right@value@rank

    if (left_rank > 2 || right_rank > 2) {
      stop("%*% only supports vectors/matrices (rank <= 2)")
    }

    left_dims <- matrix_dims(
      left,
      orientation = if (left_rank == 1) "rowvec" else "matrix"
    )

    right_dims <- matrix_dims(
      right,
      orientation = if (right_rank == 1) "colvec" else "matrix"
    )

    left_eff <- if (left_rank == 2) {
      effective_dims(left_dims, left_trans)
    } else {
      left_dims
    }
    right_eff <- if (right_rank == 2) {
      effective_dims(right_dims, right_trans)
    } else {
      right_dims
    }

    # Compute effective shapes
    m <- left_eff$rows
    k <- left_eff$cols
    n <- right_eff$cols

    # Leading dimensions
    lda <- left_dims$rows
    ldb <- right_dims$rows
    ldc_expr <- m

    # Matrix-Vector: use GEMV
    if (left_rank == 2 && right_rank == 1) {
      expected_len <- if (left_trans == "N") left_dims$cols else left_dims$rows
      conform <- check_conformable(expected_len, right_dims$rows)
      if (!conform$ok) {
        stop("non-conformable arguments in %*%", call. = FALSE)
      }
      if (conform$unknown) {
        warn_conformability_unknown(expected_len, right_dims$rows, "%*%")
      }
      out_len <- if (left_trans == "N") left_dims$rows else left_dims$cols
      return(gemv(
        transA = left_trans,
        A = left,
        x = right,
        m = left_dims$rows,
        n = left_dims$cols,
        lda = left_dims$rows,
        out_dims = list(out_len, 1L),
        scope = scope,
        hoist = hoist,
        dest = dest,
        context = "%*%"
      ))
    }
    # Vector-Matrix: use GEMV with transpose
    if (left_rank == 1 && right_rank == 2) {
      transA <- if (right_trans == "N") "T" else "N"
      expected_len <- if (transA == "N") right_dims$cols else right_dims$rows
      conform <- check_conformable(left_dims$cols, expected_len)
      if (!conform$ok) {
        stop("non-conformable arguments in %*%", call. = FALSE)
      }
      if (conform$unknown) {
        warn_conformability_unknown(left_dims$cols, expected_len, "%*%")
      }
      out_len <- if (transA == "N") right_dims$rows else right_dims$cols
      return(gemv(
        transA = transA,
        A = right,
        x = left,
        m = right_dims$rows,
        n = right_dims$cols,
        lda = right_dims$rows,
        out_dims = list(1L, out_len),
        scope = scope,
        hoist = hoist,
        dest = dest,
        context = "%*%"
      ))
    }

    conform <- check_conformable(k, right_eff$rows)
    if (!conform$ok) {
      stop("non-conformable arguments in %*%", call. = FALSE)
    }
    if (conform$unknown) {
      warn_conformability_unknown(k, right_eff$rows, "%*%")
    }

    # Matrix-Matrix
    gemm(
      opA = left_trans,
      opB = right_trans,
      left = left,
      right = right,
      m = m,
      n = n,
      k = k,
      lda = lda,
      ldb = ldb,
      ldc_expr = ldc_expr,
      scope = scope,
      hoist = hoist,
      dest = dest,
      context = "%*%"
    )
  },
  dest_supported = TRUE,
  dest_infer = infer_dest_matmul
)


# t(x) handler: transpose 2D; 1D becomes a 1 x n row matrix
r2f_handlers[["t"]] <- function(args, scope, ..., hoist = NULL) {
  stopifnot(length(args) == 1L)
  x <- r2f(args[[1L]], scope, ..., hoist = hoist)
  x <- maybe_cast_double(x)
  if (x@value@rank == 2) {
    val <- Variable("double", list(x@value@dims[[2]], x@value@dims[[1]]))
    return(Fortran(glue("transpose({x})"), val))
  } else if (x@value@rank == 1) {
    len <- x@value@dims[[1]]
    val <- Variable("double", list(1L, len))
    return(Fortran(glue("reshape({x}, [1, int({len})])"), val))
  } else if (x@value@rank == 0) {
    return(x)
  } else {
    stop("t() only supports rank 0-2 inputs")
  }
}

register_r2f_handler(
  "drop",
  function(args, scope, ..., hoist = NULL) {
    x_arg <- args$x %||% args[[1L]]
    if (is.null(x_arg) || is_missing(x_arg)) {
      stop("drop() expects `x`", call. = FALSE)
    }
    x <- r2f(x_arg, scope, ..., hoist = hoist)
    if (is.null(x@value)) {
      stop("drop() expects a typed value", call. = FALSE)
    }
    if (x@value@rank <= 1L) {
      return(x)
    }
    if (x@value@rank != 2L) {
      stop("drop() only supports rank 0-2 inputs", call. = FALSE)
    }

    row_dim <- x@value@dims[[1L]]
    col_dim <- x@value@dims[[2L]]
    row_is_one <- dim_is_one(row_dim)
    col_is_one <- dim_is_one(col_dim)

    if (row_is_one && col_is_one) {
      return(scalarize_matrix(x))
    }
    if (row_is_one) {
      out_val <- Variable(x@value@mode, list(col_dim))
      return(Fortran(glue("{x}(1, :)"), out_val))
    }
    if (col_is_one) {
      out_val <- Variable(x@value@mode, list(row_dim))
      return(Fortran(glue("{x}(:, 1)"), out_val))
    }
    x
  }
)

bind_output_mode <- function(values, context) {
  modes <- unique(vapply(
    values,
    function(val) val@value@mode %||% NA_character_,
    character(1)
  ))
  if (anyNA(modes) || any(!nzchar(modes))) {
    stop(context, " inputs must have a known type", call. = FALSE)
  }
  if ("complex" %in% modes) {
    if (length(modes) > 1L) {
      stop(
        context,
        " does not support mixing complex with other types",
        call. = FALSE
      )
    }
    return("complex")
  }
  if ("double" %in% modes) {
    return("double")
  }
  if ("integer" %in% modes) {
    return("integer")
  }
  if ("logical" %in% modes) {
    return("logical")
  }
  if ("raw" %in% modes) {
    return("raw")
  }
  stop(context, " does not support input mode(s): ", str_flatten_commas(modes))
}

bind_cast_value <- function(value, mode, context) {
  if (identical(value@value@mode, mode)) {
    return(value)
  }
  if (identical(mode, "double")) {
    return(maybe_cast_double(value))
  }
  if (identical(mode, "integer") && identical(value@value@mode, "logical")) {
    return(Fortran(
      glue("merge(1_c_int, 0_c_int, {value})"),
      Variable("integer", value@value@dims)
    ))
  }
  stop(
    context,
    " does not support coercion from ",
    value@value@mode,
    " to ",
    mode,
    call. = FALSE
  )
}

bind_dim_sum <- function(values, context, label) {
  if (!length(values)) {
    return(0L)
  }
  if (any(map_lgl(values, is_scalar_na))) {
    stop(
      context,
      " requires inputs with known ",
      label,
      " sizes",
      call. = FALSE
    )
  }
  if (all(map_lgl(values, is_wholenumber))) {
    return(sum(as.integer(values)))
  }
  reduce(values, \(a, b) call("+", a, b))
}

bind_common_dim <- function(dim_list, scalar_flags, context, label) {
  non_scalar <- which(!scalar_flags)
  if (!length(non_scalar)) {
    return(1L)
  }
  target <- dim_list[[non_scalar[[1L]]]]
  if (is_scalar_na(target)) {
    stop(
      context,
      " requires inputs with known ",
      label,
      " counts",
      call. = FALSE
    )
  }
  if (length(non_scalar) > 1L) {
    for (idx in non_scalar[-1L]) {
      conform <- check_conformable(target, dim_list[[idx]])
      if (!conform$ok) {
        stop(
          context,
          " requires inputs with a common ",
          label,
          " count",
          call. = FALSE
        )
      }
      if (conform$unknown) {
        stop(
          context,
          " requires inputs with a common ",
          label,
          " count",
          call. = FALSE
        )
      }
    }
  }
  target
}

bind_dim_string <- function(dim) {
  if (is.character(dim)) {
    dim
  } else if (is_wholenumber(dim)) {
    as.character(as.integer(dim))
  } else if (is.numeric(dim)) {
    as.character(dim)
  } else {
    gsub("([0-9]+)L\\b", "\\1", deparse1(dim))
  }
}

bind_dim_int <- function(dim) {
  paste0("int(", bind_dim_string(dim), ")")
}

bind_col_matrix_expr <- function(value, rows, is_scalar, context) {
  rows_int <- bind_dim_int(rows)
  if (is_scalar) {
    vec <- glue("spread({value}, 1, {rows_int})")
    return(glue("reshape({vec}, [{rows_int}, 1])"))
  }
  if (value@value@rank == 1L) {
    return(glue("reshape({value}, [{rows_int}, 1])"))
  }
  if (value@value@rank == 2L) {
    return(as.character(value))
  }
  stop(context, " only supports rank 0-2 inputs", call. = FALSE)
}

bind_row_matrix_expr <- function(value, cols, is_scalar, context) {
  cols_int <- bind_dim_int(cols)
  if (is_scalar) {
    vec <- glue("spread({value}, 1, {cols_int})")
    return(glue("reshape({vec}, [1, {cols_int}])"))
  }
  if (value@value@rank == 1L) {
    return(glue("reshape({value}, [1, {cols_int}])"))
  }
  if (value@value@rank == 2L) {
    return(as.character(value))
  }
  stop(context, " only supports rank 0-2 inputs", call. = FALSE)
}

register_r2f_handler(
  "cbind",
  function(args, scope, ..., hoist = NULL) {
    context <- "cbind()"
    if (!is.null(args$deparse.level) && !is_missing(args$deparse.level)) {
      args$deparse.level <- NULL
    }
    args <- args[!vapply(args, is_missing, logical(1))]
    args <- args[
      !vapply(
        args,
        \(x) is.null(x) || identical(x, quote(NULL)),
        logical(1)
      )
    ]
    if (!length(args)) {
      stop("cbind() requires at least one argument", call. = FALSE)
    }

    values <- lapply(args, r2f, scope, ..., hoist = hoist)
    for (val in values) {
      if (is.null(val@value) || is.null(val@value@mode)) {
        stop(context, " inputs must have a value", call. = FALSE)
      }
      assert_rank_leq2(val, paste0(context, " only supports rank 0-2 inputs"))
    }

    mode <- bind_output_mode(values, context)
    values <- lapply(values, bind_cast_value, mode = mode, context = context)

    dims <- lapply(values, matrix_dims, orientation = "colvec")
    scalar_flags <- map_lgl(values, \(val) passes_as_scalar(val@value))
    row_sizes <- lapply(dims, `[[`, "rows")
    col_sizes <- lapply(dims, `[[`, "cols")

    rows <- bind_common_dim(row_sizes, scalar_flags, context, "row")
    cols <- bind_dim_sum(col_sizes, context, "column")

    col_exprs <- vector("list", length(values))
    for (i in seq_along(values)) {
      col_exprs[[i]] <- bind_col_matrix_expr(
        value = values[[i]],
        rows = rows,
        is_scalar = scalar_flags[[i]],
        context = context
      )
    }

    data_expr <- glue("[{str_flatten_commas(col_exprs)}]")
    out_expr <- glue(
      "reshape({data_expr}, [{bind_dim_int(rows)}, {bind_dim_int(cols)}])"
    )
    Fortran(out_expr, Variable(mode, list(rows, cols)))
  }
)

register_r2f_handler(
  "rbind",
  function(args, scope, ..., hoist = NULL) {
    context <- "rbind()"
    if (!is.null(args$deparse.level) && !is_missing(args$deparse.level)) {
      args$deparse.level <- NULL
    }
    args <- args[!vapply(args, is_missing, logical(1))]
    args <- args[
      !vapply(
        args,
        \(x) is.null(x) || identical(x, quote(NULL)),
        logical(1)
      )
    ]
    if (!length(args)) {
      stop("rbind() requires at least one argument", call. = FALSE)
    }

    values <- lapply(args, r2f, scope, ..., hoist = hoist)
    for (val in values) {
      if (is.null(val@value) || is.null(val@value@mode)) {
        stop(context, " inputs must have a value", call. = FALSE)
      }
      assert_rank_leq2(val, paste0(context, " only supports rank 0-2 inputs"))
    }

    mode <- bind_output_mode(values, context)
    values <- lapply(values, bind_cast_value, mode = mode, context = context)

    dims <- lapply(values, matrix_dims, orientation = "rowvec")
    scalar_flags <- map_lgl(values, \(val) passes_as_scalar(val@value))
    row_sizes <- lapply(dims, `[[`, "rows")
    col_sizes <- lapply(dims, `[[`, "cols")

    cols <- bind_common_dim(col_sizes, scalar_flags, context, "column")
    rows <- bind_dim_sum(row_sizes, context, "row")

    row_exprs <- vector("list", length(values))
    for (i in seq_along(values)) {
      row_exprs[[i]] <- bind_row_matrix_expr(
        value = values[[i]],
        cols = cols,
        is_scalar = scalar_flags[[i]],
        context = context
      )
    }
    transposed <- lapply(row_exprs, \(expr) glue("transpose({expr})"))

    data_expr <- glue("[{str_flatten_commas(transposed)}]")
    combined <- glue(
      "reshape({data_expr}, [{bind_dim_int(cols)}, {bind_dim_int(rows)}])"
    )
    out_expr <- glue("transpose({combined})")

    Fortran(out_expr, Variable(mode, list(rows, cols)))
  }
)


# Handle crossprod(), using SYRK for single-arg and GEMM for two-arg forms.
register_r2f_handler(
  "crossprod",
  function(args, scope, ..., hoist = NULL, dest = NULL) {
    x_arg <- args$x %||% args[[1L]]
    y_arg <- args$y %||% if (length(args) > 1L) args[[2L]] else NULL
    crossprod_like(
      x_arg = x_arg,
      y_arg = y_arg,
      scope = scope,
      ...,
      hoist = hoist,
      dest = dest,
      trans_single = "T",
      opA = "T",
      opB = "N",
      context = "crossprod"
    )
  },
  dest_supported = TRUE,
  dest_infer = infer_dest_crossprod
)


# Handle tcrossprod(), using SYRK for single-arg and GEMM for two-arg forms.
register_r2f_handler(
  "tcrossprod",
  function(args, scope, ..., hoist = NULL, dest = NULL) {
    x_arg <- args$x %||% args[[1L]]
    y_arg <- args$y %||% if (length(args) > 1L) args[[2L]] else NULL
    crossprod_like(
      x_arg = x_arg,
      y_arg = y_arg,
      scope = scope,
      ...,
      hoist = hoist,
      dest = dest,
      trans_single = "N",
      opA = "N",
      opB = "T",
      context = "tcrossprod"
    )
  },
  dest_supported = TRUE,
  dest_infer = infer_dest_tcrossprod
)

# Handle outer() for FUN = "*" as BLAS outer product.
register_r2f_handler(
  "outer",
  function(args, scope, ..., hoist = NULL, dest = NULL) {
    x_arg <- args$X %||% args[[1L]]
    y_arg <- args$Y %||% if (length(args) >= 2L) args[[2L]] else NULL
    if (is.null(x_arg) || is.null(y_arg)) {
      stop("outer() expects X and Y")
    }

    fun <- args$FUN %||% "*"
    if (!identical(fun, "*")) {
      stop("outer() only supports FUN = \"*\"")
    }
    x <- r2f(x_arg, scope, ..., hoist = hoist)
    y <- r2f(y_arg, scope, ..., hoist = hoist)
    outer_mul(
      x,
      y,
      scope = scope,
      hoist = hoist,
      dest = dest,
      context = "outer"
    )
  },
  dest_supported = TRUE,
  dest_infer = infer_dest_outer
)

# Handle %o% for outer products via BLAS GER.
register_r2f_handler(
  "%o%",
  function(args, scope, ..., hoist = NULL, dest = NULL) {
    stopifnot(length(args) == 2L)
    x <- r2f(args[[1L]], scope, ..., hoist = hoist)
    y <- r2f(args[[2L]], scope, ..., hoist = hoist)
    outer_mul(
      x,
      y,
      scope = scope,
      hoist = hoist,
      dest = dest,
      context = "%o%"
    )
  },
  dest_supported = TRUE,
  dest_infer = infer_dest_outer
)

register_r2f_handler(
  "solve",
  function(args, scope, ..., hoist = NULL, dest = NULL) {
    a_arg <- args$a %||% args[[1L]]
    if (is.null(a_arg) || is_missing(a_arg)) {
      stop("solve() expects `a`", call. = FALSE)
    }
    if (!is.null(args$tol) && !is_missing(args$tol)) {
      stop("solve() does not support tol yet", call. = FALSE)
    }
    if (!is.null(args$LINPACK) && !is_missing(args$LINPACK)) {
      stop("solve() does not support LINPACK yet", call. = FALSE)
    }

    b_arg <- args$b %||% if (length(args) >= 2L) args[[2L]] else NULL
    if (!is.null(b_arg) && is_missing(b_arg)) {
      b_arg <- NULL
    }

    A <- r2f(a_arg, scope, ..., hoist = hoist)
    if (is.null(b_arg)) {
      return(lapack_inverse(
        A,
        scope = scope,
        hoist = hoist,
        dest = dest,
        context = "solve"
      ))
    }

    B <- r2f(b_arg, scope, ..., hoist = hoist)
    lapack_solve(
      A = A,
      B = B,
      scope = scope,
      hoist = hoist,
      dest = dest,
      context = "solve"
    )
  },
  dest_supported = TRUE,
  dest_infer = infer_dest_solve
)

register_r2f_handler(
  "qr.solve",
  function(args, scope, ..., hoist = NULL, dest = NULL) {
    a_arg <- args$a %||% args[[1L]]
    if (is.null(a_arg) || is_missing(a_arg)) {
      stop("qr.solve() expects `a`", call. = FALSE)
    }

    b_arg <- args$b %||% if (length(args) >= 2L) args[[2L]] else NULL
    if (is.null(b_arg) || is_missing(b_arg)) {
      stop("qr.solve() expects `b`", call. = FALSE)
    }

    A <- r2f(a_arg, scope, ..., hoist = hoist)
    B <- r2f(b_arg, scope, ..., hoist = hoist)

    tol_arg <- args$tol %||% if (length(args) >= 3L) args[[3L]] else NULL
    tol <- if (is.null(tol_arg) || is_missing(tol_arg)) {
      r2f(1e-7, scope, ..., hoist = hoist)
    } else {
      tol <- maybe_cast_double(r2f(tol_arg, scope, ..., hoist = hoist))
      if (tol@value@rank != 0L) {
        stop("qr.solve() expects a scalar `tol`", call. = FALSE)
      }
      tol
    }
    lapack_solve(
      A = A,
      B = B,
      scope = scope,
      hoist = hoist,
      dest = dest,
      context = "qr.solve",
      tol = tol
    )
  },
  dest_supported = TRUE,
  dest_infer = infer_dest_solve
)

register_r2f_handler(
  "chol",
  function(args, scope, ..., hoist = NULL, dest = NULL) {
    x_arg <- args$x %||% args[[1L]]
    if (is.null(x_arg) || is_missing(x_arg)) {
      stop("chol() expects `x`", call. = FALSE)
    }
    pivot <- logical_arg_or_default(args, "pivot", FALSE, "chol()")
    if (isTRUE(pivot)) {
      stop("chol() does not support pivot = TRUE yet", call. = FALSE)
    }
    if (!is.null(args$LINPACK) && !is_missing(args$LINPACK)) {
      stop("chol() does not support LINPACK yet", call. = FALSE)
    }

    x <- r2f(x_arg, scope, ..., hoist = hoist)
    lapack_chol(
      A = x,
      scope = scope,
      hoist = hoist,
      dest = dest,
      context = "chol"
    )
  },
  dest_supported = TRUE,
  dest_infer = infer_dest_chol
)

register_r2f_handler(
  "chol2inv",
  function(args, scope, ..., hoist = NULL, dest = NULL) {
    x_arg <- args$x %||% args[[1L]]
    if (is.null(x_arg) || is_missing(x_arg)) {
      stop("chol2inv() expects `x`", call. = FALSE)
    }
    if (!is.null(args$size) && !is_missing(args$size)) {
      stop("chol2inv() does not support size yet", call. = FALSE)
    }

    x <- r2f(x_arg, scope, ..., hoist = hoist)
    lapack_chol2inv(
      R = x,
      scope = scope,
      hoist = hoist,
      dest = dest,
      context = "chol2inv"
    )
  },
  dest_supported = TRUE,
  dest_infer = infer_dest_chol2inv
)

register_r2f_handler(
  "diag",
  function(args, scope, ..., hoist = NULL, dest = NULL) {
    # R signature: diag(x = 1, nrow, ncol, names = TRUE)
    # Handle both named and positional arguments
    arg_names <- names(args)
    if (is.null(arg_names)) {
      arg_names <- rep("", length(args))
    }
    unnamed_idx <- which(!nzchar(arg_names) | is.na(arg_names))

    # Extract x (named or position 1)
    x_arg <- NULL
    if (!is.null(args$x) && !is_missing(args$x)) {
      x_arg <- args$x
    } else if (length(unnamed_idx) >= 1L) {
      candidate <- args[[unnamed_idx[[1L]]]]
      if (!is_missing(candidate)) {
        x_arg <- candidate
      }
    }

    # Extract nrow (named or position 2)
    nrow_arg <- args$nrow
    if (is.null(nrow_arg) && length(unnamed_idx) >= 2L) {
      nrow_arg <- args[[unnamed_idx[[2L]]]]
    }

    # Extract ncol (named or position 3)
    ncol_arg <- args$ncol
    if (is.null(ncol_arg) && length(unnamed_idx) >= 3L) {
      ncol_arg <- args[[unnamed_idx[[3L]]]]
    }

    if (!is.null(args$names) && !is_missing(args$names)) {
      logical_arg_or_default(args, "names", TRUE, "diag()")
    }

    has_nrow <- !is.null(nrow_arg) && !is_missing(nrow_arg)
    has_ncol <- !is.null(ncol_arg) && !is_missing(ncol_arg)

    if (is.null(x_arg) || is_missing(x_arg)) {
      if (!has_nrow && !has_ncol) {
        stop("argument \"nrow\" is missing, with no default", call. = FALSE)
      }
      if (!has_nrow && has_ncol) {
        stop("argument \"nrow\" is missing, with no default", call. = FALSE)
      }
      x_val <- Fortran("1.0_c_double", Variable("double"))
      nrow <- if (has_nrow) r2size(nrow_arg, scope) else r2size(ncol_arg, scope)
      ncol <- if (has_ncol) r2size(ncol_arg, scope) else nrow
      return(diag_matrix(
        x = x_val,
        nrow = nrow,
        ncol = ncol,
        scope = scope,
        hoist = hoist,
        dest = dest,
        context = "diag"
      ))
    }

    x <- r2f(x_arg, scope, ..., hoist = hoist)
    x_rank <- x@value@rank

    if (x_rank == 2L) {
      if (has_nrow || has_ncol) {
        stop(
          "'nrow' or 'ncol' cannot be specified when 'x' is a matrix",
          call. = FALSE
        )
      }
      return(diag_extract(
        x = x,
        scope = scope,
        hoist = hoist,
        dest = dest,
        context = "diag"
      ))
    }

    assert_rank_leq2(
      x,
      "diag() only supports scalar, vector, or matrix inputs"
    )

    if (!has_nrow && !has_ncol && x_rank == 0L) {
      nrow <- r2size(x_arg, scope)
      ncol <- nrow
      x_val <- Fortran("1.0_c_double", Variable("double"))
      return(diag_matrix(
        x = x_val,
        nrow = nrow,
        ncol = ncol,
        scope = scope,
        hoist = hoist,
        dest = dest,
        context = "diag"
      ))
    }

    nrow <- if (has_nrow) r2size(nrow_arg, scope) else NULL
    ncol <- if (has_ncol) r2size(ncol_arg, scope) else NULL

    if (is.null(nrow) && is.null(ncol)) {
      nrow <- dim_or_one(x, 1L)
      ncol <- nrow
    } else if (is.null(nrow)) {
      nrow <- ncol
    } else if (is.null(ncol)) {
      ncol <- nrow
    }

    diag_matrix(
      x = x,
      nrow = nrow,
      ncol = ncol,
      scope = scope,
      hoist = hoist,
      dest = dest,
      context = "diag"
    )
  },
  dest_supported = TRUE,
  dest_infer = infer_dest_diag
)

# Handle forwardsolve() via triangular BLAS routines.
register_r2f_handler(
  "forwardsolve",
  function(args, scope, ..., hoist = NULL, dest = NULL) {
    stopifnot(length(args) >= 2L)
    if (!is.null(args$k)) {
      stop("forwardsolve() does not support k yet")
    }
    upper_tri <- logical_arg_or_default(
      args,
      "upper.tri",
      FALSE,
      "forwardsolve()"
    )
    transpose <- logical_arg_or_default(
      args,
      "transpose",
      FALSE,
      "forwardsolve()"
    )
    diag_unit <- logical_arg_or_default(args, "diag", FALSE, "forwardsolve()")

    l_arg <- args$l %||% args[[1L]]
    x_arg <- args$x %||% args[[2L]]
    A <- r2f(l_arg, scope, ..., hoist = hoist)
    B <- r2f(x_arg, scope, ..., hoist = hoist)

    triangular_solve(
      A = A,
      B = B,
      uplo = if (upper_tri) "U" else "L",
      trans = if (transpose) "T" else "N",
      diag = if (diag_unit) "U" else "N",
      scope = scope,
      hoist = hoist,
      dest = dest,
      context = "forwardsolve"
    )
  },
  dest_supported = TRUE,
  dest_infer = infer_dest_triangular
)

# Handle backsolve() via triangular BLAS routines.
register_r2f_handler(
  "backsolve",
  function(args, scope, ..., hoist = NULL, dest = NULL) {
    stopifnot(length(args) >= 2L)
    if (!is.null(args$k)) {
      stop("backsolve() does not support k yet")
    }
    upper_tri <- logical_arg_or_default(args, "upper.tri", TRUE, "backsolve()")
    transpose <- logical_arg_or_default(args, "transpose", FALSE, "backsolve()")
    diag_unit <- logical_arg_or_default(args, "diag", FALSE, "backsolve()")

    r_arg <- args$r %||% args[[1L]]
    x_arg <- args$x %||% args[[2L]]
    A <- r2f(r_arg, scope, ..., hoist = hoist)
    B <- r2f(x_arg, scope, ..., hoist = hoist)

    triangular_solve(
      A = A,
      B = B,
      uplo = if (upper_tri) "U" else "L",
      trans = if (transpose) "T" else "N",
      diag = if (diag_unit) "U" else "N",
      scope = scope,
      hoist = hoist,
      dest = dest,
      context = "backsolve"
    )
  },
  dest_supported = TRUE,
  dest_infer = infer_dest_triangular
)

# Shared crossprod/tcrossprod logic for one- and two-argument forms.
crossprod_like <- function(
  x_arg,
  y_arg,
  scope,
  ...,
  hoist,
  dest,
  trans_single,
  opA,
  opB,
  context
) {
  x <- r2f(x_arg, scope, ..., hoist = hoist)
  x <- maybe_cast_double(x)

  if (is.null(y_arg)) {
    return(syrk(
      trans = trans_single,
      X = x,
      scope = scope,
      hoist = hoist,
      dest = dest,
      context = context
    ))
  }

  y <- maybe_cast_double(r2f(y_arg, scope, ..., hoist = hoist))

  x_dims <- matrix_dims(x)
  y_dims <- matrix_dims(y)
  x_eff <- effective_dims(x_dims, opA)
  y_eff <- effective_dims(y_dims, opB)

  conform <- check_conformable(x_eff$cols, y_eff$rows)
  if (!conform$ok) {
    stop("non-conformable arguments in ", context, call. = FALSE)
  }
  if (conform$unknown) {
    stop(
      "cannot verify conformability in ",
      context,
      " at compile time",
      call. = FALSE
    )
  }

  m <- x_eff$rows
  n <- y_eff$cols
  k <- x_eff$cols

  lda <- x_dims$rows
  ldb <- y_dims$rows
  ldc_expr <- m

  gemm(
    opA = opA,
    opB = opB,
    left = x,
    right = y,
    m = m,
    n = n,
    k = k,
    lda = lda,
    ldb = ldb,
    ldc_expr = ldc_expr,
    scope = scope,
    hoist = hoist,
    dest = dest,
    context = context
  )
}

svd_call_args <- function(args, context = "svd") {
  x_arg <- args$x %||% args[[1L]]
  if (is.null(x_arg) || is_missing(x_arg)) {
    stop(context, "() expects `x`", call. = FALSE)
  }
  if (!is.null(args$LINPACK) && !is_missing(args$LINPACK)) {
    stop(context, "() does not support LINPACK", call. = FALSE)
  }
  if (!is.null(args$nu) && !is_missing(args$nu)) {
    stop(context, "() does not support `nu` yet", call. = FALSE)
  }
  if (!is.null(args$nv) && !is_missing(args$nv)) {
    stop(context, "() does not support `nv` yet", call. = FALSE)
  }
  x_arg
}

svd_output_vars_scope <- function(scope, dims) {
  stopifnot(
    inherits(scope, "quickr_scope"),
    is.list(dims),
    all(c("m", "n", "mn") %in% names(dims))
  )
  list(
    d = scope_unique_var(scope, mode = "double", dims = list(dims$mn)),
    u = scope_unique_var(scope, mode = "double", dims = list(dims$m, dims$mn)),
    v = scope_unique_var(scope, mode = "double", dims = list(dims$n, dims$mn))
  )
}

svd_output_vars_tmp <- function(hoist, dims) {
  assert_hoist_env(hoist)
  list(
    d = hoist$declare_tmp(mode = "double", dims = list(dims$mn)),
    u = hoist$declare_tmp(mode = "double", dims = list(dims$m, dims$mn)),
    v = hoist$declare_tmp(mode = "double", dims = list(dims$n, dims$mn))
  )
}

compile_svd_assignment <- function(name, svd_call, scope, ..., hoist) {
  stopifnot(is_string(name), is_call(svd_call, "svd"))
  existing <- get0(name, scope, inherits = FALSE)
  if (inherits(existing, Variable)) {
    stop(
      "svd() result cannot overwrite declared variable: ",
      name,
      call. = FALSE
    )
  }

  args <- as.list(svd_call)[-1L]
  x_arg <- svd_call_args(args, context = "svd")
  x <- r2f(x_arg, scope, ..., hoist = hoist)
  dims <- svd_dims(x, context = "svd")
  outputs <- svd_output_vars_scope(scope, dims)

  lapack_svd(
    A = x,
    d = outputs$d,
    u = outputs$u,
    v = outputs$v,
    scope = scope,
    hoist = hoist,
    context = "svd"
  )

  scope[[name]] <- SvdResult(d = outputs$d, u = outputs$u, v = outputs$v)
  Fortran("")
}

svd_component_from_call <- function(svd_call, field, scope, ..., hoist) {
  stopifnot(is_call(svd_call, "svd"), is_string(field))
  if (!field %in% c("d", "u", "v")) {
    stop("svd() only supports $d, $u, and $v", call. = FALSE)
  }
  args <- as.list(svd_call)[-1L]
  x_arg <- svd_call_args(args, context = "svd")
  x <- r2f(x_arg, scope, ..., hoist = hoist)
  dims <- svd_dims(x, context = "svd")
  outputs <- svd_output_vars_tmp(hoist, dims)

  lapack_svd(
    A = x,
    d = outputs$d,
    u = outputs$u,
    v = outputs$v,
    scope = scope,
    hoist = hoist,
    context = "svd"
  )

  out_var <- outputs[[field]]
  Fortran(out_var@name, out_var)
}

register_r2f_handler(
  "svd",
  function(args, scope, ..., hoist = NULL) {
    stop(
      "svd() must be assigned to a symbol or accessed via $d, $u, $v",
      call. = FALSE
    )
  }
)

defuse_numeric_literals <- function(e) {
  if (is.call(e)) {
    e <- as.call(lapply(e, defuse_numeric_literals))
    if (
      is.symbol(e1 <- e[[1L]]) &&
        as.character(e1) %in% c("+", "-", "*", "/", "%%", "%/%", "^") &&
        all(map_lgl(e[-1L], is.atomic))
    ) {
      e <- eval(e, baseenv())
    }
  }
  e
}

# Helper function to validate that all list elements are symbols
validate_list_symbols <- function(list_call) {
  args <- as.list(list_call)[-1L]
  if (!all(map_lgl(args, is.symbol))) {
    stop("all elements of the list must be symbols")
  }
  invisible(TRUE)
}


ensure_last_expr_sym <- function(bdy) {
  if (!is_call(bdy, quote(`{`))) {
    stop("bad body, needs {")
  }

  last_expr <- last(bdy)

  # Case 1: Last expression is a symbol
  if (is.symbol(last_expr)) {
    # Check for pattern: out <- list(...); out
    n <- length(bdy)
    second_last_expr <- bdy[[n - 1L]]

    list_pattern <-
      is_call(second_last_expr, quote(`<-`)) &&
      identical(second_last_expr[[2L]], last_expr) &&
      is_call(second_last_expr[[3L]], quote(list))

    if (list_pattern) {
      # Modify body such that last espression is list(...)
      list_call <- second_last_expr[[3L]]
      validate_list_symbols(list_call)
      bdy[[n - 1]] <- NULL # delete list assignment
      bdy[[n - 1]] <- list_call # replace last line with list(...)
    }

    return(bdy)
  }

  # Case 2: Last expression is a direct list call
  if (is_call(last_expr, quote(list))) {
    validate_list_symbols(last_expr)
    return(bdy)
  }

  # Case 3: Other expressions - create assignment to out_
  bdy[[length(bdy)]] <- call("<-", quote(out_), last_expr)
  bdy[[length(bdy) + 1L]] <- quote(out_)
  bdy
}

whole_doubles_to_ints <- function(x) {
  walker <- function(x) {
    switch(
      typeof(x),
      double = if (trunc(x) == x) as.integer(x) else x,
      language = as.call(lapply(x, walker)),
      list = lapply(x, walker),
      x
    )
  }
  walker(x)
}

# Matrix destination inference helpers

# Infer a variable from a symbol in the current scope.
infer_symbol_var <- function(arg, scope) {
  arg <- unwrap_parens(arg)
  if (!is.symbol(arg)) {
    return(NULL)
  }
  var <- get0(as.character(arg), scope, inherits = FALSE)
  if (inherits(var, Variable)) var else NULL
}

# Infer a matrix argument, handling t() and scalar/vector promotion.
infer_matrix_arg <- function(arg, scope) {
  arg <- unwrap_parens(arg)
  if (is_call(arg, quote(t)) && length(arg) == 2L) {
    inner <- infer_symbol_var(arg[[2L]], scope)
    if (is.null(inner)) {
      return(NULL)
    }
    if (inner@rank == 2L) {
      return(list(var = inner, trans = "T"))
    }
    if (inner@rank == 1L) {
      len <- inner@dims[[1L]]
      if (is.null(len)) {
        return(NULL)
      }
      val <- Variable("double", list(1L, len))
      return(list(var = val, trans = "N"))
    }
    if (inner@rank == 0L) {
      return(list(var = inner, trans = "N"))
    }
    return(NULL)
  }
  var <- infer_symbol_var(arg, scope)
  if (is.null(var)) {
    return(NULL)
  }
  list(var = var, trans = "N")
}

# Infer destination dimensions for %*% based on inputs.
infer_dest_matmul <- function(args, scope) {
  if (length(args) != 2L) {
    return(NULL)
  }
  left_info <- infer_matrix_arg(args[[1L]], scope)
  right_info <- infer_matrix_arg(args[[2L]], scope)
  if (is.null(left_info) || is.null(right_info)) {
    return(NULL)
  }

  left <- left_info$var
  right <- right_info$var
  left_trans <- left_info$trans
  right_trans <- right_info$trans

  left_rank <- left@rank
  right_rank <- right@rank
  if (left_rank > 2L || right_rank > 2L) {
    return(NULL)
  }

  left_dims <- matrix_dims_var(
    left,
    orientation = if (left_rank == 1L) "rowvec" else "matrix"
  )
  right_dims <- matrix_dims_var(
    right,
    orientation = if (right_rank == 1L) "colvec" else "matrix"
  )

  left_eff <- if (left_rank == 2L) {
    effective_dims(left_dims, left_trans)
  } else {
    left_dims
  }
  right_eff <- if (right_rank == 2L) {
    effective_dims(right_dims, right_trans)
  } else {
    right_dims
  }

  if (left_rank == 2L && right_rank == 1L) {
    out_len <- if (left_trans == "N") left_dims$rows else left_dims$cols
    return(Variable("double", list(out_len, 1L)))
  }
  if (left_rank == 1L && right_rank == 2L) {
    transA <- if (right_trans == "N") "T" else "N"
    out_len <- if (transA == "N") right_dims$rows else right_dims$cols
    return(Variable("double", list(1L, out_len)))
  }

  Variable("double", list(left_eff$rows, right_eff$cols))
}

# Shared inference for crossprod/tcrossprod destination sizes.
infer_dest_crossprod_like <- function(args, scope, trans) {
  x_arg <- args$x %||% args[[1L]]
  x <- infer_symbol_var(x_arg, scope)
  if (is.null(x)) {
    return(NULL)
  }
  y_arg <- args$y %||% if (length(args) > 1L) args[[2L]] else NULL
  y <- if (!is.null(y_arg)) infer_symbol_var(y_arg, scope) else NULL
  x_dims <- matrix_dims_var(x)
  if (is.null(y)) {
    n <- if (identical(trans, "T")) x_dims$cols else x_dims$rows
    return(Variable("double", list(n, n)))
  }
  y_dims <- matrix_dims_var(y)
  if (identical(trans, "T")) {
    Variable("double", list(x_dims$cols, y_dims$cols))
  } else {
    Variable("double", list(x_dims$rows, y_dims$rows))
  }
}

# Infer destination dimensions for crossprod().
infer_dest_crossprod <- function(args, scope) {
  infer_dest_crossprod_like(args, scope, trans = "T")
}

# Infer destination dimensions for tcrossprod().
infer_dest_tcrossprod <- function(args, scope) {
  infer_dest_crossprod_like(args, scope, trans = "N")
}

# Infer destination dimensions for outer() and %o%().
infer_dest_outer <- function(args, scope) {
  x_arg <- args$X %||% args[[1L]]
  y_arg <- args$Y %||% if (length(args) >= 2L) args[[2L]] else NULL
  x <- infer_symbol_var(x_arg, scope)
  y <- infer_symbol_var(y_arg, scope)
  if (is.null(x) || is.null(y)) {
    return(NULL)
  }
  if (x@rank > 1L || y@rank > 1L) {
    return(NULL)
  }
  m <- var_dim_or_one(x, 1L)
  n <- var_dim_or_one(y, 1L)
  Variable("double", list(m, n))
}

# Infer destination dimensions for forwardsolve() and backsolve().
# forwardsolve(l, x, ...), backsolve(r, x, ...)
infer_dest_triangular <- function(args, scope) {
  if (length(args) < 2L) {
    return(NULL)
  }
  # First arg is l (forwardsolve) or r (backsolve)
  a_arg <- args$l %||% args$r %||% args[[1L]]
  # Second arg is x
  b_arg <- args$x %||% args[[2L]]
  A <- infer_symbol_var(a_arg, scope)
  B <- infer_symbol_var(b_arg, scope)
  if (is.null(A) || is.null(B)) {
    return(NULL)
  }
  if (A@rank != 2L || B@rank == 0L || B@rank > 2L) {
    return(NULL)
  }
  if (is.null(B@dims)) {
    return(NULL)
  }
  Variable("double", B@dims)
}

# Infer destination dimensions for solve().
infer_dest_solve <- function(args, scope) {
  a_arg <- args$a %||% args[[1L]]
  if (is.null(a_arg)) {
    return(NULL)
  }
  A <- infer_symbol_var(a_arg, scope)
  if (is.null(A) || A@rank != 2L) {
    return(NULL)
  }
  a_dims <- matrix_dims_var(A)
  n_rows <- a_dims$rows
  n_cols <- a_dims$cols

  b_arg <- args$b %||% if (length(args) >= 2L) args[[2L]] else NULL
  if (is.null(b_arg)) {
    return(Variable("double", list(n_rows, n_cols)))
  }
  B <- infer_symbol_var(b_arg, scope)
  if (is.null(B)) {
    return(NULL)
  }
  if (B@rank == 1L) {
    return(Variable("double", list(n_cols)))
  }
  if (B@rank == 2L) {
    return(Variable("double", list(n_cols, B@dims[[2L]])))
  }
  NULL
}

# Infer destination dimensions for chol().
infer_dest_chol <- function(args, scope) {
  x_arg <- args$x %||% args[[1L]]
  if (is.null(x_arg)) {
    return(NULL)
  }
  X <- infer_symbol_var(x_arg, scope)
  if (is.null(X) || X@rank != 2L) {
    return(NULL)
  }
  x_dims <- matrix_dims_var(X)
  Variable("double", list(x_dims$rows, x_dims$cols))
}

# Infer destination dimensions for chol2inv().
infer_dest_chol2inv <- function(args, scope) {
  x_arg <- args$x %||% args[[1L]]
  if (is.null(x_arg)) {
    return(NULL)
  }
  X <- infer_symbol_var(x_arg, scope)
  if (is.null(X) || X@rank != 2L) {
    return(NULL)
  }
  x_dims <- matrix_dims_var(X)
  Variable("double", list(x_dims$rows, x_dims$cols))
}

# Helper to infer a size from a literal or symbol.
infer_size <- function(arg, scope) {
  if (is.null(arg) || is_missing(arg)) {
    return(NULL)
  }
  if (is.numeric(arg) && length(arg) == 1L && is_wholenumber(arg)) {
    return(as.integer(arg))
  }
  if (is.symbol(arg)) {
    var <- get0(as.character(arg), scope, inherits = FALSE)
    if (!inherits(var, Variable)) {
      return(NULL)
    }
    # Scalar (rank 0) or length-1 vector (rank 1 with dim 1)
    if (var@rank == 0L) {
      return(arg)
    }
    if (var@rank == 1L && length(var@dims) == 1L) {
      d <- var@dims[[1L]]
      if (is_wholenumber(d) && identical(as.integer(d), 1L)) {
        return(arg)
      }
    }
  }
  NULL
}

# Infer destination dimensions for diag().
infer_dest_diag <- function(args, scope) {
  # R signature: diag(x = 1, nrow, ncol, names = TRUE)
  # Handle both named and positional arguments
  arg_names <- names(args)
  if (is.null(arg_names)) {
    arg_names <- rep("", length(args))
  }
  unnamed_idx <- which(!nzchar(arg_names) | is.na(arg_names))

  # Extract x (named or position 1)
  x_arg <- NULL
  if (!is.null(args$x) && !is_missing(args$x)) {
    x_arg <- args$x
  } else if (length(unnamed_idx) >= 1L) {
    candidate <- args[[unnamed_idx[[1L]]]]
    if (!is_missing(candidate)) {
      x_arg <- candidate
    }
  }

  # Extract nrow (named or position 2)
  nrow_arg <- args$nrow
  if (is.null(nrow_arg) && length(unnamed_idx) >= 2L) {
    nrow_arg <- args[[unnamed_idx[[2L]]]]
  }

  # Extract ncol (named or position 3)
  ncol_arg <- args$ncol
  if (is.null(ncol_arg) && length(unnamed_idx) >= 3L) {
    ncol_arg <- args[[unnamed_idx[[3L]]]]
  }

  has_nrow <- !is.null(nrow_arg) && !is_missing(nrow_arg)
  has_ncol <- !is.null(ncol_arg) && !is_missing(ncol_arg)

  # Case: no x, just nrow (identity matrix)
  if (is.null(x_arg) || is_missing(x_arg)) {
    if (!has_nrow) {
      return(NULL)
    }
    nrow <- infer_size(nrow_arg, scope)
    if (is.null(nrow)) {
      return(NULL)
    }
    ncol <- if (has_ncol) infer_size(ncol_arg, scope) else nrow
    if (is.null(ncol)) {
      return(NULL)
    }
    return(Variable("double", list(nrow, ncol)))
  }

  x <- infer_symbol_var(x_arg, scope)

  # Case: x is a matrix -> extract diagonal (returns vector)
  if (!is.null(x) && x@rank == 2L) {
    x_dims <- matrix_dims_var(x)
    diag_len <- diag_length_expr(x_dims$rows, x_dims$cols, "diag")
    return(Variable("double", list(diag_len)))
  }

  # Case: x is a scalar literal (identity matrix of that size)
  if (is.null(x) && is.numeric(x_arg) && length(x_arg) == 1L) {
    if (!has_nrow && !has_ncol && is_wholenumber(x_arg)) {
      n <- as.integer(x_arg)
      return(Variable("double", list(n, n)))
    }
  }

  # Case: x is a scalar symbol without nrow/ncol (identity matrix)
  if (!is.null(x) && x@rank == 0L && !has_nrow && !has_ncol) {
    return(NULL)
  }

  # Case: x is a vector or scalar, construct diagonal matrix
  if (!is.null(x) && x@rank <= 1L) {
    if (has_nrow || has_ncol) {
      nrow <- if (has_nrow) infer_size(nrow_arg, scope) else NULL
      ncol <- if (has_ncol) infer_size(ncol_arg, scope) else NULL
      if (is.null(nrow) && is.null(ncol)) {
        return(NULL)
      }
      if (is.null(nrow)) {
        nrow <- ncol
      }
      if (is.null(ncol)) {
        ncol <- nrow
      }
      return(Variable("double", list(nrow, ncol)))
    }
    # No nrow/ncol: square matrix from vector length
    if (x@rank == 1L) {
      len <- var_dim_or_one(x, 1L)
      return(Variable("double", list(len, len)))
    }
  }

  NULL
}

# r2f-aab-core.R
# Core translation engine for R-to-Fortran conversion.
#
# Take parsed R code (anything returnable by base::str2lang()) and returns
# a Fortran object, which is a string of Fortran code and some attributes
# describing the value.

# --- Hoisting Infrastructure ---

new_hoist <- function(scope) {
  hoisted <- character()
  block_scope <- NULL

  emit <- function(...) {
    hoisted <<- c(
      hoisted,
      as.character(unlist(c(character(), ...), use.names = FALSE))
    )
  }

  has_block <- function() !is.null(block_scope)

  ensure_block_scope <- function() {
    if (is.null(block_scope)) {
      block_scope <<- scope_new_child(scope, "block")
    }
    block_scope
  }

  declare_tmp <- function(mode, dims, logical_as_int = FALSE) {
    stopifnot(
      is_string(mode),
      is.null(dims) || is.list(dims),
      is_bool(logical_as_int)
    )
    ensure_block_scope()@get_unique_var(
      mode = mode,
      dims = dims,
      logical_as_int = logical_as_int
    )
  }

  render <- function(code) {
    code <- str_split_lines(code)
    if (!length(hoisted) && !has_block()) {
      return(str_flatten_lines(code))
    }

    stmts <- str_split_lines(hoisted, code)

    if (has_block()) {
      block_vars <- scope_vars(block_scope)
      decls <- emit_decls(block_vars, block_scope)
      allocs <- block_tmp_allocation_lines(block_vars, block_scope)
      if (length(allocs)) {
        stmts <- c(allocs, stmts)
      }
      return(str_flatten_lines(emit_block(decls, stmts)))
    }

    str_flatten_lines(stmts)
  }

  list2env(
    list(
      emit = emit,
      declare_tmp = declare_tmp,
      render = render
    ),
    parent = emptyenv()
  )
}


# --- Scope Helpers ---

logical_as_int_symbol <- function(var) {
  inherits(var, Variable) &&
    identical(var@mode, "logical") &&
    logical_as_int(var)
}

scope_is_closure <- function(scope) {
  inherits(scope, "quickr_scope") && identical(scope_kind(scope), "closure")
}

scope_fortran_names <- function(scope) {
  stopifnot(inherits(scope, "quickr_scope"))
  out <- character()
  while (inherits(scope, "quickr_scope")) {
    vars <- scope_vars(scope)
    out <- c(out, map_chr(vars, \(v) v@name %||% ""))
    scope <- parent.env(scope)
  }
  unique(out[nzchar(out)])
}

make_shadow_fortran_name <- function(scope, base, suffix = "__local_") {
  stopifnot(inherits(scope, "quickr_scope"), is_string(base), is_string(suffix))
  used <- scope_fortran_names(scope)
  candidate <- paste0(base, suffix)
  if (!candidate %in% used) {
    return(candidate)
  }
  i <- 1L
  repeat {
    candidate <- paste0(base, suffix, i, "_")
    if (!candidate %in% used) {
      return(candidate)
    }
    i <- i + 1L
  }
}


# --- Main Translation Engine ---

lang2fortran <- r2f <- function(
  e,
  scope = NULL,
  ...,
  calls = character(),
  hoist = NULL
) {
  ## 'hoist' is a per-statement context that handlers can use to pre-emit some
  ## Fortran code. E.g., to setup a temporary variable if the generated Fortran
  ## code doesn't neatly translate into a single expression.
  render_hoist <- is.null(hoist)
  if (render_hoist) {
    hoist <- new_hoist(scope)
  }

  fortran <- switch(
    typeof(e),
    language = {
      # a call
      callable <- e[[1L]]
      callable_unwrapped <- callable
      while (
        is_call(callable_unwrapped, quote(`(`)) &&
          length(callable_unwrapped) == 2L
      ) {
        callable_unwrapped <- callable_unwrapped[[2L]]
      }

      if (!is.null(scope)) {
        maybe_lower_local_closure_call(
          e,
          scope,
          ...,
          hoist = hoist,
          needs_value = !render_hoist
        ) %||%
          {
            handler <- get_r2f_handler(callable_unwrapped)

            match.fun <- if (inherits(handler, R2FHandler)) {
              handler@match_fun
            } else {
              attr(handler, "match.fun", TRUE)
            }
            if (is.null(match.fun)) {
              match.fun <- get0(
                callable_unwrapped,
                parent.env(globalenv()),
                mode = "function"
              )
              # this is a best effort to, eg. resolve `seq.default` from `seq`.
              # This should likely be moved into attaching the `match.fun` attr
              # to handlers, for more involved resolution (e.g., with getS3Method())
              if ("UseMethod" %in% all.names(body(match.fun))) {
                match.fun <- get0(
                  paste0(callable_unwrapped, ".default"),
                  parent.env(globalenv()),
                  mode = "function",
                  ifnotfound = match.fun
                )
              }
            }
            if (typeof(match.fun) == "closure") {
              e <- match.call(match.fun, e)
            }

            if (isTRUE(getOption("quickr.r2f.debug"))) {
              try(handler(
                as.list(e)[-1L],
                scope,
                ...,
                calls = c(calls, as.character(callable_unwrapped)),
                hoist = hoist
              )) -> res
              if (inherits(res, "try-error")) {
                debugonce(handler)
                handler(
                  as.list(e)[-1L],
                  scope,
                  ...,
                  calls = c(calls, as.character(callable_unwrapped)),
                  hoist = hoist
                )
              }

              res
            } else {
              handler(
                as.list(e)[-1L],
                scope,
                ...,
                calls = c(calls, as.character(callable_unwrapped)),
                hoist = hoist
              )
            }
          }
      }
    },

    integer = ,
    double = ,
    complex = ,
    logical = atomic2Fortran(e),

    `NULL` = Fortran("", NULL),

    symbol = {
      r_name <- as.character(e)
      val <- if (is.null(scope)) NULL else get0(r_name, scope)
      if (inherits(val, SvdResult)) {
        stop(
          "svd() results must be accessed with $d, $u, or $v",
          call. = FALSE
        )
      }
      # `scope` inherits from the R closure environment. Ignore non-compiler
      # bindings (like captured R objects) so they can't mask undeclared args.
      if (!inherits(val, Variable) && !inherits(val, SvdResult)) {
        val <- NULL
      }
      if (is.null(val) && inherits(scope, "quickr_scope")) {
        closure <- scope_closure(scope)
        arg_names <- if (is.null(closure)) NULL else names(formals(closure))
        if (!is.null(arg_names) && r_name %in% arg_names) {
          stop(
            "arg not declared: ",
            r_name,
            ". Add declare(type(",
            r_name,
            " = ...))",
            call. = FALSE
          )
        }
      }
      s <- if (inherits(val, Variable) && !is.null(val@name)) {
        val@name
      } else {
        r_name
      }
      if (logical_as_int_symbol(val)) {
        # logicals passed via the bind(c) interface are stored as integer(0/1)
        # and must be "booleanized" for Fortran logical operations.
        s <- paste0("(", s, "/=0)")
        out <- Fortran(s, value = if (inherits(val, Variable)) val else NULL)
        out@logical_booleanized <- TRUE
        out
      } else {
        Fortran(s, value = if (inherits(val, Variable)) val else NULL)
      }
    },

    ## handling 'object' and 'closure' here are both bad ideas,
    ## TODO: delete both
    # "object" = {
    #   if (inherits(e, Variable))
    #     e <- Fortran(character(), e)
    #   stopifnot(inherits(e, Fortran))
    #   e
    # },

    closure = {
      if (is.null(name <- attr(e, "name", TRUE))) {
        name <- if (is.symbol(name <- substitute(e))) {
          as.character(name)
        } else {
          "anonymous_function"
        }
      }

      stopifnot(is.null(scope))
      new_fortran_subroutine(name, e)
    },

    ## all the other typeof() possible values
    # "character",
    # "raw" ,
    # "list",
    # "NULL",
    # "function",
    # "special",
    # "builtin",
    # "environment",
    # "S4",
    # "pairlist",
    # "promise",
    # "char",
    # "...",
    # "any",
    # "expression",
    # "externalptr",
    # "bytecode",
    # "weakref"
    # default
    stop("Unsupported object type encountered: ", typeof(e))
  )

  attr(fortran, "r") <- e
  if (render_hoist) {
    combined <- hoist$render(fortran)
    attributes(combined) <- attributes(fortran)
    attr(combined, "r") <- e
    combined
  } else {
    fortran
  }
}


# --- Atomic Conversion ---

atomic2Fortran <- function(x) {
  stopifnot(is_scalar_atomic(x))
  s <- switch(
    typeof(x),
    double = ,
    integer = num2fortran(x),
    logical = if (x) ".true." else ".false.",
    complex = sprintf("(%s, %s)", num2fortran(Re(x)), num2fortran(Im(x)))
  )
  Fortran(s, Variable(typeof(x)))
}

num2fortran <- function(x) {
  stopifnot(typeof(x) %in% c("integer", "double"))
  digits <- 7L
  nsmall <- switch(typeof(x), integer = 0L, double = 1L)
  repeat {
    s <- format.default(x, digits = digits, nsmall = nsmall, scientific = 1L)
    if (x == eval(str2lang(s))) {
      # eval() needed for negative and complex numbers
      break
    }
    add(digits) <- 1L
    if (digits > 22L) {
      stop("number formatting error: ", x, " formatted as : ", s)
    }
  }
  paste0(s, switch(typeof(x), double = "_c_double", integer = "_c_int"))
}


# --- Handler Lookup ---

get_r2f_handler <- function(name) {
  stopifnot("All functions called must be named as symbols" = is.symbol(name))
  get0(name, r2f_handlers) %||%
    stop("Unsupported function: ", name, call. = FALSE)
}


# --- Destination Helpers ---

dest_supported_for_call <- function(call) {
  if (!is.call(call)) {
    return(FALSE)
  }
  unwrapped <- call
  while (is_call(unwrapped, "(") && length(unwrapped) == 2L) {
    unwrapped <- unwrapped[[2L]]
  }
  if (!is.call(unwrapped) || !is.symbol(unwrapped[[1L]])) {
    return(FALSE)
  }
  handler <- get0(as.character(unwrapped[[1L]]), r2f_handlers, inherits = FALSE)
  if (inherits(handler, R2FHandler)) {
    isTRUE(handler@dest_supported)
  } else {
    isTRUE(attr(handler, "dest_supported", exact = TRUE))
  }
}

dest_infer_for_call <- function(call, scope) {
  if (!is.call(call)) {
    return(NULL)
  }
  unwrapped <- call
  while (is_call(unwrapped, "(") && length(unwrapped) == 2L) {
    unwrapped <- unwrapped[[2L]]
  }
  if (!is.call(unwrapped) || !is.symbol(unwrapped[[1L]])) {
    return(NULL)
  }
  handler <- get0(as.character(unwrapped[[1L]]), r2f_handlers, inherits = FALSE)
  infer <- if (inherits(handler, R2FHandler)) {
    handler@dest_infer
  } else {
    attr(handler, "dest_infer", exact = TRUE)
  }
  infer_name <- if (inherits(handler, R2FHandler)) {
    handler@dest_infer_name
  } else {
    attr(handler, "dest_infer_name", exact = TRUE)
  }

  infer_fun <- NULL
  if (is_string(infer_name)) {
    # Resolve dynamically from the handler's environment (typically the package
    # namespace) so instrumented/rebound functions are respected.
    infer_fun <- get0(
      infer_name,
      envir = environment(handler),
      mode = "function"
    )
  }
  if (!is.function(infer_fun)) {
    infer_fun <- infer
  }
  if (!is.function(infer_fun)) {
    return(NULL)
  }
  infer_fun(as.list(unwrapped)[-1L], scope)
}


# --- Default Handlers ---

r2f_default_handler <- function(args, scope = NULL, ..., calls) {
  # stopifnot(is.call(e), is.symbol(e[[1L]]))

  x <- lapply(args, r2f, scope = scope, calls = calls, ...)
  s <- sprintf("%s(%s)", last(calls), str_flatten_commas(x[-1]))
  Fortran(s)
}

.r2f_handler_not_implemented_yet <- function(e, scope, ...) {
  stop(
    gettextf("'%s' is not implemented yet", as.character(e[[1L]])),
    call. = FALSE
  )
}


# --- Utility ---

check_call <- function(e, nargs) {
  if (length(e) != (nargs + 1L)) {
    stop("Too many args to: ", as.character(e[[1L]]))
  }
}

#' @importFrom glue glue glue_data trim as_glue glue_collapse single_quote
#' @importFrom dotty .
#' @importFrom stats setNames
#' @importFrom utils gethash hashtab remhash sethash str
NULL

`%||%` <- function(x, y) if (is.null(x)) y else x

fortranize_name <- function(name, prefix = "v_") {
  stopifnot(is_string(name), is_string(prefix), nzchar(prefix))
  out <- gsub("[^A-Za-z0-9_]", "_", name)
  if (!nzchar(out) || !grepl("^[A-Za-z]", out)) {
    out <- paste0(prefix, out)
  }
  out
}

fortranize_expr_symbols <- function(expr) {
  if (!is.symbol(expr) && !is.call(expr)) {
    return(expr)
  }
  syms <- all.vars(expr)
  if (!length(syms)) {
    return(expr)
  }
  replacements <- setNames(
    lapply(syms, \(sym) as.symbol(fortranize_name(sym))),
    syms
  )
  substitute_(expr, list2env(replacements, parent = emptyenv()))
}

scope_fortran_symbol <- function(sym, scope) {
  stopifnot(is.symbol(sym))
  if (is.null(scope)) {
    return(sym)
  }
  var <- get0(as.character(sym), scope)
  if (inherits(var, Variable) && !is.null(var@name)) {
    return(as.symbol(var@name))
  }
  sym
}

quickr_r_cmd <- function(
  os_type = .Platform$OS.type,
  r_home = R.home,
  file_exists = file.exists
) {
  r_cmd <- r_home("bin/R")
  if (identical(os_type, "windows") && !file_exists(r_cmd)) {
    r_cmd <- paste0(r_cmd, ".exe")
  }
  r_cmd
}

quickr_r_cmd_config_value <- function(
  name,
  r_cmd = quickr_r_cmd(),
  system2 = base::system2
) {
  out <- tryCatch(
    suppressWarnings(system2(
      r_cmd,
      c("CMD", "config", name),
      stdout = TRUE,
      stderr = FALSE
    )),
    error = function(e) character()
  )
  status <- attr(out, "status")
  if (!is.null(status)) {
    return("")
  }
  value <- trimws(paste(out, collapse = " "))
  if (!nzchar(value) || grepl("^ERROR:", value)) {
    return("")
  }
  value
}


# @export
# This will be exported by S7 next release.
`:=` <- function(left, right) {
  name <- substitute(left)
  if (!is.symbol(name)) {
    stop("left hand side must be a symbol")
  }

  right <- substitute(right)
  if (!is.call(right)) {
    stop("right hand side must be a call")
  }

  if (
    is.symbol(cl <- right[[1L]]) &&
      as.character(cl) %in% c("function", "new.env")
  ) {
    # attach "name" attr for usage like:
    # foo := function(){}
    # foo := new.env()
    right <- eval(right, parent.frame())
    attr(right, "name") <- as.character(name)
  } else {
    # for all other usage,
    # inject name as a named arg, so that
    #   foo := new_class(...)
    # becomes
    #   foo <- new_class(..., name = "foo")

    right <- as.call(c(as.list(right), list(name = as.character(name))))

    ## skip check; if duplicate 'name' arg is an issue the call itself will signal an error.
    # if (hasName(right, "name")) stop("duplicate `name` argument.")

    ## alternative code path that injects `name` as positional arg instead
    # right <- as.list(right)
    # right <- as.call(c(right[[1L]], as.character(name), right[-1L]))
  }

  eval(call("<-", name, right), parent.frame())
}

`%error%` <- function(x, y) tryCatch(x, error = function(e) y)

`append<-` <- function(x, after, value) {
  if (missing(after)) c(x, value) else append(x, value, after = after)
}

`append1<-` <- function(x, value) {
  stopifnot(is.list(x) || identical(mode(x), mode(value)))
  x[[length(x) + 1L]] <- value
  x
}

`prepend<-` <- function(x, value) {
  c(vector(typeof(x)), value, x)
}

`add<-` <- `+` #function(x, value) x + value

map_int <- function(.x, .f, ...) vapply(X = .x, FUN = .f, FUN.VALUE = 0L, ...)
map_lgl <- function(.x, .f, ...) vapply(X = .x, FUN = .f, FUN.VALUE = TRUE, ...)
map_chr <- function(.x, .f, ...) vapply(X = .x, FUN = .f, FUN.VALUE = "", ...)

imap <- function(.x, .f, ...) {
  out <- .mapply(.f, list(.x, names(.x) %||% seq_along(.x)), list(...))
  names(out) <- names(.x)
  out
}

map2 <- function(.x, .y, .f, ...) {
  if (length(.x) != length(.y) && length(.x) != 1L && length(.y) != 1L) {
    stop(
      ".x and .y must have the same length, or one of them must have length 1"
    )
  }
  out <- .mapply(.f, list(.x, .y), list(...))
  if (length(.x) == length(out)) {
    names(out) <- names(.x)
  }
  out
}

discard <- function(.x, .f, ...) {
  .x[!vapply(X = .x, FUN = .f, FUN.VALUE = TRUE, ...)]
}

keep <- function(.x, .f, ...) {
  .x[vapply(X = .x, FUN = .f, FUN.VALUE = TRUE, ...)]
}

compact <- function(.x) {
  .x[as.logical(lengths(.x, use.names = FALSE))]
}

drop_nulls <- function(x, i) {
  if (missing(i)) {
    x[!vapply(X = x, FUN = is.null, FUN.VALUE = FALSE, USE.NAMES = FALSE)]
  } else {
    drop <- logical(length(x))
    names(drop) <- names(x)
    drop[i] <-
      vapply(X = x[i], FUN = is.null, FUN.VALUE = FALSE, USE.NAMES = FALSE)
    x[!drop]
  }
}

last <- function(x) x[[length(x)]]
drop_last <- function(x) x[-length(x)]

compile_nonreturn_statements <- function(stmts, scope) {
  if (!length(stmts)) {
    check_pending_parallel_consumed(scope)
    return("")
  }

  compiled <- vector("list", length(stmts))
  for (i in seq_along(stmts)) {
    stmt <- stmts[[i]]
    check_pending_parallel_target(stmt, scope)
    stmt_f <- r2f(stmt, scope)
    if (!is.null(stmt_f@value)) {
      stop(
        "all expressions except the final return must compile to a statement (no value); found: ",
        deparse1(stmt),
        call. = FALSE
      )
    }
    compiled[[i]] <- stmt_f
  }

  check_pending_parallel_consumed(scope)
  str_flatten_lines(compiled)
}
# fmt: skip
{
is_scalar_na      <- function(x) is.atomic(x)    && !is.object(x) && length(x) == 1L && is.na(x)
is_scalar_atomic  <- function(x) is.atomic(x)    && !is.object(x) && length(x) == 1L && !is.na(x)
is_scalar_integer <- function(x) is.integer(x)   && !is.object(x) && length(x) == 1L && !is.na(x)
is_string         <- function(x) is.character(x) && length(x) == 1L && !is.na(x) # could also be 'glue' class.
is_bool           <- function(x) is.logical(x)   && !is.object(x) && length(x) == 1L && !is.na(x)
is_number         <- function(x) is.numeric(x)   && !is.object(x) && length(x) == 1L && !is.na(x)
is_scalar_integerish <- function(x) is_number(x) && trunc(x) == x
is_wholenumber    <- function(x) is.numeric(x)   && !is.object(x) && length(x) == 1L && !is.na(x) &&
  x >= 0L && (is.integer(x) || is.double(x) && trunc(x) == x)
}

new_function <- function(args = NULL, body = NULL, env = parent.frame()) {
  as.function.default(c(args, body %||% list(NULL)), env)
}

is_call <- function(x, name = NULL) {
  is.call(x) && (is.null(name) || identical(as.symbol(name), x[[1L]]))
}

str_flatten <- function(x, collapse = "") {
  paste0(as.character(unlist(x, use.names = FALSE)), collapse = collapse)
}

str_flatten_lines <- function(...) {
  paste0(unlist(c(character(), ...), use.names = FALSE), collapse = "\n")
}

str_flatten_commas <- function(...) {
  paste0(unlist(c(character(), ...), use.names = FALSE), collapse = ", ")
}

str_flatten_args <- function(..., multiline = length(dots) >= 3) {
  dots <- unlist(c(character(), ...), use.names = FALSE)
  if (multiline) {
    dots <- paste0("\n  ", dots, collapse = ",")
    paste(dots, "\n")
  } else {
    paste0(dots, collapse = ",")
  }
}

interleave <- function(x, y) {
  stopifnot(is.atomic(x), is.atomic(y), length(y) == 1L, typeof(x) == typeof(y))
  drop_last(as.vector(rbind(x, y, deparse.level = 0L)))
}

str_split_lines <- function(...) {
  x <- c(...) |>
    unlist(use.names = FALSE) |>
    strsplit("\n", fixed = TRUE)
  x[!lengths(x)] <- ""
  x |>
    unlist(use.names = FALSE) |>
    trimws("right")
}

indent <- function(x, n = 2L) {
  x <- str_split_lines(x)
  x <- sub("[ \t\r]+$", "", x, perl = TRUE) # trim trailing whitespace
  paste0(strrep(" ", n), x, collapse = "\n")
}

# fmt: skip
parent.pkg <- function(env = parent.frame(2)) {
  if (isNamespace(env <- topenv(env)))
    as.character(getNamespaceName(env)) # unname
  else
    NULL # print visible
}

set_names <- function(x, nm = x, ...) {
  names(x) <- as.character(
    if (is.function(nm)) {
      nm(names(x), ...)
    } else {
      unlist(list(nm, ...), use.names = FALSE)
    }
  )
  x
}

zip_lists <- function(...) {
  x <- if (...length() == 1L) ..1 else list(...)

  if (is.character(nms.1 <- names(x.1 <- x[[1L]]))) {
    if (anyDuplicated(nms.1) || anyNA(nms.1) || any(nms.1 == "")) {
      stop(
        "All names must be unique.",
        " (Use `unname()` for positional matching.)"
      )
    }
  }

  if (length(setdiff(lengths(x), 1L)) != 1L) {
    stop("all elements must have the same length")
  }

  for (i in seq_along(x)) {
    if (identical(nms.1, nms.i <- names(x[[i]]))) {
      next
    }
    if (setequal(nms.1, nms.i)) {
      x[[i]] <- x[[i]][nms.1]
      next
    }
    stop(
      "All names of arguments provided to `zip_lists()` must match.",
      " Call `unname()` on each argument if you want positional matching"
    )
  }
  ans <- .mapply(list, x, NULL)
  names(ans) <- nms.1
  ans
}

is_missing <- function(x) missing(x) || identical(x, quote(expr = ))


is_type_call <- function(e) {
  is.call(e) && identical(e[[1]], quote(type))
}

reduce <- function(.x, .f, ..., .init) {
  f <- function(x, y) .f(x, y, ...)
  Reduce(f, .x, init = .init)
}

substitute_ <- function(expr, env) {
  do.call(base::substitute, list(expr, env))
}

defer <- function(expr, env = parent.frame(), after = FALSE) {
  thunk <- as.call(list(function() expr))
  do.call(on.exit, list(thunk, TRUE, after), envir = env)
}

is_scalar <- function(x) identical(length(x), 1L)

# Unit tests for internal helper utilities

skip_on_cran()

test_that("zzz .onLoad can be invoked", {
  expect_error(quickr:::.onLoad(), NA)
})

test_that("nil-coalescing %||% returns first non-NULL", {
  expect_identical(quickr:::`%||%`(NULL, 1), 1)
  expect_identical(quickr:::`%||%`(0, 1), 0)
})

test_that("S7-style := assigns and preserves name", {
  local({
    quickr:::`:=`(f, function() 1L)
    expect_true(is.function(f))
    expect_identical(attr(f, "name"), "f")

    quickr:::`:=`(e, new.env())
    expect_true(is.environment(e))
    expect_identical(attr(e, "name"), "e")

    new_obj <- function(name) name
    quickr:::`:=`(x, new_obj())
    expect_identical(x, "x")

    expect_error(quickr:::`:=`(1, function() 1L), "left hand side")
    expect_error(quickr:::`:=`(bad, 1), "right hand side")
    expect_error(quickr:::`:=`(dup, new_obj(name = "x")), "matched by multiple")
  })
})

test_that("append helpers work for common cases", {
  expect_identical(quickr:::`append<-`(1:2, value = 3L), c(1L, 2L, 3L))
  expect_identical(
    quickr:::`append<-`(1:2, after = 1L, value = 3L),
    c(1L, 3L, 2L)
  )

  expect_identical(quickr:::`append1<-`(1:2, 3L), c(1L, 2L, 3L))
  expect_error(quickr:::`append1<-`(1:2, "x"))

  expect_identical(quickr:::`prepend<-`(1:2, 0L), c(0L, 1L, 2L))
})

test_that("map2 validates lengths and preserves names", {
  expect_error(
    quickr:::map2(1:2, 1:3, `+`),
    ".x and .y must have the same length"
  )

  x <- setNames(1:2, c("a", "b"))
  out <- quickr:::map2(x, 1L, `+`)
  expect_identical(names(out), c("a", "b"))
  expect_identical(out, list(a = 2L, b = 3L))
})

test_that("discard and drop_nulls behave as expected", {
  expect_identical(quickr:::discard(1:5, \(x) x %% 2L == 0L), c(1L, 3L, 5L))

  x <- list(a = 1, b = NULL, c = 3)
  expect_identical(names(quickr:::drop_nulls(x)), c("a", "c"))

  x <- list(a = NULL, b = NULL, c = 3)
  expect_identical(names(quickr:::drop_nulls(x, c("a", "c"))), c("b", "c"))
})

test_that("new_function and str_flatten_args are usable", {
  f <- quickr:::new_function(args = alist(x = ), body = quote(x + 1L))
  expect_identical(f(1L), 2L)

  expect_identical(
    quickr:::str_flatten_args("a", "b", multiline = FALSE),
    "a,b"
  )
  expect_true(
    grepl("\n", quickr:::str_flatten_args("a", "b", "c", multiline = TRUE))
  )
})

test_that("parent.pkg detects namespaces and set_names mutates names", {
  expect_identical(quickr:::parent.pkg(environment(quickr::quick)), "quickr")
  expect_null(quickr:::parent.pkg(new.env(parent = emptyenv())))

  x <- setNames(1:2, c("a", "b"))
  expect_identical(names(quickr:::set_names(x, toupper)), c("A", "B"))
})

test_that("zip_lists zips named lists and errors on mismatches", {
  a <- list(x = 1, y = 2)
  b <- list(x = 3, y = 4)
  expect_identical(
    quickr:::zip_lists(a, b),
    list(x = list(1, 3), y = list(2, 4))
  )

  bad_names <- structure(list(1, 2), names = c("x", "x"))
  expect_error(quickr:::zip_lists(list(bad_names)), "All names must be unique")

  expect_error(
    quickr:::zip_lists(list(x = 1, y = 2), list(x = 1, y = 2, z = 3)),
    "all elements must have the same length"
  )

  expect_error(
    quickr:::zip_lists(list(x = 1, y = 2), list(x = 1, z = 2)),
    "must match"
  )
})

test_that("defer schedules cleanup code on exit", {
  e <- new.env(parent = emptyenv())

  f <- function() {
    quickr:::defer(assign("done", TRUE, envir = e))
    invisible()
  }
  f()
  expect_true(isTRUE(e$done))
})

test_that("iterable helpers cover edge cases", {
  expect_null(quickr:::r2f_iterable_context(NULL))
  expect_null(quickr:::r2f_iterable_context(character()))
  expect_null(quickr:::r2f_iterable_context("seq"))
  expect_null(quickr:::r2f_iterable_context(c("foo", "seq")))
  expect_identical(quickr:::r2f_iterable_context(c("[", "seq")), "[")
  expect_identical(quickr:::r2f_iterable_context(c("for", "seq")), "for")

  var_na <- quickr:::Variable("double", list(NA_integer_))
  expect_identical(quickr:::value_length_expr(var_na), NA_integer_)

  expect_identical(quickr:::seq_like_length_expr(NULL, 1L), NA_integer_)
  expect_identical(quickr:::seq_like_length_expr(1L, 1), 1L)
  expect_error(
    quickr:::seq_like_length_expr(1L, 2L, 0L),
    "invalid '\\(to - from\\)/by'"
  )

  scope <- new.env(parent = emptyenv())
  expect_error(
    quickr:::seq_like_parse(
      "seq",
      list(from = quote(expr = ), to = 5L),
      scope
    ),
    "seq\\(\\) requires both `from` and `to`"
  )
  expect_error(
    quickr:::seq_like_parse(
      "seq",
      list(from = 5L, to = quote(expr = )),
      scope
    ),
    "seq\\(\\) requires both `from` and `to`"
  )
  out <- quickr:::seq_like_parse(
    "seq",
    list(from = 1L, to = 3L, by = quote(expr = )),
    scope
  )
  expect_null(out$by)
  expect_error(
    quickr:::seq_like_parse("banana", list(), scope),
    "unsupported iterable"
  )

  expect_false(quickr:::iterable_is_singleton_one(1L, scope))
  expect_false(quickr:::iterable_is_singleton_one(quote(foo(1L)), scope))
  expect_false(quickr:::iterable_is_singleton_one(quote(seq(1L)), scope))
  expect_false(
    quickr:::iterable_is_singleton_one(quote(seq_along(x)), scope)
  )

  scope2 <- quickr:::new_scope(function() NULL)
  expect_error(
    quickr:::r2f_for_iterable(quote(x), scope2),
    "unsupported iterable in for\\(\\)"
  )
})

test_that("iterable_is_singleton_one handles unknown iterable kinds", {
  scope <- new.env(parent = emptyenv())
  local_mocked_bindings(
    seq_like_parse = function(...) list(kind = "bogus"),
    .package = "quickr"
  )

  expect_false(quickr:::iterable_is_singleton_one(quote(seq_len(1L)), scope))
})

test_that("quickr_r_cmd adds .exe extension on Windows when needed", {
  result <- quickr:::quickr_r_cmd(
    os_type = "windows",
    r_home = function(sub) "/path/to/R",
    file_exists = function(x) FALSE
  )
  expect_equal(result, "/path/to/R.exe")
})

test_that("set_names handles list argument", {
  x <- 1:2
  names(x) <- c("a", "b")
  result <- quickr:::set_names(x, "c", "d")
  expect_equal(names(result), c("c", "d"))
})

test_that("zip_lists reorders elements when names match but different order", {
  a <- list(x = 1, y = 2)
  b <- list(y = 4, x = 3)
  result <- quickr:::zip_lists(a, b)
  expect_equal(result$x, list(1, 3))
  expect_equal(result$y, list(2, 4))
})

test_that("is_scalar returns correct values", {
  expect_true(quickr:::is_scalar(1))
  expect_true(quickr:::is_scalar("a"))
  expect_false(quickr:::is_scalar(1:2))
  expect_false(quickr:::is_scalar(character()))
})

test_that("quickr_ordered_env detects untracked names", {
  env <- quickr:::new_ordered_env()
  # Directly assign without going through [[<-
  base::assign("sneaky", 1, envir = env)
  expect_error(
    suppressWarnings(names(env)),
    "untracked name"
  )
})

test_that("print.quickr_ordered_env outputs bindings", {
  env <- quickr:::new_ordered_env()
  env[["x"]] <- 1
  env[["y"]] <- 2
  out <- capture.output(print(env))
  expect_true(any(grepl("x", out)))
  expect_true(any(grepl("with bindings", out)))
})

test_that("check_assignment_compatible handles NULL value", {
  target <- quickr:::Variable("double", list(1L))
  expect_silent(quickr:::check_assignment_compatible(target, NULL))
})

# Unit tests for r2f handler registry

skip_on_cran()

test_that("register_r2f_handler sets dest_supported attribute", {
  handler <- function(e, scope, ...) NULL
  result <- quickr:::register_r2f_handler(
    "test_handler_dest",
    handler,
    dest_supported = TRUE
  )
  expect_true(inherits(result, quickr:::R2FHandler))
  expect_identical(result@dest_supported, TRUE)
})

test_that("register_r2f_handler stores dest_infer metadata", {
  handler <- function(e, scope, ...) NULL
  infer_fn <- function(args, scope) NULL
  result <- quickr:::register_r2f_handler(
    "test_handler_infer",
    handler,
    dest_infer = infer_fn
  )
  expect_true(inherits(result, quickr:::R2FHandler))
  expect_identical(result@dest_infer, infer_fn)
  expect_identical(result@dest_infer_name, "infer_fn")
})

test_that("register_r2f_handler keeps anonymous dest_infer without a name", {
  handler <- function(e, scope, ...) NULL
  infer_fn <- function(args, scope) NULL
  result <- quickr:::register_r2f_handler(
    "test_handler_infer_anon",
    handler,
    dest_infer = (function(args, scope) infer_fn(args, scope))
  )
  expect_true(inherits(result, quickr:::R2FHandler))
  expect_true(is.function(result@dest_infer))
  expect_null(result@dest_infer_name)
})

test_that("register_r2f_handler sets match.fun attribute when not TRUE", {
  handler <- function(e, scope, ...) NULL
  match_fn <- function(x, envir) x
  result <- quickr:::register_r2f_handler(
    "test_handler_match",
    handler,
    match_fun = match_fn
  )
  expect_true(inherits(result, quickr:::R2FHandler))
  expect_identical(result@match_fun, match_fn)
})

test_that("register_r2f_handler does not set match.fun when TRUE", {
  handler <- function(e, scope, ...) NULL
  result <- quickr:::register_r2f_handler(
    "test_handler_match_true",
    handler,
    match_fun = TRUE
  )
  expect_true(inherits(result, quickr:::R2FHandler))
  expect_null(result@match_fun)
})

test_that("register_r2f_handler registers multiple names", {
  handler <- function(e, scope, ...) NULL
  withr::defer(
    rm(list = c("multi_test_a", "multi_test_b"), envir = quickr:::r2f_handlers),
    envir = environment()
  )
  quickr:::register_r2f_handler(
    c("multi_test_a", "multi_test_b"),
    handler
  )
  expect_identical(
    quickr:::r2f_handlers[["multi_test_a"]],
    quickr:::r2f_handlers[["multi_test_b"]]
  )
})

# r2f-reductions-helpers.R
# Generic helpers for reduction operations.

# Create a hoist context for masking in reduction intrinsics.
# Used by: r2f-reductions.R
create_mask_hoist <- function() {
  .hoisted_mask <- NULL
  .conflict <- FALSE

  try_set <- function(mask) {
    stopifnot(inherits(mask, Fortran), mask@value@mode == "logical")
    mask <- booleanize_logical_as_int(mask)
    # each hoist can only accept one mask.
    if (is.null(.hoisted_mask)) {
      .hoisted_mask <<- mask
      return(TRUE)
    }
    # if the mask is identical, we accept it.
    if (identical(.hoisted_mask, mask)) {
      return(TRUE)
    }
    # can't hoist this mask.
    .conflict <<- TRUE
    FALSE
  }

  get_hoisted <- function() .hoisted_mask
  has_conflict <- function() .conflict

  environment()
}

# Convert a linear 1D index to multi-dimensional subscripts.
# Used by: r2f-reductions.R, r2f-subscript.R, r2f-control-flow.R
linear_subscripts_from_1d <- function(base_name, rank, idx) {
  stopifnot(is_string(base_name), is_wholenumber(rank), inherits(idx, Fortran))
  k <- glue("int({idx}, kind=c_int)")
  tmp <- glue("({k} - 1_c_int)")
  subs <- character(rank)
  if (rank == 1L) {
    subs[[1L]] <- k
    return(subs)
  }

  for (axis in seq_len(rank - 1L)) {
    dim_size <- glue("size({base_name}, {axis})")
    subs[[axis]] <- glue("(mod({tmp}, {dim_size}) + 1_c_int)")
    tmp <- glue("({tmp} / {dim_size})")
  }
  subs[[rank]] <- glue("({tmp} + 1_c_int)")
  subs
}

# r2f-iterables-helpers.R
# Generic helpers for iterable sequences and for-loop iteration.

# Determine the context in which an iterable is used.
# Used by: r2f-sequences.R
r2f_iterable_context <- function(calls) {
  if (is.null(calls) || !length(calls)) {
    return(NULL)
  }
  calls <- drop_last(calls)
  if (!length(calls)) {
    return(NULL)
  }
  parent_call <- last(calls)
  if (parent_call %in% c("[", "for")) {
    parent_call
  } else {
    NULL
  }
}

# Compute the length expression for a Variable value.
# Used by: r2f-sequences.R, r2f-control-flow.R
value_length_expr <- function(value) {
  stopifnot(inherits(value, Variable))
  if (passes_as_scalar(value)) {
    return(1L)
  }
  dims <- value@dims
  if (is.null(dims) || any(map_lgl(dims, is_scalar_na))) {
    return(NA_integer_)
  }
  if (value@rank == 1L) {
    return(dims[[1L]])
  }
  reduce(dims, \(d1, d2) call("*", d1, d2))
}

# Compute the length expression for a seq-like construct.
# Used by: r2f-sequences.R
seq_like_length_expr <- function(from, to, by = NULL) {
  if (is.null(from) || is.null(to) || is_missing(from) || is_missing(to)) {
    return(NA_integer_)
  }
  if (identical(from, to)) {
    return(1L)
  }

  if (is_scalar_integerish(from) && is_scalar_integerish(to)) {
    from_val <- as.integer(from)
    to_val <- as.integer(to)
    delta <- to_val - from_val

    if (delta == 0L) {
      return(1L)
    }

    if (!is.null(by) && is_scalar_integerish(by)) {
      by_val <- as.integer(by)
      if (by_val == 0L) {
        stop("invalid '(to - from)/by'", call. = FALSE)
      }
      if (sign(delta) != sign(by_val)) {
        stop("wrong sign in 'by' argument", call. = FALSE)
      }
      return(abs(delta %/% by_val) + 1L)
    }

    return(abs(delta) + 1L)
  }

  if (is.null(by)) {
    return(call("+", call("abs", call("-", to, from)), 1L))
  }
  call("+", call("abs", call("%/%", call("-", to, from), by)), 1L)
}

# Parse a seq-like call into its components.
# Used by: r2f-sequences.R, r2f-control-flow.R
seq_like_parse <- function(name, args, scope) {
  stopifnot(is_string(name))
  switch(
    name,
    `:` = {
      args <- whole_doubles_to_ints(args)
      from <- args[[1L]]
      to <- args[[2L]]
      len_expr <- seq_like_length_expr(from, to)
      list(
        kind = ":",
        from = from,
        to = to,
        by = NULL,
        len_expr = len_expr
      )
    },
    seq = {
      call_expr <- as.call(c(as.symbol("seq"), args))
      seq_call <- match.call(seq.default, call_expr)
      seq_call <- whole_doubles_to_ints(seq_call)

      if (!is.null(seq_call$length.out) && !is_missing(seq_call$length.out)) {
        stop("seq(length.out=, along.with=) not implemented yet")
      }
      if (!is.null(seq_call$along.with) && !is_missing(seq_call$along.with)) {
        stop("seq(length.out=, along.with=) not implemented yet")
      }

      from <- seq_call$from
      to <- seq_call$to
      by <- seq_call$by

      if (is.null(from) || is.null(to)) {
        stop("seq() requires both `from` and `to`", call. = FALSE)
      }

      if (is_scalar_integer(by) && identical(by, 0L)) {
        if (is.null(from) || is.null(to) || !identical(from, to)) {
          stop("invalid '(to - from)/by'", call. = FALSE)
        }
        by <- NULL
      }

      len_expr <- seq_like_length_expr(from, to, by)
      list(
        kind = "seq",
        from = from,
        to = to,
        by = by,
        len_expr = len_expr
      )
    },
    seq_len = {
      stopifnot(length(args) == 1L)
      n_expr <- whole_doubles_to_ints(args[[1L]])
      list(kind = "seq_len", n = n_expr)
    },
    seq_along = {
      stopifnot(length(args) == 1L)
      list(kind = "seq_along", arg = args[[1L]])
    },
    stop("unsupported iterable: ", name, call. = FALSE)
  )
}

# Translate a seq-like call to Fortran.
# Used by: r2f-sequences.R, r2f-control-flow.R
seq_like_r2f <- function(
  name,
  args,
  scope,
  ...,
  context = NULL,
  reversed = FALSE
) {
  info <- seq_like_parse(name, args, scope)
  kind <- info$kind
  len_expr <- info$len_expr %||% NA_integer_

  state <- switch(
    kind,
    `:` = {
      from <- r2f(info$from, scope, ...)
      to <- r2f(info$to, scope, ...)
      list(
        from = from,
        to = to,
        by = Fortran(glue("sign(1, {to}-{from})"), Variable("integer")),
        len_expr = len_expr,
        omit_step = FALSE
      )
    },
    seq = {
      from <- r2f(info$from, scope, ...)
      to <- r2f(info$to, scope, ...)
      by <- if (is.null(info$by)) {
        Fortran(glue("sign(1, {to}-{from})"), Variable("integer"))
      } else {
        r2f(info$by, scope, ...)
      }

      if (
        from@value@mode != "integer" ||
          to@value@mode != "integer" ||
          by@value@mode != "integer"
      ) {
        stop("non-integer seq()'s not implemented yet.")
      }

      if (isTRUE(reversed)) {
        if (!passes_as_scalar(from@value) || !passes_as_scalar(to@value)) {
          stop("seq() iterable bounds must be scalars")
        }
        if (!passes_as_scalar(by@value)) {
          stop("seq() iterable step must be a scalar")
        }
      }

      list(
        from = from,
        to = to,
        by = by,
        len_expr = len_expr,
        omit_step = FALSE
      )
    },
    seq_len = {
      n <- r2f(info$n, scope, ...)
      if (n@value@mode != "integer" || !passes_as_scalar(n@value)) {
        stop("seq_len() expects an integer scalar")
      }
      len_expr <- r2size(info$n, scope)
      if (is_scalar_na(len_expr)) {
        len_expr <- NA_integer_
      }
      list(
        from = Fortran("1", Variable("integer")),
        to = n,
        by = Fortran("1", Variable("integer")),
        len_expr = len_expr,
        omit_step = !isTRUE(reversed)
      )
    },
    seq_along = {
      x <- r2f(info$arg, scope, ...)
      if (is.null(x@value)) {
        stop("seq_along() argument must have a value")
      }
      len_expr <- value_length_expr(x@value)
      end <- if (passes_as_scalar(x@value)) "1" else glue("size({x})")
      list(
        from = Fortran("1", Variable("integer")),
        to = Fortran(end, Variable("integer")),
        by = Fortran("1", Variable("integer")),
        len_expr = len_expr,
        omit_step = !isTRUE(reversed)
      )
    },
    stop("unsupported iterable: ", kind, call. = FALSE)
  )
  from <- state$from
  to <- state$to
  by <- state$by
  len_expr <- state$len_expr
  omit_step <- state$omit_step

  context <- context %||% r2f_iterable_context(list(...)$calls)
  if (is.null(context)) {
    context <- "value"
  }

  if (is.null(len_expr) || is_scalar_na(len_expr)) {
    len_expr <- NA_integer_
  }
  if (
    context == "value" &&
      is_wholenumber(len_expr) &&
      identical(as.integer(len_expr), 1L)
  ) {
    len_expr <- call("+", 0L, 1L)
  }
  val <- Variable("integer", list(len_expr))

  if (isTRUE(reversed)) {
    last <- glue("{from} + (({to} - {from}) / {by}) * {by}")
    start <- last
    end <- from
    step <- glue("(-{by})")
    omit_step <- FALSE
  } else {
    start <- from
    end <- to
    step <- by
  }

  if (context == "for") {
    fr <- if (omit_step) {
      glue("{start}, {end}")
    } else {
      glue("{start}, {end}, {step}")
    }
  } else if (context == "[") {
    fr <- if (omit_step) {
      glue("{start}:{end}")
    } else {
      glue("{start}:{end}:{step}")
    }
  } else {
    i <- scope_unique_var(scope, "integer")
    fr <- if (omit_step) {
      glue("[ ({i}, {i} = {start}, {end}) ]")
    } else {
      glue("[ ({i}, {i} = {start}, {end}, {step}) ]")
    }
  }

  Fortran(fr, val)
}

# Unwrap a for-loop iterable, handling rev() calls.
# Used by: r2f-control-flow.R
r2f_unwrap_for_iterable <- function(iterable) {
  reversed <- FALSE
  repeat {
    while (
      is_call(iterable, quote(`(`)) &&
        length(iterable) == 2L
    ) {
      iterable <- iterable[[2L]]
    }
    if (is_call(iterable, quote(rev)) && length(iterable) == 2L) {
      reversed <- !reversed
      iterable <- iterable[[2L]]
      next
    }
    break
  }

  list(iterable = iterable, reversed = reversed)
}

# Check if an iterable is a singleton sequence of 1.
# Used by: r2f-control-flow.R
iterable_is_singleton_one <- function(iterable, scope) {
  is_one <- function(x) {
    is_wholenumber(x) && identical(as.integer(x), 1L)
  }

  if (!is.call(iterable) || !is.symbol(iterable[[1L]])) {
    return(FALSE)
  }

  name <- as.character(iterable[[1L]])
  if (!name %in% c(":", "seq", "seq_len", "seq_along")) {
    return(FALSE)
  }

  args <- as.list(iterable)[-1L]
  info <- tryCatch(seq_like_parse(name, args, scope), error = function(e) NULL)
  if (is.null(info)) {
    return(FALSE)
  }

  switch(
    info$kind,
    seq_len = is_one(info$n),
    seq_along = {
      arg <- info$arg
      if (is.symbol(arg)) {
        var <- get0(as.character(arg), scope)
        if (inherits(var, Variable) && passes_as_scalar(var)) {
          return(TRUE)
        }
      }
      FALSE
    },
    `:` = is_one(info$from) && is_one(info$to),
    seq = is_one(info$from) && is_one(info$to),
    FALSE
  )
}

# Translate a for-loop iterable to Fortran.
# Used by: r2f-control-flow.R
r2f_for_iterable <- function(iterable, scope, ...) {
  original <- iterable
  unwrapped <- r2f_unwrap_for_iterable(iterable)
  iterable <- unwrapped$iterable
  reversed <- unwrapped$reversed

  stop_unsupported <- function(x) {
    stop(
      "unsupported iterable in for(): ",
      deparse1(x),
      "\nSupported: `<symbol>`, `a:b`, `seq(from, to, by)`, `seq_len(n)`, `seq_along(x)`.",
      call. = FALSE
    )
  }

  if (is.symbol(iterable)) {
    stop_unsupported(original)
  }
  if (!is.call(iterable) || !is.symbol(iterable[[1L]])) {
    stop_unsupported(original)
  }

  name <- as.character(iterable[[1L]])
  supported <- c(":", "seq", "seq_len", "seq_along")
  if (!name %in% supported) {
    stop_unsupported(original)
  }

  if (!reversed) {
    return(r2f(iterable, scope, ...))
  }

  args <- as.list(iterable)[-1L]
  switch(
    name,
    `:` = seq_like_r2f(":", args, scope, ..., context = "for", reversed = TRUE),
    seq_len = seq_like_r2f(
      "seq_len",
      args,
      scope,
      ...,
      context = "for",
      reversed = TRUE
    ),
    seq_along = seq_like_r2f(
      "seq_along",
      args,
      scope,
      ...,
      context = "for",
      reversed = TRUE
    ),
    seq = seq_like_r2f(
      "seq",
      args,
      scope,
      ...,
      context = "for",
      reversed = TRUE
    )
  )
}

# Scope helpers.
#
# quickr scopes are environments with reference semantics. Historically, we
# stored a lot of mutable state in ad-hoc env attributes and accessed it via a
# custom `@.quickr_scope` method, which can be confused with S7 `@` property
# access. These helpers make scope state access explicit and grep-able.

scope_state <- function(scope) {
  stopifnot(inherits(scope, "quickr_scope"))
  st <- attr(scope, "state", exact = TRUE)
  stopifnot(is.environment(st))
  st
}

scope_get <- function(scope, name, default = NULL) {
  stopifnot(inherits(scope, "quickr_scope"), is_string(name))
  st <- scope_state(scope)
  if (!exists(name, envir = st, inherits = FALSE)) {
    return(default)
  }
  get(name, envir = st, inherits = FALSE)
}

scope_set <- function(scope, name, value) {
  stopifnot(inherits(scope, "quickr_scope"), is_string(name))
  st <- scope_state(scope)
  assign(name, value, envir = st)
  invisible(scope)
}

scope_kind <- function(scope) {
  scope_get(scope, "kind")
}

scope_closure <- function(scope) {
  scope_get(scope, "closure")
}

scope_uses_rng <- function(scope) {
  isTRUE(scope_get(scope, "uses_rng", FALSE))
}

scope_mark_uses_rng <- function(scope) {
  scope_set(scope, "uses_rng", TRUE)
  invisible(TRUE)
}

scope_uses_errors_flag <- function(scope) {
  isTRUE(scope_get(scope, "uses_errors", FALSE))
}

scope_mark_uses_errors_flag <- function(scope) {
  scope_set(scope, "uses_errors", TRUE)
  invisible(TRUE)
}

scope_uses_openmp_flag <- function(scope) {
  isTRUE(scope_get(scope, "uses_openmp", FALSE))
}

scope_mark_uses_openmp_flag <- function(scope) {
  scope_set(scope, "uses_openmp", TRUE)
  invisible(TRUE)
}

scope_forbid_superassign <- function(scope) {
  scope_get(scope, "forbid_superassign", character())
}

scope_host_scope <- function(scope) {
  scope_get(scope, "host_scope")
}

scope_new_child <- function(scope, kind) {
  stopifnot(inherits(scope, "quickr_scope"), is_string(kind))
  f <- scope_get(scope, "new_child")
  stopifnot(is.function(f))
  f(kind)
}

scope_unique_var <- function(scope, ...) {
  f <- scope_get(scope, "get_unique_var")
  stopifnot(is.function(f))
  f(...)
}

scope_unique_proc <- function(scope, prefix = "closure") {
  stopifnot(is_string(prefix))
  f <- scope_get(scope, "get_unique_proc")
  stopifnot(is.function(f))
  f(prefix = prefix)
}

scope_add_internal_proc <- function(scope, proc) {
  f <- scope_get(scope, "add_internal_proc")
  stopifnot(is.function(f))
  f(proc)
}

quickr_error_msg_name <- function() "quickr_err_msg"

quickr_error_msg_len <- function() 256L

quickr_error_setter_name <- function() "quickr_set_error_msg"

quickr_error_arg_names <- function() {
  c(quickr_error_msg_name())
}

is_quickr_error_msg <- function(name) {
  identical(name, quickr_error_msg_name())
}

scope_root_for_errors <- function(scope) {
  if (!inherits(scope, "quickr_scope")) {
    return(scope)
  }
  while (
    !identical(scope_kind(scope), "subroutine") &&
      inherits(parent.env(scope), "quickr_scope")
  ) {
    scope <- parent.env(scope)
  }
  scope
}

mark_scope_uses_errors <- function(scope) {
  root <- scope_root_for_errors(scope)
  if (inherits(root, "quickr_scope")) {
    scope_mark_uses_errors_flag(root)
  }
  invisible(TRUE)
}

scope_uses_errors <- function(scope) {
  root <- scope_root_for_errors(scope)
  if (!inherits(root, "quickr_scope")) {
    return(FALSE)
  }
  scope_uses_errors_flag(root)
}

fortran_string_literal <- function(x) {
  stopifnot(is_string(x))
  escaped <- gsub("\r\n|\r|\n", "\\\\n", x)
  escaped <- gsub("\"", "\"\"", escaped, fixed = TRUE)
  paste0("\"", escaped, "\"")
}

check_quickr_error_message_continuable <- function(msg) {
  stopifnot(is_string(msg))
  if (grepl("[ \t]", msg)) {
    return(invisible(TRUE))
  }
  msg_literal <- fortran_string_literal(msg)
  line_len <- nchar(glue(
    "&{quickr_error_setter_name()}( {msg_literal} )"
  ))
  if (line_len > 132L) {
    stop(
      "Error message is too long to fit in a single Fortran line without spaces.",
      " Add spaces to allow line continuations.",
      call. = FALSE
    )
  }
  invisible(TRUE)
}

quickr_error_manifest_lines <- function() {
  msg_name <- quickr_error_msg_name()
  len_val <- quickr_error_msg_len()

  glue("character(kind=c_char), intent(inout) :: {msg_name}({len_val})")
}

quickr_error_helper_fortran <- function(openmp = FALSE) {
  msg_name <- quickr_error_msg_name()
  setter <- quickr_error_setter_name()
  len_val <- quickr_error_msg_len()

  glue::trim(str_flatten_lines(
    glue("subroutine {setter}(msg)"),
    "  character(len=*), intent(in) :: msg",
    "  integer :: i",
    "  integer :: n",
    if (isTRUE(openmp)) "  !$omp critical (quickr_error)",
    glue("  if ({msg_name}(1) == c_null_char) then"),
    glue("    n = min(len(msg), {len_val} - 1)"),
    glue("    {msg_name}(1:n) = [(msg(i:i), i = 1, n)]"),
    glue("    {msg_name}(n + 1) = c_null_char"),
    "  end if",
    if (isTRUE(openmp)) "  !$omp end critical (quickr_error)",
    glue("end subroutine {setter}")
  ))
}

quickr_error_fortran_lines <- function(message = NULL, scope = NULL) {
  msg <- message %||% "quickr error"
  stopifnot(is_string(msg))
  if (!nzchar(msg)) {
    msg <- "quickr error"
  }
  check_quickr_error_message_continuable(msg)
  msg_literal <- fortran_string_literal(msg)
  lines <- glue("call {quickr_error_setter_name()}({msg_literal})")
  if (isTRUE(scope_in_openmp(scope))) {
    lines <- c(lines, "!$omp cancel do")
  } else {
    lines <- c(lines, "return")
  }
  lines
}

quickr_error_return_if_set <- function(
  scope,
  openmp_depth = scope_openmp_depth(scope)
) {
  if (!isTRUE(scope_uses_errors(scope))) {
    return("")
  }
  if (is.null(openmp_depth)) {
    openmp_depth <- 0L
  }
  openmp_depth <- max(as.integer(openmp_depth), 0L)
  if (openmp_depth > 0L) {
    return(str_flatten_lines(
      glue("if ({quickr_error_msg_name()}(1) /= c_null_char) then"),
      "  !$omp cancel do",
      "end if"
    ))
  }
  glue("if ({quickr_error_msg_name()}(1) /= c_null_char) return")
}

# r2f-reductions.R
# Handlers for reduction operations:
# - numeric: max, min, sum, prod
# - logical: any, all
# - index: which.max, which.min

# --- Handlers ---

register_r2f_handler(
  c("max", "min", "sum", "prod"),
  function(
    args,
    scope,
    ...
  ) {
    intrinsic <- switch(
      last(list(...)$calls),
      max = "maxval",
      min = "minval",
      sum = "sum",
      prod = "product"
    )

    reduce_arg <- function(arg) {
      mask_hoist <- create_mask_hoist()
      # Nested reductions (e.g., min(max(...), ...)) can thread an existing
      # hoist_mask through `...`. We always want a single mask hoister per
      # reduction context, so we ignore any inherited one and install ours.
      dots <- list(...)
      x <- r2f(
        arg,
        scope,
        calls = dots$calls,
        hoist = dots$hoist,
        hoist_mask = mask_hoist$try_set
      )
      if (mask_hoist$has_conflict()) {
        stop(
          "reduction expressions only support a single logical mask",
          call. = FALSE
        )
      }
      if (x@value@is_scalar) {
        return(x)
      }
      hoisted_mask <- mask_hoist$get_hoisted()
      s <- glue(
        if (is.null(hoisted_mask)) {
          "{intrinsic}({x})"
        } else {
          "{intrinsic}({x}, mask = {hoisted_mask})"
        }
      )
      Fortran(s, Variable(x@value@mode))
    }

    if (length(args) == 1) {
      reduce_arg(args[[1]])
    } else {
      args <- lapply(args, reduce_arg)
      mode <- reduce_promoted_mode(args)
      s <- switch(
        last(list(...)$calls),
        max = glue("max({str_flatten_commas(args)})"),
        min = glue("min({str_flatten_commas(args)})"),
        sum = glue("({str_flatten(args, ' + ')})"),
        prod = glue("({str_flatten(args, ' * ')})")
      )
      Fortran(s, Variable(mode))
    }
  }
)

register_r2f_handler(
  c("any", "all"),
  function(
    args,
    scope,
    ...
  ) {
    # For now, we only support the most common `any(x)` / `all(x)` shape.
    # We intentionally do not support named arguments like `na.rm`.
    arg_names <- names(args) %||% character()
    if (length(arg_names) && any(nzchar(arg_names))) {
      stop(
        "any()/all() do not support named arguments (e.g. `na.rm`)",
        call. = FALSE
      )
    }

    call_name <- last(list(...)$calls)
    intrinsic <- switch(
      call_name,
      any = "any",
      all = "all",
      stop("internal error: unexpected call: ", call_name, call. = FALSE)
    )

    # Match R's base semantics: any() == FALSE, all() == TRUE.
    if (length(args) == 0L) {
      lit <- if (identical(call_name, "any")) ".false." else ".true."
      return(Fortran(lit, Variable("logical")))
    }

    reduce_arg <- function(arg) {
      mask_hoist <- create_mask_hoist()
      x <- r2f(arg, scope, ..., hoist_mask = mask_hoist$try_set)
      if (mask_hoist$has_conflict()) {
        stop(
          "reduction expressions only support a single logical mask",
          call. = FALSE
        )
      }

      if (!identical(x@value@mode, "logical")) {
        stop("any()/all() only implemented for logical", call. = FALSE)
      }

      hoisted_mask <- mask_hoist$get_hoisted()

      # Scalar logical: any(x) == x, all(x) == x
      if (x@value@is_scalar) {
        if (is.null(hoisted_mask)) {
          # `c(FALSE)` lowers to a 1-element Fortran array constructor
          # (`[.false.]`) but any()/all() must still return scalars.
          x_code <- trimws(as.character(x))
          if (startsWith(x_code, "[")) {
            return(Fortran(glue("{intrinsic}({x})"), Variable("logical")))
          }
          return(x)
        }

        # For scalar `x`, `x[mask]` is empty iff `!any(mask)`.
        #
        # Note: `logical(1)` masks are represented as rank-1 (dims = list(1L))
        # but pass as scalars in the ABI and must *not* be wrapped in `any()` /
        # `all()` (compilers reject `any()` / `all()` on scalar arguments).
        #
        # Conversely, literal masks like `c(FALSE)` compile to array constructors
        # (e.g. `[ .false. ]`) and must be reduced to a scalar condition.
        mask_code <- trimws(as.character(hoisted_mask))
        is_array_ctor <- startsWith(mask_code, "[")
        mask_is_scalar <-
          !is.null(hoisted_mask@value) &&
          passes_as_scalar(hoisted_mask@value) &&
          !is_array_ctor

        mask_len1 <-
          !is.null(hoisted_mask@value) &&
          identical(hoisted_mask@value@dims, list(1L))

        if (!mask_is_scalar && !mask_len1) {
          stop(
            "any()/all(): scalar masked subsets only support scalar or length-1 masks",
            call. = FALSE
          )
        }

        mask_scalar <- if (mask_is_scalar) {
          glue("{hoisted_mask}")
        } else {
          glue("any({hoisted_mask})")
        }

        # When `[` hoists a scalar mask (x[mask] -> x with a hoisted mask),
        # we must preserve empty-selection semantics:
        # - any(logical(0)) == FALSE
        # - all(logical(0)) == TRUE
        identity <- if (identical(call_name, "any")) ".false." else ".true."
        x_code <- trimws(as.character(x))
        x_scalar <- if (startsWith(x_code, "[")) {
          glue("{intrinsic}({x})")
        } else {
          glue("{x}")
        }
        return(Fortran(
          glue("merge({x_scalar}, {identity}, {mask_scalar})"),
          Variable("logical", x@value@dims)
        ))
      }

      x_expr <- if (is.null(hoisted_mask)) {
        glue("{x}")
      } else {
        # Avoid `pack()` temporaries. For a mask-selected subset:
        # - any(x[mask]) is equivalent to any(x .and. mask)
        # - all(x[mask]) is equivalent to all((.not. mask) .or. x)
        # Both preserve empty-selection semantics.
        #
        # Note: A length-1 mask constructor like `c(TRUE)` compiles to a rank-1
        # array constructor (`[ .true. ]`). In R, this is recycled as a scalar
        # mask, so we must scalarize it to keep elementwise ops conformable.
        mask_code <- trimws(as.character(hoisted_mask))
        mask_is_array_ctor <- startsWith(mask_code, "[")
        mask_ctor_len1 <-
          mask_is_array_ctor &&
          !is.null(hoisted_mask@value) &&
          identical(hoisted_mask@value@dims, list(1L))
        mask_expr <- if (mask_ctor_len1) {
          glue("any({hoisted_mask})")
        } else {
          glue("{hoisted_mask}")
        }
        if (identical(call_name, "any")) {
          glue("(({x}) .and. ({mask_expr}))")
        } else {
          glue("((.not. ({mask_expr})) .or. ({x}))")
        }
      }

      Fortran(glue("{intrinsic}({x_expr})"), Variable("logical"))
    }

    if (length(args) == 1L) {
      return(reduce_arg(args[[1L]]))
    }

    args <- lapply(args, reduce_arg)
    op <- if (identical(call_name, "any")) ".or." else ".and."
    Fortran(glue("({str_flatten(args, glue(' {op} '))})"), Variable("logical"))
  }
)


r2f_handlers[["which.max"]] <- r2f_handlers[["which.min"]] <-
  function(args, scope = NULL, ...) {
    stopifnot(length(args) == 1)
    x <- r2f(args[[1L]], scope, ...)
    stopifnot(
      "Values passed to which.max()/which.min() must be 1d arrays" = x@value@rank ==
        1
    )
    valout <- Variable(mode = "integer") # integer scalar

    if (x@value@mode == "logical") {
      # R semantics:
      # - which.max(all FALSE) == 1
      # - which.min(all TRUE)  == 1
      # findloc() returns 0 when the value is not found, so we wrap it with
      # max(1, ...) to preserve R's tie/default.
      #
      # Performance notes (quickr-compiled, n = 20,000,000 logicals ~= 76 MiB):
      # - maxloc(merge(1_c_int, 0_c_int, (a/=0)), 1) is ~10ms regardless of
      #   where the first .true. occurs (full traversal).
      # - max(1_c_int, findloc((a/=0), .true., 1, kind=c_int)) can early-exit
      #   (~1.3ms when the first element is .true.) but is much slower on full
      #   scans (~55-62ms when the last element is .true. or no .true. exists).
      # - max(1_c_int, findloc(a, 1_c_int, 1, kind=c_int)) on the underlying
      #   integer storage keeps full-scan performance close to maxloc (~14ms)
      #   while retaining early-exit.
      # Results are compiler/runtime dependent; the relative pattern was stable.
      #
      call_name <- last(list(...)$calls)

      has_var_name <- inherits(x@value, Variable) && !is.null(x@value@name)
      use_lgl_storage <- has_var_name && !logical_as_int(x@value)
      int_backed_expr <-
        logical_as_int(x@value) &&
        !isTRUE(x@logical_booleanized)

      # Prefer searching the underlying integer storage directly when available
      # (external logical arrays are passed as integer(0/1)). If the input is an
      # actual Fortran logical array, search it directly to avoid unnecessary
      # casting.
      haystack <- if (has_var_name) {
        x@value@name
      } else if (int_backed_expr) {
        as.character(x)
      } else {
        glue("merge(1_c_int, 0_c_int, {x})")
      }
      needle <- switch(
        call_name,
        which.max = if (use_lgl_storage) ".true." else "1_c_int",
        which.min = if (use_lgl_storage) ".false." else "0_c_int"
      )

      loc <- glue("findloc({haystack}, {needle}, 1, kind=c_int)")
      f <- glue("max(1_c_int, {loc})")
    } else {
      intrinsic <- switch(
        last(list(...)$calls),
        which.max = "maxloc",
        which.min = "minloc"
      )
      f <- glue("{intrinsic}({x}, 1)")
    }

    Fortran(f, valout)
  }

check_type_call <- function(cl) {
  if (length(cl) > 2) {
    stop("only one variable can be declared per type() call")
  }
  args <- as.list(cl)[-1]
  if (length(names(args)) != 1) {
    stop("name must be provided as: type(<name> = <mode>(<<dims>>)")
  }
  if (!is.call(args[[1]]) && as.character(args[[1]]) %in% .atomic_type_names) {
    stop("only atomic modes are supported")
  }
}


type_call_to_var <- function(cl) {
  check_type_call(cl)
  r_name <- names(cl)[-1]
  Variable(
    name = fortranize_name(r_name),
    r_name = r_name,
    mode = as.character(cl[[2L]][[1L]]),
    dims = unname(as.list(cl[[2]])[-1])
  )
}

var_to_type_call <- function(var) {
  arg <- as.call(c(as.symbol(var@mode), var@dims))
  arg <- setNames(list(arg), var@r_name %||% var@name)
  as.call(c(quote(type), arg))
}


get_flattened_args <- function(cl) {
  # flatten exprs from `{` in usage like declare({ ... })`
  args <- as.list(cl)[-1]
  args <- lapply(args, function(e) {
    if (is_missing(e)) {
      NULL
    } else if (is_call(e, quote(`{`))) {
      get_flattened_args(e)
    } else {
      list(e)
    }
  })
  unlist(args, recursive = FALSE)
}

self_evaluate <- function(...) sys.call()

substitute_declared_sizes <- function(e) {
  stopifnot(is_call(e, quote(`{`)))

  declared_names <- local({
    names_out <- character()
    walk <- function(node) {
      if (is_call(node, quote(declare))) {
        args <- get_flattened_args(node)
        for (a in args) {
          if (is_type_call(a)) {
            nm <- names(as.list(a)[-1])
            names_out <<- c(names_out, nm)
          }
        }
      }
      if (is.call(node)) {
        lapply(as.list(node), walk)
      }
    }
    walk(e)
    unique(names_out[nzchar(names_out)])
  })

  aliases <- new.env(parent = emptyenv())
  eval_env <- new.env(parent = emptyenv())
  for (name in all.names(e, functions = TRUE, unique = TRUE)) {
    assign(name, self_evaluate, eval_env)
  }
  eval_env <- new.env(parent = eval_env)
  for (name in all.names(e, functions = FALSE, unique = TRUE)) {
    assign(name, as.symbol(name), eval_env)
  }

  eval_env$`{` <- function(...) {
    as.call(c(list(quote(`{`)), list(...)))
  }

  eval_env$declare <- function(...) {
    args <- get_flattened_args(sys.call())
    args <- lapply(args, function(e) {
      if (is_type_call(e)) {
        var <- type_call_to_var(e)
        var@dims <- imap(var@dims, function(size, axis) {
          size_name <- as.symbol(get_size_name(var, axis))
          if (
            is.symbol(size) &&
              !exists(size, aliases) &&
              !(as.character(size) %in% declared_names)
          ) {
            # user defined implicit size_name alias
            assign(as.character(size), size_name, aliases)
            size <- size_name
          } else if (is_scalar_na(size)) {
            size <- size_name
          } else if (is_wholenumber(size)) {
            size <- as.integer(size)
          }
          size
        })
        e <- var_to_type_call(var)
      }
      e
    })

    as.call(c(quote(declare), args))
  }

  e <- eval(e, eval_env)

  # Now the 'aliases' env is populated; go through and substitute
  # size aliases with the actual size name.
  eval_env$declare <- function(...) {
    as.call(lapply(sys.call(), function(e) {
      if (is_type_call(e)) {
        e <- substitute_(e, aliases)
      }
      e
    }))
  }

  eval(e, eval_env)
}


r2size <- function(r, scope) {
  sanitize_dim <- function(dim) {
    if (is.symbol(dim) || is.call(dim)) {
      return(r2size(dim, scope))
    }
    dim
  }

  resolve_var_dim <- function(var_expr, axis, expr = var_expr) {
    var <- get0(as.character(var_expr), scope)
    if (!inherits(var, Variable)) {
      stop("could not resolve size: ", deparse1(expr))
    }
    if (axis > var@rank) {
      stop("insufficient rank of variable in ", deparse1(expr))
    }
    sanitize_dim(var@dims[[axis]])
  }

  typeof(r) |>
    switch(
      integer = r,
      double = {
        if (is_wholenumber(r)) {
          as.integer(r)
        } else {
          stop("size must be an integer, found: ", r)
        }
      },
      symbol = {
        if (is_size_name(r)) {
          return(r)
        }
        var <- get0(as.character(r), scope)
        if (!inherits(var, Variable)) {
          stop("could not resolve size: ", as.character(r))
        }
        if (var@mode != "integer" || !passes_as_scalar(var)) {
          warning("size is not an integer:", as.character(r))
        }
        if (var@is_arg && !var@modified) {
          return(scope_fortran_symbol(r, scope))
        }
        # TODO: add specific unit tests here
        if (identical(var@r, r)) {
          return(scope_fortran_symbol(r, scope))
        }
        # make a best effort to use the r expression last assigned to the
        # symbol, or fail gracefully and return NA.
        # closure-locals with unspecified shape are declared allocatable
        # input and/or output args with unspecified shape signal an error.
        r2size(var@r, scope)
      },
      language = {
        op <- as.character(r[[1]])

        if (op %in% c("+", "-", "/", "*", "^", "%/%", "%%")) {
          args <- as.list(r)[-1]
          args <- lapply(args, r2size, scope)
          if (anyNA(rapply(args, as.list))) {
            return(NA_integer_)
          }
          cl <- as.call(c(r[[1]], args))
          if (all(map_lgl(args, is.atomic))) {
            cl <- eval(cl, baseenv())
          }
          return(cl)
        }

        switch(
          op,
          length = {
            var <- get0(as.character(r[[2L]]), scope)
            if (!inherits(var, Variable)) {
              stop("could not resolve size: ", deparse1(r))
            }
            if (var@rank == 1) {
              return(sanitize_dim(var@dims[[1L]]))
            }
            len <- reduce(var@dims, \(d1, d2) call("*", d1, d2))
            r2size(len, scope)
          },
          `[` = {
            # [ only works when paired with dim()
            if (!is_call(r[[2L]], quote(dim))) {
              return(NA_integer_)
            }
            axis <- r[[3]]
            if (!is_wholenumber(axis)) {
              return(NA_integer_)
            }
            resolve_var_dim(r[[2L]][[2L]], axis, r)
          },
          # dim = {
          #
          # },
          nrow = resolve_var_dim(r[[2L]], 1L, r),
          ncol = resolve_var_dim(r[[2L]], 2L, r),
          NA_integer_
        )
      },
      NA_integer_
    )
}

r2dims <- function(r, scope) {
  if (is.call(r)) {
    as.character(r[[1]]) |>
      switch(
        dim = {
          var <- get0(as.character(r[[2L]]), scope)
          if (!inherits(var, Variable)) {
            stop("could not resolve dims: ", deparse1(r))
          }
          return(var@dims)
        },
        c = {
          args <- lapply(r[-1], r2dims, scope)
          dims <- unlist(args, recursive = FALSE)
          return(as.list(dims))
        },
        r <- list(r)
      )
  }
  lapply(r, r2size, scope)
}

get_size_name <- function(var, axis = NULL, name = var@name, rank = var@rank) {
  stopifnot(is.null(axis) || is_wholenumber(axis) && axis > 0)
  if (is.null(axis) || rank == 1 && axis == 1) {
    sprintf("%s__len_", name)
  } else {
    if (axis > rank) {
      stop("axis must not be > rank")
    }
    sprintf("%s__dim_%i_", name, axis)
  }
}

# TODO: allow syntax like:
#   declare(type(a, b, c = integer(1)))
# or:
#   declare(type(a = , b = , c = integer(1)))

# r2f-dimensions.R
# Handlers for dimension queries: length, nrow, ncol, dim

# --- Handlers ---

r2f_handlers[["length"]] <- function(args, scope, ...) {
  x <- r2f(args[[1]], scope, ...)
  Fortran(glue("size({x})"), Variable("integer"))
}

r2f_handlers[["nrow"]] <- function(args, scope, ...) {
  x <- r2f(args[[1]], scope, ...)
  Fortran(glue("size({x}, 1)"), Variable("integer"))
}

r2f_handlers[["ncol"]] <- function(args, scope, ...) {
  x <- r2f(args[[1]], scope, ...)
  Fortran(glue("size({x}, 2)"), Variable("integer"))
}

r2f_handlers[["dim"]] <- function(args, scope, ...) {
  x <- r2f(args[[1]], scope, ...)
  Fortran(glue("shape({x})"), Variable("integer", x@value@rank))
}

# r2f-operators-helpers.R
# Generic helpers for binary operators and type conformance.

# Convert a logical value backed by bind(c) integer storage (0/1/NA) to a
# Fortran LOGICAL expression. Symbols are typically booleanized during r2f()
# (see r2f-aab-core.R), but expressions like rev(x) need handling at use sites.
# Used by: r2f-logical.R, r2f-conditionals.R, r2f-subscript.R, r2f-reductions.R
booleanize_logical_as_int <- function(x) {
  stopifnot(inherits(x, Fortran))

  if (
    is.null(x@value) ||
      !identical(x@value@mode, "logical") ||
      !logical_as_int(x@value)
  ) {
    return(x)
  }

  if (isTRUE(x@logical_booleanized)) {
    return(x)
  }

  out <- Fortran(glue("({x} /= 0)"), Variable("logical", x@value@dims))
  out@logical_booleanized <- TRUE
  out
}

# Cast a value to double if it's logical or integer.
# Used by: r2f-arithmetic.R
maybe_cast_double <- function(x) {
  if (x@value@mode == "logical") {
    Fortran(
      glue("merge(1_c_double, 0_c_double, {x})"),
      Variable("double", x@value@dims)
    )
  } else if (x@value@mode == "integer") {
    Fortran(
      glue("real({x}, kind=c_double)"),
      Variable("double", x@value@dims)
    )
  } else {
    x
  }
}

# Check if a dimension expression equals 1.
# Used by: r2f-arithmetic.R, r2f-logical.R
dim_is_one <- function(x) {
  is_wholenumber(x) && identical(as.integer(x), 1L)
}

# Check if a Fortran value is a 1x1 matrix.
# Used by: r2f-arithmetic.R, r2f-logical.R
is_one_by_one <- function(x) {
  stopifnot(inherits(x, Fortran))
  x@value@rank == 2L &&
    dim_is_one(x@value@dims[[1L]]) &&
    dim_is_one(x@value@dims[[2L]])
}

# Check if two dimension expressions match.
# Used by: r2f-arithmetic.R, r2f-logical.R
dims_match <- function(left, right) {
  if (is_wholenumber(left) && is_wholenumber(right)) {
    return(identical(as.integer(left), as.integer(right)))
  }
  identical(left, right)
}

# Check if two lengths recycle without warnings.
# Used by: r2f-arithmetic.R, r2f-logical.R
check_recyclable_pair <- function(left, right) {
  if (is_wholenumber(left) && is_wholenumber(right)) {
    left <- as.integer(left)
    right <- as.integer(right)
    if (left == 0L || right == 0L) {
      return(list(ok = TRUE, unknown = FALSE))
    }
    longer <- max(left, right)
    shorter <- min(left, right)
    return(list(ok = (longer %% shorter) == 0L, unknown = FALSE))
  }
  left_norm <- fortranize_expr_symbols(left)
  right_norm <- fortranize_expr_symbols(right)
  if (identical(left_norm, right_norm)) {
    return(list(ok = TRUE, unknown = FALSE))
  }
  list(ok = TRUE, unknown = TRUE)
}

# Reshape a vector to match a matrix's dimensions.
# Used by: r2f-arithmetic.R, r2f-logical.R
reshape_vector_for_matrix <- function(vec, rows, cols) {
  stopifnot(inherits(vec, Fortran))
  out_val <- Variable(vec@value@mode, list(rows, cols))
  source <- if (passes_as_scalar(vec@value)) {
    glue("[{vec}]")
  } else {
    glue("{vec}")
  }
  out_expr <- glue(
    "reshape({source}, [{bind_dim_int(rows)}, {bind_dim_int(cols)}], pad = {source})"
  )
  Fortran(out_expr, out_val)
}

# Convert a 1x1 matrix to a scalar.
# Used by: r2f-arithmetic.R, r2f-logical.R
scalarize_matrix <- function(mat) {
  stopifnot(inherits(mat, Fortran))
  out_val <- Variable(mat@value@mode)
  Fortran(glue("{mat}(1, 1)"), out_val)
}

# Reshape vector/matrix operands to match ranks for binary operations.
# Used by: r2f-arithmetic.R, r2f-logical.R
maybe_reshape_vector_matrix <- function(left, right) {
  if (
    !inherits(left, Fortran) ||
      !inherits(right, Fortran) ||
      is.null(left@value) ||
      is.null(right@value)
  ) {
    return(list(left = left, right = right))
  }

  left_scalar <- passes_as_scalar(left@value)
  right_scalar <- passes_as_scalar(right@value)
  left_rank <- if (left_scalar) 0L else left@value@rank
  right_rank <- if (right_scalar) 0L else right@value@rank

  if (left_rank == 2L && right_rank == 1L && is_one_by_one(left)) {
    right_len <- dim_or_one(right, 1L)
    if (!dim_is_one(right_len)) {
      left <- scalarize_matrix(left)
      left_rank <- 0L
    }
  } else if (left_rank == 1L && right_rank == 2L && is_one_by_one(right)) {
    left_len <- dim_or_one(left, 1L)
    if (!dim_is_one(left_len)) {
      right <- scalarize_matrix(right)
      right_rank <- 0L
    }
  }

  if (left_rank == 1L && right_rank == 1L) {
    conform <- check_recyclable_pair(
      dim_or_one(left, 1L),
      dim_or_one(right, 1L)
    )
    if (!conform$ok) {
      stop(
        "elementwise vector operations require lengths that recycle cleanly unless one operand is scalar",
        call. = FALSE
      )
    }
  }

  if (left_rank == 2L && right_rank == 2L) {
    left_dims <- matrix_dims(left)
    right_dims <- matrix_dims(right)
    row_conform <- check_conformable(left_dims$rows, right_dims$rows)
    col_conform <- check_conformable(left_dims$cols, right_dims$cols)
    if (!row_conform$ok || !col_conform$ok) {
      stop(
        "elementwise matrix operations require matching dimensions",
        call. = FALSE
      )
    }
  }

  if (left_rank == 1L && right_rank == 2L) {
    right_dims <- matrix_dims(right)
    left_len <- dim_or_one(left, 1L)
    row_conform <- check_conformable(left_len, right_dims$rows)
    if (!row_conform$ok || row_conform$unknown) {
      stop(
        "elementwise vector-matrix operations require a scalar or a vector length equal to the matrix first dimension (nrow)",
        call. = FALSE
      )
    }
    left <- reshape_vector_for_matrix(left, right_dims$rows, right_dims$cols)
  } else if (left_rank == 2L && right_rank == 1L) {
    left_dims <- matrix_dims(left)
    right_len <- dim_or_one(right, 1L)
    row_conform <- check_conformable(right_len, left_dims$rows)
    if (!row_conform$ok || row_conform$unknown) {
      stop(
        "elementwise vector-matrix operations require a scalar or a vector length equal to the matrix first dimension (nrow)",
        call. = FALSE
      )
    }
    right <- reshape_vector_for_matrix(right, left_dims$rows, left_dims$cols)
  }

  list(left = left, right = right)
}

# Determine the promoted mode from a list of Fortran values.
# Used by: r2f-arithmetic.R, r2f-constructors.R
reduce_promoted_mode <- function(...) {
  getmode <- function(d) {
    if (inherits(d, Fortran)) {
      d <- d@value
    }
    if (inherits(d, Variable)) {
      return(d@mode)
    }
    if (is.list(d) && length(d)) {
      lapply(d, getmode)
    }
  }
  modes <- unique(unlist(getmode(list(...))))

  if ("double" %in% modes) {
    "double"
  } else if ("integer" %in% modes) {
    "integer"
  } else if ("logical" %in% modes) {
    "logical"
  } else {
    NULL
  }
}

# Create a Variable with conforming dimensions from multiple inputs.
# Used by: r2f-arithmetic.R, r2f-logical.R, r2f-constructors.R, r2f-conditionals.R
conform <- function(..., mode = NULL) {
  var <- NULL
  # technically, types are implicit promoted, but we'll let <- handle that.
  for (var in drop_nulls(list(...))) {
    if (passes_as_scalar(var)) {
      next
    } else {
      break
    }
  }
  if (is.null(var)) {
    NULL
  } else {
    Variable(mode %||% var@mode, var@dims)
  }
}

quickr_flang_path <- function(which = Sys.which) {
  flang_new <- which("flang-new")
  if (nzchar(flang_new)) {
    return(flang_new)
  }
  flang <- which("flang")
  if (nzchar(flang)) {
    return(flang)
  }
  ""
}

quickr_flang_available <- function(
  which = Sys.which,
  system2 = base::system2
) {
  flang <- quickr_flang_path(which = which)
  if (!nzchar(flang)) {
    return(list(path = "", available = FALSE))
  }
  probe <- tryCatch(
    system2(flang, "--version", stdout = TRUE, stderr = TRUE),
    error = function(e) structure(character(), status = 1L)
  )
  if (!is.null(attr(probe, "status"))) {
    return(list(path = flang, available = FALSE))
  }
  list(path = flang, available = TRUE)
}

quickr_flang_state <- local({
  state <- new.env(parent = emptyenv())
  state$auto_disabled <- FALSE
  state$fallback_warned <- FALSE
  state
})

quickr_flang_auto_disabled <- function(state = quickr_flang_state) {
  isTRUE(state$auto_disabled)
}

quickr_disable_flang_auto <- function(state = quickr_flang_state) {
  state$auto_disabled <- TRUE
  invisible(state$auto_disabled)
}

quickr_warn_flang_fallback_once <- function(state = quickr_flang_state) {
  if (isTRUE(state$fallback_warned)) {
    return(invisible(TRUE))
  }
  warning(
    paste(
      "flang compilation failed; falling back to gfortran and disabling",
      "automatic flang preference for this session."
    ),
    call. = FALSE
  )
  state$fallback_warned <- TRUE
  invisible(TRUE)
}

quickr_compiler_warning_state <- local({
  state <- new.env(parent = emptyenv())
  state$warned <- FALSE
  state
})

quickr_warn_compiler_failure_once <- function(
  message,
  state = quickr_compiler_warning_state
) {
  if (isTRUE(state$warned)) {
    return(invisible(TRUE))
  }
  warning(message, call. = FALSE)
  state$warned <- TRUE
  invisible(TRUE)
}

quickr_flang_runtime_flags <- local({
  cache <- NULL

  function(flang, sysname = Sys.info()[["sysname"]]) {
    stopifnot(is_string(flang))
    if (!nzchar(flang) || sysname != "Darwin") {
      return(character())
    }
    if (!file.exists(flang)) {
      return(character())
    }
    if (!is.null(cache)) {
      return(cache)
    }

    resolved <- normalizePath(flang, winslash = "/", mustWork = FALSE)

    prefix <- dirname(dirname(resolved))
    libdirs <- unique(
      c(
        file.path(prefix, "lib"),
        file.path(prefix, "lib64"),
        Sys.glob(file.path(prefix, "lib", "clang", "*", "lib", "darwin")),
        Sys.glob(file.path(prefix, "lib64", "clang", "*", "lib", "darwin"))
      )
    )

    runtime <- "libflang_rt.runtime.dylib"
    libdir <- keep(libdirs, function(d) file.exists(file.path(d, runtime)))

    if (!length(libdir)) {
      cache <<- character()
      return(cache)
    }

    cache <<- c(sprintf("-L%s", libdir[[1L]]), "-lflang_rt.runtime")
    cache
  }
})

quickr_fortran_compiler_option <- function(
  opt = getOption("quickr.fortran_compiler")
) {
  if (is.null(opt)) {
    return(NULL)
  }
  if (!is_string(opt)) {
    stop(
      "`options(quickr.fortran_compiler)` must be a single string.",
      call. = FALSE
    )
  }
  opt <- tolower(trimws(opt))
  if (!nzchar(opt) || opt %in% c("auto", "default", "system")) {
    return(NULL)
  }
  if (opt %in% c("flang", "flang-new")) {
    return("flang")
  }
  if (opt %in% c("gfortran", "gnu")) {
    return("gfortran")
  }
  stop(
    "`options(quickr.fortran_compiler)` must be one of ",
    "\"flang\", \"gfortran\", or \"auto\".",
    call. = FALSE
  )
}

quickr_prefer_flang <- function(
  sysname = Sys.info()[["sysname"]],
  which = Sys.which,
  system2 = base::system2
) {
  compiler_opt <- quickr_fortran_compiler_option()
  if (identical(compiler_opt, "flang")) {
    return(TRUE)
  }
  if (identical(compiler_opt, "gfortran")) {
    return(FALSE)
  }
  if (quickr_flang_auto_disabled()) {
    return(FALSE)
  }

  # Best-effort: on macOS, prefer flang if it is available.
  if (sysname == "Darwin") {
    info <- quickr_flang_available(which = which, system2 = system2)
    return(isTRUE(info$available))
  }

  FALSE
}

quickr_default_fortran_makevars_lines <- function(
  config_value = quickr_r_cmd_config_value
) {
  fc <- trimws(config_value("FC"))
  if (!nzchar(fc)) {
    return(character())
  }

  compiler <- strsplit(fc, "\\s+")[[1L]][[1L]]
  compiler <- basename(compiler)
  if (!grepl("^gfortran(?:-[0-9]+)?(?:\\.exe)?$", compiler)) {
    return(character())
  }

  # GCC 12+ uses a very-cheap vectorizer cost model at -O2. That keeps the
  # default build conservative for loops like quickr's generated array kernels.
  # Relaxing the cost model restores the vectorized code path without changing
  # the compiler or generated Fortran source.
  "PKG_FFLAGS += -fvect-cost-model=cheap"
}

quickr_fcompiler_env <- function(
  build_dir,
  which = Sys.which,
  system2 = base::system2,
  write_lines = writeLines,
  sysname = Sys.info()[["sysname"]],
  use_openmp = FALSE,
  link_flags = character(),
  config_value = quickr_r_cmd_config_value
) {
  stopifnot(is.character(build_dir), length(build_dir) == 1L, nzchar(build_dir))

  use_openmp <- isTRUE(use_openmp)
  link_flags <- link_flags[nzchar(link_flags)]
  compiler_opt <- quickr_fortran_compiler_option()
  explicit_request <- identical(compiler_opt, "flang")

  flang <- ""
  flang_runtime <- character()
  use_flang <- isTRUE(quickr_prefer_flang(
    sysname = sysname,
    which = which,
    system2 = system2
  ))
  if (use_flang) {
    flang_info <- quickr_flang_available(which = which, system2 = system2)
    flang <- flang_info$path
    if (!isTRUE(flang_info$available)) {
      if (isTRUE(explicit_request)) {
        stop(
          "quickr was configured to use flang, but flang was not available or could not be executed.\n",
          "Ensure flang is on your PATH and that `flang --version` succeeds, or switch compilers with:\n",
          "  options(quickr.fortran_compiler = \"gfortran\")\n"
        )
      }
      use_flang <- FALSE
      flang <- ""
    }
  }
  if (use_openmp && use_flang && !isTRUE(explicit_request)) {
    use_flang <- FALSE
    flang <- ""
  }
  if (use_flang) {
    flang_runtime <- if (sysname == "Darwin") {
      quickr_flang_runtime_flags(flang = flang, sysname = sysname)
    } else {
      character()
    }
    if (sysname == "Darwin" && !length(flang_runtime)) {
      if (isTRUE(explicit_request)) {
        stop(
          "quickr was configured to use flang (",
          flang,
          ") but could not locate the flang runtime library (libflang_rt.runtime.dylib) to link against.\n",
          "Either reinstall flang so the runtime is available, or switch compilers with:\n",
          "  options(quickr.fortran_compiler = \"gfortran\")\n"
        )
      }
      use_flang <- FALSE
      flang_runtime <- character()
    }
  }

  default_makevars_lines <- if (use_flang) {
    character()
  } else {
    quickr_default_fortran_makevars_lines(config_value = config_value)
  }

  if (!use_flang && !use_openmp && !length(default_makevars_lines)) {
    return(character())
  }

  makevars_path <- file.path(build_dir, "Makevars.quickr")
  makevars_lines <- c(
    if (use_flang) {
      c(
        sprintf("FC=%s", flang),
        sprintf("F77=%s", flang),
        if (length(flang_runtime)) {
          paste(c("FLIBS +=", flang_runtime), collapse = " ")
        }
      )
    },
    default_makevars_lines,
    if (use_openmp) openmp_makevars_lines(),
    if (length(link_flags)) {
      paste("PKG_LIBS +=", paste(link_flags, collapse = " "))
    }
  )
  write_lines(
    makevars_lines,
    makevars_path
  )
  sprintf("R_MAKEVARS_USER=%s", makevars_path)
}

# Unit tests for compiler selection helpers

skip_on_cran()

test_that("quickr_r_cmd_config_value captures only stdout", {
  expect_identical(
    deparse(formals(quickr:::quickr_r_cmd_config_value)$system2),
    "base::system2"
  )

  observed_stdout <- NULL
  observed_stderr <- NULL
  system2_stub <- function(
    command,
    args,
    stdout = "",
    stderr = "",
    ...
  ) {
    observed_stdout <<- stdout
    observed_stderr <<- stderr
    " value "
  }

  expect_identical(
    quickr:::quickr_r_cmd_config_value(
      "CC",
      r_cmd = "R",
      system2 = system2_stub
    ),
    "value"
  )
  expect_identical(observed_stdout, TRUE)
  expect_identical(observed_stderr, FALSE)
})

test_that("quickr_r_cmd_config_value returns empty on command failure", {
  system2_stub <- function(command, args, stdout = "", stderr = "", ...) {
    structure(" value ", status = 1L)
  }

  expect_identical(
    quickr:::quickr_r_cmd_config_value(
      "CC",
      r_cmd = "R",
      system2 = system2_stub
    ),
    ""
  )
})

test_that("quickr_flang_path and quickr_prefer_flang are deterministic with stubs", {
  which <- function(x) {
    if (x == "flang-new") {
      "/tmp/flang-new"
    } else if (x == "flang") {
      "/tmp/flang"
    } else {
      ""
    }
  }
  system2_stub <- function(command, args, stdout = TRUE, stderr = TRUE, ...) {
    "flang version"
  }

  expect_identical(quickr:::quickr_flang_path(which = which), "/tmp/flang-new")

  withr::local_options(quickr.fortran_compiler = "auto")

  expect_true(quickr:::quickr_prefer_flang(
    sysname = "Darwin",
    which = which,
    system2 = system2_stub
  ))
  expect_false(quickr:::quickr_prefer_flang(sysname = "Linux", which = which))
})

test_that("quickr_prefer_flang respects quickr.fortran_compiler", {
  withr::local_options(quickr.fortran_compiler = "flang")
  expect_true(quickr:::quickr_prefer_flang(sysname = "Linux"))

  withr::local_options(quickr.fortran_compiler = "gfortran")
  expect_false(quickr:::quickr_prefer_flang(sysname = "Darwin"))
})

test_that("quickr_default_fortran_makevars_lines relaxes gfortran cost model", {
  expect_equal(
    quickr:::quickr_default_fortran_makevars_lines(
      config_value = function(name) {
        if (identical(name, "FC")) "gfortran -m64" else ""
      }
    ),
    "PKG_FFLAGS += -fvect-cost-model=cheap"
  )

  expect_equal(
    quickr:::quickr_default_fortran_makevars_lines(
      config_value = function(name) {
        if (identical(name, "FC")) "/usr/bin/gfortran-13" else ""
      }
    ),
    "PKG_FFLAGS += -fvect-cost-model=cheap"
  )

  expect_identical(
    quickr:::quickr_default_fortran_makevars_lines(
      config_value = function(name) {
        if (identical(name, "FC")) "flang-new" else ""
      }
    ),
    character()
  )
})

test_that("quickr_fortran_compiler_option validates values", {
  withr::local_options(quickr.fortran_compiler = "auto")
  expect_null(quickr:::quickr_fortran_compiler_option())

  withr::local_options(quickr.fortran_compiler = "flang")
  expect_identical(quickr:::quickr_fortran_compiler_option(), "flang")

  withr::local_options(quickr.fortran_compiler = "gfortran")
  expect_identical(quickr:::quickr_fortran_compiler_option(), "gfortran")

  withr::local_options(quickr.fortran_compiler = "nope")
  expect_error(
    quickr:::quickr_fortran_compiler_option(),
    "options(quickr.fortran_compiler)",
    fixed = TRUE
  )
})

test_that("quickr_fcompiler_env writes Makevars when flang is usable", {
  temp <- withr::local_tempdir()
  prefix <- file.path(temp, "flang")
  dir.create(file.path(prefix, "bin"), recursive = TRUE)
  dir.create(file.path(prefix, "lib"), recursive = TRUE)

  flang <- file.path(prefix, "bin", "flang-new")
  file.create(flang)
  file.create(file.path(prefix, "lib", "libflang_rt.runtime.dylib"))

  which <- function(x) if (x == "flang-new") flang else ""

  cache_env <- environment(quickr:::quickr_flang_runtime_flags)
  old_cache <- cache_env$cache
  cache_env$cache <- NULL
  on.exit(cache_env$cache <- old_cache, add = TRUE)

  build_dir <- file.path(temp, "build")
  dir.create(build_dir)

  withr::local_options(quickr.fortran_compiler = "flang")
  env <- quickr:::quickr_fcompiler_env(
    build_dir = build_dir,
    which = which,
    system2 = function(...) "",
    sysname = "Darwin"
  )
  expect_true(startsWith(env, "R_MAKEVARS_USER="))
  expect_true(file.exists(sub("R_MAKEVARS_USER=", "", env, fixed = TRUE)))
})

test_that("quickr_fcompiler_env writes Makevars for default gfortran flags", {
  build_dir <- withr::local_tempdir()

  withr::local_options(quickr.fortran_compiler = "gfortran")
  env <- quickr:::quickr_fcompiler_env(
    build_dir = build_dir,
    which = function(cmd) "",
    system2 = function(...) "",
    sysname = "Linux",
    config_value = function(name) {
      if (identical(name, "FC")) "gfortran -m64" else ""
    }
  )

  expect_true(startsWith(env, "R_MAKEVARS_USER="))
  makevars_path <- sub("^R_MAKEVARS_USER=", "", env)
  expect_equal(
    readLines(makevars_path),
    "PKG_FFLAGS += -fvect-cost-model=cheap"
  )
})

test_that("quickr_fcompiler_env errors when flang is explicitly requested but unavailable", {
  build_dir <- withr::local_tempdir()

  withr::local_options(quickr.fortran_compiler = "flang")
  expect_error(
    quickr:::quickr_fcompiler_env(
      build_dir = build_dir,
      which = function(cmd) "",
      system2 = function(...) structure("", status = 1L)
    ),
    "configured to use flang",
    fixed = TRUE
  )
})

test_that("quickr_flang_available returns unavailable when system2 fails", {
  which_stub <- function(x) if (x == "flang-new") "/tmp/flang-new" else ""
  system2_fail <- function(...) structure("error", status = 1L)

  result <- quickr:::quickr_flang_available(
    which = which_stub,
    system2 = system2_fail
  )
  expect_identical(result$path, "/tmp/flang-new")
  expect_false(result$available)
})

test_that("quickr_disable_flang_auto sets auto_disabled flag", {
  state <- new.env(parent = emptyenv())
  state$auto_disabled <- FALSE
  state$fallback_warned <- FALSE

  result <- quickr:::quickr_disable_flang_auto(state = state)
  expect_true(result)
  expect_true(state$auto_disabled)
})

test_that("quickr_warn_flang_fallback_once warns only once", {
  state <- new.env(parent = emptyenv())
  state$fallback_warned <- FALSE

  expect_warning(
    quickr:::quickr_warn_flang_fallback_once(state = state),
    "flang compilation failed"
  )
  expect_true(state$fallback_warned)

  # Second call should not warn
  expect_silent(quickr:::quickr_warn_flang_fallback_once(state = state))
})

test_that("quickr_warn_compiler_failure_once warns only once", {
  state <- new.env(parent = emptyenv())
  state$warned <- FALSE

  expect_warning(
    quickr:::quickr_warn_compiler_failure_once("test error", state = state),
    "test error"
  )
  expect_true(state$warned)

  # Second call should not warn
  expect_silent(quickr:::quickr_warn_compiler_failure_once(
    "test error 2",
    state = state
  ))
})

test_that("quickr_flang_runtime_flags returns empty for non-Darwin", {
  result <- quickr:::quickr_flang_runtime_flags(
    "/usr/bin/flang",
    sysname = "Linux"
  )
  expect_identical(result, character())
})

test_that("quickr_flang_runtime_flags returns empty for empty flang path", {
  result <- quickr:::quickr_flang_runtime_flags("", sysname = "Darwin")
  expect_identical(result, character())
})

test_that("quickr_flang_runtime_flags returns empty when flang does not exist", {
  # Clear cache
  cache_env <- environment(quickr:::quickr_flang_runtime_flags)
  old_cache <- cache_env$cache
  cache_env$cache <- NULL
  on.exit(cache_env$cache <- old_cache, add = TRUE)

  result <- quickr:::quickr_flang_runtime_flags(
    "/nonexistent/path/to/flang",
    sysname = "Darwin"
  )
  expect_identical(result, character())
})

test_that("quickr_flang_runtime_flags returns empty when runtime lib not found", {
  temp <- withr::local_tempdir()
  flang <- file.path(temp, "bin", "flang-new")
  dir.create(dirname(flang), recursive = TRUE)
  file.create(flang)
  # Create lib dir but no runtime lib
  dir.create(file.path(temp, "lib"))

  # Clear cache
  cache_env <- environment(quickr:::quickr_flang_runtime_flags)
  old_cache <- cache_env$cache
  cache_env$cache <- NULL
  on.exit(cache_env$cache <- old_cache, add = TRUE)

  result <- quickr:::quickr_flang_runtime_flags(flang, sysname = "Darwin")
  expect_identical(result, character())
})

test_that("quickr_fortran_compiler_option errors for non-string", {
  withr::local_options(quickr.fortran_compiler = 123)
  expect_error(
    quickr:::quickr_fortran_compiler_option(),
    "must be a single string"
  )
})

test_that("quickr_prefer_flang returns FALSE when flang_auto_disabled", {
  state <- new.env(parent = emptyenv())
  state$auto_disabled <- TRUE
  state$fallback_warned <- FALSE

  withr::local_options(quickr.fortran_compiler = "auto")

  # Inject the state
  local_mocked_bindings(
    quickr_flang_auto_disabled = function(...) TRUE,
    .package = "quickr"
  )

  expect_false(quickr:::quickr_prefer_flang(sysname = "Darwin"))
})

test_that("quickr_fcompiler_env handles flang unavailable for non-explicit request", {
  build_dir <- withr::local_tempdir()

  withr::local_options(quickr.fortran_compiler = "auto")

  # Mock flang as preferred but unavailable
  local_mocked_bindings(
    quickr_prefer_flang = function(...) TRUE,
    quickr_flang_available = function(...) {
      list(path = "/tmp/flang", available = FALSE)
    },
    .package = "quickr"
  )

  # Should return character() since not explicit and flang unavailable
  result <- quickr:::quickr_fcompiler_env(
    build_dir = build_dir,
    which = function(x) "",
    system2 = function(...) "",
    sysname = "Darwin",
    config_value = function(name) if (identical(name, "FC")) "clang" else ""
  )
  expect_identical(result, character())
})

test_that("quickr_fcompiler_env errors when flang runtime not found on Darwin explicit", {
  temp <- withr::local_tempdir()
  flang <- file.path(temp, "bin", "flang-new")
  dir.create(dirname(flang), recursive = TRUE)
  file.create(flang)

  # Clear cache
  cache_env <- environment(quickr:::quickr_flang_runtime_flags)
  old_cache <- cache_env$cache
  cache_env$cache <- NULL
  on.exit(cache_env$cache <- old_cache, add = TRUE)

  build_dir <- file.path(temp, "build")
  dir.create(build_dir)

  withr::local_options(quickr.fortran_compiler = "flang")

  expect_error(
    quickr:::quickr_fcompiler_env(
      build_dir = build_dir,
      which = function(x) if (x == "flang-new") flang else "",
      system2 = function(...) "",
      sysname = "Darwin"
    ),
    "could not locate the flang runtime library"
  )
})

test_that("quickr_fcompiler_env falls back when flang runtime not found non-explicit", {
  temp <- withr::local_tempdir()
  flang <- file.path(temp, "bin", "flang-new")
  dir.create(dirname(flang), recursive = TRUE)
  file.create(flang)
  dir.create(file.path(temp, "lib"))

  # Clear cache
  cache_env <- environment(quickr:::quickr_flang_runtime_flags)
  old_cache <- cache_env$cache
  cache_env$cache <- NULL
  on.exit(cache_env$cache <- old_cache, add = TRUE)

  build_dir <- file.path(temp, "build")
  dir.create(build_dir)

  withr::local_options(quickr.fortran_compiler = "auto")

  result <- quickr:::quickr_fcompiler_env(
    build_dir = build_dir,
    which = function(x) if (x == "flang-new") flang else "",
    system2 = function(...) "",
    sysname = "Darwin",
    config_value = function(name) if (identical(name, "FC")) "clang" else ""
  )
  # Should fall back to character() since runtime not found and not explicit
  expect_identical(result, character())
})

test_that("compile cleans existing build directories and reports failures", {
  fsub <- r2f(function(x) {
    declare(type(x = double(1)))
    x + 1
  })

  build_dir <- withr::local_tempdir()
  file.create(file.path(build_dir, "stale.txt"))

  calls <- 0L
  system2_stub <- function(
    command,
    args,
    stdout = TRUE,
    stderr = TRUE,
    env = character(),
    ...
  ) {
    if (
      length(args) >= 3L &&
        identical(args[[1L]], "CMD") &&
        identical(args[[2L]], "config")
    ) {
      return("")
    }
    calls <<- calls + 1L
    if (calls == 1L) {
      return(structure("flang fail", status = 1))
    }
    structure("fallback fail", status = 2)
  }

  local_mocked_bindings(
    system2 = system2_stub,
    .package = "base"
  )
  local_mocked_bindings(
    quickr_fcompiler_env = function(...) "ENV=1",
    .package = "quickr"
  )

  expect_error(
    suppressWarnings(quickr:::compile(fsub, build_dir = build_dir)),
    "Compilation Error",
    fixed = TRUE
  )
  expect_true(dir.exists(build_dir))
  expect_false(file.exists(file.path(build_dir, "stale.txt")))
})

skip_on_cran()

test_that("quickr_fcompiler_env prefers flang-new when requested", {
  which <- function(cmd) {
    if (identical(cmd, "flang-new")) {
      return("/opt/bin/flang-new")
    }
    ""
  }

  withr::local_options(quickr.fortran_compiler = "flang")

  build_dir <- tempfile("quickr-build-")
  dir.create(build_dir)
  env <- quickr:::quickr_fcompiler_env(
    build_dir,
    system2 = function(...) "",
    which = which,
    sysname = "Linux"
  )

  expect_true(startsWith(env, "R_MAKEVARS_USER="))
  makevars_path <- sub("^R_MAKEVARS_USER=", "", env)
  expect_true(file.exists(makevars_path))
  expect_equal(
    readLines(makevars_path),
    c("FC=/opt/bin/flang-new", "F77=/opt/bin/flang-new")
  )
})

test_that("quickr_fcompiler_env falls back to flang when flang-new missing", {
  which <- function(cmd) {
    if (identical(cmd, "flang")) {
      return("/opt/bin/flang")
    }
    ""
  }

  withr::local_options(quickr.fortran_compiler = "flang")

  build_dir <- tempfile("quickr-build-")
  dir.create(build_dir)
  env <- quickr:::quickr_fcompiler_env(
    build_dir,
    system2 = function(...) "",
    which = which,
    sysname = "Linux"
  )

  expect_true(startsWith(env, "R_MAKEVARS_USER="))
  makevars_path <- sub("^R_MAKEVARS_USER=", "", env)
  expect_true(file.exists(makevars_path))
  expect_equal(
    readLines(makevars_path),
    c("FC=/opt/bin/flang", "F77=/opt/bin/flang")
  )
})

test_that("quickr_fcompiler_env returns empty when disabled or unavailable", {
  which <- function(cmd) ""
  build_dir <- tempfile("quickr-build-")
  dir.create(build_dir)

  withr::local_options(quickr.fortran_compiler = "gfortran")
  expect_equal(
    quickr:::quickr_fcompiler_env(
      build_dir,
      which = which,
      config_value = function(name) if (identical(name, "FC")) "clang" else ""
    ),
    character()
  )

  withr::local_options(quickr.fortran_compiler = "auto")
  expect_equal(
    quickr:::quickr_fcompiler_env(
      build_dir,
      which = which,
      config_value = function(name) if (identical(name, "FC")) "clang" else ""
    ),
    character()
  )
})

test_that("quickr_prefer_flang defaults to TRUE on macOS when flang exists", {
  which <- function(cmd) {
    if (identical(cmd, "flang-new")) {
      return("/opt/bin/flang-new")
    }
    ""
  }

  withr::local_options(quickr.fortran_compiler = "auto")

  expect_true(quickr:::quickr_prefer_flang(
    sysname = "Darwin",
    which = which,
    system2 = function(...) ""
  ))
  expect_false(quickr:::quickr_prefer_flang(sysname = "Linux", which = which))
})

test_that("quickr.fortran_compiler = \"gfortran\" disables auto preference", {
  which <- function(cmd) {
    if (identical(cmd, "flang-new")) {
      return("/opt/bin/flang-new")
    }
    ""
  }

  withr::local_options(quickr.fortran_compiler = "gfortran")

  expect_false(quickr:::quickr_prefer_flang(sysname = "Darwin", which = which))
})

# r2f-rev.R
# Handler for rev()

r2f_handlers[["rev"]] <- function(args, scope, ..., hoist = NULL) {
  stopifnot(length(args) == 1L)

  x <- r2f(args[[1L]], scope, ..., hoist = hoist)
  if (is.null(x@value)) {
    stop("rev() expects a typed value", call. = FALSE)
  }

  # Scalars (incl. length-1 vectors that are lowered as scalars) reverse to self.
  if (passes_as_scalar(x@value)) {
    # For bind(c) logical scalars, the default symbol lowering booleanizes the
    # argument as `(m/=0)`, which would both lose NA_LOGICAL and force a
    # nonstandard logical->integer assignment into the integer-backed return.
    # Preserve the underlying integer storage when available.
    if (identical(x@value@mode, "logical") && logical_as_int(x@value)) {
      base_name <- x@value@name
      if (!is.null(base_name)) {
        return(Fortran(base_name, x@value))
      }
    }
    return(x)
  }

  if (x@value@rank != 1L) {
    stop("rev() only supports rank 0-1 inputs", call. = FALSE)
  }

  # Fortran array sections require an array designator; hoist array expressions.
  if (is.null(x@value@name)) {
    tmp <- hoist$declare_tmp(
      mode = x@value@mode,
      dims = x@value@dims,
      logical_as_int = logical_as_int(x@value)
    )
    hoist$emit(glue("{tmp@name} = {x}"))
    x <- Fortran(tmp@name, tmp)
  }

  base_name <- x@value@name %||%
    stop("missing array name for rev()", call. = FALSE)

  # External logical args are stored as integer(0/1) and symbol-lowered as `(x/=0)`.
  # Reverse the underlying storage (including NA_LOGICAL sentinel values).
  #
  # Note: this returns integer storage (0/1/NA) for bind(c) logicals, which
  # preserves NA when the reversed value is returned back to R.
  if (identical(x@value@mode, "logical") && logical_as_int(x@value)) {
    out_val <- Variable("logical", x@value@dims)
    out_val@logical_as_int <- TRUE
    return(Fortran(
      glue("{base_name}(size({base_name}):1:-1)"),
      out_val
    ))
  }

  out_val <- Variable(x@value@mode, x@value@dims)
  Fortran(glue("{base_name}(size({base_name}):1:-1)"), out_val)
}

# Matrix parsing helpers

# Unwrap t() calls to infer transpose flags and normalize scalars/vectors.
unwrap_transpose_arg <- function(arg, scope, ..., hoist) {
  arg_unwrapped <- unwrap_parens(arg)
  if (is_call(arg_unwrapped, quote(t)) && length(arg_unwrapped) == 2L) {
    inner_arg <- unwrap_parens(arg_unwrapped[[2L]])
    inner <- r2f(inner_arg, scope, ..., hoist = hoist)
    inner <- maybe_cast_double(inner)
    if (inner@value@rank == 2L) {
      return(list(value = inner, trans = "T"))
    } else if (inner@value@rank == 1L) {
      len <- inner@value@dims[[1L]]
      val <- Variable("double", list(1L, len))
      return(list(
        value = Fortran(glue("reshape({inner}, [1, int({len})])"), val),
        trans = "N"
      ))
    } else if (inner@value@rank == 0L) {
      return(list(value = inner, trans = "N"))
    } else {
      stop("t() only supports rank 0-2 inputs")
    }
  }
  value <- r2f(arg, scope, ..., hoist = hoist)
  value <- maybe_cast_double(value)
  list(value = value, trans = "N")
}

# Extract a logical argument or use the provided default.
logical_arg_or_default <- function(args, name, default, context) {
  val <- args[[name]] %||% default
  if (is.null(val)) {
    return(default)
  }
  if (!is.logical(val) || length(val) != 1L || is.na(val)) {
    stop(context, " only supports literal ", name, " = TRUE/FALSE")
  }
  val
}

# r2f-sequences.R
# Handlers for sequence generation: :, seq, seq_len, seq_along

# --- Handlers ---

r2f_handlers[[":"]] <- function(args, scope, ...) {
  seq_like_r2f(":", args, scope, ...)
}


r2f_handlers[["seq"]] <- function(args, scope, ...) {
  seq_like_r2f("seq", args, scope, ...)
}

r2f_handlers[["seq_len"]] <- function(args, scope, ...) {
  seq_like_r2f("seq_len", args, scope, ...)
}

r2f_handlers[["seq_along"]] <- function(args, scope, ...) {
  seq_like_r2f("seq_along", args, scope, ...)
}

# r2f-constructors.R
# Handlers for value constructors: c, logical, integer, double, numeric,
# character, raw, matrix, array

# --- Handlers ---

r2f_handlers[["c"]] <- function(args, scope = NULL, ...) {
  ff <- lapply(args, r2f, scope, ...)
  s <- glue("[ {str_flatten_commas(ff)} ]")
  lens <- lapply(ff[order(map_int(ff, \(f) f@value@rank))], function(e) {
    rank <- e@value@rank
    if (rank == 0) {
      1L
    } else if (rank == 1) {
      e@value@dims[[1]]
    } else {
      stop("all args passed to c() must be scalars or 1-d arrays")
    }
  })
  mode <- reduce_promoted_mode(ff)
  len <- Reduce(
    \(l1, l2) {
      if (is_scalar_na(l1) || is_scalar_na(l2)) {
        NA
      } else if (is_wholenumber(l1) && is_wholenumber(l2)) {
        l1 + l2
      } else {
        call("+", l1, l2)
      }
    },
    lens
  )
  Fortran(s, Variable(mode, list(len)))
}


r2f_handlers[["rep.int"]] <- function(args, scope, ..., hoist = NULL) {
  # This handler exists to support `x[rep.int(i, n)]` style subscripting. A
  # general rep.int() translation would need to preserve x's type/shape; until
  # implemented, fail fast outside `[` context to avoid silent semantic changes.
  context <- r2f_iterable_context(list(...)$calls)
  if (!identical(context, "[")) {
    stop(
      "rep.int() is only supported when used as an index inside `x[...]`",
      call. = FALSE
    )
  }

  # Only support the common scalar form used in indexing: rep.int(scalar, times).
  x_arg <- args$x %||% args[[1L]]
  times_arg <- args$times %||% args[[2L]]

  if (is_missing(x_arg) || is_missing(times_arg) || length(args) != 2L) {
    stop(
      "rep.int() only supports `rep.int(x, times)` with 2 arguments",
      call. = FALSE
    )
  }

  x_arg <- whole_doubles_to_ints(x_arg)
  times_arg <- whole_doubles_to_ints(times_arg)

  x <- r2f(x_arg, scope, ..., hoist = hoist)
  times <- r2f(times_arg, scope, ..., hoist = hoist)

  if (is.null(x@value) || is.null(times@value)) {
    stop(
      "rep.int() only supports scalar integer arguments in indexing (x and times must not be NULL)",
      call. = FALSE
    )
  }

  if (x@value@mode == "double") {
    x <- Fortran(
      glue("int({x}, kind=c_int)"),
      Variable("integer", x@value@dims)
    )
  }
  if (times@value@mode == "double") {
    times <- Fortran(
      glue("int({times}, kind=c_int)"),
      Variable("integer", times@value@dims)
    )
  }

  if (x@value@mode != "integer" || !passes_as_scalar(x@value)) {
    stop("rep.int() expects an integer scalar `x`", call. = FALSE)
  }
  if (times@value@mode != "integer" || !passes_as_scalar(times@value)) {
    stop("rep.int() expects an integer scalar `times`", call. = FALSE)
  }

  len_expr <- r2size(times_arg, scope)
  if (is.null(len_expr) || is_scalar_na(len_expr)) {
    len_expr <- NA_integer_
  }

  i <- scope_unique_var(scope, "integer")
  out_val <- Variable("integer", list(len_expr))
  Fortran(glue("[({x}, {i}=1, int({times}, kind=c_int))]"), out_val)
}


register_r2f_handler(
  "logical",
  function(args, scope, ...) {
    Fortran(".false.", Variable(mode = "logical", dims = r2dims(args, scope)))
  },
  match_fun = FALSE
)

register_r2f_handler(
  "integer",
  function(args, scope, ...) {
    Fortran("0", Variable(mode = "integer", dims = r2dims(args, scope)))
  },
  match_fun = FALSE
)

register_r2f_handler(
  c("double", "numeric"),
  function(args, scope, ...) {
    Fortran("0", Variable(mode = "double", dims = r2dims(args, scope)))
  },
  match_fun = FALSE
)


r2f_handlers[["character"]] <- r2f_handlers[["raw"]] <-
  .r2f_handler_not_implemented_yet


r2f_handlers[["matrix"]] <- function(args, scope = NULL, ..., hoist = NULL) {
  args$data %||% stop("matrix(data=) must be provided, cannot be NA")
  if (!is.null(args$byrow) && !is_missing(args$byrow) && !isFALSE(args$byrow)) {
    stop("matrix(byrow=TRUE) is not supported", call. = FALSE)
  }

  # Require explicit dims for now. (R can infer one dimension, but quickr's
  # lowering keeps this strict to avoid surprising recycling rules.)
  if (is.null(args$nrow) || is_missing(args$nrow)) {
    stop("matrix(nrow=) must be provided", call. = FALSE)
  }
  if (is.null(args$ncol) || is_missing(args$ncol)) {
    stop("matrix(ncol=) must be provided", call. = FALSE)
  }

  src <- r2f(args$data, scope, ..., hoist = hoist)
  dims <- r2dims(list(args$nrow, args$ncol), scope)
  out_val <- Variable(mode = src@value@mode, dims = dims)

  # Scalars can be broadcast into an array on assignment, so keep them as-is.
  if (passes_as_scalar(src@value)) {
    src@value <- out_val
    return(src)
  }

  rows <- dims[[1L]]
  cols <- dims[[2L]]
  source <- glue("{src}")

  # Avoid double-evaluating non-trivial expressions when used in both the
  # `source` and `pad` args. In Fortran, intrinsic actual args are evaluated
  # before the call, so repeating the expression can duplicate side effects
  # (e.g. RNG state via runif()).
  if (
    is.null(src@value@name) ||
      !identical(trimws(source), src@value@name)
  ) {
    tmp <- hoist$declare_tmp(
      mode = src@value@mode,
      dims = src@value@dims,
      logical_as_int = logical_as_int(src@value)
    )
    hoist$emit(glue("{tmp@name} = {src}"))
    source <- tmp@name
  }
  Fortran(
    glue(
      "reshape({source}, [{bind_dim_int(rows)}, {bind_dim_int(cols)}], pad = {source})"
    ),
    out_val
  )
}

r2f_handlers[["array"]] <- function(args, scope = NULL, ..., hoist = NULL) {
  args$data %||% stop("array(data=) must be provided, cannot be NA")
  if (is.null(args$dim)) {
    stop("array(dim=) must be provided, cannot be NA")
  }
  if (!is.null(args$dimnames)) {
    stop("array(dimnames=) not supported")
  }

  dim_to_dims <- function(dim_arg) {
    if (
      is.atomic(dim_arg) &&
        typeof(dim_arg) %in% c("integer", "double")
    ) {
      if (!length(dim_arg) || anyNA(dim_arg)) {
        stop(
          "array(dim=) must be non-empty and must not contain NA",
          call. = FALSE
        )
      }
      dim_arg <- vapply(
        dim_arg,
        function(x) {
          if (!is_wholenumber(x)) {
            stop(
              "array(dim=) must be whole numbers, found: ",
              x,
              call. = FALSE
            )
          }
          as.integer(x)
        },
        integer(1L)
      )
      return(as.list(dim_arg))
    }

    if (is.call(dim_arg) && is.symbol(dim_arg[[1L]])) {
      op <- as.character(dim_arg[[1L]])
      if (op == ":") {
        if (length(dim_arg) != 3L) {
          stop("bad dim sequence", call. = FALSE)
        }
        from <- dim_arg[[2L]]
        to <- dim_arg[[3L]]
        if (
          !(is.atomic(from) && length(from) == 1L && is_wholenumber(from)) ||
            !(is.atomic(to) && length(to) == 1L && is_wholenumber(to))
        ) {
          stop(
            "array(dim=) only supports literal sequences like 2:4",
            call. = FALSE
          )
        }
        return(as.list(seq.int(as.integer(from), as.integer(to))))
      }
    }

    if (is.symbol(dim_arg)) {
      var <- get0(as.character(dim_arg), scope)
      if (
        inherits(var, Variable) &&
          var@mode %in% c("integer", "double") &&
          var@rank == 1L &&
          (is.language(var@r) || is.atomic(var@r)) &&
          !identical(var@r, dim_arg)
      ) {
        return(dim_to_dims(var@r))
      }
    }

    r2dims(dim_arg, scope)
  }

  out <- r2f(args$data, scope, ..., hoist = hoist)
  target_dims <- dim_to_dims(args$dim)
  if (!length(target_dims)) {
    stop("array(dim=) must not be empty", call. = FALSE)
  }
  if (!passes_as_scalar(out@value)) {
    # R semantics: `array()` flattens its input (dropping dim) then reshapes.
    # We implement this as Fortran `reshape()`. Recycling (i.e. expanding a
    # shorter SOURCE to a larger target shape) is not supported.
    dims_f <- dims2f(target_dims, scope)
    scalar_target <- !nzchar(dims_f) && length(target_dims) == 1L
    if (scalar_target) {
      # `dim = 1` is scalar-like in quickr (rank-1 length-1 is declared scalar).
      # Avoid `reshape(..., [1])` (rank-1) and instead return the first element.
      if (is.null(hoist)) {
        stop("internal error: array() requires hoist context", call. = FALSE)
      }
      target_dims <- list(1L)
      tmp <- hoist$declare_tmp(mode = out@value@mode, dims = out@value@dims)
      hoist$emit(glue("{tmp@name} = {out}"))
      idxs <- rep("1", out@value@rank)
      out <- Fortran(
        glue("{tmp@name}({str_flatten_commas(idxs)})"),
        Variable(mode = out@value@mode, dims = list(1L))
      )
    } else {
      if (!nzchar(dims_f)) {
        dims_f <- "1"
      }
      if (grepl(":", dims_f, fixed = TRUE)) {
        stop("array(dim=) must be known", call. = FALSE)
      }
      shape <- glue("int([{dims_f}])")

      data_r <- args$data
      is_fill_constructor <-
        is.call(data_r) &&
        is.symbol(data_r[[1L]]) &&
        as.character(data_r[[1L]]) %in%
          c(
            "logical",
            "integer",
            "double",
            "numeric"
          )

      axis_terms <- vapply(
        target_dims,
        function(d) {
          axis <- dims2f(list(d), scope)
          if (!nzchar(axis)) {
            "1"
          } else {
            axis
          }
        },
        character(1L)
      )
      n_expr <- if (length(axis_terms) == 1L) {
        axis_terms[[1L]]
      } else {
        paste0("(", paste0("(", axis_terms, ")", collapse = " * "), ")")
      }

      known_prod <- function(dims) {
        if (is.null(dims) || !length(dims)) {
          return(1)
        }
        vals <- vapply(
          dims,
          function(d) {
            if (
              is.atomic(d) &&
                length(d) == 1L &&
                !is.na(d) &&
                is_wholenumber(d)
            ) {
              as.double(d)
            } else {
              NA_real_
            }
          },
          double(1L)
        )
        if (anyNA(vals)) {
          return(NA_real_)
        }
        prod(vals)
      }

      source <- if (is_fill_constructor) {
        i <- scope_unique_var(scope, "integer")
        glue("[({out}, {i}=1, int({n_expr}))]")
      } else {
        n_target <- known_prod(target_dims)
        n_source <- known_prod(out@value@dims)
        if (!is.na(n_target) && !is.na(n_source) && n_target > n_source) {
          stop(
            "array() reshape does not support recycling: prod(dim)=",
            n_target,
            " > length(data)=",
            n_source,
            call. = FALSE
          )
        }
        if (!is.null(hoist)) {
          mark_scope_uses_errors(scope)
          err <- quickr_error_fortran_lines(
            "array() reshape does not support recycling (data shorter than prod(dim))",
            scope = scope
          )
          hoist$emit(glue("if (int({n_expr}) > size({out})) then"))
          hoist$emit(paste0("  ", err))
          hoist$emit("end if")
        }

        # RESHAPE() requires `SOURCE` to be an array expression; array constructors
        # flatten array-valued expressions (which matches R's array() semantics).
        glue("[{out}]")
      }

      out <- Fortran(glue("reshape({source}, {shape})"), out@value)
    }
  }

  out@value <- Variable(
    mode = out@value@mode,
    dims = target_dims
  )
  out
}

# r2f-arithmetic.R
# Handlers for arithmetic operators: +, -, *, /, ^, %%, %/%

# --- Handlers ---

r2f_handlers[["+"]] <- function(args, scope, ...) {
  # Support both binary and unary plus
  if (length(args) == 1L) {
    x <- r2f(args[[1L]], scope, ...)
    Fortran(glue("(+{x})"), Variable(x@value@mode, x@value@dims))
  } else {
    .[left, right] <- lapply(args, r2f, scope, ...)
    reshaped <- maybe_reshape_vector_matrix(left, right)
    left <- reshaped$left
    right <- reshaped$right
    Fortran(glue("({left} + {right})"), conform(left@value, right@value))
  }
}

r2f_handlers[["-"]] <- function(args, scope, ...) {
  # Support both binary and unary minus
  if (length(args) == 1L) {
    x <- r2f(args[[1L]], scope, ...)
    Fortran(glue("(-{x})"), Variable(x@value@mode, x@value@dims))
  } else {
    .[left, right] <- lapply(args, r2f, scope, ...)
    reshaped <- maybe_reshape_vector_matrix(left, right)
    left <- reshaped$left
    right <- reshaped$right
    Fortran(glue("({left} - {right})"), conform(left@value, right@value))
  }
}

r2f_handlers[["*"]] <- function(args, scope = NULL, ...) {
  .[left, right] <- lapply(args, r2f, scope, ...)
  reshaped <- maybe_reshape_vector_matrix(left, right)
  left <- reshaped$left
  right <- reshaped$right
  Fortran(glue("({left} * {right})"), conform(left@value, right@value))
}

r2f_handlers[["/"]] <- function(args, scope = NULL, ...) {
  .[left, right] <- lapply(args, r2f, scope, ...)
  left <- maybe_cast_double(left)
  right <- maybe_cast_double(right)
  reshaped <- maybe_reshape_vector_matrix(left, right)
  left <- reshaped$left
  right <- reshaped$right
  Fortran(glue("({left} / {right})"), conform(left@value, right@value))
}

r2f_handlers[["^"]] <- function(args, scope, ...) {
  .[left, right] <- lapply(args, r2f, scope, ...)
  reshaped <- maybe_reshape_vector_matrix(left, right)
  left <- reshaped$left
  right <- reshaped$right
  Fortran(glue("({left} ** {right})"), conform(left@value, right@value))
}


# ---- remainder (%%) and integer division (%/%) ----
#
# R semantics:
#   x %%  y  ==  r   where  r has the sign of y  (divisor)
#   x %/% y  ==  q   where  q = floor(x / y)
# and  x == r + y * q  (within rounding error)
#
# Fortran intrinsics:
#   - MODULO(a,p)   : remainder with sign(p)
#   - FLOOR(x)      : greatest integer <= x      (real)
#   - AINT(x)       : truncation toward 0       (real)

r2f_handlers[["%%"]] <- function(args, scope, ...) {
  .[left, right] <- lapply(args, r2f, scope, ...)
  out_val <- conform(left@value, right@value)
  # MODULO gives result with sign(right) - matches R %% behaviour
  Fortran(glue("modulo({left}, {right})"), out_val)
}

r2f_handlers[["%/%"]] <- function(args, scope, ...) {
  .[left, right] <- lapply(args, r2f, scope, ...)
  out_val <- conform(left@value, right@value)

  expr <- switch(
    out_val@mode,
    integer = glue("int(floor(real({left}) / real({right})))"),
    double = glue("floor({left} / {right})"),
    stop("%/% only implemented for numeric types")
  )

  Fortran(expr, out_val)
}

# Local closures + higher-order lowering helpers

maybe_lower_local_closure_call <- function(
  e,
  scope,
  ...,
  hoist,
  needs_value
) {
  stopifnot(
    is.call(e),
    inherits(scope, "quickr_scope"),
    inherits(hoist, "environment"),
    is_bool(needs_value)
  )

  callable_unwrapped <- e[[1L]]
  while (
    is_call(callable_unwrapped, quote(`(`)) &&
      length(callable_unwrapped) == 2L
  ) {
    callable_unwrapped <- callable_unwrapped[[2L]]
  }

  if (is.symbol(callable_unwrapped)) {
    callable_name <- as.character(callable_unwrapped)
    closure_obj <- scope[[callable_name]]
    if (!inherits(closure_obj, LocalClosure)) {
      return(NULL)
    }

    call_expr <- as.call(c(list(callable_unwrapped), as.list(e)[-1L]))
    return(compile_closure_call(
      call_expr = call_expr,
      closure_obj = closure_obj,
      proc_name = callable_name,
      scope = scope,
      ...,
      hoist = hoist,
      needs_value = needs_value
    ))
  }

  if (is_function_call(callable_unwrapped)) {
    proc_name <- scope_unique_proc(scope_root(scope), prefix = "closure")
    host_closure <- scope_root(scope)@closure
    closure_obj <- as_local_closure(
      callable_unwrapped,
      env = environment(host_closure),
      name = proc_name
    )
    call_expr <- as.call(c(list(callable_unwrapped), as.list(e)[-1L]))
    return(compile_closure_call(
      call_expr = call_expr,
      closure_obj = closure_obj,
      proc_name = proc_name,
      scope = scope,
      ...,
      hoist = hoist,
      needs_value = needs_value
    ))
  }

  NULL
}


is_function_call <- function(x) {
  is.call(x) && identical(x[[1L]], as.symbol("function"))
}

is_sapply_call <- function(x) is.call(x) && identical(x[[1L]], quote(sapply))


new_local_closure <- function(fun, name = NULL) {
  stopifnot(is.function(fun), is.null(name) || is_string(name))
  LocalClosure(fun = fun, name = name)
}

as_local_closure <- function(fun_expr, env, name = NULL) {
  stopifnot(is_function_call(fun_expr))
  new_local_closure(eval(fun_expr, envir = env), name = name)
}

scope_root <- function(scope) {
  stopifnot(inherits(scope, "quickr_scope"))
  while (
    !identical(scope_kind(scope), "subroutine") &&
      inherits(parent.env(scope), "quickr_scope")
  ) {
    scope <- parent.env(scope)
  }
  scope
}


compile_internal_subroutine <- function(
  proc_name,
  closure_obj,
  parent_scope,
  formal_vars,
  res_var,
  allow_void_return = FALSE,
  forbid_superassign = character(),
  optional_args = character()
) {
  stopifnot(is_string(proc_name), inherits(closure_obj, LocalClosure))
  fun <- closure_obj@fun
  stopifnot(is.function(fun))
  stopifnot(is.null(res_var) || inherits(res_var, Variable))
  stopifnot(is_bool(allow_void_return))
  stopifnot(is.character(forbid_superassign))
  stopifnot(is.character(optional_args))
  forbid_superassign <- unique(forbid_superassign)
  optional_args <- unique(optional_args)
  if (length(forbid_superassign) && any(!nzchar(forbid_superassign))) {
    stop("forbid_superassign must contain only non-empty names")
  }

  formal_names <- names(formals(fun)) %||% character()
  if (length(formal_names) && any(!nzchar(formal_names))) {
    stop("local closures must have only named arguments")
  }
  stopifnot(is.list(formal_vars))
  if (!identical((names(formal_vars) %||% character()), formal_names)) {
    stop("internal error: formal vars do not match closure formals")
  }

  used_names <- unique(all.vars(body(fun), functions = FALSE))

  formal_scope <- new_scope(closure = NULL, parent = parent_scope)
  scope_set(formal_scope, "kind", "closure_formals")

  proc_scope <- new_scope(fun, parent = formal_scope)
  scope_set(proc_scope, "kind", "closure")
  scope_set(proc_scope, "host_scope", scope_root(parent_scope))
  scope_set(proc_scope, "forbid_superassign", forbid_superassign)

  arg_names <- character()
  optional_locals <- list()
  optional_inits <- character()
  if (length(optional_args)) {
    unknown_optional <- setdiff(optional_args, formal_names)
    if (length(unknown_optional)) {
      stop(
        "internal error: optional args not in closure formals: ",
        str_flatten_commas(unknown_optional)
      )
    }
  }
  for (nm in formal_names) {
    var <- formal_vars[[nm]]
    stopifnot(inherits(var, Variable))
    fortran_name <- var@name %||% fortranize_name(nm)

    arg_var <- Variable(
      mode = var@mode,
      dims = var@dims,
      name = fortran_name,
      r_name = nm
    )
    if (logical_as_int(var)) {
      arg_var@logical_as_int <- TRUE
    }
    formal_scope[[nm]] <- arg_var
    arg_names <- c(arg_names, fortran_name)

    if (nm %in% optional_args) {
      local_name <- make_shadow_fortran_name(proc_scope, fortran_name)
      local_var <- Variable(
        mode = var@mode,
        dims = var@dims,
        name = local_name,
        r_name = nm
      )
      if (logical_as_int(var)) {
        local_var@logical_as_int <- TRUE
      }
      local_var@optional_dummy <- fortran_name
      proc_scope[[nm]] <- local_var
      optional_locals[[nm]] <- local_var
      optional_inits <- c(
        optional_inits,
        glue(
          "if (present({fortran_name})) then\n  {local_name} = {fortran_name}\nend if"
        )
      )
    }
  }

  res_name <- NULL

  body_expr <- body(fun)
  stmts <- if (is_call(body_expr, quote(`{`))) {
    as.list(body_expr)[-1L]
  } else {
    list(body_expr)
  }
  if (!length(stmts)) {
    stop("closure body must not be empty")
  }

  if (length(optional_args)) {
    unsafe <- character()
    for (nm in optional_args) {
      used <- any(map_lgl(stmts, optional_arg_used, nm = nm))
      if (!used) {
        next
      }
      missing_init <- any(map_lgl(stmts, optional_arg_missing_init, nm = nm))
      assigned_before_use <- optional_arg_assigned_before_use(stmts, nm = nm)
      if (!missing_init && !assigned_before_use) {
        unsafe <- c(unsafe, nm)
      }
    }
    if (length(unsafe)) {
      stop(
        "optional argument(s) used without initializing when NULL: ",
        str_flatten_commas(unsafe),
        ". Add an is.null() branch that assigns a value before use.",
        call. = FALSE
      )
    }
  }

  body_prefix <- character()
  assign_code <- character()
  if (is.null(res_var)) {
    if (is.null(last(stmts))) {
      stmts <- drop_last(stmts)
    }
    body_prefix <- compile_nonreturn_statements(stmts, proc_scope)
  } else {
    last_expr <- last(stmts)
    prefix <- drop_last(stmts)

    body_prefix <- compile_nonreturn_statements(prefix, proc_scope)

    h <- new_hoist(proc_scope)
    expr_error <- NULL
    expr <- tryCatch(
      r2f(last_expr, proc_scope, hoist = h),
      error = function(e) {
        expr_error <<- e
        NULL
      }
    )

    if (!is.null(expr_error)) {
      if (!isTRUE(allow_void_return)) {
        stop(expr_error)
      }
      # If `last_expr` is itself a local closure call that returns no value,
      # compiling in value-position (with `hoist`) fails. Retry compilation in
      # statement-position.
      stmt_expr <- r2f(last_expr, proc_scope)
      if (!is.null(stmt_expr@value)) {
        stop(expr_error)
      }
      assign_code <- as.character(stmt_expr)
      res_var <- NULL
    } else if (is.null(expr@value)) {
      if (!isTRUE(allow_void_return)) {
        stop("local closure does not return a value")
      }
      assign_code <- h$render(expr)
      res_var <- NULL
    } else if (is.null(expr@value@mode)) {
      stop("could not infer closure return type")
    } else {
      res_name <- "res"
      while (res_name %in% c(formal_names, used_names)) {
        res_name <- paste0(res_name, "_")
      }
      res_var@name <- res_name
      proc_scope[[res_name]] <- res_var
      arg_names <- c(arg_names, res_name)
    }

    if (!is.null(res_var)) {
      if (is.null(res_var@mode)) {
        res_var@mode <- expr@value@mode
        res_var@dims <- expr@value@dims
        proc_scope[[res_name]] <- res_var
      }
      if (!identical(expr@value@mode, res_var@mode)) {
        stop(
          "closure result mode (",
          expr@value@mode,
          ") does not match output mode (",
          res_var@mode,
          ")"
        )
      }
      if (passes_as_scalar(res_var)) {
        if (!passes_as_scalar(expr@value)) {
          stop("closure must return a scalar for scalar outputs")
        }
      } else {
        if (passes_as_scalar(expr@value)) {
          stop("closure must return an array for array outputs")
        }
        if (expr@value@rank != res_var@rank) {
          stop("closure result rank does not match output rank")
        }
        if (
          !identical(
            dims2f(expr@value@dims, proc_scope),
            dims2f(res_var@dims, proc_scope)
          )
        ) {
          stop("closure result shape does not match output shape")
        }
      }
      assign_code <- h$render(glue("{res_name} = {expr}"))
    }
  }

  if (length(optional_locals)) {
    for (nm in names(optional_locals)) {
      dummy_var <- formal_scope[[nm]]
      local_var <- proc_scope[[nm]]
      if (is.null(local_var@mode) && !is.null(dummy_var@mode)) {
        local_var@mode <- dummy_var@mode
        local_var@dims <- dummy_var@dims
      }
      if (is.null(dummy_var@mode) && !is.null(local_var@mode)) {
        dummy_var@mode <- local_var@mode
        dummy_var@dims <- local_var@dims
      }
      if (is.null(dummy_var@mode) || is.null(local_var@mode)) {
        stop(
          "optional argument `",
          nm,
          "` type could not be inferred; provide a typed value or assign a typed default",
          call. = FALSE
        )
      }
      formal_scope[[nm]] <- dummy_var
      proc_scope[[nm]] <- local_var
    }
  }

  vars_formals <- scope_vars(formal_scope)
  vars_locals <- scope_vars(proc_scope)
  locals <- vars_locals
  if (!is.null(res_name)) {
    locals <- locals[setdiff(names(locals), res_name)]
  }

  if (length(locals)) {
    bad <- map_lgl(locals, function(v) {
      !passes_as_scalar(v) &&
        grepl(":", dims2f(v@dims, proc_scope), fixed = TRUE)
    })
    if (any(bad)) {
      stop("closures cannot declare allocatable locals yet")
    }
  }

  out_arg <- if (is.null(res_name)) {
    list()
  } else {
    setNames(list(proc_scope[[res_name]]), res_name)
  }
  vars_declared <- c(vars_formals, out_arg, locals)

  formals_intents <- rep(list("intent(in)"), length(vars_formals))
  names(formals_intents) <- names(vars_formals)
  if (length(optional_locals)) {
    for (nm in names(optional_locals)) {
      formals_intents[[nm]] <- "intent(in), optional"
    }
  }

  decls <- c(
    emit_decls(
      vars_formals,
      formal_scope,
      intents = formals_intents,
      assumed_shape = TRUE,
      allow_allocatable = FALSE
    ),
    if (!is.null(res_name)) {
      emit_decls(
        out_arg,
        formal_scope,
        intents = list("intent(out)"),
        assumed_shape = TRUE,
        allow_allocatable = FALSE
      )
    },
    if (length(locals)) emit_decls(locals, proc_scope) else character()
  )

  body_code <- str_flatten_lines(optional_inits, body_prefix, assign_code)
  used_iso_bindings <- iso_c_binding_symbols(
    vars = vars_declared,
    body_code = body_code,
    logical_is_c_int = logical_as_int,
    uses_rng = FALSE
  )
  use_iso <- if (length(used_iso_bindings)) {
    glue("use iso_c_binding, only: {str_flatten_commas(used_iso_bindings)}")
  } else {
    NULL
  }

  proc_sig <- str_flatten_commas(arg_names)
  proc_code <- glue(
    "
    subroutine {proc_name}({proc_sig})
    {indent(str_flatten_lines(use_iso, \"implicit none\"), 2)}

    {indent(str_flatten_lines(decls), 2)}

    {indent(body_code, 2)}
    end subroutine
    ",
    .null = ""
  )
  proc_code <- glue::trim(proc_code)

  proc_code <- insert_fortran_line_continuations(
    proc_code,
    preserve_attributes = FALSE
  )

  list(
    name = proc_name,
    code = proc_code,
    captures = character(),
    res = res_name,
    res_var = res_var
  )
}

closure_last_expr <- function(fun) {
  stopifnot(is.function(fun))
  body_expr <- body(fun)
  if (is_call(body_expr, quote(`{`))) {
    stmts <- as.list(body_expr)[-1L]
    if (!length(stmts)) {
      stop("closure body must not be empty")
    }
    last(stmts)
  } else {
    body_expr
  }
}

optional_arg_used <- function(expr, nm) {
  if (is.symbol(expr)) {
    return(identical(as.character(expr), nm))
  }

  if (!is.call(expr)) {
    return(FALSE)
  }

  if (
    is_call(expr, quote(is.null)) &&
      length(expr) == 2L &&
      is.symbol(expr[[2L]]) &&
      identical(as.character(expr[[2L]]), nm)
  ) {
    return(FALSE)
  }

  if (
    is_call(expr, quote(`!`)) &&
      length(expr) == 2L &&
      is_call(expr[[2L]], quote(is.null)) &&
      length(expr[[2L]]) == 2L &&
      is.symbol(expr[[2L]][[2L]]) &&
      identical(as.character(expr[[2L]][[2L]]), nm)
  ) {
    return(FALSE)
  }

  if (is_call(expr, quote(`{`))) {
    return(any(map_lgl(as.list(expr)[-1L], optional_arg_used, nm = nm)))
  }

  if (is_call(expr, quote(`if`))) {
    if (optional_arg_used(expr[[2L]], nm = nm)) {
      return(TRUE)
    }
    if (optional_arg_used(expr[[3L]], nm = nm)) {
      return(TRUE)
    }
    if (length(expr) == 4L && optional_arg_used(expr[[4L]], nm = nm)) {
      return(TRUE)
    }
    return(FALSE)
  }

  if (
    is_call(expr, quote(`<-`)) ||
      is_call(expr, quote(`=`)) ||
      is_call(expr, quote(`<<-`))
  ) {
    return(optional_arg_used(expr[[3L]], nm = nm))
  }

  any(map_lgl(as.list(expr)[-1L], optional_arg_used, nm = nm))
}

optional_arg_assigned <- function(expr, nm) {
  if (!is.call(expr)) {
    return(FALSE)
  }

  if (
    is_call(expr, quote(`<-`)) ||
      is_call(expr, quote(`=`)) ||
      is_call(expr, quote(`<<-`))
  ) {
    lhs <- expr[[2L]]
    if (is.symbol(lhs) && identical(as.character(lhs), nm)) {
      return(TRUE)
    }
    return(optional_arg_assigned(expr[[3L]], nm = nm))
  }

  if (is_call(expr, quote(`{`))) {
    return(any(map_lgl(as.list(expr)[-1L], optional_arg_assigned, nm = nm)))
  }

  if (is_call(expr, quote(`if`))) {
    if (optional_arg_assigned(expr[[2L]], nm = nm)) {
      return(TRUE)
    }
    if (optional_arg_assigned(expr[[3L]], nm = nm)) {
      return(TRUE)
    }
    if (length(expr) == 4L && optional_arg_assigned(expr[[4L]], nm = nm)) {
      return(TRUE)
    }
    return(FALSE)
  }

  any(map_lgl(as.list(expr)[-1L], optional_arg_assigned, nm = nm))
}

optional_arg_missing_init <- function(expr, nm) {
  if (!is.call(expr)) {
    return(FALSE)
  }

  if (is_call(expr, quote(`{`))) {
    return(any(map_lgl(as.list(expr)[-1L], optional_arg_missing_init, nm = nm)))
  }

  if (is_call(expr, quote(`if`))) {
    cond <- expr[[2L]]
    then_branch <- expr[[3L]]
    else_branch <- if (length(expr) == 4L) expr[[4L]] else NULL

    if (
      is_call(cond, quote(is.null)) &&
        length(cond) == 2L &&
        is.symbol(cond[[2L]]) &&
        identical(as.character(cond[[2L]]), nm)
    ) {
      if (optional_arg_assigned(then_branch, nm = nm)) return(TRUE)
    }

    if (
      is_call(cond, quote(`!`)) &&
        length(cond) == 2L &&
        is_call(cond[[2L]], quote(is.null)) &&
        length(cond[[2L]]) == 2L &&
        is.symbol(cond[[2L]][[2L]]) &&
        identical(as.character(cond[[2L]][[2L]]), nm)
    ) {
      if (
        !is.null(else_branch) &&
          optional_arg_assigned(else_branch, nm = nm)
      ) {
        return(TRUE)
      }
    }

    if (optional_arg_missing_init(then_branch, nm = nm)) {
      return(TRUE)
    }
    if (
      !is.null(else_branch) &&
        optional_arg_missing_init(else_branch, nm = nm)
    ) {
      return(TRUE)
    }
    return(FALSE)
  }

  FALSE
}

optional_arg_assigned_before_use <- function(stmts, nm) {
  stopifnot(is.list(stmts), is_string(nm))
  assigned <- FALSE

  scan_expr <- function(expr, assigned) {
    if (is_call(expr, quote(`{`))) {
      for (stmt in as.list(expr)[-1L]) {
        res <- scan_expr(stmt, assigned)
        if (res$used_before) {
          return(res)
        }
        assigned <- res$assigned
      }
      return(list(assigned = assigned, used_before = FALSE))
    }

    if (
      is_call(expr, quote(`<-`)) ||
        is_call(expr, quote(`=`)) ||
        is_call(expr, quote(`<<-`))
    ) {
      lhs <- expr[[2L]]
      if (is.symbol(lhs) && identical(as.character(lhs), nm)) {
        return(list(assigned = TRUE, used_before = FALSE))
      }
    }

    if (optional_arg_used(expr, nm = nm)) {
      return(list(assigned = assigned, used_before = !assigned))
    }

    list(assigned = assigned, used_before = FALSE)
  }

  for (stmt in stmts) {
    res <- scan_expr(stmt, assigned)
    if (res$used_before) {
      return(FALSE)
    }
    assigned <- res$assigned
  }

  assigned
}

closure_formal_vars <- function(args_f, formal_names) {
  stopifnot(is.list(args_f), is.character(formal_names))
  if (!length(formal_names)) {
    return(setNames(list(), character()))
  }
  if (length(args_f) != length(formal_names)) {
    stop("internal error: argument values do not match closure formals")
  }
  fortran_names <- map_chr(formal_names, fortranize_name)
  dup <- duplicated(tolower(fortran_names)) |
    duplicated(tolower(fortran_names), fromLast = TRUE)
  if (any(dup)) {
    dup_map <- paste0(formal_names[dup], " -> ", fortran_names[dup])
    stop(
      "local closure arguments map to the same Fortran name: ",
      str_flatten_commas(dup_map),
      call. = FALSE
    )
  }
  fortran_by_r <- setNames(fortran_names, formal_names)
  names(args_f) <- formal_names
  formal_vars <- imap(args_f, function(f, nm) {
    fortran_name <- fortran_by_r[[nm]]
    if (is.null(f)) {
      v <- Variable(name = fortran_name, r_name = nm)
    } else {
      stopifnot(inherits(f, Fortran), inherits(f@value, Variable))
      v <- Variable(
        mode = f@value@mode,
        dims = f@value@dims,
        name = fortran_name,
        r_name = nm
      )
      if (logical_as_int_symbol(f@value)) {
        v@logical_as_int <- TRUE
      }
    }
    v
  })
  names(formal_vars) <- formal_names
  formal_vars
}

match_closure_call_args <- function(
  call_expr,
  closure_obj,
  scope,
  ...,
  hoist = NULL
) {
  stopifnot(is.call(call_expr), inherits(closure_obj, LocalClosure))
  fun <- closure_obj@fun
  call_expr <- match.call(fun, call_expr)
  args_expr <- as.list(call_expr)[-1L]

  formals_list <- as.list(formals(fun))
  formal_names <- names(formals_list) %||% character()
  closure_name <- closure_obj@name %||% "local closure"

  arg_names <- names(args_expr) %||% rep("", length(args_expr))
  if (any(!nzchar(arg_names))) {
    stop("internal error: local closure call has unnamed arguments")
  }

  extra <- setdiff(arg_names, formal_names)
  if (length(extra)) {
    stop(
      closure_name,
      " call has unknown argument(s): ",
      str_flatten_commas(extra),
      call. = FALSE
    )
  }

  args_aligned <- formals_list
  if (length(args_expr)) {
    args_aligned[names(args_expr)] <- args_expr
  }

  optional_args <- names(formals_list)[map_lgl(formals_list, function(x) {
    is.null(x) || identical(x, quote(NULL))
  })] %||%
    character()

  args_present <- setNames(rep(TRUE, length(formal_names)), formal_names)
  missing_args <- character()
  for (nm in formal_names) {
    default_expr <- formals_list[[nm]]
    arg_expr <- args_aligned[[nm]]
    optional_here <- nm %in% optional_args

    if (is_missing(arg_expr)) {
      if (is_missing(default_expr)) {
        missing_args <- c(missing_args, nm)
      } else if (optional_here) {
        args_present[[nm]] <- FALSE
        args_aligned[[nm]] <- quote(expr = )
      } else {
        args_aligned[[nm]] <- default_expr
      }
      next
    }

    if (
      optional_here && (is.null(arg_expr) || identical(arg_expr, quote(NULL)))
    ) {
      args_present[[nm]] <- FALSE
      args_aligned[[nm]] <- quote(expr = )
    }
  }

  if (length(missing_args)) {
    stop(
      closure_name,
      " call is missing required argument(s): ",
      str_flatten_commas(missing_args),
      call. = FALSE
    )
  }

  args_expr <- args_aligned

  args_f <- lapply(formal_names, function(nm) {
    if (!isTRUE(args_present[[nm]])) {
      return(NULL)
    }
    r2f(args_expr[[nm]], scope, ..., hoist = hoist)
  })
  names(args_f) <- formal_names

  arg_ok <- map_lgl(
    args_f,
    \(arg) {
      is.null(arg) ||
        (inherits(arg@value, Variable) && !is.null(arg@value@mode))
    }
  )
  if (any(!arg_ok)) {
    bad_args <- formal_names[!arg_ok]
    stop(
      closure_name,
      " call has argument(s) without inferred types: ",
      str_flatten_commas(bad_args),
      ". Provide explicit typed values.",
      call. = FALSE
    )
  }

  formal_vars <- closure_formal_vars(args_f, formal_names)

  list(
    call_expr = call_expr,
    args_expr = args_expr,
    args_f = args_f,
    formal_names = formal_names,
    formal_vars = formal_vars,
    optional_args = optional_args,
    args_present = args_present
  )
}

closure_call_inputs <- function(args_f, args_present, formal_vars) {
  stopifnot(is.list(args_f), is.logical(args_present), is.list(formal_vars))
  formal_names <- names(formal_vars) %||% character()
  if (!length(formal_names)) {
    return(list(args = character(), use_keywords = FALSE))
  }
  present_names <- formal_names[args_present[formal_names]]
  use_keywords <- any(!args_present)
  if (!length(present_names)) {
    return(list(args = character(), use_keywords = use_keywords))
  }
  if (use_keywords) {
    args <- map_chr(present_names, function(nm) {
      dummy_name <- formal_vars[[nm]]@name %||% nm
      glue("{dummy_name} = {args_f[[nm]]}")
    })
  } else {
    args <- unname(args_f[present_names])
  }
  list(args = args, use_keywords = use_keywords)
}

compile_local_closure_proc <- function(
  proc_name,
  closure_obj,
  scope,
  formal_vars,
  res_var,
  allow_void_return = FALSE,
  forbid_superassign = character(),
  optional_args = character()
) {
  proc <- compile_internal_subroutine(
    proc_name,
    closure_obj,
    scope,
    formal_vars = formal_vars,
    res_var = res_var,
    allow_void_return = allow_void_return,
    forbid_superassign = forbid_superassign,
    optional_args = optional_args
  )
  scope_add_internal_proc(scope_root(scope), proc)
  proc
}

compile_closure_call <- function(
  call_expr,
  closure_obj,
  proc_name,
  scope,
  ...,
  hoist,
  needs_value
) {
  stopifnot(
    is.call(call_expr),
    inherits(closure_obj, LocalClosure),
    is_string(proc_name),
    inherits(scope, "quickr_scope"),
    inherits(hoist, "environment"),
    is_bool(needs_value)
  )

  call_info <- match_closure_call_args(
    call_expr,
    closure_obj,
    scope,
    ...,
    hoist = hoist
  )
  args_f <- call_info$args_f
  formal_vars <- call_info$formal_vars
  optional_args <- call_info$optional_args
  args_present <- call_info$args_present

  last_expr <- closure_last_expr(closure_obj@fun)

  if (is.null(last_expr)) {
    if (needs_value) {
      stop("local closure calls that return `NULL` cannot be used as values")
    }
    proc <- compile_local_closure_proc(
      proc_name,
      closure_obj,
      scope,
      formal_vars = formal_vars,
      res_var = NULL,
      optional_args = optional_args
    )

    inputs <- closure_call_inputs(args_f, args_present, formal_vars)
    call_args <- inputs$args
    if (length(call_args)) {
      call_stmt <- glue("call {proc$name}({str_flatten_commas(call_args)})")
      return(Fortran(str_flatten_lines(
        call_stmt,
        quickr_error_return_if_set(scope)
      )))
    }
    return(Fortran(str_flatten_lines(
      glue("call {proc$name}()"),
      quickr_error_return_if_set(scope)
    )))
  }

  proc <- compile_local_closure_proc(
    proc_name,
    closure_obj,
    scope,
    formal_vars = formal_vars,
    res_var = Variable(),
    allow_void_return = !needs_value,
    optional_args = optional_args
  )

  if (!needs_value && is.null(proc$res)) {
    inputs <- closure_call_inputs(args_f, args_present, formal_vars)
    call_args <- inputs$args
    if (length(call_args)) {
      call_stmt <- glue("call {proc$name}({str_flatten_commas(call_args)})")
      return(Fortran(str_flatten_lines(
        call_stmt,
        quickr_error_return_if_set(scope)
      )))
    }
    return(Fortran(str_flatten_lines(
      glue("call {proc$name}()"),
      quickr_error_return_if_set(scope)
    )))
  }

  res_var <- proc$res_var
  if (is.null(res_var@mode)) {
    stop("internal error: could not infer closure return type")
  }

  tmp <- hoist$declare_tmp(mode = res_var@mode, dims = res_var@dims)
  inputs <- closure_call_inputs(args_f, args_present, formal_vars)
  call_args <- inputs$args
  res_arg <- if (inputs$use_keywords) {
    glue("{proc$res} = {tmp@name}")
  } else {
    tmp@name
  }
  call_args <- c(call_args, res_arg)
  call_stmt <- glue("call {proc$name}({str_flatten_commas(call_args)})")
  call_stmt <- str_flatten_lines(call_stmt, quickr_error_return_if_set(scope))

  if (needs_value) {
    hoist$emit(call_stmt)
    Fortran(tmp@name, tmp)
  } else {
    Fortran(call_stmt)
  }
}

compile_closure_call_assignment <- function(
  target_name,
  call_expr,
  scope,
  ...
) {
  stopifnot(
    is_string(target_name),
    is.call(call_expr),
    is.symbol(call_expr[[1L]])
  )
  hoist <- list(...)$hoist
  if (is.null(hoist)) {
    hoist <- new_hoist(scope)
  }

  closure_name <- as.character(call_expr[[1L]])
  closure_obj <- scope[[closure_name]]
  if (!inherits(closure_obj, LocalClosure)) {
    stop("internal error: expected a LocalClosure")
  }

  target_var <- get0(target_name, scope)
  target_exists <- inherits(target_var, Variable)
  target_fortran_name <- if (target_exists) {
    target_var@name
  } else {
    assignment_fortran_name(target_name, scope)
  }

  if (is.null(closure_last_expr(closure_obj@fun))) {
    stop("local closure calls that return `NULL` cannot be assigned")
  }
  call_info <- match_closure_call_args(call_expr, closure_obj, scope, ...)
  args_expr <- call_info$args_expr
  args_f <- call_info$args_f
  formal_vars <- call_info$formal_vars
  optional_args <- call_info$optional_args
  args_present <- call_info$args_present

  return_names <- scope_get(scope, "return_names", default = character()) %||%
    character()
  res_var <- if (target_exists) {
    out <- Variable(
      mode = target_var@mode,
      dims = target_var@dims,
      name = target_fortran_name,
      r_name = target_name
    )
    if (logical_as_int(target_var)) {
      out@logical_as_int <- TRUE
    }
    out
  } else {
    Variable()
  }

  proc <- compile_local_closure_proc(
    closure_name,
    closure_obj,
    scope,
    formal_vars = formal_vars,
    res_var = res_var,
    optional_args = optional_args
  )
  if (!target_exists) {
    inferred_res_var <- proc$res_var
    if (is.null(inferred_res_var@mode)) {
      stop("internal error: could not infer closure return type")
    }
    target_var <- Variable(
      mode = inferred_res_var@mode,
      dims = inferred_res_var@dims
    )
    target_var@r_name <- target_name
    target_var@name <- target_fortran_name
    if (
      identical(inferred_res_var@mode, "logical") &&
        target_name %in% return_names
    ) {
      target_var@logical_as_int <- TRUE
      # Recompile with the correct storage for the output dummy argument.
      res_var <- Variable(mode = target_var@mode, dims = target_var@dims)
      res_var@r_name <- target_name
      res_var@name <- target_fortran_name
      res_var@logical_as_int <- TRUE
      proc <- compile_local_closure_proc(
        closure_name,
        closure_obj,
        scope,
        formal_vars = formal_vars,
        res_var = res_var,
        optional_args = optional_args
      )
    }
    scope[[target_name]] <- target_var
  }
  scope_add_internal_proc(scope_root(scope), proc)

  arg_reads_target <- any(map_lgl(args_expr, function(e) {
    any(all.vars(e, functions = FALSE) == target_name)
  }))

  res_target <- target_fortran_name
  post <- character()
  if (arg_reads_target) {
    tmp <- hoist$declare_tmp(
      mode = target_var@mode,
      dims = target_var@dims,
      logical_as_int = logical_as_int(target_var)
    )
    res_target <- tmp@name
    post <- glue("{target_fortran_name} = {res_target}")
  }

  inputs <- closure_call_inputs(args_f, args_present, formal_vars)
  res_arg <- if (inputs$use_keywords) {
    glue("{proc$res} = {res_target}")
  } else {
    res_target
  }
  call_args <- c(inputs$args, res_arg)

  if (target_exists) {
    target_var@modified <- TRUE
    scope[[target_name]] <- target_var
  }

  Fortran(glue(
    "
    call {proc$name}({str_flatten_commas(call_args)})
    {quickr_error_return_if_set(scope)}
    {str_flatten_lines(post)}
    "
  ))
}

compile_sapply_assignment <- function(
  out_name,
  call_expr,
  scope,
  ...,
  parallel = NULL
) {
  stopifnot(is_string(out_name), is_sapply_call(call_expr))
  hoist <- list(...)$hoist
  if (is.null(hoist)) {
    hoist <- new_hoist(scope)
  }
  args <- as.list(call_expr)[-1L]
  if (length(args) < 2L) {
    stop("sapply() requires at least 2 arguments")
  }

  seq_call <- args[[1L]]
  fun_expr <- args[[2L]]
  simplify <- args$simplify
  if (!is.null(simplify) && !is_missing(simplify)) {
    if (is_string(simplify) && identical(simplify, "array")) {
      # ok
    } else if (is_bool(simplify) && isTRUE(simplify)) {
      simplify <- NULL
    } else {
      stop('Only `sapply(..., simplify = "array")` is supported.')
    }
  }

  out_var <- get0(out_name, scope)
  target_exists <- inherits(out_var, Variable)
  if (target_exists) {
    if (out_var@rank < 1L) {
      stop("sapply() output must be an array: ", out_name)
    }
    if (
      out_var@rank > 2L && (is.null(simplify) || !identical(simplify, "array"))
    ) {
      stop('sapply() that returns arrays requires `simplify = "array"`.')
    }
  }

  env <- environment(scope_closure(scope))
  if (is.symbol(fun_expr)) {
    fun_name <- as.character(fun_expr)
    closure_obj <- scope[[fun_name]]
    if (!inherits(closure_obj, LocalClosure)) {
      stop("unsupported FUN in sapply(): ", fun_name)
    }
    proc_name <- fun_name
  } else if (is_function_call(fun_expr)) {
    proc_name <- scope_unique_proc(scope_root(scope), prefix = "closure")
    closure_obj <- as_local_closure(fun_expr, env, name = proc_name)
  } else {
    stop("unsupported FUN in sapply(); use a local closure or function(i) ...")
  }

  formal_names <- names(formals(closure_obj@fun)) %||% character()
  if (length(formal_names) != 1L || any(!nzchar(formal_names))) {
    stop("sapply() FUN must have exactly one named argument")
  }

  seq_call_unwrapped <- seq_call
  while (
    is_call(seq_call_unwrapped, quote(`(`)) && length(seq_call_unwrapped) == 2L
  ) {
    seq_call_unwrapped <- seq_call_unwrapped[[2L]]
  }
  index_iterable <- is_call(seq_call_unwrapped, quote(seq_len)) ||
    is_call(seq_call_unwrapped, quote(seq_along))

  iterable_len_expr <- NULL
  iterable_tmp <- NULL
  iterable_tmp_assign <- NULL
  iterable_value <- NULL

  if (index_iterable) {
    seq_val <- r2f(seq_call, scope, calls = "for", hoist = hoist)
    if (!is.null(seq_val@value)) {
      iterable_len_expr <- value_length_expr(seq_val@value)
    }
    formal_vars <- list(
      Variable(mode = "integer", name = formal_names[[1L]])
    )
    names(formal_vars) <- formal_names
  } else {
    iterable_val <- r2f(seq_call, scope, calls = "sapply", hoist = hoist)
    if (is.null(iterable_val@value) || is.null(iterable_val@value@mode)) {
      stop("sapply() iterable must have a value")
    }
    iterable_value <- iterable_val@value

    iterable_len_expr <- value_length_expr(iterable_value)

    iterable_tmp <- scope_unique_var(
      scope,
      mode = iterable_value@mode,
      dims = iterable_value@dims
    )
    iterable_tmp_assign <- glue("{iterable_tmp@name} = {iterable_val}")

    formal_vars <- list(
      Variable(mode = iterable_value@mode, name = formal_names[[1L]])
    )
    names(formal_vars) <- formal_names
  }
  res_var <- if (target_exists) {
    res_dims <- if (out_var@rank == 1L) {
      NULL
    } else {
      out_var@dims[seq_len(out_var@rank - 1L)]
    }
    res_out <- Variable(mode = out_var@mode, dims = res_dims)
    if (logical_as_int(out_var)) {
      res_out@logical_as_int <- TRUE
    }
    res_out
  } else {
    Variable()
  }

  proc <- compile_internal_subroutine(
    proc_name,
    closure_obj,
    scope,
    formal_vars,
    res_var,
    forbid_superassign = out_name
  )

  if (!target_exists) {
    inferred <- proc$res_var
    if (is.null(inferred@mode)) {
      stop("internal error: could not infer sapply() output type")
    }
    res_var <- inferred

    return_names <- scope_get(scope, "return_names", default = character()) %||%
      character()
    if (res_var@mode == "logical" && out_name %in% return_names) {
      res_var@logical_as_int <- TRUE
      proc <- compile_internal_subroutine(
        proc_name,
        closure_obj,
        scope,
        formal_vars,
        res_var,
        forbid_superassign = out_name
      )
    }

    if (is.null(iterable_len_expr) || is_scalar_na(iterable_len_expr)) {
      stop("sapply() requires a vector input with a known length")
    }
    if (
      res_var@rank > 1L && (is.null(simplify) || !identical(simplify, "array"))
    ) {
      stop('sapply() that returns arrays requires `simplify = "array"`.')
    }
    out_dims <- if (res_var@rank == 0L) {
      list(iterable_len_expr)
    } else {
      c(res_var@dims, list(iterable_len_expr))
    }
    out_var <- Variable(mode = res_var@mode, dims = out_dims, name = out_name)
    if (logical_as_int(res_var)) {
      out_var@logical_as_int <- TRUE
    }
    scope[[out_name]] <- out_var
  }

  scope_add_internal_proc(scope_root(scope), proc)

  out_target <- out_name
  post_stmts <- character()
  if (out_name %in% all.vars(body(closure_obj@fun), functions = FALSE)) {
    tmp_out <- hoist$declare_tmp(
      mode = out_var@mode,
      dims = out_var@dims,
      logical_as_int = logical_as_int(out_var)
    )
    out_target <- tmp_out@name
    post_stmts <- glue("{out_name} = {out_target}")
  }

  idx <- scope_unique_var(scope, "integer")
  last_i <- if (index_iterable) {
    if (is.null(iterable_len_expr) || is_scalar_na(iterable_len_expr)) {
      NULL
    } else {
      r2f(iterable_len_expr, scope, hoist = hoist)
    }
  } else if (passes_as_scalar(iterable_value)) {
    "1_c_int"
  } else {
    glue("size({iterable_tmp@name})")
  }
  if (is.null(last_i)) {
    stop("sapply() requires a vector input with a known length")
  }

  res_target <- if (out_var@rank == 1L) {
    glue("{out_target}({idx@name})")
  } else {
    subs <- c(rep(":", out_var@rank - 1L), idx@name)
    glue("{out_target}({str_flatten_commas(subs)})")
  }
  if (passes_as_scalar(out_var)) {
    res_target <- out_target
  }

  element_designator <- if (index_iterable) {
    idx@name
  } else if (passes_as_scalar(iterable_value)) {
    iterable_tmp@name
  } else if (iterable_value@rank == 1L) {
    glue("{iterable_tmp@name}({idx@name})")
  } else {
    subs <- linear_subscripts_from_1d(
      iterable_tmp@name,
      iterable_value@rank,
      Fortran(idx@name, idx)
    )
    glue("{iterable_tmp@name}({str_flatten_commas(subs)})")
  }

  call_args <- str_flatten_commas(c(
    element_designator,
    res_target
  ))

  out_var@modified <- TRUE
  scope[[out_name]] <- out_var

  directives <- openmp_directives(parallel)
  if (!is.null(parallel)) {
    mark_openmp_used(scope)
  }
  error_check_inner <- if (is.null(parallel)) {
    quickr_error_return_if_set(scope)
  } else {
    quickr_error_return_if_set(
      scope,
      openmp_depth = scope_openmp_depth(scope) + 1L
    )
  }
  error_check_after <- if (!is.null(parallel)) {
    quickr_error_return_if_set(
      scope,
      openmp_depth = scope_openmp_depth(scope)
    )
  } else {
    ""
  }
  loop_header <- glue("do {idx@name} = 1_c_int, {last_i}")
  prefix <- str_flatten_lines(
    if (!index_iterable) iterable_tmp_assign else NULL,
    str_flatten_lines(directives$prefix, loop_header)
  )
  Fortran(glue(
    "
    {prefix}
      call {proc_name}({call_args})
      {error_check_inner}
    end do
    {str_flatten_lines(directives$suffix)}
    {error_check_after}
    {str_flatten_lines(post_stmts)}
    "
  ))
}


compile_subset_designator <- function(
  base_var,
  base_name,
  idx_args,
  scope,
  ...,
  hoist = NULL,
  drop = TRUE,
  allow_logical_vector_subscripts = FALSE
) {
  stopifnot(
    inherits(base_var, Variable),
    is_string(base_name),
    inherits(scope, "quickr_scope"),
    is_bool(drop),
    is_bool(allow_logical_vector_subscripts)
  )

  idxs <- whole_doubles_to_ints(idx_args)
  idxs <- imap(idxs, function(idx, i) {
    if (is_missing(idx)) {
      Fortran(":", Variable("integer", base_var@dims[[i]]))
    } else {
      sub <- r2f(idx, scope, ..., hoist = hoist)
      if (sub@value@mode == "double") {
        Fortran(
          glue("int({sub}, kind=c_ptrdiff_t)"),
          Variable("integer", sub@value@dims)
        )
      } else {
        sub
      }
    }
  })

  # Indexing a scalar (rank-1 length-1) with `[1]` is valid in R, but Fortran
  # scalars cannot be subscripted. Treat it as a no-op.
  if (
    passes_as_scalar(base_var) &&
      length(idxs) == 1 &&
      idxs[[1]]@value@mode == "integer" &&
      passes_as_scalar(idxs[[1]]@value)
  ) {
    idx_r <- attr(idxs[[1]], "r", exact = TRUE)
    if (identical(idx_r, 1L) || identical(idx_r, 1)) {
      return(base_name)
    }
    if (isTRUE(idxs[[1]]@value@loop_is_singleton)) {
      return(base_name)
    }
  }

  # R-style linear indexing for rank>1 arrays: x[i]
  if (
    length(idxs) == 1 &&
      idxs[[1]]@value@mode == "integer" &&
      passes_as_scalar(idxs[[1]]@value) &&
      base_var@rank > 1
  ) {
    subs <- linear_subscripts_from_1d(base_name, base_var@rank, idxs[[1]])
    return(as.character(glue("{base_name}({str_flatten_commas(subs)})")))
  }

  if (length(idxs) != base_var@rank) {
    stop(
      "number of args to x[...] must match the rank of x, received:",
      deparse1(as.call(c(quote(`[`), idx_args)))
    )
  }

  idxs <- imap(idxs, function(subscript, i) {
    switch(
      paste0(subscript@value@mode, subscript@value@rank),
      logical0 = {
        Fortran(":", Variable("integer", base_var@dims[[i]]))
      },
      logical1 = {
        if (!allow_logical_vector_subscripts) {
          stop("logical subscript vectors are not supported for assignment")
        }

        # Convert logical vectors to integer vector subscripts (R's `which()`).
        # Fortran array designators do not accept logical vectors directly.
        mask <- booleanize_logical_as_int(subscript)
        it <- scope_unique_var(scope, "integer")
        f <- glue("pack([({it}, {it}=1, size({mask}))], {mask})")
        Fortran(f, Variable("int", NA))
      },
      integer0 = {
        if (drop) {
          subscript
        } else {
          Fortran(glue("{subscript}:{subscript}"), Variable("int", 1))
        }
      },
      integer1 = {
        subscript
      },
      stop(
        "all args to x[...] must be logical or integer of rank 0 or 1",
        deparse1(as.call(c(quote(`[`), idx_args)))
      )
    )
  })

  as.character(glue("{base_name}({str_flatten_commas(idxs)})"))
}

compile_subscript_lhs <- function(
  subset_call,
  scope,
  ...,
  hoist = NULL,
  target = c("local", "host")
) {
  stopifnot(is_call(subset_call, quote(`[`)))
  target <- match.arg(target)

  if (target == "local") {
    base <- subset_call[[2L]]
    if (!is.symbol(base)) {
      stop("assignment targets must be symbols, found: ", deparse1(base))
    }
    base_name <- as.character(base)

    pre <- NULL

    if (scope_is_closure(scope)) {
      local_base <- get0(base_name, scope, inherits = FALSE)
      if (is.null(local_base) || !inherits(local_base, Variable)) {
        parent_base <- get0(base_name, scope)
        if (!inherits(parent_base, Variable)) {
          stop("could not resolve symbol: ", base_name)
        }

        shadow <- Variable(mode = parent_base@mode, dims = parent_base@dims)
        shadow@r_name <- base_name
        shadow@name <- make_shadow_fortran_name(
          scope,
          fortranize_name(base_name)
        )
        if (logical_as_int(parent_base)) {
          shadow@logical_as_int <- TRUE
        }
        scope[[base_name]] <- shadow

        pre <- glue("{shadow@name} = {parent_base@name}")
      }
    }

    base_var <- get0(base_name, scope)
    if (!inherits(base_var, Variable)) {
      stop("could not resolve symbol: ", base_name)
    }

    idx_args <- as.list(subset_call)[-1L]
    idx_args <- idx_args[-1L]
    drop <- idx_args$drop %||% TRUE
    idx_args$drop <- NULL

    # When compiling subscripts for assignment, force iterable indices like `i:i`
    # to render as Fortran triplets (i:i) rather than value sequences.
    dots <- list(...)
    dots$calls <- c(dots$calls %||% character(), "[")

    designator <- do.call(
      compile_subset_designator,
      c(
        list(
          base_var = base_var,
          base_name = base_var@name,
          idx_args = idx_args,
          scope = scope,
          hoist = hoist,
          drop = drop,
          allow_logical_vector_subscripts = TRUE
        ),
        dots
      )
    )

    return(list(pre = pre, lhs = Fortran(designator)))
  }

  if (is.null(scope) || !identical(scope_kind(scope), "closure")) {
    stop("host-target subset compilation is only valid inside local closures")
  }

  base <- subset_call[[2L]]
  if (!is.symbol(base)) {
    stop("only superassignment to x[...] is supported")
  }
  name <- as.character(base)

  host_scope <- scope_host_scope(scope) %||%
    stop("internal error: missing host scope")
  host_var <- get0(name, host_scope)
  if (!inherits(host_var, Variable)) {
    stop(
      "<<- targets must resolve to an existing variable in the enclosing quick() scope: ",
      name
    )
  }

  idx_args <- as.list(subset_call)[-1L]
  idx_args <- idx_args[-1L]
  drop <- idx_args$drop %||% TRUE
  idx_args$drop <- NULL
  if (!isTRUE(drop)) {
    stop("drop = FALSE not supported for superassignment")
  }

  designator <- compile_subset_designator(
    base_var = host_var,
    base_name = host_var@name,
    idx_args = idx_args,
    scope = scope,
    ...,
    hoist = hoist,
    drop = drop,
    allow_logical_vector_subscripts = TRUE
  )

  list(pre = NULL, lhs = Fortran(designator))
}

# r2f-subscript.R
# Handlers for subscripting operations: [

# --- Handlers ---

r2f_handlers[["["]] <- function(
  args,
  scope,
  ...,
  hoist_mask = function(mask) FALSE,
  hoist = NULL
) {
  # only a subset of R's x[...] features can be translated here. `...` can only be:
  # - a single logical mask, of the same rank as `x`. returns a rank 1 vector.
  # - a number of arguments matching the rank of `x`, with each being
  #   an integer of rank 0 or 1. In this case, a rank 1 logical becomes
  #   converted to an integer with

  var <- args[[1]]
  var <- r2f(var, scope, ..., hoist = hoist)

  idx_args <- args[-1]
  drop <- idx_args$drop %||% TRUE
  idx_args$drop <- NULL

  idxs <- whole_doubles_to_ints(idx_args)
  idxs <- imap(idxs, function(idx, i) {
    if (is_missing(idx)) {
      Fortran(":", Variable("integer", var@value@dims[[i]]))
    } else {
      # Important: pass along the per-statement hoist context, otherwise
      # subscript expressions that need temporaries (e.g. rev(seq_len(n)))
      # will self-render as an inline `block ... end block` *expression*,
      # which is invalid Fortran inside an array designator.
      sub <- r2f(idx, scope, ..., hoist = hoist)
      if (sub@value@mode == "double") {
        # Fortran subscripts must be integers; coerce numeric expressions
        Fortran(
          glue("int({sub}, kind=c_ptrdiff_t)"),
          Variable("integer", sub@value@dims)
        )
      } else {
        sub
      }
    }
  })

  if (
    length(idxs) == 1 &&
      idxs[[1]]@value@mode == "logical" &&
      idxs[[1]]@value@rank == var@value@rank
  ) {
    mask <- idxs[[1]]
    mask <- booleanize_logical_as_int(mask)
    if (hoist_mask(mask)) {
      return(var)
    }
    return(Fortran(
      glue("pack({var}, {mask})"),
      Variable(var@value@mode, dims = NA)
    ))
  }

  # Indexing a scalar (rank-1 length-1) with `[1]` is valid in R, but Fortran
  # scalars cannot be subscripted. Treat it as a no-op.
  if (
    passes_as_scalar(var@value) &&
      length(idxs) == 1 &&
      idxs[[1]]@value@mode == "integer" &&
      passes_as_scalar(idxs[[1]]@value)
  ) {
    idx_r <- attr(idxs[[1]], "r", exact = TRUE)
    if (identical(idx_r, 1L) || identical(idx_r, 1)) {
      return(var)
    }
    if (isTRUE(idxs[[1]]@value@loop_is_singleton)) {
      return(var)
    }
  }

  # R-style linear indexing for rank>1 arrays: x[i]
  if (
    length(idxs) == 1 &&
      idxs[[1]]@value@mode == "integer" &&
      passes_as_scalar(idxs[[1]]@value) &&
      var@value@rank > 1
  ) {
    # Hoist array expressions before subscripting (no invalid (expr)(i)).
    if (!passes_as_scalar(var@value) && is.null(var@value@name)) {
      tmp <- hoist$declare_tmp(mode = var@value@mode, dims = var@value@dims)
      hoist$emit(glue("{tmp@name} = {var}"))
      var <- Fortran(tmp@name, tmp)
    }

    base_name <- var@value@name %||% stop("missing array name for subscripting")
    subs <- linear_subscripts_from_1d(base_name, var@value@rank, idxs[[1]])
    outval <- Variable(var@value@mode)

    if (var@value@mode == "logical" && logical_as_int(var@value)) {
      designator <- glue("{base_name}({str_flatten_commas(subs)})")
      return(Fortran(glue("({designator} /= 0)"), outval))
    }
    return(Fortran(glue("{base_name}({str_flatten_commas(subs)})"), outval))
  }

  if (length(idxs) != var@value@rank) {
    stop(
      "number of args to x[...] must match the rank of x, received:",
      deparse1(as.call(c(list(as.name("[")), args)))
    )
  }

  idxs <- imap(idxs, function(subscript, i) {
    # if (!idx@value@rank %in% 0:1)
    #   stop("all args to x[...] must have rank 0 or 1",
    #        deparse1(as.call(c(quote(`[`,args )))))
    switch(
      paste0(subscript@value@mode, subscript@value@rank),
      logical0 = {
        Fortran(":", Variable("integer", var@value@dims[[i]]))
      },
      logical1 = {
        # we convert to a temp integer vector, doing the equivalent of R's which()
        i <- scope_unique_var(scope, "integer")
        f <- glue("pack([({i}, {i}=1, size({subscript}))], {subscript})")
        return(Fortran(f, Variable("int", NA)))
      },
      integer0 = {
        if (drop) {
          subscript
        } else {
          Fortran(glue("{subscript}:{subscript}"), Variable("int", 1))
        }
      },
      integer1 = {
        if (drop && passes_as_scalar(subscript@value)) {
          # R drop=TRUE drops any dimensions of length 1 in the result, even when
          # the index is a length-1 range like 1:1. Fortran, however, treats a
          # triplet subscript (1:1) as an array section, so the rank would not
          # be reduced. Scalarize the index so the generated Fortran rank
          # matches the dropped R result.
          r <- attr(subscript, "r", exact = TRUE)
          while (is_call(r, quote(`(`)) && length(r) == 2L) {
            r <- r[[2L]]
          }
          while (is_call(r, quote(rev)) && length(r) == 2L) {
            r <- r[[2L]]
          }

          if (is_call(r, quote(`:`)) && length(r) == 3L) {
            scalar <- r2f(r[[2L]], scope, ..., hoist = hoist)
            if (scalar@value@mode == "double") {
              scalar <- Fortran(
                glue("int({scalar}, kind=c_ptrdiff_t)"),
                Variable("integer", scalar@value@dims)
              )
            }
            return(scalar)
          }

          if (is_call(r, quote(seq_len)) && length(r) == 2L) {
            n <- r[[2L]]
            if (is_wholenumber(n) && identical(as.integer(n), 1L)) {
              return(Fortran("1_c_int", Variable("integer")))
            }
          }

          if (is_call(r, quote(seq_along)) && length(r) == 2L) {
            return(Fortran("1_c_int", Variable("integer")))
          }

          if (is_call(r, quote(seq))) {
            info <- seq_like_parse("seq", as.list(r)[-1L], scope)
            scalar <- r2f(info$from, scope, ..., hoist = hoist)
            if (scalar@value@mode == "double") {
              scalar <- Fortran(
                glue("int({scalar}, kind=c_ptrdiff_t)"),
                Variable("integer", scalar@value@dims)
              )
            }
            return(scalar)
          }
        }

        subscript
      },
      # double0 = { },
      # double1 = { },
      stop(
        "all args to x[...] must be logical or integer of rank 0 or 1",
        deparse1(as.call(c(list(as.name("[")), args)))
      )
    )
  })

  dims <- drop_nulls(lapply(idxs, function(idx) {
    if (drop && passes_as_scalar(idx@value)) {
      return(NULL)
    }

    idx@value@dims[[1]]
  }))
  outval <- Variable(var@value@mode, dims)

  # Fortran does not allow subscripting arbitrary parenthesized expressions,
  # so if the base is an array expression (not a named array designator),
  # hoist it into a temporary array first.
  if (
    !passes_as_scalar(var@value) &&
      is.null(var@value@name)
  ) {
    tmp <- hoist$declare_tmp(mode = var@value@mode, dims = var@value@dims)
    hoist$emit(glue("{tmp@name} = {var}"))
    var <- Fortran(tmp@name, tmp)
  }

  # External logicals are passed as integer storage (0/1) and are "booleanized"
  # during symbol lowering as `(x/=0)`. When indexing, we must subscript the
  # underlying storage first, then convert the indexed value/section to logical.
  if (var@value@mode == "logical" && logical_as_int(var@value)) {
    base_name <- var@value@name %||% stop("missing array name for subscripting")
    designator <- glue("{base_name}({str_flatten_commas(idxs)})")
    Fortran(glue("({designator} /= 0)"), outval)
  } else {
    base_name <- var@value@name %||% stop("missing array name for subscripting")
    Fortran(glue("{base_name}({str_flatten_commas(idxs)})"), outval)
  }
}

# r2f-logical.R
# Handlers for logical and comparison operators: !, &, &&, |, ||, >=, >, <, <=, ==, !=

# --- Handlers ---

# ---- comparison operators ----

r2f_handlers[[">="]] <- function(args, scope, ...) {
  .[left, right] <- lapply(args, r2f, scope, ...)
  var <- conform(left@value, right@value)
  var@mode <- "logical"
  Fortran(glue("({left} >= {right})"), var)
}

r2f_handlers[[">"]] <- function(args, scope, ...) {
  .[left, right] <- lapply(args, r2f, scope, ...)
  var <- conform(left@value, right@value)
  var@mode <- "logical"
  Fortran(glue("({left} > {right})"), var)
}

r2f_handlers[["<"]] <- function(args, scope, ...) {
  .[left, right] <- lapply(args, r2f, scope, ...)
  var <- conform(left@value, right@value)
  var@mode <- "logical"
  Fortran(glue("({left} < {right})"), var)
}

r2f_handlers[["<="]] <- function(args, scope, ...) {
  .[left, right] <- lapply(args, r2f, scope, ...)
  var <- conform(left@value, right@value)
  var@mode <- "logical"
  Fortran(glue("({left} <= {right})"), var)
}

r2f_handlers[["=="]] <- function(args, scope, ...) {
  .[left, right] <- lapply(args, r2f, scope, ...)
  var <- conform(left@value, right@value)
  var@mode <- "logical"
  Fortran(glue("({left} == {right})"), var)
}

r2f_handlers[["!="]] <- function(args, scope, ...) {
  .[left, right] <- lapply(args, r2f, scope, ...)
  var <- conform(left@value, right@value)
  var@mode <- "logical"
  Fortran(glue("({left} /= {right})"), var)
}

# ---- unary logical not ----

r2f_handlers[["!"]] <- function(args, scope, ...) {
  stopifnot(length(args) == 1L)
  x <- r2f(args[[1L]], scope, ...)
  if (x@value@mode != "logical") {
    stop("'!' expects a logical value; numeric coercions not yet supported")
  }
  x <- booleanize_logical_as_int(x)
  Fortran(glue("(.not. {x})"), Variable("logical", x@value@dims))
}

register_r2f_handler(
  "is.null",
  function(args, scope, ...) {
    stopifnot(length(args) == 1L)
    arg <- args[[1L]]
    if (!is.symbol(arg)) {
      stop("is.null() is only supported on symbols", call. = FALSE)
    }
    var <- get0(as.character(arg), scope)
    if (!inherits(var, Variable) || is.null(var@optional_dummy)) {
      stop(
        "is.null() is only supported for optional arguments with NULL defaults",
        call. = FALSE
      )
    }
    Fortran(glue("(.not. present({var@optional_dummy}))"), Variable("logical"))
  }
)


# ---- binary logical operators ----

# TODO: the scalar || probably need some more type checking.
# TODO: gfortran supports implicit casting that of logical to integer when
# assigning a logical to a variable declared integer, converting `.true.` to `1`,
# but this is not a standard language feature, and Intel's `ifort` uses `-1` for `.true`.
# We should explicitly use
#   `merge(1_c_int, 0_c_int, <lgl>)` to cast logical to int.
register_r2f_handler(
  c("&", "&&", "|", "||"),
  function(args, scope, ...) {
    args <- lapply(args, r2f, scope, ...)
    args <- lapply(args, function(a) {
      if (a@value@mode != "logical") {
        stop("must be logical")
      }
      a
    })
    .[left, right] <- args
    left <- booleanize_logical_as_int(left)
    right <- booleanize_logical_as_int(right)

    operator <- switch(
      last(list(...)$calls),
      `&` = ,
      `&&` = ".and.",
      `|` = ,
      `||` = ".or."
    )

    s <- glue("{left} {operator} {right}")
    val <- conform(left@value, right@value)
    val@mode <- "logical"
    Fortran(s, val)
  }
)

### local variables with unspecified size are 'allocatable'. If they are bound
### to a named symbol, the manifest must mark it as allocatable.
###
### Generally, if an expression produces an array of unspecified size, even if
### it's never bound, it's still 'allocatable'. For example, an inline fortran
### `pack()` call likely still produces a corresponding `malloc()` in the
### generated code, regardless of if the output of `pack()` is bound to
### a symbol (in the case of pack specifically, the malloc is behind a
### _gfortran_pack() call.
###
### We can potentially link/mask `_malloc` and `_free` with a custom one that
### uses R_alloc(), which will automatically free after the .External() call
### returns. We can also pass along -fstack-arrays to gfortran and flang-new
### (llvm), and that will mostly get rid most of the malloc calls, instead
### allocating arrays on the C stack (which will automatically free on
### return/lngjmp), but that will run into issues with larger arrays (especially
### on windows)
###
### local vars of undefined sizes are allocatable. These will typically be
### allocated on the c stack if they are not too large, but may include a
### malloc+free call if they are large. Those might leak if we lngjmp
### away (e.g., due to an interrupt). This potential leak is a non-issue for
### now, since interrupts aren't supported yet, so there is no risk of lngjmp.
###
### When we do add support for interruptable quick functions, this potential
### leak could be guarded against by:
###
### a) linking malloc -> R_alloc() for the fortran compilation unit which
### would make the memory automatically be released after .External()
### return. Note that unlinke malloc(), R_alloc() is not thread safe, so we would need
### additional work for a `do concurrent` context to be supported.
###
### b) forcing all arrays to be stack allocated with -fstack-arrays passed
### to the gfortran/flang-new. This is not a great, since c stack limits are
### typically "small" and enforced by the OS.

logical_as_int <- function(var) {
  stopifnot(inherits(var, Variable))
  identical(var@mode, "logical") && isTRUE(var@logical_as_int)
}

block_tmp_allocatable_threshold <- 16L

subroutine_local_allocatable_threshold_bytes <- 256L * 1024L

var_element_count <- function(var) {
  stopifnot(inherits(var, Variable))
  dims <- var@dims
  stopifnot(is.list(dims), length(dims) > 0L)
  sizes <- vapply(
    dims,
    function(axis) {
      if (is.integer(axis) && length(axis) == 1L && !is.na(axis)) {
        axis
      } else {
        NA_integer_
      }
    },
    integer(1)
  )
  if (anyNA(sizes)) {
    return(NA_integer_)
  }
  prod(as.numeric(sizes))
}

block_tmp_element_count <- function(var) {
  var_element_count(var)
}

var_storage_bytes <- function(var) {
  stopifnot(inherits(var, Variable))
  switch(
    var@mode,
    double = 8,
    integer = 4,
    complex = 16,
    logical = 4,
    raw = 1,
    stop("var_storage_bytes() does not support mode: ", var@mode)
  )
}

subroutine_local_allocatable <- function(
  var,
  scope,
  max_stack_bytes = subroutine_local_allocatable_threshold_bytes
) {
  stopifnot(inherits(var, Variable))
  if (passes_as_scalar(var) || is.null(var@dims)) {
    return(FALSE)
  }

  # For declarations like `type(a = double(NA, NA))`, substitute_declared_sizes()
  # rewrites NA axes to `a__dim_*` symbols. Those sizes are not available for
  # explicit allocation, so treat these as implicitly-sized locals.
  self_size_names <- vapply(
    seq_along(var@dims),
    function(i) get_size_name(var, axis = as.integer(i)),
    character(1)
  )
  if (
    any(vapply(
      seq_along(var@dims),
      function(i) {
        d <- var@dims[[i]]
        is.symbol(d) && identical(as.character(d), self_size_names[[i]])
      },
      logical(1)
    ))
  ) {
    return(FALSE)
  }

  # If any dimension is deferred-shape (":"), don't emit an explicit allocate().
  # Those locals are expected to be allocated implicitly (e.g., on assignment).
  dims <- dims2f(var@dims, scope)
  if (!nzchar(dims) || grepl(":", dims, fixed = TRUE)) {
    return(FALSE)
  }

  n_elements <- var_element_count(var)
  if (is.na(n_elements)) {
    return(TRUE)
  }

  as.numeric(n_elements) * var_storage_bytes(var) > max_stack_bytes
}

block_tmp_allocatable <- function(
  var,
  scope,
  max_stack_elements = block_tmp_allocatable_threshold
) {
  stopifnot(inherits(var, Variable))
  if (
    !inherits(scope, "quickr_scope") || !identical(scope_kind(scope), "block")
  ) {
    return(FALSE)
  }
  if (passes_as_scalar(var) || is.null(var@dims)) {
    return(FALSE)
  }

  dims <- dims2f(var@dims, scope)
  if (!nzchar(dims) || grepl(":", dims, fixed = TRUE)) {
    return(FALSE)
  }

  n_elements <- block_tmp_element_count(var)
  is.na(n_elements) || n_elements > max_stack_elements
}

block_tmp_allocation_lines <- function(vars, scope) {
  stopifnot(is.list(vars))
  allocs <- lapply(vars, function(var) {
    if (!block_tmp_allocatable(var, scope)) {
      return(NULL)
    }
    dims <- dims2f(var@dims, scope)
    glue("allocate({var@name}({dims}))")
  })
  unlist(allocs, use.names = FALSE)
}

scope_vars <- function(scope) {
  vars <- as.list(scope)
  keep(vars, inherits, what = Variable)
}

scope_var_by_fortran_name <- function(scope, name) {
  stopifnot(inherits(scope, "quickr_scope"), is_string(name))
  vars <- scope_vars(scope)
  var_names <- map_chr(vars, \(var) var@name %||% "")
  idx <- match(tolower(name), tolower(var_names))
  if (is.na(idx)) {
    return(NULL)
  }
  vars[[idx]]
}

iso_c_binding_symbols <- function(
  vars,
  body_code = "",
  logical_is_c_int = logical_as_int,
  uses_rng = FALSE,
  include_errors = FALSE
) {
  stopifnot(is.list(vars), is_string(body_code), is.function(logical_is_c_int))

  used_iso_bindings <- unique(unlist(
    use.names = FALSE,
    lapply(vars, function(var) {
      stopifnot(inherits(var, Variable))
      list(
        switch(
          var@mode,
          double = "c_double",
          integer = "c_int",
          complex = "c_double_complex",
          logical = if (isTRUE(logical_is_c_int(var))) "c_int",
          raw = "c_int8_t",
          stop("unrecognized kind: ", format(var))
        ),
        lapply(var@dims, function(size) {
          syms <- all.vars(size)
          c(
            if (any(grepl("__len_$", syms))) "c_ptrdiff_t",
            if (any(grepl("__dim_[0-9]+_$", syms))) "c_int"
          )
        })
      )
    })
  ))

  # check for literal kinds used in the body
  if (grepl("\\b[0-9]+_c_int\\b", body_code)) {
    used_iso_bindings <- union(used_iso_bindings, "c_int")
  }
  if (grepl("\\bc_int\\b", body_code)) {
    used_iso_bindings <- union(used_iso_bindings, "c_int")
  }
  if (grepl("\\b[0-9]+\\.[0-9]+_c_double\\b", body_code)) {
    used_iso_bindings <- union(used_iso_bindings, "c_double")
  }
  if (grepl("\\bc_double\\b", body_code)) {
    used_iso_bindings <- union(used_iso_bindings, "c_double")
  }
  if (grepl("\\bc_ptrdiff_t\\b", body_code)) {
    used_iso_bindings <- union(used_iso_bindings, "c_ptrdiff_t")
  }

  if (isTRUE(uses_rng)) {
    used_iso_bindings <- union(used_iso_bindings, "c_double")
  }

  if (isTRUE(include_errors)) {
    used_iso_bindings <- union(
      used_iso_bindings,
      c("c_char", "c_null_char")
    )
  }

  used_iso_bindings |>
    compact() |>
    unique() |>
    sort(method = "radix")
}

emit_decl_line <- function(
  var,
  scope,
  intent = NULL,
  assumed_shape = FALSE,
  allow_allocatable = TRUE
) {
  stopifnot(inherits(var, Variable))
  if (isTRUE(var@host_associated)) {
    return(NULL)
  }

  type <- switch(
    var@mode,
    double = "real(c_double)",
    integer = "integer(c_int)",
    complex = "complex(c_double_complex)",
    logical = if (logical_as_int(var)) "integer(c_int)" else "logical",
    raw = "integer(c_int8_t)",
    stop("unrecognized kind: ", format(var))
  )

  # Block-scoped temporaries are explicitly marked allocatable so we can
  # allocate them on the heap rather than relying on compiler defaults.
  # GFortran already heap-allocates large/unknown-size locals implicitly,
  # but flang lowers block locals to `alloca` and will stack-allocate even
  # large runtime shapes, which can segfault under typical stack limits.
  # We keep small, fixed-size temps (<= 16 elements) as automatic arrays
  # to avoid allocation overhead and leave those to the compiler.
  block_allocatable <- allow_allocatable && block_tmp_allocatable(var, scope)

  dims <- if (passes_as_scalar(var)) {
    NULL
  } else if (block_allocatable) {
    sprintf("(%s)", str_flatten_commas(rep(":", var@rank)))
  } else if (assumed_shape) {
    sprintf("(%s)", str_flatten_commas(rep(":", var@rank)))
  } else {
    dims2f(var@dims, scope) |> str_flatten_commas() |> sprintf(fmt = "(%s)")
  }

  allocatable <- if (block_allocatable) {
    "allocatable"
  } else if (
    allow_allocatable &&
      !assumed_shape &&
      !is.null(dims) &&
      grepl(":", dims, fixed = TRUE)
  ) {
    "allocatable"
  }

  name <- var@name
  comment <- if (var@mode == "logical") " ! logical"

  glue(
    '{str_flatten_commas(type, intent, allocatable)} :: {name}{dims}{comment}',
    .null = ""
  )
}

emit_decls <- function(
  vars,
  scope,
  intents = NULL,
  assumed_shape = FALSE,
  allow_allocatable = TRUE
) {
  stopifnot(is.list(vars))
  if (is.null(intents)) {
    intents <- rep(list(NULL), length(vars))
    names(intents) <- names(vars)
  }
  Map(
    f = emit_decl_line,
    var = vars,
    intent = intents,
    MoreArgs = list(
      scope = scope,
      assumed_shape = assumed_shape,
      allow_allocatable = allow_allocatable
    )
  ) |>
    unlist(use.names = FALSE)
}

emit_block <- function(decls, stmts) {
  decls <- unlist(decls, use.names = FALSE)
  stmts <- unlist(stmts, use.names = FALSE)
  glue::trim(glue(
    "
    block
    {indent(str_flatten_lines(decls, \"\", stmts))}
    end block
    "
  ))
}

r2f.scope <- function(scope, include_errors = FALSE) {
  return_var_names <- unname(scope_return_var_names(scope))
  vars <- scope_vars(scope)

  local_allocs <- character()
  vars <- lapply(vars, function(var) {
    r_name <- var@r_name %||% var@name
    intent_in <- r_name %in% names(formals(scope_closure(scope)))
    intent_out <-
      (r_name %in% return_var_names) ||
      (intent_in && var@modified)

    intent <-
      if (intent_in && intent_out) {
        "intent(in out)"
      } else if (intent_in) {
        "intent(in)"
      } else if (intent_out) {
        "intent(out)"
      } else {
        NULL
      }

    type <- switch(
      var@mode,
      double = "real(c_double)",
      integer = "integer(c_int)",
      complex = "complex(c_double_complex)",
      logical = if (logical_as_int(var)) "integer(c_int)" else "logical",
      raw = "integer(c_int8_t)",
      stop("unrecognized kind: ", format(var))
    )

    dims <- if (passes_as_scalar(var)) {
      NULL
    } else {
      dims2f(var@dims, scope) |> str_flatten_commas() |> sprintf(fmt = "(%s)")
    }

    # In subroutines, locals declared with unspecified dims (NA -> `a__dim_*`)
    # are emitted as deferred-shape allocatables and rely on implicit allocation.
    if (
      is.null(intent) &&
        !is.null(dims) &&
        any(vapply(
          seq_along(var@dims),
          function(i) {
            d <- var@dims[[i]]
            is.symbol(d) &&
              identical(as.character(d), get_size_name(var, axis = i))
          },
          logical(1)
        ))
    ) {
      dims <- sprintf("(%s)", str_flatten_commas(rep(":", var@rank)))
    }

    heap_local <- is.null(intent) && subroutine_local_allocatable(var, scope)
    if (isTRUE(heap_local)) {
      # Deferred-shape allocatable avoids large stack allocations (notably flang).
      dims <- sprintf("(%s)", str_flatten_commas(rep(":", var@rank)))
      local_allocs <<- c(
        local_allocs,
        glue("allocate({var@name}({dims2f(var@dims, scope)}))")
      )
    }

    allocatable <- if (isTRUE(heap_local)) {
      "allocatable"
    } else if (!is.null(dims) && grepl(":", dims, fixed = TRUE)) {
      "allocatable"
    }

    if (intent_in && intent_out && !is.null(allocatable)) {
      stop("all input and output vars must have a fully defined shape")
    }

    name <- var@name
    comment <- if (var@mode == "logical") " ! logical"

    glue(
      '{str_flatten_commas(type, intent, allocatable)} :: {name}{dims}{comment}',
      .null = ""
    )
  })

  # vars that will be visible in the C bridge, either as an input or output
  non_local_var_names <- unique(c(
    names(formals(scope_closure(scope))),
    return_var_names
  ))

  # collect all size_names; sort so non-locals are declared first.
  size_names <- unique(unlist(lapply(non_local_var_names, function(name) {
    var <- scope[[name]]
    lapply(var@dims, all.names, functions = FALSE, unique = TRUE)
  }))) |>
    setdiff(names(formals(scope_closure(scope))))
  if (length(names(formals(scope_closure(scope))))) {
    formal_vars <- mget(names(formals(scope_closure(scope))), scope)
    formal_fortran_names <- unique(map_chr(formal_vars, \(var) {
      var@name %||% ""
    }))
    formal_fortran_names <- formal_fortran_names[nzchar(formal_fortran_names)]
    size_names <- setdiff(size_names, formal_fortran_names)
  }
  if (is.null(size_names)) {
    size_names <- character()
  }

  sizes <- lapply(size_names, function(name) {
    kind <- if (endsWith(name, "_len_")) "c_ptrdiff_t" else "c_int"
    glue("integer({kind}), intent(in), value :: {name}")
  })

  manifest <- compact(list(
    sizes = sizes,
    error = if (isTRUE(include_errors)) quickr_error_manifest_lines(),
    args = vars[non_local_var_names],
    locals = vars[setdiff(names(vars), non_local_var_names)]
  ))

  manifest <- imap(manifest, \(declarations, category) {
    str_flatten_lines(paste("!", category), declarations)
  }) |>
    str_flatten("\n\n")

  manifest <- str_flatten_lines("! manifest start", manifest, "! manifest end")
  attr(manifest, "local_allocations") <- local_allocs

  # symbols that must come in as args to the subroutine
  # # method="radix" for locale-independent stable order.
  signature <- unique(c(
    map_chr(mget(non_local_var_names, scope), \(var) var@name),
    sort(size_names, method = "radix"),
    if (isTRUE(include_errors)) quickr_error_arg_names()
  ))
  attr(manifest, "signature") <- signature

  manifest
}


## fortran precedence order
##   ** (exp)
##   * /
##   + -
##
## R prededence order
##   ^
##   - +
##   %/% %%
##   * /

## generally, we just deparse() to convert an axis size.
## except for NA, which becomes ":"

dims2f_eval_base_env <- new.env(parent = emptyenv())
dims2f_eval_base_env[["("]] <- baseenv()[["("]]

# any call always evaluates to a string.
# every argument will be either:
# - NA  -> translates to ":"
# - a symbol -> translates to deparsed string
# - a call  ->

dims2f_eval_base_env[["+"]] <- function(e1, e2) glue("({e1} + {e2})")
dims2f_eval_base_env[["-"]] <- function(e1, e2) glue("({e1} - {e2})")
dims2f_eval_base_env[["*"]] <- function(e1, e2) glue("({e1} * {e2})")
dims2f_eval_base_env[["/"]] <- function(e1, e2) glue("real({e1}) / real({e2})")
# dividing integers truncates towards 0
dims2f_eval_base_env[["%/%"]] <- function(e1, e2) glue("int({e1}) / int({e2})")
dims2f_eval_base_env[["%%"]] <- function(e1, e2) {
  glue("mod(int({e1}), int({e2}))")
}
dims2f_eval_base_env[["^"]] <- function(e1, e2) glue("({e1})**({e2})")
dims2f_eval_base_env[["abs"]] <- function(x) glue("abs({x})")
dims2f_eval_base_env[["length"]] <- function(x) {
  if (is.symbol(x)) {
    glue("size({as.character(x)})")
  } else {
    glue("size({x})")
  }
}
dims2f_eval_base_env[["nrow"]] <- function(x) {
  if (is.symbol(x)) {
    glue("size({as.character(x)}, 1)")
  } else {
    glue("size({x}, 1)")
  }
}
dims2f_eval_base_env[["ncol"]] <- function(x) {
  if (is.symbol(x)) {
    glue("size({as.character(x)}, 2)")
  } else {
    glue("size({x}, 2)")
  }
}
dims2f_eval_base_env[["dim"]] <- function(x) x
dims2f_eval_base_env[["["]] <- function(x, i) {
  if (!is_wholenumber(i)) {
    stop("dim(x)[axis] requires integer axis")
  }
  if (is.symbol(x)) {
    glue("size({as.character(x)}, {as.integer(i)})")
  } else {
    glue("size({x}, {as.integer(i)})")
  }
}
dims2f_eval_base_env[["min"]] <- function(...) {
  args <- list(...)
  glue("min({str_flatten_commas(args)})")
}
dims2f_eval_base_env[["max"]] <- function(...) {
  args <- list(...)
  glue("max({str_flatten_commas(args)})")
}


dims2f <- function(dims, scope) {
  syms <- unique(unlist(lapply(dims, \(d) if (is.language(d)) all.vars(d))))
  vars <- lapply(syms, function(sym) {
    scope_fortran_symbol(as.symbol(sym), scope)
  })
  names(vars) <- syms
  eval_env <- list2env(vars, parent = dims2f_eval_base_env)
  dims <- map_chr(dims, function(d) {
    d <- eval(d, eval_env)
    if (is.symbol(d)) {
      as.character(d)
    } else if (is_wholenumber(d)) {
      as.character(d)
    } else if (is_scalar_na(d)) {
      ":"
    } else if (is_string(d)) {
      d
    } else if (inherits(d, Variable)) {
      # a locally allocated var that is a return var
      if (!d@modified && d@is_arg) {
        return(d@name)
      }
      stop("unexpected axis size value")
    }
  })
  if (!length(dims) || identical(dims, "1")) {
    ""
  } else {
    str_flatten_commas(dims)
  }
}

skip_on_cran()

test_that("large local arrays are emitted as allocatable + allocate()", {
  f <- function(x) {
    declare(type(x = double(16, 64, 64, 16)))
    a <- x + x
    b <- a + x
    b
  }

  fsub <- r2f(f)
  code <- as.character(fsub)

  expect_match(code, "allocatable[^\\n]*:: a\\(")
  expect_match(code, "allocate\\(a\\(")

  fq <- quick(f)
  set.seed(1)
  x <- array(runif(16 * 64 * 64 * 16), dim = c(16, 64, 64, 16))
  expect_identical(f(x), fq(x))
})

test_that("multiple local arrays do not stack overflow under flang", {
  f <- function(x) {
    declare(type(x = double(16, 48, 48, 16)))
    a <- x + x
    b <- a + x
    c <- b + x
    c
  }

  fq <- quick(f)
  set.seed(2)
  x <- array(runif(16 * 48 * 48 * 16), dim = c(16, 48, 48, 16))
  expect_identical(f(x), fq(x))
})

test_that("local allocatable threshold accounts for storage mode", {
  mk <- function(mode, nrow = 300L, ncol = 300L) {
    force(mode)
    force(nrow)
    force(ncol)
    if (identical(mode, "integer")) {
      function(x) {
        declare(type(x = integer(nrow, ncol)))
        a <- x + x
        out <- a + x
        out
      }
    } else if (identical(mode, "complex")) {
      function(x) {
        declare(type(x = complex(nrow, ncol)))
        a <- x + x
        out <- a + x
        out
      }
    } else if (identical(mode, "logical")) {
      function(x) {
        declare(type(x = logical(nrow, ncol)))
        a <- !x
        out <- a & x
        out
      }
    } else {
      stop("unknown mode: ", mode)
    }
  }

  modes <- c("integer", "complex", "logical")
  for (mode in modes) {
    f <- mk(mode)
    code <- as.character(r2f(f))
    expect_match(code, "allocatable[^\\n]*:: a\\(")
    expect_match(code, "allocate\\(a\\(")
  }

  set.seed(3)
  x_int <- matrix(sample.int(100, 300L * 300L, replace = TRUE), nrow = 300L)
  expect_identical(quick(mk("integer"))(x_int), mk("integer")(x_int))

  set.seed(4)
  x_cplx <- matrix(
    complex(
      real = runif(300L * 300L),
      imaginary = runif(300L * 300L)
    ),
    nrow = 300L
  )
  expect_equal(quick(mk("complex"))(x_cplx), mk("complex")(x_cplx))

  set.seed(5)
  x_lgl <- matrix(
    sample(c(TRUE, FALSE), 300L * 300L, replace = TRUE),
    nrow = 300L
  )
  expect_identical(quick(mk("logical"))(x_lgl), mk("logical")(x_lgl))
})

test_that("unknown local element counts are treated as allocatable", {
  f <- function(x, n) {
    declare(type(n = integer(1)), type(x = double(n, n)))
    a <- x + x
    out <- a + x
    out
  }

  code <- as.character(r2f(f))
  expect_match(code, "allocatable[^\\n]*:: a\\(")
  expect_match(code, "allocate\\(a\\(")

  set.seed(6)
  x <- matrix(runif(40 * 40), nrow = 40)
  expect_identical(quick(f)(x, 40L), f(x, 40L))
})

test_that("raw locals are sized as 1 byte for heap allocation decisions", {
  f <- function(x) {
    declare(type(x = raw(513L, 513L)))
    a <- x
    b <- a
    b
  }

  code <- as.character(r2f(f))
  expect_match(code, "allocatable[^\\n]*:: a\\(")
  expect_match(code, "allocate\\(a\\(")
})

test_that("heap sizing accounts for complex and logical storage", {
  # Use local declarations with fixed dims so var_element_count() is known and
  # var_storage_bytes() is exercised.
  f_complex <- function() {
    declare(type(a = complex(10L, 10L)))
    1
  }
  f_logical <- function() {
    declare(type(a = logical(10L, 10L)))
    1
  }

  # Codegen is enough; no need to run compiled code here.
  expect_match(as.character(r2f(f_complex)), "complex\\(", perl = TRUE)
  expect_match(as.character(r2f(f_logical)), "logical|! logical", perl = TRUE)
})

test_that("deferred-shape locals are allocatable without explicit allocate()", {
  f <- function(x) {
    declare(type(x = double(NA, NA)), type(a = double(NA, NA)))
    a <- x
    1
  }

  code <- as.character(r2f(f))
  expect_match(code, "allocatable[^\\n]*:: a\\(")
  expect_match(code, ":: a\\(:,\\s*:\\)")
  expect_no_match(code, "allocate\\(a\\(")
})

test_that("deferred-shape locals (self-sized dims) snapshot", {
  # For locals declared with unknown sizes like double(NA, NA), the declared
  # sizes are rewritten to `a__dim_*` symbols. Those sizes are not available for
  # explicit allocation, so we rely on implicit allocation and emit `a(:, :)`.
  f <- function(x) {
    declare(type(x = double(NA, NA)), type(a = double(NA, NA)))
    a <- x
    1
  }

  expect_snapshot(r2f(f))

  x <- matrix(as.double(1:6), nrow = 2)
  expect_quick_identical(f, x)
})

skip_on_cran()

test_that("var_storage_bytes() fails fast for unsupported Variable@mode", {
  v <- Variable(mode = "character", dims = list(10L))

  # character is an allowed Variable@mode, but storage sizing must not silently
  # return NULL (which can lead to length-0 logicals in heap-allocation code).
  expect_error(
    quickr:::var_storage_bytes(v),
    "character|unsupported|var_storage_bytes",
    ignore.case = TRUE
  )
})

# Handler registry and registration helpers.

r2f_handlers <- new.env(parent = emptyenv())

## ??? export as S7::convert() methods?
register_r2f_handler <- function(
  name,
  fun,
  dest_supported = NULL,
  dest_infer = NULL,
  match_fun = TRUE
) {
  stopifnot(is.function(fun))

  handler <- if (inherits(fun, R2FHandler)) fun else R2FHandler(fun)

  if (!is.null(dest_supported)) {
    handler@dest_supported <- isTRUE(dest_supported)
  }

  if (!is.null(dest_infer)) {
    handler@dest_infer <- dest_infer
    # covr rewrites function bindings in the namespace; resolving by name at call
    # time ensures instrumented/rebound functions are respected. We keep the
    # function object for robustness (e.g., anonymous functions) and additionally
    # store the name when `dest_infer` is passed as a symbol.
    dest_infer_expr <- substitute(dest_infer)
    if (is.symbol(dest_infer_expr)) {
      handler@dest_infer_name <- as.character(dest_infer_expr)
    } else {
      handler@dest_infer_name <- NULL
    }
  }

  if (isTRUE(match_fun)) {
    handler@match_fun <- NULL
  } else if (
    is.null(match_fun) || isFALSE(match_fun) || is.function(match_fun)
  ) {
    handler@match_fun <- match_fun
  } else {
    stop("match_fun must be TRUE, FALSE, NULL, or a function")
  }

  for (nm in name) {
    r2f_handlers[[nm]] <- handler
  }
  invisible(handler)
}

# Assignment-related r2f handlers and helpers

assignment_dispatch_call_target <- function(
  target,
  args,
  scope,
  ...,
  hoist,
  assign_op
) {
  if (!is.call(target)) {
    return(NULL)
  }
  target_callable <- target[[1L]]
  stopifnot(is.symbol(target_callable))
  name <- as.symbol(paste0(as.character(target_callable), assign_op))
  handler <- get_r2f_handler(name)
  handler(args, scope, ..., hoist = hoist)
}

assignment_extract_fallthrough <- function(rhs) {
  rhs_unwrapped <- rhs
  while (is_call(rhs_unwrapped, "(") && length(rhs_unwrapped) == 2L) {
    rhs_unwrapped <- rhs_unwrapped[[2L]]
  }
  if (
    (is_call(rhs_unwrapped, "<-") || is_call(rhs_unwrapped, "=")) &&
      length(rhs_unwrapped) == 3L &&
      is.symbol(rhs_unwrapped[[2L]])
  ) {
    return(list(
      target = rhs_unwrapped[[2L]],
      rhs = rhs_unwrapped[[3L]]
    ))
  }
  NULL
}

assignment_fortran_name <- function(name, scope) {
  stopifnot(is_string(name))
  base <- fortranize_name(name)
  if (scope_is_closure(scope) && inherits(get0(name, scope), Variable)) {
    make_shadow_fortran_name(scope, base)
  } else {
    base
  }
}

assignment_is_local_closure_call <- function(rhs, scope) {
  is.call(rhs) &&
    is.symbol(rhs[[1L]]) &&
    inherits(scope[[as.character(rhs[[1L]])]], LocalClosure)
}

register_r2f_handler(
  "<-",
  function(args, scope, ..., hoist = NULL) {
    target <- args[[1L]]
    if (
      !is.null(
        out <- assignment_dispatch_call_target(
          target,
          args,
          scope,
          ...,
          hoist = hoist,
          assign_op = "<-"
        )
      )
    ) {
      return(out)
    }

    # It sure seems like it's be nice if the Fortran() constructor
    # took mode and dims as args directly,
    # without needing to go through Variable...
    stopifnot(is.symbol(target))
    name <- as.character(target)

    rhs <- args[[2L]]

    # Fall-through assignment: `a <- b <- expr` (or `a <- (b <- expr)`).
    # R evaluates this right-to-left and returns the assigned value, i.e.
    # `a <- (b <- expr)` is equivalent to `b <- expr; a <- b`.
    if (!is.null(fallthrough <- assignment_extract_fallthrough(rhs))) {
      inner_stmt <- r2f(
        call("<-", fallthrough$target, fallthrough$rhs),
        scope,
        ...,
        hoist = hoist
      )
      outer_stmt <- r2f(
        call("<-", target, fallthrough$target),
        scope,
        ...,
        hoist = hoist
      )
      return(Fortran(str_flatten_lines(inner_stmt, outer_stmt)))
    }

    # Local closure definition: `f <- function(i) ...`
    if (is_function_call(rhs)) {
      scope[[name]] <- as_local_closure(
        rhs,
        environment(scope_closure(scope)),
        name = name
      )
      return(Fortran(""))
    }

    # Local closure call: `x <- f(...)` where `f <- function(...) ...` in scope.
    if (assignment_is_local_closure_call(rhs, scope)) {
      return(compile_closure_call_assignment(
        name,
        rhs,
        scope,
        ...,
        hoist = hoist
      ))
    }

    # Targeted higher-order lowering: `out <- sapply(seq_along(x), f)`
    if (is_sapply_call(rhs)) {
      parallel <- take_pending_parallel(scope)
      return(
        compile_sapply_assignment(
          name,
          rhs,
          scope,
          ...,
          hoist = hoist,
          parallel = parallel
        )
      )
    }

    rhs_unwrapped <- unwrap_parens(rhs)
    if (is_call(rhs_unwrapped, "svd")) {
      return(compile_svd_assignment(
        name,
        rhs_unwrapped,
        scope,
        ...,
        hoist = hoist
      ))
    }

    dest_allowed <- dest_supported_for_call(rhs)

    # If target already exists (declared), thread destination hint to a single BLAS-capable child
    var <- get0(name, scope, inherits = FALSE)
    existing_binding <- !is.null(var) && inherits(var, Variable)
    inferred_var <- NULL
    fortran_name <- NULL
    if (!existing_binding && dest_allowed) {
      inferred_var <- dest_infer_for_call(rhs, scope)
      fortran_name <- assignment_fortran_name(name, scope)
    }

    if (existing_binding) {
      value <- if (dest_allowed) {
        r2f(rhs, scope, ..., hoist = hoist, dest = var)
      } else {
        r2f(rhs, scope, ..., hoist = hoist)
      }
    } else if (inherits(inferred_var, Variable)) {
      var <- inferred_var
      var@name <- fortran_name
      value <- r2f(rhs, scope, ..., hoist = hoist, dest = var)
    } else {
      value <- r2f(rhs, scope, ..., hoist = hoist)
    }

    # immutable / copy-on-modify usage of Variable()
    if (!existing_binding) {
      # The var does not exist -> this is a binding to a new symbol
      # Create a fresh Variable carrying only mode/dims and a new name.
      if (!inherits(var, Variable)) {
        src <- value@value
        var <- Variable(mode = src@mode, dims = src@dims)
      }
      if (
        inherits(value, Fortran) &&
          inherits(value@value, Variable) &&
          identical(value@value@mode, "logical") &&
          logical_as_int(value@value) &&
          !isTRUE(value@logical_booleanized)
      ) {
        # Keep bind(c) logicals as integer storage when the RHS is an
        # integer-backed expression (e.g. rev(x) for external logicals).
        var@logical_as_int <- TRUE
      }
      if (is.null(fortran_name)) {
        fortran_name <- assignment_fortran_name(name, scope)
      }
      var@r_name <- name
      var@name <- fortran_name
      # keep a reference to the R expression assigned, if available
      tryCatch(
        var@r <- attr(value, "r", TRUE),
        error = function(e) NULL
      )
      scope[[name]] <- var
    } else {
      # The var already exists, this assignment is a modification / reassignment
      if (is.null(var@r_name)) {
        var@r_name <- name
      }
      if (
        is.null(var@mode) &&
          inherits(value@value, Variable) &&
          !is.null(value@value@mode)
      ) {
        var@mode <- value@value@mode
        var@dims <- value@value@dims
      }
      check_assignment_compatible(var, value@value)
      var@modified <- TRUE
      # could probably drop this @modified property, and instead track
      # if the var populated by declare is identical at the end (e.g., perhaps by
      # address, or by attaching a unique id to each var, or ???)
      assign(name, var, scope)
    }

    # If child consumed destination (e.g., BLAS wrote directly into LHS), skip assignment
    if (inherits(value, Fortran) && isTRUE(value@writes_to_dest)) {
      Fortran("")
    } else {
      Fortran(glue("{var@name} = {value}"))
    }
  }
)

register_r2f_handler(
  "[<-",
  function(args, scope = NULL, ...) {
    # TODO: handle logical subsetting here, which must become a where a construct like:
    #   x[lgl] <- val
    # becomes
    # where (lgl)
    #   x = val
    # end where
    # ! but if {va} references {x}, it will only see the subset x, not the full {x}
    # e.g.,
    # sum(x) is not the same as `where lgl \n sum(x) \n end where`
    # ditto for ifelse() ?
    # e <- as.list(e)

    stopifnot(is_call(target_call <- args[[1L]], "["))

    lhs <- compile_subscript_lhs(target_call, scope, ..., target = "local")
    value <- r2f(args[[2L]], scope, ...)

    Fortran(str_flatten_lines(lhs$pre, glue("{lhs$lhs} = {value}")))
  }
)

register_r2f_handler(
  "<<-",
  function(args, scope, ..., hoist = NULL) {
    if (is.null(scope) || !identical(scope_kind(scope), "closure")) {
      stop("<<- is only supported inside local closures")
    }

    target <- args[[1L]]
    if (
      !is.null(
        out <- assignment_dispatch_call_target(
          target,
          args,
          scope,
          ...,
          hoist = hoist,
          assign_op = "<<-"
        )
      )
    ) {
      return(out)
    }

    stopifnot(is.symbol(target))
    name <- as.character(target)

    formal_names <- names(formals(scope_closure(scope))) %||% character()
    if (name %in% formal_names) {
      stop("<<- targets must not shadow closure formals: ", name)
    }

    forbidden <- scope_forbid_superassign(scope)
    if (name %in% forbidden) {
      stop("closure must not superassign to its output variable: ", name)
    }

    host_scope <- scope_host_scope(scope) %||%
      stop("internal error: missing host scope")
    host_var <- get0(name, host_scope)
    if (!inherits(host_var, Variable)) {
      stop(
        "<<- targets must resolve to an existing variable in the enclosing quick() scope: ",
        name
      )
    }

    host_var@modified <- TRUE
    host_scope[[name]] <- host_var

    value <- r2f(args[[2L]], scope, ..., hoist = hoist)
    check_assignment_compatible(host_var, value@value)

    Fortran(glue("{host_var@name} = {value}"))
  }
)

register_r2f_handler(
  "[<<-",
  function(args, scope, ..., hoist = NULL) {
    if (is.null(scope) || !identical(scope_kind(scope), "closure")) {
      stop("<<- is only supported inside local closures")
    }

    stopifnot(is_call(target <- args[[1L]], "["))
    subset_call <- target

    base <- subset_call[[2L]]
    if (!is.symbol(base)) {
      stop("only superassignment to x[...] is supported")
    }
    name <- as.character(base)

    formal_names <- names(formals(scope_closure(scope))) %||% character()
    if (name %in% formal_names) {
      stop("<<- targets must not shadow closure formals: ", name)
    }

    forbidden <- scope_forbid_superassign(scope)
    if (name %in% forbidden) {
      stop("closure must not superassign to its output variable: ", name)
    }

    host_scope <- scope_host_scope(scope) %||%
      stop("internal error: missing host scope")
    host_var <- get0(name, host_scope)
    if (!inherits(host_var, Variable)) {
      stop(
        "<<- targets must resolve to an existing variable in the enclosing quick() scope: ",
        name
      )
    }

    host_var@modified <- TRUE
    host_scope[[name]] <- host_var

    lhs <- compile_subscript_lhs(
      subset_call,
      scope,
      ...,
      hoist = hoist,
      target = "host"
    )
    value <- r2f(args[[2L]], scope, ..., hoist = hoist)
    Fortran(glue("{lhs$lhs} = {value}"))
  }
)

register_r2f_handler("=", r2f_handlers[["<-"]])

#' @import S7
NULL

new_setter <- function(
  coerce = NULL,
  coerce_null = FALSE,
  set_once = FALSE,
  env = parent.frame(2L)
) {
  if (is.null(coerce) || isFALSE(coerce) && isFALSE(set_once)) {
    return()
  }

  bind_name <- quote(
    name <- as.character(last(attr(self, ".setting_prop", TRUE)))
  )

  check_set_once <- if (set_once) {
    quote(
      if (!is.null(prop(self, name))) {
        stop(name, " can only be set once")
      }
    )
  }

  rebind_coerced_value <-
    if (is.null(coerce) || isFALSE(coerce)) {
      NULL
    } else if (isTRUE(coerce)) {
      quote(
        value <- convert(
          from = value,
          to = S7_class(self)@properties[[as.character(name)]]$class
        )
      )
    } else if (is.function(coerce) || is.symbol(coerce)) {
      bquote(value <- .(coerce)(value))
    } else if (is.language(coerce)) {
      bquote(value <- .(coerce))
    } else {
      stop("coerce must be TRUE, FALSE, NULL, a function, a symbol, or a call")
    }

  if (!coerce_null && !is.null(rebind_coerced_value)) {
    rebind_coerced_value <- bquote(if (!is.null(value)) .(rebind_coerced_value))
  }

  set <- quote(`prop<-`(
    object = self,
    name = name,
    check = FALSE,
    value = value
  ))

  new_function(
    args = alist(self = , value = ),
    body = as.call(c(
      quote(`{`),
      bind_name,
      check_set_once,
      rebind_coerced_value,
      set
    )),
    env = env
  )
}


new_scalar_validator <- function(
  allow_null = FALSE,
  allow_na = FALSE,
  additional_checks = NULL,
  env = parent.frame(2L)
) {
  checks <- c(
    if (allow_null) quote(if (is.null(value)) return()),
    quote(if (length(value) != 1L) return("must be a scalar")),
    if (!allow_na) quote(if (anyNA(value)) return("must not be NA")),
    additional_checks
  )

  new_function(
    args = alist(value = ),
    body = as.call(c(quote(`{`), checks)),
    env = parent.frame(2L)
  )
}


prop_bool <- function(
  default,
  allow_null = FALSE,
  allow_na = FALSE,
  set_once = FALSE
) {
  stopifnot(is_bool(set_once), is_bool(allow_null), is_bool(allow_na))

  new_property(
    class = if (allow_null) NULL | class_logical else class_logical,
    setter = new_setter(set_once = set_once),
    validator = new_scalar_validator(
      allow_null = allow_null,
      allow_na = allow_na
    ),
    default = default
  )
}


prop_string <- function(
  default = NULL,
  allow_null = FALSE,
  allow_na = FALSE,
  coerce = FALSE,
  set_once = FALSE
) {
  stopifnot(is_bool(set_once), is_bool(allow_null), is_bool(allow_na))

  if (isTRUE(coerce)) {
    coerce <- quote(as.character)
  }

  new_property(
    class = if (allow_null) NULL | class_character else class_character,
    default = default,
    validator = new_scalar_validator(allow_null = allow_null),
    setter = new_setter(
      coerce = coerce,
      coerce_null = !allow_null,
      set_once = set_once
    )
  )
}


prop_wholenumber <- function(
  default = NULL,
  allow_null = FALSE,
  allow_na = FALSE,
  coerce = TRUE,
  set_once = FALSE
) {
  stopifnot(is_bool(set_once), is_bool(allow_null), is_bool(allow_na))

  if (isTRUE(coerce)) {
    coerce <- quote(
      if (is_wholenumber(value)) {
        as.integer(value)
      } else {
        stop("@", name, " must be a whole number, but received: ", value)
      }
    )
  }

  new_property(
    class = if (allow_null) NULL | class_integer else class_integer,
    default = as.integer(default),
    setter = new_setter(
      coerce = coerce,
      coerce_null = !allow_null,
      set_once = set_once
    ),
    validator = new_scalar_validator(allow_null = allow_null)
  )
}


prop_enum <- function(
  values,
  nullable = FALSE,
  default = if (nullable) NULL else values[1],
  exact = FALSE,
  set_once = FALSE
) {
  stopifnot(
    "values must be a character vector of length >= 2 without any NA" = is.character(
      values
    ) &&
      length(values) >= 2 &&
      !anyNA(values)
  )

  coerce <- if (exact) {
    NULL
  } else {
    bquote(
      if (length(value) == 1L && !anyNA(i <- charmatch(value, .(values)))) {
        .(values)[i]
      } else {
        value
      }
    )
  }

  display_values <- glue_collapse(
    single_quote(values),
    sep = ", ",
    last = ", or "
  )
  msg <- sprintf("must be either %s, not '", display_values)
  validator <- new_scalar_validator(
    allow_null = nullable,
    additional_checks = bquote(
      if (!match(value, .(values), nomatch = 0L)) {
        return(paste0(.(msg), value, "'."))
      }
    )
  )

  new_property(
    class = if (nullable) NULL | class_character else class_character,
    setter = new_setter(
      coerce = coerce,
      coerce_null = !nullable,
      set_once = set_once
    ),
    validator = validator,
    default = default
  )
}


.atomic_type_names <- c(
  "integer",
  "logical",
  "double",
  "character",
  "raw",
  "complex"
)


# the print method for this should only print non-null values
Variable := new_class(
  properties = list(
    mode = prop_enum(.atomic_type_names, nullable = TRUE, set_once = FALSE),

    dims = new_property(
      # NULL means scalar
      NULL | class_list,
      setter = function(self, value) {
        if (!length(value)) {
          return(self)
        }

        value <- switch(
          typeof(value),
          logical = ,
          integer = ,
          double = as.list(value),
          language = ,
          symbol = list(value), # implicit rank-1
          list = value,
          stop("@dims must be a list")
        )

        value <- lapply(value, \(axis) {
          if (is.language(axis)) {
            axis
          } else if (is_wholenumber(axis) || is_scalar_na(axis)) {
            as.integer(axis)
          } else {
            stop(sprintf(
              "%s@dims must be a list of language or scalar integers, not %s",
              self@name %||% '',
              axis
            ))
          }
        })

        self@dims <- value
        self
      } # dims$setter
    ), # dims = new_property()

    name = prop_string(
      allow_null = TRUE,
      coerce = quote(switch(
        typeof(value),
        symbol = as.character(value),
        value
      )),
      set_once = FALSE #TRUE
    ),

    r_name = prop_string(
      allow_null = TRUE,
      coerce = quote(switch(
        typeof(value),
        symbol = as.character(value),
        value
      )),
      set_once = FALSE
    ),

    rank = new_property(
      class_integer,
      getter = function(self) {
        length(self@dims)
      }
    ),

    modified = prop_bool(default = FALSE),

    loop_is_singleton = prop_bool(default = FALSE),

    r = new_property(
      NULL | class_language | class_atomic,
      setter = function(self, value) {
        # custom setter to workaround https://github.com/RConsortium/S7/issues/511
        attr(self, "r") <- value
        self
      }
    ),

    is_arg = prop_bool(default = FALSE),

    is_return = prop_bool(default = FALSE),

    # TRUE for closure args and return values, FALSE for all other vars.
    is_external = new_property(
      class_logical,
      getter = function(self) {
        self@is_arg || self@is_return
      }
    ),

    is_scalar = new_property(
      class_logical,
      getter = function(self) {
        self@rank == 0 || identical(self@dims, list(1L))
      }
    ),

    # When TRUE, Fortran/C interfaces should treat logicals as integer(c_int)
    # storage (0/1) rather than Fortran LOGICAL.
    logical_as_int = prop_bool(default = FALSE),

    # TRUE when the variable is available via host association and should not
    # be redeclared in the local scope.
    host_associated = prop_bool(default = FALSE),

    # When set, references to this variable should treat the named dummy
    # argument as an optional input (e.g., is.null() -> .not. present()).
    optional_dummy = prop_string(default = NULL, allow_null = TRUE)
  ),

  validator = function(self) {
    if (isTRUE(self@logical_as_int) && !identical(self@mode, "logical")) {
      "`logical_as_int` can only be TRUE when `mode` is 'logical'"
    }
  }
)

# method(print, Variable) <- function(x, ...) {
#
# }

Fortran := new_class(
  class_character,

  properties = list(
    value = NULL | Variable,

    # Metadata flags used during compilation/lowering. Keep these as explicit
    # properties rather than ad-hoc attributes so they are discoverable and
    # consistently propagated with the Fortran object.
    logical_booleanized = prop_bool(default = FALSE),
    writes_to_dest = prop_bool(default = FALSE),

    r = new_property(
      # custom setter only to workaround https://github.com/RConsortium/S7/issues/511
      NULL | class_language | class_atomic,
      setter = function(self, value) {
        attr(self, "r") <- value
        self
      }
    )
  ),

  validator = function(self) {
    if (length(self) != 1L) {
      "must be a length 1 string"
    }
  }
)

SvdResult := new_class(
  properties = list(
    d = Variable,
    u = NULL | Variable,
    v = NULL | Variable
  )
)

LocalClosure := new_class(
  properties = list(
    name = prop_string(default = NULL, allow_null = TRUE),
    fun = class_function
  )
)


FortranSubroutine := new_class(
  Fortran,
  properties = list(
    name = prop_string(),
    signature = class_character,
    closure = class_function,
    scope = NULL | class_environment,
    c_bridge = S7::new_property(
      NULL | class_character,
      getter = function(self) {
        make_c_bridge(self) %error% NULL
      }
    )
  )
)

R2FHandler := new_class(
  class_function,
  properties = list(
    dest_supported = prop_bool(default = FALSE),
    dest_infer = new_property(NULL | class_function),
    dest_infer_name = prop_string(default = NULL, allow_null = TRUE),
    # When NULL, r2f will resolve the callable by name and use match.call().
    # When FALSE, r2f will not attempt match.call().
    match_fun = new_property(
      NULL | class_function | class_logical,
      default = NULL
    )
  )
)

try_prop <- function(object, name) S7::prop(object, name) %error% NULL

emit <- function(..., sep = "", end = "\n") cat(..., end, sep = sep)

method(format, Variable) <- function(x, ...) {
  capture.output(str(x))
}

method(as.character, Variable) <- function(x, ...) {
  x@name %||% stop("Variable does not have a name")
}

method(print, Fortran) <- function(x, ...) {
  emit(trimws(x), end = "\n\n")
  for (prop_name in c("value", "r", "c_bridge")) {
    if (!is.null(prop_val <- try_prop(x, prop_name))) {
      emit("@", prop_name, ": ", trimws(indent(format(prop_val))))
    }
  }
}

# Unit tests for internal S7 helpers/classes

skip_on_cran()

test_that("prop helpers implement coercion, validation and set-once behavior", {
  Test <- S7::new_class(
    name = "Test",
    properties = list(
      s = quickr:::prop_string(
        default = NULL,
        allow_null = TRUE,
        coerce = TRUE,
        set_once = TRUE
      ),
      n = quickr:::prop_wholenumber(
        default = 1,
        allow_null = TRUE,
        coerce = TRUE
      ),
      e = quickr:::prop_enum(
        values = c("alpha", "beta"),
        nullable = TRUE,
        exact = FALSE
      )
    )
  )

  obj <- Test()

  obj@s <- 123
  expect_identical(obj@s, "123")
  expect_error(obj@s <- "again", "can only be set once")

  obj@n <- 2
  expect_identical(obj@n, 2L)
  expect_error(obj@n <- 2.5, "must be a whole number")

  obj@e <- "alp"
  expect_identical(obj@e, "alpha")
  obj@e <- "gamma"
  expect_error(S7::validate(obj), "must be either")
})

test_that("Variable dims setter accepts common forms", {
  v <- quickr:::Variable(name = "x", mode = "integer", dims = c(2, NA))
  expect_identical(v@dims, list(2L, NA_integer_))
  expect_identical(v@rank, 2L)

  v2 <- quickr:::Variable(name = quote(foo), mode = "double", dims = quote(n))
  expect_identical(v2@name, "foo")
  expect_true(is.symbol(v2@dims[[1L]]))

  v3 <- quickr:::Variable(name = "y", mode = "double", dims = quote(n + 1L))
  expect_true(is.call(v3@dims[[1L]]))

  expect_error(
    quickr:::Variable(name = "bad", mode = "integer", dims = list("x")),
    "@dims must be a list"
  )
})

test_that("Variable validator rejects non-logical logical_as_int", {
  expect_error(
    quickr:::Variable(mode = "integer", logical_as_int = TRUE),
    "logical_as_int"
  )
})

test_that("Fortran validates length and prints non-null properties", {
  expect_error(quickr:::Fortran(c("a", "b")), "length 1")

  v <- quickr:::Variable(name = "x", mode = "integer", dims = 1L)
  f <- quickr:::Fortran("x", value = v, r = quote(x))

  out <- capture.output(print(f))
  expect_true(any(grepl("@value:", out, fixed = TRUE)))
  expect_true(any(grepl("@r:", out, fixed = TRUE)))
})

test_that("new_setter returns NULL when no coercion or set_once", {
  result <- quickr:::new_setter(coerce = FALSE, set_once = FALSE)
  expect_null(result)
})

test_that("new_setter handles coerce = NULL correctly", {
  result <- quickr:::new_setter(coerce = NULL, set_once = FALSE)
  expect_null(result)
})

test_that("new_setter handles TRUE coercion", {
  Test <- S7::new_class(
    name = "TestCoerce",
    properties = list(
      x = quickr:::prop_string(
        default = NULL,
        allow_null = TRUE,
        coerce = TRUE
      )
    )
  )
  obj <- Test()
  obj@x <- 123
  expect_identical(obj@x, "123")
})

test_that("new_setter errors for invalid coerce argument", {
  expect_error(
    quickr:::new_setter(coerce = list()),
    "coerce must be TRUE, FALSE, NULL"
  )
})

test_that("CRAN smoke budget stays small", {
  smoke_files <- list.files(
    test_path(),
    pattern = "^test-cran-smoke-.*\\.R$",
    full.names = TRUE
  )
  lines <- unlist(lapply(smoke_files, readLines), use.names = FALSE)
  quick_entrypoints <- sum(grepl("expect_quick_(equal|identical)\\(", lines))
  quick_entrypoints <- quick_entrypoints + sum(grepl("\\bquick\\(", lines))

  expect_lte(quick_entrypoints, 1L)
})

test_that("non-smoke test files skip on CRAN", {
  test_files <- list.files(
    test_path(),
    pattern = "^test-.*\\.R$",
    full.names = TRUE
  )
  non_smoke_files <- test_files[
    !grepl("^test-cran-(budget|smoke-.*)\\.R$", basename(test_files))
  ]
  has_top_level_skip <- vapply(
    non_smoke_files,
    function(path) {
      lines <- readLines(path, warn = FALSE)
      head_text <- paste(
        lines[seq_len(min(10, length(lines)))],
        collapse = "\n"
      )
      grepl("skip_on_cran()", head_text, fixed = TRUE)
    },
    logical(1)
  )

  expect_true(
    all(has_top_level_skip),
    info = paste(
      basename(non_smoke_files[!has_top_level_skip]),
      collapse = ", "
    )
  )
})

# division casts integers

    Code
      fn
    Output
      function(a, b) {
          declare(type(a = integer(n)), type(b = integer(n)))
          a / b
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(a, b, out_, a__len_) bind(c)
        use iso_c_binding, only: c_double, c_int, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: a__len_
      
        ! args
        integer(c_int), intent(in) :: a(a__len_)
        integer(c_int), intent(in) :: b(a__len_)
        real(c_double), intent(out) :: out_(a__len_)
        ! manifest end
      
      
        out_ = (real(a, kind=c_double) / real(b, kind=c_double))
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const int* const a__, 
        const int* const b__, 
        double* const out___, 
        const R_xlen_t a__len_);
      
      SEXP fn_(SEXP _args) {
        // a
        _args = CDR(_args);
        SEXP a = CAR(_args);
        if (TYPEOF(a) != INTSXP) {
          Rf_error("typeof(a) must be 'integer', not '%s'", Rf_type2char(TYPEOF(a)));
        }
        const int* const a__ = INTEGER(a);
        const R_xlen_t a__len_ = Rf_xlength(a);
        
        // b
        _args = CDR(_args);
        SEXP b = CAR(_args);
        if (TYPEOF(b) != INTSXP) {
          Rf_error("typeof(b) must be 'integer', not '%s'", Rf_type2char(TYPEOF(b)));
        }
        const int* const b__ = INTEGER(b);
        const R_xlen_t b__len_ = Rf_xlength(b);
        
        if (a__len_ != b__len_)
          Rf_error("length(b) must equal length(a),"
                   " but are %0.f and %0.f",
                    (double)b__len_, (double)a__len_);
        const R_xlen_t out___len_ = a__len_;
        SEXP out_ = PROTECT(Rf_allocVector(REALSXP, out___len_));
        double* out___ = REAL(out_);
        
        fn(
          a__,
          b__,
          out___,
          a__len_);
        
        UNPROTECT(1);
        return out_;
      }

# division casts double and integer

    Code
      fn
    Output
      function(a, b) {
          declare(type(a = double(n)), type(b = integer(n)))
          a / b
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(a, b, out_, a__len_) bind(c)
        use iso_c_binding, only: c_double, c_int, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: a__len_
      
        ! args
        real(c_double), intent(in) :: a(a__len_)
        integer(c_int), intent(in) :: b(a__len_)
        real(c_double), intent(out) :: out_(a__len_)
        ! manifest end
      
      
        out_ = (a / real(b, kind=c_double))
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const a__, 
        const int* const b__, 
        double* const out___, 
        const R_xlen_t a__len_);
      
      SEXP fn_(SEXP _args) {
        // a
        _args = CDR(_args);
        SEXP a = CAR(_args);
        if (TYPEOF(a) != REALSXP) {
          Rf_error("typeof(a) must be 'double', not '%s'", Rf_type2char(TYPEOF(a)));
        }
        const double* const a__ = REAL(a);
        const R_xlen_t a__len_ = Rf_xlength(a);
        
        // b
        _args = CDR(_args);
        SEXP b = CAR(_args);
        if (TYPEOF(b) != INTSXP) {
          Rf_error("typeof(b) must be 'integer', not '%s'", Rf_type2char(TYPEOF(b)));
        }
        const int* const b__ = INTEGER(b);
        const R_xlen_t b__len_ = Rf_xlength(b);
        
        if (a__len_ != b__len_)
          Rf_error("length(b) must equal length(a),"
                   " but are %0.f and %0.f",
                    (double)b__len_, (double)a__len_);
        const R_xlen_t out___len_ = a__len_;
        SEXP out_ = PROTECT(Rf_allocVector(REALSXP, out___len_));
        double* out___ = REAL(out_);
        
        fn(
          a__,
          b__,
          out___,
          a__len_);
        
        UNPROTECT(1);
        return out_;
      }

# division casts logical

    Code
      fn
    Output
      function(a, b) {
          declare(type(a = double(n)), type(b = logical(n)))
          a / b
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(a, b, out_, a__len_) bind(c)
        use iso_c_binding, only: c_double, c_int, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: a__len_
      
        ! args
        real(c_double), intent(in) :: a(a__len_)
        integer(c_int), intent(in) :: b(a__len_) ! logical
        real(c_double), intent(out) :: out_(a__len_)
        ! manifest end
      
      
        out_ = (a / merge(1_c_double, 0_c_double, (b/=0)))
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const a__, 
        const int* const b__, 
        double* const out___, 
        const R_xlen_t a__len_);
      
      SEXP fn_(SEXP _args) {
        // a
        _args = CDR(_args);
        SEXP a = CAR(_args);
        if (TYPEOF(a) != REALSXP) {
          Rf_error("typeof(a) must be 'double', not '%s'", Rf_type2char(TYPEOF(a)));
        }
        const double* const a__ = REAL(a);
        const R_xlen_t a__len_ = Rf_xlength(a);
        
        // b
        _args = CDR(_args);
        SEXP b = CAR(_args);
        if (TYPEOF(b) != LGLSXP) {
          Rf_error("typeof(b) must be 'logical', not '%s'", Rf_type2char(TYPEOF(b)));
        }
        const int* const b__ = LOGICAL(b);
        const R_xlen_t b__len_ = Rf_xlength(b);
        
        if (a__len_ != b__len_)
          Rf_error("length(b) must equal length(a),"
                   " but are %0.f and %0.f",
                    (double)b__len_, (double)a__len_);
        const R_xlen_t out___len_ = a__len_;
        SEXP out_ = PROTECT(Rf_allocVector(REALSXP, out___len_));
        double* out___ = REAL(out_);
        
        fn(
          a__,
          b__,
          out___,
          a__len_);
        
        UNPROTECT(1);
        return out_;
      }

# division casts complex

    Code
      fn
    Output
      function(a, b) {
          declare(type(a = complex(n)), type(b = complex(n)))
          a / b
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(a, b, out_, a__len_) bind(c)
        use iso_c_binding, only: c_double_complex, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: a__len_
      
        ! args
        complex(c_double_complex), intent(in) :: a(a__len_)
        complex(c_double_complex), intent(in) :: b(a__len_)
        complex(c_double_complex), intent(out) :: out_(a__len_)
        ! manifest end
      
      
        out_ = (a / b)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const Rcomplex* const a__, 
        const Rcomplex* const b__, 
        Rcomplex* const out___, 
        const R_xlen_t a__len_);
      
      SEXP fn_(SEXP _args) {
        // a
        _args = CDR(_args);
        SEXP a = CAR(_args);
        if (TYPEOF(a) != CPLXSXP) {
          Rf_error("typeof(a) must be 'complex', not '%s'", Rf_type2char(TYPEOF(a)));
        }
        const Rcomplex* const a__ = COMPLEX(a);
        const R_xlen_t a__len_ = Rf_xlength(a);
        
        // b
        _args = CDR(_args);
        SEXP b = CAR(_args);
        if (TYPEOF(b) != CPLXSXP) {
          Rf_error("typeof(b) must be 'complex', not '%s'", Rf_type2char(TYPEOF(b)));
        }
        const Rcomplex* const b__ = COMPLEX(b);
        const R_xlen_t b__len_ = Rf_xlength(b);
        
        if (a__len_ != b__len_)
          Rf_error("length(b) must equal length(a),"
                   " but are %0.f and %0.f",
                    (double)b__len_, (double)a__len_);
        const R_xlen_t out___len_ = a__len_;
        SEXP out_ = PROTECT(Rf_allocVector(CPLXSXP, out___len_));
        Rcomplex* out___ = COMPLEX(out_);
        
        fn(
          a__,
          b__,
          out___,
          a__len_);
        
        UNPROTECT(1);
        return out_;
      }

# division example in #33

    Code
      fn
    Output
      function(x) {
          declare(type(x = double(NA)))
          mu <- sum(x) / length(x)
          mu
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, mu, x__len_) bind(c)
        use iso_c_binding, only: c_double, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: x__len_
      
        ! args
        real(c_double), intent(in) :: x(x__len_)
        real(c_double), intent(out) :: mu
        ! manifest end
      
      
        mu = (sum(x) / real(size(x), kind=c_double))
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const x__, 
        double* const mu__, 
        const R_xlen_t x__len_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        const R_xlen_t mu__len_ = (1);
        SEXP mu = PROTECT(Rf_allocVector(REALSXP, mu__len_));
        double* mu__ = REAL(mu);
        
        fn(x__, mu__, x__len_);
        
        UNPROTECT(1);
        return mu;
      }

# parentheses preserve arithmetic precedence for scalars

    Code
      fn
    Output
      function(a, b, c, d) {
          declare(
            type(a = double(1)),
            type(b = double(1)),
            type(c = double(1)),
            type(d = double(1))
          )
      
          (a + b) / (c + d)
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(a, b, c, d, out_) bind(c)
        use iso_c_binding, only: c_double
        implicit none
      
        ! manifest start
        ! args
        real(c_double), intent(in) :: a
        real(c_double), intent(in) :: b
        real(c_double), intent(in) :: c
        real(c_double), intent(in) :: d
        real(c_double), intent(out) :: out_
        ! manifest end
      
      
        out_ = (((a + b)) / ((c + d)))
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const a__, 
        const double* const b__, 
        const double* const c__, 
        const double* const d__, 
        double* const out___);
      
      SEXP fn_(SEXP _args) {
        // a
        _args = CDR(_args);
        SEXP a = CAR(_args);
        if (TYPEOF(a) != REALSXP) {
          Rf_error("typeof(a) must be 'double', not '%s'", Rf_type2char(TYPEOF(a)));
        }
        const double* const a__ = REAL(a);
        const R_xlen_t a__len_ = Rf_xlength(a);
        
        // b
        _args = CDR(_args);
        SEXP b = CAR(_args);
        if (TYPEOF(b) != REALSXP) {
          Rf_error("typeof(b) must be 'double', not '%s'", Rf_type2char(TYPEOF(b)));
        }
        const double* const b__ = REAL(b);
        const R_xlen_t b__len_ = Rf_xlength(b);
        
        // c
        _args = CDR(_args);
        SEXP c = CAR(_args);
        if (TYPEOF(c) != REALSXP) {
          Rf_error("typeof(c) must be 'double', not '%s'", Rf_type2char(TYPEOF(c)));
        }
        const double* const c__ = REAL(c);
        const R_xlen_t c__len_ = Rf_xlength(c);
        
        // d
        _args = CDR(_args);
        SEXP d = CAR(_args);
        if (TYPEOF(d) != REALSXP) {
          Rf_error("typeof(d) must be 'double', not '%s'", Rf_type2char(TYPEOF(d)));
        }
        const double* const d__ = REAL(d);
        const R_xlen_t d__len_ = Rf_xlength(d);
        
        if (a__len_ != 1)
          Rf_error("length(a) must be 1, not %0.f",
                    (double)a__len_);
        if (b__len_ != 1)
          Rf_error("length(b) must be 1, not %0.f",
                    (double)b__len_);
        if (c__len_ != 1)
          Rf_error("length(c) must be 1, not %0.f",
                    (double)c__len_);
        if (d__len_ != 1)
          Rf_error("length(d) must be 1, not %0.f",
                    (double)d__len_);
        const R_xlen_t out___len_ = (1);
        SEXP out_ = PROTECT(Rf_allocVector(REALSXP, out___len_));
        double* out___ = REAL(out_);
        
        fn(
          a__,
          b__,
          c__,
          d__,
          out___);
        
        UNPROTECT(1);
        return out_;
      }

# parentheses preserve precedence in vectorized expressions

    Code
      fn
    Output
      function(x, y) {
          declare(type(x = double(n)), type(y = double(n)))
          (x + 1) * (y - 1)
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, y, out_, x__len_) bind(c)
        use iso_c_binding, only: c_double, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: x__len_
      
        ! args
        real(c_double), intent(in) :: x(x__len_)
        real(c_double), intent(in) :: y(x__len_)
        real(c_double), intent(out) :: out_(x__len_)
        ! manifest end
      
      
        out_ = (((x + 1.0_c_double)) * ((y - 1.0_c_double)))
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const x__, 
        const double* const y__, 
        double* const out___, 
        const R_xlen_t x__len_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        // y
        _args = CDR(_args);
        SEXP y = CAR(_args);
        if (TYPEOF(y) != REALSXP) {
          Rf_error("typeof(y) must be 'double', not '%s'", Rf_type2char(TYPEOF(y)));
        }
        const double* const y__ = REAL(y);
        const R_xlen_t y__len_ = Rf_xlength(y);
        
        if (x__len_ != y__len_)
          Rf_error("length(y) must equal length(x),"
                   " but are %0.f and %0.f",
                    (double)y__len_, (double)x__len_);
        const R_xlen_t out___len_ = x__len_;
        SEXP out_ = PROTECT(Rf_allocVector(REALSXP, out___len_));
        double* out___ = REAL(out_);
        
        fn(
          x__,
          y__,
          out___,
          x__len_);
        
        UNPROTECT(1);
        return out_;
      }

# as.integer(double) truncates toward zero

    Code
      fn
    Output
      function(x) {
          declare(type(x = double(NA)))
          out <- as.integer(x)
          out
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out, x__len_) bind(c)
        use iso_c_binding, only: c_double, c_int, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: x__len_
      
        ! args
        real(c_double), intent(in) :: x(x__len_)
        integer(c_int), intent(out) :: out(x__len_)
        ! manifest end
      
      
        out = int(x, kind=c_int)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const x__, 
        int* const out__, 
        const R_xlen_t x__len_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        const R_xlen_t out__len_ = x__len_;
        SEXP out = PROTECT(Rf_allocVector(INTSXP, out__len_));
        int* out__ = INTEGER(out);
        
        fn(x__, out__, x__len_);
        
        UNPROTECT(1);
        return out;
      }

# trunc() returns double and truncates toward zero

    Code
      fn
    Output
      function(x) {
          declare(type(x = double(NA)))
          out <- trunc(x)
          out
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out, x__len_) bind(c)
        use iso_c_binding, only: c_double, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: x__len_
      
        ! args
        real(c_double), intent(in) :: x(x__len_)
        real(c_double), intent(out) :: out(x__len_)
        ! manifest end
      
      
        out = aint(x)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const x__, 
        double* const out__, 
        const R_xlen_t x__len_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        const R_xlen_t out__len_ = x__len_;
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        
        fn(x__, out__, x__len_);
        
        UNPROTECT(1);
        return out;
      }

---

    Code
      fn
    Output
      function(x) {
          declare(type(x = integer(NA)))
          out <- trunc(x)
          out
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out, x__len_) bind(c)
        use iso_c_binding, only: c_double, c_int, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: x__len_
      
        ! args
        integer(c_int), intent(in) :: x(x__len_)
        real(c_double), intent(out) :: out(x__len_)
        ! manifest end
      
      
        out = real(x, kind=c_double)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const int* const x__, 
        double* const out__, 
        const R_xlen_t x__len_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != INTSXP) {
          Rf_error("typeof(x) must be 'integer', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const int* const x__ = INTEGER(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        const R_xlen_t out__len_ = x__len_;
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        
        fn(x__, out__, x__len_);
        
        UNPROTECT(1);
        return out;
      }

# as.integer(integer division) truncates toward zero

    Code
      fn
    Output
      function(a, b) {
          declare(type(a = integer(n)), type(b = integer(n)))
          out <- as.integer(a / b)
          out
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(a, b, out, a__len_) bind(c)
        use iso_c_binding, only: c_double, c_int, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: a__len_
      
        ! args
        integer(c_int), intent(in) :: a(a__len_)
        integer(c_int), intent(in) :: b(a__len_)
        integer(c_int), intent(out) :: out(a__len_)
        ! manifest end
      
      
        out = int((real(a, kind=c_double) / real(b, kind=c_double)), kind=c_int)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const int* const a__, 
        const int* const b__, 
        int* const out__, 
        const R_xlen_t a__len_);
      
      SEXP fn_(SEXP _args) {
        // a
        _args = CDR(_args);
        SEXP a = CAR(_args);
        if (TYPEOF(a) != INTSXP) {
          Rf_error("typeof(a) must be 'integer', not '%s'", Rf_type2char(TYPEOF(a)));
        }
        const int* const a__ = INTEGER(a);
        const R_xlen_t a__len_ = Rf_xlength(a);
        
        // b
        _args = CDR(_args);
        SEXP b = CAR(_args);
        if (TYPEOF(b) != INTSXP) {
          Rf_error("typeof(b) must be 'integer', not '%s'", Rf_type2char(TYPEOF(b)));
        }
        const int* const b__ = INTEGER(b);
        const R_xlen_t b__len_ = Rf_xlength(b);
        
        if (a__len_ != b__len_)
          Rf_error("length(b) must equal length(a),"
                   " but are %0.f and %0.f",
                    (double)b__len_, (double)a__len_);
        const R_xlen_t out__len_ = a__len_;
        SEXP out = PROTECT(Rf_allocVector(INTSXP, out__len_));
        int* out__ = INTEGER(out);
        
        fn(
          a__,
          b__,
          out__,
          a__len_);
        
        UNPROTECT(1);
        return out;
      }

# matrix

    Code
      r2f(fn)
    Output
      subroutine fn(a, b, out) bind(c)
        use iso_c_binding, only: c_double, c_int
        implicit none
      
        ! manifest start
        ! args
        integer(c_int), intent(in) :: a
        integer(c_int), intent(in) :: b
        real(c_double), intent(out) :: out(a, b)
        ! manifest end
      
      
      
        out = 0.0_c_double
      end subroutine
      
      @r: function (a, b)
        {
            declare(type(a = integer(1)))
            declare(type(b = integer(1)))
            out <- matrix(0, a, b)
            out
        }
      @c_bridge: #define R_NO_REMAP
        #include <R.h>
        #include <Rinternals.h>
        
        
        extern void fn(
          const int* const a__,
          const int* const b__,
          double* const out__);
        
        SEXP fn_(SEXP _args) {
          // a
          _args = CDR(_args);
          SEXP a = CAR(_args);
          if (TYPEOF(a) != INTSXP) {
            Rf_error("typeof(a) must be 'integer', not '%s'", Rf_type2char(TYPEOF(a)));
          }
          const int* const a__ = INTEGER(a);
          const R_xlen_t a__len_ = Rf_xlength(a);
        
          // b
          _args = CDR(_args);
          SEXP b = CAR(_args);
          if (TYPEOF(b) != INTSXP) {
            Rf_error("typeof(b) must be 'integer', not '%s'", Rf_type2char(TYPEOF(b)));
          }
          const int* const b__ = INTEGER(b);
          const R_xlen_t b__len_ = Rf_xlength(b);
        
          if (a__len_ != 1)
            Rf_error("length(a) must be 1, not %0.f",
                      (double)a__len_);
          if (b__len_ != 1)
            Rf_error("length(b) must be 1, not %0.f",
                      (double)b__len_);
          const int _as_int_a = Rf_asInteger(a);
          const int _as_int_b = Rf_asInteger(b);
          const R_xlen_t out__len_ = (_as_int_a) * (_as_int_b);
          SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
          double* out__ = REAL(out);
          {
            const SEXP _dim_sexp = PROTECT(Rf_allocVector(INTSXP, 2));
            int* const _dim = INTEGER(_dim_sexp);
            _dim[0] = _as_int_a;
            _dim[1] = _as_int_b;
            Rf_dimgets(out, _dim_sexp);
          }
        
          fn(a__, b__, out__);
        
          UNPROTECT(2);
          return out;
        }

# reuse implicit size

    Code
      print(fsub)
    Output
      subroutine fn(a1, a2, out, a1__len_) bind(c)
        use iso_c_binding, only: c_double, c_int, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: a1__len_
      
        ! args
        real(c_double), intent(in) :: a1(a1__len_)
        real(c_double), intent(in) :: a2(a1__len_, a1__len_)
        real(c_double), intent(out) :: out(a1__len_)
        ! manifest end
      
      
      
        out = (a1 + a2(1_c_int, :))
      end subroutine
      
      @r: function (a1, a2)
        {
            declare(type(a1 = double(n)))
            declare(type(a2 = double(n, n)))
            out <- a1 + a2[1, ]
            out
        }
      @c_bridge: #define R_NO_REMAP
        #include <R.h>
        #include <Rinternals.h>
        
        
        extern void fn(
          const double* const a1__,
          const double* const a2__,
          double* const out__,
          const R_xlen_t a1__len_);
        
        SEXP fn_(SEXP _args) {
          // a1
          _args = CDR(_args);
          SEXP a1 = CAR(_args);
          if (TYPEOF(a1) != REALSXP) {
            Rf_error("typeof(a1) must be 'double', not '%s'", Rf_type2char(TYPEOF(a1)));
          }
          const double* const a1__ = REAL(a1);
          const R_xlen_t a1__len_ = Rf_xlength(a1);
        
          // a2
          _args = CDR(_args);
          SEXP a2 = CAR(_args);
          if (TYPEOF(a2) != REALSXP) {
            Rf_error("typeof(a2) must be 'double', not '%s'", Rf_type2char(TYPEOF(a2)));
          }
          const double* const a2__ = REAL(a2);
          const int* const a2__dim_ = ({
          SEXP dim_ = Rf_getAttrib(a2, R_DimSymbol);
          if (Rf_length(dim_) != 2) Rf_error(
            "a2 must be a 2D-array, but length(dim(a2)) is %i",
            (int) Rf_length(dim_));
          INTEGER(dim_);});
          const int a2__dim_1_ = a2__dim_[0];
          const int a2__dim_2_ = a2__dim_[1];
        
          if (a1__len_ != a2__dim_1_)
            Rf_error("dim(a2)[1] must equal length(a1),"
                     " but are %0.f and %0.f",
                      (double)a2__dim_1_, (double)a1__len_);
          if (a1__len_ != a2__dim_2_)
            Rf_error("dim(a2)[2] must equal length(a1),"
                     " but are %0.f and %0.f",
                      (double)a2__dim_2_, (double)a1__len_);
          const R_xlen_t out__len_ = a1__len_;
          SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
          double* out__ = REAL(out);
        
          fn(
            a1__,
            a2__,
            out__,
            a1__len_);
        
          UNPROTECT(1);
          return out;
        }
    Code
      cat(c_wrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const a1__, 
        const double* const a2__, 
        double* const out__, 
        const R_xlen_t a1__len_);
      
      SEXP fn_(SEXP _args) {
        // a1
        _args = CDR(_args);
        SEXP a1 = CAR(_args);
        if (TYPEOF(a1) != REALSXP) {
          Rf_error("typeof(a1) must be 'double', not '%s'", Rf_type2char(TYPEOF(a1)));
        }
        const double* const a1__ = REAL(a1);
        const R_xlen_t a1__len_ = Rf_xlength(a1);
        
        // a2
        _args = CDR(_args);
        SEXP a2 = CAR(_args);
        if (TYPEOF(a2) != REALSXP) {
          Rf_error("typeof(a2) must be 'double', not '%s'", Rf_type2char(TYPEOF(a2)));
        }
        const double* const a2__ = REAL(a2);
        const int* const a2__dim_ = ({
        SEXP dim_ = Rf_getAttrib(a2, R_DimSymbol);
        if (Rf_length(dim_) != 2) Rf_error(
          "a2 must be a 2D-array, but length(dim(a2)) is %i",
          (int) Rf_length(dim_));
        INTEGER(dim_);});
        const int a2__dim_1_ = a2__dim_[0];
        const int a2__dim_2_ = a2__dim_[1];
        
        if (a1__len_ != a2__dim_1_)
          Rf_error("dim(a2)[1] must equal length(a1),"
                   " but are %0.f and %0.f",
                    (double)a2__dim_1_, (double)a1__len_);
        if (a1__len_ != a2__dim_2_)
          Rf_error("dim(a2)[2] must equal length(a1),"
                   " but are %0.f and %0.f",
                    (double)a2__dim_2_, (double)a1__len_);
        const R_xlen_t out__len_ = a1__len_;
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        
        fn(
          a1__,
          a2__,
          out__,
          a1__len_);
        
        UNPROTECT(1);
        return out;
      }

# scalar logical indexing works in ifelse()

    Code
      cat("# Snapshot note: ", note, "\n", sep = "")
    Output
      # Snapshot note: Regression: indexing external logical arrays must compile (no invalid subscripting of booleanized expressions).
    Code
      fn
    Output
      function(pred) {
          declare(type(pred = logical(3, 4)))
          out <- double(1)
          out[1] <- ifelse(pred[2, 3], 1.0, 0.0)
          out
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(pred, out) bind(c)
        use iso_c_binding, only: c_double, c_int
        implicit none
      
        ! manifest start
        ! args
        integer(c_int), intent(in) :: pred(3, 4) ! logical
        real(c_double), intent(out) :: out
        ! manifest end
      
      
        out = 0
        out = merge(1.0_c_double, 0.0_c_double, (pred(2_c_int, 3_c_int) /= 0))
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(const int* const pred__, double* const out__);
      
      SEXP fn_(SEXP _args) {
        // pred
        _args = CDR(_args);
        SEXP pred = CAR(_args);
        if (TYPEOF(pred) != LGLSXP) {
          Rf_error("typeof(pred) must be 'logical', not '%s'", Rf_type2char(TYPEOF(pred)));
        }
        const int* const pred__ = LOGICAL(pred);
        const int* const pred__dim_ = ({
        SEXP dim_ = Rf_getAttrib(pred, R_DimSymbol);
        if (Rf_length(dim_) != 2) Rf_error(
          "pred must be a 2D-array, but length(dim(pred)) is %i",
          (int) Rf_length(dim_));
        INTEGER(dim_);});
        const int pred__dim_1_ = pred__dim_[0];
        const int pred__dim_2_ = pred__dim_[1];
        
        if (pred__dim_1_ != 3)
          Rf_error("dim(pred)[1] must be 3, not %0.f",
                    (double)pred__dim_1_);
        if (pred__dim_2_ != 4)
          Rf_error("dim(pred)[2] must be 4, not %0.f",
                    (double)pred__dim_2_);
        const R_xlen_t out__len_ = (1);
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        
        fn(pred__, out__);
        
        UNPROTECT(1);
        return out;
      }

# indexing a logical expression works (comparison)

    Code
      cat("# Snapshot note: ", note, "\n", sep = "")
    Output
      # Snapshot note: Ensures indexing a logical expression compiles by hoisting the array expression to a temporary before subscripting (no invalid (expr)(i,j)).
    Code
      fn
    Output
      function(x) {
          declare(type(x = double(3, 4)))
          out <- double(1)
          out[1] <- ifelse(((((x > 0.0))))[2, 3], 1.0, 0.0)
          out
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out) bind(c)
        use iso_c_binding, only: c_double, c_int
        implicit none
      
        ! manifest start
        ! args
        real(c_double), intent(in) :: x(3, 4)
        real(c_double), intent(out) :: out
        ! manifest end
      
      
        out = 0
        block
          logical :: btmp1_(3, 4) ! logical
      
          btmp1_ = (((((x > 0.0_c_double)))))
          out = merge(1.0_c_double, 0.0_c_double, btmp1_(2_c_int, 3_c_int))
        end block
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(const double* const x__, double* const out__);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const int* const x__dim_ = ({
        SEXP dim_ = Rf_getAttrib(x, R_DimSymbol);
        if (Rf_length(dim_) != 2) Rf_error(
          "x must be a 2D-array, but length(dim(x)) is %i",
          (int) Rf_length(dim_));
        INTEGER(dim_);});
        const int x__dim_1_ = x__dim_[0];
        const int x__dim_2_ = x__dim_[1];
        
        if (x__dim_1_ != 3)
          Rf_error("dim(x)[1] must be 3, not %0.f",
                    (double)x__dim_1_);
        if (x__dim_2_ != 4)
          Rf_error("dim(x)[2] must be 4, not %0.f",
                    (double)x__dim_2_);
        const R_xlen_t out__len_ = (1);
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        
        fn(x__, out__);
        
        UNPROTECT(1);
        return out;
      }

# indexing a logical expression works (boolean ops)

    Code
      cat("# Snapshot note: ", note, "\n", sep = "")
    Output
      # Snapshot note: Ensures indexing a boolean expression compiles by hoisting to a temporary before subscripting (no invalid (expr)(i,j)).
    Code
      fn
    Output
      function(x) {
          declare(type(x = double(3, 4)))
          out <- double(1)
          out[1] <- ifelse(((((x > 0.0) & (x < 0.5))))[2, 3], 1.0, 0.0)
          out
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out) bind(c)
        use iso_c_binding, only: c_double, c_int
        implicit none
      
        ! manifest start
        ! args
        real(c_double), intent(in) :: x(3, 4)
        real(c_double), intent(out) :: out
        ! manifest end
      
      
        out = 0
        block
          logical :: btmp1_(3, 4) ! logical
      
          btmp1_ = (((((x > 0.0_c_double)) .and. ((x < 0.5_c_double)))))
          out = merge(1.0_c_double, 0.0_c_double, btmp1_(2_c_int, 3_c_int))
        end block
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(const double* const x__, double* const out__);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const int* const x__dim_ = ({
        SEXP dim_ = Rf_getAttrib(x, R_DimSymbol);
        if (Rf_length(dim_) != 2) Rf_error(
          "x must be a 2D-array, but length(dim(x)) is %i",
          (int) Rf_length(dim_));
        INTEGER(dim_);});
        const int x__dim_1_ = x__dim_[0];
        const int x__dim_2_ = x__dim_[1];
        
        if (x__dim_1_ != 3)
          Rf_error("dim(x)[1] must be 3, not %0.f",
                    (double)x__dim_1_);
        if (x__dim_2_ != 4)
          Rf_error("dim(x)[2] must be 4, not %0.f",
                    (double)x__dim_2_);
        const R_xlen_t out__len_ = (1);
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        
        fn(x__, out__);
        
        UNPROTECT(1);
        return out;
      }

# expression indexing with logical mask avoids extra materialization

    Code
      cat("# Snapshot note: ", note, "\n", sep = "")
    Output
      # Snapshot note: Mask subsetting should stay as a single pack-like operation (avoid pushing mask into operands and duplicating mask evaluation).
    Code
      fn
    Output
      function(x, y, z, a) {
          declare(
            type(x = double(3, 4)),
            type(y = double(3, 4)),
            type(z = double(3, 4)),
            type(a = double(1))
          )
          out <- double(1)
          out[1] <- sum((x + y)[z > a])
          out
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, y, z, a, out) bind(c)
        use iso_c_binding, only: c_double
        implicit none
      
        ! manifest start
        ! args
        real(c_double), intent(in) :: x(3, 4)
        real(c_double), intent(in) :: y(3, 4)
        real(c_double), intent(in) :: z(3, 4)
        real(c_double), intent(in) :: a
        real(c_double), intent(out) :: out
        ! manifest end
      
      
        out = 0
        out = sum(((x + y)), mask = (z > a))
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const x__, 
        const double* const y__, 
        const double* const z__, 
        const double* const a__, 
        double* const out__);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const int* const x__dim_ = ({
        SEXP dim_ = Rf_getAttrib(x, R_DimSymbol);
        if (Rf_length(dim_) != 2) Rf_error(
          "x must be a 2D-array, but length(dim(x)) is %i",
          (int) Rf_length(dim_));
        INTEGER(dim_);});
        const int x__dim_1_ = x__dim_[0];
        const int x__dim_2_ = x__dim_[1];
        
        // y
        _args = CDR(_args);
        SEXP y = CAR(_args);
        if (TYPEOF(y) != REALSXP) {
          Rf_error("typeof(y) must be 'double', not '%s'", Rf_type2char(TYPEOF(y)));
        }
        const double* const y__ = REAL(y);
        const int* const y__dim_ = ({
        SEXP dim_ = Rf_getAttrib(y, R_DimSymbol);
        if (Rf_length(dim_) != 2) Rf_error(
          "y must be a 2D-array, but length(dim(y)) is %i",
          (int) Rf_length(dim_));
        INTEGER(dim_);});
        const int y__dim_1_ = y__dim_[0];
        const int y__dim_2_ = y__dim_[1];
        
        // z
        _args = CDR(_args);
        SEXP z = CAR(_args);
        if (TYPEOF(z) != REALSXP) {
          Rf_error("typeof(z) must be 'double', not '%s'", Rf_type2char(TYPEOF(z)));
        }
        const double* const z__ = REAL(z);
        const int* const z__dim_ = ({
        SEXP dim_ = Rf_getAttrib(z, R_DimSymbol);
        if (Rf_length(dim_) != 2) Rf_error(
          "z must be a 2D-array, but length(dim(z)) is %i",
          (int) Rf_length(dim_));
        INTEGER(dim_);});
        const int z__dim_1_ = z__dim_[0];
        const int z__dim_2_ = z__dim_[1];
        
        // a
        _args = CDR(_args);
        SEXP a = CAR(_args);
        if (TYPEOF(a) != REALSXP) {
          Rf_error("typeof(a) must be 'double', not '%s'", Rf_type2char(TYPEOF(a)));
        }
        const double* const a__ = REAL(a);
        const R_xlen_t a__len_ = Rf_xlength(a);
        
        if (x__dim_1_ != 3)
          Rf_error("dim(x)[1] must be 3, not %0.f",
                    (double)x__dim_1_);
        if (x__dim_2_ != 4)
          Rf_error("dim(x)[2] must be 4, not %0.f",
                    (double)x__dim_2_);
        if (y__dim_1_ != 3)
          Rf_error("dim(y)[1] must be 3, not %0.f",
                    (double)y__dim_1_);
        if (y__dim_2_ != 4)
          Rf_error("dim(y)[2] must be 4, not %0.f",
                    (double)y__dim_2_);
        if (z__dim_1_ != 3)
          Rf_error("dim(z)[1] must be 3, not %0.f",
                    (double)z__dim_1_);
        if (z__dim_2_ != 4)
          Rf_error("dim(z)[2] must be 4, not %0.f",
                    (double)z__dim_2_);
        if (a__len_ != 1)
          Rf_error("length(a) must be 1, not %0.f",
                    (double)a__len_);
        const R_xlen_t out__len_ = (1);
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        
        fn(
          x__,
          y__,
          z__,
          a__,
          out__);
        
        UNPROTECT(1);
        return out;
      }

# declare dims support nested length() (vector)

    Code
      cat("# Snapshot note: ", note, "\n", sep = "")
    Output
      # Snapshot note: dims2c must translate length(x) inside arithmetic, not evaluate base::length() on the C expression string.
    Code
      fn
    Output
      function(x) {
          declare(type(x = double(NA)), type(out = double(length(x) + 1)))
          out[1] <- 0
          out
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out, x__len_) bind(c)
        use iso_c_binding, only: c_double, c_int, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: x__len_
      
        ! args
        real(c_double), intent(in) :: x(x__len_)
        real(c_double), intent(out) :: out((size(x) + 1))
        ! manifest end
      
      
        out(1_c_int) = 0.0_c_double
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const x__, 
        double* const out__, 
        const R_xlen_t x__len_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        const R_xlen_t out__len_ = (x__len_ + 1);
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        
        fn(x__, out__, x__len_);
        
        UNPROTECT(1);
        return out;
      }

# declare dims support nested length() (rank>1)

    Code
      cat("# Snapshot note: ", note, "\n", sep = "")
    Output
      # Snapshot note: dims2c must translate length(x) for rank>1 arrays (length == prod(dim)).
    Code
      fn
    Output
      function(x) {
          declare(type(x = double(NA, NA)), type(out = double(length(x) + 1)))
          out[1] <- 0
          out
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out, x__dim_1_, x__dim_2_) bind(c)
        use iso_c_binding, only: c_double, c_int
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_int), intent(in), value :: x__dim_1_
        integer(c_int), intent(in), value :: x__dim_2_
      
        ! args
        real(c_double), intent(in) :: x(x__dim_1_, x__dim_2_)
        real(c_double), intent(out) :: out((size(x) + 1))
        ! manifest end
      
      
        out(1_c_int) = 0.0_c_double
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const x__, 
        double* const out__, 
        const R_len_t x__dim_1_, 
        const R_len_t x__dim_2_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const int* const x__dim_ = ({
        SEXP dim_ = Rf_getAttrib(x, R_DimSymbol);
        if (Rf_length(dim_) != 2) Rf_error(
          "x must be a 2D-array, but length(dim(x)) is %i",
          (int) Rf_length(dim_));
        INTEGER(dim_);});
        const int x__dim_1_ = x__dim_[0];
        const int x__dim_2_ = x__dim_[1];
        
        const R_xlen_t out__len_ = ((x__dim_1_ * x__dim_2_) + 1);
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        
        fn(
          x__,
          out__,
          x__dim_1_,
          x__dim_2_);
        
        UNPROTECT(1);
        return out;
      }

# declare dims support min() in size expressions

    Code
      fn
    Output
      function(n, m) {
          declare(
            type(n = integer(1)),
            type(m = integer(1)),
            type(out = double(min(n, m)))
          )
          for (i in seq_len(length(out))) {
            out[i] <- as.double(i)
          }
          out
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(n, m, out) bind(c)
        use iso_c_binding, only: c_double, c_int
        implicit none
      
        ! manifest start
        ! args
        integer(c_int), intent(in) :: n
        integer(c_int), intent(in) :: m
        real(c_double), intent(out) :: out(min(n, m))
      
        ! locals
        integer(c_int) :: i
        ! manifest end
      
      
        do i = 1, size(out)
          out(i) = real(i, kind=c_double)
        end do
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const int* const n__, 
        const int* const m__, 
        double* const out__);
      
      SEXP fn_(SEXP _args) {
        // n
        _args = CDR(_args);
        SEXP n = CAR(_args);
        if (TYPEOF(n) != INTSXP) {
          Rf_error("typeof(n) must be 'integer', not '%s'", Rf_type2char(TYPEOF(n)));
        }
        const int* const n__ = INTEGER(n);
        const R_xlen_t n__len_ = Rf_xlength(n);
        
        // m
        _args = CDR(_args);
        SEXP m = CAR(_args);
        if (TYPEOF(m) != INTSXP) {
          Rf_error("typeof(m) must be 'integer', not '%s'", Rf_type2char(TYPEOF(m)));
        }
        const int* const m__ = INTEGER(m);
        const R_xlen_t m__len_ = Rf_xlength(m);
        
        if (n__len_ != 1)
          Rf_error("length(n) must be 1, not %0.f",
                    (double)n__len_);
        if (m__len_ != 1)
          Rf_error("length(m) must be 1, not %0.f",
                    (double)m__len_);
        const int _as_int_n = Rf_asInteger(n);
        const int _as_int_m = Rf_asInteger(m);
        const R_xlen_t out__len_ = ((_as_int_n) < (_as_int_m) ? (_as_int_n) : (_as_int_m));
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        
        fn(n__, m__, out__);
        
        UNPROTECT(1);
        return out;
      }

# declare dims support max() in size expressions

    Code
      fn
    Output
      function(n, m) {
          declare(
            type(n = integer(1)),
            type(m = integer(1)),
            type(out = double(max(n, m)))
          )
          for (i in seq_len(length(out))) {
            out[i] <- as.double(i)
          }
          out
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(n, m, out) bind(c)
        use iso_c_binding, only: c_double, c_int
        implicit none
      
        ! manifest start
        ! args
        integer(c_int), intent(in) :: n
        integer(c_int), intent(in) :: m
        real(c_double), intent(out) :: out(max(n, m))
      
        ! locals
        integer(c_int) :: i
        ! manifest end
      
      
        do i = 1, size(out)
          out(i) = real(i, kind=c_double)
        end do
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const int* const n__, 
        const int* const m__, 
        double* const out__);
      
      SEXP fn_(SEXP _args) {
        // n
        _args = CDR(_args);
        SEXP n = CAR(_args);
        if (TYPEOF(n) != INTSXP) {
          Rf_error("typeof(n) must be 'integer', not '%s'", Rf_type2char(TYPEOF(n)));
        }
        const int* const n__ = INTEGER(n);
        const R_xlen_t n__len_ = Rf_xlength(n);
        
        // m
        _args = CDR(_args);
        SEXP m = CAR(_args);
        if (TYPEOF(m) != INTSXP) {
          Rf_error("typeof(m) must be 'integer', not '%s'", Rf_type2char(TYPEOF(m)));
        }
        const int* const m__ = INTEGER(m);
        const R_xlen_t m__len_ = Rf_xlength(m);
        
        if (n__len_ != 1)
          Rf_error("length(n) must be 1, not %0.f",
                    (double)n__len_);
        if (m__len_ != 1)
          Rf_error("length(m) must be 1, not %0.f",
                    (double)m__len_);
        const int _as_int_n = Rf_asInteger(n);
        const int _as_int_m = Rf_asInteger(m);
        const R_xlen_t out__len_ = ((_as_int_n) > (_as_int_m) ? (_as_int_n) : (_as_int_m));
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        
        fn(n__, m__, out__);
        
        UNPROTECT(1);
        return out;
      }

# quick() supports svd(x)$d

    Code
      fn
    Output
      function(x) {
          declare(type(x = double(3, 2)))
          svd(x)$d
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out_, quickr_err_msg) bind(c)
        use iso_c_binding, only: c_char, c_double, c_int, c_null_char
        implicit none
      
        ! manifest start
        ! error
        character(kind=c_char), intent(inout) :: quickr_err_msg(256)
      
        ! args
        real(c_double), intent(in) :: x(3, 2)
        real(c_double), intent(out) :: out_(2)
        ! manifest end
      
      
        block
          real(c_double) :: btmp1_(2)
          real(c_double) :: btmp2_(3, 2)
          real(c_double) :: btmp3_(2, 2)
          real(c_double) :: btmp4_(3, 2)
          real(c_double) :: btmp5_(2, 2)
          integer(c_int) :: btmp6_
          integer(c_int) :: btmp7_
          real(c_double), allocatable :: btmp8_(:)
          integer(c_int), allocatable :: btmp9_(:)
          real(c_double), allocatable :: btmp10_(:)
      
          allocate(btmp8_((1 + 0)))
          allocate(btmp9_((8 * 2)))
          btmp4_ = x
          btmp7_ = -1_c_int
      call dgesdd('S', int(3, kind=c_int), int(2, kind=c_int), btmp4_, int(3, kind=c_int), btmp1_, btmp2_, int(3, kind=c_int), btmp5_,&
      & int(2, kind=c_int), btmp8_, btmp7_, btmp9_, btmp6_)
          btmp7_ = int(btmp8_(1), kind=c_int)
          allocate(btmp10_(btmp7_))
      call dgesdd('S', int(3, kind=c_int), int(2, kind=c_int), btmp4_, int(3, kind=c_int), btmp1_, btmp2_, int(3, kind=c_int), btmp5_,&
      & int(2, kind=c_int), btmp10_, btmp7_, btmp9_, btmp6_)
          if (btmp6_ < 0_c_int) then
            call quickr_set_error_msg("Lapack routine dgesdd: illegal argument")
            return
          end if
          if (btmp6_ > 0_c_int) then
            call quickr_set_error_msg("Lapack routine dgesdd failed to converge")
            return
          end if
          btmp3_ = transpose(btmp5_)
          out_ = btmp1_
        end block
      
        contains
          subroutine quickr_set_error_msg(msg)
            character(len=*), intent(in) :: msg
            integer :: i
            integer :: n
            if (quickr_err_msg(1) == c_null_char) then
              n = min(len(msg), 256 - 1)
              quickr_err_msg(1:n) = [(msg(i:i), i = 1, n)]
              quickr_err_msg(n + 1) = c_null_char
            end if
          end subroutine quickr_set_error_msg
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const x__, 
        double* const out___, 
        char* quickr_err_msg);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const int* const x__dim_ = ({
        SEXP dim_ = Rf_getAttrib(x, R_DimSymbol);
        if (Rf_length(dim_) != 2) Rf_error(
          "x must be a 2D-array, but length(dim(x)) is %i",
          (int) Rf_length(dim_));
        INTEGER(dim_);});
        const int x__dim_1_ = x__dim_[0];
        const int x__dim_2_ = x__dim_[1];
        
        if (x__dim_1_ != 3)
          Rf_error("dim(x)[1] must be 3, not %0.f",
                    (double)x__dim_1_);
        if (x__dim_2_ != 2)
          Rf_error("dim(x)[2] must be 2, not %0.f",
                    (double)x__dim_2_);
        const R_xlen_t out___len_ = 2;
        SEXP out_ = PROTECT(Rf_allocVector(REALSXP, out___len_));
        double* out___ = REAL(out_);
        
        char quickr_err_msg[256];
        quickr_err_msg[0] = '\0';
        
        
        fn(x__, out___, quickr_err_msg);
        if (quickr_err_msg[0] != '\0') {
          Rf_error("%s", quickr_err_msg);
        }
        
        UNPROTECT(1);
        return out_;
      }

# double unary intrinsics

    Code
      fn
    Output
      function (x) 
      {
          declare(type(x = double(NA)))
          out <- sin(x)
          out
      }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out, x__len_) bind(c)
        use iso_c_binding, only: c_double, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: x__len_
      
        ! args
        real(c_double), intent(in) :: x(x__len_)
        real(c_double), intent(out) :: out(x__len_)
        ! manifest end
      
      
        out = sin(x)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const x__, 
        double* const out__, 
        const R_xlen_t x__len_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        const R_xlen_t out__len_ = x__len_;
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        
        fn(x__, out__, x__len_);
        
        UNPROTECT(1);
        return out;
      }

---

    Code
      fn
    Output
      function (x) 
      {
          declare(type(x = double(NA)))
          out <- cos(x)
          out
      }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out, x__len_) bind(c)
        use iso_c_binding, only: c_double, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: x__len_
      
        ! args
        real(c_double), intent(in) :: x(x__len_)
        real(c_double), intent(out) :: out(x__len_)
        ! manifest end
      
      
        out = cos(x)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const x__, 
        double* const out__, 
        const R_xlen_t x__len_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        const R_xlen_t out__len_ = x__len_;
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        
        fn(x__, out__, x__len_);
        
        UNPROTECT(1);
        return out;
      }

---

    Code
      fn
    Output
      function (x) 
      {
          declare(type(x = double(NA)))
          out <- tan(x)
          out
      }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out, x__len_) bind(c)
        use iso_c_binding, only: c_double, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: x__len_
      
        ! args
        real(c_double), intent(in) :: x(x__len_)
        real(c_double), intent(out) :: out(x__len_)
        ! manifest end
      
      
        out = tan(x)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const x__, 
        double* const out__, 
        const R_xlen_t x__len_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        const R_xlen_t out__len_ = x__len_;
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        
        fn(x__, out__, x__len_);
        
        UNPROTECT(1);
        return out;
      }

---

    Code
      fn
    Output
      function (x) 
      {
          declare(type(x = double(NA)))
          out <- tanh(x)
          out
      }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out, x__len_) bind(c)
        use iso_c_binding, only: c_double, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: x__len_
      
        ! args
        real(c_double), intent(in) :: x(x__len_)
        real(c_double), intent(out) :: out(x__len_)
        ! manifest end
      
      
        out = tanh(x)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const x__, 
        double* const out__, 
        const R_xlen_t x__len_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        const R_xlen_t out__len_ = x__len_;
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        
        fn(x__, out__, x__len_);
        
        UNPROTECT(1);
        return out;
      }

---

    Code
      fn
    Output
      function (x) 
      {
          declare(type(x = double(NA)))
          out <- asin(x)
          out
      }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out, x__len_) bind(c)
        use iso_c_binding, only: c_double, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: x__len_
      
        ! args
        real(c_double), intent(in) :: x(x__len_)
        real(c_double), intent(out) :: out(x__len_)
        ! manifest end
      
      
        out = asin(x)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const x__, 
        double* const out__, 
        const R_xlen_t x__len_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        const R_xlen_t out__len_ = x__len_;
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        
        fn(x__, out__, x__len_);
        
        UNPROTECT(1);
        return out;
      }

---

    Code
      fn
    Output
      function (x) 
      {
          declare(type(x = double(NA)))
          out <- acos(x)
          out
      }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out, x__len_) bind(c)
        use iso_c_binding, only: c_double, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: x__len_
      
        ! args
        real(c_double), intent(in) :: x(x__len_)
        real(c_double), intent(out) :: out(x__len_)
        ! manifest end
      
      
        out = acos(x)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const x__, 
        double* const out__, 
        const R_xlen_t x__len_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        const R_xlen_t out__len_ = x__len_;
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        
        fn(x__, out__, x__len_);
        
        UNPROTECT(1);
        return out;
      }

---

    Code
      fn
    Output
      function (x) 
      {
          declare(type(x = double(NA)))
          out <- atan(x)
          out
      }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out, x__len_) bind(c)
        use iso_c_binding, only: c_double, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: x__len_
      
        ! args
        real(c_double), intent(in) :: x(x__len_)
        real(c_double), intent(out) :: out(x__len_)
        ! manifest end
      
      
        out = atan(x)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const x__, 
        double* const out__, 
        const R_xlen_t x__len_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        const R_xlen_t out__len_ = x__len_;
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        
        fn(x__, out__, x__len_);
        
        UNPROTECT(1);
        return out;
      }

---

    Code
      fn
    Output
      function (x) 
      {
          declare(type(x = double(NA)))
          out <- sqrt(x)
          out
      }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out, x__len_) bind(c)
        use iso_c_binding, only: c_double, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: x__len_
      
        ! args
        real(c_double), intent(in) :: x(x__len_)
        real(c_double), intent(out) :: out(x__len_)
        ! manifest end
      
      
        out = sqrt(x)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const x__, 
        double* const out__, 
        const R_xlen_t x__len_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        const R_xlen_t out__len_ = x__len_;
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        
        fn(x__, out__, x__len_);
        
        UNPROTECT(1);
        return out;
      }

---

    Code
      fn
    Output
      function (x) 
      {
          declare(type(x = double(NA)))
          out <- exp(x)
          out
      }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out, x__len_) bind(c)
        use iso_c_binding, only: c_double, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: x__len_
      
        ! args
        real(c_double), intent(in) :: x(x__len_)
        real(c_double), intent(out) :: out(x__len_)
        ! manifest end
      
      
        out = exp(x)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const x__, 
        double* const out__, 
        const R_xlen_t x__len_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        const R_xlen_t out__len_ = x__len_;
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        
        fn(x__, out__, x__len_);
        
        UNPROTECT(1);
        return out;
      }

---

    Code
      fn
    Output
      function (x) 
      {
          declare(type(x = double(NA)))
          out <- log(x)
          out
      }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out, x__len_) bind(c)
        use iso_c_binding, only: c_double, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: x__len_
      
        ! args
        real(c_double), intent(in) :: x(x__len_)
        real(c_double), intent(out) :: out(x__len_)
        ! manifest end
      
      
        out = log(x)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const x__, 
        double* const out__, 
        const R_xlen_t x__len_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        const R_xlen_t out__len_ = x__len_;
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        
        fn(x__, out__, x__len_);
        
        UNPROTECT(1);
        return out;
      }

---

    Code
      fn
    Output
      function (x) 
      {
          declare(type(x = double(NA)))
          out <- log10(x)
          out
      }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out, x__len_) bind(c)
        use iso_c_binding, only: c_double, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: x__len_
      
        ! args
        real(c_double), intent(in) :: x(x__len_)
        real(c_double), intent(out) :: out(x__len_)
        ! manifest end
      
      
        out = log10(x)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const x__, 
        double* const out__, 
        const R_xlen_t x__len_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        const R_xlen_t out__len_ = x__len_;
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        
        fn(x__, out__, x__len_);
        
        UNPROTECT(1);
        return out;
      }

---

    Code
      fn
    Output
      function (x) 
      {
          declare(type(x = double(NA)))
          out <- floor(x)
          out
      }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out, x__len_) bind(c)
        use iso_c_binding, only: c_double, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: x__len_
      
        ! args
        real(c_double), intent(in) :: x(x__len_)
        real(c_double), intent(out) :: out(x__len_)
        ! manifest end
      
      
        out = (aint(x) - merge(1.0_c_double, 0.0_c_double, (x < aint(x))))
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const x__, 
        double* const out__, 
        const R_xlen_t x__len_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        const R_xlen_t out__len_ = x__len_;
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        
        fn(x__, out__, x__len_);
        
        UNPROTECT(1);
        return out;
      }

---

    Code
      fn
    Output
      function (x) 
      {
          declare(type(x = double(NA)))
          out <- ceiling(x)
          out
      }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out, x__len_) bind(c)
        use iso_c_binding, only: c_double, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: x__len_
      
        ! args
        real(c_double), intent(in) :: x(x__len_)
        real(c_double), intent(out) :: out(x__len_)
        ! manifest end
      
      
        out = (aint(x) + merge(1.0_c_double, 0.0_c_double, (x > aint(x))))
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const x__, 
        double* const out__, 
        const R_xlen_t x__len_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        const R_xlen_t out__len_ = x__len_;
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        
        fn(x__, out__, x__len_);
        
        UNPROTECT(1);
        return out;
      }

---

    Code
      fn
    Output
      function (x) 
      {
          declare(type(x = double(NA)))
          out <- abs(x)
          out
      }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out, x__len_) bind(c)
        use iso_c_binding, only: c_double, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: x__len_
      
        ! args
        real(c_double), intent(in) :: x(x__len_)
        real(c_double), intent(out) :: out(x__len_)
        ! manifest end
      
      
        out = abs(x)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const x__, 
        double* const out__, 
        const R_xlen_t x__len_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        const R_xlen_t out__len_ = x__len_;
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        
        fn(x__, out__, x__len_);
        
        UNPROTECT(1);
        return out;
      }

# integer unary intrinsics

    Code
      fn
    Output
      function (x) 
      {
          declare(type(x = integer(NA)))
          out <- abs(x)
          out
      }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out, x__len_) bind(c)
        use iso_c_binding, only: c_int, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: x__len_
      
        ! args
        integer(c_int), intent(in) :: x(x__len_)
        integer(c_int), intent(out) :: out(x__len_)
        ! manifest end
      
      
        out = abs(x)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const int* const x__, 
        int* const out__, 
        const R_xlen_t x__len_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != INTSXP) {
          Rf_error("typeof(x) must be 'integer', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const int* const x__ = INTEGER(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        const R_xlen_t out__len_ = x__len_;
        SEXP out = PROTECT(Rf_allocVector(INTSXP, out__len_));
        int* out__ = INTEGER(out);
        
        fn(x__, out__, x__len_);
        
        UNPROTECT(1);
        return out;
      }

# complex unary intrinsics

    Code
      fn
    Output
      function (z) 
      {
          declare(type(z = complex(NA)))
          out <- sin(z)
          out
      }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(z, out, z__len_) bind(c)
        use iso_c_binding, only: c_double_complex, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: z__len_
      
        ! args
        complex(c_double_complex), intent(in) :: z(z__len_)
        complex(c_double_complex), intent(out) :: out(z__len_)
        ! manifest end
      
      
        out = sin(z)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const Rcomplex* const z__, 
        Rcomplex* const out__, 
        const R_xlen_t z__len_);
      
      SEXP fn_(SEXP _args) {
        // z
        _args = CDR(_args);
        SEXP z = CAR(_args);
        if (TYPEOF(z) != CPLXSXP) {
          Rf_error("typeof(z) must be 'complex', not '%s'", Rf_type2char(TYPEOF(z)));
        }
        const Rcomplex* const z__ = COMPLEX(z);
        const R_xlen_t z__len_ = Rf_xlength(z);
        
        const R_xlen_t out__len_ = z__len_;
        SEXP out = PROTECT(Rf_allocVector(CPLXSXP, out__len_));
        Rcomplex* out__ = COMPLEX(out);
        
        fn(z__, out__, z__len_);
        
        UNPROTECT(1);
        return out;
      }

---

    Code
      fn
    Output
      function (z) 
      {
          declare(type(z = complex(NA)))
          out <- cos(z)
          out
      }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(z, out, z__len_) bind(c)
        use iso_c_binding, only: c_double_complex, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: z__len_
      
        ! args
        complex(c_double_complex), intent(in) :: z(z__len_)
        complex(c_double_complex), intent(out) :: out(z__len_)
        ! manifest end
      
      
        out = cos(z)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const Rcomplex* const z__, 
        Rcomplex* const out__, 
        const R_xlen_t z__len_);
      
      SEXP fn_(SEXP _args) {
        // z
        _args = CDR(_args);
        SEXP z = CAR(_args);
        if (TYPEOF(z) != CPLXSXP) {
          Rf_error("typeof(z) must be 'complex', not '%s'", Rf_type2char(TYPEOF(z)));
        }
        const Rcomplex* const z__ = COMPLEX(z);
        const R_xlen_t z__len_ = Rf_xlength(z);
        
        const R_xlen_t out__len_ = z__len_;
        SEXP out = PROTECT(Rf_allocVector(CPLXSXP, out__len_));
        Rcomplex* out__ = COMPLEX(out);
        
        fn(z__, out__, z__len_);
        
        UNPROTECT(1);
        return out;
      }

---

    Code
      fn
    Output
      function (z) 
      {
          declare(type(z = complex(NA)))
          out <- tan(z)
          out
      }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(z, out, z__len_) bind(c)
        use iso_c_binding, only: c_double_complex, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: z__len_
      
        ! args
        complex(c_double_complex), intent(in) :: z(z__len_)
        complex(c_double_complex), intent(out) :: out(z__len_)
        ! manifest end
      
      
        out = tan(z)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const Rcomplex* const z__, 
        Rcomplex* const out__, 
        const R_xlen_t z__len_);
      
      SEXP fn_(SEXP _args) {
        // z
        _args = CDR(_args);
        SEXP z = CAR(_args);
        if (TYPEOF(z) != CPLXSXP) {
          Rf_error("typeof(z) must be 'complex', not '%s'", Rf_type2char(TYPEOF(z)));
        }
        const Rcomplex* const z__ = COMPLEX(z);
        const R_xlen_t z__len_ = Rf_xlength(z);
        
        const R_xlen_t out__len_ = z__len_;
        SEXP out = PROTECT(Rf_allocVector(CPLXSXP, out__len_));
        Rcomplex* out__ = COMPLEX(out);
        
        fn(z__, out__, z__len_);
        
        UNPROTECT(1);
        return out;
      }

---

    Code
      fn
    Output
      function (z) 
      {
          declare(type(z = complex(NA)))
          out <- tanh(z)
          out
      }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(z, out, z__len_) bind(c)
        use iso_c_binding, only: c_double_complex, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: z__len_
      
        ! args
        complex(c_double_complex), intent(in) :: z(z__len_)
        complex(c_double_complex), intent(out) :: out(z__len_)
        ! manifest end
      
      
        out = tanh(z)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const Rcomplex* const z__, 
        Rcomplex* const out__, 
        const R_xlen_t z__len_);
      
      SEXP fn_(SEXP _args) {
        // z
        _args = CDR(_args);
        SEXP z = CAR(_args);
        if (TYPEOF(z) != CPLXSXP) {
          Rf_error("typeof(z) must be 'complex', not '%s'", Rf_type2char(TYPEOF(z)));
        }
        const Rcomplex* const z__ = COMPLEX(z);
        const R_xlen_t z__len_ = Rf_xlength(z);
        
        const R_xlen_t out__len_ = z__len_;
        SEXP out = PROTECT(Rf_allocVector(CPLXSXP, out__len_));
        Rcomplex* out__ = COMPLEX(out);
        
        fn(z__, out__, z__len_);
        
        UNPROTECT(1);
        return out;
      }

---

    Code
      fn
    Output
      function (z) 
      {
          declare(type(z = complex(NA)))
          out <- asin(z)
          out
      }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(z, out, z__len_) bind(c)
        use iso_c_binding, only: c_double_complex, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: z__len_
      
        ! args
        complex(c_double_complex), intent(in) :: z(z__len_)
        complex(c_double_complex), intent(out) :: out(z__len_)
        ! manifest end
      
      
        out = asin(z)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const Rcomplex* const z__, 
        Rcomplex* const out__, 
        const R_xlen_t z__len_);
      
      SEXP fn_(SEXP _args) {
        // z
        _args = CDR(_args);
        SEXP z = CAR(_args);
        if (TYPEOF(z) != CPLXSXP) {
          Rf_error("typeof(z) must be 'complex', not '%s'", Rf_type2char(TYPEOF(z)));
        }
        const Rcomplex* const z__ = COMPLEX(z);
        const R_xlen_t z__len_ = Rf_xlength(z);
        
        const R_xlen_t out__len_ = z__len_;
        SEXP out = PROTECT(Rf_allocVector(CPLXSXP, out__len_));
        Rcomplex* out__ = COMPLEX(out);
        
        fn(z__, out__, z__len_);
        
        UNPROTECT(1);
        return out;
      }

---

    Code
      fn
    Output
      function (z) 
      {
          declare(type(z = complex(NA)))
          out <- acos(z)
          out
      }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(z, out, z__len_) bind(c)
        use iso_c_binding, only: c_double_complex, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: z__len_
      
        ! args
        complex(c_double_complex), intent(in) :: z(z__len_)
        complex(c_double_complex), intent(out) :: out(z__len_)
        ! manifest end
      
      
        out = acos(z)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const Rcomplex* const z__, 
        Rcomplex* const out__, 
        const R_xlen_t z__len_);
      
      SEXP fn_(SEXP _args) {
        // z
        _args = CDR(_args);
        SEXP z = CAR(_args);
        if (TYPEOF(z) != CPLXSXP) {
          Rf_error("typeof(z) must be 'complex', not '%s'", Rf_type2char(TYPEOF(z)));
        }
        const Rcomplex* const z__ = COMPLEX(z);
        const R_xlen_t z__len_ = Rf_xlength(z);
        
        const R_xlen_t out__len_ = z__len_;
        SEXP out = PROTECT(Rf_allocVector(CPLXSXP, out__len_));
        Rcomplex* out__ = COMPLEX(out);
        
        fn(z__, out__, z__len_);
        
        UNPROTECT(1);
        return out;
      }

---

    Code
      fn
    Output
      function (z) 
      {
          declare(type(z = complex(NA)))
          out <- atan(z)
          out
      }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(z, out, z__len_) bind(c)
        use iso_c_binding, only: c_double_complex, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: z__len_
      
        ! args
        complex(c_double_complex), intent(in) :: z(z__len_)
        complex(c_double_complex), intent(out) :: out(z__len_)
        ! manifest end
      
      
        out = atan(z)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const Rcomplex* const z__, 
        Rcomplex* const out__, 
        const R_xlen_t z__len_);
      
      SEXP fn_(SEXP _args) {
        // z
        _args = CDR(_args);
        SEXP z = CAR(_args);
        if (TYPEOF(z) != CPLXSXP) {
          Rf_error("typeof(z) must be 'complex', not '%s'", Rf_type2char(TYPEOF(z)));
        }
        const Rcomplex* const z__ = COMPLEX(z);
        const R_xlen_t z__len_ = Rf_xlength(z);
        
        const R_xlen_t out__len_ = z__len_;
        SEXP out = PROTECT(Rf_allocVector(CPLXSXP, out__len_));
        Rcomplex* out__ = COMPLEX(out);
        
        fn(z__, out__, z__len_);
        
        UNPROTECT(1);
        return out;
      }

---

    Code
      fn
    Output
      function (z) 
      {
          declare(type(z = complex(NA)))
          out <- sqrt(z)
          out
      }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(z, out, z__len_) bind(c)
        use iso_c_binding, only: c_double_complex, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: z__len_
      
        ! args
        complex(c_double_complex), intent(in) :: z(z__len_)
        complex(c_double_complex), intent(out) :: out(z__len_)
        ! manifest end
      
      
        out = sqrt(z)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const Rcomplex* const z__, 
        Rcomplex* const out__, 
        const R_xlen_t z__len_);
      
      SEXP fn_(SEXP _args) {
        // z
        _args = CDR(_args);
        SEXP z = CAR(_args);
        if (TYPEOF(z) != CPLXSXP) {
          Rf_error("typeof(z) must be 'complex', not '%s'", Rf_type2char(TYPEOF(z)));
        }
        const Rcomplex* const z__ = COMPLEX(z);
        const R_xlen_t z__len_ = Rf_xlength(z);
        
        const R_xlen_t out__len_ = z__len_;
        SEXP out = PROTECT(Rf_allocVector(CPLXSXP, out__len_));
        Rcomplex* out__ = COMPLEX(out);
        
        fn(z__, out__, z__len_);
        
        UNPROTECT(1);
        return out;
      }

---

    Code
      fn
    Output
      function (z) 
      {
          declare(type(z = complex(NA)))
          out <- exp(z)
          out
      }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(z, out, z__len_) bind(c)
        use iso_c_binding, only: c_double_complex, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: z__len_
      
        ! args
        complex(c_double_complex), intent(in) :: z(z__len_)
        complex(c_double_complex), intent(out) :: out(z__len_)
        ! manifest end
      
      
        out = exp(z)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const Rcomplex* const z__, 
        Rcomplex* const out__, 
        const R_xlen_t z__len_);
      
      SEXP fn_(SEXP _args) {
        // z
        _args = CDR(_args);
        SEXP z = CAR(_args);
        if (TYPEOF(z) != CPLXSXP) {
          Rf_error("typeof(z) must be 'complex', not '%s'", Rf_type2char(TYPEOF(z)));
        }
        const Rcomplex* const z__ = COMPLEX(z);
        const R_xlen_t z__len_ = Rf_xlength(z);
        
        const R_xlen_t out__len_ = z__len_;
        SEXP out = PROTECT(Rf_allocVector(CPLXSXP, out__len_));
        Rcomplex* out__ = COMPLEX(out);
        
        fn(z__, out__, z__len_);
        
        UNPROTECT(1);
        return out;
      }

---

    Code
      fn
    Output
      function (z) 
      {
          declare(type(z = complex(NA)))
          out <- log(z)
          out
      }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(z, out, z__len_) bind(c)
        use iso_c_binding, only: c_double_complex, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: z__len_
      
        ! args
        complex(c_double_complex), intent(in) :: z(z__len_)
        complex(c_double_complex), intent(out) :: out(z__len_)
        ! manifest end
      
      
        out = log(z)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const Rcomplex* const z__, 
        Rcomplex* const out__, 
        const R_xlen_t z__len_);
      
      SEXP fn_(SEXP _args) {
        // z
        _args = CDR(_args);
        SEXP z = CAR(_args);
        if (TYPEOF(z) != CPLXSXP) {
          Rf_error("typeof(z) must be 'complex', not '%s'", Rf_type2char(TYPEOF(z)));
        }
        const Rcomplex* const z__ = COMPLEX(z);
        const R_xlen_t z__len_ = Rf_xlength(z);
        
        const R_xlen_t out__len_ = z__len_;
        SEXP out = PROTECT(Rf_allocVector(CPLXSXP, out__len_));
        Rcomplex* out__ = COMPLEX(out);
        
        fn(z__, out__, z__len_);
        
        UNPROTECT(1);
        return out;
      }

---

    Code
      fn
    Output
      function (z) 
      {
          declare(type(z = complex(NA)))
          out <- log10(z)
          out
      }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(z, out, z__len_) bind(c)
        use iso_c_binding, only: c_double, c_double_complex, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: z__len_
      
        ! args
        complex(c_double_complex), intent(in) :: z(z__len_)
        complex(c_double_complex), intent(out) :: out(z__len_)
        ! manifest end
      
      
        out = (log(z) / log(10.0_c_double))
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const Rcomplex* const z__, 
        Rcomplex* const out__, 
        const R_xlen_t z__len_);
      
      SEXP fn_(SEXP _args) {
        // z
        _args = CDR(_args);
        SEXP z = CAR(_args);
        if (TYPEOF(z) != CPLXSXP) {
          Rf_error("typeof(z) must be 'complex', not '%s'", Rf_type2char(TYPEOF(z)));
        }
        const Rcomplex* const z__ = COMPLEX(z);
        const R_xlen_t z__len_ = Rf_xlength(z);
        
        const R_xlen_t out__len_ = z__len_;
        SEXP out = PROTECT(Rf_allocVector(CPLXSXP, out__len_));
        Rcomplex* out__ = COMPLEX(out);
        
        fn(z__, out__, z__len_);
        
        UNPROTECT(1);
        return out;
      }

---

    Code
      fn
    Output
      function (z) 
      {
          declare(type(z = complex(NA)))
          out <- Re(z)
          out
      }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(z, out, z__len_) bind(c)
        use iso_c_binding, only: c_double, c_double_complex, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: z__len_
      
        ! args
        complex(c_double_complex), intent(in) :: z(z__len_)
        real(c_double), intent(out) :: out(z__len_)
        ! manifest end
      
      
        out = real(z)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const Rcomplex* const z__, 
        double* const out__, 
        const R_xlen_t z__len_);
      
      SEXP fn_(SEXP _args) {
        // z
        _args = CDR(_args);
        SEXP z = CAR(_args);
        if (TYPEOF(z) != CPLXSXP) {
          Rf_error("typeof(z) must be 'complex', not '%s'", Rf_type2char(TYPEOF(z)));
        }
        const Rcomplex* const z__ = COMPLEX(z);
        const R_xlen_t z__len_ = Rf_xlength(z);
        
        const R_xlen_t out__len_ = z__len_;
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        
        fn(z__, out__, z__len_);
        
        UNPROTECT(1);
        return out;
      }

---

    Code
      fn
    Output
      function (z) 
      {
          declare(type(z = complex(NA)))
          out <- Im(z)
          out
      }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(z, out, z__len_) bind(c)
        use iso_c_binding, only: c_double, c_double_complex, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: z__len_
      
        ! args
        complex(c_double_complex), intent(in) :: z(z__len_)
        real(c_double), intent(out) :: out(z__len_)
        ! manifest end
      
      
        out = aimag(z)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const Rcomplex* const z__, 
        double* const out__, 
        const R_xlen_t z__len_);
      
      SEXP fn_(SEXP _args) {
        // z
        _args = CDR(_args);
        SEXP z = CAR(_args);
        if (TYPEOF(z) != CPLXSXP) {
          Rf_error("typeof(z) must be 'complex', not '%s'", Rf_type2char(TYPEOF(z)));
        }
        const Rcomplex* const z__ = COMPLEX(z);
        const R_xlen_t z__len_ = Rf_xlength(z);
        
        const R_xlen_t out__len_ = z__len_;
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        
        fn(z__, out__, z__len_);
        
        UNPROTECT(1);
        return out;
      }

---

    Code
      fn
    Output
      function (z) 
      {
          declare(type(z = complex(NA)))
          out <- Mod(z)
          out
      }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(z, out, z__len_) bind(c)
        use iso_c_binding, only: c_double, c_double_complex, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: z__len_
      
        ! args
        complex(c_double_complex), intent(in) :: z(z__len_)
        real(c_double), intent(out) :: out(z__len_)
        ! manifest end
      
      
        out = abs(z)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const Rcomplex* const z__, 
        double* const out__, 
        const R_xlen_t z__len_);
      
      SEXP fn_(SEXP _args) {
        // z
        _args = CDR(_args);
        SEXP z = CAR(_args);
        if (TYPEOF(z) != CPLXSXP) {
          Rf_error("typeof(z) must be 'complex', not '%s'", Rf_type2char(TYPEOF(z)));
        }
        const Rcomplex* const z__ = COMPLEX(z);
        const R_xlen_t z__len_ = Rf_xlength(z);
        
        const R_xlen_t out__len_ = z__len_;
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        
        fn(z__, out__, z__len_);
        
        UNPROTECT(1);
        return out;
      }

---

    Code
      fn
    Output
      function (z) 
      {
          declare(type(z = complex(NA)))
          out <- Arg(z)
          out
      }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(z, out, z__len_) bind(c)
        use iso_c_binding, only: c_double, c_double_complex, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: z__len_
      
        ! args
        complex(c_double_complex), intent(in) :: z(z__len_)
        real(c_double), intent(out) :: out(z__len_)
        ! manifest end
      
      
        out = atan2(aimag(z), real(z))
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const Rcomplex* const z__, 
        double* const out__, 
        const R_xlen_t z__len_);
      
      SEXP fn_(SEXP _args) {
        // z
        _args = CDR(_args);
        SEXP z = CAR(_args);
        if (TYPEOF(z) != CPLXSXP) {
          Rf_error("typeof(z) must be 'complex', not '%s'", Rf_type2char(TYPEOF(z)));
        }
        const Rcomplex* const z__ = COMPLEX(z);
        const R_xlen_t z__len_ = Rf_xlength(z);
        
        const R_xlen_t out__len_ = z__len_;
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        
        fn(z__, out__, z__len_);
        
        UNPROTECT(1);
        return out;
      }

---

    Code
      fn
    Output
      function (z) 
      {
          declare(type(z = complex(NA)))
          out <- Conj(z)
          out
      }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(z, out, z__len_) bind(c)
        use iso_c_binding, only: c_double_complex, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: z__len_
      
        ! args
        complex(c_double_complex), intent(in) :: z(z__len_)
        complex(c_double_complex), intent(out) :: out(z__len_)
        ! manifest end
      
      
        out = conjg(z)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const Rcomplex* const z__, 
        Rcomplex* const out__, 
        const R_xlen_t z__len_);
      
      SEXP fn_(SEXP _args) {
        // z
        _args = CDR(_args);
        SEXP z = CAR(_args);
        if (TYPEOF(z) != CPLXSXP) {
          Rf_error("typeof(z) must be 'complex', not '%s'", Rf_type2char(TYPEOF(z)));
        }
        const Rcomplex* const z__ = COMPLEX(z);
        const R_xlen_t z__len_ = Rf_xlength(z);
        
        const R_xlen_t out__len_ = z__len_;
        SEXP out = PROTECT(Rf_allocVector(CPLXSXP, out__len_));
        Rcomplex* out__ = COMPLEX(out);
        
        fn(z__, out__, z__len_);
        
        UNPROTECT(1);
        return out;
      }

# logical not local used as ifelse mask compiles and runs

    Code
      fn
    Output
      function(x) {
          declare(type(x = logical(NA)))
          y <- !x
          out <- ifelse(y, 1L, 0L)
          out
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out, x__len_) bind(c)
        use iso_c_binding, only: c_int, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: x__len_
      
        ! args
        integer(c_int), intent(in) :: x(x__len_) ! logical
        integer(c_int), intent(out) :: out(x__len_)
      
        ! locals
        logical, allocatable :: y(:) ! logical
        ! manifest end
      
        allocate(y(x__len_))
      
      
        y = (.not. (x/=0))
        out = merge(1_c_int, 0_c_int, y)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const int* const x__, 
        int* const out__, 
        const R_xlen_t x__len_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != LGLSXP) {
          Rf_error("typeof(x) must be 'logical', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const int* const x__ = LOGICAL(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        const R_xlen_t out__len_ = x__len_;
        SEXP out = PROTECT(Rf_allocVector(INTSXP, out__len_));
        int* out__ = INTEGER(out);
        
        fn(x__, out__, x__len_);
        
        UNPROTECT(1);
        return out;
      }

# case-sensitive variable name clashes

    Code
      quick(function(j) {
        declare(type(j = integer(1)))
        J <- double(length = j)
        J
      })
    Condition
      Error in `check_all_var_names_valid()`:
      ! Fortran is case-insensitive; these names conflict when mapped: `j -> j` and `J -> J`

# reserved or underscored names are rejected

    Code
      quick(function(x) {
        `_bad` <- x + 1L
        `_bad`
      })
    Condition
      Error in `check_all_var_names_valid()`:
      ! symbols cannot start or end with '_', but found: _bad

---

    Code
      quick(function(x) {
        bad_ <- x + 1L
        bad_
      })
    Condition
      Error in `check_all_var_names_valid()`:
      ! symbols cannot start or end with '_', but found: bad_

---

    Code
      quick(function(int) {
        int
      })
    Condition
      Error in `check_all_var_names_valid()`:
      ! symbols map to reserved Fortran names: int -> int

---

    Code
      quick(function(foo.bar, foo_bar) {
        1
      })
    Condition
      Error in `check_all_var_names_valid()`:
      ! Fortran is case-insensitive; these names conflict when mapped: `foo.bar -> foo_bar` and `foo_bar -> foo_bar`

# sapply lowers scalar-return closures (named + inline)

    Code
      cat("# Snapshot note: ", note, "\n", sep = "")
    Output
      # Snapshot note: Named local closure lowered to an internal subroutine using host association for captures (no capture arguments).
    Code
      fn
    Output
      function(x) {
          declare(type(x = double(NA)))
          out <- double(length(x))
          f <- function(i) x[i] * 2
          out <- sapply(seq_along(out), f)
          out
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out, x__len_) bind(c)
        use iso_c_binding, only: c_double, c_int, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: x__len_
      
        ! args
        real(c_double), intent(in) :: x(x__len_)
        real(c_double), intent(out) :: out(x__len_)
      
        ! locals
        integer(c_int) :: tmp1_
        ! manifest end
      
      
        out = 0
      
        do tmp1_ = 1_c_int, x__len_
          call f(tmp1_, out(tmp1_))
      
        end do
      
      
        contains
          subroutine f(i, res)
            use iso_c_binding, only: c_double, c_int
            implicit none
      
            integer(c_int), intent(in) :: i
            real(c_double), intent(out) :: res
      
      
            res = (x(i) * 2.0_c_double)
          end subroutine
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const x__, 
        double* const out__, 
        const R_xlen_t x__len_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        const R_xlen_t out__len_ = x__len_;
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        
        fn(x__, out__, x__len_);
        
        UNPROTECT(1);
        return out;
      }

---

    Code
      cat("# Snapshot note: ", note, "\n", sep = "")
    Output
      # Snapshot note: Inline closure lowered to an internal subroutine using host association for captures (no capture arguments).
    Code
      fn
    Output
      function(x, thresh) {
          declare(type(x = double(NA)), type(thresh = double(1)))
          out <- logical(length(x))
          out <- sapply(seq_along(out), function(i) x[i] > thresh)
          out
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, thresh, out, x__len_) bind(c)
        use iso_c_binding, only: c_double, c_int, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: x__len_
      
        ! args
        real(c_double), intent(in) :: x(x__len_)
        real(c_double), intent(in) :: thresh
        integer(c_int), intent(out) :: out(x__len_) ! logical
      
        ! locals
        integer(c_int) :: tmp1_
        ! manifest end
      
      
        out = .false.
        do tmp1_ = 1_c_int, x__len_
          call closure1_(tmp1_, out(tmp1_))
      
        end do
      
      
        contains
          subroutine closure1_(i, res)
            use iso_c_binding, only: c_int
            implicit none
      
            integer(c_int), intent(in) :: i
            integer(c_int), intent(out) :: res ! logical
      
      
            res = (x(i) > thresh)
          end subroutine
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const x__, 
        const double* const thresh__, 
        int* const out__, 
        const R_xlen_t x__len_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        // thresh
        _args = CDR(_args);
        SEXP thresh = CAR(_args);
        if (TYPEOF(thresh) != REALSXP) {
          Rf_error("typeof(thresh) must be 'double', not '%s'", Rf_type2char(TYPEOF(thresh)));
        }
        const double* const thresh__ = REAL(thresh);
        const R_xlen_t thresh__len_ = Rf_xlength(thresh);
        
        if (thresh__len_ != 1)
          Rf_error("length(thresh) must be 1, not %0.f",
                    (double)thresh__len_);
        const R_xlen_t out__len_ = x__len_;
        SEXP out = PROTECT(Rf_allocVector(LGLSXP, out__len_));
        int* out__ = LOGICAL(out);
        
        fn(
          x__,
          thresh__,
          out__,
          x__len_);
        
        UNPROTECT(1);
        return out;
      }

# sapply supports integer scalar return

    Code
      cat("# Snapshot note: ", note, "\n", sep = "")
    Output
      # Snapshot note: Integer scalar return produces an integer vector.
    Code
      fn
    Output
      function(x) {
          declare(type(x = double(NA)))
          out <- integer(length(x))
          out <- sapply(seq_along(out), function(i) i * 2L)
          out
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out, x__len_) bind(c)
        use iso_c_binding, only: c_double, c_int, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: x__len_
      
        ! args
        real(c_double), intent(in) :: x(x__len_)
        integer(c_int), intent(out) :: out(x__len_)
      
        ! locals
        integer(c_int) :: tmp1_
        ! manifest end
      
      
        out = 0
        do tmp1_ = 1_c_int, x__len_
          call closure1_(tmp1_, out(tmp1_))
      
        end do
      
      
        contains
          subroutine closure1_(i, res)
            use iso_c_binding, only: c_int
            implicit none
      
            integer(c_int), intent(in) :: i
            integer(c_int), intent(out) :: res
      
      
            res = (i * 2_c_int)
          end subroutine
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const x__, 
        int* const out__, 
        const R_xlen_t x__len_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        const R_xlen_t out__len_ = x__len_;
        SEXP out = PROTECT(Rf_allocVector(INTSXP, out__len_));
        int* out__ = INTEGER(out);
        
        fn(x__, out__, x__len_);
        
        UNPROTECT(1);
        return out;
      }

# sapply supports vector return -> matrix output

    Code
      cat("# Snapshot note: ", note, "\n", sep = "")
    Output
      # Snapshot note: Vector return from a closure simplifies to a rank-2 output.
    Code
      fn
    Output
      function(x) {
          declare(type(x = double(m, n)))
          out <- matrix(0, nrow(x), ncol(x))
          out <- sapply(seq_len(ncol(x)), function(j) x[, j] * 2.0)
          out
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out, x__dim_1_, x__dim_2_) bind(c)
        use iso_c_binding, only: c_double, c_int
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_int), intent(in), value :: x__dim_1_
        integer(c_int), intent(in), value :: x__dim_2_
      
        ! args
        real(c_double), intent(in) :: x(x__dim_1_, x__dim_2_)
        real(c_double), intent(out) :: out(x__dim_1_, x__dim_2_)
      
        ! locals
        integer(c_int) :: tmp1_
        ! manifest end
      
      
        out = 0.0_c_double
        do tmp1_ = 1_c_int, x__dim_2_
          call closure1_(tmp1_, out(:, tmp1_))
      
        end do
      
      
        contains
          subroutine closure1_(j, res)
            use iso_c_binding, only: c_double, c_int
            implicit none
      
            integer(c_int), intent(in) :: j
            real(c_double), intent(out) :: res(:)
      
      
            res = (x(:, j) * 2.0_c_double)
          end subroutine
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const x__, 
        double* const out__, 
        const R_len_t x__dim_1_, 
        const R_len_t x__dim_2_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const int* const x__dim_ = ({
        SEXP dim_ = Rf_getAttrib(x, R_DimSymbol);
        if (Rf_length(dim_) != 2) Rf_error(
          "x must be a 2D-array, but length(dim(x)) is %i",
          (int) Rf_length(dim_));
        INTEGER(dim_);});
        const int x__dim_1_ = x__dim_[0];
        const int x__dim_2_ = x__dim_[1];
        
        const R_xlen_t out__len_ = (x__dim_1_) * (x__dim_2_);
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        {
          const SEXP _dim_sexp = PROTECT(Rf_allocVector(INTSXP, 2));
          int* const _dim = INTEGER(_dim_sexp);
          _dim[0] = x__dim_1_;
          _dim[1] = x__dim_2_;
          Rf_dimgets(out, _dim_sexp);
        }
        
        fn(
          x__,
          out__,
          x__dim_1_,
          x__dim_2_);
        
        UNPROTECT(2);
        return out;
      }

# sapply supports logical vector return -> logical matrix output

    Code
      cat("# Snapshot note: ", note, "\n", sep = "")
    Output
      # Snapshot note: Logical vector return simplifies to a logical matrix output.
    Code
      fn
    Output
      function(x, thresh) {
          declare(type(x = double(m, n)), type(thresh = double(1)))
          out <- matrix(FALSE, nrow(x), ncol(x))
          out <- sapply(seq_len(ncol(x)), function(j) x[, j] > thresh)
          out
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, thresh, out, x__dim_1_, x__dim_2_) bind(c)
        use iso_c_binding, only: c_double, c_int
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_int), intent(in), value :: x__dim_1_
        integer(c_int), intent(in), value :: x__dim_2_
      
        ! args
        real(c_double), intent(in) :: x(x__dim_1_, x__dim_2_)
        real(c_double), intent(in) :: thresh
        integer(c_int), intent(out) :: out(x__dim_1_, x__dim_2_) ! logical
      
        ! locals
        integer(c_int) :: tmp1_
        ! manifest end
      
      
        out = .false.
        do tmp1_ = 1_c_int, x__dim_2_
          call closure1_(tmp1_, out(:, tmp1_))
      
        end do
      
      
        contains
          subroutine closure1_(j, res)
            use iso_c_binding, only: c_int
            implicit none
      
            integer(c_int), intent(in) :: j
            integer(c_int), intent(out) :: res(:) ! logical
      
      
            res = (x(:, j) > thresh)
          end subroutine
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const x__, 
        const double* const thresh__, 
        int* const out__, 
        const R_len_t x__dim_1_, 
        const R_len_t x__dim_2_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const int* const x__dim_ = ({
        SEXP dim_ = Rf_getAttrib(x, R_DimSymbol);
        if (Rf_length(dim_) != 2) Rf_error(
          "x must be a 2D-array, but length(dim(x)) is %i",
          (int) Rf_length(dim_));
        INTEGER(dim_);});
        const int x__dim_1_ = x__dim_[0];
        const int x__dim_2_ = x__dim_[1];
        
        // thresh
        _args = CDR(_args);
        SEXP thresh = CAR(_args);
        if (TYPEOF(thresh) != REALSXP) {
          Rf_error("typeof(thresh) must be 'double', not '%s'", Rf_type2char(TYPEOF(thresh)));
        }
        const double* const thresh__ = REAL(thresh);
        const R_xlen_t thresh__len_ = Rf_xlength(thresh);
        
        if (thresh__len_ != 1)
          Rf_error("length(thresh) must be 1, not %0.f",
                    (double)thresh__len_);
        const R_xlen_t out__len_ = (x__dim_1_) * (x__dim_2_);
        SEXP out = PROTECT(Rf_allocVector(LGLSXP, out__len_));
        int* out__ = LOGICAL(out);
        {
          const SEXP _dim_sexp = PROTECT(Rf_allocVector(INTSXP, 2));
          int* const _dim = INTEGER(_dim_sexp);
          _dim[0] = x__dim_1_;
          _dim[1] = x__dim_2_;
          Rf_dimgets(out, _dim_sexp);
        }
        
        fn(
          x__,
          thresh__,
          out__,
          x__dim_1_,
          x__dim_2_);
        
        UNPROTECT(2);
        return out;
      }

# sapply supports matrix return -> rank-3 output

    Code
      cat("# Snapshot note: ", note, "\n", sep = "")
    Output
      # Snapshot note: Matrix return from a closure simplifies to a rank-3 output.
    Code
      fn
    Output
      function(x, k) {
          declare(type(x = double(m, n)), type(k = integer(1)))
          out <- array(0, dim = c(nrow(x), ncol(x), k))
          out <- sapply(seq_len(k), function(t) x + as.double(t), simplify = "array")
          out
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, k, out, x__dim_1_, x__dim_2_) bind(c)
        use iso_c_binding, only: c_double, c_int
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_int), intent(in), value :: x__dim_1_
        integer(c_int), intent(in), value :: x__dim_2_
      
        ! args
        real(c_double), intent(in) :: x(x__dim_1_, x__dim_2_)
        integer(c_int), intent(in) :: k
        real(c_double), intent(out) :: out(x__dim_1_, x__dim_2_, k)
      
        ! locals
        integer(c_int) :: tmp1_
        ! manifest end
      
      
        out = 0.0_c_double
        do tmp1_ = 1_c_int, k
          call closure1_(tmp1_, out(:, :, tmp1_))
      
        end do
      
      
        contains
          subroutine closure1_(t, res)
            use iso_c_binding, only: c_double, c_int
            implicit none
      
            integer(c_int), intent(in) :: t
            real(c_double), intent(out) :: res(:, :)
      
      
            res = (x + real(t, kind=c_double))
          end subroutine
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const x__, 
        const int* const k__, 
        double* const out__, 
        const R_len_t x__dim_1_, 
        const R_len_t x__dim_2_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const int* const x__dim_ = ({
        SEXP dim_ = Rf_getAttrib(x, R_DimSymbol);
        if (Rf_length(dim_) != 2) Rf_error(
          "x must be a 2D-array, but length(dim(x)) is %i",
          (int) Rf_length(dim_));
        INTEGER(dim_);});
        const int x__dim_1_ = x__dim_[0];
        const int x__dim_2_ = x__dim_[1];
        
        // k
        _args = CDR(_args);
        SEXP k = CAR(_args);
        if (TYPEOF(k) != INTSXP) {
          Rf_error("typeof(k) must be 'integer', not '%s'", Rf_type2char(TYPEOF(k)));
        }
        const int* const k__ = INTEGER(k);
        const R_xlen_t k__len_ = Rf_xlength(k);
        
        if (k__len_ != 1)
          Rf_error("length(k) must be 1, not %0.f",
                    (double)k__len_);
        const int _as_int_k = Rf_asInteger(k);
        const R_xlen_t out__len_ = (x__dim_1_) * (x__dim_2_) * (_as_int_k);
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        {
          const SEXP _dim_sexp = PROTECT(Rf_allocVector(INTSXP, 3));
          int* const _dim = INTEGER(_dim_sexp);
          _dim[0] = x__dim_1_;
          _dim[1] = x__dim_2_;
          _dim[2] = _as_int_k;
          Rf_dimgets(out, _dim_sexp);
        }
        
        fn(
          x__,
          k__,
          out__,
          x__dim_1_,
          x__dim_2_);
        
        UNPROTECT(2);
        return out;
      }

# sapply supports slice returns for higher-rank captures

    Code
      cat("# Snapshot note: ", note, "\n", sep = "")
    Output
      # Snapshot note: Matrix slice x[,,t] returned into a rank-3 result.
    Code
      fn
    Output
      function(x) {
          declare(type(x = double(a, b, k)))
          out <- array(0, dim = dim(x))
          out <- sapply(
            seq_len(dim(x)[3]),
            function(t) x[,, t] + 1.0,
            simplify = "array"
          )
          out
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out, x__dim_1_, x__dim_2_, x__dim_3_) bind(c)
        use iso_c_binding, only: c_double, c_int
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_int), intent(in), value :: x__dim_1_
        integer(c_int), intent(in), value :: x__dim_2_
        integer(c_int), intent(in), value :: x__dim_3_
      
        ! args
        real(c_double), intent(in) :: x(x__dim_1_, x__dim_2_, x__dim_3_)
        real(c_double), intent(out) :: out(x__dim_1_, x__dim_2_, x__dim_3_)
      
        ! locals
        integer(c_int) :: tmp1_
        ! manifest end
      
      
        out = 0.0_c_double
        block
          integer(c_int) :: btmp1_(3)
      
          btmp1_ = shape(x)
          do tmp1_ = 1_c_int, x__dim_3_
            call closure1_(tmp1_, out(:, :, tmp1_))
      
          end do
      
        end block
      
        contains
          subroutine closure1_(t, res)
            use iso_c_binding, only: c_double, c_int
            implicit none
      
            integer(c_int), intent(in) :: t
            real(c_double), intent(out) :: res(:, :)
      
      
            res = (x(:, :, t) + 1.0_c_double)
          end subroutine
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const x__, 
        double* const out__, 
        const R_len_t x__dim_1_, 
        const R_len_t x__dim_2_, 
        const R_len_t x__dim_3_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const int* const x__dim_ = ({
        SEXP dim_ = Rf_getAttrib(x, R_DimSymbol);
        if (Rf_length(dim_) != 3) Rf_error(
          "x must be a 3D-array, but length(dim(x)) is %i",
          (int) Rf_length(dim_));
        INTEGER(dim_);});
        const int x__dim_1_ = x__dim_[0];
        const int x__dim_2_ = x__dim_[1];
        const int x__dim_3_ = x__dim_[2];
        
        const R_xlen_t out__len_ = (x__dim_1_) * (x__dim_2_) * (x__dim_3_);
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        {
          const SEXP _dim_sexp = PROTECT(Rf_allocVector(INTSXP, 3));
          int* const _dim = INTEGER(_dim_sexp);
          _dim[0] = x__dim_1_;
          _dim[1] = x__dim_2_;
          _dim[2] = x__dim_3_;
          Rf_dimgets(out, _dim_sexp);
        }
        
        fn(
          x__,
          out__,
          x__dim_1_,
          x__dim_2_,
          x__dim_3_);
        
        UNPROTECT(2);
        return out;
      }

---

    Code
      cat("# Snapshot note: ", note, "\n", sep = "")
    Output
      # Snapshot note: Rank-3 slice x[,,,t] returned into a rank-4 result.
    Code
      fn
    Output
      function(x) {
          declare(type(x = double(a, b, c, k)))
          out <- array(0, dim = dim(x))
          out <- sapply(
            seq_len(dim(x)[4]),
            function(t) x[,,, t] * 2.0,
            simplify = "array"
          )
          out
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out, x__dim_1_, x__dim_2_, x__dim_3_, x__dim_4_) bind(c)
        use iso_c_binding, only: c_double, c_int
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_int), intent(in), value :: x__dim_1_
        integer(c_int), intent(in), value :: x__dim_2_
        integer(c_int), intent(in), value :: x__dim_3_
        integer(c_int), intent(in), value :: x__dim_4_
      
        ! args
        real(c_double), intent(in) :: x(x__dim_1_, x__dim_2_, x__dim_3_, x__dim_4_)
        real(c_double), intent(out) :: out(x__dim_1_, x__dim_2_, x__dim_3_, x__dim_4_)
      
        ! locals
        integer(c_int) :: tmp1_
        ! manifest end
      
      
        out = 0.0_c_double
        block
          integer(c_int) :: btmp1_(4)
      
          btmp1_ = shape(x)
          do tmp1_ = 1_c_int, x__dim_4_
            call closure1_(tmp1_, out(:, :, :, tmp1_))
      
          end do
      
        end block
      
        contains
          subroutine closure1_(t, res)
            use iso_c_binding, only: c_double, c_int
            implicit none
      
            integer(c_int), intent(in) :: t
            real(c_double), intent(out) :: res(:, :, :)
      
      
            res = (x(:, :, :, t) * 2.0_c_double)
          end subroutine
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const x__, 
        double* const out__, 
        const R_len_t x__dim_1_, 
        const R_len_t x__dim_2_, 
        const R_len_t x__dim_3_, 
        const R_len_t x__dim_4_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const int* const x__dim_ = ({
        SEXP dim_ = Rf_getAttrib(x, R_DimSymbol);
        if (Rf_length(dim_) != 4) Rf_error(
          "x must be a 4D-array, but length(dim(x)) is %i",
          (int) Rf_length(dim_));
        INTEGER(dim_);});
        const int x__dim_1_ = x__dim_[0];
        const int x__dim_2_ = x__dim_[1];
        const int x__dim_3_ = x__dim_[2];
        const int x__dim_4_ = x__dim_[3];
        
        const R_xlen_t out__len_ = (x__dim_1_) * (x__dim_2_) * (x__dim_3_) * (x__dim_4_);
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        {
          const SEXP _dim_sexp = PROTECT(Rf_allocVector(INTSXP, 4));
          int* const _dim = INTEGER(_dim_sexp);
          _dim[0] = x__dim_1_;
          _dim[1] = x__dim_2_;
          _dim[2] = x__dim_3_;
          _dim[3] = x__dim_4_;
          Rf_dimgets(out, _dim_sexp);
        }
        
        fn(
          x__,
          out__,
          x__dim_1_,
          x__dim_2_,
          x__dim_3_,
          x__dim_4_);
        
        UNPROTECT(2);
        return out;
      }

# sapply supports rank-3 return -> rank-4 output

    Code
      cat("# Snapshot note: ", note, "\n", sep = "")
    Output
      # Snapshot note: Rank-3 return from a closure simplifies to a rank-4 output.
    Code
      fn
    Output
      function(x, k) {
          declare(type(x = double(a, b, c)), type(k = integer(1)))
          out <- array(0, dim = c(dim(x), k))
          out <- sapply(seq_len(k), function(t) x + as.double(t), simplify = "array")
          out
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, k, out, x__dim_1_, x__dim_2_, x__dim_3_) bind(c)
        use iso_c_binding, only: c_double, c_int
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_int), intent(in), value :: x__dim_1_
        integer(c_int), intent(in), value :: x__dim_2_
        integer(c_int), intent(in), value :: x__dim_3_
      
        ! args
        real(c_double), intent(in) :: x(x__dim_1_, x__dim_2_, x__dim_3_)
        integer(c_int), intent(in) :: k
        real(c_double), intent(out) :: out(x__dim_1_, x__dim_2_, x__dim_3_, k)
      
        ! locals
        integer(c_int) :: tmp1_
        ! manifest end
      
      
        out = 0.0_c_double
        do tmp1_ = 1_c_int, k
          call closure1_(tmp1_, out(:, :, :, tmp1_))
      
        end do
      
      
        contains
          subroutine closure1_(t, res)
            use iso_c_binding, only: c_double, c_int
            implicit none
      
            integer(c_int), intent(in) :: t
            real(c_double), intent(out) :: res(:, :, :)
      
      
            res = (x + real(t, kind=c_double))
          end subroutine
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const x__, 
        const int* const k__, 
        double* const out__, 
        const R_len_t x__dim_1_, 
        const R_len_t x__dim_2_, 
        const R_len_t x__dim_3_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const int* const x__dim_ = ({
        SEXP dim_ = Rf_getAttrib(x, R_DimSymbol);
        if (Rf_length(dim_) != 3) Rf_error(
          "x must be a 3D-array, but length(dim(x)) is %i",
          (int) Rf_length(dim_));
        INTEGER(dim_);});
        const int x__dim_1_ = x__dim_[0];
        const int x__dim_2_ = x__dim_[1];
        const int x__dim_3_ = x__dim_[2];
        
        // k
        _args = CDR(_args);
        SEXP k = CAR(_args);
        if (TYPEOF(k) != INTSXP) {
          Rf_error("typeof(k) must be 'integer', not '%s'", Rf_type2char(TYPEOF(k)));
        }
        const int* const k__ = INTEGER(k);
        const R_xlen_t k__len_ = Rf_xlength(k);
        
        if (k__len_ != 1)
          Rf_error("length(k) must be 1, not %0.f",
                    (double)k__len_);
        const int _as_int_k = Rf_asInteger(k);
        const R_xlen_t out__len_ = (x__dim_1_) * (x__dim_2_) * (x__dim_3_) * (_as_int_k);
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        {
          const SEXP _dim_sexp = PROTECT(Rf_allocVector(INTSXP, 4));
          int* const _dim = INTEGER(_dim_sexp);
          _dim[0] = x__dim_1_;
          _dim[1] = x__dim_2_;
          _dim[2] = x__dim_3_;
          _dim[3] = _as_int_k;
          Rf_dimgets(out, _dim_sexp);
        }
        
        fn(
          x__,
          k__,
          out__,
          x__dim_1_,
          x__dim_2_,
          x__dim_3_);
        
        UNPROTECT(2);
        return out;
      }

# closures can capture and index rank>1 arrays with x[i] linear indexing

    Code
      cat("# Snapshot note: ", note, "\n", sep = "")
    Output
      # Snapshot note: Linear indexing x[i] on a rank-2 capture uses computed subscripts.
    Code
      fn
    Output
      function(x) {
          declare(type(x = double(3, 4)))
          out <- double(length(x))
          out <- sapply(seq_along(out), function(i) x[i] + 1.0)
          out
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out) bind(c)
        use iso_c_binding, only: c_double, c_int
        implicit none
      
        ! manifest start
        ! args
        real(c_double), intent(in) :: x(3, 4)
        real(c_double), intent(out) :: out(12)
      
        ! locals
        integer(c_int) :: tmp1_
        ! manifest end
      
      
        out = 0
        do tmp1_ = 1_c_int, 12_c_int
          call closure1_(tmp1_, out(tmp1_))
      
        end do
      
      
        contains
          subroutine closure1_(i, res)
            use iso_c_binding, only: c_double, c_int
            implicit none
      
            integer(c_int), intent(in) :: i
            real(c_double), intent(out) :: res
      
      
      res = (x((mod((int(i, kind=c_int) - 1_c_int), size(x, 1)) + 1_c_int), (((int(i, kind=c_int) - 1_c_int) / size(x, 1)) + 1_c_int)) +&
          & 1.0_c_double)
          end subroutine
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(const double* const x__, double* const out__);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const int* const x__dim_ = ({
        SEXP dim_ = Rf_getAttrib(x, R_DimSymbol);
        if (Rf_length(dim_) != 2) Rf_error(
          "x must be a 2D-array, but length(dim(x)) is %i",
          (int) Rf_length(dim_));
        INTEGER(dim_);});
        const int x__dim_1_ = x__dim_[0];
        const int x__dim_2_ = x__dim_[1];
        
        if (x__dim_1_ != 3)
          Rf_error("dim(x)[1] must be 3, not %0.f",
                    (double)x__dim_1_);
        if (x__dim_2_ != 4)
          Rf_error("dim(x)[2] must be 4, not %0.f",
                    (double)x__dim_2_);
        const R_xlen_t out__len_ = 12;
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        
        fn(x__, out__);
        
        UNPROTECT(1);
        return out;
      }

# sapply preserves R semantics when output is also captured

    Code
      cat("# Snapshot note: ", note, "\n", sep = "")
    Output
      # Snapshot note: When the output is captured by the closure, quickr uses a hidden temp to avoid in-place updates during the loop.
    Code
      fn
    Output
      function(x) {
          declare(type(x = double(m, n)))
          out <- matrix(0, nrow(x), ncol(x))
          out <- x
          out <- sapply(seq_len(ncol(out)), function(j) out[, j] + 1.0)
          out
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out, x__dim_1_, x__dim_2_) bind(c)
        use iso_c_binding, only: c_double, c_int
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_int), intent(in), value :: x__dim_1_
        integer(c_int), intent(in), value :: x__dim_2_
      
        ! args
        real(c_double), intent(in) :: x(x__dim_1_, x__dim_2_)
        real(c_double), intent(out) :: out(x__dim_1_, x__dim_2_)
      
        ! locals
        integer(c_int) :: tmp1_
        ! manifest end
      
      
        out = 0.0_c_double
        out = x
        block
          real(c_double), allocatable :: btmp1_(:, :)
      
          allocate(btmp1_(x__dim_1_, x__dim_2_))
          do tmp1_ = 1_c_int, x__dim_2_
            call closure1_(tmp1_, btmp1_(:, tmp1_))
      
          end do
      
      
          out = btmp1_
        end block
      
        contains
          subroutine closure1_(j, res)
            use iso_c_binding, only: c_double, c_int
            implicit none
      
            integer(c_int), intent(in) :: j
            real(c_double), intent(out) :: res(:)
      
      
            res = (out(:, j) + 1.0_c_double)
          end subroutine
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const x__, 
        double* const out__, 
        const R_len_t x__dim_1_, 
        const R_len_t x__dim_2_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const int* const x__dim_ = ({
        SEXP dim_ = Rf_getAttrib(x, R_DimSymbol);
        if (Rf_length(dim_) != 2) Rf_error(
          "x must be a 2D-array, but length(dim(x)) is %i",
          (int) Rf_length(dim_));
        INTEGER(dim_);});
        const int x__dim_1_ = x__dim_[0];
        const int x__dim_2_ = x__dim_[1];
        
        const R_xlen_t out__len_ = (x__dim_1_) * (x__dim_2_);
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        {
          const SEXP _dim_sexp = PROTECT(Rf_allocVector(INTSXP, 2));
          int* const _dim = INTEGER(_dim_sexp);
          _dim[0] = x__dim_1_;
          _dim[1] = x__dim_2_;
          Rf_dimgets(out, _dim_sexp);
        }
        
        fn(
          x__,
          out__,
          x__dim_1_,
          x__dim_2_);
        
        UNPROTECT(2);
        return out;
      }

# hoist mask

    Code
      fn
    Output
      function(x) {
          declare(type(x = double(NA)))
          out <- max(x)
          out
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out, x__len_) bind(c)
        use iso_c_binding, only: c_double, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: x__len_
      
        ! args
        real(c_double), intent(in) :: x(x__len_)
        real(c_double), intent(out) :: out
        ! manifest end
      
      
        out = maxval(x)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const x__, 
        double* const out__, 
        const R_xlen_t x__len_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        const R_xlen_t out__len_ = (1);
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        
        fn(x__, out__, x__len_);
        
        UNPROTECT(1);
        return out;
      }

---

    Code
      fn
    Output
      function(x) {
          declare(type(x = double(NA)))
          out <- max(x[x >= 0])
          out
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out, x__len_) bind(c)
        use iso_c_binding, only: c_double, c_int, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: x__len_
      
        ! args
        real(c_double), intent(in) :: x(x__len_)
        real(c_double), intent(out) :: out
        ! manifest end
      
      
        out = maxval(x, mask = (x >= 0_c_int))
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const x__, 
        double* const out__, 
        const R_xlen_t x__len_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        const R_xlen_t out__len_ = (1);
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        
        fn(x__, out__, x__len_);
        
        UNPROTECT(1);
        return out;
      }

# size check blocks redeclare hoisted size temps

    Code
      fn
    Output
      function(n, m, a, b) {
          declare(
            type(n = integer(1)),
            type(m = integer(1)),
            type(a = double(min(n, m))),
            type(b = double(min(n, m))),
            type(out = double(min(n, m)))
          )
          out <- double(min(n, m))
          for (i in seq_len(length(out))) {
            out[i] <- a[i] + b[i]
          }
          out
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(n, m, a, b, out) bind(c)
        use iso_c_binding, only: c_double, c_int
        implicit none
      
        ! manifest start
        ! args
        integer(c_int), intent(in) :: n
        integer(c_int), intent(in) :: m
        real(c_double), intent(in) :: a(min(n, m))
        real(c_double), intent(in) :: b(min(n, m))
        real(c_double), intent(out) :: out(min(n, m))
      
        ! locals
        integer(c_int) :: i
        ! manifest end
      
      
        out = 0
        do i = 1, size(out)
          out(i) = (a(i) + b(i))
        end do
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const int* const n__, 
        const int* const m__, 
        const double* const a__, 
        const double* const b__, 
        double* const out__);
      
      SEXP fn_(SEXP _args) {
        // n
        _args = CDR(_args);
        SEXP n = CAR(_args);
        if (TYPEOF(n) != INTSXP) {
          Rf_error("typeof(n) must be 'integer', not '%s'", Rf_type2char(TYPEOF(n)));
        }
        const int* const n__ = INTEGER(n);
        const R_xlen_t n__len_ = Rf_xlength(n);
        
        // m
        _args = CDR(_args);
        SEXP m = CAR(_args);
        if (TYPEOF(m) != INTSXP) {
          Rf_error("typeof(m) must be 'integer', not '%s'", Rf_type2char(TYPEOF(m)));
        }
        const int* const m__ = INTEGER(m);
        const R_xlen_t m__len_ = Rf_xlength(m);
        
        // a
        _args = CDR(_args);
        SEXP a = CAR(_args);
        if (TYPEOF(a) != REALSXP) {
          Rf_error("typeof(a) must be 'double', not '%s'", Rf_type2char(TYPEOF(a)));
        }
        const double* const a__ = REAL(a);
        const R_xlen_t a__len_ = Rf_xlength(a);
        
        // b
        _args = CDR(_args);
        SEXP b = CAR(_args);
        if (TYPEOF(b) != REALSXP) {
          Rf_error("typeof(b) must be 'double', not '%s'", Rf_type2char(TYPEOF(b)));
        }
        const double* const b__ = REAL(b);
        const R_xlen_t b__len_ = Rf_xlength(b);
        
        if (n__len_ != 1)
          Rf_error("length(n) must be 1, not %0.f",
                    (double)n__len_);
        if (m__len_ != 1)
          Rf_error("length(m) must be 1, not %0.f",
                    (double)m__len_);
        const int _as_int_n = Rf_asInteger(n);
        const int _as_int_m = Rf_asInteger(m);
        {
          const R_xlen_t expected = ((_as_int_n) < (_as_int_m) ? (_as_int_n) : (_as_int_m));
          if (a__len_ != expected)
            Rf_error("length(a) must equal (min(n, m)),"
                     " but are %0.f and %0.f",
                      (double)a__len_, (double)expected);
        }
        {
          const R_xlen_t expected = ((_as_int_n) < (_as_int_m) ? (_as_int_n) : (_as_int_m));
          if (b__len_ != expected)
            Rf_error("length(b) must equal (min(n, m)),"
                     " but are %0.f and %0.f",
                      (double)b__len_, (double)expected);
        }
        const R_xlen_t out__len_ = ((_as_int_n) < (_as_int_m) ? (_as_int_n) : (_as_int_m));
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        
        fn(
          n__,
          m__,
          a__,
          b__,
          out__);
        
        UNPROTECT(1);
        return out;
      }

# which.max

    Code
      r2f(fn)
    Output
      subroutine fn(a, out, a__len_) bind(c)
        use iso_c_binding, only: c_double, c_int, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: a__len_
      
        ! args
        real(c_double), intent(in) :: a(a__len_)
        integer(c_int), intent(out) :: out
        ! manifest end
      
      
        out = maxloc(a, 1)
      end subroutine
      
      @r: function (a)
        {
            declare(type(a = double(NA)))
            out <- which.max(a)
            out
        }
      @c_bridge: #define R_NO_REMAP
        #include <R.h>
        #include <Rinternals.h>
        
        
        extern void fn(
          const double* const a__,
          int* const out__,
          const R_xlen_t a__len_);
        
        SEXP fn_(SEXP _args) {
          // a
          _args = CDR(_args);
          SEXP a = CAR(_args);
          if (TYPEOF(a) != REALSXP) {
            Rf_error("typeof(a) must be 'double', not '%s'", Rf_type2char(TYPEOF(a)));
          }
          const double* const a__ = REAL(a);
          const R_xlen_t a__len_ = Rf_xlength(a);
        
          const R_xlen_t out__len_ = (1);
          SEXP out = PROTECT(Rf_allocVector(INTSXP, out__len_));
          int* out__ = INTEGER(out);
        
          fn(a__, out__, a__len_);
        
          UNPROTECT(1);
          return out;
        }

---

    Code
      r2f(fn)
    Output
      subroutine fn(a, out, a__len_) bind(c)
        use iso_c_binding, only: c_int, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: a__len_
      
        ! args
        integer(c_int), intent(in) :: a(a__len_) ! logical
        integer(c_int), intent(out) :: out
        ! manifest end
      
      
        out = max(1_c_int, findloc(a, 1_c_int, 1, kind=c_int))
      end subroutine
      
      @r: function (a)
        {
            declare(type(a = logical(NA)))
            out <- which.max(a)
            out
        }
      @c_bridge: #define R_NO_REMAP
        #include <R.h>
        #include <Rinternals.h>
        
        
        extern void fn(
          const int* const a__,
          int* const out__,
          const R_xlen_t a__len_);
        
        SEXP fn_(SEXP _args) {
          // a
          _args = CDR(_args);
          SEXP a = CAR(_args);
          if (TYPEOF(a) != LGLSXP) {
            Rf_error("typeof(a) must be 'logical', not '%s'", Rf_type2char(TYPEOF(a)));
          }
          const int* const a__ = LOGICAL(a);
          const R_xlen_t a__len_ = Rf_xlength(a);
        
          const R_xlen_t out__len_ = (1);
          SEXP out = PROTECT(Rf_allocVector(INTSXP, out__len_));
          int* out__ = INTEGER(out);
        
          fn(a__, out__, a__len_);
        
          UNPROTECT(1);
          return out;
        }

# which.max/which.min

    Code
      fn
    Output
      function(lgl1, int1, dbl1) {
          declare(type(lgl1 = logical(NA)))
          declare(type(int1 = integer(NA)))
          declare(type(dbl1 = double(NA)))
          out <- c(
            which.min(lgl1),
            which.min(int1),
            which.min(dbl1),
            which.max(lgl1),
            which.max(int1),
            which.max(dbl1),
            which.max(dbl1[dbl1 < 0])
          )
          out
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(lgl1, int1, dbl1, out, dbl1__len_, int1__len_, lgl1__len_) bind(c)
        use iso_c_binding, only: c_double, c_int, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: lgl1__len_
        integer(c_ptrdiff_t), intent(in), value :: int1__len_
        integer(c_ptrdiff_t), intent(in), value :: dbl1__len_
      
        ! args
        integer(c_int), intent(in) :: lgl1(lgl1__len_) ! logical
        integer(c_int), intent(in) :: int1(int1__len_)
        real(c_double), intent(in) :: dbl1(dbl1__len_)
        integer(c_int), intent(out) :: out(7)
        ! manifest end
      
      
      
      
      out = [ max(1_c_int, findloc(lgl1, 0_c_int, 1, kind=c_int)), minloc(int1, 1), minloc(dbl1, 1), max(1_c_int, findloc(lgl1, 1_c_int,&
      & 1, kind=c_int)), maxloc(int1, 1), maxloc(dbl1, 1), maxloc(pack(dbl1, (dbl1 < 0_c_int)), 1) ]
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const int* const lgl1__, 
        const int* const int1__, 
        const double* const dbl1__, 
        int* const out__, 
        const R_xlen_t dbl1__len_, 
        const R_xlen_t int1__len_, 
        const R_xlen_t lgl1__len_);
      
      SEXP fn_(SEXP _args) {
        // lgl1
        _args = CDR(_args);
        SEXP lgl1 = CAR(_args);
        if (TYPEOF(lgl1) != LGLSXP) {
          Rf_error("typeof(lgl1) must be 'logical', not '%s'", Rf_type2char(TYPEOF(lgl1)));
        }
        const int* const lgl1__ = LOGICAL(lgl1);
        const R_xlen_t lgl1__len_ = Rf_xlength(lgl1);
        
        // int1
        _args = CDR(_args);
        SEXP int1 = CAR(_args);
        if (TYPEOF(int1) != INTSXP) {
          Rf_error("typeof(int1) must be 'integer', not '%s'", Rf_type2char(TYPEOF(int1)));
        }
        const int* const int1__ = INTEGER(int1);
        const R_xlen_t int1__len_ = Rf_xlength(int1);
        
        // dbl1
        _args = CDR(_args);
        SEXP dbl1 = CAR(_args);
        if (TYPEOF(dbl1) != REALSXP) {
          Rf_error("typeof(dbl1) must be 'double', not '%s'", Rf_type2char(TYPEOF(dbl1)));
        }
        const double* const dbl1__ = REAL(dbl1);
        const R_xlen_t dbl1__len_ = Rf_xlength(dbl1);
        
        const R_xlen_t out__len_ = 7;
        SEXP out = PROTECT(Rf_allocVector(INTSXP, out__len_));
        int* out__ = INTEGER(out);
        
        fn(
          lgl1__,
          int1__,
          dbl1__,
          out__,
          dbl1__len_,
          int1__len_,
          lgl1__len_);
        
        UNPROTECT(1);
        return out;
      }

# between

    Code
      fn
    Output
      function(x, left, right) {
          declare({
            type(x = double(n))
            type(left = double(1))
            type(right = double(1))
          })
          out <- x >= left & x <= right
          out
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, left, right, out, x__len_) bind(c)
        use iso_c_binding, only: c_double, c_int, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: x__len_
      
        ! args
        real(c_double), intent(in) :: x(x__len_)
        real(c_double), intent(in) :: left
        real(c_double), intent(in) :: right
        integer(c_int), intent(out) :: out(x__len_) ! logical
        ! manifest end
      
      
        out = (x >= left) .and. (x <= right)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const x__, 
        const double* const left__, 
        const double* const right__, 
        int* const out__, 
        const R_xlen_t x__len_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        // left
        _args = CDR(_args);
        SEXP left = CAR(_args);
        if (TYPEOF(left) != REALSXP) {
          Rf_error("typeof(left) must be 'double', not '%s'", Rf_type2char(TYPEOF(left)));
        }
        const double* const left__ = REAL(left);
        const R_xlen_t left__len_ = Rf_xlength(left);
        
        // right
        _args = CDR(_args);
        SEXP right = CAR(_args);
        if (TYPEOF(right) != REALSXP) {
          Rf_error("typeof(right) must be 'double', not '%s'", Rf_type2char(TYPEOF(right)));
        }
        const double* const right__ = REAL(right);
        const R_xlen_t right__len_ = Rf_xlength(right);
        
        if (left__len_ != 1)
          Rf_error("length(left) must be 1, not %0.f",
                    (double)left__len_);
        if (right__len_ != 1)
          Rf_error("length(right) must be 1, not %0.f",
                    (double)right__len_);
        const R_xlen_t out__len_ = x__len_;
        SEXP out = PROTECT(Rf_allocVector(LGLSXP, out__len_));
        int* out__ = LOGICAL(out);
        
        fn(
          x__,
          left__,
          right__,
          out__,
          x__len_);
        
        UNPROTECT(1);
        return out;
      }

# logical ops

    Code
      fn
    Output
      function(a, b) {
          declare(
            type(a = double(1)),
            type(b = double(1))
          )
      
          delta <- a - b
          if (delta < 0) {
            delta <- (-1) * delta
          }
      
          a_gt_b <- a > b
          b_gt_a <- b > a
          delta_lt_3 <- delta <= 3
      
          out <- (a_gt_b || b_gt_a) && delta_lt_3
          out
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(a, b, out) bind(c)
        use iso_c_binding, only: c_double, c_int
        implicit none
      
        ! manifest start
        ! args
        real(c_double), intent(in) :: a
        real(c_double), intent(in) :: b
        integer(c_int), intent(out) :: out ! logical
      
        ! locals
        real(c_double) :: delta
        logical :: a_gt_b ! logical
        logical :: b_gt_a ! logical
        logical :: delta_lt_3 ! logical
        ! manifest end
      
      
        delta = (a - b)
        if ((delta < 0.0_c_double)) then
          delta = ((-1.0_c_double) * delta)
        end if
        a_gt_b = (a > b)
        b_gt_a = (b > a)
        delta_lt_3 = (delta <= 3.0_c_double)
        out = (a_gt_b .or. b_gt_a) .and. delta_lt_3
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const a__, 
        const double* const b__, 
        int* const out__);
      
      SEXP fn_(SEXP _args) {
        // a
        _args = CDR(_args);
        SEXP a = CAR(_args);
        if (TYPEOF(a) != REALSXP) {
          Rf_error("typeof(a) must be 'double', not '%s'", Rf_type2char(TYPEOF(a)));
        }
        const double* const a__ = REAL(a);
        const R_xlen_t a__len_ = Rf_xlength(a);
        
        // b
        _args = CDR(_args);
        SEXP b = CAR(_args);
        if (TYPEOF(b) != REALSXP) {
          Rf_error("typeof(b) must be 'double', not '%s'", Rf_type2char(TYPEOF(b)));
        }
        const double* const b__ = REAL(b);
        const R_xlen_t b__len_ = Rf_xlength(b);
        
        if (a__len_ != 1)
          Rf_error("length(a) must be 1, not %0.f",
                    (double)a__len_);
        if (b__len_ != 1)
          Rf_error("length(b) must be 1, not %0.f",
                    (double)b__len_);
        const R_xlen_t out__len_ = (1);
        SEXP out = PROTECT(Rf_allocVector(LGLSXP, out__len_));
        int* out__ = LOGICAL(out);
        
        fn(a__, b__, out__);
        
        UNPROTECT(1);
        return out;
      }

---

    Code
      fn
    Output
      function(a, b) {
          declare({
            type(a = double(1))
            type(b = double(1))
          })
      
          delta <- abs(a - b)
          out <- (a != b) & (delta <= 3)
          out
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(a, b, out) bind(c)
        use iso_c_binding, only: c_double, c_int
        implicit none
      
        ! manifest start
        ! args
        real(c_double), intent(in) :: a
        real(c_double), intent(in) :: b
        integer(c_int), intent(out) :: out ! logical
      
        ! locals
        real(c_double) :: delta
        ! manifest end
      
      
        delta = abs((a - b))
        out = ((a /= b)) .and. ((delta <= 3.0_c_double))
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const a__, 
        const double* const b__, 
        int* const out__);
      
      SEXP fn_(SEXP _args) {
        // a
        _args = CDR(_args);
        SEXP a = CAR(_args);
        if (TYPEOF(a) != REALSXP) {
          Rf_error("typeof(a) must be 'double', not '%s'", Rf_type2char(TYPEOF(a)));
        }
        const double* const a__ = REAL(a);
        const R_xlen_t a__len_ = Rf_xlength(a);
        
        // b
        _args = CDR(_args);
        SEXP b = CAR(_args);
        if (TYPEOF(b) != REALSXP) {
          Rf_error("typeof(b) must be 'double', not '%s'", Rf_type2char(TYPEOF(b)));
        }
        const double* const b__ = REAL(b);
        const R_xlen_t b__len_ = Rf_xlength(b);
        
        if (a__len_ != 1)
          Rf_error("length(a) must be 1, not %0.f",
                    (double)a__len_);
        if (b__len_ != 1)
          Rf_error("length(b) must be 1, not %0.f",
                    (double)b__len_);
        const R_xlen_t out__len_ = (1);
        SEXP out = PROTECT(Rf_allocVector(LGLSXP, out__len_));
        int* out__ = LOGICAL(out);
        
        fn(a__, b__, out__);
        
        UNPROTECT(1);
        return out;
      }

---

    Code
      fn
    Output
      function(a, b) {
          declare(type(a = double(1)), type(b = double(1)))
          out <- (a != b) && abs(a - b) <= 3
          out
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(a, b, out) bind(c)
        use iso_c_binding, only: c_double, c_int
        implicit none
      
        ! manifest start
        ! args
        real(c_double), intent(in) :: a
        real(c_double), intent(in) :: b
        integer(c_int), intent(out) :: out ! logical
        ! manifest end
      
      
        out = ((a /= b)) .and. (abs((a - b)) <= 3.0_c_double)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const a__, 
        const double* const b__, 
        int* const out__);
      
      SEXP fn_(SEXP _args) {
        // a
        _args = CDR(_args);
        SEXP a = CAR(_args);
        if (TYPEOF(a) != REALSXP) {
          Rf_error("typeof(a) must be 'double', not '%s'", Rf_type2char(TYPEOF(a)));
        }
        const double* const a__ = REAL(a);
        const R_xlen_t a__len_ = Rf_xlength(a);
        
        // b
        _args = CDR(_args);
        SEXP b = CAR(_args);
        if (TYPEOF(b) != REALSXP) {
          Rf_error("typeof(b) must be 'double', not '%s'", Rf_type2char(TYPEOF(b)));
        }
        const double* const b__ = REAL(b);
        const R_xlen_t b__len_ = Rf_xlength(b);
        
        if (a__len_ != 1)
          Rf_error("length(a) must be 1, not %0.f",
                    (double)a__len_);
        if (b__len_ != 1)
          Rf_error("length(b) must be 1, not %0.f",
                    (double)b__len_);
        const R_xlen_t out__len_ = (1);
        SEXP out = PROTECT(Rf_allocVector(LGLSXP, out__len_));
        int* out__ = LOGICAL(out);
        
        fn(a__, b__, out__);
        
        UNPROTECT(1);
        return out;
      }

---

    Code
      fn
    Output
      function(a, b) {
          declare(type(a = double(n)), type(b = double(n)))
          out <- (a != b) & abs(a - b) <= 3
          out
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(a, b, out, a__len_) bind(c)
        use iso_c_binding, only: c_double, c_int, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: a__len_
      
        ! args
        real(c_double), intent(in) :: a(a__len_)
        real(c_double), intent(in) :: b(a__len_)
        integer(c_int), intent(out) :: out(a__len_) ! logical
        ! manifest end
      
      
        out = ((a /= b)) .and. (abs((a - b)) <= 3.0_c_double)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const a__, 
        const double* const b__, 
        int* const out__, 
        const R_xlen_t a__len_);
      
      SEXP fn_(SEXP _args) {
        // a
        _args = CDR(_args);
        SEXP a = CAR(_args);
        if (TYPEOF(a) != REALSXP) {
          Rf_error("typeof(a) must be 'double', not '%s'", Rf_type2char(TYPEOF(a)));
        }
        const double* const a__ = REAL(a);
        const R_xlen_t a__len_ = Rf_xlength(a);
        
        // b
        _args = CDR(_args);
        SEXP b = CAR(_args);
        if (TYPEOF(b) != REALSXP) {
          Rf_error("typeof(b) must be 'double', not '%s'", Rf_type2char(TYPEOF(b)));
        }
        const double* const b__ = REAL(b);
        const R_xlen_t b__len_ = Rf_xlength(b);
        
        if (a__len_ != b__len_)
          Rf_error("length(b) must equal length(a),"
                   " but are %0.f and %0.f",
                    (double)b__len_, (double)a__len_);
        const R_xlen_t out__len_ = a__len_;
        SEXP out = PROTECT(Rf_allocVector(LGLSXP, out__len_));
        int* out__ = LOGICAL(out);
        
        fn(
          a__,
          b__,
          out__,
          a__len_);
        
        UNPROTECT(1);
        return out;
      }

# parentheses preserve logical precedence

    Code
      fn
    Output
      function(x, y) {
          declare(type(x = integer(1)), type(y = integer(1)))
          cond <- (x > 8L || x <= 0L) && (y > 8L || y <= 0L)
          cond
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, y, cond) bind(c)
        use iso_c_binding, only: c_int
        implicit none
      
        ! manifest start
        ! args
        integer(c_int), intent(in) :: x
        integer(c_int), intent(in) :: y
        integer(c_int), intent(out) :: cond ! logical
        ! manifest end
      
      
        cond = ((x > 8_c_int) .or. (x <= 0_c_int)) .and. ((y > 8_c_int) .or. (y <= 0_c_int))
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const int* const x__, 
        const int* const y__, 
        int* const cond__);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != INTSXP) {
          Rf_error("typeof(x) must be 'integer', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const int* const x__ = INTEGER(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        // y
        _args = CDR(_args);
        SEXP y = CAR(_args);
        if (TYPEOF(y) != INTSXP) {
          Rf_error("typeof(y) must be 'integer', not '%s'", Rf_type2char(TYPEOF(y)));
        }
        const int* const y__ = INTEGER(y);
        const R_xlen_t y__len_ = Rf_xlength(y);
        
        if (x__len_ != 1)
          Rf_error("length(x) must be 1, not %0.f",
                    (double)x__len_);
        if (y__len_ != 1)
          Rf_error("length(y) must be 1, not %0.f",
                    (double)y__len_);
        const R_xlen_t cond__len_ = (1);
        SEXP cond = PROTECT(Rf_allocVector(LGLSXP, cond__len_));
        int* cond__ = LOGICAL(cond);
        
        fn(x__, y__, cond__);
        
        UNPROTECT(1);
        return cond;
      }

---

    Code
      fn
    Output
      function(x, y) {
          declare(type(x = integer(1)), type(y = integer(1)))
          cond_x <- x > 8L || x <= 0L
          cond_y <- y > 8L || y <= 0L
          cond_x && cond_y
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, y, out_) bind(c)
        use iso_c_binding, only: c_int
        implicit none
      
        ! manifest start
        ! args
        integer(c_int), intent(in) :: x
        integer(c_int), intent(in) :: y
        integer(c_int), intent(out) :: out_ ! logical
      
        ! locals
        logical :: cond_x ! logical
        logical :: cond_y ! logical
        ! manifest end
      
      
        cond_x = (x > 8_c_int) .or. (x <= 0_c_int)
        cond_y = (y > 8_c_int) .or. (y <= 0_c_int)
        out_ = cond_x .and. cond_y
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const int* const x__, 
        const int* const y__, 
        int* const out___);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != INTSXP) {
          Rf_error("typeof(x) must be 'integer', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const int* const x__ = INTEGER(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        // y
        _args = CDR(_args);
        SEXP y = CAR(_args);
        if (TYPEOF(y) != INTSXP) {
          Rf_error("typeof(y) must be 'integer', not '%s'", Rf_type2char(TYPEOF(y)));
        }
        const int* const y__ = INTEGER(y);
        const R_xlen_t y__len_ = Rf_xlength(y);
        
        if (x__len_ != 1)
          Rf_error("length(x) must be 1, not %0.f",
                    (double)x__len_);
        if (y__len_ != 1)
          Rf_error("length(y) must be 1, not %0.f",
                    (double)y__len_);
        const R_xlen_t out___len_ = (1);
        SEXP out_ = PROTECT(Rf_allocVector(LGLSXP, out___len_));
        int* out___ = LOGICAL(out_);
        
        fn(x__, y__, out___);
        
        UNPROTECT(1);
        return out_;
      }

# heat diffusion

    Code
      diffuse_heat
    Output
      function(nx, ny, dx, dy, dt, k, steps) {
          declare(
            type(nx = integer(1)),
            type(ny = integer(1)),
            type(dx = integer(1)),
            type(dy = integer(1)),
            type(dt = double(1)),
            type(k = double(1)),
            type(steps = integer(1))
          )
      
          # Initialize temperature grid
          temp <- matrix(0, nx, ny)
          temp[nx / 2, ny / 2] <- 100 # Initial heat source in the center
      
          apply_boundary_conditions <- function(temp) {
            temp[1, ] <- 0
            temp[nx, ] <- 0
            temp[, 1] <- 0
            temp[, ny] <- 0
            temp
          }
      
          update_temperature <- function(temp, k, dx, dy, dt) {
            temp_new <- temp
            for (i in 2:(nx - 1)) {
              for (j in 2:(ny - 1)) {
                temp_new[i, j] <- temp[i, j] +
                  k *
                    dt *
                    ((temp[i + 1, j] - 2 * temp[i, j] + temp[i - 1, j]) /
                      dx^2 +
                      (temp[i, j + 1] - 2 * temp[i, j] + temp[i, j - 1]) / dy^2)
              }
            }
            temp_new
          }
      
          # Time stepping
          for (step in seq_len(steps)) {
            temp <- apply_boundary_conditions(temp)
            temp <- update_temperature(temp, k, dx, dy, dt)
          }
      
          temp
      
          # Plot the final temperature distribution
          # image(temp, col = heat.colors(100), main = "Heat Diffusion")
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine diffuse_heat(nx, ny, dx, dy, dt, k, steps, temp) bind(c)
        use iso_c_binding, only: c_double, c_int, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! args
        integer(c_int), intent(in) :: nx
        integer(c_int), intent(in) :: ny
        integer(c_int), intent(in) :: dx
        integer(c_int), intent(in) :: dy
        real(c_double), intent(in) :: dt
        real(c_double), intent(in) :: k
        integer(c_int), intent(in) :: steps
        real(c_double), intent(out) :: temp(nx, ny)
      
        ! locals
        integer(c_int) :: step
        ! manifest end
      
      
        temp = 0.0_c_double
      temp(int((real(nx, kind=c_double) / real(2_c_int, kind=c_double)), kind=c_ptrdiff_t), int((real(ny, kind=c_double) / real(2_c_int,&
      & kind=c_double)), kind=c_ptrdiff_t)) = 100.0_c_double
      
      
        do step = 1, steps
          block
            real(c_double), allocatable :: btmp1_(:, :)
      
            allocate(btmp1_(nx, ny))
            call apply_boundary_conditions(temp, btmp1_)
      
            temp = btmp1_
          end block
          block
            real(c_double), allocatable :: btmp1_(:, :)
      
            allocate(btmp1_(nx, ny))
            call update_temperature(temp, k, dx, dy, dt, btmp1_)
      
            temp = btmp1_
          end block
        end do
      
        contains
          subroutine apply_boundary_conditions(temp, res)
            use iso_c_binding, only: c_double, c_int
            implicit none
      
            real(c_double), intent(in) :: temp(:, :)
            real(c_double), intent(out) :: res(:, :)
            real(c_double) :: temp__local_(nx, ny)
      
            temp__local_ = temp
            temp__local_(1_c_int, :) = 0.0_c_double
            temp__local_(nx, :) = 0.0_c_double
            temp__local_(:, 1_c_int) = 0.0_c_double
            temp__local_(:, ny) = 0.0_c_double
            res = temp__local_
          end subroutine
          subroutine update_temperature(temp, k, dx, dy, dt, res)
            use iso_c_binding, only: c_double, c_int
            implicit none
      
            real(c_double), intent(in) :: temp(:, :)
            real(c_double), intent(in) :: k
            integer(c_int), intent(in) :: dx
            integer(c_int), intent(in) :: dy
            real(c_double), intent(in) :: dt
            real(c_double), intent(out) :: res(:, :)
            real(c_double) :: temp_new(nx, ny)
            integer(c_int) :: i
            integer(c_int) :: j
      
            temp_new = temp
            do i = 2_c_int, ((nx - 1_c_int)), sign(1, ((nx - 1_c_int))-2_c_int)
              do j = 2_c_int, ((ny - 1_c_int)), sign(1, ((ny - 1_c_int))-2_c_int)
      temp_new(i, j) = (temp(i, j) + ((k * dt) * ((((((temp((i + 1_c_int), j) - (2.0_c_double * temp(i, j))) + temp((i - 1_c_int), j)))&
          & / (dx ** 2.0_c_double)) + ((((temp(i, (j + 1_c_int)) - (2.0_c_double * temp(i, j))) + temp(i, (j - 1_c_int)))) / (dy **&
          & 2.0_c_double))))))
              end do
            end do
            res = temp_new
          end subroutine
      end subroutine
    Code
      cat(make_c_bridge(fsub))
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void diffuse_heat(
        const int* const nx__, 
        const int* const ny__, 
        const int* const dx__, 
        const int* const dy__, 
        const double* const dt__, 
        const double* const k__, 
        const int* const steps__, 
        double* const temp__);
      
      SEXP diffuse_heat_(SEXP _args) {
        // nx
        _args = CDR(_args);
        SEXP nx = CAR(_args);
        if (TYPEOF(nx) != INTSXP) {
          Rf_error("typeof(nx) must be 'integer', not '%s'", Rf_type2char(TYPEOF(nx)));
        }
        const int* const nx__ = INTEGER(nx);
        const R_xlen_t nx__len_ = Rf_xlength(nx);
        
        // ny
        _args = CDR(_args);
        SEXP ny = CAR(_args);
        if (TYPEOF(ny) != INTSXP) {
          Rf_error("typeof(ny) must be 'integer', not '%s'", Rf_type2char(TYPEOF(ny)));
        }
        const int* const ny__ = INTEGER(ny);
        const R_xlen_t ny__len_ = Rf_xlength(ny);
        
        // dx
        _args = CDR(_args);
        SEXP dx = CAR(_args);
        if (TYPEOF(dx) != INTSXP) {
          Rf_error("typeof(dx) must be 'integer', not '%s'", Rf_type2char(TYPEOF(dx)));
        }
        const int* const dx__ = INTEGER(dx);
        const R_xlen_t dx__len_ = Rf_xlength(dx);
        
        // dy
        _args = CDR(_args);
        SEXP dy = CAR(_args);
        if (TYPEOF(dy) != INTSXP) {
          Rf_error("typeof(dy) must be 'integer', not '%s'", Rf_type2char(TYPEOF(dy)));
        }
        const int* const dy__ = INTEGER(dy);
        const R_xlen_t dy__len_ = Rf_xlength(dy);
        
        // dt
        _args = CDR(_args);
        SEXP dt = CAR(_args);
        if (TYPEOF(dt) != REALSXP) {
          Rf_error("typeof(dt) must be 'double', not '%s'", Rf_type2char(TYPEOF(dt)));
        }
        const double* const dt__ = REAL(dt);
        const R_xlen_t dt__len_ = Rf_xlength(dt);
        
        // k
        _args = CDR(_args);
        SEXP k = CAR(_args);
        if (TYPEOF(k) != REALSXP) {
          Rf_error("typeof(k) must be 'double', not '%s'", Rf_type2char(TYPEOF(k)));
        }
        const double* const k__ = REAL(k);
        const R_xlen_t k__len_ = Rf_xlength(k);
        
        // steps
        _args = CDR(_args);
        SEXP steps = CAR(_args);
        if (TYPEOF(steps) != INTSXP) {
          Rf_error("typeof(steps) must be 'integer', not '%s'", Rf_type2char(TYPEOF(steps)));
        }
        const int* const steps__ = INTEGER(steps);
        const R_xlen_t steps__len_ = Rf_xlength(steps);
        
        if (nx__len_ != 1)
          Rf_error("length(nx) must be 1, not %0.f",
                    (double)nx__len_);
        if (ny__len_ != 1)
          Rf_error("length(ny) must be 1, not %0.f",
                    (double)ny__len_);
        if (dx__len_ != 1)
          Rf_error("length(dx) must be 1, not %0.f",
                    (double)dx__len_);
        if (dy__len_ != 1)
          Rf_error("length(dy) must be 1, not %0.f",
                    (double)dy__len_);
        if (dt__len_ != 1)
          Rf_error("length(dt) must be 1, not %0.f",
                    (double)dt__len_);
        if (k__len_ != 1)
          Rf_error("length(k) must be 1, not %0.f",
                    (double)k__len_);
        if (steps__len_ != 1)
          Rf_error("length(steps) must be 1, not %0.f",
                    (double)steps__len_);
        const int _as_int_nx = Rf_asInteger(nx);
        const int _as_int_ny = Rf_asInteger(ny);
        const R_xlen_t temp__len_ = (_as_int_nx) * (_as_int_ny);
        SEXP temp = PROTECT(Rf_allocVector(REALSXP, temp__len_));
        double* temp__ = REAL(temp);
        {
          const SEXP _dim_sexp = PROTECT(Rf_allocVector(INTSXP, 2));
          int* const _dim = INTEGER(_dim_sexp);
          _dim[0] = _as_int_nx;
          _dim[1] = _as_int_ny;
          Rf_dimgets(temp, _dim_sexp);
        }
        
        diffuse_heat(
          nx__,
          ny__,
          dx__,
          dy__,
          dt__,
          k__,
          steps__,
          temp__);
        
        UNPROTECT(2);
        return temp;
      }

# heat diffusion with statement boundary closure + <<-

    Code
      diffuse_heat
    Output
      function(nx, ny, dx, dy, dt, k, steps) {
          declare(
            type(nx = integer(1)),
            type(ny = integer(1)),
            type(dx = integer(1)),
            type(dy = integer(1)),
            type(dt = double(1)),
            type(k = double(1)),
            type(steps = integer(1))
          )
      
          temp <- matrix(0, nx, ny)
          temp[nx / 2, ny / 2] <- 100
      
          apply_boundary_conditions <- function() {
            temp[1, ] <<- 0
            temp[nx, ] <<- 0
            temp[, 1] <<- 0
            temp[, ny] <<- 0
          }
      
          update_temperature <- function(temp, k, dx, dy, dt) {
            temp_new <- temp
            for (i in 2:(nx - 1)) {
              for (j in 2:(ny - 1)) {
                temp_new[i, j] <- temp[i, j] +
                  k *
                    dt *
                    ((temp[i + 1, j] - 2 * temp[i, j] + temp[i - 1, j]) /
                      dx^2 +
                      (temp[i, j + 1] - 2 * temp[i, j] + temp[i, j - 1]) / dy^2)
              }
            }
            temp_new
          }
      
          for (step in seq_len(steps)) {
            apply_boundary_conditions()
            temp <- update_temperature(temp, k, dx, dy, dt)
          }
      
          temp
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine diffuse_heat(nx, ny, dx, dy, dt, k, steps, temp) bind(c)
        use iso_c_binding, only: c_double, c_int, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! args
        integer(c_int), intent(in) :: nx
        integer(c_int), intent(in) :: ny
        integer(c_int), intent(in) :: dx
        integer(c_int), intent(in) :: dy
        real(c_double), intent(in) :: dt
        real(c_double), intent(in) :: k
        integer(c_int), intent(in) :: steps
        real(c_double), intent(out) :: temp(nx, ny)
      
        ! locals
        integer(c_int) :: step
        ! manifest end
      
      
        temp = 0.0_c_double
      temp(int((real(nx, kind=c_double) / real(2_c_int, kind=c_double)), kind=c_ptrdiff_t), int((real(ny, kind=c_double) / real(2_c_int,&
      & kind=c_double)), kind=c_ptrdiff_t)) = 100.0_c_double
      
      
        do step = 1, steps
          call apply_boundary_conditions()
          block
            real(c_double), allocatable :: btmp1_(:, :)
      
            allocate(btmp1_(nx, ny))
            call update_temperature(temp, k, dx, dy, dt, btmp1_)
      
            temp = btmp1_
          end block
        end do
      
        contains
          subroutine apply_boundary_conditions()
            use iso_c_binding, only: c_double, c_int
            implicit none
      
      
      
            temp(1_c_int, :) = 0.0_c_double
            temp(nx, :) = 0.0_c_double
            temp(:, 1_c_int) = 0.0_c_double
            temp(:, ny) = 0.0_c_double
          end subroutine
          subroutine update_temperature(temp, k, dx, dy, dt, res)
            use iso_c_binding, only: c_double, c_int
            implicit none
      
            real(c_double), intent(in) :: temp(:, :)
            real(c_double), intent(in) :: k
            integer(c_int), intent(in) :: dx
            integer(c_int), intent(in) :: dy
            real(c_double), intent(in) :: dt
            real(c_double), intent(out) :: res(:, :)
            real(c_double) :: temp_new(nx, ny)
            integer(c_int) :: i
            integer(c_int) :: j
      
            temp_new = temp
            do i = 2_c_int, ((nx - 1_c_int)), sign(1, ((nx - 1_c_int))-2_c_int)
              do j = 2_c_int, ((ny - 1_c_int)), sign(1, ((ny - 1_c_int))-2_c_int)
      temp_new(i, j) = (temp(i, j) + ((k * dt) * ((((((temp((i + 1_c_int), j) - (2.0_c_double * temp(i, j))) + temp((i - 1_c_int), j)))&
          & / (dx ** 2.0_c_double)) + ((((temp(i, (j + 1_c_int)) - (2.0_c_double * temp(i, j))) + temp(i, (j - 1_c_int)))) / (dy **&
          & 2.0_c_double))))))
              end do
            end do
            res = temp_new
          end subroutine
      end subroutine
    Code
      cat(make_c_bridge(fsub))
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void diffuse_heat(
        const int* const nx__, 
        const int* const ny__, 
        const int* const dx__, 
        const int* const dy__, 
        const double* const dt__, 
        const double* const k__, 
        const int* const steps__, 
        double* const temp__);
      
      SEXP diffuse_heat_(SEXP _args) {
        // nx
        _args = CDR(_args);
        SEXP nx = CAR(_args);
        if (TYPEOF(nx) != INTSXP) {
          Rf_error("typeof(nx) must be 'integer', not '%s'", Rf_type2char(TYPEOF(nx)));
        }
        const int* const nx__ = INTEGER(nx);
        const R_xlen_t nx__len_ = Rf_xlength(nx);
        
        // ny
        _args = CDR(_args);
        SEXP ny = CAR(_args);
        if (TYPEOF(ny) != INTSXP) {
          Rf_error("typeof(ny) must be 'integer', not '%s'", Rf_type2char(TYPEOF(ny)));
        }
        const int* const ny__ = INTEGER(ny);
        const R_xlen_t ny__len_ = Rf_xlength(ny);
        
        // dx
        _args = CDR(_args);
        SEXP dx = CAR(_args);
        if (TYPEOF(dx) != INTSXP) {
          Rf_error("typeof(dx) must be 'integer', not '%s'", Rf_type2char(TYPEOF(dx)));
        }
        const int* const dx__ = INTEGER(dx);
        const R_xlen_t dx__len_ = Rf_xlength(dx);
        
        // dy
        _args = CDR(_args);
        SEXP dy = CAR(_args);
        if (TYPEOF(dy) != INTSXP) {
          Rf_error("typeof(dy) must be 'integer', not '%s'", Rf_type2char(TYPEOF(dy)));
        }
        const int* const dy__ = INTEGER(dy);
        const R_xlen_t dy__len_ = Rf_xlength(dy);
        
        // dt
        _args = CDR(_args);
        SEXP dt = CAR(_args);
        if (TYPEOF(dt) != REALSXP) {
          Rf_error("typeof(dt) must be 'double', not '%s'", Rf_type2char(TYPEOF(dt)));
        }
        const double* const dt__ = REAL(dt);
        const R_xlen_t dt__len_ = Rf_xlength(dt);
        
        // k
        _args = CDR(_args);
        SEXP k = CAR(_args);
        if (TYPEOF(k) != REALSXP) {
          Rf_error("typeof(k) must be 'double', not '%s'", Rf_type2char(TYPEOF(k)));
        }
        const double* const k__ = REAL(k);
        const R_xlen_t k__len_ = Rf_xlength(k);
        
        // steps
        _args = CDR(_args);
        SEXP steps = CAR(_args);
        if (TYPEOF(steps) != INTSXP) {
          Rf_error("typeof(steps) must be 'integer', not '%s'", Rf_type2char(TYPEOF(steps)));
        }
        const int* const steps__ = INTEGER(steps);
        const R_xlen_t steps__len_ = Rf_xlength(steps);
        
        if (nx__len_ != 1)
          Rf_error("length(nx) must be 1, not %0.f",
                    (double)nx__len_);
        if (ny__len_ != 1)
          Rf_error("length(ny) must be 1, not %0.f",
                    (double)ny__len_);
        if (dx__len_ != 1)
          Rf_error("length(dx) must be 1, not %0.f",
                    (double)dx__len_);
        if (dy__len_ != 1)
          Rf_error("length(dy) must be 1, not %0.f",
                    (double)dy__len_);
        if (dt__len_ != 1)
          Rf_error("length(dt) must be 1, not %0.f",
                    (double)dt__len_);
        if (k__len_ != 1)
          Rf_error("length(k) must be 1, not %0.f",
                    (double)k__len_);
        if (steps__len_ != 1)
          Rf_error("length(steps) must be 1, not %0.f",
                    (double)steps__len_);
        const int _as_int_nx = Rf_asInteger(nx);
        const int _as_int_ny = Rf_asInteger(ny);
        const R_xlen_t temp__len_ = (_as_int_nx) * (_as_int_ny);
        SEXP temp = PROTECT(Rf_allocVector(REALSXP, temp__len_));
        double* temp__ = REAL(temp);
        {
          const SEXP _dim_sexp = PROTECT(Rf_allocVector(INTSXP, 2));
          int* const _dim = INTEGER(_dim_sexp);
          _dim[0] = _as_int_nx;
          _dim[1] = _as_int_ny;
          Rf_dimgets(temp, _dim_sexp);
        }
        
        diffuse_heat(
          nx__,
          ny__,
          dx__,
          dy__,
          dt__,
          k__,
          steps__,
          temp__);
        
        UNPROTECT(2);
        return temp;
      }

# stop() translation includes error plumbing

    Code
      cat("# Snapshot note: ", note, "\n", sep = "")
    Output
      # Snapshot note: stop() should emit error message and C bridge checks
    Code
      fn
    Output
      function(x) {
          declare(type(x = double(1)))
          if (x < 0) {
            stop("x must be nonnegative")
          }
          x + 1
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out_, quickr_err_msg) bind(c)
        use iso_c_binding, only: c_char, c_double, c_null_char
        implicit none
      
        ! manifest start
        ! error
        character(kind=c_char), intent(inout) :: quickr_err_msg(256)
      
        ! args
        real(c_double), intent(in) :: x
        real(c_double), intent(out) :: out_
        ! manifest end
      
      
        if ((x < 0.0_c_double)) then
          call quickr_set_error_msg("x must be nonnegative")
          return
        end if
        out_ = (x + 1.0_c_double)
      
        contains
          subroutine quickr_set_error_msg(msg)
            character(len=*), intent(in) :: msg
            integer :: i
            integer :: n
            if (quickr_err_msg(1) == c_null_char) then
              n = min(len(msg), 256 - 1)
              quickr_err_msg(1:n) = [(msg(i:i), i = 1, n)]
              quickr_err_msg(n + 1) = c_null_char
            end if
          end subroutine quickr_set_error_msg
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const x__, 
        double* const out___, 
        char* quickr_err_msg);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        if (x__len_ != 1)
          Rf_error("length(x) must be 1, not %0.f",
                    (double)x__len_);
        const R_xlen_t out___len_ = (1);
        SEXP out_ = PROTECT(Rf_allocVector(REALSXP, out___len_));
        double* out___ = REAL(out_);
        
        char quickr_err_msg[256];
        quickr_err_msg[0] = '\0';
        
        
        fn(x__, out___, quickr_err_msg);
        if (quickr_err_msg[0] != '\0') {
          Rf_error("%s", quickr_err_msg);
        }
        
        UNPROTECT(1);
        return out_;
      }

# stop() translation wraps long error messages

    Code
      fn
    Output
      function(x) {
          declare(type(x = double(1)))
          if (x < 0) {
            stop(.(long_msg))
          }
          x + 1
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out_, quickr_err_msg) bind(c)
        use iso_c_binding, only: c_char, c_double, c_null_char
        implicit none
      
        ! manifest start
        ! error
        character(kind=c_char), intent(inout) :: quickr_err_msg(256)
      
        ! args
        real(c_double), intent(in) :: x
        real(c_double), intent(out) :: out_
        ! manifest end
      
      
        if ((x < 0.0_c_double)) then
      call quickr_set_error_msg("abcdefghij abcdefghij abcdefghij abcdefghij abcdefghij abcdefghij abcdefghij abcdefghij abcdefghij&
      & abcdefghij abcdefghij abcdefghij abcdefghij abcdefghij abcdefghij")
          return
        end if
        out_ = (x + 1.0_c_double)
      
        contains
          subroutine quickr_set_error_msg(msg)
            character(len=*), intent(in) :: msg
            integer :: i
            integer :: n
            if (quickr_err_msg(1) == c_null_char) then
              n = min(len(msg), 256 - 1)
              quickr_err_msg(1:n) = [(msg(i:i), i = 1, n)]
              quickr_err_msg(n + 1) = c_null_char
            end if
          end subroutine quickr_set_error_msg
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const x__, 
        double* const out___, 
        char* quickr_err_msg);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        if (x__len_ != 1)
          Rf_error("length(x) must be 1, not %0.f",
                    (double)x__len_);
        const R_xlen_t out___len_ = (1);
        SEXP out_ = PROTECT(Rf_allocVector(REALSXP, out___len_));
        double* out___ = REAL(out_);
        
        char quickr_err_msg[256];
        quickr_err_msg[0] = '\0';
        
        
        fn(x__, out___, quickr_err_msg);
        if (quickr_err_msg[0] != '\0') {
          Rf_error("%s", quickr_err_msg);
        }
        
        UNPROTECT(1);
        return out_;
      }

# qr.solve translation uses linpack path

    Code
      cat("# Snapshot note: ", note, "\n", sep = "")
    Output
      # Snapshot note: qr.solve uses dqrdc2/dqrcf (vector rhs)
    Code
      fn
    Output
      function(a, b) {
          declare(
            type(a = double(n, k)),
            type(b = double(n))
          )
          qr.solve(a, b)
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(a, b, out_, a__dim_1_, a__dim_2_, quickr_err_msg) bind(c)
        use iso_c_binding, only: c_char, c_double, c_int, c_null_char
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_int), intent(in), value :: a__dim_1_
        integer(c_int), intent(in), value :: a__dim_2_
      
        ! error
        character(kind=c_char), intent(inout) :: quickr_err_msg(256)
      
        ! args
        real(c_double), intent(in) :: a(a__dim_1_, a__dim_2_)
        real(c_double), intent(in) :: b(a__dim_1_)
        real(c_double), intent(out) :: out_(a__dim_2_)
        ! manifest end
      
      
        block
          real(c_double), allocatable :: btmp1_(:, :)
          real(c_double), allocatable :: btmp2_(:, :)
          real(c_double), allocatable :: btmp3_(:)
          integer(c_int), allocatable :: btmp4_(:)
          real(c_double), allocatable :: btmp5_(:, :)
          integer(c_int) :: btmp6_
          integer(c_int) :: btmp7_
          real(c_double), allocatable :: btmp8_(:, :)
          integer(c_int) :: btmp9_
          integer(c_int) :: btmp10_
      
          allocate(btmp1_(a__dim_1_, a__dim_2_))
          allocate(btmp2_(a__dim_1_, 1))
          allocate(btmp3_(a__dim_2_))
          allocate(btmp4_(a__dim_2_))
          allocate(btmp5_(a__dim_2_, 2))
          allocate(btmp8_(min(a__dim_1_, a__dim_2_), 1))
          btmp1_ = a
          btmp2_ = 0.0_c_double
          btmp2_(1:a__dim_1_, 1) = b
          do btmp7_ = 1_c_int, int(a__dim_2_, kind=c_int)
            btmp4_(btmp7_) = btmp7_
          end do
      call dqrdc2(btmp1_, int(a__dim_1_, kind=c_int), int(a__dim_1_, kind=c_int), int(a__dim_2_, kind=c_int), 1e-07_c_double, btmp6_,&
      & btmp3_, btmp4_, btmp5_)
          if (btmp6_ < int(min(a__dim_1_, a__dim_2_), kind=c_int)) then
            call quickr_set_error_msg("rank deficient matrix in qr.solve")
            return
          end if
          btmp8_ = 0.0_c_double
          call dqrcf(btmp1_, int(a__dim_1_, kind=c_int), btmp6_, btmp3_, btmp2_, int(1, kind=c_int), btmp8_, btmp9_)
          if (btmp9_ /= 0_c_int) then
            call quickr_set_error_msg("exact singularity in 'qr.coef'")
            return
          end if
          out_ = 0.0_c_double
          do btmp10_ = 1_c_int, btmp6_
            out_(btmp4_(btmp10_)) = btmp8_(btmp10_, 1)
          end do
        end block
      
        contains
          subroutine quickr_set_error_msg(msg)
            character(len=*), intent(in) :: msg
            integer :: i
            integer :: n
            if (quickr_err_msg(1) == c_null_char) then
              n = min(len(msg), 256 - 1)
              quickr_err_msg(1:n) = [(msg(i:i), i = 1, n)]
              quickr_err_msg(n + 1) = c_null_char
            end if
          end subroutine quickr_set_error_msg
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const a__, 
        const double* const b__, 
        double* const out___, 
        const R_len_t a__dim_1_, 
        const R_len_t a__dim_2_, 
        char* quickr_err_msg);
      
      SEXP fn_(SEXP _args) {
        // a
        _args = CDR(_args);
        SEXP a = CAR(_args);
        if (TYPEOF(a) != REALSXP) {
          Rf_error("typeof(a) must be 'double', not '%s'", Rf_type2char(TYPEOF(a)));
        }
        const double* const a__ = REAL(a);
        const int* const a__dim_ = ({
        SEXP dim_ = Rf_getAttrib(a, R_DimSymbol);
        if (Rf_length(dim_) != 2) Rf_error(
          "a must be a 2D-array, but length(dim(a)) is %i",
          (int) Rf_length(dim_));
        INTEGER(dim_);});
        const int a__dim_1_ = a__dim_[0];
        const int a__dim_2_ = a__dim_[1];
        
        // b
        _args = CDR(_args);
        SEXP b = CAR(_args);
        if (TYPEOF(b) != REALSXP) {
          Rf_error("typeof(b) must be 'double', not '%s'", Rf_type2char(TYPEOF(b)));
        }
        const double* const b__ = REAL(b);
        const R_xlen_t b__len_ = Rf_xlength(b);
        
        if (a__dim_1_ != b__len_)
          Rf_error("length(b) must equal dim(a)[1],"
                   " but are %0.f and %0.f",
                    (double)b__len_, (double)a__dim_1_);
        const R_xlen_t out___len_ = a__dim_2_;
        SEXP out_ = PROTECT(Rf_allocVector(REALSXP, out___len_));
        double* out___ = REAL(out_);
        
        char quickr_err_msg[256];
        quickr_err_msg[0] = '\0';
        
        
        fn(
          a__,
          b__,
          out___,
          a__dim_1_,
          a__dim_2_,
          quickr_err_msg);
        if (quickr_err_msg[0] != '\0') {
          Rf_error("%s", quickr_err_msg);
        }
        
        UNPROTECT(1);
        return out_;
      }

---

    Code
      cat("# Snapshot note: ", note, "\n", sep = "")
    Output
      # Snapshot note: qr.solve uses dqrdc2/dqrcf (matrix rhs)
    Code
      fn
    Output
      function(a, b) {
          declare(
            type(a = double(n, k)),
            type(b = double(n, m))
          )
          qr.solve(a, b)
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(a, b, out_, a__dim_1_, a__dim_2_, b__dim_2_, quickr_err_msg) bind(c)
        use iso_c_binding, only: c_char, c_double, c_int, c_null_char
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_int), intent(in), value :: a__dim_1_
        integer(c_int), intent(in), value :: a__dim_2_
        integer(c_int), intent(in), value :: b__dim_2_
      
        ! error
        character(kind=c_char), intent(inout) :: quickr_err_msg(256)
      
        ! args
        real(c_double), intent(in) :: a(a__dim_1_, a__dim_2_)
        real(c_double), intent(in) :: b(a__dim_1_, b__dim_2_)
        real(c_double), intent(out) :: out_(a__dim_2_, b__dim_2_)
        ! manifest end
      
      
        block
          real(c_double), allocatable :: btmp1_(:, :)
          real(c_double), allocatable :: btmp2_(:, :)
          real(c_double), allocatable :: btmp3_(:)
          integer(c_int), allocatable :: btmp4_(:)
          real(c_double), allocatable :: btmp5_(:, :)
          integer(c_int) :: btmp6_
          integer(c_int) :: btmp7_
          real(c_double), allocatable :: btmp8_(:, :)
          integer(c_int) :: btmp9_
          integer(c_int) :: btmp10_
          integer(c_int) :: btmp11_
      
          allocate(btmp1_(a__dim_1_, a__dim_2_))
          allocate(btmp2_(a__dim_1_, b__dim_2_))
          allocate(btmp3_(a__dim_2_))
          allocate(btmp4_(a__dim_2_))
          allocate(btmp5_(a__dim_2_, 2))
          allocate(btmp8_(min(a__dim_1_, a__dim_2_), b__dim_2_))
          btmp1_ = a
          btmp2_ = 0.0_c_double
          btmp2_(1:a__dim_1_, 1:b__dim_2_) = b
          do btmp7_ = 1_c_int, int(a__dim_2_, kind=c_int)
            btmp4_(btmp7_) = btmp7_
          end do
      call dqrdc2(btmp1_, int(a__dim_1_, kind=c_int), int(a__dim_1_, kind=c_int), int(a__dim_2_, kind=c_int), 1e-07_c_double, btmp6_,&
      & btmp3_, btmp4_, btmp5_)
          if (btmp6_ < int(min(a__dim_1_, a__dim_2_), kind=c_int)) then
            call quickr_set_error_msg("rank deficient matrix in qr.solve")
            return
          end if
          btmp8_ = 0.0_c_double
          call dqrcf(btmp1_, int(a__dim_1_, kind=c_int), btmp6_, btmp3_, btmp2_, int(b__dim_2_, kind=c_int), btmp8_, btmp9_)
          if (btmp9_ /= 0_c_int) then
            call quickr_set_error_msg("exact singularity in 'qr.coef'")
            return
          end if
          out_ = 0.0_c_double
          do btmp11_ = 1_c_int, int(b__dim_2_, kind=c_int)
            do btmp10_ = 1_c_int, btmp6_
              out_(btmp4_(btmp10_), btmp11_) = btmp8_(btmp10_, btmp11_)
            end do
          end do
        end block
      
        contains
          subroutine quickr_set_error_msg(msg)
            character(len=*), intent(in) :: msg
            integer :: i
            integer :: n
            if (quickr_err_msg(1) == c_null_char) then
              n = min(len(msg), 256 - 1)
              quickr_err_msg(1:n) = [(msg(i:i), i = 1, n)]
              quickr_err_msg(n + 1) = c_null_char
            end if
          end subroutine quickr_set_error_msg
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const a__, 
        const double* const b__, 
        double* const out___, 
        const R_len_t a__dim_1_, 
        const R_len_t a__dim_2_, 
        const R_len_t b__dim_2_, 
        char* quickr_err_msg);
      
      SEXP fn_(SEXP _args) {
        // a
        _args = CDR(_args);
        SEXP a = CAR(_args);
        if (TYPEOF(a) != REALSXP) {
          Rf_error("typeof(a) must be 'double', not '%s'", Rf_type2char(TYPEOF(a)));
        }
        const double* const a__ = REAL(a);
        const int* const a__dim_ = ({
        SEXP dim_ = Rf_getAttrib(a, R_DimSymbol);
        if (Rf_length(dim_) != 2) Rf_error(
          "a must be a 2D-array, but length(dim(a)) is %i",
          (int) Rf_length(dim_));
        INTEGER(dim_);});
        const int a__dim_1_ = a__dim_[0];
        const int a__dim_2_ = a__dim_[1];
        
        // b
        _args = CDR(_args);
        SEXP b = CAR(_args);
        if (TYPEOF(b) != REALSXP) {
          Rf_error("typeof(b) must be 'double', not '%s'", Rf_type2char(TYPEOF(b)));
        }
        const double* const b__ = REAL(b);
        const int* const b__dim_ = ({
        SEXP dim_ = Rf_getAttrib(b, R_DimSymbol);
        if (Rf_length(dim_) != 2) Rf_error(
          "b must be a 2D-array, but length(dim(b)) is %i",
          (int) Rf_length(dim_));
        INTEGER(dim_);});
        const int b__dim_1_ = b__dim_[0];
        const int b__dim_2_ = b__dim_[1];
        
        if (a__dim_1_ != b__dim_1_)
          Rf_error("dim(b)[1] must equal dim(a)[1],"
                   " but are %0.f and %0.f",
                    (double)b__dim_1_, (double)a__dim_1_);
        const R_xlen_t out___len_ = (a__dim_2_) * (b__dim_2_);
        SEXP out_ = PROTECT(Rf_allocVector(REALSXP, out___len_));
        double* out___ = REAL(out_);
        {
          const SEXP _dim_sexp = PROTECT(Rf_allocVector(INTSXP, 2));
          int* const _dim = INTEGER(_dim_sexp);
          _dim[0] = a__dim_2_;
          _dim[1] = b__dim_2_;
          Rf_dimgets(out_, _dim_sexp);
        }
        
        char quickr_err_msg[256];
        quickr_err_msg[0] = '\0';
        
        
        fn(
          a__,
          b__,
          out___,
          a__dim_1_,
          a__dim_2_,
          b__dim_2_,
          quickr_err_msg);
        if (quickr_err_msg[0] != '\0') {
          Rf_error("%s", quickr_err_msg);
        }
        
        UNPROTECT(2);
        return out_;
      }

# deferred-shape locals (self-sized dims) snapshot

    Code
      r2f(f)
    Output
      subroutine f(x, out_, x__dim_1_, x__dim_2_) bind(c)
        use iso_c_binding, only: c_double, c_int
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_int), intent(in), value :: x__dim_1_
        integer(c_int), intent(in), value :: x__dim_2_
      
        ! args
        real(c_double), intent(in) :: x(x__dim_1_, x__dim_2_)
        real(c_double), intent(out) :: out_
      
        ! locals
        real(c_double), allocatable :: a(:, :)
        ! manifest end
      
      
        a = x
        out_ = 1.0_c_double
      end subroutine
      
      @r: function (x)
        {
            declare(type(x = double(NA, NA)), type(a = double(NA, NA)))
            a <- x
            1
        }
      @c_bridge: #define R_NO_REMAP
        #include <R.h>
        #include <Rinternals.h>
        
        
        extern void f(
          const double* const x__,
          double* const out___,
          const R_len_t x__dim_1_,
          const R_len_t x__dim_2_);
        
        SEXP f_(SEXP _args) {
          // x
          _args = CDR(_args);
          SEXP x = CAR(_args);
          if (TYPEOF(x) != REALSXP) {
            Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
          }
          const double* const x__ = REAL(x);
          const int* const x__dim_ = ({
          SEXP dim_ = Rf_getAttrib(x, R_DimSymbol);
          if (Rf_length(dim_) != 2) Rf_error(
            "x must be a 2D-array, but length(dim(x)) is %i",
            (int) Rf_length(dim_));
          INTEGER(dim_);});
          const int x__dim_1_ = x__dim_[0];
          const int x__dim_2_ = x__dim_[1];
        
          const R_xlen_t out___len_ = (1);
          SEXP out_ = PROTECT(Rf_allocVector(REALSXP, out___len_));
          double* out___ = REAL(out_);
        
          f(
            x__,
            out___,
            x__dim_1_,
            x__dim_2_);
        
          UNPROTECT(1);
          return out_;
        }

# runif generates random numbers

    Code
      fn
    Output
      function(n) {
          declare(type(n = integer(1)))
          runif(n)
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(n, out_) bind(c)
        use iso_c_binding, only: c_double, c_int
        implicit none
      
        ! manifest start
        ! args
        integer(c_int), intent(in) :: n
        real(c_double), intent(out) :: out_(n)
      
        ! locals
        integer(c_int) :: tmp1_
        ! manifest end
      
        interface
          function unif_rand() bind(c, name = "unif_rand") result(u)
            use iso_c_binding, only: c_double
            real(c_double) :: u
          end function unif_rand
        end interface
      
      
        out_ = [(unif_rand(), tmp1_=1, n)]
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      #include <R_ext/Random.h>
      
      
      extern void fn(const int* const n__, double* const out___);
      
      SEXP fn_(SEXP _args) {
        // n
        _args = CDR(_args);
        SEXP n = CAR(_args);
        if (TYPEOF(n) != INTSXP) {
          Rf_error("typeof(n) must be 'integer', not '%s'", Rf_type2char(TYPEOF(n)));
        }
        const int* const n__ = INTEGER(n);
        const R_xlen_t n__len_ = Rf_xlength(n);
        
        if (n__len_ != 1)
          Rf_error("length(n) must be 1, not %0.f",
                    (double)n__len_);
        const int _as_int_n = Rf_asInteger(n);
        const R_xlen_t out___len_ = _as_int_n;
        SEXP out_ = PROTECT(Rf_allocVector(REALSXP, out___len_));
        double* out___ = REAL(out_);
        
        GetRNGstate();
        fn(n__, out___);
        PutRNGstate();
        
        UNPROTECT(1);
        return out_;
      }

---

    Code
      fn
    Output
      function(x) {
          declare(type(x = double(NA)))
          x * runif(1)
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out_, x__len_) bind(c)
        use iso_c_binding, only: c_double, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: x__len_
      
        ! args
        real(c_double), intent(in) :: x(x__len_)
        real(c_double), intent(out) :: out_(x__len_)
        ! manifest end
      
        interface
          function unif_rand() bind(c, name = "unif_rand") result(u)
            use iso_c_binding, only: c_double
            real(c_double) :: u
          end function unif_rand
        end interface
      
      
        out_ = (x * unif_rand())
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      #include <R_ext/Random.h>
      
      
      extern void fn(
        const double* const x__, 
        double* const out___, 
        const R_xlen_t x__len_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        const R_xlen_t out___len_ = x__len_;
        SEXP out_ = PROTECT(Rf_allocVector(REALSXP, out___len_));
        double* out___ = REAL(out_);
        
        GetRNGstate();
        fn(x__, out___, x__len_);
        PutRNGstate();
        
        UNPROTECT(1);
        return out_;
      }

---

    Code
      fn
    Output
      function(x) {
          declare(type(x = double(NA)))
          x * runif(length(x))
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out_, x__len_) bind(c)
        use iso_c_binding, only: c_double, c_int, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: x__len_
      
        ! args
        real(c_double), intent(in) :: x(x__len_)
        real(c_double), intent(out) :: out_(x__len_)
      
        ! locals
        integer(c_int) :: tmp1_
        ! manifest end
      
        interface
          function unif_rand() bind(c, name = "unif_rand") result(u)
            use iso_c_binding, only: c_double
            real(c_double) :: u
          end function unif_rand
        end interface
      
      
        out_ = (x * [(unif_rand(), tmp1_=1, x__len_)])
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      #include <R_ext/Random.h>
      
      
      extern void fn(
        const double* const x__, 
        double* const out___, 
        const R_xlen_t x__len_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        const R_xlen_t out___len_ = x__len_;
        SEXP out_ = PROTECT(Rf_allocVector(REALSXP, out___len_));
        double* out___ = REAL(out_);
        
        GetRNGstate();
        fn(x__, out___, x__len_);
        PutRNGstate();
        
        UNPROTECT(1);
        return out_;
      }

# runif with min/max

    Code
      fn
    Output
      function(n, a, b) {
          declare(
            type(n = integer(1)),
            type(a = double(1)),
            type(b = double(1))
          )
          runif(n, a, b)
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(n, a, b, out_) bind(c)
        use iso_c_binding, only: c_double, c_int
        implicit none
      
        ! manifest start
        ! args
        integer(c_int), intent(in) :: n
        real(c_double), intent(in) :: a
        real(c_double), intent(in) :: b
        real(c_double), intent(out) :: out_(n)
      
        ! locals
        integer(c_int) :: tmp1_
        ! manifest end
      
        interface
          function unif_rand() bind(c, name = "unif_rand") result(u)
            use iso_c_binding, only: c_double
            real(c_double) :: u
          end function unif_rand
        end interface
      
      
        out_ = [((a + (unif_rand() * (b - a))), tmp1_=1, n)]
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      #include <R_ext/Random.h>
      
      
      extern void fn(
        const int* const n__, 
        const double* const a__, 
        const double* const b__, 
        double* const out___);
      
      SEXP fn_(SEXP _args) {
        // n
        _args = CDR(_args);
        SEXP n = CAR(_args);
        if (TYPEOF(n) != INTSXP) {
          Rf_error("typeof(n) must be 'integer', not '%s'", Rf_type2char(TYPEOF(n)));
        }
        const int* const n__ = INTEGER(n);
        const R_xlen_t n__len_ = Rf_xlength(n);
        
        // a
        _args = CDR(_args);
        SEXP a = CAR(_args);
        if (TYPEOF(a) != REALSXP) {
          Rf_error("typeof(a) must be 'double', not '%s'", Rf_type2char(TYPEOF(a)));
        }
        const double* const a__ = REAL(a);
        const R_xlen_t a__len_ = Rf_xlength(a);
        
        // b
        _args = CDR(_args);
        SEXP b = CAR(_args);
        if (TYPEOF(b) != REALSXP) {
          Rf_error("typeof(b) must be 'double', not '%s'", Rf_type2char(TYPEOF(b)));
        }
        const double* const b__ = REAL(b);
        const R_xlen_t b__len_ = Rf_xlength(b);
        
        if (n__len_ != 1)
          Rf_error("length(n) must be 1, not %0.f",
                    (double)n__len_);
        if (a__len_ != 1)
          Rf_error("length(a) must be 1, not %0.f",
                    (double)a__len_);
        if (b__len_ != 1)
          Rf_error("length(b) must be 1, not %0.f",
                    (double)b__len_);
        const int _as_int_n = Rf_asInteger(n);
        const R_xlen_t out___len_ = _as_int_n;
        SEXP out_ = PROTECT(Rf_allocVector(REALSXP, out___len_));
        double* out___ = REAL(out_);
        
        GetRNGstate();
        fn(
          n__,
          a__,
          b__,
          out___);
        PutRNGstate();
        
        UNPROTECT(1);
        return out_;
      }

---

    Code
      fn
    Output
      function(n, b) {
          declare(
            type(n = integer(1)),
            type(b = double(1))
          )
          runif(n, max = b)
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(n, b, out_) bind(c)
        use iso_c_binding, only: c_double, c_int
        implicit none
      
        ! manifest start
        ! args
        integer(c_int), intent(in) :: n
        real(c_double), intent(in) :: b
        real(c_double), intent(out) :: out_(n)
      
        ! locals
        integer(c_int) :: tmp1_
        ! manifest end
      
        interface
          function unif_rand() bind(c, name = "unif_rand") result(u)
            use iso_c_binding, only: c_double
            real(c_double) :: u
          end function unif_rand
        end interface
      
      
        out_ = [(unif_rand() * b, tmp1_=1, n)]
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      #include <R_ext/Random.h>
      
      
      extern void fn(
        const int* const n__, 
        const double* const b__, 
        double* const out___);
      
      SEXP fn_(SEXP _args) {
        // n
        _args = CDR(_args);
        SEXP n = CAR(_args);
        if (TYPEOF(n) != INTSXP) {
          Rf_error("typeof(n) must be 'integer', not '%s'", Rf_type2char(TYPEOF(n)));
        }
        const int* const n__ = INTEGER(n);
        const R_xlen_t n__len_ = Rf_xlength(n);
        
        // b
        _args = CDR(_args);
        SEXP b = CAR(_args);
        if (TYPEOF(b) != REALSXP) {
          Rf_error("typeof(b) must be 'double', not '%s'", Rf_type2char(TYPEOF(b)));
        }
        const double* const b__ = REAL(b);
        const R_xlen_t b__len_ = Rf_xlength(b);
        
        if (n__len_ != 1)
          Rf_error("length(n) must be 1, not %0.f",
                    (double)n__len_);
        if (b__len_ != 1)
          Rf_error("length(b) must be 1, not %0.f",
                    (double)b__len_);
        const int _as_int_n = Rf_asInteger(n);
        const R_xlen_t out___len_ = _as_int_n;
        SEXP out_ = PROTECT(Rf_allocVector(REALSXP, out___len_));
        double* out___ = REAL(out_);
        
        GetRNGstate();
        fn(n__, b__, out___);
        PutRNGstate();
        
        UNPROTECT(1);
        return out_;
      }

---

    Code
      fn
    Output
      function(b) {
          declare(
            type(b = double(1))
          )
          runif(1, max = b)
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(b, out_) bind(c)
        use iso_c_binding, only: c_double
        implicit none
      
        ! manifest start
        ! args
        real(c_double), intent(in) :: b
        real(c_double), intent(out) :: out_
        ! manifest end
      
        interface
          function unif_rand() bind(c, name = "unif_rand") result(u)
            use iso_c_binding, only: c_double
            real(c_double) :: u
          end function unif_rand
        end interface
      
      
        out_ = unif_rand() * b
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      #include <R_ext/Random.h>
      
      
      extern void fn(const double* const b__, double* const out___);
      
      SEXP fn_(SEXP _args) {
        // b
        _args = CDR(_args);
        SEXP b = CAR(_args);
        if (TYPEOF(b) != REALSXP) {
          Rf_error("typeof(b) must be 'double', not '%s'", Rf_type2char(TYPEOF(b)));
        }
        const double* const b__ = REAL(b);
        const R_xlen_t b__len_ = Rf_xlength(b);
        
        if (b__len_ != 1)
          Rf_error("length(b) must be 1, not %0.f",
                    (double)b__len_);
        const R_xlen_t out___len_ = (1);
        SEXP out_ = PROTECT(Rf_allocVector(REALSXP, out___len_));
        double* out___ = REAL(out_);
        
        GetRNGstate();
        fn(b__, out___);
        PutRNGstate();
        
        UNPROTECT(1);
        return out_;
      }

---

    Code
      fn
    Output
      function(b) {
          declare(
            type(b = double(1))
          )
          runif(10, max = b)
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(b, out_) bind(c)
        use iso_c_binding, only: c_double, c_int
        implicit none
      
        ! manifest start
        ! args
        real(c_double), intent(in) :: b
        real(c_double), intent(out) :: out_(10)
      
        ! locals
        integer(c_int) :: tmp1_
        ! manifest end
      
        interface
          function unif_rand() bind(c, name = "unif_rand") result(u)
            use iso_c_binding, only: c_double
            real(c_double) :: u
          end function unif_rand
        end interface
      
      
        out_ = [(unif_rand() * b, tmp1_=1, 10)]
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      #include <R_ext/Random.h>
      
      
      extern void fn(const double* const b__, double* const out___);
      
      SEXP fn_(SEXP _args) {
        // b
        _args = CDR(_args);
        SEXP b = CAR(_args);
        if (TYPEOF(b) != REALSXP) {
          Rf_error("typeof(b) must be 'double', not '%s'", Rf_type2char(TYPEOF(b)));
        }
        const double* const b__ = REAL(b);
        const R_xlen_t b__len_ = Rf_xlength(b);
        
        if (b__len_ != 1)
          Rf_error("length(b) must be 1, not %0.f",
                    (double)b__len_);
        const R_xlen_t out___len_ = 10;
        SEXP out_ = PROTECT(Rf_allocVector(REALSXP, out___len_));
        double* out___ = REAL(out_);
        
        GetRNGstate();
        fn(b__, out___);
        PutRNGstate();
        
        UNPROTECT(1);
        return out_;
      }

# convolve

    Code
      slow_convolve
    Output
      function(a, b) {
          declare(type(a = double(NA)))
          declare(type(b = double(NA)))
      
          ab <- double(length(a) + length(b) - 1)
          for (i in seq_along(a)) {
            for (j in seq_along(b)) {
              ab[i + j - 1] = ab[i + j - 1] + a[i] * b[j]
            }
          }
          ab
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine slow_convolve(a, b, ab, a__len_, b__len_) bind(c)
        use iso_c_binding, only: c_double, c_int, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: a__len_
        integer(c_ptrdiff_t), intent(in), value :: b__len_
      
        ! args
        real(c_double), intent(in) :: a(a__len_)
        real(c_double), intent(in) :: b(b__len_)
        real(c_double), intent(out) :: ab(((a__len_ + b__len_) - 1))
      
        ! locals
        integer(c_int) :: i
        integer(c_int) :: j
        ! manifest end
      
      
      
        ab = 0
        do i = 1, size(a)
          do j = 1, size(b)
            ab(((i + j) - 1_c_int)) = (ab(((i + j) - 1_c_int)) + (a(i) * b(j)))
          end do
        end do
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void slow_convolve(
        const double* const a__, 
        const double* const b__, 
        double* const ab__, 
        const R_xlen_t a__len_, 
        const R_xlen_t b__len_);
      
      SEXP slow_convolve_(SEXP _args) {
        // a
        _args = CDR(_args);
        SEXP a = CAR(_args);
        if (TYPEOF(a) != REALSXP) {
          Rf_error("typeof(a) must be 'double', not '%s'", Rf_type2char(TYPEOF(a)));
        }
        const double* const a__ = REAL(a);
        const R_xlen_t a__len_ = Rf_xlength(a);
        
        // b
        _args = CDR(_args);
        SEXP b = CAR(_args);
        if (TYPEOF(b) != REALSXP) {
          Rf_error("typeof(b) must be 'double', not '%s'", Rf_type2char(TYPEOF(b)));
        }
        const double* const b__ = REAL(b);
        const R_xlen_t b__len_ = Rf_xlength(b);
        
        const R_xlen_t ab__len_ = ((a__len_ + b__len_) - 1);
        SEXP ab = PROTECT(Rf_allocVector(REALSXP, ab__len_));
        double* ab__ = REAL(ab);
        
        slow_convolve(
          a__,
          b__,
          ab__,
          a__len_,
          b__len_);
        
        UNPROTECT(1);
        return ab;
      }

# array-expression subscripting hoists into a block-scoped temp

    Code
      cat("# Snapshot note: ", note, "\n", sep = "")
    Output
      # Snapshot note: Fortran disallows (expr)(i,j); quickr uses a block-local temp array.
    Code
      fn
    Output
      function(x) {
          declare(type(x = double(3, 4)))
          out <- ifelse((x > 0.0)[2, 3], 1.0, 0.0)
          out
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out) bind(c)
        use iso_c_binding, only: c_double, c_int
        implicit none
      
        ! manifest start
        ! args
        real(c_double), intent(in) :: x(3, 4)
        real(c_double), intent(out) :: out
        ! manifest end
      
      
        block
          logical :: btmp1_(3, 4) ! logical
      
          btmp1_ = ((x > 0.0_c_double))
          out = merge(1.0_c_double, 0.0_c_double, btmp1_(2_c_int, 3_c_int))
        end block
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(const double* const x__, double* const out__);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const int* const x__dim_ = ({
        SEXP dim_ = Rf_getAttrib(x, R_DimSymbol);
        if (Rf_length(dim_) != 2) Rf_error(
          "x must be a 2D-array, but length(dim(x)) is %i",
          (int) Rf_length(dim_));
        INTEGER(dim_);});
        const int x__dim_1_ = x__dim_[0];
        const int x__dim_2_ = x__dim_[1];
        
        if (x__dim_1_ != 3)
          Rf_error("dim(x)[1] must be 3, not %0.f",
                    (double)x__dim_1_);
        if (x__dim_2_ != 4)
          Rf_error("dim(x)[2] must be 4, not %0.f",
                    (double)x__dim_2_);
        const R_xlen_t out__len_ = (1);
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        
        fn(x__, out__);
        
        UNPROTECT(1);
        return out;
      }

# block-scoped temps allocate on the heap for runtime shapes

    Code
      cat("# Snapshot note: ", note, "\n", sep = "")
    Output
      # Snapshot note: Block temps with runtime sizes are allocatable so flang doesn't stack-allocate large work arrays.
    Code
      fn
    Output
      function(x) {
          declare(type(x = double(n, m)))
          out <- ifelse((x > 0.0)[1, 1], 1.0, 0.0)
          out
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out, x__dim_1_, x__dim_2_) bind(c)
        use iso_c_binding, only: c_double, c_int
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_int), intent(in), value :: x__dim_1_
        integer(c_int), intent(in), value :: x__dim_2_
      
        ! args
        real(c_double), intent(in) :: x(x__dim_1_, x__dim_2_)
        real(c_double), intent(out) :: out
        ! manifest end
      
      
        block
          logical, allocatable :: btmp1_(:, :) ! logical
      
          allocate(btmp1_(x__dim_1_, x__dim_2_))
          btmp1_ = ((x > 0.0_c_double))
          out = merge(1.0_c_double, 0.0_c_double, btmp1_(1_c_int, 1_c_int))
        end block
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const x__, 
        double* const out__, 
        const R_len_t x__dim_1_, 
        const R_len_t x__dim_2_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const int* const x__dim_ = ({
        SEXP dim_ = Rf_getAttrib(x, R_DimSymbol);
        if (Rf_length(dim_) != 2) Rf_error(
          "x must be a 2D-array, but length(dim(x)) is %i",
          (int) Rf_length(dim_));
        INTEGER(dim_);});
        const int x__dim_1_ = x__dim_[0];
        const int x__dim_2_ = x__dim_[1];
        
        const R_xlen_t out__len_ = (1);
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        
        fn(
          x__,
          out__,
          x__dim_1_,
          x__dim_2_);
        
        UNPROTECT(1);
        return out;
      }

# roll_mean

    Code
      fn
    Output
      function(x, weights, normalize = TRUE) {
          declare(
            type(x = double(NA)),
            type(weights = double(NA)),
            type(normalize = logical(1))
          )
          out <- double(length(x) - length(weights) + 1)
          n <- length(weights)
          if (normalize) {
            weights <- weights / sum(weights) * length(weights)
          }
      
          for (i in seq_along(out)) {
            out[i] <- sum(x[i:(i + n - 1)] * weights) / length(weights)
          }
          out
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, weights, normalize, out, weights__len_, x__len_) bind(c)
        use iso_c_binding, only: c_double, c_int, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: x__len_
        integer(c_ptrdiff_t), intent(in), value :: weights__len_
      
        ! args
        real(c_double), intent(in) :: x(x__len_)
        real(c_double), intent(in out) :: weights(weights__len_)
        integer(c_int), intent(in) :: normalize ! logical
        real(c_double), intent(out) :: out(((x__len_ - weights__len_) + 1))
      
        ! locals
        integer(c_int) :: n
        integer(c_int) :: i
        ! manifest end
      
      
        out = 0
        n = size(weights)
        if ((normalize/=0)) then
          weights = ((weights / sum(weights)) * size(weights))
        end if
        do i = 1, size(out)
          out(i) = (sum((x(i:(((i + n) - 1_c_int)):sign(1, (((i + n) - 1_c_int))-i)) * weights)) / real(size(weights), kind=c_double))
        end do
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const x__, 
        double* const weights__, 
        const int* const normalize__, 
        double* const out__, 
        const R_xlen_t weights__len_, 
        const R_xlen_t x__len_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        // weights
        _args = CDR(_args);
        SEXP weights = CAR(_args);
        if (TYPEOF(weights) != REALSXP) {
          Rf_error("typeof(weights) must be 'double', not '%s'", Rf_type2char(TYPEOF(weights)));
        }
        weights = Rf_duplicate(weights);
        SETCAR(_args, weights);
        double* const weights__ = REAL(weights);
        const R_xlen_t weights__len_ = Rf_xlength(weights);
        
        // normalize
        _args = CDR(_args);
        SEXP normalize = CAR(_args);
        if (TYPEOF(normalize) != LGLSXP) {
          Rf_error("typeof(normalize) must be 'logical', not '%s'", Rf_type2char(TYPEOF(normalize)));
        }
        const int* const normalize__ = LOGICAL(normalize);
        const R_xlen_t normalize__len_ = Rf_xlength(normalize);
        
        if (normalize__len_ != 1)
          Rf_error("length(normalize) must be 1, not %0.f",
                    (double)normalize__len_);
        const R_xlen_t out__len_ = ((x__len_ - weights__len_) + 1);
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        
        fn(
          x__,
          weights__,
          normalize__,
          out__,
          weights__len_,
          x__len_);
        
        UNPROTECT(1);
        return out;
      }

# translation snapshots: statement closure with host-associated <<-

    Code
      cat("# Snapshot note: ", note, "\n", sep = "")
    Output
      # Snapshot note: Statement local closure lowered as internal subroutine; <<- subset targets are host-associated (no capture arg/decl in the closure).
    Code
      fn
    Output
      function(nx, ny) {
          declare(type(nx = integer(1)), type(ny = integer(1)))
          temp <- matrix(0, nx, ny)
      
          bc <- function() {
            temp[1, ] <<- 1
            temp[nx, ] <<- 2
            temp[, 1] <<- 3
            temp[, ny] <<- 4
            NULL
          }
      
          bc()
          temp
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(nx, ny, temp) bind(c)
        use iso_c_binding, only: c_double, c_int
        implicit none
      
        ! manifest start
        ! args
        integer(c_int), intent(in) :: nx
        integer(c_int), intent(in) :: ny
        real(c_double), intent(out) :: temp(nx, ny)
        ! manifest end
      
      
        temp = 0.0_c_double
      
        call bc()
      
        contains
          subroutine bc()
            use iso_c_binding, only: c_double, c_int
            implicit none
      
      
      
            temp(1_c_int, :) = 1.0_c_double
            temp(nx, :) = 2.0_c_double
            temp(:, 1_c_int) = 3.0_c_double
            temp(:, ny) = 4.0_c_double
          end subroutine
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const int* const nx__, 
        const int* const ny__, 
        double* const temp__);
      
      SEXP fn_(SEXP _args) {
        // nx
        _args = CDR(_args);
        SEXP nx = CAR(_args);
        if (TYPEOF(nx) != INTSXP) {
          Rf_error("typeof(nx) must be 'integer', not '%s'", Rf_type2char(TYPEOF(nx)));
        }
        const int* const nx__ = INTEGER(nx);
        const R_xlen_t nx__len_ = Rf_xlength(nx);
        
        // ny
        _args = CDR(_args);
        SEXP ny = CAR(_args);
        if (TYPEOF(ny) != INTSXP) {
          Rf_error("typeof(ny) must be 'integer', not '%s'", Rf_type2char(TYPEOF(ny)));
        }
        const int* const ny__ = INTEGER(ny);
        const R_xlen_t ny__len_ = Rf_xlength(ny);
        
        if (nx__len_ != 1)
          Rf_error("length(nx) must be 1, not %0.f",
                    (double)nx__len_);
        if (ny__len_ != 1)
          Rf_error("length(ny) must be 1, not %0.f",
                    (double)ny__len_);
        const int _as_int_nx = Rf_asInteger(nx);
        const int _as_int_ny = Rf_asInteger(ny);
        const R_xlen_t temp__len_ = (_as_int_nx) * (_as_int_ny);
        SEXP temp = PROTECT(Rf_allocVector(REALSXP, temp__len_));
        double* temp__ = REAL(temp);
        {
          const SEXP _dim_sexp = PROTECT(Rf_allocVector(INTSXP, 2));
          int* const _dim = INTEGER(_dim_sexp);
          _dim[0] = _as_int_nx;
          _dim[1] = _as_int_ny;
          Rf_dimgets(temp, _dim_sexp);
        }
        
        fn(nx__, ny__, temp__);
        
        UNPROTECT(2);
        return temp;
      }

# translation snapshots: sapply + <<- mutates host + returns value

    Code
      cat("# Snapshot note: ", note, "\n", sep = "")
    Output
      # Snapshot note: Local closure lowered under contains; x is host-associated (no capture arg), marked modified so the C bridge duplicates x to preserve R semantics.
    Code
      fn
    Output
      function(x) {
          declare(type(x = double(NA)), type(out = double(length(x))))
          f <- function(i) {
            x[i] <<- x[i] * 2
            x[i]
          }
          out <- sapply(seq_along(x), f)
          list(x = x, out = out)
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out, x__len_) bind(c)
        use iso_c_binding, only: c_double, c_int, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: x__len_
      
        ! args
        real(c_double), intent(in out) :: x(x__len_)
        real(c_double), intent(out) :: out(size(x))
      
        ! locals
        integer(c_int) :: tmp1_
        ! manifest end
      
      
      
        do tmp1_ = 1_c_int, x__len_
          call f(tmp1_, out(tmp1_))
      
        end do
      
      
        contains
          subroutine f(i, res)
            use iso_c_binding, only: c_double, c_int
            implicit none
      
            integer(c_int), intent(in) :: i
            real(c_double), intent(out) :: res
      
            x(i) = (x(i) * 2.0_c_double)
            res = x(i)
          end subroutine
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        double* const x__, 
        double* const out__, 
        const R_xlen_t x__len_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        x = Rf_duplicate(x);
        SETCAR(_args, x);
        double* const x__ = REAL(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        const R_xlen_t out__len_ = x__len_;
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        
        fn(x__, out__, x__len_);
        
        SEXP _ans = PROTECT(Rf_allocVector(VECSXP, 2));
        SET_VECTOR_ELT(_ans, 0, x);
        SET_VECTOR_ELT(_ans, 1, out);
        SEXP _names = PROTECT(Rf_allocVector(STRSXP, 2));
        SET_STRING_ELT(_names, 0, Rf_mkChar("x"));
        SET_STRING_ELT(_names, 1, Rf_mkChar("out"));
        Rf_setAttrib(_ans, R_NamesSymbol, _names);
        UNPROTECT(3);
        return _ans;
      }

# translation snapshots: 3D slice superassignment with missing indices

    Code
      cat("# Snapshot note: ", note, "\n", sep = "")
    Output
      # Snapshot note: 3D array section designators compile to host-associated Fortran slices (a(:, :, k)).
    Code
      fn
    Output
      function(nx, ny, nz) {
          declare(type(nx = integer(1)), type(ny = integer(1)), type(nz = integer(1)))
          a <- array(0.0, c(nx, ny, nz))
      
          f <- function(k) {
            a[,, k] <<- as.double(k)
            a[1, 1, k] <<- a[1, 1, k] + 0.5
            NULL
          }
      
          f(1L)
          f(nz)
          a
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(nx, ny, nz, a) bind(c)
        use iso_c_binding, only: c_double, c_int
        implicit none
      
        ! manifest start
        ! args
        integer(c_int), intent(in) :: nx
        integer(c_int), intent(in) :: ny
        integer(c_int), intent(in) :: nz
        real(c_double), intent(out) :: a(nx, ny, nz)
        ! manifest end
      
      
        a = 0.0_c_double
      
        call f(1_c_int)
        call f(nz)
      
        contains
          subroutine f(k)
            use iso_c_binding, only: c_double, c_int
            implicit none
      
            integer(c_int), intent(in) :: k
      
            a(:, :, k) = real(k, kind=c_double)
            a(1_c_int, 1_c_int, k) = (a(1_c_int, 1_c_int, k) + 0.5_c_double)
          end subroutine
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const int* const nx__, 
        const int* const ny__, 
        const int* const nz__, 
        double* const a__);
      
      SEXP fn_(SEXP _args) {
        // nx
        _args = CDR(_args);
        SEXP nx = CAR(_args);
        if (TYPEOF(nx) != INTSXP) {
          Rf_error("typeof(nx) must be 'integer', not '%s'", Rf_type2char(TYPEOF(nx)));
        }
        const int* const nx__ = INTEGER(nx);
        const R_xlen_t nx__len_ = Rf_xlength(nx);
        
        // ny
        _args = CDR(_args);
        SEXP ny = CAR(_args);
        if (TYPEOF(ny) != INTSXP) {
          Rf_error("typeof(ny) must be 'integer', not '%s'", Rf_type2char(TYPEOF(ny)));
        }
        const int* const ny__ = INTEGER(ny);
        const R_xlen_t ny__len_ = Rf_xlength(ny);
        
        // nz
        _args = CDR(_args);
        SEXP nz = CAR(_args);
        if (TYPEOF(nz) != INTSXP) {
          Rf_error("typeof(nz) must be 'integer', not '%s'", Rf_type2char(TYPEOF(nz)));
        }
        const int* const nz__ = INTEGER(nz);
        const R_xlen_t nz__len_ = Rf_xlength(nz);
        
        if (nx__len_ != 1)
          Rf_error("length(nx) must be 1, not %0.f",
                    (double)nx__len_);
        if (ny__len_ != 1)
          Rf_error("length(ny) must be 1, not %0.f",
                    (double)ny__len_);
        if (nz__len_ != 1)
          Rf_error("length(nz) must be 1, not %0.f",
                    (double)nz__len_);
        const int _as_int_nx = Rf_asInteger(nx);
        const int _as_int_ny = Rf_asInteger(ny);
        const int _as_int_nz = Rf_asInteger(nz);
        const R_xlen_t a__len_ = (_as_int_nx) * (_as_int_ny) * (_as_int_nz);
        SEXP a = PROTECT(Rf_allocVector(REALSXP, a__len_));
        double* a__ = REAL(a);
        {
          const SEXP _dim_sexp = PROTECT(Rf_allocVector(INTSXP, 3));
          int* const _dim = INTEGER(_dim_sexp);
          _dim[0] = _as_int_nx;
          _dim[1] = _as_int_ny;
          _dim[2] = _as_int_nz;
          Rf_dimgets(a, _dim_sexp);
        }
        
        fn(
          nx__,
          ny__,
          nz__,
          a__);
        
        UNPROTECT(2);
        return a;
      }

# translation snapshots: sapply simplify='array' + <<- mutates host matrix argument

    Code
      cat("# Snapshot note: ", note, "\n", sep = "")
    Output
      # Snapshot note: sapply() lowering with higher-rank output and host mutation; x is duplicated by the C bridge due to modification tracking.
    Code
      fn
    Output
      function(x) {
          declare(type(x = double(NA, NA)))
          out <- x
          f <- function(j) {
            x[, j] <<- x[, j] * 2.0
            x[, j]
          }
          out <- sapply(seq_len(ncol(x)), f, simplify = "array")
          list(x = x, out = out)
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out, x__dim_1_, x__dim_2_) bind(c)
        use iso_c_binding, only: c_double, c_int
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_int), intent(in), value :: x__dim_1_
        integer(c_int), intent(in), value :: x__dim_2_
      
        ! args
        real(c_double), intent(in out) :: x(x__dim_1_, x__dim_2_)
        real(c_double), intent(out) :: out(x__dim_1_, x__dim_2_)
      
        ! locals
        integer(c_int) :: tmp1_
        ! manifest end
      
      
        out = x
      
        do tmp1_ = 1_c_int, x__dim_2_
          call f(tmp1_, out(:, tmp1_))
      
        end do
      
      
        contains
          subroutine f(j, res)
            use iso_c_binding, only: c_double, c_int
            implicit none
      
            integer(c_int), intent(in) :: j
            real(c_double), intent(out) :: res(:)
      
            x(:, j) = (x(:, j) * 2.0_c_double)
            res = x(:, j)
          end subroutine
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        double* const x__, 
        double* const out__, 
        const R_len_t x__dim_1_, 
        const R_len_t x__dim_2_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        x = Rf_duplicate(x);
        SETCAR(_args, x);
        double* const x__ = REAL(x);
        const int* const x__dim_ = ({
        SEXP dim_ = Rf_getAttrib(x, R_DimSymbol);
        if (Rf_length(dim_) != 2) Rf_error(
          "x must be a 2D-array, but length(dim(x)) is %i",
          (int) Rf_length(dim_));
        INTEGER(dim_);});
        const int x__dim_1_ = x__dim_[0];
        const int x__dim_2_ = x__dim_[1];
        
        const R_xlen_t out__len_ = (x__dim_1_) * (x__dim_2_);
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        {
          const SEXP _dim_sexp = PROTECT(Rf_allocVector(INTSXP, 2));
          int* const _dim = INTEGER(_dim_sexp);
          _dim[0] = x__dim_1_;
          _dim[1] = x__dim_2_;
          Rf_dimgets(out, _dim_sexp);
        }
        
        fn(
          x__,
          out__,
          x__dim_1_,
          x__dim_2_);
        
        SEXP _ans = PROTECT(Rf_allocVector(VECSXP, 2));
        SET_VECTOR_ELT(_ans, 0, x);
        SET_VECTOR_ELT(_ans, 1, out);
        SEXP _names = PROTECT(Rf_allocVector(STRSXP, 2));
        SET_STRING_ELT(_names, 0, Rf_mkChar("x"));
        SET_STRING_ELT(_names, 1, Rf_mkChar("out"));
        Rf_setAttrib(_ans, R_NamesSymbol, _names);
        UNPROTECT(4);
        return _ans;
      }

# size constraint

    Code
      fn
    Output
      function(a, b) {
          declare(type(a = double(n)), type(b = double(n + 1)))
          a = sum(b)
          a
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(a, b, a__len_) bind(c)
        use iso_c_binding, only: c_double, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: a__len_
      
        ! args
        real(c_double), intent(in out) :: a(a__len_)
        real(c_double), intent(in) :: b((a__len_ + 1))
        ! manifest end
      
      
        a = sum(b)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        double* const a__, 
        const double* const b__, 
        const R_xlen_t a__len_);
      
      SEXP fn_(SEXP _args) {
        // a
        _args = CDR(_args);
        SEXP a = CAR(_args);
        if (TYPEOF(a) != REALSXP) {
          Rf_error("typeof(a) must be 'double', not '%s'", Rf_type2char(TYPEOF(a)));
        }
        a = Rf_duplicate(a);
        SETCAR(_args, a);
        double* const a__ = REAL(a);
        const R_xlen_t a__len_ = Rf_xlength(a);
        
        // b
        _args = CDR(_args);
        SEXP b = CAR(_args);
        if (TYPEOF(b) != REALSXP) {
          Rf_error("typeof(b) must be 'double', not '%s'", Rf_type2char(TYPEOF(b)));
        }
        const double* const b__ = REAL(b);
        const R_xlen_t b__len_ = Rf_xlength(b);
        
        {
          const R_xlen_t expected = (a__len_ + 1);
          if (b__len_ != expected)
            Rf_error("length(b) must equal (length(a) + 1),"
                     " but are %0.f and %0.f",
                      (double)b__len_, (double)expected);
        }
        
        fn(a__, b__, a__len_);
        
        return a;
      }

# repeat/break

    Code
      fn
    Output
      function(x) {
          declare(type(x = integer(1)))
          repeat {
            if (x >= 5L) {
              break
            }
            x <- x + 1L
          }
          x
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x) bind(c)
        use iso_c_binding, only: c_int
        implicit none
      
        ! manifest start
        ! args
        integer(c_int), intent(in out) :: x
        ! manifest end
      
      
        do
          if ((x >= 5_c_int)) then
            exit
          end if
          x = (x + 1_c_int)
        end do
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(int* const x__);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != INTSXP) {
          Rf_error("typeof(x) must be 'integer', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        x = Rf_duplicate(x);
        SETCAR(_args, x);
        int* const x__ = INTEGER(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        if (x__len_ != 1)
          Rf_error("length(x) must be 1, not %0.f",
                    (double)x__len_);
        
        fn(x__);
        
        return x;
      }

# repeat + next

    Code
      fn
    Output
      function(x) {
          declare(type(x = integer(1)))
          repeat {
            x <- x + 1L
            if (x < 0L) {
              next
            }
            if (x >= 5L) break
          }
          x
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x) bind(c)
        use iso_c_binding, only: c_int
        implicit none
      
        ! manifest start
        ! args
        integer(c_int), intent(in out) :: x
        ! manifest end
      
      
        do
          x = (x + 1_c_int)
          if ((x < 0_c_int)) then
            cycle
          end if
          if ((x >= 5_c_int)) then
            exit
          end if
        end do
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(int* const x__);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != INTSXP) {
          Rf_error("typeof(x) must be 'integer', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        x = Rf_duplicate(x);
        SETCAR(_args, x);
        int* const x__ = INTEGER(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        if (x__len_ != 1)
          Rf_error("length(x) must be 1, not %0.f",
                    (double)x__len_);
        
        fn(x__);
        
        return x;
      }

# break/for

    Code
      fn
    Output
      function(x) {
          declare(type(x = integer(1)))
          for (i in 1:10) {
            x = x + 1L
            if (x >= 5L) {
              break
            }
          }
          x
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x) bind(c)
        use iso_c_binding, only: c_int
        implicit none
      
        ! manifest start
        ! args
        integer(c_int), intent(in out) :: x
      
        ! locals
        integer(c_int) :: i
        ! manifest end
      
      
        do i = 1_c_int, 10_c_int, sign(1, 10_c_int-1_c_int)
          x = (x + 1_c_int)
          if ((x >= 5_c_int)) then
            exit
          end if
        end do
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(int* const x__);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != INTSXP) {
          Rf_error("typeof(x) must be 'integer', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        x = Rf_duplicate(x);
        SETCAR(_args, x);
        int* const x__ = INTEGER(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        if (x__len_ != 1)
          Rf_error("length(x) must be 1, not %0.f",
                    (double)x__len_);
        
        fn(x__);
        
        return x;
      }

# while

    Code
      fn
    Output
      function(x) {
          declare(type(x = integer(1)))
          while (x < 5L) {
            x = x + 1L
          }
          x
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x) bind(c)
        use iso_c_binding, only: c_int
        implicit none
      
        ! manifest start
        ! args
        integer(c_int), intent(in out) :: x
        ! manifest end
      
      
        do while ((x < 5_c_int))
          x = (x + 1_c_int)
        end do
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(int* const x__);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != INTSXP) {
          Rf_error("typeof(x) must be 'integer', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        x = Rf_duplicate(x);
        SETCAR(_args, x);
        int* const x__ = INTEGER(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        if (x__len_ != 1)
          Rf_error("length(x) must be 1, not %0.f",
                    (double)x__len_);
        
        fn(x__);
        
        return x;
      }

# while + next

    Code
      fn
    Output
      function(x) {
          declare(type(x = integer(1)))
          while (x < 5L) {
            x <- x + 1L
            if (x < 0L) next
          }
          x
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x) bind(c)
        use iso_c_binding, only: c_int
        implicit none
      
        ! manifest start
        ! args
        integer(c_int), intent(in out) :: x
        ! manifest end
      
      
        do while ((x < 5_c_int))
          x = (x + 1_c_int)
          if ((x < 0_c_int)) then
            cycle
          end if
        end do
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(int* const x__);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != INTSXP) {
          Rf_error("typeof(x) must be 'integer', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        x = Rf_duplicate(x);
        SETCAR(_args, x);
        int* const x__ = INTEGER(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        if (x__len_ != 1)
          Rf_error("length(x) must be 1, not %0.f",
                    (double)x__len_);
        
        fn(x__);
        
        return x;
      }

# while + break

    Code
      fn
    Output
      function(x) {
          declare(type(x = integer(1)))
          while (TRUE) {
            if (x >= 5L) {
              break
            }
            x <- x + 1L
          }
          x
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x) bind(c)
        use iso_c_binding, only: c_int
        implicit none
      
        ! manifest start
        ! args
        integer(c_int), intent(in out) :: x
        ! manifest end
      
      
        do while (.true.)
          if ((x >= 5_c_int)) then
            exit
          end if
          x = (x + 1_c_int)
        end do
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(int* const x__);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != INTSXP) {
          Rf_error("typeof(x) must be 'integer', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        x = Rf_duplicate(x);
        SETCAR(_args, x);
        int* const x__ = INTEGER(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        if (x__len_ != 1)
          Rf_error("length(x) must be 1, not %0.f",
                    (double)x__len_);
        
        fn(x__);
        
        return x;
      }

# expr return value

    Code
      fn
    Output
      function(x) {
          declare(type(x = integer(NA)))
          x + 1L
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out_, x__len_) bind(c)
        use iso_c_binding, only: c_int, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: x__len_
      
        ! args
        integer(c_int), intent(in) :: x(x__len_)
        integer(c_int), intent(out) :: out_(x__len_)
        ! manifest end
      
      
        out_ = (x + 1_c_int)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const int* const x__, 
        int* const out___, 
        const R_xlen_t x__len_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != INTSXP) {
          Rf_error("typeof(x) must be 'integer', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const int* const x__ = INTEGER(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        const R_xlen_t out___len_ = x__len_;
        SEXP out_ = PROTECT(Rf_allocVector(INTSXP, out___len_));
        int* out___ = INTEGER(out_);
        
        fn(x__, out___, x__len_);
        
        UNPROTECT(1);
        return out_;
      }

# cbind/rbind reject rank > 2 inputs with clear errors

    Code
      capture_bind_error(r2f(bad_cbind))
    Output
      cbind() only supports rank 0-2 inputs 
    Code
      capture_bind_error(r2f(bad_rbind))
    Output
      rbind() only supports rank 0-2 inputs 

# translation snapshots: hoist+block inside contains (sapply closure)

    Code
      cat("# Snapshot note: ", note, "\n", sep = "")
    Output
      # Snapshot note: The closure body indexes an array expression, which forces a hoisted temporary and a Fortran block inside the internal procedure.
    Code
      fn
    Output
      function(x) {
          declare(type(x = double(NA)))
          out <- double(length(x))
          out <- sapply(seq_along(out), function(i) (x + 1.0)[i])
          out
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out, x__len_) bind(c)
        use iso_c_binding, only: c_double, c_int, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: x__len_
      
        ! args
        real(c_double), intent(in) :: x(x__len_)
        real(c_double), intent(out) :: out(x__len_)
      
        ! locals
        integer(c_int) :: tmp1_
        ! manifest end
      
      
        out = 0
        do tmp1_ = 1_c_int, x__len_
          call closure1_(tmp1_, out(tmp1_))
      
        end do
      
      
        contains
          subroutine closure1_(i, res)
            use iso_c_binding, only: c_double, c_int
            implicit none
      
            integer(c_int), intent(in) :: i
            real(c_double), intent(out) :: res
      
      
            block
              real(c_double), allocatable :: btmp1_(:)
      
              allocate(btmp1_(x__len_))
              btmp1_ = ((x + 1.0_c_double))
              res = btmp1_(i)
            end block
          end subroutine
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const x__, 
        double* const out__, 
        const R_xlen_t x__len_);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        const R_xlen_t out__len_ = x__len_;
        SEXP out = PROTECT(Rf_allocVector(REALSXP, out__len_));
        double* out__ = REAL(out);
        
        fn(x__, out__, x__len_);
        
        UNPROTECT(1);
        return out;
      }

# translation snapshots: hoist+block inside contains (statement closure + <<-)

    Code
      cat("# Snapshot note: ", note, "\n", sep = "")
    Output
      # Snapshot note: Statement local closure lowered under contains; RHS indexing forces hoisting + a block inside the internal procedure; LHS uses [<<- to mutate the host variable.
    Code
      fn
    Output
      function(nx, ny) {
          declare(type(nx = integer(1)), type(ny = integer(1)))
          temp <- matrix(0, nx, ny)
      
          bc <- function() {
            temp[1, 1] <<- (temp + 1.0)[1, 1]
            temp[nx, ny] <<- (temp + 2.0)[nx, ny]
            NULL
          }
      
          bc()
          temp
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(nx, ny, temp) bind(c)
        use iso_c_binding, only: c_double, c_int
        implicit none
      
        ! manifest start
        ! args
        integer(c_int), intent(in) :: nx
        integer(c_int), intent(in) :: ny
        real(c_double), intent(out) :: temp(nx, ny)
        ! manifest end
      
      
        temp = 0.0_c_double
      
        call bc()
      
        contains
          subroutine bc()
            use iso_c_binding, only: c_double, c_int
            implicit none
      
      
      
            block
              real(c_double), allocatable :: btmp1_(:, :)
      
              allocate(btmp1_(nx, ny))
              btmp1_ = ((temp + 1.0_c_double))
              temp(1_c_int, 1_c_int) = btmp1_(1_c_int, 1_c_int)
            end block
            block
              real(c_double), allocatable :: btmp1_(:, :)
      
              allocate(btmp1_(nx, ny))
              btmp1_ = ((temp + 2.0_c_double))
              temp(nx, ny) = btmp1_(nx, ny)
            end block
          end subroutine
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const int* const nx__, 
        const int* const ny__, 
        double* const temp__);
      
      SEXP fn_(SEXP _args) {
        // nx
        _args = CDR(_args);
        SEXP nx = CAR(_args);
        if (TYPEOF(nx) != INTSXP) {
          Rf_error("typeof(nx) must be 'integer', not '%s'", Rf_type2char(TYPEOF(nx)));
        }
        const int* const nx__ = INTEGER(nx);
        const R_xlen_t nx__len_ = Rf_xlength(nx);
        
        // ny
        _args = CDR(_args);
        SEXP ny = CAR(_args);
        if (TYPEOF(ny) != INTSXP) {
          Rf_error("typeof(ny) must be 'integer', not '%s'", Rf_type2char(TYPEOF(ny)));
        }
        const int* const ny__ = INTEGER(ny);
        const R_xlen_t ny__len_ = Rf_xlength(ny);
        
        if (nx__len_ != 1)
          Rf_error("length(nx) must be 1, not %0.f",
                    (double)nx__len_);
        if (ny__len_ != 1)
          Rf_error("length(ny) must be 1, not %0.f",
                    (double)ny__len_);
        const int _as_int_nx = Rf_asInteger(nx);
        const int _as_int_ny = Rf_asInteger(ny);
        const R_xlen_t temp__len_ = (_as_int_nx) * (_as_int_ny);
        SEXP temp = PROTECT(Rf_allocVector(REALSXP, temp__len_));
        double* temp__ = REAL(temp);
        {
          const SEXP _dim_sexp = PROTECT(Rf_allocVector(INTSXP, 2));
          int* const _dim = INTEGER(_dim_sexp);
          _dim[0] = _as_int_nx;
          _dim[1] = _as_int_ny;
          Rf_dimgets(temp, _dim_sexp);
        }
        
        fn(nx__, ny__, temp__);
        
        UNPROTECT(2);
        return temp;
      }

# %% and %/%

    Code
      fn
    Output
      function(a, b) {
          declare(type(a = double(n)), type(b = double(n)))
          a %% b
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(a, b, out_, a__len_) bind(c)
        use iso_c_binding, only: c_double, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: a__len_
      
        ! args
        real(c_double), intent(in) :: a(a__len_)
        real(c_double), intent(in) :: b(a__len_)
        real(c_double), intent(out) :: out_(a__len_)
        ! manifest end
      
      
        out_ = modulo(a, b)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const a__, 
        const double* const b__, 
        double* const out___, 
        const R_xlen_t a__len_);
      
      SEXP fn_(SEXP _args) {
        // a
        _args = CDR(_args);
        SEXP a = CAR(_args);
        if (TYPEOF(a) != REALSXP) {
          Rf_error("typeof(a) must be 'double', not '%s'", Rf_type2char(TYPEOF(a)));
        }
        const double* const a__ = REAL(a);
        const R_xlen_t a__len_ = Rf_xlength(a);
        
        // b
        _args = CDR(_args);
        SEXP b = CAR(_args);
        if (TYPEOF(b) != REALSXP) {
          Rf_error("typeof(b) must be 'double', not '%s'", Rf_type2char(TYPEOF(b)));
        }
        const double* const b__ = REAL(b);
        const R_xlen_t b__len_ = Rf_xlength(b);
        
        if (a__len_ != b__len_)
          Rf_error("length(b) must equal length(a),"
                   " but are %0.f and %0.f",
                    (double)b__len_, (double)a__len_);
        const R_xlen_t out___len_ = a__len_;
        SEXP out_ = PROTECT(Rf_allocVector(REALSXP, out___len_));
        double* out___ = REAL(out_);
        
        fn(
          a__,
          b__,
          out___,
          a__len_);
        
        UNPROTECT(1);
        return out_;
      }

---

    Code
      fn
    Output
      function(a, b) {
          declare(type(a = double(n)), type(b = double(n)))
          a %/% b
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(a, b, out_, a__len_) bind(c)
        use iso_c_binding, only: c_double, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: a__len_
      
        ! args
        real(c_double), intent(in) :: a(a__len_)
        real(c_double), intent(in) :: b(a__len_)
        real(c_double), intent(out) :: out_(a__len_)
        ! manifest end
      
      
        out_ = floor(a / b)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const a__, 
        const double* const b__, 
        double* const out___, 
        const R_xlen_t a__len_);
      
      SEXP fn_(SEXP _args) {
        // a
        _args = CDR(_args);
        SEXP a = CAR(_args);
        if (TYPEOF(a) != REALSXP) {
          Rf_error("typeof(a) must be 'double', not '%s'", Rf_type2char(TYPEOF(a)));
        }
        const double* const a__ = REAL(a);
        const R_xlen_t a__len_ = Rf_xlength(a);
        
        // b
        _args = CDR(_args);
        SEXP b = CAR(_args);
        if (TYPEOF(b) != REALSXP) {
          Rf_error("typeof(b) must be 'double', not '%s'", Rf_type2char(TYPEOF(b)));
        }
        const double* const b__ = REAL(b);
        const R_xlen_t b__len_ = Rf_xlength(b);
        
        if (a__len_ != b__len_)
          Rf_error("length(b) must equal length(a),"
                   " but are %0.f and %0.f",
                    (double)b__len_, (double)a__len_);
        const R_xlen_t out___len_ = a__len_;
        SEXP out_ = PROTECT(Rf_allocVector(REALSXP, out___len_));
        double* out___ = REAL(out_);
        
        fn(
          a__,
          b__,
          out___,
          a__len_);
        
        UNPROTECT(1);
        return out_;
      }

# arithmetic expressions in dimensions compile

    Code
      fn
    Output
      function(n) {
          declare(type(n = integer(1)))
          x <- double(n * 2L)
          y <- double(n - 1L)
          length(x) + length(y)
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(n, out_) bind(c)
        use iso_c_binding, only: c_double, c_int
        implicit none
      
        ! manifest start
        ! args
        integer(c_int), intent(in) :: n
        integer(c_int), intent(out) :: out_
      
        ! locals
        real(c_double), allocatable :: x(:)
        real(c_double), allocatable :: y(:)
        ! manifest end
      
        allocate(x((n * 2)))
        allocate(y((n - 1)))
      
      
        x = 0
        y = 0
        out_ = (size(x) + size(y))
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(const int* const n__, int* const out___);
      
      SEXP fn_(SEXP _args) {
        // n
        _args = CDR(_args);
        SEXP n = CAR(_args);
        if (TYPEOF(n) != INTSXP) {
          Rf_error("typeof(n) must be 'integer', not '%s'", Rf_type2char(TYPEOF(n)));
        }
        const int* const n__ = INTEGER(n);
        const R_xlen_t n__len_ = Rf_xlength(n);
        
        if (n__len_ != 1)
          Rf_error("length(n) must be 1, not %0.f",
                    (double)n__len_);
        const R_xlen_t out___len_ = (1);
        SEXP out_ = PROTECT(Rf_allocVector(INTSXP, out___len_));
        int* out___ = INTEGER(out_);
        
        fn(n__, out___);
        
        UNPROTECT(1);
        return out_;
      }

# integer division and modulus in dimensions compile

    Code
      fn
    Output
      function(n) {
          declare(type(n = integer(1)))
          out <- double(n %/% 2L + n %% 2L)
          length(out)
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(n, out_) bind(c)
        use iso_c_binding, only: c_double, c_int
        implicit none
      
        ! manifest start
        ! args
        integer(c_int), intent(in) :: n
        integer(c_int), intent(out) :: out_
      
        ! locals
        real(c_double), allocatable :: out(:)
        ! manifest end
      
        allocate(out((int(n) / int(2) + mod(int(n), int(2)))))
      
      
        out = 0
        out_ = size(out)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(const int* const n__, int* const out___);
      
      SEXP fn_(SEXP _args) {
        // n
        _args = CDR(_args);
        SEXP n = CAR(_args);
        if (TYPEOF(n) != INTSXP) {
          Rf_error("typeof(n) must be 'integer', not '%s'", Rf_type2char(TYPEOF(n)));
        }
        const int* const n__ = INTEGER(n);
        const R_xlen_t n__len_ = Rf_xlength(n);
        
        if (n__len_ != 1)
          Rf_error("length(n) must be 1, not %0.f",
                    (double)n__len_);
        const R_xlen_t out___len_ = (1);
        SEXP out_ = PROTECT(Rf_allocVector(INTSXP, out___len_));
        int* out___ = INTEGER(out_);
        
        fn(n__, out___);
        
        UNPROTECT(1);
        return out_;
      }

# matrix dimension expressions compile

    Code
      fn
    Output
      function(n) {
          declare(type(n = integer(1)))
          out <- matrix(1, n + 1L, n %/% 2L + 1L)
          dim(out)
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(n, out_) bind(c)
        use iso_c_binding, only: c_double, c_int
        implicit none
      
        ! manifest start
        ! args
        integer(c_int), intent(in) :: n
        integer(c_int), intent(out) :: out_(2)
      
        ! locals
        real(c_double), allocatable :: out(:, :)
        ! manifest end
      
        allocate(out((n + 1), (int(n) / int(2) + 1)))
      
      
        out = 1.0_c_double
        out_ = shape(out)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(const int* const n__, int* const out___);
      
      SEXP fn_(SEXP _args) {
        // n
        _args = CDR(_args);
        SEXP n = CAR(_args);
        if (TYPEOF(n) != INTSXP) {
          Rf_error("typeof(n) must be 'integer', not '%s'", Rf_type2char(TYPEOF(n)));
        }
        const int* const n__ = INTEGER(n);
        const R_xlen_t n__len_ = Rf_xlength(n);
        
        if (n__len_ != 1)
          Rf_error("length(n) must be 1, not %0.f",
                    (double)n__len_);
        const R_xlen_t out___len_ = 2;
        SEXP out_ = PROTECT(Rf_allocVector(INTSXP, out___len_));
        int* out___ = INTEGER(out_);
        
        fn(n__, out___);
        
        UNPROTECT(1);
        return out_;
      }

# quick() supports .Machine$double.eps

    Code
      fn
    Output
      function(x) {
          declare(type(x = double(1)))
          x + .Machine$double.eps
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(x, out_) bind(c)
        use iso_c_binding, only: c_double
        implicit none
      
        ! manifest start
        ! args
        real(c_double), intent(in) :: x
        real(c_double), intent(out) :: out_
        ! manifest end
      
      
        out_ = (x + epsilon(1.0_c_double))
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(const double* const x__, double* const out___);
      
      SEXP fn_(SEXP _args) {
        // x
        _args = CDR(_args);
        SEXP x = CAR(_args);
        if (TYPEOF(x) != REALSXP) {
          Rf_error("typeof(x) must be 'double', not '%s'", Rf_type2char(TYPEOF(x)));
        }
        const double* const x__ = REAL(x);
        const R_xlen_t x__len_ = Rf_xlength(x);
        
        if (x__len_ != 1)
          Rf_error("length(x) must be 1, not %0.f",
                    (double)x__len_);
        const R_xlen_t out___len_ = (1);
        SEXP out_ = PROTECT(Rf_allocVector(REALSXP, out___len_));
        double* out___ = REAL(out_);
        
        fn(x__, out___);
        
        UNPROTECT(1);
        return out_;
      }

# viterbi

    Code
      viterbi
    Output
      function(
          observations,
          states,
          initial_probs,
          transition_probs,
          emission_probs
        ) {
          declare({
            type(observations = integer(num_steps))
            type(states = integer(num_states))
            type(initial_probs = double(num_states))
            type(transition_probs = double(num_states, num_states))
            type(emission_probs = double(num_states, num_obs))
          })
      
          num_states <- length(states)
          num_steps <- length(observations)
      
          # Trellis matrices for probabilities and backtracking
          trellis <- matrix(0, nrow = length(states), ncol = length(observations))
          backpointer <- matrix(
            0L,
            nrow = length(states),
            ncol = length(observations)
          )
      
          # print(backpointer)
          # print(trellis)
          # Fortran("write (*,*) backpointer")
      
          # Initialization step
          trellis[, 1] <- initial_probs * emission_probs[, observations[1]]
      
          # print(backpointer)
          # print(trellis)
      
          # Recursion step
          for (step in 2:num_steps) {
            for (current_state in 1:num_states) {
              probabilities <- trellis[, step - 1] * transition_probs[, current_state]
              trellis[current_state, step] <- max(probabilities) *
                emission_probs[current_state, observations[step]]
              backpointer[current_state, step] <- which.max(probabilities)
            }
          }
      
          # print(backpointer)
          # print(trellis)
      
          # Backtracking to find the most likely path
          path <- integer(length(observations))
          # print(path)
          path[num_steps] <- which.max(trellis[, num_steps])
          # print(path)
          for (step in seq((num_steps - 1), 1)) {
            # print(backpointer[path[step + 1], step + 1])
            path[step] <- backpointer[path[step + 1], step + 1]
            # print(step)
          }
      
          # print(path)
      
          # print(states)
          # Return the most likely path
          out <- states[path]
          out
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine viterbi(observations, states, initial_probs, transition_probs, emission_probs, out, emission_probs__dim_2_,&
      & observations__len_, states__len_) bind(c)
        use iso_c_binding, only: c_double, c_int, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: observations__len_
        integer(c_ptrdiff_t), intent(in), value :: states__len_
        integer(c_int), intent(in), value :: emission_probs__dim_2_
      
        ! args
        integer(c_int), intent(in) :: observations(observations__len_)
        integer(c_int), intent(in) :: states(states__len_)
        real(c_double), intent(in) :: initial_probs(states__len_)
        real(c_double), intent(in) :: transition_probs(states__len_, states__len_)
        real(c_double), intent(in) :: emission_probs(states__len_, emission_probs__dim_2_)
        integer(c_int), intent(out) :: out(observations__len_)
      
        ! locals
        integer(c_int) :: num_states
        integer(c_int) :: num_steps
        real(c_double), allocatable :: trellis(:, :)
        integer(c_int), allocatable :: backpointer(:, :)
        integer(c_int) :: step
        integer(c_int) :: current_state
        real(c_double), allocatable :: probabilities(:)
        integer(c_int), allocatable :: path(:)
        ! manifest end
      
        allocate(trellis(states__len_, observations__len_))
        allocate(backpointer(states__len_, observations__len_))
        allocate(probabilities(states__len_))
        allocate(path(observations__len_))
      
      
        num_states = size(states)
        num_steps = size(observations)
        trellis = 0.0_c_double
        backpointer = 0_c_int
        trellis(:, 1_c_int) = (initial_probs * emission_probs(:, observations(1_c_int)))
        do step = 2_c_int, num_steps, sign(1, num_steps-2_c_int)
          do current_state = 1_c_int, num_states, sign(1, num_states-1_c_int)
            probabilities = (trellis(:, (step - 1_c_int)) * transition_probs(:, current_state))
            trellis(current_state, step) = (maxval(probabilities) * emission_probs(current_state, observations(step)))
            backpointer(current_state, step) = maxloc(probabilities, 1)
          end do
        end do
        path = 0
        path(num_steps) = maxloc(trellis(:, num_steps), 1)
        do step = ((num_steps - 1_c_int)), 1_c_int, sign(1, 1_c_int-((num_steps - 1_c_int)))
          path(step) = backpointer(path((step + 1_c_int)), (step + 1_c_int))
        end do
        out = states(path)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void viterbi(
        const int* const observations__, 
        const int* const states__, 
        const double* const initial_probs__, 
        const double* const transition_probs__, 
        const double* const emission_probs__, 
        int* const out__, 
        const R_len_t emission_probs__dim_2_, 
        const R_xlen_t observations__len_, 
        const R_xlen_t states__len_);
      
      SEXP viterbi_(SEXP _args) {
        // observations
        _args = CDR(_args);
        SEXP observations = CAR(_args);
        if (TYPEOF(observations) != INTSXP) {
          Rf_error("typeof(observations) must be 'integer', not '%s'", Rf_type2char(TYPEOF(observations)));
        }
        const int* const observations__ = INTEGER(observations);
        const R_xlen_t observations__len_ = Rf_xlength(observations);
        
        // states
        _args = CDR(_args);
        SEXP states = CAR(_args);
        if (TYPEOF(states) != INTSXP) {
          Rf_error("typeof(states) must be 'integer', not '%s'", Rf_type2char(TYPEOF(states)));
        }
        const int* const states__ = INTEGER(states);
        const R_xlen_t states__len_ = Rf_xlength(states);
        
        // initial_probs
        _args = CDR(_args);
        SEXP initial_probs = CAR(_args);
        if (TYPEOF(initial_probs) != REALSXP) {
          Rf_error("typeof(initial_probs) must be 'double', not '%s'", Rf_type2char(TYPEOF(initial_probs)));
        }
        const double* const initial_probs__ = REAL(initial_probs);
        const R_xlen_t initial_probs__len_ = Rf_xlength(initial_probs);
        
        // transition_probs
        _args = CDR(_args);
        SEXP transition_probs = CAR(_args);
        if (TYPEOF(transition_probs) != REALSXP) {
          Rf_error("typeof(transition_probs) must be 'double', not '%s'", Rf_type2char(TYPEOF(transition_probs)));
        }
        const double* const transition_probs__ = REAL(transition_probs);
        const int* const transition_probs__dim_ = ({
        SEXP dim_ = Rf_getAttrib(transition_probs, R_DimSymbol);
        if (Rf_length(dim_) != 2) Rf_error(
          "transition_probs must be a 2D-array, but length(dim(transition_probs)) is %i",
          (int) Rf_length(dim_));
        INTEGER(dim_);});
        const int transition_probs__dim_1_ = transition_probs__dim_[0];
        const int transition_probs__dim_2_ = transition_probs__dim_[1];
        
        // emission_probs
        _args = CDR(_args);
        SEXP emission_probs = CAR(_args);
        if (TYPEOF(emission_probs) != REALSXP) {
          Rf_error("typeof(emission_probs) must be 'double', not '%s'", Rf_type2char(TYPEOF(emission_probs)));
        }
        const double* const emission_probs__ = REAL(emission_probs);
        const int* const emission_probs__dim_ = ({
        SEXP dim_ = Rf_getAttrib(emission_probs, R_DimSymbol);
        if (Rf_length(dim_) != 2) Rf_error(
          "emission_probs must be a 2D-array, but length(dim(emission_probs)) is %i",
          (int) Rf_length(dim_));
        INTEGER(dim_);});
        const int emission_probs__dim_1_ = emission_probs__dim_[0];
        const int emission_probs__dim_2_ = emission_probs__dim_[1];
        
        if (states__len_ != initial_probs__len_)
          Rf_error("length(initial_probs) must equal length(states),"
                   " but are %0.f and %0.f",
                    (double)initial_probs__len_, (double)states__len_);
        if (states__len_ != transition_probs__dim_1_)
          Rf_error("dim(transition_probs)[1] must equal length(states),"
                   " but are %0.f and %0.f",
                    (double)transition_probs__dim_1_, (double)states__len_);
        if (states__len_ != transition_probs__dim_2_)
          Rf_error("dim(transition_probs)[2] must equal length(states),"
                   " but are %0.f and %0.f",
                    (double)transition_probs__dim_2_, (double)states__len_);
        if (states__len_ != emission_probs__dim_1_)
          Rf_error("dim(emission_probs)[1] must equal length(states),"
                   " but are %0.f and %0.f",
                    (double)emission_probs__dim_1_, (double)states__len_);
        const R_xlen_t out__len_ = observations__len_;
        SEXP out = PROTECT(Rf_allocVector(INTSXP, out__len_));
        int* out__ = INTEGER(out);
        
        viterbi(
          observations__,
          states__,
          initial_probs__,
          transition_probs__,
          emission_probs__,
          out__,
          emission_probs__dim_2_,
          observations__len_,
          states__len_);
        
        UNPROTECT(1);
        return out;
      }

# viterbi2

    Code
      viterbi
    Output
      function(
          observations,
          states,
          initial_probs,
          transition_probs,
          emission_probs
        ) {
          declare(
            type(observations = integer(num_steps)),
            type(states = integer(num_states)),
            type(initial_probs = double(num_states)),
            type(transition_probs = double(num_states, num_states)),
            type(emission_probs = double(num_states, num_obs)),
          )
      
          trellis <- matrix(0, nrow = length(states), ncol = length(observations))
          backpointer <- matrix(
            0L,
            nrow = length(states),
            ncol = length(observations)
          )
          trellis[, 1] <- initial_probs * emission_probs[, observations[1]]
      
          for (step in 2:length(observations)) {
            for (current_state in 1:length(states)) {
              probabilities <- trellis[, step - 1] * transition_probs[, current_state]
              trellis[current_state, step] <- max(probabilities) *
                emission_probs[current_state, observations[step]]
              backpointer[current_state, step] <- which.max(probabilities)
            }
          }
      
          path <- integer(length(observations))
          path[length(observations)] <- which.max(trellis[, length(observations)])
          for (step in seq(length(observations) - 1, 1)) {
            path[step] <- backpointer[path[step + 1], step + 1]
          }
      
          out <- states[path]
          out
        }
      <environment: 0x0>
    Code
      cat(fsub <- r2f(viterbi))
    Output
      subroutine viterbi(observations, states, initial_probs, transition_probs, emission_probs, out, emission_probs__dim_2_,&
      & observations__len_, states__len_) bind(c)
        use iso_c_binding, only: c_double, c_int, c_ptrdiff_t
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_ptrdiff_t), intent(in), value :: observations__len_
        integer(c_ptrdiff_t), intent(in), value :: states__len_
        integer(c_int), intent(in), value :: emission_probs__dim_2_
      
        ! args
        integer(c_int), intent(in) :: observations(observations__len_)
        integer(c_int), intent(in) :: states(states__len_)
        real(c_double), intent(in) :: initial_probs(states__len_)
        real(c_double), intent(in) :: transition_probs(states__len_, states__len_)
        real(c_double), intent(in) :: emission_probs(states__len_, emission_probs__dim_2_)
        integer(c_int), intent(out) :: out(observations__len_)
      
        ! locals
        real(c_double), allocatable :: trellis(:, :)
        integer(c_int), allocatable :: backpointer(:, :)
        integer(c_int) :: step
        integer(c_int) :: current_state
        real(c_double), allocatable :: probabilities(:)
        integer(c_int), allocatable :: path(:)
        ! manifest end
      
        allocate(trellis(states__len_, observations__len_))
        allocate(backpointer(states__len_, observations__len_))
        allocate(probabilities(states__len_))
        allocate(path(observations__len_))
      
      
        trellis = 0.0_c_double
        backpointer = 0_c_int
        trellis(:, 1_c_int) = (initial_probs * emission_probs(:, observations(1_c_int)))
        do step = 2_c_int, size(observations), sign(1, size(observations)-2_c_int)
          do current_state = 1_c_int, size(states), sign(1, size(states)-1_c_int)
            probabilities = (trellis(:, (step - 1_c_int)) * transition_probs(:, current_state))
            trellis(current_state, step) = (maxval(probabilities) * emission_probs(current_state, observations(step)))
            backpointer(current_state, step) = maxloc(probabilities, 1)
          end do
        end do
        path = 0
        path(size(observations)) = maxloc(trellis(:, size(observations)), 1)
        do step = (size(observations) - 1_c_int), 1_c_int, sign(1, 1_c_int-(size(observations) - 1_c_int))
          path(step) = backpointer(path((step + 1_c_int)), (step + 1_c_int))
        end do
        out = states(path)
      end subroutine
    Code
      cat(make_c_bridge(fsub))
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void viterbi(
        const int* const observations__, 
        const int* const states__, 
        const double* const initial_probs__, 
        const double* const transition_probs__, 
        const double* const emission_probs__, 
        int* const out__, 
        const R_len_t emission_probs__dim_2_, 
        const R_xlen_t observations__len_, 
        const R_xlen_t states__len_);
      
      SEXP viterbi_(SEXP _args) {
        // observations
        _args = CDR(_args);
        SEXP observations = CAR(_args);
        if (TYPEOF(observations) != INTSXP) {
          Rf_error("typeof(observations) must be 'integer', not '%s'", Rf_type2char(TYPEOF(observations)));
        }
        const int* const observations__ = INTEGER(observations);
        const R_xlen_t observations__len_ = Rf_xlength(observations);
        
        // states
        _args = CDR(_args);
        SEXP states = CAR(_args);
        if (TYPEOF(states) != INTSXP) {
          Rf_error("typeof(states) must be 'integer', not '%s'", Rf_type2char(TYPEOF(states)));
        }
        const int* const states__ = INTEGER(states);
        const R_xlen_t states__len_ = Rf_xlength(states);
        
        // initial_probs
        _args = CDR(_args);
        SEXP initial_probs = CAR(_args);
        if (TYPEOF(initial_probs) != REALSXP) {
          Rf_error("typeof(initial_probs) must be 'double', not '%s'", Rf_type2char(TYPEOF(initial_probs)));
        }
        const double* const initial_probs__ = REAL(initial_probs);
        const R_xlen_t initial_probs__len_ = Rf_xlength(initial_probs);
        
        // transition_probs
        _args = CDR(_args);
        SEXP transition_probs = CAR(_args);
        if (TYPEOF(transition_probs) != REALSXP) {
          Rf_error("typeof(transition_probs) must be 'double', not '%s'", Rf_type2char(TYPEOF(transition_probs)));
        }
        const double* const transition_probs__ = REAL(transition_probs);
        const int* const transition_probs__dim_ = ({
        SEXP dim_ = Rf_getAttrib(transition_probs, R_DimSymbol);
        if (Rf_length(dim_) != 2) Rf_error(
          "transition_probs must be a 2D-array, but length(dim(transition_probs)) is %i",
          (int) Rf_length(dim_));
        INTEGER(dim_);});
        const int transition_probs__dim_1_ = transition_probs__dim_[0];
        const int transition_probs__dim_2_ = transition_probs__dim_[1];
        
        // emission_probs
        _args = CDR(_args);
        SEXP emission_probs = CAR(_args);
        if (TYPEOF(emission_probs) != REALSXP) {
          Rf_error("typeof(emission_probs) must be 'double', not '%s'", Rf_type2char(TYPEOF(emission_probs)));
        }
        const double* const emission_probs__ = REAL(emission_probs);
        const int* const emission_probs__dim_ = ({
        SEXP dim_ = Rf_getAttrib(emission_probs, R_DimSymbol);
        if (Rf_length(dim_) != 2) Rf_error(
          "emission_probs must be a 2D-array, but length(dim(emission_probs)) is %i",
          (int) Rf_length(dim_));
        INTEGER(dim_);});
        const int emission_probs__dim_1_ = emission_probs__dim_[0];
        const int emission_probs__dim_2_ = emission_probs__dim_[1];
        
        if (states__len_ != initial_probs__len_)
          Rf_error("length(initial_probs) must equal length(states),"
                   " but are %0.f and %0.f",
                    (double)initial_probs__len_, (double)states__len_);
        if (states__len_ != transition_probs__dim_1_)
          Rf_error("dim(transition_probs)[1] must equal length(states),"
                   " but are %0.f and %0.f",
                    (double)transition_probs__dim_1_, (double)states__len_);
        if (states__len_ != transition_probs__dim_2_)
          Rf_error("dim(transition_probs)[2] must equal length(states),"
                   " but are %0.f and %0.f",
                    (double)transition_probs__dim_2_, (double)states__len_);
        if (states__len_ != emission_probs__dim_1_)
          Rf_error("dim(emission_probs)[1] must equal length(states),"
                   " but are %0.f and %0.f",
                    (double)emission_probs__dim_1_, (double)states__len_);
        const R_xlen_t out__len_ = observations__len_;
        SEXP out = PROTECT(Rf_allocVector(INTSXP, out__len_));
        int* out__ = INTEGER(out);
        
        viterbi(
          observations__,
          states__,
          initial_probs__,
          transition_probs__,
          emission_probs__,
          out__,
          emission_probs__dim_2_,
          observations__len_,
          states__len_);
        
        UNPROTECT(1);
        return out;
      }

# drop() translation snapshots

    Code
      fn
    Output
      function(A) {
          declare(type(A = double(1L, 3L)))
          drop(A)
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(A, out_) bind(c)
        use iso_c_binding, only: c_double
        implicit none
      
        ! manifest start
        ! args
        real(c_double), intent(in) :: A(1, 3)
        real(c_double), intent(out) :: out_(3)
        ! manifest end
      
      
        out_ = A(1, :)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(const double* const A__, double* const out___);
      
      SEXP fn_(SEXP _args) {
        // A
        _args = CDR(_args);
        SEXP A = CAR(_args);
        if (TYPEOF(A) != REALSXP) {
          Rf_error("typeof(A) must be 'double', not '%s'", Rf_type2char(TYPEOF(A)));
        }
        const double* const A__ = REAL(A);
        const int* const A__dim_ = ({
        SEXP dim_ = Rf_getAttrib(A, R_DimSymbol);
        if (Rf_length(dim_) != 2) Rf_error(
          "A must be a 2D-array, but length(dim(A)) is %i",
          (int) Rf_length(dim_));
        INTEGER(dim_);});
        const int A__dim_1_ = A__dim_[0];
        const int A__dim_2_ = A__dim_[1];
        
        if (A__dim_1_ != 1)
          Rf_error("dim(A)[1] must be 1, not %0.f",
                    (double)A__dim_1_);
        if (A__dim_2_ != 3)
          Rf_error("dim(A)[2] must be 3, not %0.f",
                    (double)A__dim_2_);
        const R_xlen_t out___len_ = 3;
        SEXP out_ = PROTECT(Rf_allocVector(REALSXP, out___len_));
        double* out___ = REAL(out_);
        
        fn(A__, out___);
        
        UNPROTECT(1);
        return out_;
      }

---

    Code
      fn
    Output
      function(A) {
          declare(type(A = double(3L, 1L)))
          drop(A)
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(A, out_) bind(c)
        use iso_c_binding, only: c_double
        implicit none
      
        ! manifest start
        ! args
        real(c_double), intent(in) :: A(3, 1)
        real(c_double), intent(out) :: out_(3)
        ! manifest end
      
      
        out_ = A(:, 1)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(const double* const A__, double* const out___);
      
      SEXP fn_(SEXP _args) {
        // A
        _args = CDR(_args);
        SEXP A = CAR(_args);
        if (TYPEOF(A) != REALSXP) {
          Rf_error("typeof(A) must be 'double', not '%s'", Rf_type2char(TYPEOF(A)));
        }
        const double* const A__ = REAL(A);
        const int* const A__dim_ = ({
        SEXP dim_ = Rf_getAttrib(A, R_DimSymbol);
        if (Rf_length(dim_) != 2) Rf_error(
          "A must be a 2D-array, but length(dim(A)) is %i",
          (int) Rf_length(dim_));
        INTEGER(dim_);});
        const int A__dim_1_ = A__dim_[0];
        const int A__dim_2_ = A__dim_[1];
        
        if (A__dim_1_ != 3)
          Rf_error("dim(A)[1] must be 3, not %0.f",
                    (double)A__dim_1_);
        if (A__dim_2_ != 1)
          Rf_error("dim(A)[2] must be 1, not %0.f",
                    (double)A__dim_2_);
        const R_xlen_t out___len_ = 3;
        SEXP out_ = PROTECT(Rf_allocVector(REALSXP, out___len_));
        double* out___ = REAL(out_);
        
        fn(A__, out___);
        
        UNPROTECT(1);
        return out_;
      }

---

    Code
      fn
    Output
      function(A) {
          declare(type(A = double(1L, NA)))
          drop(A)
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(A, out_, A__dim_2_) bind(c)
        use iso_c_binding, only: c_double, c_int
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_int), intent(in), value :: A__dim_2_
      
        ! args
        real(c_double), intent(in) :: A(1, A__dim_2_)
        real(c_double), intent(out) :: out_(A__dim_2_)
        ! manifest end
      
      
        out_ = A(1, :)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const A__, 
        double* const out___, 
        const R_len_t A__dim_2_);
      
      SEXP fn_(SEXP _args) {
        // A
        _args = CDR(_args);
        SEXP A = CAR(_args);
        if (TYPEOF(A) != REALSXP) {
          Rf_error("typeof(A) must be 'double', not '%s'", Rf_type2char(TYPEOF(A)));
        }
        const double* const A__ = REAL(A);
        const int* const A__dim_ = ({
        SEXP dim_ = Rf_getAttrib(A, R_DimSymbol);
        if (Rf_length(dim_) != 2) Rf_error(
          "A must be a 2D-array, but length(dim(A)) is %i",
          (int) Rf_length(dim_));
        INTEGER(dim_);});
        const int A__dim_1_ = A__dim_[0];
        const int A__dim_2_ = A__dim_[1];
        
        if (A__dim_1_ != 1)
          Rf_error("dim(A)[1] must be 1, not %0.f",
                    (double)A__dim_1_);
        const R_xlen_t out___len_ = A__dim_2_;
        SEXP out_ = PROTECT(Rf_allocVector(REALSXP, out___len_));
        double* out___ = REAL(out_);
        
        fn(A__, out___, A__dim_2_);
        
        UNPROTECT(1);
        return out_;
      }

---

    Code
      fn
    Output
      function(A) {
          declare(type(A = double(NA, 1L)))
          drop(A)
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(A, out_, A__dim_1_) bind(c)
        use iso_c_binding, only: c_double, c_int
        implicit none
      
        ! manifest start
        ! sizes
        integer(c_int), intent(in), value :: A__dim_1_
      
        ! args
        real(c_double), intent(in) :: A(A__dim_1_, 1)
        real(c_double), intent(out) :: out_(A__dim_1_)
        ! manifest end
      
      
        out_ = A(:, 1)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const A__, 
        double* const out___, 
        const R_len_t A__dim_1_);
      
      SEXP fn_(SEXP _args) {
        // A
        _args = CDR(_args);
        SEXP A = CAR(_args);
        if (TYPEOF(A) != REALSXP) {
          Rf_error("typeof(A) must be 'double', not '%s'", Rf_type2char(TYPEOF(A)));
        }
        const double* const A__ = REAL(A);
        const int* const A__dim_ = ({
        SEXP dim_ = Rf_getAttrib(A, R_DimSymbol);
        if (Rf_length(dim_) != 2) Rf_error(
          "A must be a 2D-array, but length(dim(A)) is %i",
          (int) Rf_length(dim_));
        INTEGER(dim_);});
        const int A__dim_1_ = A__dim_[0];
        const int A__dim_2_ = A__dim_[1];
        
        if (A__dim_2_ != 1)
          Rf_error("dim(A)[2] must be 1, not %0.f",
                    (double)A__dim_2_);
        const R_xlen_t out___len_ = A__dim_1_;
        SEXP out_ = PROTECT(Rf_allocVector(REALSXP, out___len_));
        double* out___ = REAL(out_);
        
        fn(A__, out___, A__dim_1_);
        
        UNPROTECT(1);
        return out_;
      }

---

    Code
      fn
    Output
      function(A, n) {
          declare(type(n = integer(1)))
          declare(type(A = double(1L, n)))
          drop(A)
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(A, n, out_) bind(c)
        use iso_c_binding, only: c_double, c_int
        implicit none
      
        ! manifest start
        ! args
        real(c_double), intent(in) :: A(1, n)
        integer(c_int), intent(in) :: n
        real(c_double), intent(out) :: out_(n)
        ! manifest end
      
      
      
        out_ = A(1, :)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const A__, 
        const int* const n__, 
        double* const out___);
      
      SEXP fn_(SEXP _args) {
        // A
        _args = CDR(_args);
        SEXP A = CAR(_args);
        if (TYPEOF(A) != REALSXP) {
          Rf_error("typeof(A) must be 'double', not '%s'", Rf_type2char(TYPEOF(A)));
        }
        const double* const A__ = REAL(A);
        const int* const A__dim_ = ({
        SEXP dim_ = Rf_getAttrib(A, R_DimSymbol);
        if (Rf_length(dim_) != 2) Rf_error(
          "A must be a 2D-array, but length(dim(A)) is %i",
          (int) Rf_length(dim_));
        INTEGER(dim_);});
        const int A__dim_1_ = A__dim_[0];
        const int A__dim_2_ = A__dim_[1];
        
        // n
        _args = CDR(_args);
        SEXP n = CAR(_args);
        if (TYPEOF(n) != INTSXP) {
          Rf_error("typeof(n) must be 'integer', not '%s'", Rf_type2char(TYPEOF(n)));
        }
        const int* const n__ = INTEGER(n);
        const R_xlen_t n__len_ = Rf_xlength(n);
        
        if (A__dim_1_ != 1)
          Rf_error("dim(A)[1] must be 1, not %0.f",
                    (double)A__dim_1_);
        const int _as_int_n = Rf_asInteger(n);
        if (_as_int_n != A__dim_2_)
          Rf_error("dim(A)[2] must equal n,"
                   " but are %0.f and %0.f",
                    (double)A__dim_2_, (double)_as_int_n);
        if (n__len_ != 1)
          Rf_error("length(n) must be 1, not %0.f",
                    (double)n__len_);
        const R_xlen_t out___len_ = _as_int_n;
        SEXP out_ = PROTECT(Rf_allocVector(REALSXP, out___len_));
        double* out___ = REAL(out_);
        
        fn(A__, n__, out___);
        
        UNPROTECT(1);
        return out_;
      }

---

    Code
      fn
    Output
      function(A, n) {
          declare(type(n = integer(1)))
          declare(type(A = double(n, 1L)))
          drop(A)
        }
      <environment: 0x0>
    Code
      cat(fsub)
    Output
      subroutine fn(A, n, out_) bind(c)
        use iso_c_binding, only: c_double, c_int
        implicit none
      
        ! manifest start
        ! args
        real(c_double), intent(in) :: A(n, 1)
        integer(c_int), intent(in) :: n
        real(c_double), intent(out) :: out_(n)
        ! manifest end
      
      
      
        out_ = A(:, 1)
      end subroutine
    Code
      cat(cwrapper)
    Output
      #define R_NO_REMAP
      #include <R.h>
      #include <Rinternals.h>
      
      
      extern void fn(
        const double* const A__, 
        const int* const n__, 
        double* const out___);
      
      SEXP fn_(SEXP _args) {
        // A
        _args = CDR(_args);
        SEXP A = CAR(_args);
        if (TYPEOF(A) != REALSXP) {
          Rf_error("typeof(A) must be 'double', not '%s'", Rf_type2char(TYPEOF(A)));
        }
        const double* const A__ = REAL(A);
        const int* const A__dim_ = ({
        SEXP dim_ = Rf_getAttrib(A, R_DimSymbol);
        if (Rf_length(dim_) != 2) Rf_error(
          "A must be a 2D-array, but length(dim(A)) is %i",
          (int) Rf_length(dim_));
        INTEGER(dim_);});
        const int A__dim_1_ = A__dim_[0];
        const int A__dim_2_ = A__dim_[1];
        
        // n
        _args = CDR(_args);
        SEXP n = CAR(_args);
        if (TYPEOF(n) != INTSXP) {
          Rf_error("typeof(n) must be 'integer', not '%s'", Rf_type2char(TYPEOF(n)));
        }
        const int* const n__ = INTEGER(n);
        const R_xlen_t n__len_ = Rf_xlength(n);
        
        const int _as_int_n = Rf_asInteger(n);
        if (_as_int_n != A__dim_1_)
          Rf_error("dim(A)[1] must equal n,"
                   " but are %0.f and %0.f",
                    (double)A__dim_1_, (double)_as_int_n);
        if (A__dim_2_ != 1)
          Rf_error("dim(A)[2] must be 1, not %0.f",
                    (double)A__dim_2_);
        if (n__len_ != 1)
          Rf_error("length(n) must be 1, not %0.f",
                    (double)n__len_);
        const R_xlen_t out___len_ = _as_int_n;
        SEXP out_ = PROTECT(Rf_allocVector(REALSXP, out___len_));
        double* out___ = REAL(out_);
        
        fn(A__, n__, out___);
        
        UNPROTECT(1);
        return out_;
      }

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/declare.R
\name{declare}
\alias{declare}
\title{Declare quickr annotations}
\usage{
declare(...)
}
\arguments{
\item{...}{Declarations, typically calls like \code{type(x = double(n))}.}
}
\value{
\code{NULL}, invisibly.
}
\description{
\code{declare()} marks declarations (e.g., \code{type(x = double(n))}) for use by
\code{quickr}'s compiler. It is a runtime no-op and does not evaluate its
arguments.
}
\details{
\code{declare()} is provided by the base package starting in R 4.4.0; for older
versions of R, quickr exports a compatible backport.

\code{declare(parallel())} or \code{declare(omp())} applies an OpenMP \verb{parallel do}
directive to the next \code{for} loop or \code{sapply()} assignment. \code{for} loops can
iterate values over symbols or index iterables (\code{1:n}, \code{seq_len()},
\code{seq_along()}, \code{seq()}), and \code{sapply()} iterates over vector inputs with a
known length.

Control the number of OpenMP threads using environment variables such as
\code{OMP_NUM_THREADS} (threads per region), \code{OMP_THREAD_LIMIT} (global cap),
and \code{OMP_DYNAMIC} (disable/enable runtime adjustment). Set them before
calling a compiled function, e.g. \code{Sys.setenv(OMP_NUM_THREADS = "4")}.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/quick.R
\name{quick}
\alias{quick}
\title{Compile a Quick Function}
\usage{
quick(fun, name = NULL)
}
\arguments{
\item{fun}{An R function}

\item{name}{String, name to use for the function. This is optional in
regular usage but required in an R package. As a convenience, arguments
\code{fun} and \code{name} can also be supplied as positional arguments to \code{quick} with
\code{name} in the first position.}
}
\value{
A quicker R function.
}
\description{
Compile an R function.
}
\details{
\subsection{\code{declare(type())} syntax:}{

The shape and mode of all function arguments must be declared. Local and
return variables may optionally also be declared.

\code{declare(type())} also has support for declaring size constraints, or
size relationships between variables. Here are some examples of declare
calls:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{declare(type(x = double(NA))) # x is a 1-d double vector of any length
declare(type(x = double(10))) # x is a 1-d double vector of length 10
declare(type(x = double(1)))  # x is a scalar double

declare(type(x = integer(2, 3)))  # x is a 2-d integer matrix with dim (2, 3)
declare(type(x = integer(NA, 3))) # x is a 2-d integer matrix with dim (<any>, 3)

# x is a 4-d logical matrix with dim (<any>, 24, 24, 3)
declare(type(x = logical(NA, 24, 24, 3)))

# x and y are 1-d double vectors of any length
declare(type(x = double(NA)),
        type(y = double(NA)))

# x and y are 1-d double vectors of the same length
declare(
  type(x = double(n)),
  type(y = double(n)),
)

# x and y are 1-d double vectors, where length(y) == length(x) + 2
declare(type(x = double(n)),
        type(y = double(n+2)))
}\if{html}{\out{</div>}}

You can provide declarations to \code{declare()} as:
\itemize{
\item Multiple arguments to a single \code{declare()} call
\item Separate \code{declare()} calls
\item Multiple arguments within a code block (\code{{}}) inside \code{declare()}
}

\if{html}{\out{<div class="sourceCode r">}}\preformatted{declare(
  type(x = double(n)),
  type(y = double(n)),
)

declare(type(x = double(n)))
declare(type(y = double(n)))

declare(\{
  type(x = double(n))
  type(y = double(n))
\})
}\if{html}{\out{</div>}}
}

\subsection{Return values}{

The shape and type of a function return value must be known at compile
time. In most situations, this will be automatically inferred by
\code{quick()}. However, if the output is dynamic, then you may need to
provide a hint. For example, returning the result of \code{seq()} will fail
because the output shape cannot be inferred.

\if{html}{\out{<div class="sourceCode r">}}\preformatted{# Will fail to compile:
quick_seq <- quick(function(start, end) \{
  declare(\{
    type(start = integer(1))
    type(end = integer(1))
  \})
  out <- seq(start, end)
  out
\})
}\if{html}{\out{</div>}}

However, if the output size can be declared as a dynamic expression using
other values known at runtime, compilation will succeed:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{# Succeeds:
quick_seq <- quick(function(start, end) \{
  declare(\{
    type(start = integer(1))
    type(end = integer(1))
    type(out = integer(end - start + 1))
  \})
  out <- seq(start, end)
  out
\})
quick_seq(1L, 5L)
}\if{html}{\out{</div>}}
}

\subsection{Fortran compiler}{

quickr compiles via \verb{R CMD SHLIB} and will normally use the same toolchain
that R was built/configured with.

quickr only uses LLVM flang when it is explicitly requested or, on macOS,
when flang is available on \code{PATH} (and \code{flang --version} succeeds). If flang
is requested but unavailable, compilation errors. If flang compilation
fails, quickr retries with the default toolchain; on success it emits a
one-time warning and disables automatic flang preference for the rest of the
session.

In interactive use, you can explicitly control this with:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{options(quickr.fortran_compiler = "flang")
}\if{html}{\out{</div>}}

To disable the macOS auto-preference, set
\code{options(quickr.fortran_compiler = "gfortran")}.
}
}
\examples{
\donttest{
add_ab <- quick(function(a, b) {
  declare(type(a = double(n)),
          type(b = double(n)))
  a + b
})
add_ab(1, 2)
add_ab(c(1, 2, 3), c(4, 5, 6))
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/compile-package.R
\name{compile_package}
\alias{compile_package}
\title{Compile all \code{quick()} functions in a package.}
\usage{
compile_package(path = ".")
}
\arguments{
\item{path}{Path to an R package}
}
\value{
Called for its side effect.
}
\description{
This will compile all \code{quick()} functions in an R package, and
generate source files in the \verb{src/} directory.
}
\details{
Note, this function is automatically invoked during a \code{pkgload::load_all()} call.
}
